# encoding: utf-8

module UR
  SAB_CODES = {
    'A' => 'Bok- och biblioteksväsen',
    'Aa' => 'Bibliografi',
    'Aa:b' => 'Bibliografisk forskning',
    'Aa:bf' => 'Bibliografiska institutioner',
    'Aa:d' => 'Bibliografisk teori, filosofi och metodlära',
    'Aa:dd' => 'Metodlära',
    'Aa:k' => 'Bibliografins historia',
    'Aa.0' => 'Särskilda typer av bibliografier och förteckningar',
    'Aa.01' => 'Nationalbibliografier m m',
    'Aa.011' => 'Periodikaförteckningar',
    'Aa.012' => 'Författarlexikon',
    'Aa.014' => 'Anonym- och pseudonymlexikon',
    'Aa.016' => 'Översättningar',
    'Aa.018' => 'Officiellt tryck',
    'Aa.02' => 'Handskrifter, inkunabler och rariteter',
    'Aa.021' => 'Handskrifter',
    'Aa.022' => 'Inkunabler',
    'Aa.023' => 'Rariteter',
    'Aa.03' => 'Standardkataloger',
    'Aa.04' => 'Tidskrifts- och tidningsindex',
    'Aa.043' => 'Referatpublikationer',
    'Aa.05' => 'Avhandlingar och program',
    'Aa.06' => 'Barn- och skolböcker',
    'Aa.061' => 'Barn- och ungdomsböcker',
    'Aa.065' => 'Skolböcker',
    'Aa.07' => 'Förbjudna böcker',
    'Aa.08' => 'Elektroniska resurser (maskinläsbara datafiler)',
    'Aa.09' => 'Övriga förteckningar',
    'Aa.091' => 'Kongress- och konferenstryck',
    'Aa.092' => 'Festskrifter',
    'Aa.093' => 'Bilder',
    'Aa.094' => 'Kartor',
    'Aa.095' => 'Ljudupptagningar',
    'Aa.096' => 'Mikroformer',
    'Aa.097' => 'Video- och filminspelningar',
    'Aa.099' => 'Talböcker och böcker med punktskrift',
    'Aa-' => 'Särskilda länder och områden',
    'Aa-a' => 'Europa: allmänt',
    'Aa-b' => 'Norden: allmänt',
    'Aa-c' => 'Sverige',
    'Aa-d' => 'Övriga Norden',
    'Aa-da' => 'Danmark',
    'Aa-db' => 'Norge',
    'Aa-dc' => 'Island och Färöarna',
    'Aa-dd' => 'Finland',
    'Aa-e' => 'Brittiska öarna (Storbritannien)',
    'Aa-f' => 'Mellaneuropa',
    'Aa-fa' => 'Tyskland',
    'Aa-fb' => 'Österrike och Liechtenstein',
    'Aa-fc' => 'Ungern',
    'Aa-fd' => 'Tjeckien och Slovakien',
    'Aa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Aa-h' => 'Schweiz',
    'Aa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Aa-j' => 'Frankrike och Monaco',
    'Aa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Aa-l' => 'Portugal',
    'Aa-m' => 'Östeuropa',
    'Aa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Aa-mb' => 'Polen',
    'Aa-mc' => 'Estland, Lettland, Litauen',
    'Aa-n' => 'Balkanländerna',
    'Aa-na' => 'Rumänien',
    'Aa-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Aa-nc' => 'Bulgarien',
    'Aa-nd' => 'Grekland',
    'Aa-nf' => 'Albanien',
    'Aa-o' => 'Asien',
    'Aa-oa' => 'Främre Asien',
    'Aa-ob' => 'Främre Indien',
    'Aa-oc' => 'Bortre Indien',
    'Aa-od' => 'Ostindiska öarna',
    'Aa-oe' => 'Östasien',
    'Aa-oea' => 'Kina',
    'Aa-oeb' => 'Korea',
    'Aa-oec' => 'Japan',
    'Aa-of' => 'Centralasien',
    'Aa-og' => 'Sibirien',
    'Aa-p' => 'Afrika',
    'Aa-pa' => 'Nordafrika utom Egypten',
    'Aa-pb' => 'Egypten och Sudan',
    'Aa-pc' => 'Västafrika',
    'Aa-pd' => 'Centralafrika',
    'Aa-pe' => 'Södra Afrika',
    'Aa-pf' => 'Östafrika',
    'Aa-pg' => 'Nordöstafrika',
    'Aa-q' => 'Amerika',
    'Aa-qa' => 'Förenta staterna',
    'Aa-qb' => 'Kanada',
    'Aa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Aa-qd' => 'Sydamerika',
    'Aa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Aa-ra' => 'Australien',
    'Aa-rb' => 'Nya Zeeland',
    'Aa-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Aa-rd' => 'Nya Guinea',
    'Aa-s' => 'Polarländerna',
    'Aaa' => 'Bok- och biblioteksväsen',
    'Aaaa' => 'Bibliografier över bibliografier',
    'Aaaaa' => 'Bok och biblioteksväsen',
    'Aaaab' => 'Allmänt och blandat',
    'Aaaac' => 'Religion',
    'Aaaad' => 'Filosofi och psykologi',
    'Aaaaf' => 'Språkvetenskap',
    'Aaaag' => 'Litteraturvetenskap',
    'Aaaah' => 'Skönlitteratur',
    'Aaaai' => 'Konst, musik, teater, film, fotokonst',
    'Aaaak' => 'Historia',
    'Aaaal' => 'Biografi med genealogi',
    'Aaaam' => 'Etnografi, socialantropologi och etnologi',
    'Aaaan' => 'Geografi och lokalhistoria',
    'Aaaao' => 'Samhälls- och rättsvetenskap',
    'Aaaap' => 'Teknik, industri och kommunikationer',
    'Aaaaq' => 'Ekonomi och näringsväsen',
    'Aaaau' => 'Naturvetenskap',
    'Aaaav' => 'Medicin',
    'Aaab' => 'Bibliotek',
    'Aaac' => 'Arkiv',
    'Aaad' => 'Bokförlag och bokhandel',
    'Aaae' => 'Bokväsen',
    'Aaaf' => 'Skrift',
    'Aab' => 'Allmänt och blandat',
    'Aaba' => 'Allmänna encyklopedier',
    'Aabb' => 'Allmänna samlingsverk',
    'Aabd' => 'Allmänna tidskrifter och allmänna serier',
    'Aabe' => 'Allmän idé- och lärdomshistoria',
    'Aabf' => 'Allmän vetenskaplig och kulturell verksamhet',
    'Aabg' => 'Allmänna museer',
    'Aabk' => 'Allmänna sällskap och föreningar',
    'Aabl' => 'Omstridda fenomen och företeelser',
    'Aabr' => 'Kommunikation, cybernetik informationsteori',
    'Aabs' => 'Masskommmunikation: allmänt',
    'Aabt' => 'Publicistik',
    'Aabu' => 'Radio och television',
    'Aac' => 'Religion',
    'Aaca' => 'Kristendomen: allmänt',
    'Aacb' => 'Bibelutgåvor',
    'Aacc' => 'Exegetik och litteratur om Bibeln',
    'Aacd' => 'Äldre teologisk litteratur',
    'Aace' => 'Dogmatik och symbolik',
    'Aacf' => 'Teologisk etik',
    'Aacg' => 'Praktisk teologi',
    'Aach' => 'Gudstjänsten',
    'Aaci' => 'Uppbyggelselitteratur',
    'Aacj' => 'Kyrkohistoria',
    'Aacjz' => 'Särskilda personer',
    'Aack' => 'Kristna samfund',
    'Aacl' => 'Kristen mission',
    'Aacm' => 'Religionshistoria',
    'Aacmdb' => 'Judendom',
    'Aacmdd' => 'Islam',
    'Aacme' => 'Indiska religioner (hinduism, buddhism m m)',
    'Aacn' => 'Moderna religionsbildningar',
    'Aad' => 'Filosofi och psykologi',
    'Aada' => 'Äldre västerländsk samt icke-västerländsk filosofisk litteratur',
    'Aadb' => 'Filosofins historia',
    'Aadbz' => 'Särskilda filosofer',
    'Aadc' => 'Logik och språkligt orienterad filosofi',
    'Aadd' => 'Kunskapsteori och vetenskapsteori',
    'Aadg' => 'Etik',
    'Aadj' => 'Verklighetsuppfattningar (metafysik, ontologi, kosmologi m m)',
    'Aado' => 'Psykologi',
    'Aadoa' => 'Metodik',
    'Aadob' => 'Psykologins historia',
    'Aadoc' => 'Särskilda riktningar och skolor',
    'Aadod' => 'Fysiologisk psykologi',
    'Aadoe' => 'Kognitiv psykologi',
    'Aadof' => 'Utvecklingspsykologi',
    'Aadog' => 'Differentiell psykologi',
    'Aadok' => 'Tillämpad psykologi',
    'Aadop' => 'Parapsykologi',
    'Aae' => 'Uppfostran och undervisning',
    'Aaea' => 'Pedagogik',
    'Aaeaa' => 'Pedagogisk psykologi',
    'Aaeab' => 'Pedagogisk metodik',
    'Aaem' => 'Undervisningsväsen',
    'Aaep' => 'Högskolor',
    'Aaeu' => 'Elever med särskilda behov',
    'Aaev' => 'Folkbildning',
    'Aaex' => 'Yrkesval',
    'Aaf' => 'Språkvetenskap',
    'Aafb' => 'Indoeuropeiska språk: allmänt',
    'Aafc' => 'Svenska',
    'Aafd' => 'Övriga nordiska språk',
    'Aafe' => 'Engelska',
    'Aaff' => 'Tyska',
    'Aafg' => 'Nederländska',
    'Aafh' => 'Romanska språk: allmänt',
    'Aafi' => 'Italienska',
    'Aafj' => 'Franska',
    'Aafk' => 'Spanska',
    'Aafl' => 'Portugisiska',
    'Aafm' => 'Slaviska och baltiska språk',
    'Aafn' => 'Keltiska språk',
    'Aafo' => 'Grekiska och latin',
    'Aafp' => 'Indo-ariska språk',
    'Aafq' => 'Iranska språk',
    'Aafr' => 'Övriga indoeuropeiska språk',
    'Aafs' => 'Semitiska språk',
    'Aaft' => 'Hamitiska språk och tchadspråk',
    'Aafu' => 'Finsk-ugriska och altaiska språk',
    'Aafv' => 'Sino-tibetanska och austroasiatiska språk',
    'Aafx' => 'Övriga språk',
    'Aafy' => 'Konstgjorda språk',
    'Aag' => 'Litteraturvetenskap',
    'Aagb' => 'Nordisk litteraturhistoria: allmän',
    'Aagc' => 'Svensk litteraturhistoria',
    'Aagcz' => 'Särskilda svenska författare',
    'Aagd' => 'Övrig nordisk litteraturhistoria',
    'Aage' => 'Engelsk litteraturhistoria',
    'Aagep' => 'Afrikansk litteraturhistoria: engelskspråkig',
    'Aageq' => 'Amerikansk litteraturhistoria',
    'Aager' => 'Australisk litteraturhistoria',
    'Aagf' => 'Tysk litteraturhistoria',
    'Aagg' => 'Nederländsk litteraturhistoria',
    'Aagh' => 'Romansk litteraturhistoria: allmänt',
    'Aagi' => 'Italiensk litteraturhistoria',
    'Aagj' => 'Fransk litteraturhistoria',
    'Aagk' => 'Spansk litteraturhistoria',
    'Aagl' => 'Portugisisk litteraturhistoria',
    'Aagm' => 'Slavisk och baltisk litteraturhistoria',
    'Aagn' => 'Keltisk litteraturhistoria',
    'Aago' => 'Grekisk och latinsk litteraturhistoria',
    'Aagp' => 'Indo-arisk litteraturhistoria',
    'Aagq' => 'Iransk litteraturhistoria',
    'Aags' => 'Semitisk litteraturhistoria',
    'Aagu' => 'Finsk-ugrisk och altaisk litteraturhistoria',
    'Aagv' => 'Litteraturhistoria: sino-tibetanska och austroasiatiska språk',
    'Aagx' => 'Övrig litteraturhistoria',
    'Aagz' => 'Särskilda utländska författare',
    'Aah' => 'Litteratur, skönlitteratur',
    'Aahb' => 'Nordisk litteraturhistoria: allmänt',
    'Aahc' => 'Svensk litteraturhistoria',
    'Aahca' => 'Fornsvensk litteratur',
    'Aahcc' => 'Svensk skönlitteratur på främmande språk',
    'Aahcd' => 'Finlandssvensk skönlitteratur',
    'Aahce' => 'Utländsk skönlitteratur i svensk översättning',
    'Aahcf' => 'Småbarnslitteratur och sagor',
    'Aahcg' => 'Skönlitteratur för mellanåldern',
    'Aahci' => 'Tecknade serier',
    'Aahd' => 'Övrig nordisk skönlitteratur',
    'Aahe' => 'Engelsk skönlitteratur',
    'Aahea' => 'Fornengelsk litteratur',
    'Aaheb' => 'Medelengelsk litteratur',
    'Aahep' => 'Afrikansk skönlitteratur: engelskspråkig',
    'Aaheq' => 'Amerikansk skönlitteratur',
    'Aaher' => 'Australisk skönlitteratur',
    'Aahf' => 'Tysk skönlitteratur',
    'Aahg' => 'Nederländsk skönlitteratur',
    'Aahh' => 'Romansk skönlitteratur: allmänt',
    'Aahi' => 'Italiensk skönlitteratur',
    'Aahj' => 'Fransk skönlitteratur',
    'Aahk' => 'Spansk skönlitteratur',
    'Aahl' => 'Portugisisk skönlitteratur',
    'Aahm' => 'Slavisk och baltisk skönlitteratur',
    'Aahma' => 'Rysk skönlitteratur',
    'Aahmc' => 'Polsk skönlitteratur',
    'Aahmd' => 'Tjeckisk skönlitteratur',
    'Aahme' => 'Slovakisk skönlitteratur',
    'Aahmf' => 'Serbisk, kroatisk och bosnisk-hercegovinsk skönlitteratur',
    'Aahmk' => 'Baltisk skönlitteratur',
    'Aahn' => 'Keltisk skönlitteratur',
    'Aaho' => 'Grekisk och latinsk litteratur',
    'Aahp' => 'Indisk litteratur',
    'Aahq' => 'Iransk litteratur',
    'Aahr' => 'Övrig indoeuropeisk litteratur',
    'Aahs' => 'Semitisk litteratur',
    'Aahsd' => 'Hebreisk skönlitteratur',
    'Aahsg' => 'Arabisk skönlitteratur',
    'Aahsi' => 'Etiopisk litteratur',
    'Aaht' => 'Litteratur på hamitiska språk och tchadspråk',
    'Aahu' => 'Finsk-ugrisk och altaisk skönlitteratur',
    'Aahv' => 'Skönlitteratur på sino-tibetanska och austroasiatiska språk',
    'Aahx' => 'Övrig skönlitteratur',
    'Aai' => 'Konst, musik, teater, film, fotokonst',
    'Aaia' => 'Konst: allmänt',
    'Aaib' => 'Konsthistoria',
    'Aaibz' => 'Särskilda konstnärer',
    'Aaic' => 'Arkitektur',
    'Aaid' => 'Skulptur',
    'Aaie' => 'Målarkonst',
    'Aaif' => 'Grafisk konst',
    'Aaig' => 'Teckningskonst',
    'Aaih' => 'Konsthantverk',
    'Aaii' => 'Konstsamlingar och -utställningar',
    'Aaij' => 'Musik',
    'Aaija' => 'Musikteori, musikarkeologi m fl musikvetenskapliga delområden',
    'Aaijb' => 'Musikhistoria',
    'Aaijc' => 'Musikinstrument: allmänt',
    'Aaijd' => 'Tangentinstrument',
    'Aaije' => 'Stråkinstrument',
    'Aaijf' => 'Blåsinstrument',
    'Aaijg' => 'Knäppinstrument',
    'Aaijk' => 'Kammarmusik',
    'Aaijm' => 'Instrumentalmusik: särskilda former',
    'Aaijn' => 'Vokalmusik: allmänt',
    'Aaijp' => 'Körsång',
    'Aaijr' => 'Dramatisk och scenisk musik',
    'Aaijs' => 'Religiös musik',
    'Aaiju' => 'Västerländsk folkmusik',
    'Aaijv' => 'Icke-västerländska kulturers musik',
    'Aaijx' => 'Jazz, rock och populärmusik',
    'Aaijz' => 'Särskilda tonkonstnärer',
    'Aaik' => 'Teater',
    'Aaika' => 'Teater: allmänt',
    'Aaikb' => 'Teaterhistoria och -kritik',
    'Aaiky' => 'Konstnärlig dans',
    'Aaikö' => 'Övrig scenisk konst och offentliga nöjen',
    'Aaim' => 'Film',
    'Aaima' => 'Film: allmänt',
    'Aaimb' => 'Filmhistoria',
    'Aaj' => 'Arkeologi',
    'Aaja' => 'Europa: allmänt (inkl klassisk arekologi)',
    'Aajb' => 'Norden: allmänt',
    'Aajc' => 'Sverige',
    'Aajd' => 'Övriga Norden',
    'Aaje' => 'Brittiska öarna (Storbritannien)',
    'Aajf' => 'Mellaneuropa',
    'Aajj' => 'Frankrike',
    'Aajk' => 'Spanien',
    'Aajm' => 'Östeuropa',
    'Aajn' => 'Balkanhalvön',
    'Aajo' => 'Asien',
    'Aajp' => 'Afrika',
    'Aajq' => 'Amerika',
    'Aak' => 'Historia',
    'Aaka' => 'Europa: allmänt',
    'Aakb' => 'Norden: allmänt',
    'Aakc' => 'Sverige',
    'Aakcx' => 'Svenskar i utlandet',
    'Aakd' => 'Övriga Norden',
    'Aake' => 'Brittiska öarna (Storbritannen)',
    'Aakf' => 'Mellaneuropa',
    'Aakfa' => 'Tyskland',
    'Aakfb' => 'Österrike och Liechtenstein',
    'Aakfc' => 'Ungern',
    'Aakfd' => 'Tjeckoslovakien (Tjeckien och Slovakien)',
    'Aakg' => 'Nederländerna, Belgien och Luxemburg',
    'Aakh' => 'Schweiz',
    'Aaki' => 'Italien',
    'Aakj' => 'Frankrike',
    'Aakk' => 'Spanien',
    'Aakm' => 'Östeuropa',
    'Aakma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Aakmb' => 'Polen',
    'Aakmc' => 'Estland, Lettland, Litauen',
    'Aakn' => 'Balkaländerna',
    'Aako' => 'Asien',
    'Aakoa' => 'Främre Asien',
    'Aakoaa' => 'Turkiet',
    'Aakoaf' => 'Palestina och Israel',
    'Aakoafh' => 'Judarnas historia',
    'Aakoak' => 'Iran (Persien)',
    'Aakob' => 'Främre Indien',
    'Aakoc' => 'Bortre Indien',
    'Aakod' => 'Ostindiska öarna',
    'Aakoe' => 'Östasien',
    'Aakp' => 'Afrika',
    'Aakq' => 'Amerika',
    'Aakqa' => 'Förenta staterna',
    'Aakqb' => 'Kanada',
    'Aakqc' => 'Mexiko, Centralamerika och Västindien',
    'Aakqd' => 'Sydmerika',
    'Aakr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Aakt' => 'Allmän kulturhistoria',
    'Aaku' => 'Allmän socialhistoria',
    'Aakv' => 'Allmän ekonomisk historia',
    'Aaky' => 'Historiska hjälpvetenskaper',
    'Aal' => 'Biografi med genealogi',
    'Aald' => 'Genealogi',
    'Aaldz' => 'Särskilda släkter',
    'Aalk' => 'Biografisk vetenskap',
    'Aalm' => 'Biografiska uppslagsverk',
    'Aals' => 'Biografiska samlingar',
    'Aalz' => 'Särskilda personer',
    'Aam' => 'Etnografi, socialantropologi och etnologi',
    'Aama' => 'Europa: allmänt',
    'Aamb' => 'Norden: allmänt',
    'Aamc' => 'Sverige',
    'Aamd' => 'Övriga Norden',
    'Aamf' => 'Mellaneuropa',
    'Aamm' => 'Östeuropa',
    'Aamn' => 'Balkaländerna',
    'Aamo' => 'Asien',
    'Aamp' => 'Afrika',
    'Aamq' => 'Amerika',
    'Aamr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Aams' => 'Polarländerna',
    'Aamx' => 'Näringsliv och arbetsliv',
    'Aamy' => 'Samhälls- och familjeliv',
    'Aamz' => 'Folktro och folkseder',
    'Aan' => 'Geografi och lokalhistoria',
    'Aana' => 'Europa: allmänt',
    'Aanb' => 'Norden: allmänt',
    'Aanc' => 'Sverige',
    'Aanca' => 'Svealand',
    'Aancb' => 'Götaland',
    'Aancc' => 'Norrland',
    'Aand' => 'Övriga Norden',
    'Aane' => 'Brittiska öarna (Storbritannen)',
    'Aanf' => 'Mellaneuropa',
    'Aanfa' => 'Tyskland',
    'Aanfb' => 'Österrike och Liechtenstein',
    'Aanfc' => 'Ungern',
    'Aanfd' => 'Tjeckien och Slovakien',
    'Aang' => 'Nederländerna, Belgien och Luxemburg',
    'Aanh' => 'Schweiz',
    'Aani' => 'Italien',
    'Aanj' => 'Frankrike',
    'Aank' => 'Spanien',
    'Aanm' => 'Östeuropa',
    'Aann' => 'Balkaländerna',
    'Aano' => 'Asien',
    'Aanoa' => 'Främre Asien',
    'Aanob' => 'Främre Indien',
    'Aanoc' => 'Bortre Indien',
    'Aanod' => 'Ostindiska öarna',
    'Aanoe' => 'Östasien',
    'Aanof' => 'Centralasien',
    'Aanp' => 'Afrika',
    'Aanpa' => 'Nordafrika utom Egypten',
    'Aanpb' => 'Egypten och Sudan',
    'Aanpc' => 'Västafrika',
    'Aanpd' => 'Centralafrika',
    'Aanpe' => 'Södra Afrika',
    'Aanpf' => 'Östafrika',
    'Aanpg' => 'Nordöstafrika',
    'Aanq' => 'Amerika',
    'Aanqa' => 'Förenta staterna',
    'Aanqb' => 'Kanada',
    'Aanqc' => 'Mexiko, Centralamerika och Västindien',
    'Aanqd' => 'Sydmerika',
    'Aanr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Aans' => 'Polarländerna',
    'Aao' => 'Samhälls- och rättsvetenskap',
    'Aaoa' => 'Sociologi',
    'Aaoaa' => 'Socialpsykologi',
    'Aaoab' => 'Sociala strukturer',
    'Aaoac' => 'Familjesociologi',
    'Aaob' => 'Internationella relationer',
    'Aaoba' => 'Folkrätt',
    'Aaobb' => 'Freds- och nedrustningsfrågor',
    'Aaobd' => 'Internationellt samarbete: allmänt',
    'Aaobe' => 'Nationernas förbund',
    'Aaobf' => 'Förenta nationerna (FN)',
    'Aaobk' => 'Regionalt mellanfolkligt samarbete',
    'Aaobn' => 'Nordiskt samarbete',
    'Aaobq' => 'Utvecklingsbistånd och internationell hjälpverksamhet',
    'Aaoc' => 'Statskunskap och politik',
    'Aaocb' => 'Statsrätt',
    'Aaocc' => 'Sveriges statskunskap och politik',
    'Aaocf' => 'Främmande länders statskunskap och politik',
    'Aaocg' => 'Politiska begrepp och politiska åskådningr',
    'Aaocl' => 'Utomparlamentariska metoder, konspirativ verksamhet, terrorism m m',
    'Aaod' => 'Förvaltning',
    'Aaodc' => 'Förvaltning: Sverige',
    'Aaodf' => 'Främmande länders förvaltning',
    'Aaodg' => 'Samhällsplanering',
    'Aaoe' => 'Rättsvetenskap',
    'Aaoea' => 'Civilrätt',
    'Aaoeb' => 'Straffrätt',
    'Aaoek' => 'Processrätt',
    'Aaoel' => 'Tryckfrihetsrätt',
    'Aaoep' => 'Kriminologi och polisväsen',
    'Aaoeq' => 'Kriminalvård',
    'Aaoer' => 'Rättsfall',
    'Aaoet' => 'Rättshistoria',
    'Aaoh' => 'Sociala frågor och socialpolitik',
    'Aaoha' => 'Arbete och arbetsmarknad',
    'Aaohab' => 'Arbetsrätt',
    'Aaohae' => 'Arbetsmiljöfrågor och arbetarskydd',
    'Aaohaf' => 'Särskilda grupper av arbetstagare',
    'Aaohai' => 'Fackliga orgnisationer',
    'Aaohc' => 'Bostäder',
    'Aaohd' => 'Emigration och immigration',
    'Aaohe' => 'Minoriteter',
    'Aaohf' => 'Social omsorg',
    'Aaohi' => 'Alkohol-, narkotika- och nikotinfrågor',
    'Aaohj' => 'Könsrollsfrågor',
    'Aaohja' => 'Kvinnofrågor',
    'Aaohjb' => 'Mansfrågor',
    'Aaohjh' => 'Homosexuella',
    'Aaohk' => 'Fritidsverksamhet',
    'Aaoi' => 'Statistik',
    'Aaoj' => 'Demografi',
    'Aaok' => 'Försäkring',
    'Aaom' => 'Kooperation',
    'Aaop' => 'Framtidsstudier',
    'Aap' => 'Teknik, industri och kommunikationer',
    'Aapa' => 'Teknisk fysik',
    'Aapb' => 'Maskinteknik',
    'Aapc' => 'Elektroteknik och elektrisk industri',
    'Aapd' => 'Bergsbruk',
    'Aape' => 'Metallbearbetning och metallindustri',
    'Aapg' => 'Glas, keramik, porslin',
    'Aaph' => 'Träteknik och träindustri',
    'Aapi' => 'Pappersindustri',
    'Aapj' => 'Textil- och beklädnadsindustri',
    'Aapm' => 'Kemisk teknik och kemisk industri',
    'Aapn' => 'Fotografi och filmteknik',
    'Aapo' => 'Tryckeri och bokbinderi',
    'Aapp' => 'Byggnadsteknik, byggnadsproduktion, teknisk hygien',
    'Aappa' => 'Byggnadsteknik',
    'Aappb' => 'Husbyggnad',
    'Aappc' => 'Väg- och vattenbyggnad',
    'Aappd' => 'Teknisk hygien, vatten och avlopp, värmeförsörjning m m',
    'Aapr' => 'Transportmedel och kommunikationer',
    'Aapt' => 'Patentbeskrivningr',
    'Aapu' => 'Datorer och databehandling',
    'Aaq' => 'Ekonomi och näringsväsen',
    'Aaqa' => 'Nationalekonomi och finansväsen',
    'Aaqaa' => 'Ekonomisk teori',
    'Aaqad' => 'Ekonomiska förhållanden',
    'Aaqadc' => 'Statlig reglering av näringslivet',
    'Aaqadd' => 'Interstatlige ekonomiskt samarbete',
    'Aaqadk' => 'Tekniköverföring',
    'Aaqadu' => 'U-länderna',
    'Aaqae' => 'Penning- och bankväsen',
    'Aaqaf' => 'Finansväsen med finansrätt',
    'Aaqb' => 'Företagsekonomi',
    'Aaqba' => 'Företagsorganisation, företagsformer, företagsledning',
    'Aaqbb' => 'Standardisering',
    'Aaqbc' => 'Redovisning',
    'Aaqbf' => 'Personaladministration',
    'Aaqbi' => 'Driftsorganisation',
    'Aaqbk' => 'Materialadministration',
    'Aaqbl' => 'Försäljningsorganisation. Marknadsföring',
    'Aaqc' => 'Hem och hushåll',
    'Aaqd' => 'Lantbruk',
    'Aaqdc' => 'Jordbrukslära',
    'Aaqdd' => 'Växtodlingslära',
    'Aaqdf' => 'Husdjurslära',
    'Aaqe' => 'Trädgårsskötsel',
    'Aaqf' => 'Skogsbruk',
    'Aaqg' => 'Jakt och fiske',
    'Aaqi' => 'Handel',
    'Aaqj' => 'Post- och televäsen',
    'Aaqm' => 'Hotell och turistväsen',
    'Aar' => 'Idrott, lek och spel',
    'Aarb' => 'Idrott och sport',
    'Aarc' => 'Danslekar och dans',
    'Aard' => 'Spel och tidsfördriv',
    'Aas' => 'Militärväsen',
    'Aasa' => 'Lantkrigsväsen',
    'Aasb' => 'Sjökrigsväsen',
    'Aasc' => 'Luftkrigsväsen',
    'Aase' => 'Total krigföring',
    'Aat' => 'Matematik',
    'Aau' => 'Naturvetenskap',
    'Aaua' => 'Astronomi',
    'Aaub' => 'Geofysik',
    'Aauc' => 'Fysik och kemi',
    'Aaucb' => 'Mekanik',
    'Aaucc' => 'Fysik',
    'Aaucd' => 'Molekyl-, atom-, kärn- och partikelfysik',
    'Aauce' => 'Kemi',
    'Aaud' => 'Geologi och paleontologi',
    'Aauda' => 'Allmän och historisk geologi',
    'Aaudb' => 'Paleontologi',
    'Aaudu' => 'Mineralogi',
    'Aaudx' => 'Ekonomisk geologi',
    'Aaue' => 'Biologi',
    'Aauf' => 'Botanik',
    'Aaufa' => 'Särskilda grupper av växter',
    'Aaufe' => 'Fröväxter (fanerogamer): allmänt',
    'Aauff' => 'Gömfröiga (Magnoliophytina)',
    'Aaufh' => 'Kryptogamer',
    'Aaug' => 'Zoologi',
    'Aaugf' => 'Däggdjur (Mammalia)',
    'Aaugg' => 'Fåglar (Aves)',
    'Aaugh' => 'Kräldjur (Reptilia) och groddjur (Amphibia)',
    'Aaugi' => 'Fiskar (Pisces) och rundmunnar (Cyclostomoi)',
    'Aaugj' => 'Ryggradslösa djur (Evertebrata)',
    'Aauh' => 'Miljöfrågor och naturskydd',
    'Aav' => 'Medicin',
    'Aava' => 'Medicinsk genetik, mikrobiologi, immunologi m fle icke kliniska discipliner',
    'Aavb' => 'Anatomi',
    'Aavc' => 'Medicinsk fysiologi, biofysik och kemi',
    'Aavd' => 'Farmakologi',
    'Aave' => 'Allmän medicin',
    'Aavf' => 'Kirurgi och anestesi',
    'Aavg' => 'Gynekologi och andrologi',
    'Aavh' => 'Pediatrik',
    'Aavi' => 'Oftalmologi (ögat)',
    'Aavj' => 'Otrinolaryngologi',
    'Aavk' => 'Odontologi',
    'Aavl' => 'Psykiatri',
    'Aavm' => 'Terapimetoder',
    'Aavn' => 'Samhällsmedicin, hygien, sexologi',
    'Aavp' => 'Hälso- och sjukvård',
    'Aavpb' => 'Sjukvårdsadministration och -organisation',
    'Aavpd' => 'Sjukvårdspersonal',
    'Aavpg' => 'Omvårdnad',
    'Aavpm' => 'Palliativ vård',
    'Aavs' => 'Geriatri',
    'Aax' => 'Förteckningar: musikalier',
    'Aaxb' => 'Musikhistoria',
    'Aaxd' => 'Tangentinstrument',
    'Aaxe' => 'Stråkinstrument',
    'Aaxf' => 'Blåsinstrument',
    'Aaxg' => 'Knäppinstrument',
    'Aaxk' => 'Instrumentalensembler',
    'Aaxl' => 'Orkestrar',
    'Aaxm' => 'Instrumentalmusik: särskilda former',
    'Aaxn' => 'Elektroakustisk (akustisk) musik',
    'Aaxo' => 'Solosång',
    'Aaxp' => 'Körsång',
    'Aaxq' => 'Vokalmusik: särskilda former',
    'Aaxr' => 'Dramatisk och scenisk musik',
    'Aaxs' => 'Religiös musik',
    'Aaxu' => 'Västerländsk folkmusik',
    'Aaxx' => 'Jazz, rock och populärmusik',
    'Aaxy' => 'Texter till vokal och dramatisk musik',
    'Aaxz' => 'Särskilda tonsättare',
    'Aay' => 'Förteckningar: musikinspelningar',
    'Aayo' => 'Solosång',
    'Aayq' => 'Vokalmusik: särskilda former',
    'Aayr' => 'Dramatisk och scenisk musik',
    'Aayu' => 'Västerländsk folkmusik',
    'Aayx' => 'Jazz, rock och populärmusik',
    'Aayz' => 'Särskilda tonsättare',
    'Ab' => 'Bibliotek',
    'Ab:bf' => 'Biblioteksinstitutioner',
    'Ab:d' => 'Biblioteksteori, -filosofi, metodlära',
    'Ab:k' => 'Bibliotekshistoria',
    'Ab:oa' => 'Bibliotekssociologi',
    'Ab:oe' => 'Bibliotekslagstiftning',
    'Ab.0' => 'särskilda typer av bibliotek',
    'Ab.01' => 'Vetenskapliga bibliotek',
    'Ab.03' => 'Specialbibliotek',
    'Ab.035' => 'Musikbibliotek',
    'Ab.04' => 'Sjukhusbibliotek',
    'Ab.05' => 'Folkbibliotek',
    'Ab.051' => 'Barnbibliotek',
    'Ab.06' => 'Skolbibliotek',
    'Ab.07' => 'Företagsbibliotek',
    'Ab.08' => 'Privatbibliotek',
    'Ab.09' => 'Övriga bibliotek',
    'Ab-' => 'Särskilda länder och områden',
    'Ab-a' => 'Europa: allmänt',
    'Ab-b' => 'Norden: allmänt',
    'Ab-c' => 'Sverige',
    'Ab-cs' => 'Samer',
    'Ab-cz' => 'Särskilda bibliotek',
    'Ab-d' => 'Övriga Norden',
    'Ab-da' => 'Danmark',
    'Ab-db' => 'Norge',
    'Ab-dc' => 'Island och Färöarna',
    'Ab-dd' => 'Finland',
    'Ab-e' => 'Brittiska öarna (Storbritannien)',
    'Ab-f' => 'Mellaneuropa',
    'Ab-fa' => 'Tyskland',
    'Ab-fb' => 'Österrike och Liechtenstein',
    'Ab-fc' => 'Ungern',
    'Ab-fd' => 'Tjeckien och Slovakien',
    'Ab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ab-h' => 'Schweiz',
    'Ab-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ab-j' => 'Frankrike och Monaco',
    'Ab-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ab-l' => 'Portugal',
    'Ab-m' => 'Östeuropa',
    'Ab-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ab-mb' => 'Polen',
    'Ab-mc' => 'Estland, Lettland, Litauen',
    'Ab-n' => 'Balkanländerna',
    'Ab-na' => 'Rumänien',
    'Ab-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ab-nc' => 'Bulgarien',
    'Ab-nd' => 'Grekland',
    'Ab-nf' => 'Albanien',
    'Ab-o' => 'Asien',
    'Ab-oa' => 'Främre Asien',
    'Ab-ob' => 'Främre Indien',
    'Ab-oc' => 'Bortre Indien',
    'Ab-od' => 'Ostindiska öarna',
    'Ab-oe' => 'Östasien',
    'Ab-p' => 'Afrika',
    'Ab-q' => 'Amerika',
    'Ab-qa' => 'Förenta staterna',
    'Ab-qb' => 'Kanada',
    'Ab-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ab-qd' => 'Sydamerika',
    'Ab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ab-s' => 'Polarländerna',
    'Aba' => 'Biblioteksteknik och -organisation',
    'Abaa' => 'Biblioteksautomatisering',
    'Abaaz' => 'Biblioteksautomatisering: särskilda system',
    'Abb' => 'Bibliotekens målsättning och uppgifter',
    'Abc' => 'Bibliotekens organisation, administration och ekonomi',
    'Abca' => 'Bibliotekens organisation och administration',
    'Abcb' => 'Biblioteksbyggnader, -lokaler och -inventarier',
    'Abcba' => 'Biblioteksbyggnader och -lokaler',
    'Abcbb' => 'Biblioteksutrustning och -inredning',
    'Abcc' => 'Bibliotekspersonal',
    'Abcd' => 'Bibliotekens ekonomi',
    'Abd' => 'Bokbestånd',
    'Abda' => 'Förvärv och urval',
    'Abdab' => 'Bytesverksamhet',
    'Abdag' => 'Gallring',
    'Abdb' => 'Katalogisering',
    'Abdc' => 'Klassifikation',
    'Abdci' => 'Tesaurer och indexering',
    'Abdd' => 'Uppställning och bokvård',
    'Abe' => 'Specialsamlingar',
    'Abea' => 'Tidningar och tidskrifter',
    'Abeb' => 'Småtryck och klippsamlingar',
    'Abec' => 'Seriella publikationer, rapporter, officiellt tryck',
    'Abee' => 'Musikalier',
    'Abef' => 'Kartor och bildmaterial',
    'Abefa' => 'Kartor',
    'Abefb' => 'Bildmaterial',
    'Abek' => 'Handskrifter och rariteter',
    'Abel' => 'Lokalsamlingar',
    'Abem' => 'Audiovisuellt material',
    'Abf' => 'Bibliotekens service',
    'Abfa' => 'Mediedistribution, utlåning',
    'Abfb' => 'Informationsservice, referensarbete',
    'Abfba' => 'Informationssökning och -återvinning',
    'Abfbaz' => 'Datorbaserad informationssökning: särskilda databaser',
    'Abfbl' => 'Löpande litteraturbevakning',
    'Abfc' => 'Reproduktionsverksamhet',
    'Abfd' => 'Regionalt biblioteksarbete',
    'Abfe' => 'Användarutbildning',
    'Abfg' => 'Social biblioteksverksamhet',
    'Abfh' => 'Arbetsplatsutlåning',
    'Abfi' => 'Service till invandrare och språkliga minoriteter',
    'Abfs' => 'Service till läshandikappade',
    'Abg' => 'Bibliotekssamarbete',
    'Abh' => 'Kontaktskapande arbete och PR',
    'Abha' => 'Allmänkulturell verksamhet',
    'Abhb' => 'Samarbete med skola, förskola, fritidsgård',
    'Abhc' => 'Samarbete med studieförbund och andra kulturorganisationer',
    'Ac' => 'Arkiv',
    'Ac:bf' => 'Arkivinstitutioner',
    'Ac:d' => 'Arkivteori, -filosofi, metodlära',
    'Ac:k' => 'Arkivhistoria',
    'Ac:oe' => 'Arkivlagstiftning',
    'Ac-' => 'Särskilda länder och områden',
    'Ac-a' => 'Europa: allmänt',
    'Ac-b' => 'Norden: allmänt',
    'Ac-c' => 'Sverige',
    'Ac-cs' => 'Samer',
    'Ac-cz' => 'Särskilda arkiv',
    'Ac-d' => 'Övriga Norden',
    'Ac-da' => 'Danmark',
    'Ac-db' => 'Norge',
    'Ac-dc' => 'Island och Färöarna',
    'Ac-dd' => 'Finland',
    'Ac-e' => 'Brittiska öarna (Storbritannien)',
    'Ac-f' => 'Mellaneuropa',
    'Ac-fa' => 'Tyskland',
    'Ac-fb' => 'Österrike och Liechtenstein',
    'Ac-fc' => 'Ungern',
    'Ac-fd' => 'Tjeckien och Slovakien',
    'Ac-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ac-h' => 'Schweiz',
    'Ac-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ac-j' => 'Frankrike och Monaco',
    'Ac-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ac-l' => 'Portugal',
    'Ac-m' => 'Östeuropa',
    'Ac-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ac-mb' => 'Polen',
    'Ac-mc' => 'Estland, Lettland, Litauen',
    'Ac-n' => 'Balkanländerna',
    'Ac-o' => 'Asien',
    'Ac-p' => 'Afrika',
    'Ac-q' => 'Amerika',
    'Ac-qa' => 'Förenta staterna',
    'Ac-qb' => 'Kanada',
    'Ac-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ac-qd' => 'Sydamerika',
    'Ac-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Aca' => 'Arkivteknik och -organisation',
    'Acb' => 'Arkivens målsättning och uppgifter',
    'Acc' => 'Arkivens organisation, administration och ekonomi',
    'Acd' => 'Arkivbestånd',
    'Acda' => 'Förvärv och urval',
    'Acdb' => 'Katalogisering',
    'Acdc' => 'Klassifikation',
    'Acdd' => 'Uppställning och arkivvård',
    'Ace' => 'Specialsamlingar',
    'Acf' => 'Arkivens service',
    'Acfb' => 'Informationsservice, referensarbete',
    'Acfc' => 'Reproduktionsverksamhet',
    'Acfe' => 'Användarutbildning',
    'Ad' => 'Bokförlag och bokhandel',
    'Ad:k' => 'Bokförlagens och bokhandelns historia',
    'Ad-' => 'Särskilda länder och områden',
    'Ad-a' => 'Europa: allmänt',
    'Ad-b' => 'Norden: allmänt',
    'Ad-c' => 'Sverige',
    'Ad-cz' => 'Särskilda företag och orter',
    'Ad-d' => 'Övriga Norden',
    'Ad-da' => 'Danmark',
    'Ad-db' => 'Norge',
    'Ad-dd' => 'Finland',
    'Ad-e' => 'Brittiska öarna (Storbritannien)',
    'Ad-f' => 'Mellaneuropa',
    'Ad-fa' => 'Tyskland',
    'Ad-fb' => 'Österrike och Liechtenstein',
    'Ad-fc' => 'Ungern',
    'Ad-fd' => 'Tjeckien och Slovakien',
    'Ad-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ad-h' => 'Schweiz',
    'Ad-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ad-j' => 'Frankrike och Monaco',
    'Ad-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ad-l' => 'Portugal',
    'Ad-m' => 'Östeuropa',
    'Ad-n' => 'Balkanländerna',
    'Ad-o' => 'Asien',
    'Ad-p' => 'Afrika',
    'Ad-q' => 'Amerika',
    'Ad-qa' => 'Förenta staterna',
    'Ad-qb' => 'Kanada',
    'Ad-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ad-qd' => 'Sydamerika',
    'Ad-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ada' => 'Bokhandelsteknik och -organisation',
    'Ads' => 'Lagerkataloger',
    'Adt' => 'Bokauktionskataloger',
    'Ae' => 'Bokväsen',
    'Aea' => 'Bokhistoria',
    'Aeb' => 'Skrivredskap och skrivmaterial',
    'Aec' => 'Boktryckerihistoria',
    'Aed' => 'Bokbandshistoria',
    'Aef' => 'Redigeringsteknik',
    'Aefd' => 'Doktorsavhandlingar',
    'Aefe' => 'Uppsatser och rapporter',
    'Aet' => 'Bibliofili',
    'Aeta' => 'Exlibriskunskap',
    'Af' => 'Skrift',
    'Afa' => 'Skrift- och alfabetshistoria',
    'Afaa' => 'Västerländska skriftsystem',
    'Afab' => 'Orientaliska skriftsystem',
    'Afac' => 'Östasiatiska skriftsystem',
    'Afaö' => 'Övriga skriftsystem',
    'Afb' => 'Paleografi',
    'Afc' => 'Kalligrafi',
    'Afd' => 'Chiffer',
    'B' => 'Allmänt och blandat',
    'Ba' => 'Allmänna encyklopedier',
    'Ba:k' => 'Encykolopedins historia',
    'Ba-' => 'Särskilda länder och områden',
    'Ba-c' => 'Sverige',
    'Ba-d' => 'Övriga Norden',
    'Ba-da' => 'Danmark',
    'Ba-db' => 'Norge',
    'Ba-dc' => 'Island och Färöarna',
    'Ba-dd' => 'Finland',
    'Ba-e' => 'Brittiska öarna (Storbritannien)',
    'Ba-f' => 'Mellaneuropa',
    'Ba-fa' => 'Tyskland',
    'Ba-fb' => 'Österrike och Liechtenstein',
    'Ba-fc' => 'Ungern',
    'Ba-fd' => 'Tjeckien och Slovakien',
    'Ba-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ba-h' => 'Schweiz',
    'Ba-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ba-j' => 'Frankrike och Monaco',
    'Ba-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ba-l' => 'Portugal',
    'Ba-m' => 'Östeuropa',
    'Ba-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ba-mb' => 'Polen',
    'Ba-mc' => 'Estland, Lettland, Litauen',
    'Ba-n' => 'Balkanländerna',
    'Ba-na' => 'Rumänien',
    'Ba-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ba-nc' => 'Bulgarien',
    'Ba-nd' => 'Grekland',
    'Ba-nf' => 'Albanien',
    'Ba-o' => 'Asien',
    'Ba-oa' => 'Främre Asien',
    'Ba-ob' => 'Främre Indien',
    'Ba-oc' => 'Bortre Indien',
    'Ba-od' => 'Ostindiska öarna',
    'Ba-oe' => 'Östasien',
    'Ba-oea' => 'Kina',
    'Ba-oeb' => 'Korea',
    'Ba-oec' => 'Japan',
    'Ba-p' => 'Afrika',
    'Ba-q' => 'Amerika',
    'Ba-qa' => 'Förenta staterna',
    'Ba-qb' => 'Kanada',
    'Ba-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ba-qd' => 'Sydamerika',
    'Ba-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bb' => 'Allmänna samlingsverk',
    'Bbh' => 'Citatsamlingar',
    'Bd' => 'Allmänna tidskrifter och allmänna serier',
    'Bd-' => 'Särskilda länder och områden',
    'Bd-b' => 'Norden: allmänt',
    'Bd-c' => 'Sverige',
    'Bd-cs' => 'Samer',
    'Bd-d' => 'Övriga Norden',
    'Bd-da' => 'Danmark',
    'Bd-db' => 'Norge',
    'Bd-dc' => 'Island och Färöarna',
    'Bd-dd' => 'Finland',
    'Bd-e' => 'Brittiska öarna (Storbritannien)',
    'Bd-f' => 'Mellaneuropa',
    'Bd-fa' => 'Tyskland',
    'Bd-fb' => 'Österrike och Liechtenstein',
    'Bd-fc' => 'Ungern',
    'Bd-fd' => 'Tjeckien och Slovakien',
    'Bd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bd-h' => 'Schweiz',
    'Bd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bd-j' => 'Frankrike och Monaco',
    'Bd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bd-l' => 'Portugal',
    'Bd-m' => 'Östeuropa',
    'Bd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Bd-mb' => 'Polen',
    'Bd-mc' => 'Estland, Lettland, Litauen',
    'Bd-n' => 'Balkanländerna',
    'Bd-na' => 'Rumänien',
    'Bd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Bd-nc' => 'Bulgarien',
    'Bd-nd' => 'Grekland',
    'Bd-nf' => 'Albanien',
    'Bd-o' => 'Asien',
    'Bd-oa' => 'Främre Asien',
    'Bd-ob' => 'Främre Indien',
    'Bd-oc' => 'Bortre Indien',
    'Bd-od' => 'Ostindiska öarna',
    'Bd-oe' => 'Östasien',
    'Bd-oea' => 'Kina',
    'Bd-oeb' => 'Korea',
    'Bd-oec' => 'Japan',
    'Bd-of' => 'Centralasien',
    'Bd-p' => 'Afrika',
    'Bd-pa' => 'Nordafrika utom Egypten',
    'Bd-pb' => 'Egypten och Sudan',
    'Bd-pc' => 'Västafrika',
    'Bd-pd' => 'Centralafrika',
    'Bd-pe' => 'Södra Afrika',
    'Bd-pf' => 'Östafrika',
    'Bd-pg' => 'Nordöstafrika',
    'Bd-q' => 'Amerika',
    'Bd-qa' => 'Förenta staterna',
    'Bd-qb' => 'Kanada',
    'Bd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Bd-qd' => 'Sydamerika',
    'Bd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bd-ra' => 'Australien',
    'Bd-rb' => 'Nya Zeeland',
    'Bd-s' => 'Polarländerna',
    'Bda' => 'Kultur, litteratur, politik',
    'Bdb' => 'Reportage och underhållning',
    'Bdc' => 'Invandrartidskrifter',
    'Be' => 'Allmän idé- och lärdomshistoria',
    'Be-' => 'Särskilda länder och områden',
    'Be-a' => 'Europa: allmänt',
    'Be-b' => 'Norden: allmänt',
    'Be-c' => 'Sverige',
    'Be-d' => 'Övriga Norden',
    'Be-da' => 'Danmark',
    'Be-db' => 'Norge',
    'Be-dd' => 'Finland',
    'Be-e' => 'Brittiska öarna (Storbritannien)',
    'Be-f' => 'Mellaneuropa',
    'Be-fa' => 'Tyskland',
    'Be-fb' => 'Österrike och Liechtenstein',
    'Be-fc' => 'Ungern',
    'Be-fd' => 'Tjeckien och Slovakien',
    'Be-g' => 'Nederländerna, Belgien och Luxemburg',
    'Be-h' => 'Schweiz',
    'Be-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Be-j' => 'Frankrike och Monaco',
    'Be-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Be-l' => 'Portugal',
    'Be-m' => 'Östeuropa',
    'Be-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Be-mb' => 'Polen',
    'Be-mc' => 'Estland, Lettland, Litauen',
    'Be-n' => 'Balkanländerna',
    'Be-o' => 'Asien',
    'Be-oa' => 'Främre Asien',
    'Be-ob' => 'Främre Indien',
    'Be-oc' => 'Bortre Indien',
    'Be-od' => 'Ostindiska öarna',
    'Be-oe' => 'Östasien',
    'Be-oea' => 'Kina',
    'Be-oeb' => 'Korea',
    'Be-oec' => 'Japan',
    'Be-p' => 'Afrika',
    'Be-q' => 'Amerika',
    'Be-qa' => 'Förenta staterna',
    'Be-qb' => 'Kanada',
    'Be-qc' => 'Mexiko, Centralamerika och Västindien',
    'Be-qd' => 'Sydamerika',
    'Be-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bf' => 'Allmän vetenskaplig och kulturell verksamhet',
    'Bf-' => 'Allmänt: särskilda länder och områden',
    'Bf-a' => 'Europa: allmänt',
    'Bf-ae' => 'Europeiska unionen (EU)',
    'Bf-b' => 'Norden: allmänt',
    'Bf-c' => 'Sverige',
    'Bf-cz' => 'Särskilda institutioner',
    'Bf-d' => 'Övriga Norden',
    'Bf-da' => 'Danmark',
    'Bf-db' => 'Norge',
    'Bf-dc' => 'Island och Färöarna',
    'Bf-dd' => 'Finland',
    'Bf-e' => 'Brittiska öarna (Storbritannien)',
    'Bf-f' => 'Mellaneuropa',
    'Bf-fa' => 'Tyskland',
    'Bf-fb' => 'Österrike och Liechtenstein',
    'Bf-fc' => 'Ungern',
    'Bf-fd' => 'Tjeckien och Slovakien',
    'Bf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bf-h' => 'Schweiz',
    'Bf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bf-j' => 'Frankrike och Monaco',
    'Bf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bf-l' => 'Portugal',
    'Bf-m' => 'Östeuropa',
    'Bf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Bf-mb' => 'Polen',
    'Bf-mc' => 'Estland, Lettland, Litauen',
    'Bf-n' => 'Balkanländerna',
    'Bf-na' => 'Rumänien',
    'Bf-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Bf-nc' => 'Bulgarien',
    'Bf-nd' => 'Grekland',
    'Bf-nf' => 'Albanien',
    'Bf-o' => 'Asien',
    'Bf-oa' => 'Främre Asien',
    'Bf-ob' => 'Främre Indien',
    'Bf-oc' => 'Bortre Indien',
    'Bf-od' => 'Ostindiska öarna',
    'Bf-oe' => 'Östasien',
    'Bf-oea' => 'Kina',
    'Bf-oeb' => 'Korea',
    'Bf-oec' => 'Japan',
    'Bf-of' => 'Centralasien',
    'Bf-og' => 'Sibirien',
    'Bf-p' => 'Afrika',
    'Bf-pa' => 'Nordafrika utom Egypten',
    'Bf-pb' => 'Egypten och Sudan',
    'Bf-pc' => 'Västafrika',
    'Bf-pd' => 'Centralafrika',
    'Bf-pe' => 'Södra Afrika',
    'Bf-pf' => 'Östafrika',
    'Bf-pg' => 'Nordöstafrika',
    'Bf-q' => 'Amerika',
    'Bf-qa' => 'Förenta staterna',
    'Bf-qb' => 'Kanada',
    'Bf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Bf-qd' => 'Sydamerika',
    'Bf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bfa' => 'Allmän vetenskaplig verksamhet',
    'Bfab' => 'Beteendevetenskaplig forskning',
    'Bfah' => 'Humanistisk forskning',
    'Bfaj' => 'Allmänna stiftelser och fonder',
    'Bfaj-cz' => 'Sverige: särskilda stiftelser och fonder',
    'Bfk' => 'Allmän kulturell verksamhet',
    'Bfkb' => 'Allmänna barn- och ungdomskulturfrågor',
    'Bg' => 'Allmänna museer',
    'Bg-' => 'Allmänt: särskilda länder och områden',
    'Bg-a' => 'Europa: allmänt',
    'Bg-b' => 'Norden: allmänt',
    'Bg-c' => 'Sverige',
    'Bg-cs' => 'Samer',
    'Bg-cz' => 'Särskilda museer',
    'Bg-d' => 'Övriga Norden',
    'Bg-da' => 'Danmark',
    'Bg-db' => 'Norge',
    'Bg-dc' => 'Island och Färöarna',
    'Bg-dd' => 'Finland',
    'Bg-e' => 'Brittiska öarna (Storbritannien)',
    'Bg-f' => 'Mellaneuropa',
    'Bg-fa' => 'Tyskland',
    'Bg-fb' => 'Österrike och Liechtenstein',
    'Bg-fc' => 'Ungern',
    'Bg-fd' => 'Tjeckien och Slovakien',
    'Bg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bg-h' => 'Schweiz',
    'Bg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bg-j' => 'Frankrike och Monaco',
    'Bg-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bg-m' => 'Östeuropa',
    'Bg-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Bg-mb' => 'Polen',
    'Bg-mc' => 'Estland, Lettland, Litauen',
    'Bg-n' => 'Balkanländerna',
    'Bg-o' => 'Asien',
    'Bg-p' => 'Afrika',
    'Bg-q' => 'Amerika',
    'Bg-qa' => 'Förenta staterna',
    'Bg-qb' => 'Kanada',
    'Bg-qd' => 'Sydamerika',
    'Bg-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bga' => 'Museiteknik',
    'Bgk' => 'Kulturminnesvård',
    'Bh' => 'Allmänna utställningar',
    'Bh-c' => 'Sverige',
    'Bh-cs' => 'Samer',
    'Bh-cz' => 'Särskilda utställningar',
    'Bi' => 'Förenings- och mötesteknik',
    'Bk' => 'Allmänna sällskap och föreningar',
    'Bk-' => 'Särskilda länder och områden',
    'Bk-a' => 'Europa: allmänt',
    'Bk-b' => 'Norden: allmänt',
    'Bk-c' => 'Sverige',
    'Bk-cs' => 'Samer',
    'Bk-d' => 'Övriga Norden',
    'Bk-e' => 'Brittiska öarna (Storbritannien)',
    'Bk-f' => 'Mellaneuropa',
    'Bk-j' => 'Frankrike och Monaco',
    'Bk-m' => 'Östeuropa',
    'Bk-o' => 'Asien',
    'Bk-p' => 'Afrika',
    'Bk-q' => 'Amerika',
    'Bkz' => 'Särskilda allmänna sällskap och föreningar',
    'Bl' => 'Omstridda fenomen och företeelser',
    'Blb' => 'Ockultism',
    'Blc' => 'Spådomskonst (divination)',
    'Blca' => 'Astrologi',
    'Blcb' => 'Drömböcker',
    'Bld' => 'Frenologi',
    'Blf' => 'Kryptozoologi',
    'Blg' => 'Ufo',
    'Br' => 'Kommunikation, cybernetik, informationsteori',
    'Bra' => 'Kommunikation',
    'Brb' => 'Cybernetik och informationsteori',
    'Bs' => 'Masskommunikation: allmänt',
    'Bs-' => 'Särskilda länder och områden',
    'Bs-a' => 'Europa: allmänt',
    'Bs-ae' => 'Europeiska unionen (EU)',
    'Bs-b' => 'Norden: allmänt',
    'Bs-c' => 'Sverige',
    'Bs-cs' => 'Samer',
    'Bs-d' => 'Övriga Norden',
    'Bs-da' => 'Danmark',
    'Bs-db' => 'Norge',
    'Bs-dc' => 'Island och Färöarna',
    'Bs-dd' => 'Finland',
    'Bs-e' => 'Brittiska öarna (Storbritannien)',
    'Bs-f' => 'Mellaneuropa',
    'Bs-fa' => 'Tyskland',
    'Bs-fb' => 'Österrike och Liechtenstein',
    'Bs-fc' => 'Ungern',
    'Bs-fd' => 'Tjeckien och Slovakien',
    'Bs-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bs-h' => 'Schweiz',
    'Bs-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bs-j' => 'Frankrike och Monaco',
    'Bs-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bs-m' => 'Östeuropa',
    'Bs-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Bs-mb' => 'Polen',
    'Bs-mc' => 'Estland, Lettland, Litauen',
    'Bs-n' => 'Balkanländerna',
    'Bs-o' => 'Asien',
    'Bs-oa' => 'Främre Asien',
    'Bs-ob' => 'Främre Indien',
    'Bs-oc' => 'Bortre Indien',
    'Bs-od' => 'Ostindiska öarna',
    'Bs-oe' => 'Östasien',
    'Bs-p' => 'Afrika',
    'Bs-q' => 'Amerika',
    'Bs-qa' => 'Förenta staterna',
    'Bs-qb' => 'Kanada',
    'Bs-qc' => 'Mexiko, Centralamerika och Västindien',
    'Bs-qd' => 'Sydamerika',
    'Bs-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bsi' => 'Indoktrinering och propaganda',
    'Bt' => 'Publicistik (inkl tidningsväsen och -historia)',
    'Bt-' => 'Särskilda länder och områden',
    'Bt-a' => 'Europa: allmänt',
    'Bt-b' => 'Norden: allmänt',
    'Bt-c' => 'Sverige',
    'Bt-cs' => 'Samer',
    'Bt-cx' => 'Emigrantpress',
    'Bt-cz' => 'Särskilda tidningar och orter',
    'Bt-d' => 'Övriga Norden',
    'Bt-da' => 'Danmark',
    'Bt-db' => 'Norge',
    'Bt-dc' => 'Island och Färöarna',
    'Bt-dd' => 'Finland',
    'Bt-e' => 'Brittiska öarna (Storbritannien)',
    'Bt-f' => 'Mellaneuropa',
    'Bt-fa' => 'Tyskland',
    'Bt-fb' => 'Österrike och Liechtenstein',
    'Bt-fc' => 'Ungern',
    'Bt-fd' => 'Tjeckien och Slovakien',
    'Bt-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bt-h' => 'Schweiz',
    'Bt-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bt-j' => 'Frankrike och Monaco',
    'Bt-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bt-l' => 'Portugal',
    'Bt-m' => 'Östeuropa',
    'Bt-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Bt-mb' => 'Polen',
    'Bt-mc' => 'Estland, Lettland, Litauen',
    'Bt-n' => 'Balkanländerna',
    'Bt-o' => 'Asien',
    'Bt-oa' => 'Främre Asien',
    'Bt-ob' => 'Främre Indien',
    'Bt-oc' => 'Bortre Indien',
    'Bt-od' => 'Ostindiska öarna',
    'Bt-oe' => 'Östasien',
    'Bt-p' => 'Afrika',
    'Bt-pa' => 'Nordafrika utom Egypten',
    'Bt-pb' => 'Egypten och Sudan',
    'Bt-pc' => 'Västafrika',
    'Bt-pd' => 'Centralafrika',
    'Bt-pe' => 'Södra Afrika',
    'Bt-pf' => 'Östafrika',
    'Bt-pg' => 'Nordöstafrika',
    'Bt-q' => 'Amerika',
    'Bt-qa' => 'Förenta staterna',
    'Bt-qb' => 'Kanada',
    'Bt-qc' => 'Mexiko, Centralamerika och Västindien',
    'Bt-qd' => 'Sydamerika',
    'Bt-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bu' => 'Masskommunikation: radio och television',
    'Bu-' => 'Särskilda länder och områden',
    'Bu-a' => 'Europa: allmänt',
    'Bu-ae' => 'Europeiska unionen (EU)',
    'Bu-b' => 'Norden: allmänt',
    'Bu-c' => 'Sverige',
    'Bu-c:bf' => 'Radio- och TV-stationer',
    'Bu-d' => 'Övriga Norden',
    'Bu-da' => 'Danmark',
    'Bu-db' => 'Norge',
    'Bu-dd' => 'Finland',
    'Bu-e' => 'Brittiska öarna (Storbritannien)',
    'Bu-f' => 'Mellaneuropa',
    'Bu-fa' => 'Tyskland',
    'Bu-fb' => 'Österrike och Liechtenstein',
    'Bu-fc' => 'Ungern',
    'Bu-fd' => 'Tjeckien och Slovakien',
    'Bu-g' => 'Nederländerna, Belgien och Luxemburg',
    'Bu-h' => 'Schweiz',
    'Bu-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Bu-j' => 'Frankrike och Monaco',
    'Bu-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Bu-m' => 'Östeuropa',
    'Bu-o' => 'Asien',
    'Bu-p' => 'Afrika',
    'Bu-q' => 'Amerika',
    'Bu-qa' => 'Förenta staterna',
    'Bu-qb' => 'Kanada',
    'Bu-qc' => 'Mexiko, Centralamerika och Västindien',
    'Bu-qd' => 'Sydamerika',
    'Bu-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Bua' => 'Radio',
    'Bub' => 'Television och video',
    'Bv' => 'Informationsteknik (IT)',
    'Bv-' => 'Särskilda länder och områden',
    'Bv-a' => 'Europa: allmänt',
    'Bv-ae' => 'Europeiska unionen (EU)',
    'Bv-b' => 'Norden: allmänt',
    'Bv-c' => 'Sverige',
    'Bv-d' => 'Övriga Norden',
    'Bv-o' => 'Asien',
    'Bv-p' => 'Afrika',
    'Bv-q' => 'Amerika',
    'C' => 'Religion',
    'C(x)' => 'Religionslexikon',
    'C:d' => 'Religionsfilosofi och -psykologi',
    'C:dd' => 'Metodlära',
    'C:do' => 'Religionspsykologi',
    'C:oa' => 'Religionssociologi',
    'Ca' => 'Kristendomen: allmänt',
    'Ca(x)' => 'Allmänt: lexikon',
    'Ca:k' => 'Kristendomens historia',
    'Cb' => 'Bibelutgåvor',
    'Cb=' => 'Bibelutgåvor på särskilda språk',
    'Cb=c' => 'Svenska',
    'Cb=d' => 'Övriga nordiska språk',
    'Cb=da' => 'Danska',
    'Cb=db' => 'Norska',
    'Cb=dc' => 'Isländska',
    'Cb=e' => 'Engelska',
    'Cb=f' => 'Tyska',
    'Cb=g' => 'Nederländska',
    'Cb=h' => 'Rumänska',
    'Cb=i' => 'Italienska',
    'Cb=j' => 'Franska',
    'Cb=k' => 'Spanska',
    'Cb=l' => 'Portugisiska',
    'Cb=m' => 'Slaviska och baltiska språk',
    'Cb=ma' => 'Ryska',
    'Cb=mb' => 'Ukrainska och vitryska',
    'Cb=mc' => 'Polska',
    'Cb=md' => 'Tjeckiska',
    'Cb=mi' => 'Fornkyrkslaviska',
    'Cb=mk' => 'Baltiska språk',
    'Cb=n' => 'Keltiska språk',
    'Cb=o' => 'Grekiska och latin',
    'Cb=oa' => 'Grekiska (klassisk och bysantinsk)',
    'Cb=oc' => 'Latin',
    'Cb=p' => 'Indo-ariska språk',
    'Cb=q' => 'Iranska språk',
    'Cb=r' => 'Övriga indoeuropeiska språk',
    'Cb=s' => 'Semitiska språk',
    'Cb=sd' => 'Heberiska',
    'Cb=se' => 'Arameiska och syriska (syriak)',
    'Cb=sg' => 'Arabiska',
    'Cb=t' => 'Hamitiska språk och tchadspråk',
    'Cb=u' => 'Finsk-ugriska och altaiska språk',
    'Cb=ub' => 'Finska',
    'Cb=v' => 'Sino-tibetanska och austroasiatiska språk',
    'Cb=x' => 'Övriga språk',
    'Cba' => 'Gamla testamentet',
    'Cba=' => 'Utgåvor på särskilda språk',
    'Cba=c' => 'Svenska',
    'Cba=d' => 'Övriga nordiska språk',
    'Cba=e' => 'Engelska',
    'Cba=f' => 'Tyska',
    'Cba=j' => 'Franska',
    'Cba=k' => 'Spanska',
    'Cba=m' => 'Slaviska och baltiska språk',
    'Cba=o' => 'Grekiska och latin',
    'Cba=oa' => 'Grekiska (klassisk och bysantinsk)',
    'Cba=oc' => 'Latin',
    'Cba=s' => 'Semitiska språk',
    'Cba=sd' => 'Heberiska',
    'Cba=se' => 'Arameiska och syriska (syriak)',
    'Cba=sg' => 'Arabiska',
    'Cba=t' => 'Hamitiska språk och tchadspråk',
    'Cba=u' => 'Finsk-ugriska och altaiska språk',
    'Cbaa' => 'Historiska böcker',
    'Cbaaa' => 'Moseböckerna (Pentateuken, Tora)',
    'Cbaab' => 'Josua',
    'Cbaac' => 'Domarboken',
    'Cbaad' => 'Rut',
    'Cbaae' => 'Samuelsböckerna',
    'Cbaaf' => 'Konungaböckerna',
    'Cbaag' => 'Krönikeböckerna',
    'Cbaah' => 'Esra',
    'Cbaai' => 'Nehemja',
    'Cbaaj' => 'Ester',
    'Cbab' => 'Poetiska böcker',
    'Cbaba' => 'Job',
    'Cbabb' => 'Psaltaren',
    'Cbabc' => 'Ordspråksboken',
    'Cbabd' => 'Predikaren',
    'Cbabe' => 'Höga Visan',
    'Cbac' => 'Profetiska böcker',
    'Cbaca' => 'Jesaja',
    'Cbacb' => 'Jeremia',
    'Cbacc' => 'Klagovisorna',
    'Cbacd' => 'Hesekiel',
    'Cbace' => 'Daniel',
    'Cbacf' => 'Hosea',
    'Cbacg' => 'Joel',
    'Cbach' => 'Amos',
    'Cbaci' => 'Obadja',
    'Cbacj' => 'Jona',
    'Cback' => 'Mika',
    'Cbacl' => 'Nahum',
    'Cbacm' => 'Habackuk',
    'Cbacn' => 'Sefanja',
    'Cbaco' => 'Haggai',
    'Cbacp' => 'Sakarja',
    'Cbacq' => 'Malaki',
    'Cbb' => 'Nya testamentet',
    'Cbb=' => 'Utgåvor på särskilda språk',
    'Cbb=c' => 'Svenska',
    'Cbb=d' => 'Övriga nordiska språk',
    'Cbb=e' => 'Engelska',
    'Cbb=f' => 'Tyska',
    'Cbb=g' => 'Nederländska',
    'Cbb=h' => 'Rumänska',
    'Cbb=i' => 'Italienska',
    'Cbb=j' => 'Franska',
    'Cbb=k' => 'Spanska',
    'Cbb=l' => 'Portugisiska',
    'Cbb=m' => 'Slaviska och baltiska språk',
    'Cbb=ma' => 'Ryska',
    'Cbb=mb' => 'Ukrainska och vitryska',
    'Cbb=mc' => 'Polska',
    'Cbb=md' => 'Tjeckiska',
    'Cbb=mi' => 'Fornkyrkslaviska',
    'Cbb=mk' => 'Baltiska språk',
    'Cbb=o' => 'Grekiska och latin',
    'Cbb=oa' => 'Grekiska (klassisk och bysantinsk)',
    'Cbb=oc' => 'Latin',
    'Cbb=q' => 'Iranska språk',
    'Cbb=s' => 'Semitiska språk',
    'Cbb=sd' => 'Heberiska',
    'Cbb=se' => 'Arameiska och syriska (syriak)',
    'Cbb=sg' => 'Arabiska',
    'Cbb=t' => 'Hamitiska språk och tchadspråk',
    'Cbb=u' => 'Finsk-ugriska och altaiska språk',
    'Cbb=ub' => 'Finska',
    'Cbb=v' => 'Sino-tibetanska och austroasiatiska språk',
    'Cbb=x' => 'Övriga språk',
    'Cbba' => 'Evangelierna och Apostlagärningarna',
    'Cbbaa' => 'Matteusevangeliet',
    'Cbbab' => 'Markusevangeliet',
    'Cbbac' => 'Lukasevangeliet',
    'Cbbad' => 'Johannesevangeliet',
    'Cbbae' => 'Apostlagärningarna',
    'Cbbb' => 'Brev',
    'Cbbba' => 'Romarbrevet',
    'Cbbbb' => 'Korinthierbreven',
    'Cbbbc' => 'Galaterbrevet',
    'Cbbbd' => 'Efesierbrevet',
    'Cbbbe' => 'Filipperbrevet',
    'Cbbbf' => 'Kolosserbrevet',
    'Cbbbg' => 'Thessalonikerbreven',
    'Cbbbh' => 'Timotheosbreven',
    'Cbbbi' => 'Titusbrevet',
    'Cbbbj' => 'Filemonbrevet',
    'Cbbbk' => 'Hebreerbrevet',
    'Cbbbl' => 'De katolska breven (Jakobsbrevet, Petrusbreven, Johannesbreven, Judasbrevet)',
    'Cbbc' => 'Uppenbarelseboken',
    'Cbc' => 'Apokryfer och pseudepigrafer',
    'Cbca' => 'Gamla testamentet',
    'Cbcb' => 'Nya testamentet',
    'Cbs' => 'Bibelspråk',
    'Cc' => 'Exegetik och litteratur om Bibeln',
    'Cc(x)' => 'Exegetiska lexikon',
    'Cca' => 'Gamla testamentet',
    'Ccaa' => 'Historiska böcker',
    'Ccaaa' => 'Moseböckerna (Pentateuken, Tora)',
    'Ccaab' => 'Josua',
    'Ccaac' => 'Domarboken',
    'Ccaad' => 'Rut',
    'Ccaae' => 'Samuelsböckerna',
    'Ccaaf' => 'Konungaböckerna',
    'Ccaag' => 'Krönikeböckerna',
    'Ccaah' => 'Esra',
    'Ccaai' => 'Nehemja',
    'Ccaaj' => 'Ester',
    'Ccab' => 'Poetiska böcker',
    'Ccaba' => 'Job',
    'Ccabb' => 'Psaltaren',
    'Ccabc' => 'Ordspråksboken',
    'Ccabd' => 'Predikaren',
    'Ccabe' => 'Höga visan',
    'Ccac' => 'Profetiska böcker',
    'Ccaca' => 'Jesaja',
    'Ccacb' => 'Jeremia',
    'Ccacc' => 'Klagovisorna',
    'Ccacd' => 'Hesekiel',
    'Ccace' => 'Daniel',
    'Ccacf' => 'Hosea',
    'Ccacg' => 'Joel',
    'Ccach' => 'Amos',
    'Ccaci' => 'Obadja',
    'Ccacj' => 'Jona',
    'Ccack' => 'Mika',
    'Ccacl' => 'Nahum',
    'Ccacm' => 'Habackuk',
    'Ccacn' => 'Sefanja',
    'Ccaco' => 'Haggai',
    'Ccacp' => 'Sakarja',
    'Ccacq' => 'Malaki',
    'Ccb' => 'Nya testamentet',
    'Ccba' => 'Evangelierna och Apostlagärningarna',
    'Ccbaa' => 'Matteusevangeliet',
    'Ccbab' => 'Markusevangeliet',
    'Ccbac' => 'Lukasevangeliet',
    'Ccbad' => 'Johannesevangeliet',
    'Ccbae' => 'Apostlagärningarna',
    'Ccbb' => 'Brev',
    'Ccbba' => 'Romarbrevet',
    'Ccbbb' => 'Korinthierbreven',
    'Ccbbc' => 'Galaterbrevet',
    'Ccbbd' => 'Efesierbrevet',
    'Ccbbe' => 'Filipperbrevet',
    'Ccbbf' => 'Kolosserbrevet',
    'Ccbbg' => 'Thessalonikerbreven',
    'Ccbbh' => 'Timotheosbreven',
    'Ccbbi' => 'Titusbrevet',
    'Ccbbj' => 'Filemonbrevet',
    'Ccbbk' => 'Hebreerbrevet',
    'Ccbbl' => 'De katolska breven (Jakobsbrevet, Petrusbreven, Johannesbreven, Judasbrevet)',
    'Ccbc' => 'Uppenbarelseboken',
    'Ccc' => 'Apokryfer och pseudepigrafer',
    'Ccca' => 'Gamla testamentet',
    'Cccb' => 'Nya testamentet',
    'Ccd' => 'Bibliska personer',
    'Ccda' => 'Jesu liv',
    'Ccdz' => 'Övriga särskilda bibliska personer',
    'Cce' => 'Biblisk realiakunskap',
    'Ccea' => 'Biblisk geografi och natur',
    'Cceb' => 'Biblisk arkeologi',
    'Ccec' => 'Biblisk historia',
    'Cced' => 'Andlig och religiös kultur',
    'Cd' => 'Äldre teologisk litteratur',
    'Cda' => 'Kyrkofädernas skrifter och fornkristen litteratur',
    'Cdb' => 'Medeltidsteologers skrifter',
    'Cdc' => 'Reformatorernas skrifter',
    'Cdd' => 'Skrifter av motreformationens teologer',
    'Ce' => 'Dogmatik och symbolik',
    'Cea' => 'Dogmatik',
    'Cea:k' => 'Dogmatikens historia',
    'Cea:k.' => 'Särskilda perioder',
    'Cea:k.2' => 'Forntiden',
    'Cea:k.3' => 'Medeltiden',
    'Cea:k.31' => 'Bysantinska riket 395-1453',
    'Cea:k.33' => 'Äldre medeltiden ca 476 - 1050',
    'Cea:k.35' => 'Högmedeltiden ca 1050 - 1300',
    'Cea:k.38' => 'Senmedeltiden ca 1300 - 1500',
    'Cea:k.4' => 'Nya tiden',
    'Cea:k.41' => '1500-1648',
    'Cea:k.43' => '1648-1789',
    'Cea:k.46' => '1815-1914',
    'Cea:k.5' => '1900-',
    'Cea:k.6' => '2000-',
    'Ceaa' => 'Gud, skapelsen och människan',
    'Ceab' => 'Kristus, frälsningen och tron',
    'Ceac' => 'Anden och kyrkan',
    'Cead' => 'Den enskildes religiösa liv',
    'Ceae' => 'Sakramenten',
    'Ceae:k' => 'Sakramentens historia',
    'Ceaea' => 'Dopet',
    'Ceaea:k' => 'Dopets historia',
    'Ceaeb' => 'Nattvarden',
    'Ceaeb:k' => 'Nattvardens historia',
    'Ceaf' => 'Eskatologi',
    'Ceaf:k' => 'Eskatologins historia',
    'Ceaf:k.' => 'Särskilda perioder',
    'Ceaf:k.2' => 'Forntiden',
    'Ceaf:k.3' => 'Medeltiden',
    'Ceaf:k.4' => 'Nya tiden',
    'Ceb' => 'Symbolik',
    'Ceb(u)' => 'Urkunder',
    'Ced' => 'Katekeser',
    'Ced=c' => 'Utgåvor på svenska',
    'Cef' => 'Polemik och apologetik',
    'Cef:k' => 'Polemikens och apologetikens historia',
    'Cef:k.' => 'Särskilda perioder',
    'Cef:k.2' => 'Forntiden',
    'Cef:k.3' => 'Medeltiden',
    'Cef:k.4' => 'Nya tiden',
    'Cef:k.5' => '1900-',
    'Cef:k.6' => '2000-',
    'Cf' => 'Teologisk etik',
    'Cf:k' => 'Den  teologiska etikens historia',
    'Cf:k.' => 'Särskilda perioder',
    'Cf:k.2' => 'Forntiden',
    'Cf:k.3' => 'Medeltiden',
    'Cf:k.4' => 'Nya tiden',
    'Cf:k.5' => '1900-',
    'Cf:k.6' => '2000-',
    'Cfd' => 'Filosofi och psykologi',
    'Cfo' => 'Samhälls- och rättsvetenskap',
    'Cfoh' => 'Sociala frågor och socialpolitik',
    'Cfq' => 'Ekonomi och näringsväsen',
    'Cfs' => 'Militärväsen',
    'Cfu' => 'Naturvetenskap',
    'Cfv' => 'Medicin',
    'Cfvn' => 'Samhällsmedicin, hygien, sexologi',
    'Cg' => 'Praktisk teologi',
    'Cga' => 'Religionssamfunden och samhället',
    'Cga-' => 'Särskilda länder och områden',
    'Cga-a' => 'Europa: allmänt',
    'Cga-ae' => 'Europeiska unionen (EU)',
    'Cga-b' => 'Norden: allmänt',
    'Cga-c' => 'Sverige',
    'Cga-d' => 'Övriga Norden',
    'Cga-e' => 'Brittiska öarna (Storbritannien)',
    'Cga-f' => 'Mellaneuropa',
    'Cga-g' => 'Nederländerna, Belgien och Luxemburg',
    'Cga-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Cga-j' => 'Frankrike och Monaco',
    'Cga-m' => 'Östeuropa',
    'Cga-o' => 'Asien',
    'Cga-p' => 'Afrika',
    'Cga-q' => 'Amerika',
    'Cga-qa' => 'Förenta staterna',
    'Cga-qb' => 'Kanada',
    'Cga-qc' => 'Mexiko, Centralamerika och Västindien',
    'Cga-qd' => 'Sydamerika',
    'Cgb' => 'Kyrklig administration och kyrkorätt',
    'Cgb(u)' => 'Lagar och förordningar: allmänt',
    'Cgb-' => 'Särskilda länder och områden',
    'Cgb-b' => 'Norden: allmänt',
    'Cgb-c' => 'Sverige',
    'Cgb-c(u)' => 'Lagar och förordningar',
    'Cgb-d' => 'Övriga Norden',
    'Cgb-da' => 'Danmark',
    'Cgb-db' => 'Norge',
    'Cgb-dd' => 'Finland',
    'Cgb-e' => 'Brittiska öarna (Storbritannien)',
    'Cgb-f' => 'Mellaneuropa',
    'Cgb-fa' => 'Tyskland',
    'Cgb-fb' => 'Österrike och Liechtenstein',
    'Cgb-h' => 'Schweiz',
    'Cgb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Cgb-j' => 'Frankrike och Monaco',
    'Cgb-m' => 'Östeuropa',
    'Cgb-o' => 'Asien',
    'Cgba' => 'Central administration',
    'Cgba-c' => 'Sverige',
    'Cgbb' => 'Stiftsadministration',
    'Cgbb-c' => 'Sverige',
    'Cgbc' => 'Församlingsadministration',
    'Cgbc-c' => 'Sverige',
    'Cgc' => 'Församlings- och själavård',
    'Cgc-c' => 'Sverige',
    'Cgc-d' => 'Övriga Norden',
    'Cgck' => 'Diakoni',
    'Cgck-c' => 'Sverige',
    'Cgck-c:bf' => 'Diakoniinstitutioner',
    'Cge' => 'Kateketik',
    'Cge-c' => 'Sverige',
    'Cgea' => 'Söndagsskola',
    'Cgea-c' => 'Sverige',
    'Cgeb' => 'Konfirmationsundervisning',
    'Cgeb-c' => 'Sverige',
    'Cgf' => 'Ekumenik',
    'Cgf:bf' => 'Ekumeniska institutioner',
    'Cgf-c' => 'Sverige',
    'Ch' => 'Gudstjänsten',
    'Cha' => 'Liturgik',
    'Cha(u)' => 'Handböcker, evangelieböcker och andra gudstjänstordningar',
    'Cha-c' => 'Sverige',
    'Cha-d' => 'Övriga Norden',
    'Chaa' => 'Offentlig gudstjänst',
    'Chab' => 'Förrättningar',
    'Chab:k' => 'Historia',
    'Chac' => 'Kyrkoåret',
    'Chb' => 'Homiletik',
    'Chc' => 'Hymnologi',
    'Chc-c' => 'Sverige',
    'Chd' => 'Kyrkliga symboler och redskap',
    'Chd-c' => 'Sverige',
    'Ci' => 'Uppbyggelselitteratur',
    'Ci(s)' => 'Samlingar: allmänt',
    'Ci,u' => 'Uppbyggelselitteratur för barn och ungdom: allmänt',
    'Ci-c' => 'Utgåvor på svenska: allmänt',
    'Cia' => 'Predikningar och betraktelser',
    'Cia(s)' => 'Samlingar',
    'Cia,u' => 'Utgåvor för barn och ungdom',
    'Cia=' => 'Utgåvor på särskilda språk',
    'Cia=c' => 'Svenska',
    'Cia=d' => 'Övriga nordiska språk',
    'Cia=o' => 'Grekiska och latin',
    'Cia=u' => 'Finsk-ugriska och altaiska språk',
    'Ciaa' => 'Morgonsamlingar',
    'Cib' => 'Psalmer och andliga sånger',
    'Cib,u' => 'Utgåvor för barn och ungdom',
    'Cib=' => 'Utgåvor på särskilda språk',
    'Cib=c' => 'Svenska',
    'Cib=d' => 'Övriga nordiska språk',
    'Cib=f' => 'Tyska',
    'Cib=u' => 'Finsk-ugriska och altaiska språk',
    'Cid' => 'Böner',
    'Cid(s)' => 'Samlingar',
    'Cid,u' => 'Utgåvor för barn och ungdom',
    'Cie' => 'Ord för dagen',
    'Cj' => 'Kyrkohistoria',
    'Cj(x)' => 'Kyrkohistoriska lexikon',
    'Cj.0' => 'Allmän kyrkohistoria: särskilda aspekter',
    'Cj.01' => 'Källor och traditioner',
    'Cj.02' => 'Troslära och trosbekännelse',
    'Cj.03' => 'Offentlig gudstjänst och andra riter',
    'Cj.04' => 'Den enskildes religiösa liv',
    'Cj.05' => 'Etik',
    'Cj.06' => 'Organisation och ledare',
    'Cj.07' => 'Religiöst inspirerade aktiviteter',
    'Cj.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cj.09' => 'Sekter och reformrörelser',
    'Cj.' => 'Allmän kyrkohistoria: särskilda perioder',
    'Cj.2' => 'Forntiden till ca 450',
    'Cj.3' => 'Medeltiden ca 450 - 1517',
    'Cj.31' => 'Bysantinsk kyrkohistoria',
    'Cj.33' => '450-1054',
    'Cj.35' => '1054-1517',
    'Cj.4' => 'Nya tiden 1517 -',
    'Cj.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj.43' => '1600- och 1700-talet',
    'Cj.46' => '1800-talet',
    'Cj.5' => '1900-talet',
    'Cj.55' => '1945-',
    'Cj.58' => '1980-',
    'Cj.6' => '2000-',
    'Cj-' => 'Allmän kyrkohistoria: särskilda länder och områden',
    'Cj-a' => 'Europa: allmänt',
    'Cj-a.' => 'Särskilda perioder',
    'Cj-a.3' => 'Medeltiden',
    'Cj-a.4' => 'Nya tiden',
    'Cj-a.5' => '1900-talet',
    'Cj-a.6' => '2000-',
    'Cj-b' => 'Norden: allmänt',
    'Cj-b.' => 'Särskilda perioder',
    'Cj-b.3' => 'Medeltiden',
    'Cj-b.4' => 'Nya tiden',
    'Cj-b.5' => '1900-talet',
    'Cj-b.6' => '2000-',
    'Cj-c' => 'Sverige',
    'Cj-c.' => 'Särskilda perioder',
    'Cj-c.3' => 'Medeltiden',
    'Cj-c.4' => 'Nya tiden',
    'Cj-c.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-c.43' => '1600- och 1700-talen',
    'Cj-c.46' => '1800-talet',
    'Cj-c.5' => '1900-talet',
    'Cj-c.58' => '1980-',
    'Cj-c.59' => '1990-',
    'Cj-c.6' => '2000-',
    'Cj-cf' => 'Uppsala ärkestift',
    'Cj-cg' => 'Linköpings stift',
    'Cj-ch' => 'Skara stift',
    'Cj-ci' => 'Strängnäs stift',
    'Cj-cj' => 'Västerås stift',
    'Cj-ck' => 'Växjö och Kalmar stift',
    'Cj-cl' => 'Lunds stift',
    'Cj-cm' => 'Göteborgs stift',
    'Cj-cn' => 'Karlstads stift',
    'Cj-co' => 'Härnösands stift',
    'Cj-cp' => 'Luleå stift',
    'Cj-cq' => 'Visby stift',
    'Cj-cr' => 'Stockholms stift',
    'Cj-cx' => 'Svenska kyrkan i utlandet',
    'Cj-cz' => 'Särskilda svenska orter',
    'Cj-d' => 'Övriga Norden',
    'Cj-da' => 'Danmark',
    'Cj-da.' => 'Särskilda perioder',
    'Cj-da.3' => 'Medeltiden',
    'Cj-da.4' => 'Nya tiden',
    'Cj-da.5' => '1900-talet',
    'Cj-da.6' => '2000-',
    'Cj-db' => 'Norge',
    'Cj-db.' => 'Särskilda perioder',
    'Cj-db.3' => 'Medeltiden',
    'Cj-db.4' => 'Nya tiden',
    'Cj-db.5' => '1900-talet',
    'Cj-db.6' => '2000-',
    'Cj-dc' => 'Island och Färöarna',
    'Cj-dd' => 'Finland',
    'Cj-dd.' => 'Särskilda perioder',
    'Cj-dd.3' => 'Medeltiden',
    'Cj-dd.4' => 'Nya tiden',
    'Cj-dd.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-dd.43' => '1600- och 1700-talen',
    'Cj-dd.46' => '1800-talet',
    'Cj-dd.5' => '1900-talet',
    'Cj-dd.6' => '2000-',
    'Cj-e' => 'Brittiska öarna (Storbritannien)',
    'Cj-e.' => 'Särskilda perioder',
    'Cj-e.2' => 'Forntiden',
    'Cj-e.3' => 'Medeltiden',
    'Cj-e.4' => 'Nya tiden',
    'Cj-e.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-e.43' => '1600- och 1700-talen',
    'Cj-e.46' => '1800-talet',
    'Cj-e.5' => '1900-talet',
    'Cj-e.6' => '2000-',
    'Cj-es' => 'Skottland',
    'Cj-et' => 'Irland',
    'Cj-f' => 'Mellaneuropa',
    'Cj-fa' => 'Tyskland',
    'Cj-fa.' => 'Särskilda perioder',
    'Cj-fa.3' => 'Medeltiden',
    'Cj-fa.4' => 'Nya tiden',
    'Cj-fa.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-fa.43' => '1600- och 1700-talen',
    'Cj-fa.46' => '1800-talet',
    'Cj-fa.5' => '1900-talet',
    'Cj-fa.6' => '2000-',
    'Cj-fb' => 'Österrike och Liechtenstein',
    'Cj-fc' => 'Ungern',
    'Cj-fd' => 'Tjeckien och Slovakien',
    'Cj-g' => 'Nederländerna, Belgien och Luxemburg',
    'Cj-ga' => 'Nederländerna',
    'Cj-gb' => 'Belgien',
    'Cj-gc' => 'Luxemburg',
    'Cj-h' => 'Schweiz',
    'Cj-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Cj-i.' => 'Särskilda perioder',
    'Cj-i.2' => 'Forntiden',
    'Cj-i.3' => 'Medeltiden',
    'Cj-i.4' => 'Nya tiden',
    'Cj-i.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-i.43' => '1600- och 1700-talen',
    'Cj-i.46' => '1800-talet',
    'Cj-i.5' => '1900-talet',
    'Cj-i.6' => '2000-',
    'Cj-j' => 'Frankrike och Monaco',
    'Cj-j.' => 'Särskilda perioder',
    'Cj-j.3' => 'Medeltiden',
    'Cj-j.4' => 'Nya tiden',
    'Cj-j.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-j.43' => '1600- och 1700-talen',
    'Cj-j.46' => '1800-talet',
    'Cj-j.5' => '1900-talet',
    'Cj-j.6' => '2000-',
    'Cj-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Cj-k.' => 'Särskilda perioder',
    'Cj-k.3' => 'Medeltiden',
    'Cj-k.4' => 'Nya tiden',
    'Cj-k.5' => '1900-talet',
    'Cj-k.6' => '2000-',
    'Cj-l' => 'Portugal',
    'Cj-m' => 'Östeuropa',
    'Cj-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Cj-ma.' => 'Särskilda perioder',
    'Cj-ma.3' => 'Medeltiden',
    'Cj-ma.4' => 'Nya tiden',
    'Cj-ma.5' => '1900-talet',
    'Cj-ma.6' => '2000-',
    'Cj-mb' => 'Polen',
    'Cj-mb.' => 'Särskilda perioder',
    'Cj-mb.3' => 'Medeltiden',
    'Cj-mb.4' => 'Nya tiden',
    'Cj-mb.5' => '1900-talet',
    'Cj-mb.6' => '2000-',
    'Cj-mc' => 'Estland, Lettland, Litauen',
    'Cj-mca' => 'Estland',
    'Cj-mcb' => 'Lettland',
    'Cj-mcc' => 'Litauen',
    'Cj-n' => 'Balkanländerna',
    'Cj-na' => 'Rumänien',
    'Cj-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Cj-nc' => 'Bulgarien',
    'Cj-nd' => 'Grekland',
    'Cj-o' => 'Asien',
    'Cj-oa' => 'Främre Asien',
    'Cj-ob' => 'Främre Indien',
    'Cj-oc' => 'Bortre Indien',
    'Cj-od' => 'Ostindiska öarna',
    'Cj-oe' => 'Östasien',
    'Cj-oea' => 'Kina',
    'Cj-oeb' => 'Korea',
    'Cj-oec' => 'Japan',
    'Cj-of' => 'Centralasien',
    'Cj-p' => 'Afrika',
    'Cj-pa' => 'Nordafrika utom Egypten',
    'Cj-pb' => 'Egypten och Sudan',
    'Cj-pc' => 'Västafrika',
    'Cj-pd' => 'Centralafrika',
    'Cj-pe' => 'Södra Afrika',
    'Cj-pf' => 'Östafrika',
    'Cj-pg' => 'Nordöstafrika',
    'Cj-q' => 'Amerika',
    'Cj-qa' => 'Förenta staterna',
    'Cj-qa.' => 'Särskilda perioder',
    'Cj-qa.4' => 'Nya tiden',
    'Cj-qa.41' => 'Reformationen och motreformationen ca 1517-1598',
    'Cj-qa.43' => '1600- och 1700-talen',
    'Cj-qa.46' => '1800-talet',
    'Cj-qa.5' => '1900-talet',
    'Cj-qa.6' => '2000-',
    'Cj-qb' => 'Kanada',
    'Cj-qc' => 'Mexiko, Centralamerika och Västindien',
    'Cj-qd' => 'Sydamerika',
    'Cj-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cj-s' => 'Polarländerna',
    'Cjy' => 'Hagiografi',
    'Cjz' => 'Kyrkohistoria: särskilda personer',
    'Ck' => 'Kristna samfund',
    'Cka' => 'Ortodoxa kyrkor',
    'Cka.0' => 'Särskilda aspekter',
    'Cka.01' => 'Källor och traditioner',
    'Cka.02' => 'Troslära och trosbekännelse',
    'Cka.03' => 'Offentlig gudstjänst och andra riter',
    'Cka.04' => 'Den enskildes religiösa liv',
    'Cka.05' => 'Etik',
    'Cka.06' => 'Organisation och ledare',
    'Cka.07' => 'Religiöst inspirerade aktiviteter',
    'Cka.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cka.09' => 'Sekter och reformrörelser',
    'Cka-c' => 'Sverige',
    'Ckab' => 'Äldre kätterier och sekter',
    'Ckb' => 'Romersk-katolska kyrkan',
    'Ckb:k' => 'Den romersk-katolska kyrkans historia',
    'Ckb.0' => 'Särskilda aspekter',
    'Ckb.02' => 'Troslära och trosbekännelse',
    'Ckb.03' => 'Offentlig gudstjänst och andra riter',
    'Ckb.04' => 'Den enskildes religiösa liv',
    'Ckb.05' => 'Etik',
    'Ckb.06' => 'Organisation och ledare',
    'Ckb.07' => 'Religiöst inspirerade aktiviteter',
    'Ckb.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Ckb.09' => 'Sekter och reformrörelser',
    'Ckb-' => 'Särskilda länder och områden',
    'Ckb-a' => 'Europa: allmänt',
    'Ckb-b' => 'Norden: allmänt',
    'Ckb-c' => 'Sverige',
    'Ckb-cs' => 'Samer',
    'Ckb-d' => 'Övriga Norden',
    'Ckb-e' => 'Brittiska öarna (Storbritannien)',
    'Ckb-f' => 'Mellaneuropa',
    'Ckb-fa' => 'Tyskland',
    'Ckb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ckb-m' => 'Östeuropa',
    'Ckb-n' => 'Balkanländerna',
    'Ckb-o' => 'Asien',
    'Ckb-p' => 'Afrika',
    'Ckb-q' => 'Amerika',
    'Ckb-qa' => 'Förenta staterna',
    'Ckb-qb' => 'Kanada',
    'Ckb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ckb-qd' => 'Sydamerika',
    'Ckba' => 'Påvestolen',
    'Ckbb' => 'Äldre kätterier och sekter',
    'Ckbc' => 'Kanonisk rätt',
    'Ckc' => 'Lutherska samfund',
    'Ckc:k' => 'De lutherska samfundens historia',
    'Ckc.0' => 'Särskilda aspekter',
    'Ckc.02' => 'Troslära och trosbekännelse',
    'Ckc.03' => 'Offentlig gudstjänst och andra riter',
    'Ckc.05' => 'Etik',
    'Ckc.06' => 'Organisation och ledare',
    'Ckc.07' => 'Religiöst inspirerade aktiviteter',
    'Ckc.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Ckc-c' => 'Sverige',
    'Ckd' => 'Reformerta samfund',
    'Ckd:k' => 'De reformerta samfundens historia',
    'Cke' => 'Anglikanska kyrkor',
    'Cko' => 'Orientaliska kyrkor av främreasiatiskt ursprung',
    'Ckoa' => 'Grekisk-katolska (Melkitiska) kyrkan',
    'Ckob' => 'Armeniska kyrkor',
    'Ckoc' => 'Syriska kyrkor',
    'Ckod' => 'Maronitiska kyrkan',
    'Ckoe' => 'Nestorianska och Kaldeisk-katolska kyrkorna',
    'Ckop' => 'Koptiska och etiopiska kyrkor',
    'Cks' => 'Frikyrkosamfund och reformrörelser',
    'Cksa' => 'Adventister',
    'Cksb' => 'Baptister',
    'Cksb-c' => 'Sverige',
    'Cksba' => 'Mennoniter',
    'Cksd' => 'Christian science',
    'Cksf' => 'Evangeliska fosterlandsstiftelsen',
    'Cksf-c' => 'Sverige',
    'Cksh-c' => 'Sverige',
    'Cksh' => 'Frälsningsarmén',
    'Cksk' => 'Herrnhutare',
    'Cksl' => 'Laestadianer',
    'Cksm' => 'Jehovas vittnen',
    'Cksn' => 'Kväkare',
    'Ckso' => 'Metodister',
    'Ckso-c' => 'Sverige',
    'Cksq' => 'Mormoner',
    'Cksr' => 'Örebromissionen',
    'Ckss' => 'Pingstvänner',
    'Ckss-c' => 'Sverige',
    'Ckst' => 'Shakers',
    'Cksu' => 'Swedenborgare',
    'Cksv' => 'Svenska alliansmissionen',
    'Cksx' => 'Svenska missionskyrkan',
    'Cksy' => 'Unitarier',
    'Cksö' => 'Övriga samfund',
    'Ckt' => 'Andliga ordnar och klosterväsen',
    'Ckta' => 'Romersk-katolska kyrkan',
    'Ckta-' => 'Särskilda länder och områden',
    'Ckta-c' => 'Sverige',
    'Ckta-d' => 'Övriga Norden',
    'Ckta-e' => 'Brittiska öarna (Storbritannien)',
    'Ckta-ez' => 'Särskilda kloster',
    'Ckta-f' => 'Mellaneuropa',
    'Ckta-fa' => 'Tyskland',
    'Ckta-faz' => 'Särskilda kloster',
    'Ckta-fb' => 'Österrike och Liechtenstein',
    'Ckta-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ckta-h' => 'Schweiz',
    'Ckta-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ckta-iz' => 'Särskilda kloster',
    'Ckta-j' => 'Frankrike och Monaco',
    'Ckta-jz' => 'Särskilda kloster',
    'Ckta-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ckta-m' => 'Östeuropa',
    'Ckta-n' => 'Balkanländerna',
    'Ckta-q' => 'Amerika',
    'Ckta-cz' => 'Särskilda kloster',
    'Cktaz' => 'Särskilda romersk-katolska ordnar',
    'Cktb' => 'Ortodoxa kyrkor',
    'Cktb-' => 'Särskilda länder och områden',
    'Cktb-dd' => 'Finland',
    'Cktb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Cktb-n' => 'Balkanländerna',
    'Cktb-nd' => 'Grekland',
    'Cktc' => 'Lutherska samfund',
    'Cktcz' => 'Särskilda lutherska ordnar',
    'Ckte' => 'Anglikanska kyrkan',
    'Ckto' => 'Orientaliska kyrkor',
    'Cku' => 'Religiösa föreningar',
    'Cl' => 'Kristen mission',
    'Cl-' => 'Särskilda länder och områden',
    'Cl-a' => 'Europa: allmänt',
    'Cl-b' => 'Norden: allmänt',
    'Cl-c' => 'Sverige',
    'Cl-cs' => 'Samer',
    'Cl-d' => 'Övriga Norden',
    'Cl-m' => 'Östeuropa',
    'Cl-o' => 'Asien',
    'Cl-oa' => 'Främre Asien',
    'Cl-ob' => 'Främre Indien',
    'Cl-oba' => 'Indien',
    'Cl-oc' => 'Bortre Indien',
    'Cl-od' => 'Ostindiska öarna',
    'Cl-oe' => 'Östasien',
    'Cl-oea' => 'Kina',
    'Cl-oeb' => 'Korea',
    'Cl-oec' => 'Japan',
    'Cl-of' => 'Centralasien',
    'Cl-p' => 'Afrika',
    'Cl-pa' => 'Nordafrika utom Egypten',
    'Cl-pb' => 'Egypten och Sudan',
    'Cl-pc' => 'Västafrika',
    'Cl-pd' => 'Centralafrika',
    'Cl-pe' => 'Södra Afrika',
    'Cl-pf' => 'Östafrika',
    'Cl-pg' => 'Nordöstafrika',
    'Cl-q' => 'Amerika',
    'Cl-qa' => 'Förenta staterna',
    'Cl-qb' => 'Kanada',
    'Cl-qc' => 'Mexiko, Centralamerika och Västindien',
    'Cl-qd' => 'Sydamerika',
    'Cl-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cl-s' => 'Polarländerna',
    'Clm' => 'Kristen mission med inriktning på särskilda religioner',
    'Clmdb' => 'Kristen mission bland judar',
    'Clmdd' => 'Kristen mission bland muslimer',
    'Clmeb' => 'Kristen mission bland hinduer',
    'Clmec' => 'Kristen mission bland buddhister',
    'Cm' => 'Religionshistoria',
    'Cm(x)' => 'Religionshistoriska lexikon',
    'Cm.0' => 'Allmänt: särskilda aspekter',
    'Cm.01' => 'Källor och traditioner',
    'Cm.02' => 'Troslära och trosbekännelse',
    'Cm.03' => 'Offentlig gudstjänst och andra riter',
    'Cm.04' => 'Den enskildes religiösa liv',
    'Cm.05' => 'Etik',
    'Cm.06' => 'Organisation och ledare',
    'Cm.07' => 'Religiöst inspirerade aktiviteter',
    'Cm.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cm.09' => 'Sekter och reformrörelser',
    'Cm-' => 'Särskilda länder och områden',
    'Cm-a' => 'Europa: allmänt',
    'Cm-b' => 'Norden: allmänt',
    'Cm-c' => 'Sverige',
    'Cm-d' => 'Övriga Norden',
    'Cm-e' => 'Brittiska öarna (Storbritannien)',
    'Cm-f' => 'Mellaneuropa',
    'Cm-m' => 'Östeuropa',
    'Cm-n' => 'Balkanländerna',
    'Cm-o' => 'Asien',
    'Cm-oa' => 'Främre Asien',
    'Cm-ob' => 'Främre Indien',
    'Cm-oc' => 'Bortre Indien',
    'Cm-od' => 'Ostindiska öarna',
    'Cm-oe' => 'Östasien',
    'Cm-oea' => 'Kina',
    'Cm-oeb' => 'Korea',
    'Cm-oec' => 'Japan',
    'Cm-of' => 'Centralasien',
    'Cm-og' => 'Sibirien',
    'Cm-p' => 'Afrika',
    'Cm-pa' => 'Nordafrika utom Egypten',
    'Cm-pb' => 'Egypten och Sudan',
    'Cm-pc' => 'Västafrika',
    'Cm-pd' => 'Centralafrika',
    'Cm-pe' => 'Södra Afrika',
    'Cm-pf' => 'Östafrika',
    'Cm-pg' => 'Nordöstafrika',
    'Cm-q' => 'Amerika',
    'Cm-qa' => 'Förenta staterna',
    'Cm-qb' => 'Kanada',
    'Cm-qc' => 'Mexiko, Centralamerika och Västindien',
    'Cm-qd' => 'Sydamerika',
    'Cm-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cm-s' => 'Polarländerna',
    'Cma' => 'Skriftlösa religioner',
    'Cma-' => 'Särskilda länder och områden',
    'Cma-a' => 'Europa: allmänt',
    'Cma-d' => 'Övriga Norden',
    'Cma-o' => 'Asien',
    'Cma-oa' => 'Främre Asien',
    'Cma-ob' => 'Främre Indien',
    'Cma-oc' => 'Bortre Indien',
    'Cma-od' => 'Ostindiska öarna',
    'Cma-oe' => 'Östasien',
    'Cma-of' => 'Centralasien',
    'Cma-og' => 'Sibirien',
    'Cma-p' => 'Afrika',
    'Cma-pa' => 'Nordafrika utom Egypten',
    'Cma-pb' => 'Egypten och Sudan',
    'Cma-pc' => 'Västafrika',
    'Cma-pcb' => 'Ekvatorialafrika',
    'Cma-pcc' => 'Norra Västafrika',
    'Cma-pcd' => 'Södra Västafrika',
    'Cma-pd' => 'Centralafrika',
    'Cma-pe' => 'Södra Afrika',
    'Cma-pf' => 'Östafrika',
    'Cma-pg' => 'Nordöstafrika',
    'Cma-q' => 'Amerika',
    'Cma-qa' => 'Förenta staterna',
    'Cma-qat' => 'Indianer i Nordamerika',
    'Cma-qb' => 'Kanada',
    'Cma-qc' => 'Mexiko, Centralamerika och Västindien',
    'Cma-qct' => 'Indianer i Centralamerika',
    'Cma-qd' => 'Sydamerika',
    'Cma-qdt' => 'Indianer i Sydamerika',
    'Cma-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cma-ra' => 'Australien',
    'Cma-rb' => 'Nya Zeeland',
    'Cma-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Cma-rd' => 'Nya Guinea',
    'Cma-s' => 'Polarländerna',
    'Cmb' => 'Östasiatiska religioner',
    'Cmba' => 'Kinesisk religion',
    'Cmbaa' => 'Konfucianism',
    'Cmbab' => 'Taoism',
    'Cmbb' => 'Koreansk religion',
    'Cmbc' => 'Japansk religion',
    'Cmc' => 'Fornegyptisk religion',
    'Cmd' => 'Religioner av främreasiatiskt ursprung',
    'Cmda' => 'Babylonisk-assyrisk religion',
    'Cmdb' => 'Judendom',
    'Cmdb:k' => 'Judendomens historia',
    'Cmdb.0' => 'Särskilda aspekter',
    'Cmdb.01' => 'Källor och traditioner',
    'Cmdb.01(u)' => 'Urkunder',
    'Cmdb.02' => 'Troslära och trosbekännelse',
    'Cmdb.03' => 'Offentlig gudstjänst och andra riter',
    'Cmdb.03(u)' => 'Urkunder',
    'Cmdb.04' => 'Den enskildes religiösa liv',
    'Cmdb.05' => 'Etik',
    'Cmdb.06' => 'Organisation och ledare',
    'Cmdb.07' => 'Religiöst inspirerade aktiviteter',
    'Cmdb.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cmdb.09' => 'Sekter och reformrörelser',
    'Cmdb-' => 'Särskilda länder och områden',
    'Cmdb-c' => 'Sverige',
    'Cmdb-d' => 'Övriga Norden',
    'Cmdb-da' => 'Danmark',
    'Cmdb-db' => 'Norge',
    'Cmdb-dd' => 'Finland',
    'Cmdb-e' => 'Brittiska öarna (Storbritannien)',
    'Cmdb-f' => 'Mellaneuropa',
    'Cmdb-fa' => 'Tyskland',
    'Cmdb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Cmdb-h' => 'Schweiz',
    'Cmdb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Cmdb-j' => 'Frankrike och Monaco',
    'Cmdb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Cmdb-m' => 'Östeuropa',
    'Cmdb-o' => 'Asien',
    'Cmdb-oaf' => 'Israel och Palestina',
    'Cmdb-p' => 'Afrika',
    'Cmdb-q' => 'Amerika',
    'Cmdb-qa' => 'Förenta staterna',
    'Cmdb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cmdc' => 'Övriga västsemitiska religioner',
    'Cmdd' => 'Islam',
    'Cmdd:k' => 'Islams historia',
    'Cmdd.0' => 'Särskilda aspekter',
    'Cmdd.01' => 'Källor och traditioner',
    'Cmdd.01(u)' => 'Urkunder',
    'Cmdd.02' => 'Troslära och trosbekännelse',
    'Cmdd.03' => 'Offentlig gudstjänst och andra riter',
    'Cmdd.04' => 'Den enskildes religiösa liv',
    'Cmdd.05' => 'Etik',
    'Cmdd.06' => 'Organisation och ledare',
    'Cmdd.07' => 'Religiöst inspirerade aktiviteter',
    'Cmdd.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cmdd-' => 'Särskilda länder och områden',
    'Cmdd-a' => 'Europa: allmänt',
    'Cmdd-c' => 'Sverige',
    'Cmdd-d' => 'Övriga Norden',
    'Cmdd-dd' => 'Finland',
    'Cmdd-e' => 'Brittiska öarna (Storbritannien)',
    'Cmdd-f' => 'Mellaneuropa',
    'Cmdd-j' => 'Frankrike och Monaco',
    'Cmdd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Cmdd-m' => 'Östeuropa',
    'Cmdd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Cmdd-n' => 'Balkanländerna',
    'Cmdd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Cmdd-nd' => 'Grekland',
    'Cmdd-o' => 'Asien',
    'Cmdd-oa' => 'Främre Asien',
    'Cmdd-ob' => 'Främre Indien',
    'Cmdd-oc' => 'Bortre Indien',
    'Cmdd-od' => 'Ostindiska öarna',
    'Cmdd-oe' => 'Östasien',
    'Cmdd-of' => 'Centralasien',
    'Cmdd-p' => 'Afrika',
    'Cmdd-pa' => 'Nordafrika utom Egypten',
    'Cmdd-pb' => 'Egypten och Sudan',
    'Cmdd-pc' => 'Västafrika',
    'Cmdd-pd' => 'Centralafrika',
    'Cmdd-pe' => 'Södra Afrika',
    'Cmdd-pf' => 'Östafrika',
    'Cmdd-pg' => 'Nordöstafrika',
    'Cmdd-q' => 'Amerika',
    'Cmdd-qa' => 'Förenta staterna',
    'Cmdd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Cmddr' => 'Islamisk rätt',
    'Cmddt' => 'Muslimska trosriktningar',
    'Cmddta' => 'Sunniter',
    'Cmddtb' => 'Shiiter',
    'Cmddtö' => 'Övriga muslimska trosriktningar',
    'Cmde' => 'Mindre Asiens religioner',
    'Cme' => 'Indiska religioner',
    'Cmea' => 'Vedism',
    'Cmea.0' => 'Särskilda aspekter',
    'Cmea.01' => 'Källor och traditioner',
    'Cmea.01(u)' => 'Urkunder',
    'Cmea.03' => 'Offentlig gudstjänst och andra riter',
    'Cmeb' => 'Hinduism',
    'Cmeb.0' => 'Särskilda aspekter',
    'Cmeb.01' => 'Källor och traditioner',
    'Cmeb.01(u)' => 'Urkunder',
    'Cmeb.02' => 'Troslära och trosbekännelse',
    'Cmeb.03' => 'Offentlig gudstjänst och andra riter',
    'Cmeb.04' => 'Den enskildes religiösa liv',
    'Cmeb.05' => 'Etik',
    'Cmeb.06' => 'Organisation och ledare',
    'Cmeb.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cmeb.09' => 'Sekter och reformrörelser',
    'Cmeb-oba' => 'Indien',
    'Cmec' => 'Buddhism',
    'Cmec.0' => 'Särskilda aspekter',
    'Cmec.01' => 'Källor och traditioner',
    'Cmec.01(u)' => 'Urkunder',
    'Cmec.02' => 'Troslära och trosbekännelse',
    'Cmec.03' => 'Offentlig gudstjänst och andra riter',
    'Cmec.04' => 'Den enskildes religiösa liv',
    'Cmec.05' => 'Etik',
    'Cmec.06' => 'Organisation och ledare',
    'Cmec.08' => 'Relationer och attityder till omvärld och andra religioner',
    'Cmec-' => 'Särskilda länder och områden',
    'Cmec-o' => 'Asien',
    'Cmec-ob' => 'Främre Indien',
    'Cmec-oc' => 'Bortre Indien',
    'Cmec-oe' => 'Östasien',
    'Cmec-oea' => 'Kina',
    'Cmec-oeb' => 'Korea',
    'Cmec-oec' => 'Japan',
    'Cmec-of' => 'Centralasien',
    'Cmec-q' => 'Amerika',
    'Cmect' => 'Buddhistiska riktningar, sekter, reformrörelser',
    'Cmecta' => 'Hinayana',
    'Cmectb' => 'Mahayana med Vajreyana',
    'Cmectbb' => 'Lamaism',
    'Cmectbc' => 'Zen-buddhism',
    'Cmed' => 'Jainism',
    'Cmee' => 'Sikher',
    'Cmf' => 'Iransk religion',
    'Cmfa' => 'Manikeism',
    'Cmfb' => 'Mandeism',
    'Cmg' => 'Grekisk och romersk religion',
    'Cmga' => 'Grekisk religion',
    'Cmgb' => 'Etruskisk religion',
    'Cmgc' => 'Romersk religion',
    'Cmgg' => 'Gnosticism',
    'Cmh' => 'Keltisk religion',
    'Cmi' => 'Germansk religion',
    'Cmia' => 'Fornnordisk religion',
    'Cmj' => 'Slavisk religion',
    'Cmk' => 'Baltisk religion',
    'Cmm' => 'Finsk-ugrisk religion',
    'Cmma' => 'Finsk religion',
    'Cmmb' => 'Samisk religion',
    'Cmq' => 'Religioner hos maya, azteker, inka',
    'Cn' => 'Moderna religionsbildningar',
    'Cna' => 'Teosofi',
    'Cnaa' => 'Antroposofi',
    'Cnb' => 'Spiritualism',
    'Cnc' => 'Scientologi',
    'Cnd' => 'Martinus',
    'Cne' => 'Amanda Marga',
    'Cnf' => 'Hare Krishna',
    'Cng' => 'Tongilrörelsen',
    'Cnh' => 'Bahai',
    'Cni' => 'Guds barn',
    'Cnj' => 'Satanism',
    'Cnö' => 'Övriga moderna religionsbildningar',
    'D' => 'Filosofi och psykologi',
    'D(x)' => 'Filosofiska lexikon',
    'D:d' => 'Filosofisk teori och metodlära',
    'Da' => 'Äldre västerländsk samt icke-västerländsk filosofisk litteratur',
    'Daa' => 'Antika filosofers skrifter',
    'Dab' => 'Medeltidsfilosofers och renässansfilosofers skrifter',
    'Dad' => 'Icke-västerländska filosofers skrifter',
    'Dada' => 'Kinesiska filosofers skrifter',
    'Dadc' => 'Judiska filosofers skrifter',
    'Dadd' => 'Indiska filosofers skrifter',
    'Dadda' => 'Samkhya',
    'Dadde' => 'Yoga',
    'Daddh' => 'Vedanta',
    'Dade' => 'Arabiska filosofers skrifter',
    'Db' => 'Filosofins historia',
    'Dba' => 'Antikens filosofi',
    'Dba.24' => 'Grekisk filosofi: allmänt',
    'Dba.26' => 'Romersk filosofi: allmänt',
    'Dbaa' => 'Försokratiker',
    'Dbab' => 'Den klassiska tidens filosofi',
    'Dbac' => 'Hellenistisk filosofi',
    'Dbb' => 'Medeltidens och renässansens filosofi',
    'Dbbc' => 'Skolastiken',
    'Dbbd' => 'Renässansens filosofi',
    'Dbc' => 'Nya tidens filosofi (fr o m Descartes)',
    'Dbc.' => 'Särskilda perioder',
    'Dbc.4' => 'Nya tiden',
    'Dbc.43' => '1600- och 1700-talen',
    'Dbc.46' => '1800-talet',
    'Dbc.5' => '1900-talet',
    'Dbc.55' => '1945-',
    'Dbc.58' => '1980-',
    'Dbc.59' => '1990-',
    'Dbc.6' => '2000-',
    'Dbc-' => 'Särskilda länder och områden',
    'Dbc-a' => 'Europa: allmänt',
    'Dbc-b' => 'Norden: allmänt',
    'Dbc-c' => 'Sverige',
    'Dbc-d' => 'Övriga Norden',
    'Dbc-e' => 'Brittiska öarna (Storbritannien)',
    'Dbc-f' => 'Mellaneuropa',
    'Dbc-fa' => 'Tyskland',
    'Dbc-fb' => 'Österrike och Liechtenstein',
    'Dbc-fc' => 'Ungern',
    'Dbc-fd' => 'Tjeckien och Slovakien',
    'Dbc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Dbc-h' => 'Schweiz',
    'Dbc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Dbc-j' => 'Frankrike och Monaco',
    'Dbc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Dbc-m' => 'Östeuropa',
    'Dbc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Dbc-mb' => 'Polen',
    'Dbc-n' => 'Balkanländerna',
    'Dbc-o' => 'Asien',
    'Dbc-p' => 'Afrika',
    'Dbc-q' => 'Amerika',
    'Dbc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Dbca' => 'Rationalism och besläktade system och doktriner',
    'Dbcb' => 'Idealism och besläktade system och doktriner',
    'Dbcba' => 'Hegelianism och nyhegelianism',
    'Dbcc' => 'Kritisk filosofi',
    'Dbcca' => 'Kantianism och nykantianism',
    'Dbccb' => 'Fenomenologisk filosofi och existentialism',
    'Dbcd' => 'Humanism och besläktade system och doktriner',
    'Dbce' => 'Naturalism och besläktade system och doktriner',
    'Dbceaa' => 'Marxism och dialektisk materialism',
    'Dbceab' => 'Positivism, nypositivism och besläktade system',
    'Dbcf' => 'Analytisk filosofi',
    'Dbcg' => 'Realism, nyrealism, kritisk realism',
    'Dbcj' => 'Nythomism',
    'Dbcl' => 'Ekosofi och holistisk filosofi',
    'Dbcö' => 'Övriga filosofiska system och doktriner',
    'Dbd' => 'Icke-västerländsk filosofi',
    'Dbda' => 'Kinesisk filosofi',
    'Dbdb' => 'Japansk filosofi',
    'Dbdc' => 'Judisk filosofi',
    'Dbdd' => 'Indisk filosofi',
    'Dbdda' => 'Samkhya',
    'Dbdde' => 'Yoga',
    'Dbddh' => 'Vedanta',
    'Dbde' => 'Arabisk filosofi',
    'Dbz' => 'Särskilda filosofer',
    'Dc' => 'Logik och språkligt orienterad filosofi',
    'Dca' => 'Logik',
    'Dcb' => 'Argumentationsanalys',
    'Dcc' => 'Språkligt orienterad filosofi',
    'Dd' => 'Kunskapsteori och vetenskapsteori',
    'Ddb' => 'Kunskapsteori',
    'Ddc' => 'Vetenskapsteori',
    'Ddca' => 'Tolkningsteori (hermeneutik)',
    'Ddcs' => 'Strukturalism',
    'De' => 'Värdefilosofi: allmänt',
    'Df' => 'Estetik',
    'Dg' => 'Etik',
    'Dgbf' => 'Allmän vetenskaplig och kulturell verksamhet',
    'Dgbr' => 'Kommunikation, cybernetik, informationsteori',
    'Dgbs' => 'masskommunikation: allmänt',
    'Dgbt' => 'publicistik (inkl tidningsväen och -hitoria)',
    'Dgbu' => 'Radio och television',
    'Dgbv' => 'Informationsteknik (IT)',
    'Dgc' => 'Religion',
    'Dgdo' => 'Psykologi',
    'Dge' => 'Uppfostran och undervisning',
    'Dgf' => 'Språkvetenskap',
    'Dgg' => 'Litteraturvetenskap',
    'Dgi' => 'Konst, musik, teater, film, fotokonst',
    'Dgj' => 'Arkeologi',
    'Dgk' => 'Historia',
    'Dgl' => 'Biografi med genealogi',
    'Dgm' => 'Etnografi, socialantropologi och etnologi',
    'Dgo' => 'Samhälls- och rättsvetenskap',
    'Dgoa' => 'Sociologi',
    'Dgob' => 'Internationella relationer',
    'Dgoc' => 'Statskunskap och politik',
    'Dgod' => 'Förvaltning',
    'Dgoe' => 'Rättsvetenskap',
    'Dgoh' => 'Sociala frågor och socialpolitik',
    'Dgp' => 'Teknik, industri och kommunikationer',
    'Dgq' => 'Ekonomi och näringsväsen',
    'Dgqa' => 'Nationalekonomi och finansväsen',
    'Dgqb' => 'Företagsekonomi',
    'Dgqd' => 'Lantbruk',
    'Dgqi' => 'Handel',
    'Dgr' => 'Idrott, lek och spel',
    'Dgs' => 'Militärväsen',
    'Dgu' => 'Naturvetenskap',
    'Dgue' => 'Biologi',
    'Dgug' => 'Zoologi',
    'Dguh' => 'Miljöfrågor och naturskydd',
    'Dgv' => 'Medicin',
    'Dgva' => 'Medicinsk genetik, mikrobiologi, immunologi m fl icke kliniska disciplinner',
    'Dgvb' => 'Anatomi',
    'Dgvf' => 'Kirurgi och anestesi',
    'Dgvg' => 'Gynekologi och andrologi',
    'Dgvl' => 'Psykiatri',
    'Dgvm' => 'Terapimetoder',
    'Dgvn' => 'Samhällsmedicin, hygien, sexologi',
    'Dgvp' => 'Hälso- och sjukvård',
    'Dgvx' => 'Militärmedicin',
    'Dh' => 'Filosofisk antropologi',
    'Dhb' => 'Liv och död',
    'Dj' => 'Verklighetsuppfattningar (metafysik, ontologi, kosmologi m m)',
    'Dja' => 'Determinism',
    'Djb' => 'Förändringsteorier',
    'Djc' => 'Rummets och tidens filosofi',
    'Do' => 'Psykologi',
    'Doa' => 'Psykologisk metodik',
    'Doaa' => 'Experimentell psykologi (människor)',
    'Doab' => 'Experimentell psykologi (djur)',
    'Doat' => 'Psykologiska mätmetoder',
    'Dob' => 'Psykologins historia',
    'Dob.' => 'Särskilda perioder',
    'Dob.4' => 'Nya tiden',
    'Dob.5' => '1900-talet',
    'Dob.6' => '2000-',
    'Dobz' => 'Särskilda psykologer',
    'Doc' => 'Särskilda riktningar och skolor',
    'Doca' => 'Karakterologi',
    'Docb' => 'Psykoanalys',
    'Docba' => 'Freud och den ursprungliga psykoanalysen',
    'Docbb' => 'Adler och individualpsykologin',
    'Docbc' => 'Jung och den analytiska (komplexa) psykologin',
    'Docbd' => 'Nyare psykoanalytiska riktningar',
    'Docc' => 'Gestaltpsykologi',
    'Docd' => 'Behaviorism',
    'Docö' => 'Övriga särskilda riktningar',
    'Dod' => 'Fysiologisk psykologi',
    'Dodb' => 'Sinnesförnimmelser, perception',
    'Dodbc' => 'Syn',
    'Dodbd' => 'Hörsel',
    'Dodbe' => 'Lukt och smak',
    'Dodbf' => 'Känsel (taktil)',
    'Dodbö' => 'Övriga (hunger, törst, trötthet m m)',
    'Dode' => 'Rörelser, motorik',
    'Dodf' => 'Känslor, känsloreaktioner',
    'Doe' => 'Kognitiv psykologi',
    'Doea' => 'Inlärning och minne',
    'Doeaa' => 'Inlärning',
    'Doeab' => 'Minne',
    'Doeb' => 'Tänkande och fantasiliv',
    'Doeba' => 'Tankeprocessen',
    'Doebb' => 'Fantasi',
    'Doec' => 'Intelligens och begåvning',
    'Doee' => 'Viljeprocessen',
    'Doef' => 'Kommunikationspsykologi',
    'Doeg' => 'Drömmar',
    'Dof' => 'Utvecklingspsykologi',
    'Dofa' => 'Barn- och ungdomspsykologi',
    'Dofaa' => 'Småbarnspsykologi',
    'Dofab' => 'Barnpsykologi',
    'Dofac' => 'Ungdomspsykologi',
    'Doff' => 'Vuxenpsykologi',
    'Dofg' => 'Ålderdomens psykologi',
    'Dog' => 'Differentiell psykologi',
    'Doga' => 'Personlighetspsykologi',
    'Dogb' => 'Könspsykologi',
    'Dok' => 'Tillämpad psykologi',
    'Doka' => 'Arbetspsykologi',
    'Dokaa' => 'Ledarskapets psykologi',
    'Dokab' => 'Anlagsprövning',
    'Dokb' => 'Personlig utveckling och träning',
    'Dokba' => 'Meditation',
    'Dokc' => 'Människan inför döden',
    'Don' => 'Grafologi',
    'Dop' => 'Parapsykologi',
    'Dopa' => 'Extrasensorisk perception',
    'Dopb' => 'Spiritism',
    'E' => 'Uppfostran och undervisning',
    'E:b' => 'Uppfostran och undervisning: forskning',
    'E:bf' => 'Organisationer och institutioner',
    'E:d' => 'Uppfostran och undervisning: teori och filosofi',
    'E:k' => 'Uppfostran och undervisning: historia',
    'E:kc' => 'Sverige',
    'E:oa' => 'Uppfostran och undervisning: sociologi',
    'Ea' => 'Pedagogik',
    'Ea:b' => 'Pedagogisk forskning',
    'Ea:bf' => 'Pedagogiska institutioner',
    'Ea:d' => 'Pedagogikens teori och filosofi',
    'Ea:k' => 'Pedagogikens historia',
    'Ea:oa' => 'Pedagogik: sociologi',
    'Eaa' => 'Pedagogisk psykologi',
    'Eaaa' => 'Differentieringsproblem',
    'Eaac' => 'Inlärning',
    'Eaaca' => 'Psykomotoriska och sensoriska processer',
    'Eaacb' => 'Motivation',
    'Eaad' => 'Skolans socialpsykologi',
    'Eaae' => 'Skolans mentalhygien',
    'Eaaf' => 'Disciplinfrågor',
    'Eab' => 'Pedagogisk metodik',
    'Eab.0' => 'Allmänt: särskilda undervisningsformer',
    'Eab.01' => 'Undervisning före den egentliga skolan',
    'Eab.02' => 'Grundskolan och motsvarande',
    'Eab.021' => 'Lågstadiet',
    'Eab.022' => 'Mellanstadiet',
    'Eab.023' => 'Högstadiet',
    'Eab.03' => 'Gymnasieskolan och motsvarande',
    'Eab.04' => 'Lärarutbildning',
    'Eab.05' => 'Folkhögskolor',
    'Eab.06' => 'Yrkesutbildning och fackskolor',
    'Eab.07' => 'Särskilda undervisningsformer för särskilda grupper',
    'Eab.071' => 'Korrespondens- och distansundervisning',
    'Eab.075' => 'Undervisning av specialbegåvade barn',
    'Eab.076' => 'Invandrar- och minoritetsundervisning',
    'Eab.0761' => 'Invandrar- och hemspråksundervisning',
    'Eab.07611' => 'Hemspråksundervisning',
    'Eab.0762' => 'Minoritetsundervisning',
    'Eab.08' => 'Vuxenundervisning',
    'Eab.09' => 'Övriga skolformer',
    'Eab-' => 'Särskilda länder och områden',
    'Eab-a' => 'Europa: allmänt',
    'Eab-b' => 'Norden: allmänt',
    'Eab-c' => 'Sverige',
    'Eab-d' => 'Övriga Norden',
    'Eab-e' => 'Brittiska öarna (Storbritannien)',
    'Eab-f' => 'Mellaneuropa',
    'Eab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Eab-j' => 'Frankrike och Monaco',
    'Eab-m' => 'Östeuropa',
    'Eab-o' => 'Asien',
    'Eab-p' => 'Afrika',
    'Eab-q' => 'Amerika',
    'Eab-qa' => 'Förenta staterna',
    'Eab-qb' => 'Kanada',
    'Eaba' => 'Undervisning i bok- och bibliotekskunskap',
    'Eabaf' => 'Skrivning (välskrivning)',
    'Eabb' => 'Undervisning i mediekunskap och kulturämnen m m',
    'Eabc' => 'Religionsundervisning i skolan',
    'Eabd' => 'Filosofi- och psykologiundervisning',
    'Eabdo' => 'Psykologiundervisning',
    'Eabe' => 'Pedagogikundervisning',
    'Eabf' => 'Språkundervisning',
    'Eabfc' => 'Svenska',
    'Eabfct' => 'Svenska för utlänningar',
    'Eabfd' => 'Övriga nordiska språk',
    'Eabfda' => 'Danska',
    'Eabfdb' => 'Norska',
    'Eabfe' => 'Engelska',
    'Eabff' => 'Tyska och jiddisch',
    'Eabfg' => 'Nederländska',
    'Eabfi' => 'Italienska',
    'Eabfj' => 'Franska',
    'Eabfk' => 'Spanska',
    'Eabfl' => 'Portugisiska',
    'Eabfm' => 'Slaviska och baltiska språk',
    'Eabfma' => 'Ryska',
    'Eabfo' => 'Grekiska och latin',
    'Eabfp' => 'Indo-ariska språk',
    'Eabfq' => 'Iranska språk',
    'Eabfs' => 'Semitiska språk',
    'Eabft' => 'Hamitiska språk och tchadspråk',
    'Eabfu' => 'Finsk-ugriska och altaiska språk',
    'Eabfub' => 'Finska',
    'Eabfue' => 'Samiska språk',
    'Eabfx' => 'Övriga språk',
    'Eabfå' => 'Teckenspråk',
    'Eabg' => 'Undervisning i litteraturhistoria',
    'Eabi' => 'Undervisning i konst, musik, teater, film, fotokonst',
    'Eabia' => 'Konstundervisning',
    'Eabic' => 'Undervisning i arkitektur',
    'Eabig' => 'Tecknings- och bildundervisning',
    'Eabih' => 'Slöjdundervisning',
    'Eabij' => 'Musikundervisning',
    'Eabik' => 'Teaterundervisning',
    'Eabim' => 'Filmundervisning',
    'Eabj' => 'Undervisning i arkeologi',
    'Eabk' => 'Historieundervisning',
    'Eabl' => 'Undervisning i biografi med genealogi',
    'Eabm' => 'Undervisning i socialantropologi och etnografi',
    'Eabn' => 'Geografiundervisning',
    'Eabo' => 'Undervisning i samhällsvetenskapliga ämnen',
    'Eaboa' => 'Sociologi',
    'Eabob' => 'Internationella relationer',
    'Eaboc' => 'Statskunskap och politik',
    'Eabod' => 'Förvaltning',
    'Eaboe' => 'Rättsvetenskap och juridik',
    'Eaboh' => 'Sociala frågor och socialpolitik',
    'Eaboi' => 'Statistik',
    'Eabop' => 'Framtidsstudier',
    'Eabp' => 'Undervisning i tekniska ämnen',
    'Eabpu' => 'Dataundervisning',
    'Eabq' => 'Undervisning i ekonomiska ämnen',
    'Eabqa' => 'Nationalekonomi',
    'Eabqb' => 'Företagsekonomi',
    'Eabqc' => 'Hem och hushåll (hemkunskap)',
    'Eabqd' => 'Lantbruk',
    'Eabqe' => 'Trädgårdsskötsel',
    'Eabqf' => 'Skogsbruk',
    'Eabr' => 'Idrottsundervisning',
    'Eabs' => 'Undervisning i militära ämnen',
    'Eabt' => 'Matematikundervisning',
    'Eabu' => 'Undervisning i naturvetenskapliga ämnen',
    'Eabua' => 'Astronomi',
    'Eabub' => 'Geofysik',
    'Eabuc' => 'Fysik och kemi',
    'Eabud' => 'Geologi och paleontologi',
    'Eabue' => 'Biologi',
    'Eabuf' => 'Botanik',
    'Eabug' => 'Zoologi',
    'Eabuh' => 'Miljöfrågor och naturskydd',
    'Eabv' => 'Undervisning i medicin',
    'Eabx' => 'Undervisningsmateriel',
    'Eaby' => 'Särskilda metoder i undervisningen',
    'Eac' => 'Särskilda pedagogiska riktningar',
    'Eaca' => 'Montessoripedagogik',
    'Eacb' => 'Waldorfpedagogik',
    'Eacö' => 'Övriga pedagogiska riktningar',
    'Ead' => 'Studieteknik',
    'Eaz' => 'Särskilda pedagoger',
    'Eh' => 'Uppfostran i hemmiljö',
    'Em' => 'Undervisningsväsen (ej högskolor)',
    'Em:d' => 'Undervisningsväsen: teori och filosofi',
    'Em:k' => 'Undervisningsväsendets historia',
    'Em:oa' => 'Undervisningsväsen: sociologi',
    'Em.0' => 'Särskilda undervisningsformer',
    'Em.01' => 'Förskolan',
    'Em.02' => 'Grundskolan',
    'Em.021' => 'Lågstadiet',
    'Em.022' => 'Mellanstadiet',
    'Em.023' => 'Högstadiet',
    'Em.03' => 'Gymnasieskolan',
    'Em.04' => 'Lärarutbildning',
    'Em.05' => 'Folkhögskolor',
    'Em.06' => 'Yrkesutbildning och fackskolor',
    'Em.07' => 'Särskilda undervisningsformer för särskilda grupper',
    'Em.071' => 'Korrespondens- och distansundervisning',
    'Em.076' => 'Invandrar- och minoritetsundervisning',
    'Em.0761' => 'Invandrar- och hemspråksundervisning',
    'Em.0762' => 'Minoritetsundervisning',
    'Em.08' => 'Vuxenundervisning',
    'Em.082' => 'Vidareutbildning',
    'Em.09' => 'Övriga skolformer',
    'Em-' => 'särskilda länder och områden',
    'Em-a' => 'Europa: allmänt',
    'Em-ae' => 'Europeiska unionen (EU)',
    'Em-b' => 'Norden: allmänt',
    'Em-c' => 'Sverige',
    'Em-c:bf' => 'Sörskilda institutioner',
    'Em-c:k' => 'Undervisningsväsendets historia',
    'Em-c:oe' => 'Lagstiftning (inkl lagar och förordningar)',
    'Em-c.0' => 'Särskilda undervisningsformer',
    'Em-c.01' => 'Förskolan',
    'Em-c.02' => 'Grundskolan',
    'Em-c.021' => 'Lågstadiet',
    'Em-c.022' => 'Mellanstadiet',
    'Em-c.023' => 'Högstadiet',
    'Em-c.03' => 'Gymnasieskolan',
    'Em-c.04' => 'Lärarutbildning',
    'Em-c.05' => 'Folkhögskolor',
    'Em-c.06' => 'Yrkesutbildning och fackskolor',
    'Em-c.07' => 'Särskilda undervisningsformer för särskilda grupper',
    'Em-c.071' => 'Korrespondens- och distansundervisning',
    'Em-c.076' => 'Invandrar- och minoritetsundervisning',
    'Em-c.0761' => 'Invandrar- och hemspråksundervisning',
    'Em-c.07611' => 'Hemspråksundervisning',
    'Em-c.0762' => 'Minoritetsundervisning',
    'Em-c.08' => 'Vuxenundervisning',
    'Em-c.082' => 'Vidareutbildning',
    'Em-c.09' => 'Övriga skolformer',
    'Em-c.091' => 'Skolor drivna av religiösa samfund',
    'Em-c.092' => 'Goss- och flickskolor',
    'Em-c.093' => 'Privatskolor',
    'Em-c.094' => 'Internatskolor',
    'Em-cs' => 'Samer',
    'Em-cz' => 'Särskilda orter och undervisningsanstalter',
    'Em-d' => 'Övriga Norden',
    'Em-da' => 'Danmark',
    'Em-db' => 'Norge',
    'Em-dc' => 'Island och Färöarna',
    'Em-dd' => 'Finland',
    'Em-e' => 'Brittiska öarna (Storbritannien)',
    'Em-f' => 'Mellaneuropa',
    'Em-fa' => 'Tyskland',
    'Em-fb' => 'Österrike och Liechtenstein',
    'Em-fc' => 'Ungern',
    'Em-fd' => 'Tjeckien och Slovakien',
    'Em-g' => 'Nederländerna, Belgien och Luxemburg',
    'Em-h' => 'Schweiz',
    'Em-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Em-j' => 'Frankrike och Monaco',
    'Em-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Em-l' => 'Portugal',
    'Em-m' => 'Östeuropa',
    'Em-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Em-mb' => 'Polen',
    'Em-mc' => 'Estland, Lettland, Litauen',
    'Em-n' => 'Balkanländerna',
    'Em-o' => 'Asien',
    'Em-oa' => 'Främre Asien',
    'Em-oafh' => 'Judar',
    'Em-ob' => 'Främre Indien',
    'Em-oc' => 'Bortre Indien',
    'Em-od' => 'Ostindiska öarna',
    'Em-oe' => 'Östasien',
    'Em-oea' => 'Kina',
    'Em-oeb' => 'Korea',
    'Em-oec' => 'Japan',
    'Em-oek' => 'Hongkong och Macau',
    'Em-of' => 'Centralasien',
    'Em-og' => 'Sibirien',
    'Em-p' => 'Afrika',
    'Em-pa' => 'Nordafrika utom Egypten',
    'Em-pb' => 'Egypten och Sudan',
    'Em-pc' => 'Västafrika',
    'Em-pd' => 'Centralafrika',
    'Em-pe' => 'Södra Afrika',
    'Em-pf' => 'Östafrika',
    'Em-pg' => 'Nordöstafrika',
    'Em-q' => 'Amerika',
    'Em-qa' => 'Förenta staterna',
    'Em-qb' => 'Kanada',
    'Em-qc' => 'Mexiko, Centralamerika och Västindien',
    'Em-qd' => 'Sydamerika',
    'Em-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Emi' => 'Skolpersonal och elever',
    'Emia' => 'Skolpersonal',
    'Emib' => 'Elever/studerande',
    'Emiba' => 'Studerandeekonomi',
    'Emk' => 'Organisation och administration',
    'Emkd' => 'Förhållande till staten',
    'Emke' => 'Förhållande till religionen',
    'Eml' => 'Skollokaler och -inventarier',
    'Emm' => 'Skolsociala åtgärder',
    'Ep' => 'Högskolor',
    'Ep:d' => 'Högskoleundervisning: teori och filosofi',
    'Ep:k' => 'Högskoleundervisningens historia',
    'Ep:oa' => 'Högskoleundervisning: sociologi',
    'Ep.0' => 'Särskilda undervisningsformer',
    'Ep.04' => 'Lärarutbildning',
    'Ep.06' => 'Yrkesutbildning och fackskolor',
    'Ep.07' => 'Särskilda undervisningsformer för särskilda grupper',
    'Ep.071' => 'Korrespondens- och distansundervisning',
    'Ep.08' => 'Vuxenundervisning',
    'Ep-' => 'särskilda länder och områden',
    'Ep-a' => 'Europa: allmänt',
    'Ep-ae' => 'Europeiska unionen (EU)',
    'Ep-b' => 'Norden: allmänt',
    'Ep-c' => 'Sverige',
    'Ep-c:bf' => 'Institutioner',
    'Ep-c:k' => 'Undervisningsväsendets historia',
    'Ep-c:oe' => 'Lagstiftning (inkl lagar och förordningar)',
    'Ep-c.0' => 'Särskilda undervisningsformer',
    'Ep-c.04' => 'Lärarutbildning',
    'Ep-c.06' => 'Yrkesutbildning och fackskolor',
    'Ep-c.07' => 'Särskilda undervisningsformer för särskilda grupper',
    'Ep-c.071' => 'Korrespondens- och distansundervisning',
    'Ep-c.076' => 'Invandrar- och minoritetsundervisning',
    'Ep-c.08' => 'Vuxenundervisning',
    'Ep-cs' => 'Samer',
    'Ep-cz' => 'Särskilda orter, universitet och högskolor',
    'Ep-d' => 'Övriga Norden',
    'Ep-da' => 'Danmark',
    'Ep-db' => 'Norge',
    'Ep-dc' => 'Island och Färöarna',
    'Ep-dd' => 'Finland',
    'Ep-e' => 'Brittiska öarna (Storbritannien)',
    'Ep-f' => 'Mellaneuropa',
    'Ep-fa' => 'Tyskland',
    'Ep-fb' => 'Österrike och Liechtenstein',
    'Ep-fc' => 'Ungern',
    'Ep-fd' => 'Tjeckien och Slovakien',
    'Ep-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ep-h' => 'Schweiz',
    'Ep-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ep-j' => 'Frankrike och Monaco',
    'Ep-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ep-l' => 'Portugal',
    'Ep-m' => 'Östeuropa',
    'Ep-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ep-mb' => 'Polen',
    'Ep-mc' => 'Estland, Lettland, Litauen',
    'Ep-n' => 'Balkanländerna',
    'Ep-o' => 'Asien',
    'Ep-oa' => 'Främre Asien',
    'Ep-oafh' => 'Judar',
    'Ep-ob' => 'Främre Indien',
    'Ep-oc' => 'Bortre Indien',
    'Ep-od' => 'Ostindiska öarna',
    'Ep-oe' => 'Östasien',
    'Ep-oea' => 'Kina',
    'Ep-oeb' => 'Korea',
    'Ep-oec' => 'Japan',
    'Ep-of' => 'Centralasien',
    'Ep-p' => 'Afrika',
    'Ep-q' => 'Amerika',
    'Ep-qa' => 'Förenta staterna',
    'Ep-qb' => 'Kanada',
    'Ep-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ep-qd' => 'Sydamerika',
    'Ep-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ep-ra' => 'Australien',
    'Ep-rb' => 'Nya Zeeland',
    'Ep-s' => 'Polarländerna',
    'Epa' => 'Högskoleundervisningens pedagogik',
    'Epaa' => 'Pedagogisk psykologi',
    'Epaaa' => 'Differentieringsproblem',
    'Epaac' => 'Inlärning',
    'Epaad' => 'Högskolans socialpsykologi',
    'Epaae' => 'Högskolans mentalhygien',
    'Epaaf' => 'Disciplinfrågor',
    'Epab' => 'Pedagogisk metodik',
    'Epaba' => 'Undervisning i bok-, biblioteks- och informationsvetenskap',
    'Epabb' => 'Undervisning i mediekunskap och kulturämnen m m',
    'Epabc' => 'Religionsundervisning',
    'Epabd' => 'Filosofi- och psykologiundervisning',
    'Epabdo' => 'Psykologiundervisning',
    'Epabe' => 'Pedagogikundervisning',
    'Epabf' => 'Språkundervisning',
    'Epabfc' => 'Svenska',
    'Epabfct' => 'Svenska för utlänningar',
    'Epabfd' => 'Övriga nordiska språk',
    'Epabfe' => 'Engelska',
    'Epabff' => 'Tyska och jiddisch',
    'Epabfi' => 'Italienska',
    'Epabfj' => 'Franska',
    'Epabfk' => 'Spanska',
    'Epabfm' => 'Slaviska och baltiska språk',
    'Epabfo' => 'Grekiska och latin',
    'Epabfu' => 'Finsk-ugriska och altaiska språk',
    'Epabfx' => 'Övriga språk',
    'Epabg' => 'Undervisning i litteraturvetenskap',
    'Epabi' => 'Undervisning i konst, musik, teater, film, fotokonst',
    'Epabib' => 'Konstvetenskap',
    'Epabic' => 'Arkitektur',
    'Epabih' => 'Konsthantverk, design och slöjd',
    'Epabij' => 'Musikvetenskap',
    'Epabik' => 'Teatervetenskap',
    'Epabim' => 'Filmvetenskap',
    'Epabj' => 'Undervisning i arkeologi',
    'Epabk' => 'Historieundervisning',
    'Epabm' => 'Undervisning i socialantropologi och etnografi',
    'Epabn' => 'Geografiundervisning',
    'Epabo' => 'Undervisning i samhällsvetenskapliga ämnen',
    'Epaboa' => 'Sociologi',
    'Epabob' => 'Internationella relationer',
    'Epaboc' => 'Statskunskap och politik',
    'Epabod' => 'Förvaltning',
    'Epaboe' => 'Rättsvetenskap och juridik',
    'Epaboh' => 'Sociala frågor och socialpolitik',
    'Epaboi' => 'Statistik',
    'Epaboj' => 'Demografi',
    'Epabok' => 'Försäkring',
    'Epabp' => 'Undervisning i tekniska ämnen',
    'Epabpb' => 'Maskinteknik',
    'Epabpc' => 'Elektroteknik',
    'Epabpu' => 'Datorer och databehandling',
    'Epabq' => 'Undervisning i ekonomiska ämnen',
    'Epabqa' => 'Nationalekonomi',
    'Epabqb' => 'Företagsekonomi',
    'Epabqc' => 'Hem och hushåll',
    'Epabqd' => 'Lantbruk',
    'Epabr' => 'Idrottsundervisning',
    'Epabt' => 'Matematikundervisning',
    'Epabu' => 'Undervisning i naturvetenskapliga ämnen',
    'Epabuc' => 'Fysik och kemi',
    'Epabue' => 'Biologi',
    'Epabuh' => 'Miljöfrågor och naturskydd',
    'Epabv' => 'Undervisning i medicin',
    'Epabx' => 'Undervisningsmateriel',
    'Epaby' => 'Särskilda metoder i undervisningen',
    'Epad' => 'Studieteknik',
    'Epb' => 'Forskarutbildning',
    'Epb-c' => 'Sverige',
    'Epi' => 'Högskolepersonal och studerande',
    'Epia' => 'Högskolepersonal',
    'Epib' => 'Studerande',
    'Epib-cz' => 'Sverige: särskilda studentkårer och motsvarande',
    'Epiba' => 'Studerandeekonomi',
    'Epk' => 'Organisation och administration',
    'Epkd' => 'Förhållande till staten',
    'Epl' => 'Lokaler och inventarier',
    'Epm' => 'Sociala åtgärder',
    'Et' => 'Ungdomsvårdsskolor',
    'Et-c' => 'Sverige',
    'Eu' => 'Elever med särskilda behov',
    'Eu-' => 'Särskilda länder och områden',
    'Eu-b' => 'Norden: allmänt',
    'Eu-c' => 'Sverige',
    'Eu-cz' => 'Särskilda skolor',
    'Eu-d' => 'Övriga Norden',
    'Eu-da' => 'Danmark',
    'Eu-db' => 'Norge',
    'Eu-dd' => 'Finland',
    'Eu-e' => 'Brittiska öarna (Storbritannien)',
    'Eu-f' => 'Mellaneuropa',
    'Eu-m' => 'Östeuropa',
    'Eu-o' => 'Asien',
    'Eu-p' => 'Afrika',
    'Eu-q' => 'Amerika',
    'Eu-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Eua' => 'Synskadade',
    'Euat' => 'Blindskrift',
    'Eub' => 'Hörselskadade',
    'Euc' => 'Psykiskt handikappade',
    'Eud' => 'Talsvårigheter',
    'Eue' => 'Läs- och skrivsvårigheter',
    'Euf' => 'Rörelsehindrade',
    'Eug' => 'Flerhandikappade',
    'Ev' => 'Folkbildning',
    'Ev-' => 'Särskilda länder och områden',
    'Ev-a' => 'Europa: allmänt',
    'Ev-c' => 'Sverige',
    'Ev-c:bf' => 'Folkbildningsorganisationer',
    'Ev-c:k' => 'Folkbildningens historia',
    'Ev-cs' => 'Samer',
    'Ev-cz' => 'Särskilda orter och lokalavdelningar',
    'Ev-d' => 'Övriga Norden',
    'Ev-e' => 'Brittiska öarna (Storbritannien)',
    'Ev-f' => 'Mellaneuropa',
    'Ev-m' => 'Östeuropa',
    'Ev-o' => 'Asien',
    'Ev-p' => 'Afrika',
    'Ev-q' => 'Amerika',
    'Eve' => 'Studiecirkelverksamhet',
    'Eve-c' => 'Sverige',
    'Evf' => 'Föreläsningsverksamhet',
    'Evf-c' => 'Sverige',
    'Evk' => 'Läsning och självstudier',
    'Evk-c' => 'Sverige',
    'Ex' => 'Yrkesval',
    'F' => 'Språkvetenskap',
    'F(x)' => 'Flerspråkiga lexikon och språkvetenskapliga uppslagsverk',
    'F:b' => 'Språkvetenskaplig forskning, organisationer och institutioner',
    'F:bf' => 'Organisationer och institutioner',
    'F:d' => 'Språkteori och -filosofi',
    'F:dd' => 'Språkvetenskaplig metodlära',
    'F:do' => 'Språkpsykologi',
    'F:dofa' => 'Barnspråk',
    'F:k' => 'Språkvetenskapens historia',
    'F:k.' => 'Särskilda perioder',
    'F:k.2' => 'Forntiden',
    'F:k.3' => 'Medeltiden',
    'F:k.4' => 'Nya tiden',
    'F:k.5' => '1900-',
    'F:k.6' => '2000-',
    'F:kc' => 'Sverige',
    'F:oa' => 'Språksociologi',
    'F:oi' => 'Språkstatistik',
    'F:pu' => 'Datalingvistik',
    'F:t' => 'Matematisk lingvistik',
    'F.0' => 'Allmänt: särskilda språkvetenskapliga aspekter',
    'F.00' => 'Språkhistoria',
    'F.01' => 'Grammatik',
    'F.011' => 'Fonetik',
    'F.012' => 'Formlära (morfologi)',
    'F.013' => 'Syntax',
    'F.02' => 'Ordförråd, lexikologi',
    'F.021' => 'Etymologi',
    'F.022' => 'Ordbildning',
    'F.023' => 'Semantik (betydelselära)',
    'F.024' => 'Språkpragmatik',
    'F.025' => 'Fraseologi, idiomatik',
    'F.026' => 'Synonymik',
    'F.03' => 'Namnforskning (onomastik)',
    'F.031' => 'Personnamn',
    'F.032' => 'Ortnamn',
    'F.04' => 'Dialektologi och språkgeografi',
    'F.042' => 'Slang och talspråk',
    'F.043' => 'Yrkesspråk',
    'F.045' => 'Blandspråk (pidgin- och kreolspråk)',
    'F.047' => 'Tvåspråkighet',
    'F.05' => 'Metrik och prosodi',
    'F.06' => 'Stilistik och textlingvistik',
    'F.061' => 'Stilistik',
    'F.062' => 'Språkriktighet',
    'F.063' => 'Retorik och muntlig framställning',
    'F.064' => 'Textlingvistik',
    'F.065' => 'Översättning',
    'F.07' => 'Ortografi, interpunktion och förkortningar',
    'F.074' => 'Transkribering och translitterering',
    'F.08' => 'Epigrafik och papyrologi',
    'F.081' => 'Epigrafik',
    'F.082' => 'Papyrologi',
    'Fb' => 'Indoeuropeiska språk: allmänt',
    'Fb(x)' => 'Lexikon',
    'Fbg' => 'Germanska språk: allmänt',
    'Fbg(x)' => 'Lexikon',
    'Fbh' => 'Urgermanska',
    'Fbk' => 'Gotiska',
    'Fbk(x)' => 'Lexikon',
    'Fbn' => 'Nordiska språk: allmänt',
    'Fbn(x)' => 'Lexikon',
    'Fbr' => 'Runologi',
    'Fbr(x)' => 'Lexikon',
    'Fc' => 'Svenska',
    'Fc(x)' => 'Lexikon',
    'Fc:bf' => 'Organisationer och institutioner',
    'Fc.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fc.00' => 'Språkhistoria',
    'Fc.01' => 'Grammatik',
    'Fc.011' => 'Fonetik',
    'Fc.012' => 'Formlära (morfologi)',
    'Fc.013' => 'Syntax',
    'Fc.02' => 'Ordförråd, lexikologi',
    'Fc.021' => 'Etymologi',
    'Fc.022' => 'Ordbildning',
    'Fc.023' => 'Semantik (betydelselära)',
    'Fc.024' => 'Språkpragmatik',
    'Fc.025' => 'Fraseologi, idiomatik',
    'Fc.026' => 'Synonymik',
    'Fc.03' => 'Namnforskning (onomastik)',
    'Fc.03c' => 'Sverige',
    'Fc.03ca' => 'Svealand',
    'Fc.03cb' => 'Götaland',
    'Fc.03cc' => 'Norrland',
    'Fc.03dd' => 'Finland',
    'Fc.031' => 'Personnamn',
    'Fc.032' => 'Ortnamn',
    'Fc.04' => 'Dialektologi och språkgeografi',
    'Fc.04c' => 'Sverige',
    'Fc.04ca' => 'Svealand',
    'Fc.04cb' => 'Götaland',
    'Fc.04cc' => 'Norrland',
    'Fc.04dd' => 'Finland',
    'Fc.04mca' => 'Estland',
    'Fc.042' => 'Slang och talspråk',
    'Fc.043' => 'Yrkesspråk',
    'Fc.047' => 'Tvåspråkighet',
    'Fc.05' => 'Metrik och prosodi',
    'Fc.06' => 'Stilistik och textlingvistik',
    'Fc.061' => 'Stilistik',
    'Fc.062' => 'Språkriktighet',
    'Fc.063' => 'Retorik och muntlig framställning',
    'Fc.064' => 'Textlingvistik',
    'Fc.065' => 'Översättning',
    'Fc.07' => 'Ortografi, interpunktion och förkortningar',
    'Fc.08' => 'Epigrafik',
    'Fca' => 'Fornsvenska och runsvenska',
    'Fca(x)' => 'Lexikon',
    'Fct' => 'Svenska för utlänningar',
    'Fct(x)' => 'Lexikon',
    'Fd' => 'Övriga nordiska språk',
    'Fda' => 'Danska',
    'Fda(x)' => 'Lexikon',
    'Fda.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fda.00' => 'Språkhistoria',
    'Fda.01' => 'Grammatik',
    'Fda.011' => 'Fonetik',
    'Fda.012' => 'Formlära (morfologi)',
    'Fda.013' => 'Syntax',
    'Fda.02' => 'Ordförråd, lexikologi',
    'Fda.021' => 'Etymologi',
    'Fda.022' => 'Ordbildning',
    'Fda.023' => 'Semantik (betydelselära)',
    'Fda.024' => 'Språkpragmatik',
    'Fda.025' => 'Fraseologi, idiomatik',
    'Fda.026' => 'Synonymik',
    'Fda.03' => 'Namnforskning (onomastik)',
    'Fda.031' => 'Personnamn',
    'Fda.032' => 'Ortnamn',
    'Fda.04' => 'Dialektologi och språkgeografi',
    'Fda.042' => 'Slang och talspråk',
    'Fda.043' => 'Yrkesspråk',
    'Fda.05' => 'Metrik och prosodi',
    'Fda.06' => 'Stilistik och textlingvistik',
    'Fda.061' => 'Stilistik',
    'Fda.062' => 'Språkriktighet',
    'Fda.063' => 'Retorik och muntlig framställning',
    'Fda.064' => 'Textlingvistik',
    'Fda.065' => 'Översättning',
    'Fda.07' => 'Ortografi, interpunktion och förkortningar',
    'Fdaa' => 'Forndanska',
    'Fdaa(x)' => 'Lexikon',
    'Fdb' => 'Norska',
    'Fdb(x)' => 'Lexikon',
    'Fdb.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fdb.00' => 'Språkhistoria',
    'Fdb.01' => 'Grammatik',
    'Fdb.011' => 'Fonetik',
    'Fdb.012' => 'Formlära (morfologi)',
    'Fdb.013' => 'Syntax',
    'Fdb.02' => 'Ordförråd, lexikologi',
    'Fdb.021' => 'Etymologi',
    'Fdb.022' => 'Ordbildning',
    'Fdb.023' => 'Semantik (betydelselära)',
    'Fdb.026' => 'Synonymik',
    'Fdb.03' => 'Namnforskning (onomastik)',
    'Fdb.031' => 'Personnamn',
    'Fdb.032' => 'Ortnamn',
    'Fdb.04' => 'Dialektologi och språkgeografi',
    'Fdb.042' => 'Slang och talspråk',
    'Fdb.043' => 'Yrkesspråk',
    'Fdb.05' => 'Metrik och prosodi',
    'Fdb.06' => 'Stilistik och textlingvistik',
    'Fdb.061' => 'Stilistik',
    'Fdb.062' => 'Språkriktighet',
    'Fdb.063' => 'Retorik och muntlig framställning',
    'Fdb.065' => 'Översättning',
    'Fdb.07' => 'Ortografi, interpunktion och förkortningar',
    'Fdbn' => 'Nynorsk',
    'Fdbn(x)' => 'Lexikon',
    'Fdc' => 'Isländska och färöiska',
    'Fdc(x)' => 'Lexikon',
    'Fdca' => 'Fornisländska och fornnorska',
    'Fdca(x)' => 'Lexikon',
    'Fdcb' => 'Nyisländska',
    'Fdcb(x)' => 'Lexikon',
    'Fdcf' => 'Färöiska',
    'Fdcf(x)' => 'Lexikon',
    'Fe' => 'Engelska',
    'Fe(x)' => 'Lexikon',
    'Fe.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fe.00' => 'Språkhistoria',
    'Fe.01' => 'Grammatik',
    'Fe.011' => 'Fonetik',
    'Fe.012' => 'Formlära (morfologi)',
    'Fe.013' => 'Syntax',
    'Fe.02' => 'Ordförråd, lexikologi',
    'Fe.021' => 'Etymologi',
    'Fe.022' => 'Ordbildning',
    'Fe.023' => 'Semantik (betydelselära)',
    'Fe.024' => 'Språkpragmatik',
    'Fe.025' => 'Fraseologi, idiomatik',
    'Fe.026' => 'Synonymik',
    'Fe.03' => 'Namnforskning (onomastik)',
    'Fe.031' => 'Personnamn',
    'Fe.032' => 'Ortnamn',
    'Fe.04' => 'Dialektologi och språkgeografi',
    'Fe.04es' => 'Skotsk engelska',
    'Fe.04et' => 'Irländsk engelska',
    'Fe.042' => 'Slang och talspråk',
    'Fe.043' => 'Yrkesspråk',
    'Fe.045' => 'Blandspråk (pidgin- och kreolspråk)',
    'Fe.047' => 'Tvåspråkighet',
    'Fe.05' => 'Metrik och prosodi',
    'Fe.06' => 'Stilistik och textlingvistik',
    'Fe.061' => 'Stilistik',
    'Fe.062' => 'Språkriktighet',
    'Fe.063' => 'Retorik och muntlig framställning',
    'Fe.064' => 'Textlingvistik',
    'Fe.065' => 'Översättning',
    'Fe.07' => 'Ortografi, interpunktion och förkortningar',
    'Fe.08' => 'Epigrafik',
    'Fea' => 'Fornengelska (anglosaxiska)',
    'Fea(x)' => 'Lexikon',
    'Feb' => 'Medelengelska',
    'Feb(x)' => 'Lexikon',
    'Feo' => 'Asiatisk engelska',
    'Feo(x)' => 'Lexikon',
    'Fep' => 'Afrikansk engelska',
    'Fep(x)' => 'Lexikon',
    'Feq' => 'Amerikansk engelska',
    'Feq(x)' => 'Lexikon',
    'Fer' => 'Australisk engelska',
    'Fer(x)' => 'Lexikon',
    'Ff' => 'Tyska',
    'Ff(x)' => 'Lexikon',
    'Ff.0' => 'Särskilda språkvetenskapliga aspekter',
    'Ff.00' => 'Språkhistoria',
    'Ff.01' => 'Grammatik',
    'Ff.011' => 'Fonetik',
    'Ff.012' => 'Formlära (morfologi)',
    'Ff.013' => 'Syntax',
    'Ff.02' => 'Ordförråd, lexikologi',
    'Ff.021' => 'Etymologi',
    'Ff.022' => 'Ordbildning',
    'Ff.023' => 'Semantik (betydelselära)',
    'Ff.024' => 'Språkpragmatik',
    'Ff.025' => 'Fraseologi, idiomatik',
    'Ff.026' => 'Synonymik',
    'Ff.03' => 'Namnforskning (onomastik)',
    'Ff.031' => 'Personnamn',
    'Ff.032' => 'Ortnamn',
    'Ff.04' => 'Dialektologi och språkgeografi',
    'Ff.04h' => 'Schwyzerdütsch',
    'Ff.04gc' => 'Letzeburgisch',
    'Ff.042' => 'Slang och talspråk',
    'Ff.043' => 'Yrkesspråk',
    'Ff.05' => 'Metrik och prosodi',
    'Ff.06' => 'Stilistik och textlingvistik',
    'Ff.061' => 'Stilistik',
    'Ff.062' => 'Språkriktighet',
    'Ff.063' => 'Retorik och muntlig framställning',
    'Ff.064' => 'Textlingvistik',
    'Ff.065' => 'Översättning',
    'Ff.07' => 'Ortografi, interpunktion och förkortningar',
    'Ff.08' => 'Epigrafik',
    'Ffa' => 'Fornhögtyska',
    'Ffa(x)' => 'Lexikon',
    'Ffb' => 'Medelhögtyska',
    'Ffb(x)' => 'Lexikon',
    'Ffl' => 'Lågtyska',
    'Ffl(x)' => 'Lexikon',
    'Ffla' => 'Fornlågtyska (fornsaxiska)',
    'Ffla(x)' => 'Lexikon',
    'Fflb' => 'Medellågtyska',
    'Fblb(x)' => 'Lexikon',
    'Ffo' => 'Jiddisch',
    'Ffo(x)' => 'Lexikon',
    'Fg' => 'Nederländska',
    'Fg(x)' => 'Lexikon',
    'Fga' => 'Fornnederländska (fornlågfrankiska)',
    'Fgb' => 'Medelnederländska',
    'Fgp' => 'Afrikaans',
    'Fgp(x)' => 'Lexikon',
    'Fgt' => 'Frisiska',
    'Fgt(x)' => 'Lexikon',
    'Fgta' => 'Fornfrisiska',
    'Fh' => 'Romanska språk: allmänt',
    'Fh(x)' => 'Lexikon',
    'Fha' => 'Rätoromanska, ladino, rumantsch, friuliska',
    'Fha(x)' => 'Lexikon',
    'Fhb' => 'Rumänska',
    'Fhb(x)' => 'Lexikon',
    'Fhc' => 'Dalmatiska',
    'Fi' => 'Italienska',
    'Fi(x)' => 'Lexikon',
    'Fi.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fi.00' => 'Språkhistoria',
    'Fi.01' => 'Grammatik',
    'Fi.011' => 'Fonetik',
    'Fi.012' => 'Formlära (morfologi)',
    'Fi.013' => 'Syntax',
    'Fi.02' => 'Ordförråd, lexikologi',
    'Fi.021' => 'Etymologi',
    'Fi.022' => 'Ordbildning',
    'Fi.023' => 'Semantik (betydelselära)',
    'Fi.024' => 'Språkpragmatik',
    'Fi.025' => 'Fraseologi, idiomatik',
    'Fi.026' => 'Synonymik',
    'Fi.03' => 'Namnforskning (onomastik)',
    'Fi.031' => 'Personnamn',
    'Fi.032' => 'Ortnamn',
    'Fi.04' => 'Dialektologi och språkgeografi',
    'Fi.042' => 'Slang och talspråk',
    'Fi.043' => 'Yrkesspråk',
    'Fi.05' => 'Metrik och prosodi',
    'Fi.06' => 'Stilistik och textlingvistik',
    'Fi.061' => 'Stilistik',
    'Fi.062' => 'Språkriktighet',
    'Fi.063' => 'Retorik och muntlig framställning',
    'Fi.064' => 'Textlingvistik',
    'Fi.065' => 'Översättning',
    'Fi.07' => 'Ortografi, interpunktion och förkortningar',
    'Fi.08' => 'Epigrafik',
    'Fia' => 'Fornitalienska',
    'Fit' => 'Sardiska',
    'Fit(x)' => 'Lexikon',
    'Fj' => 'Franska',
    'Fj(x)' => 'Lexikon',
    'Fj.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fj.00' => 'Språkhistoria',
    'Fj.01' => 'Grammatik',
    'Fj.011' => 'Fonetik',
    'Fj.012' => 'Formlära (morfologi)',
    'Fj.013' => 'Syntax',
    'Fj.02' => 'Ordförråd, lexikologi',
    'Fj.021' => 'Etymologi',
    'Fj.022' => 'Ordbildning',
    'Fj.023' => 'Semantik (betydelselära)',
    'Fj.024' => 'Språkpragmatik',
    'Fj.025' => 'Fraseologi, idiomatik',
    'Fj.026' => 'Synonymik',
    'Fj.03' => 'Namnforskning (onomastik)',
    'Fj.031' => 'Personnamn',
    'Fj.032' => 'Ortnamn',
    'Fj.04' => 'Dialektologi och språkgeografi',
    'Fj.042' => 'Slang och talspråk',
    'Fj.043' => 'Yrkesspråk',
    'Fj.045' => 'Blandspråk (pidgin- och kreolspråk)',
    'Fj.047' => 'Tvåspråkighet',
    'Fj.05' => 'Metrik och prosodi',
    'Fj.06' => 'Stilistik och textlingvistik',
    'Fj.061' => 'Stilistik',
    'Fj.062' => 'Språkriktighet',
    'Fj.063' => 'Retorik och muntlig framställning',
    'Fj.064' => 'Textlingvistik',
    'Fj.065' => 'Översättning',
    'Fj.07' => 'Ortografi, interpunktion och förkortningar',
    'Fj.08' => 'Epigrafik',
    'Fja' => 'Fornfranska',
    'Fja(x)' => 'Lexikon',
    'Fjb' => 'Medelfranska',
    'Fjb(x)' => 'Lexikon',
    'Fjp' => 'Afrikansk franska',
    'Fjp(x)' => 'Lexikon',
    'Fjq' => 'Amerikansk franska',
    'Fjq(x)' => 'Lexikon',
    'Fjt' => 'Provensalska och occitanska',
    'Fjt(x)' => 'Lexikon',
    'Fk' => 'Spanska',
    'Fk(x)' => 'Lexikon',
    'Fk.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fk.00' => 'Språkhistoria',
    'Fk.01' => 'Grammatik',
    'Fk.011' => 'Fonetik',
    'Fk.012' => 'Formlära (morfologi)',
    'Fk.013' => 'Syntax',
    'Fk.02' => 'Ordförråd, lexikologi',
    'Fk.021' => 'Etymologi',
    'Fk.022' => 'Ordbildning',
    'Fk.023' => 'Semantik (betydelselära)',
    'Fk.024' => 'Språkpragmatik',
    'Fk.025' => 'Fraseologi, idiomatik',
    'Fk.026' => 'Synonymik',
    'Fk.03' => 'Namnforskning (onomastik)',
    'Fk.031' => 'Personnamn',
    'Fk.032' => 'Ortnamn',
    'Fk.04' => 'Dialektologi och språkgeografi',
    'Fk.042' => 'Slang och talspråk',
    'Fk.043' => 'Yrkesspråk',
    'Fk.045' => 'Blandspråk (pidgin- och kreolspråk)',
    'Fk.047' => 'Tvåspråkighet',
    'Fk.05' => 'Metrik och prosodi',
    'Fk.06' => 'Stilistik och textlingvistik',
    'Fk.061' => 'Stilistik',
    'Fk.062' => 'Språkriktighet',
    'Fk.063' => 'Retorik och muntlig framställning',
    'Fk.064' => 'Textlingvistik',
    'Fk.065' => 'Översättning',
    'Fk.07' => 'Ortografi, interpunktion och förkortningar',
    'Fka' => 'Fornspanska',
    'Fka(x)' => 'Lexikon',
    'Fkb' => 'Medelspanska',
    'Fkb(x)' => 'Lexikon',
    'Fkp' => 'Afrikansk spanska',
    'Fkq' => 'Amerikansk spanska',
    'Fkq(x)' => 'Lexikon',
    'Fks' => 'Spanjolska (sefardiska el ladino)',
    'Fku' => 'Katalanska',
    'Fku(x)' => 'Lexikon',
    'Fl' => 'Portugisiska',
    'Fl(x)' => 'Lexikon',
    'Fla' => 'Fornportugisiska',
    'Flb' => 'Medelportugisiska',
    'Flp' => 'Afrikansk portugisiska',
    'Flq' => 'Brasilianska',
    'Flq(x)' => 'Lexikon',
    'Flt' => 'Galiciska',
    'Flt(x)' => 'Lexikon',
    'Fm' => 'Slaviska och baltiska språk',
    'Fm(x)' => 'Allmänt: lexikon',
    'Fma' => 'Ryska',
    'Fma(x)' => 'Lexikon',
    'Fma.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fma.00' => 'Språkhistoria',
    'Fma.01' => 'Grammatik',
    'Fma.011' => 'Fonetik',
    'Fma.012' => 'Formlära (morfologi)',
    'Fma.013' => 'Syntax',
    'Fma.02' => 'Ordförråd, lexikologi',
    'Fma.021' => 'Etymologi',
    'Fma.022' => 'Ordbildning',
    'Fma.023' => 'Semantik (betydelselära)',
    'Fma.024' => 'Språkpragmatik',
    'Fma.025' => 'Fraseologi, idiomatik',
    'Fma.026' => 'Synonymik',
    'Fma.03' => 'Namnforskning (onomastik)',
    'Fma.031' => 'Personnamn',
    'Fma.032' => 'Ortnamn',
    'Fma.04' => 'Dialektologi och språkgeografi',
    'Fma.042' => 'Slang och talspråk',
    'Fma.043' => 'Yrkesspråk',
    'Fma.05' => 'Metrik och prosodi',
    'Fma.06' => 'Stilistik och textlingvistik',
    'Fma.061' => 'Stilistik',
    'Fma.062' => 'Språkriktighet',
    'Fma.063' => 'Retorik och muntlig framställning',
    'Fma.064' => 'Textlingvistik',
    'Fma.065' => 'Översättning',
    'Fma.07' => 'Ortografi, interpunktion och förkortningar',
    'Fma.074' => 'Transkribering och translitterering',
    'Fma.08' => 'Epigrafik',
    'Fmaa' => 'Fornryska',
    'Fmaa(x)' => 'Lexikon',
    'Fmb' => 'Ukrainska',
    'Fmb(x)' => 'Lexikon',
    'Fmbt' => 'Vitryska',
    'Fmbt(x)' => 'Lexikon',
    'Fmbu' => 'Karpatorusinska och rusinska',
    'Fmc' => 'Polska',
    'Fmc(x)' => 'Lexikon',
    'Fmc.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fmc.00' => 'Språkhistoria',
    'Fmc.01' => 'Grammatik',
    'Fmc.011' => 'Fonetik',
    'Fmc.012' => 'Formlära (morfologi)',
    'Fmc.013' => 'Syntax',
    'Fmc.02' => 'Ordförråd, lexikologi',
    'Fmc.021' => 'Etymologi',
    'Fmc.022' => 'Ordbildning',
    'Fmc.023' => 'Semantik (betydelselära)',
    'Fmc.024' => 'Språkpragmatik',
    'Fmc.025' => 'Fraseologi, idiomatik',
    'Fmc.026' => 'Synonymik',
    'Fmc.03' => 'Namnforskning (onomastik)',
    'Fmc.031' => 'Personnamn',
    'Fmc.032' => 'Ortnamn',
    'Fmc.04' => 'Dialektologi och språkgeografi',
    'Fmc.042' => 'Slang och talspråk',
    'Fmc.043' => 'Yrkesspråk',
    'Fmc.05' => 'Metrik och prosodi',
    'Fmc.06' => 'Stilistik och textlingvistik',
    'Fmc.061' => 'Stilistik',
    'Fmc.062' => 'Språkriktighet',
    'Fmc.063' => 'Retorik och muntlig framställning',
    'Fmc.064' => 'Textlingvistik',
    'Fmc.065' => 'Översättning',
    'Fmc.07' => 'Ortografi, interpunktion och förkortningar',
    'Fmca' => 'Fornpolska',
    'Fmca(x)' => 'Lexikon',
    'Fmct' => 'Kasjubiska',
    'Fmct(x)' => 'Lexikon',
    'Fmcu' => 'Polabiska',
    'Fmcu(x)' => 'Lexikon',
    'Fmd' => 'Tjeckiska',
    'Fmd(x)' => 'Lexikon',
    'Fmda' => 'Forntjeckiska',
    'Fmda(x)' => 'Lexikon',
    'Fme' => 'Slovakiska',
    'Fme(x)' => 'Lexikon',
    'Fmet' => 'Sorbiska (vendiska)',
    'Fmet(x)' => 'Lexikon',
    'Fmf' => 'Serbiska, kroatiska och bosnisk-hercegovinska',
    'Fmf(x)' => 'Lexikon',
    'Fmg' => 'Slovenska',
    'Fmg(x)' => 'Lexikon',
    'Fmh' => 'Bulgariska',
    'Fmh(x)' => 'Lexikon',
    'Fmi' => 'Fornkyrkslaviska',
    'Fmi(x)' => 'Lexikon',
    'Fmj' => 'Makedonska (slavisk makedonska)',
    'Fmj(x)' => 'Lexikon',
    'Fmk' => 'Baltiska språk',
    'Fmk(x)' => 'Allmänt: lexikon',
    'Fmka' => 'Litauiska',
    'Fmka(x)' => 'Lexikon',
    'Fmkb' => 'Lettiska',
    'Fmkb(x)' => 'Lexikon',
    'Fmkc' => 'Fornpreussiska',
    'Fmkc(x)' => 'Lexikon',
    'Fn' => 'Keltiska språk',
    'Fna' => 'Kontinentalkeltiska',
    'Fnb' => 'Gaeliska',
    'Fnb(x)' => 'Lexikon',
    'Fnba' => 'Iriska',
    'Fnba(x)' => 'Lexikon',
    'Fnbb' => 'Skotsk-gaeliska',
    'Fnbb(x)' => 'Lexikon',
    'Fnbc' => 'Manx',
    'Fnc' => 'Britanniska',
    'Fnca' => 'Kymriska',
    'Fnca(x)' => 'Lexikon',
    'Fncb' => 'Korniska',
    'Fncc' => 'Bretonska',
    'Fncc(x)' => 'Lexikon',
    'Fo' => 'Grekiska och latin',
    'Fo(x)' => 'Allmänt: lexikon',
    'Foa' => 'Grekiska',
    'Foa(x)' => 'Lexikon',
    'Foa.0' => 'Särskilda språkvetenskapliga aspekter',
    'Foa.00' => 'Språkhistoria',
    'Foa.01' => 'Grammatik',
    'Foa.011' => 'Fonetik',
    'Foa.012' => 'Formlära (morfologi)',
    'Foa.013' => 'Syntax',
    'Foa.02' => 'Ordförråd, lexikologi',
    'Foa.021' => 'Etymologi',
    'Foa.022' => 'Ordbildning',
    'Foa.023' => 'Semantik (betydelselära)',
    'Foa.03' => 'Namnforskning (onomastik)',
    'Foa.031' => 'Personnamn',
    'Foa.032' => 'Ortnamn',
    'Foa.04' => 'Dialektologi och språkgeografi',
    'Foa.05' => 'Metrik och prosodi',
    'Foa.06' => 'Stilistik och textlingvistik',
    'Foa.061' => 'Stilistik',
    'Foa.063' => 'Retorik och muntlig framställning',
    'Foa.064' => 'Textlingvistik',
    'Foa.065' => 'Översättning',
    'Foa.07' => 'Ortografi, interpunktion och förkortningar',
    'Foa.08' => 'Epigrafik och papyrologi',
    'Foa.081' => 'Epigrafik',
    'Foa.082' => 'Papyrologi',
    'Foam' => 'Bysantinsk grekiska',
    'Foam(x)' => 'Lexikon',
    'Fob' => 'Nygrekiska',
    'Fob(x)' => 'Lexikon',
    'Foc' => 'Latin',
    'Foc(x)' => 'Lexikon',
    'Foc.0' => 'Särskilda språkvetenskapliga aspekter',
    'Foc.00' => 'Språkhistoria',
    'Foc.01' => 'Grammatik',
    'Foc.011' => 'Fonetik',
    'Foc.012' => 'Formlära (morfologi)',
    'Foc.013' => 'Syntax',
    'Foc.02' => 'Ordförråd, lexikologi',
    'Foc.021' => 'Etymologi',
    'Foc.022' => 'Ordbildning',
    'Foc.023' => 'Semantik (betydelselära)',
    'Foc.024' => 'Språkpragmatik',
    'Foc.025' => 'Fraseologi, idiomatik',
    'Foc.026' => 'Synonymik',
    'Foc.03' => 'Namnforskning (onomastik)',
    'Foc.031' => 'Personnamn',
    'Foc.032' => 'Ortnamn',
    'Foc.04' => 'Dialektologi och språkgeografi',
    'Foc.05' => 'Metrik och prosodi',
    'Foc.06' => 'Stilistik och textlingvistik',
    'Foc.061' => 'Stilistik',
    'Foc.063' => 'Retorik och muntlig framställning',
    'Foc.064' => 'Textlingvistik',
    'Foc.065' => 'Översättning',
    'Foc.07' => 'Ortografi, interpunktion och förkortningar',
    'Focm' => 'Medeltidslatin',
    'Focm(x)' => 'Lexikon',
    'Focn' => 'Humanist- och nylatin',
    'Focn(x)' => 'Lexikon',
    'Fod' => 'Fornitaliska språk',
    'Fod(x)' => 'Lexikon',
    'Fp' => 'Indo-ariska språk',
    'Fp(x)' => 'Allmänt: lexikon',
    'Fpa' => 'Sanskrit',
    'Fpa(x)' => 'Lexikon',
    'Fpaa' => 'Vedisk sanskrit',
    'Fpaa(x)' => 'Lexikon',
    'Fpab' => 'Episk sanskrit',
    'Fpac' => 'Klassisk sanskrit',
    'Fpac(x)' => 'Lexikon',
    'Fpb' => 'Medelindiska språk',
    'Fpb(x)' => 'Allmänt: lexikon',
    'Fpba' => 'Pali',
    'Fpba(x)' => 'Lexikon',
    'Fpbb' => 'Prakrit',
    'Fpbb(x)' => 'Lexikon',
    'Fpd' => 'Nyindiska språk',
    'Fpd(x)' => 'Allmänt: lexikon',
    'Fpda' => 'Hindi',
    'Fpda(x)' => 'Lexikon',
    'Fpdb' => 'Urdu',
    'Fpdb(x)' => 'Lexikon',
    'Fpdc' => 'Bengali',
    'Fpdc(x)' => 'Lexikon',
    'Fpdd' => 'Marathi',
    'Fpde' => 'Gujarati',
    'Fpdf' => 'Panjabi',
    'Fpdg' => 'Kashmiri',
    'Fpdi' => 'Assami',
    'Fpdj' => 'Nepali',
    'Fpdk' => 'Singalesiska',
    'Fpdk(x)' => 'Lexikon',
    'Fpdl' => 'Rajastani',
    'Fpdm' => 'Sindhi',
    'Fpdo' => 'Bihari',
    'Fpdo(x)' => 'Lexikon',
    'Fpr' => 'Romani',
    'Fpr(x)' => 'Lexikon',
    'Fq' => 'Iranska språk',
    'Fq(x)' => 'Allmänt: lexikon',
    'Fqa' => 'Forniranska språk',
    'Fqa(x)' => 'Lexikon',
    'Fqb' => 'Medeliranska språk',
    'Fqb(x)' => 'Lexikon',
    'Fqc' => 'Nyiranska språk',
    'Fqc(x)' => 'Allmänt: lexikon',
    'Fqca' => 'Nypersiska (farsi)',
    'Fqca(x)' => 'Lexikon',
    'Fqcb' => 'Tadzjikiska',
    'Fqcc' => 'Kurdiska',
    'Fqcc(x)' => 'Lexikon',
    'Fqcca' => 'Kurmanji',
    'Fqccb' => 'Sorani',
    'Fqcd' => 'Pashto (afghanska)',
    'Fqce' => 'Dari',
    'Fqcf' => 'Ossetiska',
    'Fqcg' => 'Baluchi',
    'Fr' => 'Övriga indoeuropeiska språk',
    'Fr(x)' => 'Allmänt: lexikon',
    'Fra' => 'Tochariska',
    'Frb' => 'Armeniska',
    'Frb(x)' => 'Lexikon',
    'Frc' => 'Anatoliska språk (hettitiska, luviska, lydiska m m)',
    'Frc(x)' => 'Lexikon',
    'Frd' => 'Trakisk-frygiska språk',
    'Fre' => 'Illyriska',
    'Frf' => 'Albanska',
    'Ffr(x)' => 'Lexikon',
    'Fs' => 'Semitiska språk',
    'Fs(x)' => 'Allmänt: lexikon',
    'Fsa' => 'Akkadiska (och kilskriften)',
    'Fsa(x)' => 'Lexikon',
    'Fsc' => 'Kananeiska',
    'Fsc(x)' => 'Lexikon',
    'Fsca' => 'Ugaritiska',
    'Fsca(x)' => 'Lexikon',
    'Fsd' => 'Hebreiska',
    'Fsd(x)' => 'Lexikon',
    'Fsd.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fsd.00' => 'Språkhistoria',
    'Fsd.01' => 'Grammatik',
    'Fsd.011' => 'Fonetik',
    'Fsd.012' => 'Formlära (morfologi)',
    'Fsd.013' => 'Syntax',
    'Fsd.02' => 'Ordförråd, lexikologi',
    'Fsd.021' => 'Etymologi',
    'Fsd.022' => 'Ordbildning',
    'Fsd.023' => 'Semantik (betydelselära)',
    'Fsd.03' => 'Namnforskning (onomastik)',
    'Fsd.031' => 'Personnamn',
    'Fsd.032' => 'Ortnamn',
    'Fsd.04' => 'Dialektologi och språkgeografi',
    'Fsd.05' => 'Metrik och prosodi',
    'Fsd.06' => 'Stilistik och textlingvistik',
    'Fsd.061' => 'Stilistik',
    'Fsd.063' => 'Retorik och muntlig framställning',
    'Fsd.064' => 'Textlingvistik',
    'Fsd.065' => 'Översättning',
    'Fsd.07' => 'Ortografi, interpunktion och förkortningar',
    'Fsd.074' => 'Transkribering och translitterering',
    'Fsd.08' => 'Epigrafik och papyrologi',
    'Fsd.081' => 'Epigrafik',
    'Fsd.082' => 'Papyrologi',
    'Fse' => 'Arameiska',
    'Fse(x)' => 'Lexikon',
    'Fses' => 'Syriska (syriak)',
    'Fses(x)' => 'Lexikon',
    'Fsesm' => 'Nysyriska språk',
    'Fsesmt' => 'Moderna västsyriska språk',
    'Fsesmu' => 'Moderna östsyriska språk',
    'Fsg' => 'Arabiska',
    'Fsg(x)' => 'Lexikon',
    'Fsg.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fsg.00' => 'Språkhistoria',
    'Fsg.01' => 'Grammatik',
    'Fsg.011' => 'Fonetik',
    'Fsg.012' => 'Formlära (morfologi)',
    'Fsg.013' => 'Syntax',
    'Fsg.02' => 'Ordförråd, lexikologi',
    'Fsg.021' => 'Etymologi',
    'Fsg.022' => 'Ordbildning',
    'Fsg.023' => 'Semantik (betydelselära)',
    'Fsg.024' => 'Språkpragmatik',
    'Fsg.025' => 'Fraseologi, idiomatik',
    'Fsg.026' => 'Synonymik',
    'Fsg.03' => 'Namnforskning (onomastik)',
    'Fsg.031' => 'Personnamn',
    'Fsg.032' => 'Ortnamn',
    'Fsg.04' => 'Dialektologi och språkgeografi',
    'Fsg.05' => 'Metrik och prosodi',
    'Fsg.06' => 'Stilistik och textlingvistik',
    'Fsg.061' => 'Stilistik',
    'Fsg.062' => 'Språkriktighet',
    'Fsg.063' => 'Retorik och muntlig framställning',
    'Fsg.065' => 'Översättning',
    'Fsg.07' => 'Ortografi, interpunktion och förkortningar',
    'Fsg.074' => 'Transkribering och translitterering',
    'Fsgm' => 'Maltesiska',
    'Fsgm(x)' => 'Lexikon',
    'Fsh' => 'Sydarabiska',
    'Fsh(x)' => 'Lexikon',
    'Fsi' => 'Etiopiska språk',
    'Fsi(x)' => 'Allmänt: lexikon',
    'Fsia' => 'Ge&#039;ez (fornetiopiska)',
    'Fsic' => 'Tigrinja',
    'Fsie' => 'Amhariska',
    'Fsie(x)' => 'Lexikon',
    'Ft' => 'Hamitiska språk och tchadspråk',
    'Fta' => 'Egyptiska',
    'Fta(x)' => 'Lexikon',
    'Ftaa' => 'Fornegyptiska (och hieroglyfer)',
    'Ftaa(x)' => 'Lexikon',
    'Ftab(x)' => 'Lexikon',
    'Ftab' => 'Koptiska',
    'Ftb' => 'Libysk-berbiska språk',
    'Ftb(x)' => 'Lexikon',
    'Ftc' => 'Kusjitiska språk',
    'Ftc(x)' => 'Allmänt: lexikon',
    'Ftca' => 'Somali',
    'Ftca(x)' => 'Lexikon',
    'Ftcb' => 'Oromo',
    'Ftd' => 'Tchadspråk',
    'Ftd(x)' => 'Lexikon',
    'Ftda' => 'Haussa',
    'Ftda(x)' => 'Lexikon',
    'Fu' => 'Finsk-ugriska och altaiska språk',
    'Fu(x)' => 'Allmänt: lexikon',
    'Fua' => 'Finsk-ugriska språk: allmänt',
    'Fua(x)' => 'Allmänt: lexikon',
    'Fub' => 'Finska',
    'Fub(x)' => 'Lexikon',
    'Fub.0' => 'Särskilda språkvetenskapliga aspekter',
    'Fub.00' => 'Språkhistoria',
    'Fub.01' => 'Grammatik',
    'Fub.011' => 'Fonetik',
    'Fub.012' => 'Formlära (morfologi)',
    'Fub.013' => 'Syntax',
    'Fub.02' => 'Ordförråd, lexikologi',
    'Fub.021' => 'Etymologi',
    'Fub.022' => 'Ordbildning',
    'Fub.023' => 'Semantik (betydelselära)',
    'Fub.024' => 'Språkpragmatik',
    'Fub.025' => 'Fraseologi, idiomatik',
    'Fub.026' => 'Synonymik',
    'Fub.03' => 'Namnforskning (onomastik)',
    'Fub.031' => 'Personnamn',
    'Fub.032' => 'Ortnamn',
    'Fub.04' => 'Dialektologi och språkgeografi',
    'Fub.042' => 'Slang och talspråk',
    'Fub.043' => 'Yrkesspråk',
    'Fub.045' => 'Blandspråk (pidgin- och kreolspråk)',
    'Fub.047' => 'Tvåspråkighet',
    'Fub.05' => 'Metrik och prosodi',
    'Fub.06' => 'Stilistik och textlingvistik',
    'Fub.061' => 'Stilistik',
    'Fub.062' => 'Språkriktighet',
    'Fub.063' => 'Retorik och muntlig framställning',
    'Fub.064' => 'Textlingvistik',
    'Fub.065' => 'Översättning',
    'Fub.07' => 'Ortografi, interpunktion och förkortningar',
    'Fub.074' => 'Transkribering och translitterering',
    'Fubt' => 'Tornedalsfinska',
    'Fuc' => 'Estniska',
    'Fuc(x)' => 'Lexikon',
    'Fud' => 'Övriga östersjöfinska språk',
    'Fud(x)' => 'Lexikon',
    'Fue' => 'Samiska språk',
    'Fue(x)' => 'Allmänt: lexikon',
    'Fuea' => 'Nordsamiska',
    'Fuea(x)' => 'Lexikon',
    'Fueal' => 'Lulesamiska',
    'Fueal(x)' => 'Lexikon',
    'Fueb' => 'Sydsamiska',
    'Fueb(x)' => 'Lexikon',
    'Fuec' => 'Östsamiska',
    'Fuec(x)' => 'Lexikon',
    'Fuf' => 'Volgafinska språk',
    'Fuf(x)' => 'Lexikon',
    'Fug' => 'Permiska språk',
    'Fug(x)' => 'Lexikon',
    'Fuk' => 'Ungerska',
    'Fuk(x)' => 'Lexikon',
    'Ful' => 'Övriga ugriska språk',
    'Ful(x)' => 'Lexikon',
    'Fun' => 'Samojediska språk',
    'Fun(x)' => 'Lexikon',
    'Fus' => 'Altaiska språk: allmänt',
    'Fut' => 'Turkiska språk',
    'Fut(x)' => 'Allmänt: lexikon',
    'Futa' => 'Azerbajdzjanska',
    'Futa(x)' => 'Lexikon',
    'Futb' => 'Basjkiriska',
    'Futj' => 'Jakutiska',
    'Futk' => 'Kazakiska',
    'Futl' => 'Kirgisiska',
    'Futl(x)' => 'Lexikon',
    'Futm' => 'Turkmeniska',
    'Futn' => 'Tatariska',
    'Futn(x)' => 'Lexikon',
    'Futo' => 'Tjuvasjiska',
    'Futo(x)' => 'Lexikon',
    'Futt' => 'Turkiska',
    'Futt(x)' => 'Lexikon',
    'Futu' => 'Uiguriska',
    'Futu(x)' => 'Lexikon',
    'Futv' => 'Uzbekiska',
    'Futv(x)' => 'Lexikon',
    'Fuu' => 'Mongoliska språk',
    'Fuu(x)' => 'Lexikon',
    'Fuv' => 'Tungusiska språk',
    'Fuv(x)' => 'Lexikon',
    'Fuva' => 'Manchu',
    'Fuva(x)' => 'Lexikon',
    'Fv' => 'Sinotibetanska och austroasiatiska m.fl. språk',
    'Fv(x)' => 'Allmänt: lexikon',
    'Fva' => 'Kinesiska',
    'Fva(x)' => 'Lexikon',
    'Fva.04' => 'Dialektologi och språkgeografi',
    'Fvb' => 'Taispråk',
    'Fvb(x)' => 'Allmänt: lexikon',
    'Fvba' => 'Thailändska (thai)',
    'Fvba(x)' => 'Lexikon',
    'Fvbb' => 'Laotiska (lao)',
    'Fvc' => 'Tibeto-burmanska språk',
    'Fvc(x)' => 'Allmänt: lexikon',
    'Fvca' => 'Burmanska',
    'Fvca(x)' => 'Lexikon',
    'Fvcb' => 'Tibetanska',
    'Fvcb(x)' => 'Lexikon',
    'Fvd' => 'Austroasiatiska språk',
    'Fvd(x)' => 'Allmänt: lexikon',
    'Fvda' => 'Mon-khmerspråk',
    'Fvda(x)' => 'Lexikon',
    'Fvdaa' => 'Khmer (kambodjanska)',
    'Fve' => 'Viet-muongspråk',
    'Fve(x)' => 'Lexikon',
    'Fvea' => 'Vietnamesiska',
    'Fvea(x)' => 'Lexikon',
    'Fvf' => 'Mundaspråk',
    'Fvg' => 'Hmong-mienspråk',
    'Fx' => 'Övriga språk',
    'Fxa' => 'Isolerade fornspråk',
    'Fxaa' => 'Sumeriska',
    'Fxaa(x)' => 'Lexikon',
    'Fxae' => 'Etruskiska',
    'Fxae(x)' => 'Lexikon',
    'Fxf' => 'Baskiska',
    'Fxf(x)' => 'Lexikon',
    'Fxh' => 'Kaukasiska språk',
    'Fxh(x)' => 'Lexikon',
    'Fxha' => 'Georgiska',
    'Fxha(x)' => 'Lexikon',
    'Fxi' => 'Paleosibiriska språk',
    'Fxi(x)' => 'Lexikon',
    'Fxj' => 'Japanska',
    'Fxj(x)' => 'Lexikon',
    'Fxk' => 'Koreanska',
    'Fxk(x)' => 'Lexikon',
    'Fxm' => 'Ainu',
    'Fxo' => 'Dravidiska språk',
    'Fxo(x)' => 'Allmänt: lexikon',
    'Fxoa' => 'Tamil',
    'Fxoa(x)' => 'Lexikon',
    'Fxob' => 'Telugu',
    'Fxob(x)' => 'Lexikon',
    'Fxoc' => 'Kanaresiska',
    'Fxoc(x)' => 'Lexikon',
    'Fxod' => 'Malayalam',
    'Fxod(x)' => 'Lexikon',
    'Fxp' => 'Afrikanska språk',
    'Fxp(x)' => 'Allmänt: lexikon',
    'Fxpa' => 'Khoisanspråk',
    'Fxpb' => 'Niger-Kongospråk',
    'Fxpb(x)' => 'Allmänt: lexikon',
    'Fxpba' => 'Ibo (igbo)',
    'Fxpbb' => 'Yoruba',
    'Fxpbc' => 'Wolof',
    'Fxpbd' => 'Fulani',
    'Fxpbe' => 'Efik',
    'Fxpc' => 'Bantuspråk',
    'Fxpc(x)' => 'Allmänt: lexikon',
    'Fxpca' => 'Swahili',
    'Fxpca(x)' => 'Lexikon',
    'Fxpcb' => 'Zulu',
    'Fxpcc' => 'Xhosa',
    'Fxpcd' => 'Tswana-sotho',
    'Fxpcf' => 'Shona',
    'Fxpcg' => 'Kikongo',
    'Fxpch' => 'Lingala',
    'Fxpci' => 'Rwanda-rundi',
    'Fxpck' => 'Kikuyu',
    'Fxpcl' => 'Luganda',
    'Fxpcn' => 'Ndebele (Zimbabwe)',
    'Fxpd' => 'Chari-Nilspråk',
    'Fxpd(x)' => 'Lexikon',
    'Fxpq' => 'Afrikanska språk i Amerika',
    'Fxq' => 'Amerikanska språk',
    'Fxq(x)' => 'Allmänt: lexikon',
    'Fxqa' => 'Eskimå-språk',
    'Fxqa(x)' => 'Lexikon',
    'Fxqaa' => 'Grönländska',
    'Fxqb' => 'Nord- och centralamerikanska indianspråk',
    'Fxqb(x)' => 'Allmänt: lexikon',
    'Fxqbm' => 'Maya',
    'Fxqbm(x)' => 'Lexikon',
    'Fxqbn' => 'Nahuatl',
    'Fxqbn(x)' => 'Lexikon',
    'Fxqc' => 'Sydamerikanska indianspråk',
    'Fxqc(x)' => 'Allmänt: lexikon',
    'Fxqcg' => 'Guarani',
    'Fxqcg(x)' => 'Lexikon',
    'Fxqcq' => 'Quechua',
    'Fxqcq(x)' => 'Lexikon',
    'Fxr' => 'Austronesiska språk',
    'Fxr(x)' => 'Allmänt: lexikon',
    'Fxra' => 'Papuanska',
    'Fxra(x)' => 'Lexikon',
    'Fxrb' => 'Indonesiska (malajiska) språk',
    'Fxrb(x)' => 'Allmänt: lexikon',
    'Fxrba' => 'Javanska',
    'Fxrbb' => 'Indonesiska (Bahasa Indonesia)',
    'Fxrbb(x)' => 'Lexikon',
    'Fxrbc' => 'Malajiska (Bahasa Malaysia)',
    'Fxrbc(x)' => 'Lexikon',
    'Fxrbd' => 'Tagalog',
    'Fxrbe' => 'Malagassiska',
    'Fxrbf' => 'Cebuano',
    'Fxrd' => 'Polynesiska språk',
    'Fxrd(x)' => 'Lexikon',
    'Fxre' => 'Melanesiska och mikronesiska språk',
    'Fxre(x)' => 'Lexikon',
    'Fxrf' => 'Australiska språk',
    'Fxrf(x)' => 'Lexikon',
    'Fxrg' => 'Tasmaniska',
    'Fxs' => 'Burushaski',
    'Fy' => 'Konstgjorda språk',
    'Fy(x)' => 'Allmänt: lexikon',
    'Fya' => 'Interlingua',
    'Fye' => 'Esperanto',
    'Fye(x)' => 'Lexikon',
    'Fyi' => 'Ido',
    'Fyi(x)' => 'Lexikon',
    'Fym' => 'Mondial',
    'Fyö' => 'Övriga konstgjorda språk',
    'Få' => 'Teckenspråk',
    'Få(x)' => 'Lexikon',
    'Fåc' => 'Svenska',
    'Fåc(x)' => 'Lexikon',
    'Fåe' => 'Engelska',
    'G' => 'Litteraturvetenskap',
    'G(x)' => 'Litteraturvetenskapliga lexikon',
    'G:b' => 'Litteraturvetenskaplig forskning, organisationer och institutioner',
    'G:bf' => 'Organisationer och institutioner',
    'G:dd' => 'Litteraturvetenskaplig metodlära',
    'G:df' => 'Litteraturestetik',
    'G:dg' => 'Litteraturkritik',
    'G:do' => 'Litteraturpsykologi',
    'G:k' => 'Litteraturvetenskapens historia',
    'G:kc' => 'Sverige',
    'G:oa' => 'Litteratursociologi',
    'G.0' => 'Särskilda litterära genrer och motiv',
    'G.01' => 'Romaner och noveller',
    'G.02' => 'Dramatik',
    'G.03' => 'Poesi',
    'G.04' => 'Essäer och litteraturkritik',
    'G.05' => 'Tecknade serier',
    'G.06' => 'Brev',
    'G.07' => 'Folkdiktning',
    'G.08' => 'Dialektlitteratur',
    'G.09' => 'Övriga litterära genrer och motiv',
    'G.092' => 'Barn- och ungdomslitteratur',
    'G.093' => 'Populärlitteratur',
    'G.096' => 'Skönlitterära motiv',
    'G.096z' => 'Särskilda skönlitterära motiv',
    'G.097' => 'Innehållsliga genrer',
    'G.0971' => 'Satir och humor',
    'G.0972' => 'Kvinnolitteratur',
    'G.0974' => 'Religiös litteratur',
    'G.0975' => 'Arbetarlitteratur',
    'G.0977' => 'Kriminallitteratur, skräck, thrillers',
    'G.0978' => 'Science fiction, utopi och fantastisk litteratur',
    'G.0979' => 'Erotisk litteratur',
    'G.' => 'Allmänt: särskilda litterära perioder',
    'G.2' => 'Forntiden',
    'G.3' => 'Medeltiden',
    'G.4' => '1500-',
    'G.41' => 'Renässansen',
    'G.42' => 'Klassicismen',
    'G.43' => 'Upplysningen',
    'G.45' => 'Förromantiken och romantiken',
    'G.46' => '1800-talet',
    'G.5' => '1900-talet',
    'G.55' => '1945-',
    'G.58' => '1980-',
    'G.59' => '1990-',
    'G.6' => '2000-',
    'Gb' => 'Germansk och nordisk litteraturhistoria: allmän',
    'Gbg' => 'Germansk litteraturhistoria: allmän',
    'Gbn' => 'Nordisk litteraturhistoria: allmän',
    'Gc' => 'Svensk litteraturhistoria',
    'Gc(x)' => 'Litteraturvetenskapliga lexikon',
    'Gc.0' => 'Särskilda litterära genrer och motiv',
    'Gc.01' => 'Romaner och noveller',
    'Gc.02' => 'Dramatik',
    'Gc.03' => 'Poesi',
    'Gc.04' => 'Essäer och litteraturkritik',
    'Gc.05' => 'Tecknade serier',
    'Gc.06' => 'Brev',
    'Gc.07' => 'Folkdiktning',
    'Gc.08' => 'Dialektlitteratur',
    'Gc.09' => 'Övriga litterära genrer och motiv',
    'Gc.092' => 'Barn- och ungdomslitteratur',
    'Gc.093' => 'Triviallitteratur',
    'Gc.096' => 'Skönlitterära motiv',
    'Gc.097' => 'Innehållsliga genrer',
    'Gc.0971' => 'Satir och humor',
    'Gc.0972' => 'Kvinnolitteratur',
    'Gc.0974' => 'Religiös litteratur',
    'Gc.0975' => 'Arbetarlitteratur',
    'Gc.0977' => 'Kriminallitteratur, skräck, thrillers',
    'Gc.0978' => 'Science fiction, utopi och fantastisk litteratur',
    'Gc.0979' => 'Erotisk litteratur',
    'Gc.' => 'Särskilda litterära perioder',
    'Gc.3' => 'Fornsvensk litteraturhistoria',
    'Gc.4' => 'Nya tiden',
    'Gc.41' => 'Reformationstiden',
    'Gc.42' => 'Stormaktstiden',
    'Gc.44' => 'Upplysningen',
    'Gc.45' => 'Gustavianska tiden',
    'Gc.46' => '1800-talet',
    'Gc.47' => 'Romantiken',
    'Gc.48' => 'Liberalismen och senromantiken',
    'Gc.49' => 'Åttiotal och nittiotal',
    'Gc.5' => '1900-talet',
    'Gc.51' => 'Tiotal',
    'Gc.52' => 'Tjugotal',
    'Gc.53' => 'Trettiotal',
    'Gc.55' => '1955-',
    'Gc.58' => '1980-',
    'Gc.59' => '1990-',
    'Gc.6' => '2000-',
    'Gcd' => 'Finlandssvensk litteraturhistoria',
    'Gcz' => 'Särskilda svenska författare',
    'Gd' => 'Övrig nordisk litteraturhistoria',
    'Gda' => 'Dansk litteraturhistoria',
    'Gdaz' => 'Särskilda danska författare',
    'Gdb' => 'Norsk litteraturhistoria',
    'Gdbn' => 'Nynorsk litteraturhistoria',
    'Gdbz' => 'Särskilda norska författare',
    'Gdc' => 'Isländsk litteraturhistoria',
    'Gdca' => 'Fornisländsk och fornnorsk litteraturhistoria',
    'Gdcaz' => 'Särskilda fornisländska författare',
    'Gdcazf' => 'Särskilda fornisländska och fornnorska anonyma verk',
    'Gdcb' => 'Nyisländsk litteraturhistoria',
    'Gdcbz' => 'Särskilda nyisländska författare',
    'Gdcf' => 'Färöisk litteraturhistoria',
    'Gdcfz' => 'Särskilda färöiska författare',
    'Ge' => 'Engelsk litteraturhistoria',
    'Ge.0' => 'Särskilda litterära genrer och motiv',
    'Ge.01' => 'Romaner och noveller',
    'Ge.02' => 'Dramatik',
    'Ge.03' => 'Poesi',
    'Ge.04' => 'Essäer och litteraturkritik',
    'Ge.05' => 'Tecknade serier',
    'Ge.06' => 'Brev',
    'Ge.07' => 'Folkdiktning',
    'Ge.09' => 'Övriga litterära genrer och motiv',
    'Ge.092' => 'Barn- och ungdomslitteratur',
    'Ge.093' => 'Triviallitteratur',
    'Ge.096' => 'Skönlitterära motiv',
    'Ge.097' => 'Innehållsliga genrer',
    'Ge.0971' => 'Satir och humor',
    'Ge.0972' => 'Kvinnolitteratur',
    'Ge.0974' => 'Religiös litteratur',
    'Ge.0975' => 'Arbetarlitteratur',
    'Ge.0977' => 'Kriminallitteratur, skräck, thrillers',
    'Ge.0978' => 'Science fiction, utopi och fantastisk litteratur',
    'Ge.0979' => 'Erotisk litteratur',
    'Ge.' => 'Särskilda litterära perioder',
    'Ge.2' => 'Forntiden',
    'Ge.3' => 'Medeltiden',
    'Ge.4' => 'Nya tiden',
    'Ge.41' => '1500-1603',
    'Ge.42' => '1603-1660',
    'Ge.44' => '1660-1800',
    'Ge.45' => '1789-1832',
    'Ge.46' => '1800-talet',
    'Ge.47' => '1832-1901',
    'Ge.5' => '1900-talet',
    'Ge.55' => '1945-',
    'Ge.58' => '1980-',
    'Ge.59' => '1990-',
    'Ge.6' => '2000-',
    'Gee' => 'Anglo-walesisk, skotsk och anglo-irisk litteraturhistoria',
    'Geer' => 'Anglo-walesisk litteraturhistoria',
    'Gees' => 'Skotsk litteraturhistoria',
    'Geet' => 'Anglo-irisk litteraturhistoria',
    'Geo' => 'Asiatisk litteraturhistoria: engelskspråkig',
    'Geoz' => 'Särskilda asiatiska författare',
    'Gep' => 'Afrikansk litteraturhistoria: engelskspråkig',
    'Gepz' => 'Särskilda afrikanska författare',
    'Geq' => 'Amerikansk litteraturhistoria',
    'Geq.0' => 'Särskilda litterära genrer och motiv',
    'Geq.01' => 'Romaner och noveller',
    'Geq.02' => 'Dramatik',
    'Geq.03' => 'Poesi',
    'Geq.04' => 'Essäer och litteraturkritik',
    'Geq.05' => 'Tecknade serier',
    'Geq.06' => 'Brev',
    'Geq.07' => 'Folkdiktning',
    'Geq.09' => 'Övriga litterära genrer och motiv',
    'Geq.092' => 'Barn- och ungdomslitteratur',
    'Geq.093' => 'Triviallitteratur',
    'Geq.096' => 'Skönlitterära motiv',
    'Geq.097' => 'Innehållsliga genrer',
    'Geq.0971' => 'Satir och humor',
    'Geq.0972' => 'Kvinnolitteratur',
    'Geq.0974' => 'Religiös litteratur',
    'Geq.0975' => 'Arbetarlitteratur',
    'Geq.0977' => 'Kriminallitteratur, skräck, thrillers',
    'Geq.0978' => 'Science fiction, utopi och fantastisk litteratur',
    'Geq.' => 'Särskilda litterära perioder',
    'Geq.4' => 'Nya tiden',
    'Geq.41' => 'Tiden före 1789',
    'Geq.44' => '1789-1865',
    'Geq.48' => '1865-1900',
    'Geq.5' => '1900-talet',
    'Geq.55' => '1945-',
    'Geq.58' => '1980-',
    'Geq.59' => '1990-',
    'Geq.6' => '2000-',
    'Geqb' => 'Anglo-kanadensisk litteraturhistoria',
    'Geqbz' => 'Särskilda kanadensiska författare',
    'Geqc' => 'Västindisk litteraturhistoria: engelskspråkig',
    'Geqz' => 'Särskilda amerikanska författare',
    'Ger' => 'Australisk litteraturhistoria',
    'Gerz' => 'Särskilda australiska författare',
    'Gez' => 'Särskilda engelska författare',
    'Gf' => 'Tysk litteraturhistoria',
    'Gf.0' => 'Särskilda litterära genrer och motiv',
    'Gf.01' => 'Romaner och noveller',
    'Gf.02' => 'Dramatik',
    'Gf.03' => 'Poesi',
    'Gf.04' => 'Essäer och litteraturkritik',
    'Gf.05' => 'Tecknade serier',
    'Gf.06' => 'Brev',
    'Gf.07' => 'Folkdiktning',
    'Gf.09' => 'Övriga litterära genrer och motiv',
    'Gf.092' => 'Barn- och ungdomslitteratur',
    'Gf.093' => 'Triviallitteratur',
    'Gf.096' => 'Skönlitterära motiv',
    'Gf.097' => 'Innehållsliga genrer',
    'Gf.0971' => 'Satir och humor',
    'Gf.0972' => 'Kvinnolitteratur',
    'Gf.0974' => 'Religiös litteratur',
    'Gf.0975' => 'Arbetarlitteratur',
    'Gf.0977' => 'Kriminallitteratur, skräck, thrillers',
    'Gf.0978' => 'Science fiction, utopi och fantastisk litteratur',
    'Gf.' => 'Särskilda litterära perioder',
    'Gf.3' => 'Medeltiden',
    'Gf.4' => 'Nya tiden',
    'Gf.41' => 'Ca 1500-1600',
    'Gf.42' => '1600-1750',
    'Gf.43' => '1750-1830',
    'Gf.46' => '1830-1880',
    'Gf.47' => '1880-1900',
    'Gf.5' => '1900-talet',
    'Gf.55' => '1945-',
    'Gf.58' => '1980-',
    'Gf.59' => '1990-',
    'Gf.6' => '2000-',
    'Gfb' => 'Österrikisk litteraturhistoria',
    'Gfbz' => 'Särskilda österrikiska författare',
    'Gfh' => 'Schweizertysk litteraturhistoria',
    'Gfl' => 'Lågtysk litteraturhistoria',
    'Gfo' => 'Litteraturhistoria: jiddisch',
    'Gfoz' => 'Särskilda författare',
    'Gfz' => 'Särskilda tyska författare',
    'Gfzf' => 'Särskilda tyska anonyma verk',
    'Gg' => 'Nederländsk litteraturhistoria',
    'Ggp' => 'Litteraturhistoria: afrikaans',
    'Ggt' => 'Frisisk litteraturhistoria',
    'Ggz' => 'Särskilda nederländska författare',
    'Gh' => 'Romansk litteraturhistoria: allmän',
    'Gha' => 'Rätoromansk litteraturhistoria',
    'Ghb' => 'Rumänsk litteraturhistoria',
    'Ghbz' => 'Särskilda rumänska författare',
    'Gi' => 'Italiensk litteraturhistoria',
    'Gi.0' => 'Särskilda litterära genrer och motiv',
    'Gi.01' => 'Romaner och noveller',
    'Gi.02' => 'Dramatik',
    'Gi.03' => 'Poesi',
    'Gi.04' => 'Essäer och litteraturkritik',
    'Gi.07' => 'Folkdiktning',
    'Gi.08' => 'Dialektlitteratur',
    'Gi.09' => 'Övriga litterära genrer och motiv',
    'Gi.' => 'Särskilda litterära perioder',
    'Gi.3' => 'Medeltiden',
    'Gi.4' => 'Nya tiden',
    'Gi.41' => '1400-1600',
    'Gi.43' => '1600-1750',
    'Gi.46' => '1750-1870',
    'Gi.47' => '1870-1900',
    'Gi.5' => '1900-talet',
    'Gi.55' => '1945-',
    'Gi.58' => '1980-',
    'Gi.59' => '1990-',
    'Gi.6' => '2000-',
    'Giz' => 'Särskilda italienska författare',
    'Gj' => 'Fransk litteraturhistoria',
    'Gj.0' => 'Särskilda litterära genrer och motiv',
    'Gj.01' => 'Romaner och noveller',
    'Gj.02' => 'Dramatik',
    'Gj.03' => 'Poesi',
    'Gj.04' => 'Essäer och litteraturkritik',
    'Gj.05' => 'Tecknade serier',
    'Gj.06' => 'Brev',
    'Gj.07' => 'Folkdiktning',
    'Gj.09' => 'Övriga litterära genrer och motiv',
    'Gj.092' => 'Barn- och ungdomslitteratur',
    'Gj.093' => 'Triviallitteratur',
    'Gj.096' => 'Skönlitterära motiv',
    'Gj.097' => 'Innehållsliga genrer',
    'Gj.' => 'Särskilda litterära perioder',
    'Gj.3' => 'Medeltiden',
    'Gj.4' => 'Nya tiden',
    'Gj.41' => '1500-talet',
    'Gj.42' => '1600-1715',
    'Gj.44' => '1715-1879',
    'Gj.45' => '1789-1815',
    'Gj.46' => '1800-talet',
    'Gj.47' => '1870-1900',
    'Gj.5' => '1900-talet',
    'Gj.55' => '1945-',
    'Gj.58' => '1980-',
    'Gj.59' => '1990-',
    'Gj.6' => '2000-',
    'Gjg' => 'Belgisk-fransk litteraturhistoria',
    'Gjgb' => 'Särskilda belgiska författare',
    'Gjh' => 'Schweizerfransk litteraturhistoria',
    'Gjp' => 'Afrikansk litteraturhistoria: franskspråkig',
    'Gjpz' => 'Särskilda afrikanska författare',
    'Gjq' => 'Fransk-amerikansk litteraturhistoria',
    'Gjqz' => 'Särskilda amerikanska författare',
    'Gjt' => 'Provensalsk litteraturhistoria',
    'Gjtz' => 'Särskilda provensalska författare',
    'Gjz' => 'Särskilda franska författare',
    'Gjzf' => 'Särskilda franska anonyma verk',
    'Gk' => 'Spansk litteraturhistoria',
    'Gk.0' => 'Särskilda litterära genrer och motiv',
    'Gk.01' => 'Romaner och noveller',
    'Gk.02' => 'Dramatik',
    'Gk.03' => 'Poesi',
    'Gk.04' => 'Essäer och litteraturkritik',
    'Gk.07' => 'Folkdiktning',
    'Gk.09' => 'Övriga litterära genrer och motiv',
    'Gk.' => 'Särskilda litterära perioder',
    'Gk.3' => 'Medeltiden',
    'Gk.4' => 'Nya tiden',
    'Gk.42' => '1500-1700',
    'Gk.43' => '1700-talet',
    'Gk.46' => '1800-talet',
    'Gk.5' => '1900-talet',
    'Gk.55' => '1945-',
    'Gk.58' => '1980-',
    'Gk.59' => '1990-',
    'Gk.6' => '2000-',
    'Gkq' => 'Spansk-amerikansk litteraturhistoria',
    'Gkqz' => 'Särskilda spansk-amerikanska författare',
    'Gku' => 'Katalansk litteraturhistoria',
    'Gkz' => 'Särskilda spanska författare',
    'Gl' => 'Portugisisk litteraturhistoria',
    'Glp' => 'Afrikansk litteraturhistoria: portugisiskspråkig',
    'Glq' => 'Brasiliansk litteraturhistoria',
    'Glqz' => 'Särskilda brasilianska författare',
    'Glz' => 'Särskilda portugisiska författare',
    'Gm' => 'Slavisk och baltisk litteraturhistoria',
    'Gma' => 'Rysk litteraturhistoria',
    'Gma.0' => 'Särskilda litterära genrer och motiv',
    'Gma.01' => 'Romaner och noveller',
    'Gma.02' => 'Dramatik',
    'Gma.03' => 'Poesi',
    'Gma.04' => 'Essäer och litteraturkritik',
    'Gma.05' => 'Tecknade serier',
    'Gma.06' => 'Brev',
    'Gma.07' => 'Folkdiktning',
    'Gma.09' => 'Övriga litterära genrer och motiv',
    'Gma.' => 'Särskilda litterära perioder',
    'Gma.3' => 'Medeltiden',
    'Gma.4' => 'Nya tiden',
    'Gma.41' => '1533-1682',
    'Gma.43' => '1682-1796',
    'Gma.46' => '1796-1881',
    'Gma.47' => '1881-1917',
    'Gma.5' => '1900-talet',
    'Gma.55' => '1945-',
    'Gma.58' => '1980-',
    'Gma.59' => '1990-',
    'Gma.6' => '2000-',
    'Gmaz' => 'Särskilda ryska författare',
    'Gmb' => 'Ukrainsk litteraturhistoria',
    'Gmbt' => 'Vitrysk litteraturhistoria',
    'Gmbz' => 'Särskilda ukrainska författare',
    'Gmc' => 'Polsk litteraturhistoria',
    'Gmcz' => 'Särskilda polska författare',
    'Gmd' => 'Tjeckisk litteraturhistoria',
    'Gmdz' => 'Särskilda tjeckiska författare',
    'Gme' => 'Slovakisk litteraturhistoria',
    'Gmet' => 'Sorbisk (vendisk) litteraturhistoria',
    'Gmez' => 'Särskilda slovakiska författare',
    'Gmf' => 'Serbisk, kroatisk och bosnisk-hercegovinsk litteraturhistoria',
    'Gmfz' => 'Särskilda serbiska etc författare',
    'Gmg' => 'Slovensk litteraturhistoria',
    'Gmh' => 'Bulgarisk litteraturhistoria',
    'Gmhz' => 'Särskilda bulgariska författare',
    'Gmi' => 'Fornkyrkslavisk litteraturhistoria',
    'Gmj' => 'Makedonsk litteraturhistoria',
    'Gmk' => 'Baltisk litteraturhistoria',
    'Gmka' => 'Litauisk litteraturhistoria',
    'Gmkaz' => 'Särskilda litauiska författare',
    'Gmkb' => 'Lettisk litteraturhistoria',
    'Gmkbz' => 'Särskilda lettiska författare',
    'Gn' => 'Keltisk litteraturhistoria',
    'Gnba' => 'Irisk litteraturhistoria',
    'Gnbb' => 'Skotsk-gaelisk litteraturhistoria',
    'Gnca' => 'Kymrisk litteraturhistoria',
    'Gncc' => 'Bretonsk litteraturhistoria',
    'Go' => 'Grekisk och latinsk litteraturhistoria',
    'Goa' => 'Grekisk litteraturhistoria',
    'Goam' => 'Bysantinsk litteraturhistoria',
    'Goaz' => 'Särskilda grekiska författare',
    'Gob' => 'Nygrekisk litteraturhistoria',
    'Gobz' => 'Särskilda nygrekiska författare',
    'Goc' => 'Latinsk litteraturhistoria',
    'Gocm' => 'Medeltids- och nylatinsk litteraturhistoria',
    'Gocmz' => 'Särskilda författare',
    'Gocz' => 'Särskilda latinska författare',
    'Gp' => 'Indo-arisk litteraturhistoria',
    'Gpa' => 'Sanskritlitteraturens historia',
    'Gpaz' => 'Särskilda författare och anonyma verk',
    'Gpd' => 'Nyindisk litteraturhistoria',
    'Gpda' => 'Litteraturhistoria: hindi',
    'Gpdb' => 'Litteraturhistoria: urdu',
    'Gq' => 'Iransk litteraturhistoria',
    'Gqc' => 'Litteraturhistoria: nyiranska språk',
    'Gqca' => 'Nypersisk litteraturhistoria',
    'Gqcaz' => 'Särskilda nypersiska författare',
    'Gqcc' => 'Kurdisk litteraturhistoria',
    'Gr' => 'Övrig indoeuropeisk litteraturhistoria',
    'Grb' => 'Armenisk litteraturhistoria',
    'Grf' => 'Albansk litteraturhistoria',
    'Gs' => 'Semitisk litteraturhistoria',
    'Gsd' => 'Hebreisk litteraturhistoria',
    'Gsdz' => 'Särskilda heberiska författare',
    'Gse' => 'Arameisk och syrisk litteraturhistoria',
    'Gsg' => 'Arabisk litteraturhistoria',
    'Gsgz' => 'Särskilda arabiska författare',
    'Gsgzf' => 'Särskilda arabiska anonyma verk',
    'Gsi' => 'Etiopisk litteraturhistoria',
    'Gt' => 'Litteraturhistoria: hamitiska språk och tchadspråk',
    'Gu' => 'Finsk-ugrisk och altaisk litteraturhistoria',
    'Gub' => 'Finsk och tornedalsfinsk litteraturhistoria',
    'Gubz' => 'Särskilda finska författare',
    'Guc' => 'Estnisk litteraturhistoria',
    'Gucz' => 'Särskilda estniska författare',
    'Gue' => 'Samisk litteraturhistoria',
    'Guk' => 'Ungersk litteraturhistoria',
    'Gukz' => 'Särskilda ungerska författare',
    'Gut' => 'Litteraturhistoria: turkiska språk',
    'Gutt' => 'Turkisk litteraturhistoria',
    'Guttz' => 'Särskilda turkiska författare',
    'Guu' => 'Litteraturhistoria: mongoliska språk',
    'Gv' => 'Litteraturhistoria: sino-tibetanska och austroasiatiska språk',
    'Gva' => 'Kinesisk litteraturhistoria',
    'Gvaz' => 'Särskilda kinesiska författare',
    'Gvb' => 'Litteraturhistoria: taispråk',
    'Gvc' => 'Litteraturhistoria: tibeto-burmanska språk',
    'Gvd' => 'Litteraturhistoria: austroasiatiska språk',
    'Gve' => 'Litteraturhistoria: viet-muongspråk',
    'Gx' => 'Övrig litteraturhistoria',
    'Gxf' => 'Baskisk litteraturhistoria',
    'Gxh' => 'Litteraturhistoria: kaukasiska språk',
    'Gxj' => 'Japansk litteraturhistoria',
    'Gxjz' => 'Särskilda japanska författare',
    'Gxk' => 'Koreansk litteraturhistoria',
    'Gxo' => 'Dravidisk litteraturhistoria',
    'Gxp' => 'Litteraturhistoria: afrikanska språk',
    'Gxq' => 'Litteraturhistoria: amerikanska språk',
    'Gxr' => 'Litteraturhistoria: austronesiska språk',
    'Gxrb' => 'Litteraturhistoria: indonesiska (malajiska) språk',
    'Gz' => 'Särskilda utländska författare',
    'H' => 'Skönlitteratur',
    'H.07' => 'Folkdiktning: allmänt',
    'Hbn' => 'Nordisk skönlitteratur: samlingar',
    'Hc' => 'Svensk skönlitteratur',
    'Hc(s)' => 'Samlingar',
    'Hc.0' => 'Särskilda skönlitterära genrer',
    'Hc.01' => 'Romaner och noveller',
    'Hc.016' => 'Noveller',
    'Hc.017' => 'Kåserier',
    'Hc.018' => 'Aforismer',
    'Hc.02' => 'Dramatik',
    'Hc.025' => 'Film- och televisionsscenarier',
    'Hc.027' => 'Sketcher och monologer',
    'Hc.03' => 'Poesi',
    'Hc.04' => 'Essäer',
    'Hc.07' => 'Folkdiktning',
    'Hc.07c' => 'Sverige',
    'Hc.07ca' => 'Svealand',
    'Hc.07cb' => 'Götaland',
    'Hc.07cc' => 'Norrland',
    'Hc.08' => 'Dialektlitteratur',
    'Hc.08c' => 'Sverige',
    'Hc.08ca' => 'Svealand',
    'Hc.08cb' => 'Götaland',
    'Hc.08cc' => 'Norrland',
    'Hca' => 'Fornsvensk litteratur',
    'Hcc' => 'Svensk skönlitteratur på främmande språk',
    'Hccd' => 'Övriga nordiska språk',
    'Hccda' => 'Danska',
    'Hccdb' => 'Norska',
    'Hccdc' => 'Isländska och färöiska',
    'Hcce' => 'Engelska',
    'Hccf' => 'Tyska och jiddisch',
    'Hccg' => 'Nederländska',
    'Hcch' => 'Rätormanska, rumänska och dalmatiska',
    'Hcci' => 'Italienska',
    'Hccj' => 'Franska',
    'Hcck' => 'Spanska',
    'Hccl' => 'Portugisiska',
    'Hccm' => 'Slaviska och baltiska språk',
    'Hccma' => 'Ryska',
    'Hccmc' => 'Polska',
    'Hccmd' => 'Tjeckiska',
    'Hccme' => 'Slovakiska',
    'Hccmf' => 'Serbiska, kroatiska och bosnisk-hercegovinska',
    'Hccmg' => 'Slovenska',
    'Hccmh' => 'Bulgariska',
    'Hccmk' => 'Baltiska språk',
    'Hccn' => 'Keltiska språk',
    'Hccob' => 'Grekiska',
    'Hccp' => 'Indo-ariska språk',
    'Hccq' => 'Iranska språk',
    'Hccr' => 'Övriga indoeuropeiska språk',
    'Hccs' => 'Semitiska språk',
    'Hccsd' => 'Hebreiska',
    'Hccsg' => 'Arabiska',
    'Hccu' => 'Finsk-ugriska och altaiska språk',
    'Hccub' => 'Finska och tornedalsfinska',
    'Hccuc' => 'Estniska',
    'Hccue' => 'Samiska språk',
    'Hccuk' => 'Ungerska',
    'Hccut' => 'Turkiska språk',
    'Hccv' => 'Sino-tibetanska och austroasiatiska språk',
    'Hccva' => 'Kinesiska',
    'Hccx' => 'Övriga språk',
    'Hccxf' => 'Baskiska',
    'Hccxj' => 'Japanska',
    'Hccxk' => 'Koreanska',
    'Hcd' => 'Finlandssvensk skönlitteratur',
    'Hce' => 'Utländsk skönlitteratur i svensk översättning',
    'Hced' => 'Övriga nordiska språk',
    'Hceda' => 'Danska',
    'Hcedb' => 'Norska',
    'Hcedc' => 'Isländska och färöiska',
    'Hcee' => 'Engelska',
    'Hcef' => 'Tyska och jiddisch',
    'Hceg' => 'Nederländska',
    'Hceh' => 'Rätormanska, rumänska och dalmatiska',
    'Hcei' => 'Italienska',
    'Hcej' => 'Franska',
    'Hcek' => 'Spanska',
    'Hcel' => 'Portugisiska',
    'Hcem' => 'Slaviska och baltiska språk',
    'Hcema' => 'Ryska',
    'Hcemc' => 'Polska',
    'Hcemd' => 'Tjeckiska',
    'Hceme' => 'Slovakiska',
    'Hcemf' => 'Serbiska, kroatiska och bosnisk-hercegovinska',
    'Hcemg' => 'Slovenska',
    'Hcemh' => 'Bulgariska',
    'Hcemk' => 'Baltiska språk',
    'Hcen' => 'Keltiska språk',
    'Hceo' => 'Grekiska och latin',
    'Hceoa' => 'Grekiska',
    'Hceob' => 'Nygrekiska',
    'Hceoc' => 'Latin',
    'Hcep' => 'Indo-ariska språk',
    'Hceq' => 'Iranska språk',
    'Hcer' => 'Övriga indoeuropeiska språk',
    'Hces' => 'Semitiska språk',
    'Hcesd' => 'Hebreiska',
    'Hcesg' => 'Arabiska',
    'Hceu' => 'Finsk-ugriska och altaiska språk',
    'Hceub' => 'Finska och tornedalsfinska',
    'Hceuc' => 'Estniska',
    'Hceue' => 'Samiska språk',
    'Hceuk' => 'Ungerska',
    'Hceut' => 'Turkiska språk',
    'Hcev' => 'Sino-tibetanska och austroasiatiska språk',
    'Hceva' => 'Kinesiska',
    'Hcex' => 'Övriga språk',
    'Hcexf' => 'Baskiska',
    'Hcexj' => 'Japanska',
    'Hcf' => 'Småbarnsberättelser och sagor',
    'Hcf(y)' => 'Bilderböcker',
    'Hcg' => 'Skönlitteratur för mellanåldern',
    'Hci' => 'Tecknade serier',
    'Hcq' => 'Svensk-amerikansk skönlitteratur',
    'Hd' => 'Övrig nordisk skönlitteratur',
    'Hda' => 'Dansk skönlitteratur',
    'Hda.0' => 'Särskilda skönlitterära genrer',
    'Hda.01' => 'Romaner och noveller',
    'Hda.016' => 'Noveller',
    'Hda.017' => 'Kåserier',
    'Hda.02' => 'Dramatik',
    'Hda.03' => 'Poesi',
    'Hda.04' => 'Essäer',
    'Hda.05' => 'Tecknade serier',
    'Hda.07' => 'Folkdiktning',
    'Hda.08' => 'Dialektlitteratur',
    'Hdaa' => 'Forndansk litteratur',
    'Hdb' => 'Norsk skönlitteratur',
    'Hdb.0' => 'Särskilda skönlitterära genrer',
    'Hdb.01' => 'Romaner och noveller',
    'Hdb.016' => 'Noveller',
    'Hdb.017' => 'Kåserier',
    'Hdb.02' => 'Dramatik',
    'Hdb.03' => 'Poesi',
    'Hdb.04' => 'Essäer',
    'Hdb.07' => 'Folkdiktning',
    'Hdb.08' => 'Dialektlitteratur',
    'Hdbn' => 'Nynorsk skönlitteratur',
    'Hdc' => 'Isländsk skönlitteratur',
    'Hdca' => 'Fornisländsk och fornnorsk littaratur',
    'Hdcb' => 'Nyisländsk skönlitteratur',
    'Hdcf' => 'Färöisk skönlitteratur',
    'He' => 'Engelsk skönlitteratur',
    'He.0' => 'Särskilda skönlitterära genrer',
    'He.01' => 'Romaner och noveller',
    'He.016' => 'Noveller',
    'He.017' => 'Kåserier',
    'He.018' => 'Aforismer',
    'He.02' => 'Dramatik',
    'He.03' => 'Poesi',
    'He.04' => 'Essäer',
    'He.05' => 'Tecknade serier',
    'He.07' => 'Folkdiktning',
    'He.08' => 'Dialektlitteratur',
    'Hea' => 'Fornengelsk litteratur',
    'Heb' => 'Medelengelsk litteratur',
    'Heo' => 'Asiatisk skönlitteratur: engelskspråkig',
    'Hep' => 'Afrikansk skönlitteratur: engelskspråkig',
    'Heq' => 'Amerikansk skönlitteratur',
    'Her' => 'Australisk skönlitteratur',
    'Hf' => 'Tysk skönlitteratur',
    'Hf.0' => 'Särskilda skönlitterära genrer',
    'Hf.01' => 'Romaner och noveller',
    'Hf.016' => 'Noveller',
    'Hf.017' => 'Kåserier',
    'Hf.018' => 'Aforismer',
    'Hf.02' => 'Dramatik',
    'Hf.03' => 'Poesi',
    'Hf.04' => 'Essäer',
    'Hf.05' => 'Tecknade serier',
    'Hf.07' => 'Folkdiktning',
    'Hf.08' => 'Dialektlitteratur',
    'Hfa' => 'Fornhögtysk litteratur',
    'Hfb' => 'Medelhögtysk litteratur',
    'Hfl' => 'Lågtysk skönlitteratur',
    'Hfla' => 'Fornlågtysk litteratur',
    'Hflb' => 'Medellågtysk litteratur',
    'Hfo' => 'Skönlitteratur på jiddisch',
    'Hg' => 'Nederländsk skönlitteratur',
    'Hgb' => 'Medelnederländsk litteratur',
    'Hgp' => 'Skönlitteratur på afrikaans',
    'Hgt' => 'Frisisk skönlitteratur',
    'Hgta' => 'Fornfrisisk litteratur',
    'Hh' => 'Romansk skönlitteratur',
    'Hha' => 'Rätoromansk skönlitteratur',
    'Hhb' => 'Rumänsk skönlitteratur',
    'Hi' => 'Italiensk skönlitteratur',
    'Hi.0' => 'Särskilda skönlitterära genrer',
    'Hi.01' => 'Romaner och noveller',
    'Hi.016' => 'Noveller',
    'Hi.02' => 'Dramatik',
    'Hi.03' => 'Poesi',
    'Hi.04' => 'Essäer',
    'Hi.07' => 'Folkdiktning',
    'Hi.08' => 'Dialektlitteratur',
    'Hia' => 'Fornitaliensk litteratur',
    'Hj' => 'Fransk skönlitteratur',
    'Hj.0' => 'Särskilda skönlitterära genrer',
    'Hj.01' => 'Romaner och noveller',
    'Hj.016' => 'Noveller',
    'Hj.017' => 'Kåserier',
    'Hj.018' => 'Aforismer',
    'Hj.02' => 'Dramatik',
    'Hj.03' => 'Poesi',
    'Hj.04' => 'Essäer',
    'Hj.05' => 'Tecknade serier',
    'Hj.07' => 'Folkdiktning',
    'Hj.08' => 'Dialektlitteratur',
    'Hja' => 'Fornfransk litteratur',
    'Hjb' => 'Medelfransk litteratur',
    'Hjp' => 'Afrikansk skönlitteratur: franskspråkig',
    'Hjq' => 'Fransk-amerikansk skönlitteratur',
    'Hjt' => 'Provensalsk skönlitteratur',
    'Hk' => 'Spansk skönlitteratur',
    'Hk.0' => 'Särskilda skönlitterära genrer',
    'Hk.01' => 'Romaner och noveller',
    'Hk.016' => 'Noveller',
    'Hk.02' => 'Dramatik',
    'Hk.03' => 'Poesi',
    'Hk.04' => 'Essäer',
    'Hk.07' => 'Folkdiktning',
    'Hk.08' => 'Dialektlitteratur',
    'Hka' => 'Fornspansk litteratur',
    'Hkb' => 'Medelspansk litteratur',
    'Hkq' => 'Spanskamerikansk skönlitteratur',
    'Hku' => 'Katalansk skönlitteratur',
    'Hl' => 'Portugisisk skönlitteratur',
    'Hla' => 'Fornportugisisk litteratur',
    'Hlb' => 'Medelportugisisk litteratur',
    'Hlp' => 'Afrikansk skönlitteratur: portugisiskspråkig',
    'Hlq' => 'Brasiliansk skönlitteratur',
    'Hlt' => 'Galicisk skönlitteratur',
    'Hm' => 'Slavisk och baltisk skönlitteratur',
    'Hma' => 'Rysk skönlitteratur',
    'Hma.0' => 'Särskilda skönlitterära genrer',
    'Hma.01' => 'Romaner och noveller',
    'Hma.016' => 'Noveller',
    'Hma.017' => 'Kåserier',
    'Hma.018' => 'Aforismer',
    'Hma.02' => 'Dramatik',
    'Hma.03' => 'Poesi',
    'Hma.04' => 'Essäer',
    'Hma.07' => 'Folkdiktning',
    'Hmaa' => 'Fornrysk litteratur',
    'Hmb' => 'Ukrainsk skönlitteratur',
    'Hmbt' => 'Vitrysk skönlitteratur',
    'Hmc' => 'Polsk skönlitteratur',
    'Hmc.0' => 'Särskilda skönlitterära genrer',
    'Hmc.01' => 'Romaner och noveller',
    'Hmc.016' => 'Noveller',
    'Hmc.017' => 'Kåserier',
    'Hmc.018' => 'Aforismer',
    'Hmc.02' => 'Dramatik',
    'Hmc.03' => 'Poesi',
    'Hmc.04' => 'Essäer',
    'Hmc.07' => 'Folkdiktning',
    'Hmca' => 'Fornpolsk litteratur',
    'Hmd' => 'Tjeckisk skönlitteratur',
    'Hmda' => 'Forntjeckisk litteratur',
    'Hme' => 'Slovakisk skönlitteratur',
    'Hmet' => 'Sorbisk skönlitteratur',
    'Hmf' => 'Serbisk, kroatisk och bosnisk-hercegovinsk skönlitteratur',
    'Hmg' => 'Slovensk skönlitteratur',
    'Hmh' => 'Bulgarisk skönlitteratur',
    'Hmi' => 'Fornkyrkslavisk litteratur',
    'Hmj' => 'Makedonsk skönlitteratur',
    'Hmk' => 'Baltisk skönlitteratur',
    'Hmka' => 'Litauisk skönlitteratur',
    'Hmkb' => 'Lettisk skönlitteratur',
    'Hn' => 'Keltisk skönlitteratur',
    'Hnba' => 'Irisk skönlitteratur',
    'Hnbb' => 'Skotsk-gaelisk skönlitteratur',
    'Hnca' => 'Kymrisk skönlitteratur',
    'Hncc' => 'Bretonsk skönlitteratur',
    'Ho' => 'Grekisk och latinsk litteratur',
    'Hoa' => 'Grekisk litteratur',
    'Hoa.0' => 'Särskilda skönlitterära genrer',
    'Hoa.02' => 'Dramatik',
    'Hoa.03' => 'Poesi',
    'Hoa.07' => 'Folkdiktning',
    'Hoam' => 'Bysantinsk litteratur',
    'Hob' => 'Nygrekisk skönlitteratur',
    'Hoc' => 'Latinsk litteratur',
    'Hoc.0' => 'Särskilda skönlitterära genrer',
    'Hoc.02' => 'Dramatik',
    'Hoc.07' => 'Folkdiktning',
    'Hocm' => 'Medeltidslatinsk litteratur',
    'Hocn' => 'Nylatinsk litteratur',
    'Hp' => 'Indisk litteratur',
    'Hpa' => 'Litteratur på sanskrit',
    'Hpb' => 'Medelindisk litteratur',
    'Hpba' => 'Litteratur på pali',
    'Hpbb' => 'Litteratur på prakrit',
    'Hpd' => 'Nyindisk skönlitteratur',
    'Hpda' => 'Skönlitteratur på hindi',
    'Hpdb' => 'Skönlitteratur på urdu',
    'Hpdc' => 'Skönlitteratur på bengali',
    'Hpdd' => 'Skönlitteratur på marathi',
    'Hpde' => 'Skönlitteratur på gujarati',
    'Hpdf' => 'Skönlitteratur på panjabi',
    'Hpdh' => 'Skönlitteratur på oriya',
    'Hpr' => 'Skönlitteratur på romani',
    'Hq' => 'Iransk litteratur',
    'Hqa' => 'Forniransk litteratur',
    'Hqb' => 'Medeliransk litteratur',
    'Hqc' => 'Nyiransk skönlitteratur',
    'Hqca' => 'Nypersisk skönlitteratur',
    'Hqcb' => 'Tadzjikisk skönlitteratur',
    'Hqcc' => 'Kurdisk skönlitteratur',
    'Hqcd' => 'Skönlitteratur på pashto',
    'Hr' => 'Övrig indoeuropeisk litteratur',
    'Hrb' => 'Armenisk skönlitteratur',
    'Hrf' => 'Albansk skönlitteratur',
    'Hs' => 'Semitisk litteratur',
    'Hsd' => 'Hebreisk litteratur',
    'Hse' => 'Arameisk litteratur',
    'Hses' => 'Litteratur på syriska',
    'Hsg' => 'Arabisk skönlitteratur',
    'Hsg.0' => 'Särskilda skönlitterära genrer',
    'Hsg.01' => 'Romaner och noveller',
    'Hsg.016' => 'Noveller',
    'Hsg.017' => 'Kåserier',
    'Hsg.018' => 'Aforismer',
    'Hsg.02' => 'Dramatik',
    'Hsg.03' => 'Poesi',
    'Hsg.04' => 'Essäer',
    'Hsg.05' => 'Tecknade serier',
    'Hsg.07' => 'Folkdiktning',
    'Hsg.08' => 'Dialektlitteratur',
    'Hsgm' => 'Maltesisk skönlitteratur',
    'Hsh' => 'Sydarabisk skönlitteratur',
    'Hsi' => 'Etiopisk litteratur',
    'Hsia' => 'Litteratur på ge&#039;ez (fornetiopiska)',
    'Hsic' => 'Skönlitteratur på tigrinja',
    'Hsie' => 'Amharisk skönlitteratur',
    'Ht' => 'Litteratur på hamitiska språk och tchadspråk',
    'Hta' => 'Litteratur på egyptiska',
    'Htab' => 'Litteratur på koptiska',
    'Htb' => 'Skönlitteratur på libysk-berbiska språk',
    'Htc' => 'Skönlitteratur på kusjitiska språk',
    'Htd' => 'Skönlitteratur på tchadspråk',
    'Hu' => 'Finsk-ugrisk och altaisk skönlitteratur',
    'Hub' => 'Finsk och tornedalsfinsk skönlitteratur',
    'Hub.0' => 'Särskilda skönlitterära genrer',
    'Hub.01' => 'Romaner och noveller',
    'Hub.016' => 'Noveller',
    'Hub.017' => 'Kåserier',
    'Hub.018' => 'Aforismer',
    'Hub.02' => 'Dramatik',
    'Hub.03' => 'Poesi',
    'Hub.04' => 'Essäer',
    'Hub.05' => 'Tecknade serier',
    'Hub.07' => 'Folkdiktning',
    'Hub.08' => 'Dialektlitteratur',
    'Huc' => 'Estnisk skönlitteratur',
    'Hue' => 'Samisk skönlitteratur',
    'Huea' => 'Nordsamisk skönlitteratur',
    'hueal' => 'Lulesamisk skönlitteratur',
    'Hueb' => 'Sydsamisk skönlitteratur',
    'Huec' => 'Östsamisk skönlitteratur',
    'Huk' => 'Ungersk skönlitteratur',
    'Hun' => 'Samojedisk skönlitteratur',
    'Hut' => 'Skönlitteratur på turkiska språk',
    'Huta' => 'Azerbajdzjansk skönlitteratur',
    'Hutk' => 'Kazakisk skönlitteratur',
    'Hutl' => 'Kirgisisk skönlitteratur',
    'Hutn' => 'Tatarisk skönlitteratur',
    'Hutt' => 'Turkisk skönlitteratur',
    'Hutu' => 'Uigurisk skönlitteratur',
    'Hutv' => 'Uzbekisk skönlitteratur',
    'Huu' => 'Skönlitteratur på mongoliska språk',
    'Huv' => 'Tungusisk skönlitteratur',
    'Hv' => 'Skönlitteratur på sinotibetanska och austroasiatiska m.fl. språk',
    'Hva' => 'Kinesisk skönlitteratur',
    'Hvb' => 'Skönlitteratur på taispråk',
    'Hvc' => 'Skönlitteratur på tibeto-burmanska språk',
    'Hvca' => 'Burmansk skönlitteratur',
    'Hvcb' => 'Tibetansk skönlitteratur',
    'Hvd' => 'Skönlitteratur på austroasiatiska språk',
    'Hve' => 'Skönlitteratur på viet-muongspråk',
    'Hvea' => 'Vietnamesisk skönlitteratur',
    'Hvg' => 'Skönlitteratur på hmong-mienspråk',
    'Hx' => 'Övrig skönlitteratur',
    'Hxf' => 'Baskisk skönlitteratur',
    'Hxh' => 'Skönlitteratur på kaukasiska språk',
    'Hxha' => 'Georgisk skönlitteratur',
    'Hxj' => 'Japansk skönlitteratur',
    'Hxk' => 'Koreansk skönlitteratur',
    'Hxo' => 'Skönlitteratur på dravidiska språk',
    'Hxoa' => 'Skönlitteratur på tamil',
    'Hxoc' => 'Skönlitteratur på kanaresiska',
    'Hxod' => 'Skönlitteratur på malayalam',
    'Hxp' => 'Skönlitteratur på afrikanska språk',
    'Hxpb' => 'Skönlitteratur på niger-kongospråk',
    'Hxpc' => 'Skönlitteratur på bantuspråk',
    'Hxpca' => 'Skönlitteratur på Swahili',
    'Hxpd' => 'Skönlitteratur på Chari-Nilspråk',
    'Hxq' => 'Skönlitteratur på amerikanska språk',
    'Hxqa' => 'Skönlitteratur på eskimåspråk',
    'Hxqaa' => 'Grönländsk skönlitteratur',
    'Hxqb' => 'Skönlitteratur på nord- och centralamerikanska indianspråk',
    'Hxqc' => 'Skönlitteratur på sydamerikanska indianspråk',
    'Hxr' => 'Skönlitteratur på austronesiska språk',
    'Hxrb' => 'Skönlitteratur på indonesiska språk',
    'Hxrba' => 'Javansk skönlitteratur',
    'Hxrbb' => 'Indonesisk skönlitteratur',
    'Hxrbc' => 'Malajisk skönlitteratur',
    'Hxrd' => 'Skönlitteratur på polynesiska språk',
    'Hxre' => 'Skönlitteratur på melanesiska och mikronesiska språk',
    'Hxrf' => 'Skönlitteratur på australiska språk',
    'Hy' => 'Skönlitteratur på konstgjorda språk',
    'Hå' => 'Skönlitteratur på teckenspråk',
    'I' => 'Konst, musik, teater, film, fotokonst',
    'Ia' => 'Konst: allmänt',
    'Ia:bf' => 'Konstinstitutioner',
    'Ia:do' => 'Konstpsykologi',
    'Ia:k' => 'Vetenskapshistoria',
    'Ia:oa' => 'Konstsociologi',
    'Iaa' => 'Konstteori och -estetik',
    'Iaaf' => 'Färglära',
    'Iab' => 'Stillära',
    'Ib' => 'Konsthistoria',
    'Ib:bf' => 'Konsthistoriska organisationer och institutioner',
    'Ib:k' => 'Vetenskapshistoria',
    'Ib.' => 'Särskilda konsthistoriska perioder',
    'Ib.2' => 'Forntidens konst',
    'Ib.21' => 'Egypten',
    'Ib.22' => 'Främre Asien',
    'Ib.221' => 'Mesopotamien',
    'Ib.223' => 'Syrien, Fenicien och Palestina',
    'Ib.224' => 'Kartago',
    'Ib.226' => 'Mindre Asien',
    'Ib.228' => 'Persien',
    'Ib.23' => 'Antikens konst: allmänt',
    'Ib.24' => 'Grekisk konst',
    'Ib.25' => 'Etruskisk konst',
    'Ib.26' => 'Romersk konst',
    'Ib.3' => 'Medeltidens konst',
    'Ib.31' => 'Fornkristen och bysantinsk konst',
    'Ib.311' => 'Fornkristen konst (till ca 550)',
    'Ib.312' => 'Bysantinsk konst',
    'Ib.33' => 'Karolingisk och ottonsk konst',
    'Ib.35' => 'Romansk konst (ca 1000 - 1150)',
    'Ib.37' => 'Gotisk konst (ca 1150 - 1420)',
    'Ib.4' => 'Nya tiden',
    'Ib.41' => 'Renässansen (ca 1420 - 1580)',
    'Ib.42' => 'Manierismen (ca 1520 - 1600)',
    'Ib.43' => 'Barocken (ca 1580 - 1725)',
    'Ib.45' => 'Rokokon (ca 1725 - 1760)',
    'Ib.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Ib.47' => '1800-talet',
    'Ib.48' => 'Jugend (ca 1896 - 1910)',
    'Ib.5' => '1905-',
    'Ib.55' => '1945-',
    'Ib.58' => '1980-',
    'Ib.59' => '1990-',
    'Ib.6' => '2000-',
    'Ib-' => 'Särskilda länder och områden',
    'Ib-a' => 'Europa: allmänt',
    'Ib-b' => 'Norden: allmänt',
    'Ib-c' => 'Sverige',
    'Ib-c:bf' => 'Organisationer och institutioner',
    'Ib-cs' => 'Samer',
    'Ib-cz' => 'Särskilda orters konst',
    'Ib-d' => 'Övriga Norden',
    'Ib-da' => 'Danmark',
    'Ib-db' => 'Norge',
    'Ib-dc' => 'Island och Färöarna',
    'Ib-dd' => 'Finland',
    'Ib-e' => 'Brittiska öarna (Storbritannien)',
    'Ib-f' => 'Mellaneuropa',
    'Ib-fa' => 'Tyskland',
    'Ib-fb' => 'Österrike och Liechtenstein',
    'Ib-fc' => 'Ungern',
    'Ib-fd' => 'Tjeckien och Slovakien',
    'Ib-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ib-h' => 'Schweiz',
    'Ib-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ib-j' => 'Frankrike och Monaco',
    'Ib-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ib-l' => 'Portugal',
    'Ib-m' => 'Östeuropa',
    'Ib-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ib-mb' => 'Polen',
    'Ib-mc' => 'Estland, Lettland, Litauen',
    'Ib-n' => 'Balkanländerna',
    'Ib-na' => 'Rumänien',
    'Ib-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ib-nc' => 'Bulgarien',
    'Ib-nd' => 'Grekland',
    'Ib-o' => 'Asien',
    'Ib-oa' => 'Främre Asien',
    'Ib-oafh' => 'Judar',
    'Ib-ob' => 'Främre Indien',
    'Ib-oc' => 'Bortre Indien',
    'Ib-od' => 'Ostindiska öarna',
    'Ib-oe' => 'Östasien',
    'Ib-oea' => 'Kina',
    'Ib-oeb' => 'Korea',
    'Ib-oec' => 'Japan',
    'Ib-of' => 'Centralasien',
    'Ib-og' => 'Sibirien',
    'Ib-p' => 'Afrika',
    'Ib-pa' => 'Nordafrika utom Egypten',
    'Ib-pb' => 'Egypten och Sudan',
    'Ib-pc' => 'Västafrika',
    'Ib-pd' => 'Centralafrika',
    'Ib-pe' => 'Södra Afrika',
    'Ib-pf' => 'Östafrika',
    'Ib-pg' => 'Nordöstafrika',
    'Ib-q' => 'Amerika',
    'Ib-qa' => 'Förenta staterna',
    'Ib-qb' => 'Kanada',
    'Ib-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ib-qd' => 'Sydamerika',
    'Ib-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ib-s' => 'Polarländerna',
    'Ibh' => 'Otraditionella konstformer',
    'Ibt' => 'Kyrklig konst',
    'Ibu' => 'Folkkonst',
    'Ibu-' => 'Särskilda länder och områden',
    'Ibu-a' => 'Europa: allmänt',
    'Ibu-b' => 'Norden: allmänt',
    'Ibu-c' => 'Sverige',
    'Ibu-d' => 'Övriga Norden',
    'Ibu-f' => 'Mellaneuropa',
    'Ibu-h' => 'Schweiz',
    'Ibu-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ibu-j' => 'Frankrike och Monaco',
    'Ibu-m' => 'Östeuropa',
    'Ibu-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ibu-mb' => 'Polen',
    'Ibu-mc' => 'Estland, Lettland, Litauen',
    'Ibu-n' => 'Balkanländerna',
    'Ibu-o' => 'Asien',
    'Ibu-p' => 'Afrika',
    'Ibu-q' => 'Amerika',
    'Ibu-qa' => 'Förenta staterna',
    'Ibu-qb' => 'Kanada',
    'Ibu-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ibu-qd' => 'Sydamerika',
    'Ibu-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ibu-ra' => 'Australien',
    'Ibu-rb' => 'Nya Zeeland',
    'Ibu-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ibu-rd' => 'Nya Guinea',
    'Ibu-s' => 'Polarländerna',
    'Ibv' => 'Ikonografi',
    'Ibvz' => 'Särskilda motiv i konsten',
    'Ibz' => 'Särskilda konstnärer',
    'Ic' => 'Arkitektur',
    'Ic:bf' => 'Arkitekturorganisationer och -institutioner',
    'Ic:d' => 'Arkitekturteori och -psykologi',
    'Ic:do' => 'Arkitekturpsykologi',
    'Ic:k' => 'Vetenskapshistoria',
    'Ic.' => 'Särskilda perioder',
    'Ic.2' => 'Forntidens arkitektur',
    'Ic.21' => 'Egypten',
    'Ic.22' => 'Främre Asien',
    'Ic.23' => 'Antikens arkitektur: allmänt',
    'Ic.24' => 'Grekisk arkitektur',
    'Ic.25' => 'Etruskisk arkitektur',
    'Ic.26' => 'Romersk arkitektur',
    'Ic.3' => 'Medeltidens arkitektur',
    'Ic.31' => 'Fornkristen och bysantinsk arkitektur',
    'Ic.311' => 'Fornkristen arkitektur (till ca 550)',
    'Ic.312' => 'Bysantinsk arkitektur',
    'Ic.33' => 'Karolingisk och ottonsk arkitektur',
    'Ic.35' => 'Romansk arkitektur (ca 1000 - 1150)',
    'Ic.37' => 'Gotisk arkitektur (ca 1150 - 1420)',
    'Ic.4' => 'Nya tiden',
    'Ic.41' => 'Renässansen (ca 1420 - 1580)',
    'Ic.43' => 'Barocken (ca 1580 - 1725)',
    'Ic.45' => 'Rokokon (ca 1725 - 1760)',
    'Ic.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Ic.47' => '1800-talet',
    'Ic.48' => 'Jugend (ca 1896 - 1910)',
    'Ic.5' => '1905-',
    'Ic.55' => '1945-',
    'Ic.58' => '1980-',
    'Ic.59' => '1990-',
    'Ic.6' => '2000-',
    'Ic-' => 'Särskilda länder och områden',
    'Ic-a' => 'Europa: allmänt',
    'Ic-b' => 'Norden: allmänt',
    'Ic-c' => 'Sverige',
    'Ic-c:bf' => 'Organisationer och institutioner',
    'Ic-cs' => 'Samer',
    'Ic-cz' => 'Särskilda byggnader och särskilda orters arkitektur',
    'Ic-d' => 'Övriga Norden',
    'Ic-da' => 'Danmark',
    'Ic-db' => 'Norge',
    'Ic-dc' => 'Island och Färöarna',
    'Ic-dd' => 'Finland',
    'Ic-e' => 'Brittiska öarna (Storbritannien)',
    'Ic-f' => 'Mellaneuropa',
    'Ic-fa' => 'Tyskland',
    'Ic-fb' => 'Österrike och Liechtenstein',
    'Ic-fc' => 'Ungern',
    'Ic-fd' => 'Tjeckien och Slovakien',
    'Ic-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ic-h' => 'Schweiz',
    'Ic-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ic-j' => 'Frankrike och Monaco',
    'Ic-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ic-l' => 'Portugal',
    'Ic-m' => 'Östeuropa',
    'Ic-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ic-mb' => 'Polen',
    'Ic-mc' => 'Estland, Lettland, Litauen',
    'Ic-n' => 'Balkanländerna',
    'Ic-na' => 'Rumänien',
    'Ic-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ic-nc' => 'Bulgarien',
    'Ic-nd' => 'Grekland',
    'Ic-nf' => 'Albanien',
    'Ic-o' => 'Asien',
    'Ic-oa' => 'Främre Asien',
    'Ic-ob' => 'Främre Indien',
    'Ic-oc' => 'Bortre Indien',
    'Ic-od' => 'Ostindiska öarna',
    'Ic-oe' => 'Östasien',
    'Ic-oea' => 'Kina',
    'Ic-oeb' => 'Korea',
    'Ic-oec' => 'Japan',
    'Ic-of' => 'Centralasien',
    'Ic-og' => 'Sibirien',
    'Ic-p' => 'Afrika',
    'Ic-q' => 'Amerika',
    'Ic-qa' => 'Förenta staterna',
    'Ic-qb' => 'Kanada',
    'Ic-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ic-qd' => 'Sydamerika',
    'Ic-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Icd' => 'Byggnader för särskilda ändamål',
    'Icda' => 'Bostadshus',
    'Icdaa' => 'Slott, herresäten',
    'Icdab' => 'Flerfamiljshus',
    'Icdac' => 'Enfamiljshus',
    'Icdaf' => 'Fritidshus',
    'Icdak' => 'Komplement till bostadshus',
    'Icdb' => 'Byggnader för industri, transport, lagring',
    'Icdc' => 'Byggnader för religiösa ändamål',
    'Icdd' => 'Förvaltningsbyggnader, kontor, butiker',
    'Icde' => 'Byggnader för sjukvård, social omsorg',
    'Icdf' => 'Byggnader för undervisning, vetenskap, kultur',
    'Icdg' => 'Byggnader för underhållning och rekreation',
    'Icdö' => 'Byggnader för övriga ändamål',
    'Ict' => 'Stadsplanekonst',
    'Icu' => 'Landskapsarkitektur',
    'Icv' => 'Byggnadsvård',
    'Id' => 'Skulptur',
    'Id.' => 'Särskilda perioder',
    'Id.2' => 'Forntidens skulptur',
    'Id.21' => 'Egypten',
    'Id.22' => 'Främre Asien',
    'Id.23' => 'Antikens skulptur: allmänt',
    'Id.24' => 'Grekisk skulptur',
    'Id.25' => 'Etruskisk skulptur',
    'Id.26' => 'Romersk skulptur',
    'Id.3' => 'Medeltidens skulptur',
    'Id.31' => 'Fornkristen och bysantinsk skulptur',
    'Id.33' => 'Karolingisk och ottonsk skulptur',
    'Id.35' => 'Romansk skulptur (ca 1000 - 1150)',
    'Id.37' => 'Gotisk skulptur (ca 1150 - 1420)',
    'Id.4' => 'Nya tiden',
    'Id.41' => 'Renässansen (ca 1420 - 1580)',
    'Id.43' => 'Barocken (ca 1580 - 1725)',
    'Id.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Id.47' => '1800-talet',
    'Id.5' => '1905-',
    'Id.55' => '1945-',
    'Id.58' => '1980-',
    'Id.59' => '1990-',
    'Id.6' => '2000-',
    'Id-' => 'Särskilda länder och områden',
    'Id-a' => 'Europa: allmänt',
    'Id-b' => 'Norden: allmänt',
    'Id-c' => 'Sverige',
    'Id-cs' => 'Samer',
    'Id-cz' => 'Särskilda orters skulptur',
    'Id-d' => 'Övriga Norden',
    'Id-e' => 'Brittiska öarna (Storbritannien)',
    'Id-f' => 'Mellaneuropa',
    'Id-g' => 'Nederländerna, Belgien och Luxemburg',
    'Id-h' => 'Schweiz',
    'Id-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Id-j' => 'Frankrike och Monaco',
    'Id-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Id-m' => 'Östeuropa',
    'Id-n' => 'Balkanländerna',
    'Id-o' => 'Asien',
    'Id-ob' => 'Främre Indien',
    'Id-oe' => 'Östasien',
    'Id-p' => 'Afrika',
    'Id-q' => 'Amerika',
    'Id-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Id-s' => 'Polarländerna',
    'Idy' => 'Material, metoder, teknik',
    'Ie' => 'Målarkonst',
    'Ie.' => 'Särskilda perioder',
    'Ie.2' => 'Forntidens målarkonst',
    'Ie.21' => 'Egypten',
    'Ie.22' => 'Främre Asien',
    'Ie.23' => 'Antikens målarkonst: allmänt',
    'Ie.24' => 'Grekisk målarkonst',
    'Ie.25' => 'Etruskisk målarkonst',
    'Ie.26' => 'Romersk målarkonst',
    'Ie.3' => 'Medeltidens målarkonst',
    'Ie.31' => 'Fornkristen och bysantinsk målarkonst',
    'Ie.33' => 'Karolingisk och ottonsk målarkonst',
    'Ie.35' => 'Romansk målarkonst (ca 1000 - 1150)',
    'Ie.37' => 'Gotisk målarkonst (ca 1150 - 1420)',
    'Ie.4' => 'Nya tiden',
    'Ie.41' => 'Renässansen (ca 1420 - 1580)',
    'Ie.42' => 'Manierismen (ca 1520 - 1600)',
    'Ie.43' => 'Barocken (ca 1580 - 1725)',
    'Ie.45' => 'Rokokon (ca 1725 - 1760)',
    'Ie.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Ie.47' => '1800-talet',
    'Ie.48' => 'Jugend (ca 1896 - 1910)',
    'Ie.5' => '1905-',
    'Ie.55' => '1945-',
    'Ie.58' => '1980-',
    'Ie.59' => '1990-',
    'Ie.6' => '2000-',
    'Ie-' => 'Särskilda länder och områden',
    'Ie-a' => 'Europa: allmänt',
    'Ie-b' => 'Norden: allmänt',
    'Ie-c' => 'Sverige',
    'Ie-cz' => 'Särskilda orters målarkonst',
    'Ie-d' => 'Övriga Norden',
    'Ie-da' => 'Danmark',
    'Ie-db' => 'Norge',
    'Ie-dd' => 'Finland',
    'Ie-e' => 'Brittiska öarna (Storbritannien)',
    'Ie-f' => 'Mellaneuropa',
    'Ie-fa' => 'Tyskland',
    'Ie-fb' => 'Österrike och Liechtenstein',
    'Ie-fc' => 'Ungern',
    'Ie-fd' => 'Tjeckien och Slovakien',
    'Ie-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ie-h' => 'Schweiz',
    'Ie-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ie-j' => 'Frankrike och Monaco',
    'Ie-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ie-l' => 'Portugal',
    'Ie-m' => 'Östeuropa',
    'Ie-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ie-mb' => 'Polen',
    'Ie-mc' => 'Estland, Lettland, Litauen',
    'Ie-n' => 'Balkanländerna',
    'Ie-o' => 'Asien',
    'Ie-oa' => 'Främre Asien',
    'Ie-ob' => 'Främre Indien',
    'Ie-oc' => 'Bortre Indien',
    'Ie-oe' => 'Östasien',
    'Ie-oea' => 'Kina',
    'Ie-oeb' => 'Korea',
    'Ie-oec' => 'Japan',
    'Ie-p' => 'Afrika',
    'Ie-q' => 'Amerika',
    'Ie-qa' => 'Förenta staterna',
    'Ie-qb' => 'Kanada',
    'Ie-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ie-qd' => 'Sydamerika',
    'Ie-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ieb' => 'Bokmåleri',
    'Iem' => 'Miniatyrmåleri',
    'Ien' => 'Muralmåleri',
    'Iet' => 'Teaterdekorationer',
    'Iey' => 'Material, metoder, teknik',
    'If' => 'Grafisk konst',
    'If.' => 'Särskilda perioder',
    'If.4' => 'Nya tiden',
    'If.41' => 'Renässansen (ca 1420 - 1580)',
    'If.42' => 'Manierismen (ca 1520 - 1600)',
    'If.43' => 'Barocken (ca 1580 - 1725)',
    'If.45' => 'Rokokon (ca 1725 - 1760)',
    'If.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'If.47' => '1800-talet',
    'If.48' => 'Jugend (ca 1896 - 1910)',
    'If.5' => '1905-',
    'If.55' => '1945-',
    'If.58' => '1980-',
    'If.59' => '1990-',
    'If.6' => '2000-',
    'If-' => 'Särskilda länder och områden',
    'If-a' => 'Europa: allmänt',
    'If-b' => 'Norden: allmänt',
    'If-c' => 'Sverige',
    'If-c:bf' => 'Organisationer och institutioner',
    'If-d' => 'Övriga Norden',
    'If-e' => 'Brittiska öarna (Storbritannien)',
    'If-f' => 'Mellaneuropa',
    'If-fa' => 'Tyskland',
    'If-g' => 'Nederländerna, Belgien och Luxemburg',
    'If-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'If-j' => 'Frankrike och Monaco',
    'If-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'If-m' => 'Östeuropa',
    'If-n' => 'Balkanländerna',
    'If-o' => 'Asien',
    'If-p' => 'Afrika',
    'If-q' => 'Amerika',
    'Ifq' => 'Bruksgrafik',
    'Ifr' => 'Bokillustration',
    'Ify' => 'Material, metoder, teknik',
    'Ig' => 'Teckningskonst',
    'Ig.' => 'Särskilda perioder',
    'Ig.2' => 'Forntidens teckningskonst',
    'Ig.3' => 'Medeltidens teckningskonst',
    'Ig.4' => 'Nya tiden',
    'Ig.41' => 'Renässansen (ca 1420 - 1580)',
    'Ig.42' => 'Manierismen (ca 1520 - 1600)',
    'Ig.43' => 'Barocken (ca 1580 - 1725)',
    'Ig.45' => 'Rokokon (ca 1725 - 1760)',
    'Ig.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Ig.47' => '1800-talet',
    'Ig.5' => '1905-',
    'Ig.55' => '1945-',
    'Ig.58' => '1980-',
    'Ig.59' => '1990-',
    'Ig.6' => '2000-',
    'Ig-' => 'Särskilda länder och områden',
    'Ig-a' => 'Europa: allmänt',
    'Ig-c' => 'Sverige',
    'Ig-cz' => 'Särskilda orters teckningkonst',
    'Ig-d' => 'Övriga Norden',
    'Ig-e' => 'Brittiska öarna (Storbritannien)',
    'Ig-f' => 'Mellaneuropa',
    'Ig-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ig-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ig-j' => 'Frankrike och Monaco',
    'Ig-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ig-m' => 'Östeuropa',
    'Ig-o' => 'Asien',
    'Ig-p' => 'Afrika',
    'Ig-q' => 'Amerika',
    'Igy' => 'Material, metoder, teknik',
    'Ih' => 'Konsthantverk',
    'Ih.' => 'Allmänt: särskilda perioder',
    'Ih.2' => 'Forntidens konsthantverk',
    'Ih.21' => 'Egypten',
    'Ih.22' => 'Främre Asien',
    'Ih.23' => 'Antikens konsthantverk: allmänt',
    'Ih.24' => 'Grekiskt konstantverk',
    'Ih.25' => 'Etruskiskt konsthantverk',
    'Ih.26' => 'Romerskt konsthantverk',
    'Ih.3' => 'Medeltidens teckningskonst',
    'Ih.4' => 'Nya tiden',
    'Ih.42' => 'Manierismen (ca 1520 - 1600)',
    'Ih.43' => 'Barocken (ca 1580 - 1725)',
    'Ih.45' => 'Rokokon (ca 1725 - 1760)',
    'Ih.46' => 'Nyklassicismen (ca 1760 - 1840)',
    'Ih.47' => '1800-talet',
    'Ih.48' => 'Jugend (ca 1896 - 1910)',
    'Ih.5' => '1905-',
    'Ih.55' => '1945-',
    'Ih.58' => '1980-',
    'Ih.59' => '1990-',
    'Ih.6' => '2000-',
    'Ih-' => 'Allmänt: Särskilda länder och områden',
    'Ih-a' => 'Europa: allmänt',
    'Ih-b' => 'Norden: allmänt',
    'Ih-c' => 'Sverige',
    'Ih-c:bf' => 'Organisationer och institutioner',
    'Ih-cs' => 'Samer',
    'Ih-cz' => 'Särskilda orters konsthantverk',
    'Ih-d' => 'Övriga Norden',
    'Ih-da' => 'Danmark',
    'Ih-db' => 'Norge',
    'Ih-dc' => 'Island och Färöarna',
    'Ih-dd' => 'Finland',
    'Ih-e' => 'Brittiska öarna (Storbritannien)',
    'Ih-f' => 'Mellaneuropa',
    'Ih-fa' => 'Tyskland',
    'Ih-fb' => 'Österrike och Liechtenstein',
    'Ih-fc' => 'Ungern',
    'Ih-fd' => 'Tjeckien och Slovakien',
    'Ih-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ih-h' => 'Schweiz',
    'Ih-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ih-j' => 'Frankrike och Monaco',
    'Ih-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ih-l' => 'Portugal',
    'Ih-m' => 'Östeuropa',
    'Ih-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ih-mb' => 'Polen',
    'Ih-mc' => 'Estland, Lettland, Litauen',
    'Ih-n' => 'Balkanländerna',
    'Ih-o' => 'Asien',
    'Ih-oa' => 'Främre Asien',
    'Ih-ob' => 'Främre Indien',
    'Ih-oc' => 'Bortre Indien',
    'Ih-od' => 'Ostindiska öarna',
    'Ih-oe' => 'Östasien',
    'Ih-oea' => 'Kina',
    'Ih-oeb' => 'Korea',
    'Ih-oec' => 'Japan',
    'Ih-p' => 'Afrika',
    'Ih-q' => 'Amerika',
    'Ih-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Iha' => 'Ornamentik',
    'Ihb' => 'Industriell formgivning',
    'Ihc' => 'Textil konst',
    'Ihca' => 'Vävnader',
    'Ihcb' => 'Mattor',
    'Ihcc' => 'Tygtryck',
    'Ihcd' => 'Broderier',
    'Ihce' => 'Spetsar',
    'Ihcf' => 'Virkade, stickade, flätade arbeten',
    'Ihd' => 'Konsthantverk i trä',
    'Ihe' => 'Konsthantverk i metall',
    'Ihea' => 'Guld- och silversmide',
    'Ihec' => 'Järnsmide',
    'Ihed' => 'Tenn- och mässingsarbeten',
    'Ihee' => 'Brons- och koppararbeten',
    'Ihf' => 'Keramik och glas',
    'Ihfa' => 'Keramik',
    'Ihfaa' => 'Lergods, fajans, flintgods',
    'Ihfab' => 'Stengods',
    'Ihfac' => 'Porslin',
    'Ihfb' => 'Glas',
    'Ihfc' => 'Emalj',
    'Ihfd' => 'Mosaik',
    'Ihh' => 'Inredning',
    'Ihha' => 'Väggbeklädnad',
    'Ihhb' => 'Möbelkonst',
    'Ihk' => 'Dräkthistoria',
    'Ihks' => 'Uniformer',
    'Ihkt' => 'Folkdräkter',
    'Ihku' => 'Teaterdräkter',
    'Ihq' => 'Reklamkonst',
    'Ihö' => 'Övrigt konsthantverk',
    'Ihöz' => 'Särskilda typer av konsthantverk',
    'Ii' => 'Konstsamlingar och -utställningar',
    'Iib' => 'Konstmuseer',
    'Iib-' => 'Särskilda länder och områden',
    'Iib-a' => 'Europa: allmänt',
    'Iib-b' => 'Norden: allmänt',
    'Iib-c' => 'Sverige',
    'Iib-c:bf' => 'Organisationer och institutioner',
    'Iib-cz' => 'Särskilda museer och samlingar',
    'Iib-d' => 'Övriga Norden',
    'Iib-e' => 'Brittiska öarna (Storbritannien)',
    'Iib-f' => 'Mellaneuropa',
    'Iib-fa' => 'Tyskland',
    'Iib-fb' => 'Österrike och Liechtenstein',
    'Iib-fc' => 'Ungern',
    'Iib-fd' => 'Tjeckien och Slovakien',
    'Iib-g' => 'Nederländerna, Belgien och Luxemburg',
    'Iib-h' => 'Schweiz',
    'Iib-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Iib-j' => 'Frankrike och Monaco',
    'Iib-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Iib-m' => 'Östeuropa',
    'Iib-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Iib-mb' => 'Polen',
    'Iib-mc' => 'Estland, Lettland, Litauen',
    'Iib-n' => 'Balkanländerna',
    'Iib-o' => 'Asien',
    'Iib-p' => 'Afrika',
    'Iib-q' => 'Amerika',
    'Iib-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Iis' => 'Privat konstsamlande',
    'Iisz' => 'Särskilda samlare',
    'Iit' => 'Konstutställningar',
    'Iit-' => 'Särskilda länder och områden',
    'Iit-a' => 'Europa: allmänt',
    'Iit-b' => 'Norden: allmänt',
    'Iit-c' => 'Sverige',
    'Iit-cz' => 'Särskilda orter',
    'Iit-d' => 'Övriga Norden',
    'Iit-e' => 'Brittiska öarna (Storbritannien)',
    'Iit-f' => 'Mellaneuropa',
    'Iit-g' => 'Nederländerna, Belgien och Luxemburg',
    'Iit-h' => 'Schweiz',
    'Iit-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Iit-j' => 'Frankrike och Monaco',
    'Iit-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Iit-l' => 'Portugal',
    'Iit-m' => 'Östeuropa',
    'Iit-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Iit-mb' => 'Polen',
    'Iit-mc' => 'Estland, Lettland, Litauen',
    'Iit-n' => 'Balkanländerna',
    'Iit-o' => 'Asien',
    'Iit-oe' => 'Östasien',
    'Iit-p' => 'Afrika',
    'Iit-q' => 'Amerika',
    'Iit-qa' => 'Förenta staterna',
    'Iit-qb' => 'Kanada',
    'Iit-qc' => 'Mexiko, Centralamerika och Västindien',
    'Iit-qd' => 'Sydamerika',
    'Iit-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Iit-ra' => 'Australien',
    'Iit-rb' => 'Nya Zeeland',
    'Iiu' => 'Konsthandel',
    'Iiu-cz' => 'Sverige: särskilda företag och orter',
    'Iiv' => 'Offentlig konst',
    'Iiv-cz' => 'Sverige: särskilda orter',
    'Ij' => 'Musik',
    'Ij:d' => 'Musikteori, -filosofi och -psykologi',
    'Ij:dd' => 'Metodlära',
    'Ij:df' => 'Musikestetik',
    'Ij:dg' => 'Musikkritik',
    'Ij:do' => 'Musikpsykologi',
    'Ij:k' => 'Musikforskningens historia',
    'Ij:oa' => 'Musiksociologi',
    'Ija' => 'Musikteori, musikarkeologi m fl musikvetenskapliga delområden',
    'Ijaa' => 'Musikteori och musiklära',
    'Ijaaa' => 'Melodi',
    'Ijaab' => 'Rytm',
    'Ijab' => 'Harmonilära',
    'Ijac' => 'Kontrapunkt',
    'Ijad' => 'Musikalisk formlära, stil- och strukturanalys',
    'Ijae' => 'Komposition och instrumentation',
    'Ijaec' => 'Improvisation',
    'Ijaf' => 'Dirigering och partiturläsning',
    'Ijag' => 'Uppförandepraxis',
    'Ijah' => 'Notation (notskrift)',
    'Ijai' => 'Tonsystem och skalor',
    'Ijar' => 'Musikarkeologi',
    'Ijas' => 'Musiksemiotik',
    'Ijat' => 'Texter till musik',
    'Ijav' => 'Musikikonografi',
    'Ijb' => 'Musikhistoria',
    'Ijb:bf' => 'Musikhistoriska institutioner',
    'Ijb.' => 'Allmänt: särskilda perioder',
    'Ijb.2' => 'Forntiden - ca 600 e Kr',
    'Ijb.3' => 'Medeltiden och renässansen ca 600 - 1600',
    'Ijb.38' => 'Renässansen ca 1450 - 1600',
    'Ijb.4' => 'Nya tiden ca 1600 -',
    'Ijb.43' => 'Barocken ca 1600 - 1750',
    'Ijb.45' => 'Klassicismen och förromantiken ca 1750 - 1820',
    'Ijb.47' => 'Högromantiken och senromantiken ca 1820 - 1900',
    'Ijb.5' => '1900-talet',
    'Ijb.55' => '1945-',
    'Ijb.58' => '1980-',
    'Ijb.59' => '1990-',
    'Ijb.6' => '2000-',
    'Ijb-' => 'Särskilda länder och områden',
    'Ijb-b' => 'Norden',
    'Ijb-b.2' => 'Forntiden',
    'Ijb-c' => 'Sverige',
    'Ijb-c.' => 'Särskilda perioder',
    'Ijb-c.3' => 'Medeltiden',
    'Ijb-c.4' => 'Nya tiden 1521-',
    'Ijb-c.42' => '1600-talet',
    'Ijb-c.45' => '1700-talet',
    'Ijb-c.46' => '1800-talet',
    'Ijb-c.5' => '1900-talet',
    'Ijb-c.55' => '1945-',
    'Ijb-c.58' => '1980-',
    'Ijb-c.59' => '1990-',
    'Ijb-c.6' => '2000-',
    'Ijb-cz' => 'Särskilda orter',
    'Ijb-d' => 'Övriga Norden',
    'Ijb-da' => 'Danmark',
    'Ijb-db' => 'Norge',
    'Ijb-dc' => 'Island och Färöarna',
    'Ijb-dd' => 'Finland',
    'Ijb-e' => 'Brittiska öarna (Storbritannien)',
    'Ijb-f' => 'Mellaneuropa',
    'Ijb-fa' => 'Tyskland',
    'Ijb-fb' => 'Österrike och Liechtenstein',
    'Ijb-fc' => 'Ungern',
    'Ijb-fd' => 'Tjeckien och Slovakien',
    'Ijb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ijb-h' => 'Schweiz',
    'Ijb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ijb-j' => 'Frankrike och Monaco',
    'Ijb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ijb-l' => 'Portugal',
    'Ijb-m' => 'Östeuropa',
    'Ijb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ijb-mb' => 'Polen',
    'Ijb-mc' => 'Estland, Lettland, Litauen',
    'Ijb-n' => 'Balkanländerna',
    'Ijb-na' => 'Rumänien',
    'Ijb-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ijb-nc' => 'Bulgarien',
    'Ijb-nd' => 'Grekland',
    'Ijb-o' => 'Asien',
    'Ijb-oa' => 'Främre Asien',
    'Ijb-oafh' => 'Judar',
    'Ijb-oc' => 'Bortre Indien',
    'Ijb-od' => 'Ostindiska öarna',
    'Ijb-oe' => 'Östasien',
    'Ijb-oea' => 'Kina',
    'Ijb-oeb' => 'Korea',
    'Ijb-oec' => 'Japan',
    'Ijb-p' => 'Afrika',
    'Ijb-q' => 'Amerika',
    'Ijb-qa' => 'Förenta staterna',
    'Ijb-qb' => 'Kanada',
    'Ijb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ijb-qd' => 'Sydamerika',
    'Ijb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ijc' => 'Musikinstrument: allmänt',
    'Ijd' => 'Tangentinstrument',
    'Ijda' => 'Piano',
    'Ijdb' => 'Orgel',
    'Ijdb-cz' => 'Sverige: särskilda orglar',
    'Ijdc' => 'Cembaloinstrument',
    'Ijdd' => 'Klavikord',
    'Ijdi' => 'Elektriska tangentinstrument (keyboard)',
    'Ije' => 'Stråkinstrument',
    'Ijea' => 'Violin',
    'Ijeb' => 'Viola',
    'Ijec' => 'Violoncell',
    'Ijed' => 'Kontrabas',
    'Ijee' => 'Viola da gamba',
    'Ijeg' => 'Nyckelharpa',
    'Ijez' => 'Övriga särskilda stråkinstrument',
    'Ijf' => 'Blåsinstrument',
    'Ijfa' => 'Flöjt',
    'Ijfb' => 'Blockflöjt',
    'Ijfc' => 'Oboe',
    'Ijfd' => 'Klarinett',
    'Ijfe' => 'Saxofon',
    'Ijff' => 'Fagott',
    'Ijfg' => 'Trumpet',
    'Ijfh' => 'Horn (valthorn)',
    'Ijfi' => 'Trombon (basun)',
    'Ijfk' => 'Dragspel',
    'Ijfl' => 'Säckpipa',
    'Ijfm' => 'Munspel',
    'Ijfz' => 'Övriga särskilda blåsinstrument',
    'Ijg' => 'Knäppinstrument',
    'Ijga' => 'Harpa',
    'Ijgb' => 'Gitarr',
    'Ijgbi' => 'Elgitarr',
    'Ijgbz' => 'Övriga särskilda gitarrer',
    'Ijgc' => 'Mandolin',
    'Ijgd' => 'Luta',
    'Ijge' => 'Citterinstrument',
    'Ijgf' => 'Balalajka',
    'Ijgg' => 'Banjo',
    'Ijgz' => 'Övriga särskilda knäppinstrument',
    'Ijh' => 'Slagverk och strykidiofoner',
    'Ijha' => 'Trumma och puka',
    'Ijhc' => 'Klockor och klockspel',
    'Ijhg' => 'Marimba',
    'Ijhz' => 'Övriga särskilda slaginstrument',
    'Iji' => 'Elektriska musikinstrument',
    'Ijib' => 'Synthesizer',
    'Ijj' => 'Mekaniska musikinstrument',
    'Ijja' => 'Klockspel',
    'Ijjb' => 'Speldosor, spelur',
    'Ijjc' => 'Positiv, gatuorgel m m',
    'Ijjd' => 'Självspelande piano, pianola m m',
    'Ijk' => 'Instrumentalmusik: kammarmusik',
    'Ijkd' => 'Ensembler med tangentinstrument',
    'Ijke' => 'Ensembler med stråkinstrument',
    'Ijkf' => 'Ensembler med blåsinstrument',
    'Ijl' => 'Instrumentalmusik: orkestrar',
    'Ijlc' => 'Kammarorkestrar',
    'Ijle' => 'Symfoniorkestrar',
    'Ijlf' => 'Blåsorkestrar',
    'Ijlfa' => 'Militärorkestrar',
    'Ijlfb' => 'Brassband',
    'Ijm' => 'Instrumentalmusik: särskilda former',
    'Ijma' => 'Symfoniska verk',
    'Ijmb' => 'Instrumentalkonserter',
    'Ijmbd' => 'Konserter för tangentinstrument + orkester',
    'Ijmbe' => 'Konserter för stråkinsturment + orkester',
    'Ijmbf' => 'Konserter för blåsinstrument + orkester',
    'Ijmc' => 'Divertimenti, serenader, sviter m m',
    'Ijmd' => 'Variationsverk',
    'Ijmf' => 'Symfoniska dikter och karaktärsstycken',
    'Ijmg' => 'Rapsodier, fantasier, etyder m m',
    'Ijmh' => 'Danser och dansstycken',
    'Ijmhz' => 'Särskilda dansstycken',
    'Ijmi' => 'Marscher',
    'Ijmj' => 'Kanons, toccator, fugor, ricercari, tienti m m',
    'Ijml' => 'Sonater',
    'Ijn' => 'Vokalmusik: allmänt',
    'Ijnj' => 'Sångteknik och sångröstbehandling',
    'Ijo' => 'Vokalmusik: solosång',
    'Ijp' => 'Vokalmusik: körsång',
    'Ijq' => 'Vokalmusik: särskilda former',
    'Ijqa' => 'Oratorier',
    'Ijqb' => 'Kantater',
    'Ijqc' => 'Äldre vokalmusikformer (till ca 1600)',
    'Ijqca' => 'Vokalmusik från medeltiden',
    'Ijqcb' => 'Madrigaler',
    'Ijqcc' => 'Motetter',
    'Ijqcd' => 'Andra sånger från renässansen',
    'Ijqd' => 'Passioner',
    'Ijqe' => 'Andra vokalverk med liturgisk eller biblisk text',
    'Ijqea' => 'Mässor och rekvier',
    'Ijqed' => 'Hymner, sekvenser, antifoner etc',
    'Ijqee' => 'Övriga bibeltexter',
    'Ijqf' => 'Solistiska former efter ca 1600',
    'Ijqfa' => 'Solosång från barocken ca 1600 - 1750',
    'Ijqfc' => 'Religiösa solosånger och arior',
    'Ijqfd' => 'Lieder, romanser, ballader och sångcykler',
    'Ijqfe' => 'Friare solistisk musik för soloröst',
    'Ijqg' => 'Nationella sånger',
    'Ijqga' => 'Nationalsånger',
    'Ijqh' => 'Visor',
    'Ijqhz' => 'Särskilda typer av populära sånger och visor',
    'Ijqj' => 'Barnvisor',
    'Ijql' => 'Körmusik efter ca 1600',
    'Ijr' => 'Dramatisk och scenisk musik',
    'Ijra' => 'Operor',
    'Ijrb' => 'Operetter',
    'Ijrba' => 'Musikaler',
    'Ijrc' => 'Baletter',
    'Ijrd' => 'Revyer och spex',
    'Ijre' => 'Film- och skådespelmusik',
    'Ijrea' => 'Filmmusik',
    'Ijreb' => 'Skådespelsmusik',
    'Ijrh' => 'Musik till melodramer och uppläsningar',
    'Ijrs' => 'Legend- och mysteriespel',
    'Ijrt' => 'Multimediaverk',
    'Ijs' => 'Religiös musik',
    'Ijsa' => 'Kristna samfund',
    'Ijsaa' => 'Romersk-katolska kyrkan',
    'Ijsaaa' => 'Mässa',
    'Ijsaab' => 'Tidegärd',
    'Ijsaac' => 'Hymner, sekvenser, troper, rimofficier m m',
    'Ijsab' => 'Grekisk-ortodoxa kyrkan',
    'Ijsac' => 'Bysantinsk kyrkomusik',
    'Ijsad' => 'Protestantisk kyrkomusik',
    'Ijsae' => 'Anglikansk kyrkomusik',
    'Ijsao' => 'Orientalisk kyrkomusik',
    'Ijsb' => 'Icke-kristna religioner',
    'Ijse' => 'Koraler och psalmer',
    'Ijsea' => 'Romersk-katolska kyrkan',
    'Ijsed' => 'Protestantiska kyrkor',
    'Ijsf' => 'Andliga sånger och visor',
    'Ijsg' => 'Gospels och negro spirituals',
    'Ijt' => 'Skolmusik',
    'Iju' => 'Västerländsk folkmusik',
    'Iju-' => 'Särskilda länder och områden',
    'Iju-a' => 'Europa: allmänt',
    'Iju-b' => 'Norden; allmänt',
    'Iju-c' => 'Sverige',
    'Iju-cs' => 'Samer',
    'Iju-d' => 'Övriga Norden',
    'Iju-da' => 'Danmark',
    'Iju-db' => 'Norge',
    'Iju-dd' => 'Finland',
    'Iju-e' => 'Brittiska öarna (Storbritannien)',
    'Iju-f' => 'Mellaneuropa',
    'Iju-fa' => 'Tyskland',
    'Iju-fb' => 'Österrike och Liechtenstein',
    'Iju-fc' => 'Ungern',
    'Iju-fd' => 'Tjeckien och Slovakien',
    'Iju-g' => 'Nederländerna, Belgien och Luxemburg',
    'Iju-h' => 'Schweiz',
    'Iju-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Iju-j' => 'Frankrike och Monaco',
    'Iju-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Iju-l' => 'Portugal',
    'Iju-m' => 'Östeuropa',
    'Iju-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Iju-mb' => 'Polen',
    'Iju-mc' => 'Estland, Lettland, Litauen',
    'Iju-n' => 'Balkanländerna',
    'Iju-na' => 'Rumänien',
    'Iju-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Iju-nc' => 'Bulgarien',
    'Iju-nd' => 'Grekland',
    'Iju-nf' => 'Albanien',
    'Iju-o' => 'Asien',
    'Iju-p' => 'Afrika',
    'Iju-q' => 'Amerika',
    'Iju-qa' => 'Förenta staterna',
    'Iju-qb' => 'Kanada',
    'Iju-qc' => 'Mexiko, Centralamerika och Västindien',
    'Iju-qd' => 'Sydamerika',
    'Iju-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Iju-s' => 'Polarländerna',
    'Ijv' => 'Icke-västerländska kulturers musik',
    'Ijv-' => 'Särskilda länder och områden',
    'Ijv-c' => 'Sverige',
    'Ijv-m' => 'Östeuropa',
    'Ijv-n' => 'Balkanländerna',
    'Ijv-o' => 'Asien',
    'Ijv-oa' => 'Främre Asien',
    'Ijv-oc' => 'Bortre Indien',
    'Ijv-od' => 'Ostindiska öarna',
    'Ijv-oe' => 'Östasien',
    'Ijv-oea' => 'Kina',
    'Ijv-oeb' => 'Korea',
    'Ijv-oec' => 'Japan',
    'Ijv-of' => 'Centralasien',
    'Ijv-og' => 'Sibirien',
    'Ijv-p' => 'Afrika',
    'Ijv-pa' => 'Nordafrika utom Egypten',
    'Ijv-pb' => 'Egypten och Sudan',
    'Ijv-pc' => 'Västafrika',
    'Ijv-pd' => 'Centralafrika',
    'Ijv-pe' => 'Södra Afrika',
    'Ijv-pf' => 'Östafrika',
    'Ijv-pg' => 'Nordöstafrika',
    'Ijv-q' => 'Amerika',
    'Ijv-qa' => 'Förenta staterna',
    'Ijv-qat' => 'Indianer i Nordamerika',
    'Ijv-qb' => 'Kanada',
    'Ijv-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ijv-qd' => 'Sydamerika',
    'Ijv-qdt' => 'Indianer i Sydamerika',
    'Ijv-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ijv-ra' => 'Australien',
    'Ijv-rb' => 'Nya Zeeland',
    'Ijv-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ijv-rd' => 'Nya Guinea',
    'Ijv-s' => 'Polarländerna',
    'Ijx' => 'Jazz, rock och populärmusik',
    'Ijxb' => 'Ragtime',
    'Ijxc' => 'Jazz',
    'Ijxca' => 'Tidig jazz',
    'Ijxcb' => 'Swing och sweet',
    'Ijxcc' => 'Modern jazz',
    'Ijxf' => 'Blues',
    'Ijxfa' => 'Country blues',
    'Ijxfc' => 'City blues',
    'Ijxfd' => 'Rythm &amp; blues',
    'Ijxfe' => 'Soul, funk, hip-hop och rap',
    'Ijxg' => 'Nordamerikansk folkmusik utom blues',
    'Ijxgb' => 'Country &amp; western',
    'Ijxn' => 'Rock',
    'Ijxna' => 'Tidig rock',
    'Ijxnd' => '60-talets pop och rock',
    'Ijxne' => '70-talets rock och framåt',
    'Ijxng' => 'Folkrock',
    'Ijxnh' => 'Countryrock',
    'Ijxni' => 'Singers/songwriters (&#034;visrocksångare&#034;)',
    'Ijxnv' => 'Icke-västerländsk populärmusik av rocktyp',
    'Ijxnvd' => 'Reggae',
    'Ijxnve' => 'Salsa',
    'Ijxp' => 'Populärmusik',
    'Ijxpb' => 'Schlager och evergreens',
    'Ijxpc' => 'Barbershop',
    'Ijxq' => 'Dansmusik',
    'Ijy' => 'Musikprogram',
    'Ijz' => 'Särskilda tonkonstnärer',
    'Ijä' => 'Parodier, signaler, ljudeffekter m m',
    'Ijö' => 'Övrig musik',
    'Ijöa' => 'Årstidscykeln',
    'Ijöb' => 'Livscykeln',
    'Ijög' => 'Gatumusik',
    'Ijöm' => 'Militärmusik',
    'Ik' => 'Teater',
    'Ika' => 'Teater: allmänt',
    'Ika:bf' => 'Teaterorganisationer och -institutioner',
    'Ika:do' => 'Teaterpsykologi',
    'Ika:oa' => 'Teatersociologi',
    'Ikaa' => 'Teaterns teori och estetik',
    'Ikab' => 'Teaterregi och -teknik',
    'Ikabb' => 'Teaterteknik',
    'Ikad' => 'Skådespelarkonsten',
    'Ikb' => 'Teaterhistoria och -kritik',
    'Ikb.' => 'Särskilda perioder',
    'Ikb.2' => 'Forntiden',
    'Ikb.3' => 'Medeltiden',
    'Ikb.4' => 'Nya tiden',
    'Ikb.47' => '1800-talet',
    'Ikb.5' => '1900-talet',
    'Ikb.55' => '1945-',
    'Ikb.58' => '1980-',
    'Ikb.59' => '1990-',
    'Ikb.6' => '2000-',
    'Ikb-' => 'Särskilda länder och områden',
    'Ikb-a' => 'Europa: allmänt',
    'Ikb-b' => 'Norden: allmänt',
    'Ikb-c' => 'Sverige',
    'Ikb-c:bf' => 'Teaterorganisationer och -institutioner',
    'Ikb-cs' => 'Samer',
    'Ikb-cz' => 'Särskilda teatrar och orter',
    'Ikb-d' => 'Övriga Norden',
    'Ikb-da' => 'Danmark',
    'Ikb-db' => 'Norge',
    'Ikb-dc' => 'Island och Färöarna',
    'Ikb-dd' => 'Finland',
    'Ikb-e' => 'Brittiska öarna (Storbritannien)',
    'Ikb-f' => 'Mellaneuropa',
    'Ikb-fa' => 'Tyskland',
    'Ikb-fb' => 'Österrike och Liechtenstein',
    'Ikb-fc' => 'Ungern',
    'Ikb-fd' => 'Tjeckien och Slovakien',
    'Ikb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ikb-h' => 'Schweiz',
    'Ikb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ikb-j' => 'Frankrike och Monaco',
    'Ikb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ikb-l' => 'Portugal',
    'Ikb-m' => 'Östeuropa',
    'Ikb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ikb-mb' => 'Polen',
    'Ikb-mc' => 'Estland, Lettland, Litauen',
    'Ikb-n' => 'Balkanländerna',
    'Ikb-na' => 'Rumänien',
    'Ikb-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ikb-nc' => 'Bulgarien',
    'Ikb-nd' => 'Grekland',
    'Ikb-o' => 'Asien',
    'Ikb-oa' => 'Främre Asien',
    'Ikb-oafh' => 'Judar',
    'Ikb-oc' => 'Bortre Indien',
    'Ikb-od' => 'Ostindiska öarna',
    'Ikb-oe' => 'Östasien',
    'Ikb-oea' => 'Kina',
    'Ikb-oeb' => 'Korea',
    'Ikb-oec' => 'Japan',
    'Ikb-p' => 'Afrika',
    'Ikb-q' => 'Amerika',
    'Ikb-qa' => 'Förenta staterna',
    'Ikb-qb' => 'Kanada',
    'Ikb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ikb-qd' => 'Sydamerika',
    'Ikb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ike' => 'Teaterprogram',
    'Iks' => 'Gruppteater',
    'Ikt' => 'Pantomim- och marionetteater',
    'Iku' => 'Barnteater',
    'Ikv' => 'Amatörteater',
    'Ikx' => 'Radio- och TV-teater',
    'Iky' => 'Konstnärlig dans',
    'Iky.' => 'Särskilda perioder',
    'Iky.2' => 'Forntiden',
    'Iky.3' => 'Medeltiden',
    'Iky.4' => 'Nya tiden',
    'Iky.5' => '1900-talet',
    'Iky.6' => '2000-',
    'Ikya' => 'Klassisk balett',
    'Ikyj' => 'Fri dans',
    'Ikz' => 'Särskilda sceniska konstnärer',
    'Ikö' => 'Övrig scenisk konst och offentliga nöjen',
    'Iköa' => 'Revy, kabaret, music hall, nattklubbsunderhållning',
    'Iköd' => 'Nöjesfält, tivoli, marknadsunderhållning',
    'Iköe' => 'Cirkus',
    'Iköf' => 'Tjurfäktning',
    'Iköh' => 'Offentliga fester och ceremonier',
    'Im' => 'Film',
    'Ima' => 'Film: allmänt',
    'Ima:bf' => 'Filmorganisationer och -institutioner',
    'Ima:do' => 'Filmpsykologi',
    'Ima:oa' => 'Filmsociologi',
    'Imaa' => 'Filmens estetik och teori',
    'Imab' => 'Filmregi',
    'Imac' => 'Filmproduktion och -distribution',
    'Imb' => 'Filmhistoria',
    'Imb-' => 'Allmänt: särskilda länder och områden',
    'Imb-a' => 'Europa: allmänt',
    'Imb-b' => 'Norden: allmänt',
    'Imb-c' => 'Sverige',
    'Imb-c:bf' => 'Teaterorganisationer och -institutioner',
    'Imb-cz' => 'Särskilda biografer och orter',
    'Imb-d' => 'Övriga Norden',
    'Imb-da' => 'Danmark',
    'Imb-db' => 'Norge',
    'Imb-dd' => 'Finland',
    'Imb-e' => 'Brittiska öarna (Storbritannien)',
    'Imb-f' => 'Mellaneuropa',
    'Imb-fa' => 'Tyskland',
    'Imb-fb' => 'Österrike och Liechtenstein',
    'Imb-fc' => 'Ungern',
    'Imb-fd' => 'Tjeckien och Slovakien',
    'Imb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Imb-h' => 'Schweiz',
    'Imb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Imb-j' => 'Frankrike och Monaco',
    'Imb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Imb-l' => 'Portugal',
    'Imb-m' => 'Östeuropa',
    'Imb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Imb-mb' => 'Polen',
    'Imb-mc' => 'Estland, Lettland, Litauen',
    'Imb-n' => 'Balkanländerna',
    'Imb-o' => 'Asien',
    'Imb-oa' => 'Främre Asien',
    'Imb-ob' => 'Främre Indien',
    'Imb-oe' => 'Östasien',
    'Imb-p' => 'Afrika',
    'Imb-q' => 'Amerika',
    'Imb-qa' => 'Förenta staterna',
    'Imb-qb' => 'Kanada',
    'Imb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Imb-qd' => 'Sydamerika',
    'Imb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Imba' => 'Särskilda genrer',
    'Imbaa' => 'Västernfilm',
    'Imbab' => 'Komedi och fars',
    'Imbac' => 'Pornografisk film',
    'Imbad' => 'Krigsfilm och kriminalfilm',
    'Imbae' => 'Science-fiction film och skräckfilm',
    'Imbah' => 'Underground- och avantegardefilm',
    'Imbai' => 'Animerad film',
    'Imbaj' => 'Dokumentärfilm',
    'Imbak' => 'Musikfilm',
    'In' => 'Fotokonst',
    'Ina' => 'Fotokonst: allmänt',
    'Inb' => 'Fotokonstens historia',
    'Inb-c' => 'Sverige',
    'Inz' => 'Särskilda fotografer',
    'J' => 'Arkeologi',
    'J(x)' => 'Arkeologiska lexikon',
    'J:bf' => 'Arkeologiska institutioner',
    'J:dd' => 'Arkeologisk metodlära',
    'J:k' => 'Arkeologins historia',
    'J:kc' => 'Sverige',
    'J:oe' => 'Allmän arkeologisk lagstiftning och allmän fornminneslagstiftning',
    'J.0' => 'Allmän arkeologi: särskilda aspekter',
    'J.01' => 'Kulturformer',
    'J.02' => 'Bosättningar, kultplatser, gravskick',
    'J.03' => 'Verktyg, redskap, vapen',
    'J.04' => 'Konstnärliga lämningar',
    'J.05' => 'Konsthantverk',
    'J.06' => 'Stenmonument',
    'J.07' => 'Undervattensarkeologi',
    'J.08' => 'Osteologi (benlära)',
    'J.' => 'Allmän arkeologi: särskilda perioder',
    'J.1' => 'Förhistorisk tid',
    'J.11' => 'Stenåldern',
    'J.111' => 'Paleolitisk tid',
    'J.113' => 'Mesolitisk tid',
    'J.115' => 'Neolitisk tid',
    'J.15' => 'Bronsåldern',
    'J.17' => 'Järnåldern',
    'J.3' => 'Medeltiden',
    'Ja' => 'Europa (allmän och klassisk arkeologi)',
    'Jaa' => 'Klassisk arkeologi',
    'Jaan' => 'Grekisk arkeologi (inkl konst)',
    'Jaanö' => 'Det grekiska kulturområdet utanför Grekland',
    'Jaanö-i' => 'Syditaliens grekiska kulturlämningar',
    'Jaanö-j' => 'Frankrikes grekiska kulturlämningar',
    'Jaanö-k' => 'Spaniens grekiska kulturlämningar',
    'Jaanö-m' => 'Östeuropas grekiska kulturlämningar',
    'Jaanö-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Jaanö-n' => 'Balkanhalvöns grekiska kulturlämningar',
    'Jaanö-oa' => 'Främre Asiens grekiska kulturlämningar',
    'Jaanö-oaa' => 'Turkiet',
    'Jaanö-oab' => 'Cypern',
    'Jaanö-oac' => 'Kaukasien',
    'Jaanö-oae' => 'Syrien och Libanon',
    'Jaanö-oaf' => 'Palestina och Israel',
    'Jaanö-p' => 'Nordafrikas grekiska kulturlämningar',
    'Jaanö-pa' => 'Nordafrika utom Egypten',
    'Jaanö-pb' => 'Egypten',
    'Jaao' => 'Etruskisk arkeologi',
    'Jaap' => 'Romersk arkeologi (inkl konst)',
    'Jaapö' => 'Det romerska kulturområdet utanför Italien',
    'Jaapö-e' => 'De brittiska öarnas romerska kulturlämningar',
    'Jaapö-f' => 'Mellaneuropas romerska kulturlämningar',
    'Jaapö-fa' => 'Tyskland',
    'Jaapö-fb' => 'Österrike och Liechtenstein',
    'Jaapö-fc' => 'Ungern',
    'Jaapö-fd' => 'Tjeckien och Slovakien',
    'Jaapö-g' => 'Nederländernas, Belgiens och Luxemburgs romerska kulturlämningar',
    'Jaapö-h' => 'Schweiz romerska kulturlämningar',
    'Jaapö-j' => 'Frankrikes romerska kulturlämningar',
    'Jaapö-k' => 'Spaniens romerska kulturlämningar',
    'Jaapö-l' => 'Portugls romerska kulturlämningar',
    'Japö-m' => 'Östeuropas romerska kulturlämningar',
    'Jaapö-n' => 'Balkanhalvöns romerska kulturlämningar',
    'Jaapö-na' => 'Rumänien',
    'Jaapö-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Jaapö-nc' => 'Bulgarien',
    'Jaapö-nd' => 'Grekland',
    'Jaapö-nf' => 'Albanien',
    'Jaapö-oa' => 'Främre Asiens romerska kulturlämningar',
    'Jaapö-oaa' => 'Turkiet',
    'Jaapö-oab' => 'Cypern',
    'Jaapö-oac' => 'Kaukasien',
    'Jaapö-oae' => 'Syrien och Libanon',
    'Jaapö-oaf' => 'Palestina och Israel',
    'Jaapö-oag' => 'Jordanien',
    'Jaapö-p' => 'Nordafrikas romerska kulturlämningar',
    'Jaapö-pa' => 'Nordafrika utom Egypten',
    'Jaapö-pb' => 'Egypten',
    'Jaaq' => 'Fornkristen arkeologi',
    'Jak' => 'Keltisk arkeologi',
    'Jb' => 'Norden: allmänt',
    'Jc' => 'Sverige',
    'Jca' => 'Svealand',
    'Jcaa' => 'Stockholm och Stockholms län',
    'Jcaal' => 'Stockholms län',
    'Jcab' => 'Uppland och Uppsala län',
    'Jcac' => 'Södermanland och Södermanlands län',
    'Jcad' => 'Närke och Örebro län',
    'Jcae' => 'Västmanland och Västmanlands län',
    'Jcaf' => 'Dalarna och Dalarnas län',
    'Jcag' => 'Värmland och Värmlands län',
    'Jcb' => 'Götaland (inkl Västra Götalands län)',
    'Jcba' => 'Skåne och Skåne län',
    'Jcbb' => 'Halland och Hallands län',
    'Jcbc' => 'Blekinge och Blekinge län',
    'Jcbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Jcbe' => 'Öland',
    'Jcbf' => 'Gotland och Gotlands län',
    'Jcbg' => 'Östergötland och Östergötlands län',
    'Jcbh' => 'Västergötland',
    'Jcbi' => 'Göteborg',
    'Jcbk' => 'Bohuslän',
    'Jcbl' => 'Dalsland',
    'Jcc' => 'Norrland',
    'Jcca' => 'Gästrikland och Gävleborgs län',
    'Jccb' => 'Hälsingland',
    'Jccc' => 'Jämtland och Jämtlands län',
    'Jccd' => 'Härjedalen',
    'Jcce' => 'Medelpad',
    'Jccf' => 'Ångermanland och Västernorrlands län',
    'Jccg' => 'Västerbotten och Västerbottens län',
    'Jcch' => 'Norrbotten och Norrbottens län',
    'Jcci' => 'Lappland',
    'Jd' => 'Övriga Norden',
    'Jda' => 'Danmark',
    'Jdb' => 'Norge',
    'Jdc' => 'Island och Färöarna',
    'Jdd' => 'Finland',
    'Jddå' => 'Åland',
    'Je' => 'Brittiska öarna (Storbritannien)',
    'Jea' => 'England',
    'Jer' => 'Wales',
    'Jes' => 'Skottland',
    'Jet' => 'Irland',
    'Jf' => 'Mellaneuropa',
    'Jfa' => 'Tyskland',
    'Jfb' => 'Österrike och Liechtenstein',
    'Jfc' => 'Ungern',
    'Jfd' => 'Tjeckien och Slovakien',
    'Jfda' => 'Tjeckien',
    'Jfdb' => 'Slovakien',
    'Jg' => 'Nederländerna, Belgien och Luxemburg',
    'Jga' => 'Nederländerna',
    'Jgb' => 'Belgien',
    'Jgc' => 'Luxemburg',
    'Jh' => 'Schweiz',
    'Ji' => 'Italien (exkl klassisk arkeologi)',
    'Jiv' => 'Malta',
    'Jj' => 'Frankrike',
    'Jk' => 'Spanien (inkl Andorra och Gibraltar)',
    'Jl' => 'Portugal',
    'Jm' => 'Östeuropa',
    'Jma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Jmad' => 'Ukraina',
    'Jmae' => 'Vitryssland',
    'Jmaf' => 'Moldavien',
    'Jmas' => 'Skyterna',
    'Jmb' => 'Polen',
    'Jmc' => 'Estland, Lettland, Litauen',
    'Jn' => 'Balkanhalvön',
    'Jna' => 'Rumänien',
    'Jnb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc.)',
    'Jnba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Jnbb' => 'Kroatien',
    'Jnbc' => 'Slovenien',
    'Jnbd' => 'Bosnien-Hercegovina',
    'Jnbe' => 'Montenegro',
    'Jnbf' => 'Makedonien',
    'Jnc' => 'Bulgarien',
    'Jnf' => 'Albanien',
    'Jo' => 'Asien',
    'Joa' => 'Främre Asien',
    'Joaa' => 'Mindre Asien',
    'Joab' => 'Cypern',
    'Joac' => 'Kaukasien',
    'Joacb' => 'Armenien',
    'Joae' => 'Syrien och Libanon',
    'Joaea' => 'Syrien',
    'Joaeb' => 'Libanon',
    'Joaf' => 'Palestina och Israel',
    'Joag' => 'Jordanien',
    'Joah' => 'Arabien',
    'Joai' => 'Mesopotamien',
    'Joak' => 'Persien',
    'Joal' => 'Afghanistan',
    'Joam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska Centralasien)',
    'Job' => 'Främre Indien',
    'Joba' => 'Indien',
    'Jobb' => 'Pakistan och Bangladesh',
    'Jobd' => 'Nepal',
    'Jobe' => 'Sri Lanka (f d Ceylon)',
    'Joc' => 'Bortre Indien',
    'Joca' => 'Myanmar (f d Burma)',
    'Jocb' => 'Thailand',
    'Jocc' => 'Malaysia, Singapore och Brunei',
    'Jocd' => 'Indokina',
    'Jod' => 'Ostindiska öarna',
    'Joda' => 'Indonesien',
    'Jodc' => 'Filippinerna',
    'Joe' => 'Östasien',
    'Joea' => 'Kina',
    'Joeak' => 'Tibet',
    'Joeb' => 'Korea',
    'Joec' => 'Japan',
    'Jof' => 'Centralasien',
    'Jofc' => 'Mongoliet',
    'Jog' => 'Sibirien',
    'Jp' => 'Afrika',
    'Jpa' => 'Nordafrika utom Egypten',
    'Jpaa' => 'Marocko och Kanarieöarna',
    'Jpab' => 'Algeriet',
    'Jpac' => 'Tunisien',
    'Jpad' => 'Libyen',
    'Jpb' => 'Egypten och Sudan',
    'Jpba' => 'Egypten',
    'Jpbb' => 'Sudan',
    'Jpc' => 'Västafrika',
    'Jpd' => 'Centralafrika',
    'Jpe' => 'Södra Afrika',
    'Jpf' => 'Östafrika',
    'Jpg' => 'Nordöstafrika (Afrikas horn)',
    'Jq' => 'Amerika',
    'Jqa' => 'Förenta staterna',
    'Jqb' => 'Kanada',
    'Jqc' => 'Centralamerika, Mexiko och Västindien (inkl maya)',
    'Jqca' => 'Mexiko (inkl aztekerna)',
    'Jqd' => 'Sydamerika',
    'Jqdk' => 'Peru (inkl inka)',
    'Jr' => 'Australien och Oceanien',
    'Jra' => 'Australien',
    'Jrb' => 'Nya Zeeland',
    'Jrc' => 'Melanesien, Polynesien och Mikronesien',
    'Js' => 'Polarländerna',
    'K' => 'Historia',
    'K(x)' => 'Historiska lexikon',
    'K:bf' => 'Historiska organisationer och institutioner',
    'K:d' => 'Historisk teori, filosofi och metodlära',
    'K:dd' => 'Metodlära',
    'K:k' => 'Historieforskningens historia',
    'K:k.' => 'Särskilda perioder',
    'K:k.2' => 'Forntiden',
    'K:k.23' => 'Antikens historia: allmänt',
    'K:k.24' => 'Den grekiska forntiden',
    'K:k.26' => 'Den romerska forntiden',
    'K:k.3' => 'Medeltiden',
    'K:k.4' => 'Nya tiden',
    'K:k.5' => '1914-',
    'K:k.6' => '2000-',
    'K:kc' => 'Sverige',
    'K.' => 'Allmänt: särskilda historiska perioder',
    'K.2' => 'Forntiden',
    'K.21' => 'Egypten (till 639 e Kr)',
    'K.22' => 'Främre Asien',
    'K.221' => 'Mesopotamien (inkl sumererna, Assyrien, Babylonien)',
    'K.223' => 'Syrien, Fenicien och Palestina (inkl judarnas historia före 70 e Kr)',
    'K.224' => 'Kartago',
    'K.226' => 'Mindre Asien (inkl lyderna, Pergamon m m)',
    'K.227' => 'Araberna under forntiden',
    'K.228' => 'Perserriket',
    'K.23' => 'Antikens historia: allmänt',
    'K.24' => 'Den grekiska forntiden',
    'K.241' => 'Före ca 500 f Kr',
    'K.243' => 'Den klassiska tiden ca 500-336 f Kr',
    'K.245' => 'Den hellenistiska tiden ca 336-31 f Kr',
    'K.246' => 'Romartiden 31 f Kr - 476 e Kr',
    'K.249' => 'Särskilda grekiska stater',
    'K.26' => 'Den romerska forntiden',
    'K.261' => 'Konungatiden och republiken till 31 f Kr',
    'K.264' => 'Kejsartiden 31 f Kr - 476 e Kr',
    'K.268' => 'Italien (utom Romerska riket)',
    'K.269' => 'Romerska rikets provinser',
    'K.269-' => 'Särskilda länder och områden',
    'K.269-e' => 'Brittiska öarna (Storbritannien)',
    'K.269-f' => 'Mellaneuropa',
    'K.269-fa' => 'Tyskland',
    'K.269-fb' => 'Österrike och Liechtenstein',
    'K.269-fc' => 'Ungern',
    'K.269-g' => 'Nederländerna, Belgien och Luxemburg',
    'K.269-h' => 'Schweiz',
    'K.269-j' => 'Frankrike och Monaco',
    'K.269-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'K.269-l' => 'Portugal',
    'K.269-n' => 'Balkanländerna',
    'K.269-na' => 'Rumänien',
    'K.269-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'K.269-nc' => 'Bulgarien',
    'K.269-nd' => 'Grekland',
    'K.269-o' => 'Asien',
    'K.269-oaa' => 'Turkiet',
    'K.269-oae' => 'Syrien och Libanon',
    'K.269-oaf' => 'Palestina',
    'K.269-p' => 'Afrika',
    'K.269-pa' => 'Nordafrika utom Egypten',
    'K.269-pb' => 'Egypten och Sudan',
    'K.29' => 'Germanerna under forntiden',
    'K.3' => 'Medeltiden (ca 500 - ca 1500)',
    'K.31' => 'Bysantinska riket 395-1453',
    'K.32' => 'Arabiska väldet: allmänt 622-1517',
    'K.33' => 'Äldre medeltiden ca 476-1050',
    'K.331' => 'Folkvandringarna',
    'K.333' => 'Karolingiska riket: allmänt 752-911',
    'K.35' => 'Högmedeltiden ca 1050-1300',
    'K.351' => 'Korstågen: allmänt',
    'K.38' => 'Senmedeltiden ca 1300-1500',
    'K.4' => 'Nya tiden (ca 1500-)',
    'K.41' => '1500-1648',
    'K.43' => '1648-1789',
    'K.45' => '1789-1815',
    'K.46' => '1815-1914',
    'K.5' => '1914-',
    'K.51' => 'Första världskriget 1914-1918',
    'K.51a' => 'Politisk historia',
    'K.51b' => 'Militär historia',
    'K.51ba' => 'Markoperationer',
    'K.51bb' => 'Sjöperationer',
    'K.51bc' => 'Flygoperationer',
    'K.51c' => 'Propaganda',
    'K.52' => 'Mellankrigstiden 1918-1939',
    'K.54' => 'Andra världskriget 1939-1945',
    'K.54a' => 'Politisk historia',
    'K.54b' => 'Militär historia',
    'K.54ba' => 'Markoperationer',
    'K.54bb' => 'Sjöperationer',
    'K.54bc' => 'Flygoperationer',
    'K.54c' => 'Propaganda',
    'K.55' => '1945-',
    'K.58' => '1980-',
    'K.59' => '1990-',
    'K.6' => '2000-',
    'Ka' => 'Europa: allmänt',
    'Ka.' => 'Särskilda historiska perioder',
    'Ka.2' => 'Forntiden',
    'Ka.3' => 'Medeltiden',
    'Ka.4' => 'Nya tiden',
    'Ka.46' => '1800-talet',
    'Ka.5' => '1914-',
    'Ka.51' => 'Första världskriget 1914-1918',
    'Ka.52' => 'Mellankrigstiden 1918-1939',
    'Ka.54' => 'Andra världskriget 1939-1945',
    'Ka.55' => '1945-',
    'Ka.58' => '1980-',
    'Ka.59' => '1989-',
    'Ka.6' => '2000-',
    'Kae' => 'Europeiska unionen (EU)',
    'Kak' => 'Kelternas historia',
    'Kb' => 'Norden: allmänt',
    'Kb.' => 'Särskilda historiska perioder',
    'Kb.2' => 'Forntiden till ca 1050 (inkl vikingafärderna)',
    'Kb.3' => 'Medeltiden ca 1050 - ca 1520 (inkl Kalmarunionen)',
    'Kb.4' => 'Nya tiden ca 1520-',
    'Kb.45' => 'Svensk-norska unionen 1814-1905 (endast unionsfrågan)',
    'Kb.46' => 'Skandinavismen',
    'Kb.5' => '1900-talet',
    'Kb.51' => 'Första världskriget 1914-1918',
    'Kb.52' => 'Mellankrigstiden 1918-1939',
    'Kb.54' => 'Andra världskriget 1939-1945',
    'Kb.55' => '1945-',
    'Kb.58' => '1980-',
    'Kb.59' => '1994-',
    'Kb.6' => '2000-',
    'Kbc' => 'Nordkalottens historia',
    'Kc' => 'Sverige',
    'Kc:bf' => 'Historiska organisationer och institutioner',
    'Kc.' => 'Särskilda historiska perioder',
    'Kc.2' => 'Forntiden till ca 1060',
    'Kc.3' => 'Medeltiden ca 1060-1520',
    'Kc.31' => 'Äldre medeltiden ca 1060-1319',
    'Kc.34' => 'Senare medeltiden 1319-1520',
    'Kc.4' => 'Nya tiden 1520-',
    'Kc.41' => 'Vasatiden 1520-1611',
    'Kc.411' => 'Gustav Vasa 1521-1560',
    'Kc.413' => 'Erik XIV 1560-1568',
    'Kc.415' => 'Johan III 1568-1592',
    'Kc.417' => 'Sigismund 1592-1599',
    'Kc.418' => 'Karl IX 1599-1611',
    'Kc.42' => 'Stormaktstiden 1611-1718',
    'Kc.421' => 'Gustav II Adolf 1611-1632',
    'Kc.423' => 'Kristina 1632-1654',
    'Kc.425' => 'Karl X Gustav 1654-1660',
    'Kc.426' => 'Karl XI 1660-1697',
    'Kc.428' => 'Karl XII 1697-1718',
    'Kc.43' => '1700-talet',
    'Kc.44' => 'Frihetstiden 1718-1772',
    'Kc.441' => 'Ulrika Eleonora 1719-1720',
    'Kc.442' => 'Fredrik I 1720-1751',
    'Kc.445' => 'Adolf Fredrik 1751-1771',
    'Kc.45' => 'Gustavianska tiden 1772-1809',
    'Kc.451' => 'Gustav III 1771-1792',
    'Kc.455' => 'Gustav IV Adolf 1792-1809',
    'Kc.46' => '1800-talet',
    'Kc.47' => '1809-1844',
    'Kc.48' => '1844-1865',
    'Kc.49' => '1865-1905',
    'Kc.5' => '1905-',
    'Kc.51' => 'Första världskriget 1914-1918',
    'Kc.52' => 'Mellankrigstiden 1918-1939',
    'Kc.54' => 'Andra världskriget 1939-1945',
    'Kc.55' => '1945-',
    'Kc.58' => '1980-',
    'Kc.59' => '1994-',
    'Kc.6' => '2000-',
    'Kcs' => 'Samernas historia',
    'Kcs-c' => 'Sverige',
    'Kcs-d' => 'Norge och Finland',
    'Kcs-ma' => 'Ryssland',
    'Kcx' => 'Svenskar i utlandet',
    'Kcx-' => 'Särskilda länder och områden',
    'Kcx-a' => 'Europa: allmänt',
    'Kcx-c' => 'Sverige (Svenska emigrantinstitutet m m)',
    'Kcx-d' => 'Övriga Norden',
    'Kcx-e' => 'Brittiska öarna (Storbritannien)',
    'Kcx-f' => 'Mellaneuropa',
    'Kcx-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kcx-j' => 'Frankrike och Monaco',
    'Kcx-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kcx-m' => 'Östeuropa',
    'Kcx-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kcx-mc' => 'Estland, Lettland, Litauen',
    'Kcx-mca' => 'Estland',
    'Kcx-n' => 'Balkanländerna',
    'Kcx-o' => 'Asien',
    'Kcx-p' => 'Afrika',
    'Kcx-q' => 'Amerika',
    'Kcx-qa' => 'Förenta staterna',
    'Kcx-qaa' => 'Nordöstra staterna',
    'Kcx-qab' => 'Sydöstra staterna',
    'Kcx-qac' => 'Södra centralstaterna',
    'Kcx-qad' => 'Norra centralstaterna',
    'Kcx-qae' => 'Bergsstaterna',
    'Kcx-qaf' => 'Stillahavsstaterna',
    'Kcx-qb' => 'Kanada',
    'Kcx-qc' => 'Mexiko, Centralamerika och Västindien',
    'Kcx-qd' => 'Sydamerika',
    'Kcx-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Kcx-s' => 'Polarländerna',
    'Kd' => 'Övriga Norden',
    'Kda' => 'Danmark',
    'Kda.' => 'Särskilda historiska perioder',
    'Kda.2' => 'Forntiden till ca 1050',
    'Kda.3' => 'Medeltiden ca 1050-1536',
    'Kda.4' => 'Nya tiden 1536-',
    'Kda.41' => '1536-1660',
    'Kda.43' => '1660-1814',
    'Kda.46' => '1800-1914',
    'Kda.5' => '1914-',
    'Kda.51' => 'Första världskriget 1914-1918',
    'Kda.52' => 'Mellankrigstiden 1918-1939',
    'Kda.54' => 'Andra världskriget 1939-1945',
    'Kda.55' => '1945-',
    'Kda.58' => '1980-',
    'Kda.59' => '1994-',
    'Kda.6' => '2000-',
    'Kdai' => 'Sönderjyllanda historia',
    'Kdax' => 'Danskar i utlandet',
    'Kdb' => 'Norge',
    'Kdb.' => 'Särskilda historiska perioder',
    'Kdb.2' => 'Forntiden till ca 1030',
    'Kdb.3' => 'Medeltiden ca 1030-1536',
    'Kdb.4' => 'Nya tiden 1536-',
    'Kdb.41' => '1536-1660',
    'Kdb.43' => '1660-1814',
    'Kdb.46' => '1814-1905',
    'Kdb.5' => '1905-',
    'Kdb.51' => 'Första världskriget 1914-1918',
    'Kdb.52' => 'Mellankrigstiden 1918-1939',
    'Kdb.54' => 'Andra världskriget 1939-1945',
    'Kdb.55' => '1945-',
    'Kdb.58' => '1980-',
    'Kdb.59' => '1994-',
    'Kdb.6' => '2000-',
    'Kdbx' => 'Norrmän i utlandet',
    'Kdc' => 'Island och Färöarna',
    'Kdc.' => 'Island: särskilda historiska perioder',
    'Kdc.2' => 'Fristatstiden 870-1262',
    'Kdc.3' => 'Island under Norge 1262-1537',
    'Kdc.4' => 'Nya tiden 1537-',
    'Kdc.5' => '1900-talet',
    'Kdc.54' => 'Andra världskriget 1939-1945',
    'Kdc.55' => '1944-',
    'Kdc.6' => '2000-',
    'Kdcf' => 'Färöarna',
    'Kdcx' => 'Islänningar i utlandet',
    'Kdd' => 'Finland',
    'Kdd.' => 'Finland: särskilda perioder',
    'Kdd.2' => 'Forntiden till ca 1060',
    'Kdd.3' => 'Medeltiden ca 1060-1520',
    'Kdd.31' => 'Äldre medeltiden ca 1060-1319',
    'Kdd.34' => 'Senare medeltiden 1319-1520',
    'Kdd.4' => 'Nya tiden 1520-',
    'Kdd.41' => 'Vasatiden 1520-1611',
    'Kdd.42' => 'Stormaktstiden 1611-1718',
    'Kdd.43' => '1700-talet',
    'Kdd.44' => 'Frihetstiden 1718-1772',
    'Kdd.45' => 'Gustavianska tiden 1772-1809',
    'Kdd.46' => 'Finland under Ryssland 1809-1918',
    'Kdd.5' => '1918-',
    'Kdd.51' => 'Finska inbördeskriget 1918',
    'Kdd.52' => 'Mellankrigstiden 1918-1939',
    'Kdd.54' => 'Andra världskriget 1939-1945',
    'Kdd.55' => '1945-',
    'Kdd.58' => '1980-',
    'Kdd.59' => '1994-',
    'Kdd.6' => '2000-',
    'Kddx' => 'Finländare i utlandet',
    'Kddå' => 'Åland',
    'Ke' => 'Brittiska öarna (Storbritannien)',
    'Ke.' => 'Särskilda historiska perioder',
    'Ke.2' => 'Före 1066',
    'Ke.3' => 'Medeltiden 1066-1485',
    'Ke.31' => '1066-1154',
    'Ke.32' => '1154-1399',
    'Ke.33' => '1399-1485',
    'Ke.4' => 'Nya tiden 1485-',
    'Ke.41' => '1485-1603',
    'Ke.42' => '1603-1714',
    'Ke.44' => '1714-1815',
    'Ke.46' => '1800-1914',
    'Ke.5' => '1914-',
    'Ke.51' => 'Första världskriget 1914-1918',
    'Ke.52' => 'Mellankrigstiden 1918-1939',
    'Ke.54' => 'Andra världskriget 1939-1945',
    'Ke.55' => '1945-',
    'Ke.58' => '1980-',
    'Ke.59' => '1994-',
    'Ke.6' => '2000-',
    'Ker' => 'Wales',
    'Kes' => 'Skottland',
    'Kes.' => 'Särskilda historiska perioder',
    'Kes.2' => 'Före 1066',
    'Kes.3' => 'Medeltiden 1066-1485',
    'Kes.4' => 'Nya tiden 1485-',
    'Kes.41' => '1485-1603',
    'Kes.42' => '1603-1714',
    'Kes.44' => '1714-1815',
    'Kes.46' => '1800-1914',
    'Kes.5' => '1914-',
    'Kes.6' => '2000-',
    'Ket' => 'Irland',
    'Ket.' => 'Särskilda historiska perioder',
    'Ket.2' => 'Före 1066',
    'Ket.3' => 'Medeltiden 1066-1485',
    'Ket.4' => 'Nya tiden 1485-',
    'Ket.41' => '1485-1603',
    'Ket.42' => '1603-1714',
    'Ket.44' => '1714-1815',
    'Ket.46' => '1800-1914',
    'Ket.5' => '1914-',
    'Ket.51' => 'Första världskriget 1914-1918',
    'Ket.52' => 'Mellankrigstiden 1918-1939',
    'Ket.54' => 'Andra världskriget 1939-1945',
    'Ket.55' => '1945-',
    'Ket.58' => '1980-',
    'Ket.59' => '1994-',
    'Ket.6' => '2000-',
    'Keta' => 'Irland (republiken)',
    'Ketb' => 'Nordirland',
    'Kex' => 'Engelsmän i utlandet',
    'Kex-' => 'Särskilda länder och områden',
    'Kex-c' => 'Sverige',
    'Kex-m' => 'Östeuropa',
    'Kex-o' => 'Asien',
    'Kex-oa' => 'Främre Asien',
    'Kex-ob' => 'Främre Indien',
    'Kex-oc' => 'Bortre Indien',
    'Kex-od' => 'Ostindiska öarna',
    'Kex-oe' => 'Östasien',
    'Kex-p' => 'Afrika',
    'Kex-q' => 'Amerika',
    'Kex-qa' => 'Förenta staterna',
    'Kex-qb' => 'Kanada',
    'Kex-qc' => 'Mexiko, Centralamerika och Västindien',
    'Kex-qd' => 'Sydamerika',
    'Kex-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Key' => 'Det brittiska kolonialväldet',
    'Kf' => 'Mellaneuropa',
    'Kf.' => 'Allmänt: särskilda historiska perioder',
    'Kf.2' => 'Forntiden',
    'Kf.3' => 'Medeltiden',
    'Kf.4' => 'Nya tiden',
    'Kf.5' => '1900-talet',
    'Kf.6' => '2000-',
    'Kfa' => 'Tyskland',
    'Kfa.' => 'Särskilda historiska perioder',
    'Kfa.2' => 'Före 843',
    'Kfa.3' => '843 - ca 1500',
    'Kfa.31' => '843-1254',
    'Kfa.32' => '1254-1519',
    'Kfa.36' => 'Hansan',
    'Kfa.4' => 'Ca 1500-',
    'Kfa.41' => '1500-1648',
    'Kfa.43' => '1648-1806',
    'Kfa.46' => '1806-1870',
    'Kfa.47' => '1870-1918',
    'Kfa.5' => '1900-talet',
    'Kfa.51' => 'Första världskriget 1914-1918',
    'Kfa.52' => '1918-1933',
    'Kfa.53' => '1933-1945',
    'Kfa.54' => 'Andra världskriget 1939-1945',
    'Kfa.55' => '1945-',
    'Kfa.57' => '1972-',
    'Kfa.59' => '1990-',
    'Kfa.6' => '2000-',
    'Kfaa' => 'Preussen (inkl Brandenburg)',
    'Kfaa.' => 'Särskilda historiska perioder',
    'Kfaa.3' => '843 - ca 1500',
    'Kfaa.4' => 'Ca 1500-',
    'Kfaa.41' => '1500-1648',
    'Kfaa.43' => '1648-1806',
    'Kfaa.46' => '1806-1870',
    'Kfaa.47' => '1870-1918',
    'Kfaa.5' => '1900-talet',
    'Kfaa.6' => '2000-',
    'Kfac' => 'Pommern',
    'Kfae' => 'Bayern',
    'Kfag' => 'Västtyskland (1945-1990)',
    'Kfag.' => 'Särskilda historiska perioder',
    'Kfag.55' => '1949-1990',
    'Kfag.57' => '1972-1990',
    'Kfah' => 'Östtyskland (1945-1990)',
    'Kfah.' => 'Särskilda historiska perioder',
    'Kfah.55' => '1949-1990',
    'Kfah.57' => '1972-1990',
    'Kfai' => 'Berlin',
    'Kfax' => 'Tyskar i utlandet',
    'Kfay' => 'Tyska kolonialväldet',
    'Kfaz' => 'Övriga särskilda tyska områdens historia',
    'Kfb' => 'Österrike och Liechtenstein',
    'Kfb.' => 'Österrike: särskilda historiska perioder',
    'Kfb.2' => 'Forntiden',
    'Kfb.3' => 'Medeltiden',
    'Kfb.4' => 'Nya tiden',
    'Kfb.46' => '1800-talet',
    'Kfb.5' => '1900-talet',
    'Kfb.51' => 'Första världskriget 1914-1918',
    'Kfb.52' => 'Mellankrigstiden 1918-1939',
    'Kfb.54' => 'Andra världskriget 1939-1945',
    'Kfb.55' => '1945-',
    'Kfb.58' => '1980-',
    'Kfb.59' => '1994-',
    'Kfb.6' => '2000-',
    'Kfbi' => 'Liechtenstein',
    'Kfbx' => 'Österrikare i utlandet',
    'Kfc' => 'Ungern',
    'Kfc.' => 'Särskilda historiska perioder',
    'Kfc.2' => 'Forntiden',
    'Kfc.3' => 'Medeltiden',
    'Kfc.4' => 'Nya tiden',
    'Kfc.46' => '1800-talet',
    'Kfc.5' => '1900-talet',
    'Kfc.51' => 'Första världskriget 1914-1918',
    'Kfc.52' => 'Mellankrigstiden 1918-1939',
    'Kfc.54' => 'Andra världskriget 1939-1945',
    'Kfc.55' => '1945-',
    'Kfc.56' => '1956-',
    'Kfc.58' => '1980-',
    'Kfc.59' => '1989-',
    'Kfc.6' => '2000-',
    'Kfcx' => 'Ungrare i utlandet',
    'Kfd' => 'Tjeckoslovakien (Tjeckien och Slovakien)',
    'Kfd.' => 'Särskilda historiska perioder',
    'Kfd.3' => 'Medeltiden',
    'Kfd.4' => 'Nya tiden',
    'Kfd.5' => '1900-talet',
    'Kfd.51' => 'Första världskriget 1914-1918',
    'Kfd.52' => 'Mellankrigstiden 1918-1939',
    'Kfd.54' => 'Andra världskriget 1939-1945',
    'Kfd.55' => '1945-',
    'Kfd.57' => '1968-',
    'Kfd.58' => '1980-',
    'Kfd.59' => '1993-',
    'Kfd.6' => '2000-',
    'Kfda' => 'Tjeckien 1993-',
    'Kfdb' => 'Slovakien 1993-',
    'Kfdx' => 'Tjecker och slovaker i utlandet',
    'Kg' => 'Nederländerna, Belgien och Luxemburg',
    'Kg.' => 'Allmänt: särskilda historiska perioder',
    'Kg.3' => 'Medeltiden',
    'Kg.4' => 'Nya tiden',
    'Kg.5' => '1914-',
    'Kg.6' => '2000-',
    'Kga' => 'Nederländerna',
    'Kga.' => 'Särskilda historiska perioder',
    'Kga.3' => 'Medeltiden',
    'Kga.4' => 'Nya tiden',
    'Kga.41' => '1572-1648',
    'Kga.43' => '1648-1795',
    'Kga.45' => '1795-1830',
    'Kga.46' => '1800-talet',
    'Kga.5' => '1914-',
    'Kga.51' => 'Första världskriget 1914-1918',
    'Kga.52' => 'Mellankrigstiden 1918-1939',
    'Kga.54' => 'Andra världskriget 1939-1945',
    'Kga.55' => '1945-',
    'Kga.6' => '2000-',
    'Kgax' => 'Nederländare i utlandet',
    'Kgay' => 'Det nederländska kolonialväldet',
    'Kgb' => 'Belgien',
    'Kgb.' => 'Särskilda historiska perioder',
    'Kgb.3' => 'Medeltiden',
    'Kgb.4' => 'Nya tiden',
    'Kgb.43' => '1648-1795',
    'Kgb.45' => '1795-1830',
    'Kgb.46' => '1800-talet',
    'Kgb.5' => '1914-',
    'Kgb.51' => 'Första världskriget 1914-1918',
    'Kgb.52' => 'Mellankrigstiden 1918-1939',
    'Kgb.54' => 'Andra världskriget 1939-1945',
    'Kgb.55' => '1945-',
    'Kgb.6' => '2000-',
    'Kgbx' => 'Belgare i utlandet',
    'Kgby' => 'Det belgiska kolonialväldet',
    'Kgc' => 'Luxemburg',
    'Kh' => 'Schweiz',
    'Kh.' => 'Särskilda historiska perioder',
    'Kh.2' => 'Forntiden',
    'Kh.3' => 'Medeltiden',
    'Kh.4' => 'Nya tiden',
    'Kh.41' => '1500-1648',
    'Kh.43' => '1648-1789',
    'Kh.45' => '1789-1815',
    'Kh.46' => '1815-1914',
    'Kh.5' => '1914-',
    'Kh.51' => 'Första världskriget 1914-1918',
    'Kh.52' => 'Mellankrigstiden 1918-1939',
    'Kh.54' => 'Andra världskriget 1939-1945',
    'Kh.55' => '1945-',
    'Kh.58' => '1980-',
    'Kh.59' => '1989-',
    'Kh.6' => '2000-',
    'Khx' => 'Schweizare i utlandet',
    'Ki' => 'Italien',
    'Ki.' => 'Särskilda historiska perioder (utom antiken)',
    'Ki.3' => 'Medeltiden ca 476-1400',
    'Ki.4' => 'Nya tiden 1400-',
    'Ki.41' => '1400-1550',
    'Ki.43' => '1550-1815',
    'Ki.46' => '1815-1870',
    'Ki.47' => '1870-1914',
    'Ki.5' => '1914-',
    'Ki.51' => 'Första världskriget 1914-1918',
    'Ki.52' => '1918-1943',
    'Ki.54' => 'Andra världskriget 1939-1945',
    'Ki.55' => '1945-',
    'Ki.58' => '1980-',
    'Ki.59' => '1994-',
    'Ki.6' => '2000-',
    'Kid' => 'Genua',
    'Kie' => 'Venedig',
    'Kif' => 'Sardinien',
    'Kig' => 'Rom och Kyrkostaten, Vatikanstaten',
    'Kig.' => 'Särskilda historiska perioder (utom antiken)',
    'Kig.3' => 'Medeltiden ca 476-1400',
    'Kig.4' => 'Nya tiden 1400-',
    'Kig.41' => '1400-1550',
    'Kig.43' => '1550-1815',
    'Kig.46' => '1815-1870',
    'Kig.47' => '1870-1914',
    'Kig.5' => '1914-',
    'Kig.6' => '2000-',
    'Kih' => 'Florens och Toscana',
    'Kij' => 'San Marino',
    'Kik' => 'Neapel',
    'Kil' => 'Sicilien',
    'Kiv' => 'Malta',
    'Kix' => 'Italienare i utlandet',
    'Kiy' => 'Italiens kolonialvälde',
    'Kj' => 'Frankrike',
    'Kj.' => 'Särskilda historiska perioder',
    'Kj.2' => 'Före 987',
    'Kj.3' => 'Medeltiden 987-1498',
    'Kj.31' => '987-1328',
    'Kj.32' => '1328-1498',
    'Kj.39' => 'Burgund',
    'Kj.4' => 'Nya tiden 1498-',
    'Kj.41' => '1498-1610',
    'Kj.42' => '1610-1715',
    'Kj.44' => '1715-1789',
    'Kj.45' => 'Franska revolutionen och Napoleon 1789-1815',
    'Kj.451' => 'Franska revolutionen',
    'Kj.452' => 'Napoleon',
    'Kj.46' => '1815-1870',
    'Kj.47' => '1870-1914',
    'Kj.5' => '1914-',
    'Kj.51' => 'Första världskriget 1914-1918',
    'Kj.52' => 'Mellankrigstiden 1918-1939',
    'Kj.54' => 'Andra världskriget 1939-1945',
    'Kj.55' => '1945-',
    'Kj.58' => '1981-',
    'Kj.59' => '1994-',
    'Kj.6' => '2000-',
    'Kjv' => 'Monaco',
    'Kjx' => 'Fransmän i utlandet',
    'Kjy' => 'Det franska kolonialväldet',
    'Kk' => 'Spanien',
    'Kk.' => 'Särskilda historiska perioder (exkl Spanien som del av det arabiska väldet)',
    'Kk.2' => 'Forntiden ca 400-711',
    'Kk.3' => 'Medeltiden 711-1479',
    'Kk.4' => 'Nya tiden 1479-',
    'Kk.41' => '1479-1648',
    'Kk.43' => '1648-1789',
    'Kk.45' => '1789-1815',
    'Kk.46' => '1815-1914',
    'Kk.5' => '1900-talet',
    'Kk.51' => 'Första världskriget 1914-1918',
    'Kk.52' => '1918-1931',
    'Kk.53' => '1931-1939',
    'Kk.54' => 'Andra världskriget 1939-1945',
    'Kk.55' => '1945-',
    'Kk.57' => '1975-',
    'Kk.59' => '1994-',
    'Kk.6' => '2000-',
    'Kkf' => 'Baskernas historia',
    'Kkk' => 'Gibraltar',
    'Kkx' => 'Spanjorer i utlandet',
    'Kky' => 'Det spanska kolonialväldet',
    'Kl' => 'Portugal',
    'Kl.' => 'Särskilda historiska perioder',
    'Kl.3' => 'Medeltiden 711-1500',
    'Kl.4' => 'Nya tiden 1500-',
    'Kl.41' => '1500-1648',
    'Kl.43' => '1648-1789',
    'Kl.45' => '1789-1815',
    'Kl.46' => '1815-1910',
    'Kl.5' => '1910-',
    'Kl.51' => 'Första världskriget 1914-1918',
    'Kl.52' => '1918-1933',
    'Kl.54' => 'Andra världskriget 1939-1945',
    'Kl.55' => '1945-',
    'Kl.57' => '1974-',
    'Kl.6' => '2000-',
    'Klx' => 'Portugiser i utlandet',
    'Kly' => 'Det portugisiska kolonialväldet',
    'Km' => 'Östeuropa',
    'Km.' => 'Särskilda historiska perioder',
    'Km.2' => 'Forntiden',
    'Km.3' => 'Medeltiden',
    'Km.4' => 'Nya tiden',
    'Km.41' => '1500-1648',
    'Km.43' => '1648-1789',
    'Km.45' => '1789-1815',
    'Km.46' => '1815-1914',
    'Km.5' => '1900-talet',
    'Km.51' => 'Första världskriget 1914-1918',
    'Km.52' => 'Mellankrigstiden 1918-1939',
    'Km.54' => 'Andra världskriget 1939-1945',
    'Km.55' => '1945-',
    'Km.58' => '1980-',
    'Km.59' => '1990-',
    'Km.6' => '2000-',
    'Kma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kma.' => 'Särskilda historiska perioder',
    'Kma.2' => 'Ryssland före 882',
    'Kma.3' => 'Medeltiden 882-1533',
    'Kma.4' => 'Nya tiden 1533-',
    'Kma.41' => '1533-1682',
    'Kma.43' => '1682-1796',
    'Kma.46' => '1796-1881',
    'Kma.47' => '1881-1917',
    'Kma.5' => 'Sovjetunionen 1917-1991 och Ryssland 1991-',
    'Kma.51' => 'Ryska revolutionen 1917',
    'Kma.52' => '1917-1939',
    'Kma.54' => 'Andra världskriget 1939-1945',
    'Kma.55' => '1945-',
    'Kma.58' => '1980-',
    'Kma.59' => 'Ryssland 1991-',
    'Kma.6' => '2000-',
    'Kmad' => 'Ukraina',
    'Kmad.' => 'Särskilda historiska perioder',
    'Kmad.2' => 'Ukraina före 882',
    'Kmad.3' => 'Medeltiden 882-1533',
    'Kmad.4' => 'Nya tiden 1533-',
    'Kmad.5' => '1917-',
    'Kmad.59' => '1991-',
    'Kmad.6' => '2000-',
    'Kmae' => 'Vitryssland',
    'Kmaf' => 'Moldavien',
    'Kmax' => 'Ryssar i utlandet',
    'Kmb' => 'Polen',
    'Kmb.' => 'Särskilda historiska perioder',
    'Kmb.3' => 'Medeltiden till 1515',
    'Kmb.4' => 'Nya tiden 1515-',
    'Kmb.41' => '1515-1772',
    'Kmb.43' => '1772-1795',
    'Kmb.46' => '1795-1914',
    'Kmb.5' => '1914-',
    'Kmb.51' => 'Första världskriget 1914-1918',
    'Kmb.52' => 'Mellankrigstiden 1918-1939',
    'Kmb.54' => 'Andra världskriget 1939-1945',
    'Kmb.55' => '1945-',
    'Kmb.58' => '1980-',
    'Kmb.59' => '1989-',
    'Kmb.6' => '2000-',
    'Kmbx' => 'Polacker i utlandet',
    'Kmc' => 'Estland, Lettland, Litauen',
    'Kmc.' => 'Särskilda historiska perioder',
    'Kmc.2' => 'Forntiden',
    'Kmc.3' => 'Medeltiden',
    'Kmc.4' => 'Nya tiden',
    'Kmc.41' => '1500-1648',
    'Kmc.43' => '1648-1789',
    'Kmc.45' => '1789-1815',
    'Kmc.46' => '1815-1914',
    'Kmc.5' => '1900-talet',
    'Kmc.51' => 'Första världskriget 1914-1918',
    'Kmc.52' => 'Mellankrigstiden 1918-1939',
    'Kmc.54' => 'Andra världskriget 1939-1945',
    'Kmc.55' => '1945-',
    'Kmc.58' => '1980-',
    'Kmc.59' => '1991-',
    'Kmc.6' => '2000-',
    'Kmca' => 'Estland',
    'Kmca.' => 'Särskilda historiska perioder',
    'Kmca.3' => 'Medeltiden',
    'Kmca.4' => 'Nya tiden',
    'Kmca.41' => '1500-1648',
    'Kmca.43' => '1648-1789',
    'Kmca.45' => '1789-1815',
    'Kmca.46' => '1815-1914',
    'Kmca.5' => '1900-talet',
    'Kmca.51' => 'Första världskriget 1914-1918',
    'Kmca.52' => 'Mellankrigstiden 1918-1939',
    'Kmca.54' => 'Andra världskriget 1939-1945',
    'Kmca.55' => '1945-',
    'Kmca.58' => '1980-',
    'Kmca.59' => '1991-',
    'Kmca.6' => '2000-',
    'Kmcax' => 'Ester i utlandet',
    'Kmcb' => 'Lettland',
    'Kmcb.' => 'Allmänt: särskilda historiska perioder',
    'Kmcb.3' => 'Medeltiden',
    'Kmcb.4' => 'Nya tiden',
    'Kmcb.41' => '1500-1648',
    'Kmcb.43' => '1648-1789',
    'Kmcb.45' => '1789-1815',
    'Kmcb.46' => '1815-1914',
    'Kmcb.5' => '1900-talet',
    'Kmcb.51' => 'Första världskriget 1914-1918',
    'Kmcb.52' => 'Mellankrigstiden 1918-1939',
    'Kmcb.54' => 'Andra världskriget 1939-1945',
    'Kmcb.55' => '1945-',
    'Kmcb.58' => '1980-',
    'Kmcb.59' => '1991-',
    'Kmcb.6' => '2000-',
    'Kmcbx' => 'Letter i utlandet',
    'Kmcc' => 'Litauen',
    'Kmcc.' => 'Särskilda historiska perioder',
    'Kmcc.3' => 'Medeltiden',
    'Kmcc.4' => 'Nya tiden',
    'Kmcc.5' => '1900-talet',
    'Kmcc.51' => 'Första världskriget 1914-1918',
    'Kmcc.52' => 'Mellankrigstiden 1918-1939',
    'Kmcc.54' => 'Andra världskriget 1939-1945',
    'Kmcc.55' => '1945-',
    'Kmcc.58' => '1980-',
    'Kmcc.59' => '1991-',
    'Kmcc.6' => '2000-',
    'Kmccx' => 'Litauer i utlandet',
    'Kn' => 'Balkanländerna',
    'Kn.' => 'Allmänt: särskilda historiska perioder',
    'Kn.2' => 'Forntiden',
    'Kn.3' => 'Medeltiden',
    'Kn.4' => 'Nya tiden',
    'Kn.46' => '1800-talet',
    'Kn.5' => '1900-talet',
    'Kn.51' => 'Första världskriget 1914-1918',
    'Kn.52' => 'Mellankrigstiden 1918-1939',
    'Kn.54' => 'Andra världskriget 1939-1945',
    'Kn.55' => '1945-',
    'Kn.58' => '1980-',
    'Kn.59' => '1991-',
    'Kn.6' => '2000-',
    'Kna' => 'Rumänien',
    'Kna.' => 'Särskilda historiska perioder',
    'Kna.2' => 'Forntiden',
    'Kna.3' => 'Medeltiden',
    'Kna.4' => 'Nya tiden',
    'Kna.46' => '1800-talet',
    'Kna.47' => '1862-1914',
    'Kna.5' => '1914-',
    'Kna.51' => 'Första världskriget 1914-1918',
    'Kna.52' => 'Mellankrigstiden 1918-1939',
    'Kna.54' => 'Andra världskriget 1939-1945',
    'Kna.55' => '1945-',
    'Kna.58' => '1980-',
    'Kna.59' => '1989-',
    'Kna.6' => '2000-',
    'Knax' => 'Rumäner i utlandet',
    'Knb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc.)',
    'Knb.' => 'Särskilda historiska perioder',
    'Knb.3' => 'Medeltiden',
    'Knb.4' => 'Nya tiden',
    'Knb.5' => '1900-talet',
    'Knb.51' => 'Första världskriget 1914-1918',
    'Knb.52' => 'Mellankrigstiden 1918-1939',
    'Knb.54' => 'Andra världskriget 1939-1945',
    'Knb.55' => '1945-',
    'Knb.58' => '1980-',
    'Knb.59' => '1991-',
    'Knb.6' => '2000-',
    'Knba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Knba.' => 'Särskilda historiska perioder',
    'Knba.3' => 'Medeltiden',
    'Knba.4' => 'Nya tiden',
    'Knba.5' => '1900-talet',
    'Knba.51' => 'Första världskriget 1914-1918',
    'Knba.52' => 'Mellankrigstiden 1918-1939',
    'Knba.54' => 'Andra världskriget 1939-1945',
    'Knba.55' => '1945-',
    'Knba.58' => '1980-',
    'Knba.59' => '1991-',
    'Knba.6' => '2000-',
    'Knbb' => 'Kroatien',
    'Knbc' => 'Slovenien',
    'Knbd' => 'Bosnien och Hercegovina',
    'Knbe' => 'Montenegro',
    'Knbf' => 'Makedonien',
    'Knc' => 'Bulgarien',
    'Knc.' => 'Särskilda historiska perioder',
    'Knc.3' => 'Medeltiden',
    'Knc.4' => 'Nya tiden',
    'Knc.5' => '1914-',
    'Knc.51' => 'Första världskriget 1914-1918',
    'Knc.52' => 'Mellankrigstiden 1918-1939',
    'Knc.54' => 'Andra världskriget 1939-1945',
    'Knc.55' => '1945-',
    'Knc.58' => '1980-',
    'Knc.59' => '1989-',
    'Knc.6' => '2000-',
    'Knd' => 'Grekland',
    'Knd.' => 'Särskilda historiska perioder (exkl antiken och bysantinska riket)',
    'Knd.4' => 'Nya tiden 1453-',
    'Knd.46' => '1821-1913',
    'Knd.5' => '1913-',
    'Knd.51' => '1913-1923',
    'Knd.52' => '1923-1939',
    'Knd.54' => '1939-1949',
    'Knd.55' => '1949-',
    'Knd.57' => '1974-',
    'Knd.59' => '1994-',
    'Knd.6' => '2000-',
    'Kndx' => 'Greker i utlandet',
    'Knf' => 'Albanien',
    'Knf.' => 'Särskilda historiska perioder',
    'Knf.3' => 'Medeltiden',
    'Knf.4' => 'Nya tiden',
    'Knf.5' => '1912-',
    'Knf.6' => '2000-',
    'Knfx' => 'Albaner i utlandet',
    'Ko' => 'Asien',
    'Ko.' => 'Allmänt: särskilda historiska perioder',
    'Ko.2' => 'Forntiden',
    'Ko.3' => 'Medeltiden',
    'Ko.4' => 'Nya tiden',
    'Ko.5' => '1900-talet',
    'Ko.52' => 'Mellankrigstiden 1918-1939',
    'Ko.54' => 'Andra världskriget 1939-1945',
    'Ko.55' => '1945-',
    'Ko.58' => '1980-',
    'Ko.59' => '1990-',
    'Ko.6' => '2000-',
    'Koa' => 'Främre Asien',
    'Koa.' => 'Särskilda historiska perioder',
    'Koa.3' => '640-1517',
    'Koa.4' => '1517-',
    'Koa.5' => '1914-',
    'Koa.52' => 'Mellankrigstiden 1918-1939',
    'Koa.54' => 'Andra världskriget 1939-1945',
    'Koa.55' => '1945-',
    'Koa.57' => '1967-',
    'Koa.58' => '1980-',
    'Koa.59' => '1990-',
    'Koa.6' => '2000-',
    'Koaa' => 'Turkiet',
    'Koaa.' => 'Särskilda historiska perioder',
    'Koaa.3' => '640-1517',
    'Koaa.4' => '1517-',
    'Koaa.5' => '1914-',
    'Koaa.52' => 'Mellankrigstiden 1918-1939',
    'Koaa.54' => 'Andra världskriget 1939-1945',
    'Koaa.55' => '1945-',
    'Koaa.57' => '1967-',
    'Koaa.58' => '1980-',
    'Koaa.59' => '1990-',
    'Koaa.6' => '2000-',
    'Koaax' => 'Turkar i utlandet',
    'Koab' => 'Cypern',
    'Koac' => 'Kaukasien',
    'Koac.' => 'Särskilda historiska perioder',
    'Koac.3' => '640-1517',
    'Koac.4' => '1517-',
    'Koac.5' => '1914-',
    'Koac.6' => '2000-',
    'Koaca' => 'Azerbajdzjan',
    'Koacb' => 'Armenien',
    'Koacc' => 'Georgien',
    'Koae' => 'Syrien och Libanon',
    'Koae.' => 'Särskilda historiska perioder',
    'Koae.3' => '640-1517',
    'Koae.4' => '1517-',
    'Koae.5' => '1914-',
    'Koae.6' => '2000-',
    'Koaea' => 'Syrien',
    'Koaeb' => 'Libanon',
    'Koaf' => 'Palestina och Israel',
    'Koaf.' => 'Palestina: särskilda historiska perioder',
    'Koaf.3' => '640-1517',
    'Koaf.4' => '1517-',
    'Koaf.5' => '1914-',
    'Koaf.52' => '1918-1939',
    'Koaf.54' => '1939-1945',
    'Koaf.55' => '1945-',
    'Koaf.57' => '1967-',
    'Koaf.58' => '1980-',
    'Koaf.59' => '1990-',
    'Koaf.6' => '2000-',
    'Koafh' => 'Judarnas historia',
    'Koafh-' => 'Särskilda länder och områden',
    'Koafh-a' => 'Europa: allmänt',
    'Koafh-a.' => 'Särskilda perioder',
    'Koafh-a.3' => 'Medetltiden',
    'Koafh-a.4' => 'Nya tiden',
    'Koafh-a.5' => '1914-',
    'Koafh-a.51' => 'Första världskriget 1914-1918',
    'Koafh-a.52' => 'Mellankrigstiden 1918-1939',
    'Koafh-a.54' => 'Andra världskriget 1939-1945',
    'Koafh-a.55' => '1945-',
    'Koafh-a.6' => '2000-',
    'Koafh-b' => 'Norden: allmänt',
    'Koafh-c' => 'Sverige',
    'Koafh-c.' => 'Särskilda historiska perioder',
    'Koafh-c.4' => 'Nya tiden 1520-',
    'Koafh-c.5' => '1905-',
    'Koafh-c.51' => 'Första världskriget 1914-1918',
    'Koafh-c.52' => 'Mellankrigstiden 1918-1939',
    'Koafh-c.54' => 'Andra världskriget 1939-1945',
    'Koafh-c.55' => '1945-',
    'Koafh-c.58' => '1980-',
    'Koafh-c.59' => '1994-',
    'Koafh-c.6' => '2000-',
    'Koafh-cz' => 'Särskilda orter',
    'Koafh-d' => 'Övriga Norden',
    'Koafh-da' => 'Danmark',
    'Koafh-db' => 'Norge',
    'Koafh-dd' => 'Finland',
    'Koafh-e' => 'Brittiska öarna (Storbritannien)',
    'Koafh-f' => 'Mellaneuropa',
    'Koafh-fa' => 'Tyskland',
    'Koafh-fa.' => 'Särskilda historiska perioder',
    'Koafh-fa.2' => 'Före 843',
    'Koafh-fa.3' => '843 - ca 1500',
    'Koafh-fa.4' => 'Ca 1500-',
    'Koafh-fa.41' => '1500-1648',
    'Koafh-fa.43' => '1648-1806',
    'Koafh-fa.46' => '1806-1870',
    'Koafh-fa.47' => '1870-1918',
    'Koafh-fa.5' => '1900-talet',
    'Koafh-fa.51' => 'Första världskriget 1914-1918',
    'Koafh-fa.52' => '1918-1933',
    'Koafh-fa.53' => '1933-1945',
    'Koafh-fa.54' => 'Andra världskriget 1939-1945',
    'Koafh-fa.55' => '1945-',
    'Koafh-fa.57' => '1972-',
    'Koafh-fa.59' => '1990-',
    'Koafh-fa.6' => '2000-',
    'Koafh-fb' => 'Österrike',
    'Koafh-fc' => 'Ungern',
    'Koafh-fd' => 'Tjeckien och Slovakien',
    'Koafh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Koafh-h' => 'Schweiz',
    'Koafh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Koafh-j' => 'Frankrike',
    'Koafh-k' => 'Spanien',
    'Koafh-l' => 'Portugal',
    'Koafh-m' => 'Östeuropa',
    'Koafh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Koafh-ma.' => 'Särskilda historiska perioder',
    'Koafh-ma.4' => 'Nya tiden 1533-',
    'Koafh-ma.46' => '1796-1881',
    'Koafh-ma.47' => '1881-1917',
    'Koafh-ma.5' => 'Sovjetunionen 1917-1991 och Ryssland 1991-',
    'Koafh-ma.51' => 'Ryska revolutionen 1917',
    'Koafh-ma.52' => '1917-1939',
    'Koafh-ma.54' => 'Andra världskriget 1939-1945',
    'Koafh-ma.55' => '1945-',
    'Koafh-ma.58' => '1980-',
    'Koafh-ma.59' => 'Ryssland 1991-',
    'Koafh-ma.6' => '2000-',
    'Koafh-mb' => 'Polen',
    'Koafh-mb.' => 'Särskilda historiska perioder',
    'Koafh-mb.3' => 'Medeltiden till 1515',
    'Koafh-mb.4' => 'Nya tiden 1515-',
    'Koafh-mb.41' => '1515-1772',
    'Koafh-mb.43' => '1772-1795',
    'Koafh-mb.46' => '1795-1914',
    'Koafh-mb.5' => '1914-',
    'Koafh-mb.51' => 'Första världskriget 1914-1918',
    'Koafh-mb.52' => 'Mellankrigstiden 1918-1939',
    'Koafh-mb.54' => 'Andra världskriget 1939-1945',
    'Koafh-mb.55' => '1945-',
    'Koafh-mb.6' => '2000-',
    'Koafh-mc' => 'Estland, Lettland, Litauen',
    'Koafh-mca' => 'Estland',
    'Koafh-mcb' => 'Lettland',
    'Koafh-mcc' => 'Litauen',
    'Koafh-n' => 'Balkanländerna',
    'Koafh-o' => 'Asien',
    'Koafh-oa' => 'Främre Asien',
    'Koafh-ob' => 'Främre Indien',
    'Koafh-oe' => 'Östasien',
    'Koafh-p' => 'Afrika',
    'Koafh-q' => 'Amerika',
    'Koafh-qa' => 'Förenta staterna',
    'Koafh-qb' => 'Kanada',
    'Koafh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Koafh-qd' => 'Sydamerika',
    'Koafh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Koafhy' => 'Antisemitisk propaganda',
    'Koafi' => 'Israel 1948-',
    'Koafi.' => 'Särskilda historiska perioder',
    'Koafi.55' => '1948-1967',
    'Koafi.57' => '1967-',
    'Koafi.58' => '1980-',
    'Koafi.59' => '1990-',
    'Koafi.6' => '2000-',
    'Koag' => 'Jordanien',
    'Koah' => 'Arabiska halvön',
    'Koah.' => 'Särskilda historiska perioder (utom forntiden och Arabiska väldet)',
    'Koah.3' => '640-1517',
    'Koah.4' => '1517-',
    'Koah.5' => '1914-',
    'Koah.6' => '2000-',
    'Koaha' => 'Saudi-Arabien',
    'Koahb' => 'Nordjemen',
    'Koahc' => 'Sydjemen',
    'Koahd' => 'Oman',
    'Koahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Koahf' => 'Kuwait',
    'Koai' => 'Irak',
    'Koai.' => 'Särskilda historiska perioder',
    'Koai.3' => '640-1517',
    'Koai.4' => '1517-',
    'Koai.5' => '1914-',
    'Koai.52' => 'Mellankrigstiden 1918-1939',
    'Koai.54' => 'Andra världskriget 1939-1945',
    'Koai.55' => '1945-',
    'Koai.56' => '1958-',
    'Koai.57' => '1967-',
    'Koai.58' => '1980-',
    'Koai.59' => '1990-',
    'Koai.6' => '2000-',
    'Koaj' => 'Kurdernas historia',
    'Koak' => 'Iran (Persien)',
    'Koak.' => 'Särskilda historiska perioder',
    'Koak.3' => '640-1517',
    'Koak.4' => '1517-',
    'Koak.5' => '1914-',
    'Koak.52' => 'Mellankrigstiden 1918-1939',
    'Koak.54' => 'Andra världskriget 1939-1945',
    'Koak.55' => '1945-',
    'Koak.57' => '1967-',
    'Koak.58' => '1979-',
    'Koak.59' => '1990-',
    'Koak.6' => '2000-',
    'Koal' => 'Afghanistan',
    'Koal.' => 'Särskilda historiska perioder',
    'Koal.3' => '640-1517',
    'Koal.4' => '1517-',
    'Koal.5' => '1914-',
    'Koal.6' => '2000-',
    'Koam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Koam.' => 'Särskilda historiska perioder',
    'Koam.3' => '640-1517',
    'Koam.4' => '1517-',
    'Koam.5' => '1914-',
    'Koam.6' => '2000-',
    'Koama' => 'Kazakstan',
    'Koamb' => 'Turkmenistan',
    'Koamc' => 'Uzbekistan',
    'Koamd' => 'Kirgisistan',
    'Koame' => 'Tadzjikistan',
    'Koas' => 'Syrianernas historia',
    'Koax' => 'Personer från Främre Asien i utlandet',
    'Kob' => 'Främre Indien',
    'Kob.' => 'Allmänt: särskilda historiska perioder',
    'Kob.2' => 'Före 647',
    'Kob.3' => '647-1526',
    'Kob.4' => '1526-',
    'Kob.5' => '1900-talet',
    'Kob.55' => '1947-',
    'Kob.57' => '1971-',
    'Kob.58' => '1980-',
    'Kob.59' => '1990-',
    'Kob.6' => '2000-',
    'Koba' => 'Indien 1947-',
    'Koba.' => 'Särskilda historiska perioder',
    'Koba.55' => '1947-1971',
    'Koba.57' => '1971-',
    'Koba.58' => '1980-',
    'Koba.59' => '1990-',
    'Koba.6' => '2000-',
    'Kobb' => 'Pakistan och Bangladesh',
    'Kobba' => 'Pakistan 1971-',
    'Kobbb' => 'Bangladesh 1971-',
    'Kobc' => 'Bhutan',
    'Kobd' => 'Nepal',
    'Kobe' => 'Sri Lanka (f d Ceylon)',
    'Kobf' => 'Maldiverna',
    'Kobx' => 'Personer från Främre Indien i utlandet',
    'Koc' => 'Bortre Indien',
    'Koc.' => 'Allmänt: särskilda historiska perioder',
    'Koc.2' => 'Forntiden',
    'Koc.3' => 'Medeltiden',
    'Koc.4' => 'Nya tiden',
    'Koc.5' => '1900-talet',
    'Koc.6' => '2000-',
    'Koca' => 'Myanmar (f d Burma)',
    'Kocb' => 'Thailand',
    'Kocc' => 'Malackahalvön och Brunei',
    'Kocca' => 'Malajiska federationen och Malaysia',
    'Koccb' => 'Singapore',
    'Koccd' => 'Brunei',
    'Kocd' => 'Indokina',
    'Kocd.' => 'Särskilda historiska perioder',
    'Kocd.4' => 'Nya tiden',
    'Kocd.5' => '1900-talet',
    'Kocd.55' => '1945-',
    'Kocd.57' => '1975-',
    'Kocd.6' => '2000-',
    'Kocda' => 'Laos',
    'Kocdb' => 'Kambodja',
    'Kocdc' => 'Vietnam',
    'Kocdc.' => 'Särskilda historiska perioder',
    'Kocdc.4' => 'Nya tiden',
    'Kocdc.5' => '1900-talet',
    'Kocdc.55' => '1945-',
    'Kocdc.56' => 'Vietnamkriget 1961-1975',
    'Kocdc.57' => '1975-',
    'Kocdc.6' => '2000-',
    'Kod' => 'Ostindiska öarna',
    'Koda' => 'Indonesien',
    'Koda.' => 'Särskilda historiska perioder',
    'Koda.4' => 'Nya tiden',
    'Koda.5' => '1900-talet',
    'Koda.52' => 'Mellankrigstiden 1918-1939',
    'Koda.54' => 'Andra världskriget 1939-1945',
    'Koda.55' => '1945-',
    'Koda.58' => '1980-',
    'Koda.59' => '1990-',
    'Koda.6' => '2000-',
    'Kodaa' => 'Sumatra',
    'Kodab' => 'Java',
    'Kodac' => 'Kalimantan (Borneo)',
    'Kodad' => 'Sulawesi (Celebes)',
    'Kodae' => 'Moluckerna',
    'Kodafa' => 'Östtimor',
    'Kodc' => 'Filippinerna',
    'Koe' => 'Östasien',
    'Koea' => 'Kina',
    'Koea.' => 'Särskilda historiska perioder',
    'Koea.2' => 'Före 589 e Kr',
    'Koea.3' => '589-1368',
    'Koea.4' => '1368-',
    'Koea.5' => '1911-',
    'Koea.55' => '1949-',
    'Koea.57' => '1976-',
    'Koea.59' => '1990-',
    'Koea.6' => '2000-',
    'Koeaf' => 'Taiwan',
    'Koeai' => 'Manchuriet',
    'Koeak' => 'Tibet',
    'Koeal' => 'Sinkiang (Xinjiang Uygur)',
    'Koeam' => 'Inre Mongoliet',
    'Koeax' => 'Kineser i utlandet',
    'Koeb' => 'Korea',
    'Koeb.' => 'Särskilda historiska perioder',
    'Koeb.2' => 'Före 668 e Kr',
    'Koeb.3' => '668-1392',
    'Koeb.4' => '1392-',
    'Koeb.5' => '1910-',
    'Koeb.55' => '1948- (inkl Koreakriget; endast Koreas samlade historia)',
    'Koeb.58' => '1980-',
    'Koeb.59' => '1990-',
    'Koeb.6' => '2000-',
    'Koeba' => 'Nordkorea 1948-',
    'Koebb' => 'Sydkorea 1948-',
    'Koebx' => 'Koreaner i utlandet',
    'Koec' => 'Japan',
    'Koec.' => 'Särskilda historiska perioder',
    'Koec.2' => 'Före 593 e Kr',
    'Koec.3' => '593-1600',
    'Koec.4' => '1600-',
    'Koec.43' => '1600-1867',
    'Koec.47' => '1867-1914',
    'Koec.5' => '1914-',
    'Koec.52' => '1918-1937',
    'Koec.54' => '1937-1945',
    'Koec.55' => '1945-',
    'Koec.58' => '1980-',
    'Koec.59' => '1990-',
    'Koec.6' => '2000-',
    'Koecx' => 'Japaner i utlandet',
    'Koek' => 'Hongkong och Macau',
    'Koeka' => 'Hongkong',
    'Koekc' => 'Macau',
    'Kof' => 'Centralasien',
    'Kof.' => 'Allmänt: särskilda historiska perioder',
    'Kof.2' => 'Forntiden',
    'Kof.3' => 'Medeltiden',
    'Kof.4' => 'Nya tiden',
    'Kof.5' => '1900-talet',
    'Kof.6' => '2000-',
    'Kofc' => 'Mongoliet',
    'Kog' => 'Sibirien',
    'Kp' => 'Afrika',
    'Kp.' => 'Allmänt: särskilda historiska perioder',
    'Kp.2' => 'Före ca 640',
    'Kp.3' => 'Ca 640 - ca 1500',
    'Kp.4' => '1500-',
    'Kp.46' => '1800-talet',
    'Kp.5' => '1900-talet',
    'Kp.51' => 'Första världskriget 1914-1918',
    'Kp.52' => 'Mellankrigstiden 1918-1939',
    'Kp.54' => 'Andra världskriget 1939-1945',
    'Kp.55' => '1945-',
    'Kp.56' => '1960-',
    'Kp.58' => '1980-',
    'Kp.59' => '1990-',
    'Kp.6' => '2000-',
    'Kpa' => 'Nordafrika utom Egypten',
    'Kpa.' => 'Särskilda historiska perioder',
    'Kpa.2' => 'Före ca 640',
    'Kpa.3' => 'Ca 640 - ca 1500',
    'Kpa.4' => '1500-',
    'Kpa.5' => '1900-talet',
    'Kpa.6' => '2000-',
    'Kpaa' => 'Marocko och Kanarieöarna',
    'Kpaa.' => 'Marocko: särskilda historiska perioder',
    'Kpaa.3' => 'Ca 640 - ca 1500',
    'Kpaa.4' => '1500-',
    'Kpaa.46' => '1800-talet',
    'Kpaa.5' => '1900-talet',
    'Kpaa.6' => '2000-',
    'Kpaai' => 'Kanarieöarna',
    'Kpab' => 'Algeriet',
    'Kpab.' => 'Särskilda historiska perioder',
    'Kpab.3' => 'Ca 640 - ca 1500',
    'Kpab.4' => '1500-',
    'Kpab.5' => '1900-talet',
    'Kpab.52' => 'Mellankrigstiden 1918-1939',
    'Kpab.54' => 'Andra världskriget 1939-1945',
    'Kpab.55' => '1945-',
    'Kpab.56' => '1962-',
    'Kpab.58' => '1980-',
    'Kpab.59' => '1990-',
    'Kpab.6' => '2000-',
    'Kpac' => 'Tunisien',
    'Kpad' => 'Libyen',
    'Kpb' => 'Egypten och Sudan',
    'Kpb.' => 'Särskilda historiska perioder',
    'Kpb.3' => 'Ca 640 - ca 1500',
    'Kpb.4' => '1500-',
    'Kpb.5' => '1900-talet',
    'Kpba' => 'Egypten',
    'Kpba.' => 'Särskilda historiska perioder (exkl forntiden)',
    'Kpba.3' => 'Ca 640 - ca 1500',
    'Kpba.4' => '1500-',
    'Kpba.46' => '1800-talet',
    'Kpba.5' => '1900-talet',
    'Kpba.51' => 'Första världskriget 1914-1918',
    'Kpba.52' => 'Mellankrigstiden 1918-1939',
    'Kpba.54' => 'Andra världskriget 1939-1945',
    'Kpba.55' => '1945-',
    'Kpba.56' => '1960-',
    'Kpba.57' => '1973-',
    'Kpba.59' => '1990-',
    'Kpba.6' => '2000-',
    'Kpbb' => 'Sudan',
    'Kpbb.' => 'Särskilda historiska perioder',
    'Kpbb.2' => 'Före ca 640',
    'Kpbb.3' => 'Ca 640 - ca 1500',
    'Kpbb.4' => '1500-',
    'Kpbb.46' => '1800-talet',
    'Kpbb.5' => '1900-talet',
    'Kpbb.55' => '1945-',
    'Kpbb.56' => '1956-',
    'Kpbb.58' => '1980-',
    'Kpbb.59' => '1990-',
    'Kpc' => 'Västafrika',
    'Kpc.' => 'Särskilda historiska perioder',
    'Kpc.2' => 'Före ca 640',
    'Kpc.3' => 'Ca 640 - ca 1500',
    'Kpc.4' => '1500-',
    'Kpc.46' => '1800-talet',
    'Kpc.5' => '1900-talet',
    'Kpc.6' => '2000-',
    'Kpcb' => 'Ekvatorialafrika',
    'Kpcba' => 'Tchad',
    'Kpcbb' => 'Centralafrikanska republiken',
    'Kpcbc' => 'Kongo (Brazzaville)',
    'Kpcbd' => 'Gabon',
    'Kpcbe' => 'Kamerun',
    'Kpcc' => 'Norra Västafrika',
    'Kpcca' => 'Västra Sahara',
    'Kpccb' => 'Mauretanien',
    'Kpccc' => 'Senegal',
    'Kpccd' => 'Gambia',
    'Kpcce' => 'Mali',
    'Kpccg' => 'Burkina Faso',
    'Kpcch' => 'Niger',
    'Kpcci' => 'Guinea-Bissau',
    'Kpccj' => 'Cap Verde',
    'Kpcck' => 'Guinea',
    'Kpccl' => 'Elfenbenskusten',
    'Kpccm' => 'Sierra Leone',
    'Kpccn' => 'Liberia',
    'Kpcd' => 'Södra Västafrika',
    'Kpcda' => 'Ghana',
    'Kpcda.' => 'Särskilda historiska perioder',
    'Kpcda.4' => '1500-',
    'Kpcda.5' => '1900-talet',
    'Kpcda.55' => '1945-',
    'Kpcda.56' => '1957-',
    'Kpcda.58' => '1980-',
    'Kpcda.59' => '1990-',
    'Kpcda.6' => '2000-',
    'Kpcdb' => 'Togo',
    'Kpcdc' => 'Benin',
    'Kpcdd' => 'Nigeria',
    'Kpcdd.' => 'Särskilda historiska perioder',
    'Kpcdd.4' => '1500-',
    'Kpcdd.5' => '1900-talet',
    'Kpcdd.55' => '1945-',
    'Kpcdd.56' => '1960-',
    'Kpcdd.58' => '1980-',
    'Kpcdd.59' => '1990-',
    'Kpcdd.6' => '2000-',
    'Kpcde' => 'Ekvatorialguinea',
    'Kpcdf' => 'Sao Thomé och Principe',
    'Kpd' => 'Centralafrika',
    'Kpd.' => 'Särskilda historiska perioder',
    'Kpd.4' => '1500-',
    'Kpd.5' => '1900-talet',
    'Kpd.6' => '2000-',
    'Kpda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Kpdaa' => 'Kongo (Kinshasa)',
    'Kpdaa.' => 'Särskilda historiska perioder',
    'Kpdaa.4' => '1500-',
    'Kpdaa.5' => '1900-talet',
    'Kpdaa.55' => '1945-',
    'Kpdaa.56' => '1960-',
    'Kpdaa.58' => '1980-',
    'Kpdaa.59' => '1990-',
    'Kpdaa.6' => '2000-',
    'Kpdab' => 'Rwanda',
    'Kpdac' => 'Burundi',
    'Kpdb' => 'Angola',
    'Kpdb.' => 'Särskilda historiska perioder',
    'Kpdb.4' => '1500-',
    'Kpdb.5' => '1900-talet',
    'Kpdb.55' => '1945-',
    'Kpdb.56' => '1960-',
    'Kpdb.57' => '1975-',
    'Kpdb.58' => '1980-',
    'Kpdb.59' => '1990-',
    'Kpdb.6' => '2000-',
    'Kpe' => 'Södra Afrika',
    'Kpe.' => 'Särskilda historiska perioder',
    'Kpe.4' => '1500-',
    'Kpe.5' => '1900-talet',
    'Kpe.55' => '1945-',
    'Kpe.56' => '1960-',
    'Kpe.58' => '1980-',
    'Kpe.59' => '1990-',
    'Kpe.6' => '2000-',
    'Kpea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Kpeaa' => 'Sydafrikanska republiken',
    'Kpeaa.' => 'Särskilda historiska perioder',
    'Kpeaa.4' => '1500-',
    'Kpeaa.46' => '1800-talet',
    'Kpeaa.5' => '1899-',
    'Kpeaa.55' => '1945-',
    'Kpeaa.56' => '1961-',
    'Kpeaa.58' => '1980-',
    'Kpeaa.59' => '1994-',
    'Kpeaa.6' => '2000-',
    'Kpeab' => 'Namibia',
    'Kpeab.' => 'Särskilda historiska perioder',
    'Kpeab.4' => '1500-',
    'Kpeab.5' => '1900-talet',
    'Kpeab.55' => '1945-',
    'Kpeab.56' => '1960-',
    'Kpeab.58' => '1980-',
    'Kpeab.59' => '1990-',
    'Kpeab.6' => '2000-',
    'Kpeac' => 'Lesotho',
    'Kpead' => 'Swaziland',
    'Kpeb' => 'Botswana',
    'Kpec' => 'Zimbabwe, Zambia, Malawi',
    'Kpeca' => 'Zimbabwe',
    'Kpeca.' => 'Särskilda historiska perioder',
    'Kpeca.3' => 'Ca 640 - ca 1500',
    'Kpeca.4' => '1500-',
    'Kpeca.5' => '1900-talet',
    'Kpeca.55' => '1945-',
    'Kpeca.56' => '1964-',
    'Kpeca.58' => '1980-',
    'Kpeca.59' => '1990-',
    'Kpeca.6' => '2000-',
    'Kpecb' => 'Zambia',
    'Kpecc' => 'Malawi',
    'Kped' => 'Mocambique',
    'Kped.' => 'Särskilda historiska perioder',
    'Kped.4' => '1500-',
    'Kped.5' => '1900-talet',
    'Kped.55' => '1945-',
    'Kped.56' => '1960-',
    'Kped.57' => '1875-',
    'Kped.58' => '1980-',
    'Kped.59' => '1990-',
    'Kped.6' => '2000-',
    'Kpee' => 'Madagaskar (Malagasy)',
    'Kpef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Kpeu' => 'Rasfrågan i Södra Afrika',
    'Kpf' => 'Östafrika',
    'Kpf.' => 'Särskilda historiska perioder',
    'Kpf.4' => '1500-',
    'Kpf.46' => '1800-talet',
    'Kpf.5' => '1900-talet',
    'Kpf.6' => '2000-',
    'Kpfa' => 'Uganda',
    'Kpfa.' => 'Särskilda historiska perioder',
    'Kpfa.4' => '1500-',
    'Kpfa.5' => '1900-talet',
    'Kpfa.55' => '1945-',
    'Kpfa.56' => '1962-',
    'Kpfa.58' => '1979-',
    'Kpfa.59' => '1990-',
    'Kpfa.6' => '2000-',
    'Kpfb' => 'Kenya',
    'Kpfb.' => 'Särskilda historiska perioder',
    'Kpfb.4' => '1500-',
    'Kpfb.46' => '1800-talet',
    'Kpfb.5' => '1900-talet',
    'Kpfb.55' => '1945-',
    'Kpfb.56' => '1963-',
    'Kpfb.58' => '1980-',
    'Kpfb.59' => '1990-',
    'Kpfb.6' => '2000-',
    'Kpfc' => 'Tanzania',
    'Kpfc.' => 'Särskilda historiska perioder',
    'Kpfc.3' => 'Ca 640 - ca 1500',
    'Kpfc.4' => '1500-',
    'Kpfc.5' => '1900-talet',
    'Kpfc.55' => '1945-',
    'Kpfc.56' => '1961-',
    'Kpfc.58' => '1980-',
    'Kpfc.59' => '1990-',
    'Kpfc.6' => '2000-',
    'Kpfcb' => 'Zanzibar',
    'Kpfd' => 'Öar i nordvästra Indiska Oceanen',
    'Kpg' => 'Nordöstafrika (Afrikas horn)',
    'Kpga' => 'Etiopien med Eritrea',
    'Kpga.' => 'Särskilda historiska perioder',
    'Kpga.3' => 'Ca 640 - ca 1500',
    'Kpga.4' => '1500-',
    'Kpga.46' => '1800-talet',
    'Kpga.5' => '1896-',
    'Kpga.52' => 'Mellankrigstiden 1918-1939',
    'Kpga.54' => 'Andra världskriget 1939-1945',
    'Kpga.55' => '1945-',
    'Kpga.56' => '1960-',
    'Kpga.57' => '1974-',
    'Kpga.58' => '1980-',
    'Kpga.59' => '1990-',
    'Kpga.6' => '2000-',
    'Kpgae' => 'Eritrea',
    'Kpgb' => 'Somalia',
    'Kpgc' => 'Djibouti',
    'Kq' => 'Amerika',
    'Kq.' => 'Allmänt: särskilda historiska perioder',
    'Kq.2' => 'Forntiden',
    'Kq.3' => 'Medeltiden',
    'Kq.4' => 'Nya tiden',
    'Kq.41' => '1500-1648',
    'Kq.43' => '1648-1789',
    'Kq.45' => '1789-1815',
    'Kq.46' => '1815-1914',
    'Kq.5' => '1900-talet',
    'Kq.51' => 'Första världskriget 1914-1918',
    'Kq.52' => 'Mellankrigstiden 1918-1939',
    'Kq.54' => 'Andra världskriget 1939-1945',
    'Kq.55' => '1945-',
    'Kq.58' => '1980-',
    'Kq.59' => '1990-',
    'Kq.6' => '2000-',
    'Kqa' => 'Förenta staterna',
    'Kqa.' => 'Särskilda historiska perioder',
    'Kqa.4' => 'Nordamerika under nya tiden',
    'Kqa.41' => 'Nordamerika före 1789',
    'Kqa.46' => '1789-1865',
    'Kqa.47' => '1865-1914',
    'Kqa.5' => '1900-talet',
    'Kqa.51' => 'Första världskriget 1914-1918',
    'Kqa.52' => 'Mellankrigstiden 1918-1939',
    'Kqa.54' => 'Andra världskriget 1939-1945',
    'Kqa.55' => '1945-',
    'Kqa.57' => '1975-',
    'Kqa.59' => '1990-',
    'Kqa.6' => '2000-',
    'Kqat' => 'Indianernas historia i Nordamerika',
    'Kqat.' => 'Särskilda historiska perioder',
    'Kqat.4' => 'Nordamerika under nya tiden',
    'Kqat.41' => 'Nordamerika före 1789',
    'Kqat.46' => '1789-1865',
    'Kqat.47' => '1865-1914',
    'Kqat.5' => '1900-talet',
    'Kqat.6' => '2000-',
    'Kqau' => 'Rasfrågan i Förenta staterna',
    'Kqau.' => 'Särskilda historiska perioder',
    'Kqau.4' => 'Nordamerika under nya tiden',
    'Kqau.41' => 'Nordamerika före 1789',
    'Kqau.46' => '1789-1865',
    'Kqau.47' => '1865-1914',
    'Kqau.5' => '1900-talet',
    'Kqau.52' => 'Mellankrigstiden 1918-1939',
    'Kqau.54' => 'Andra världskriget 1939-1945',
    'Kqau.55' => '1945-',
    'Kqau.57' => '1975-',
    'Kqau.59' => '1990-',
    'Kqau.6' => '2000-',
    'Kqax' => 'Amerikaner i utlandet',
    'Kqb' => 'Kanada',
    'Kqb.' => 'Särskilda historiska perioder',
    'Kqb.4' => 'Nya tiden',
    'Kqb.41' => '1500-1648',
    'Kqb.43' => '1648-1789',
    'Kqb.45' => '1789-1815',
    'Kqb.46' => '1815-1914',
    'Kqb.47' => '1867-',
    'Kqb.5' => '1900-talet',
    'Kqb.51' => 'Första världskriget 1914-1918',
    'Kqb.52' => 'Mellankrigstiden 1918-1939',
    'Kqb.54' => 'Andra världskriget 1939-1945',
    'Kqb.55' => '1945-',
    'Kqb.58' => '1980-',
    'Kqb.59' => '1990-',
    'Kqb.6' => '2000-',
    'Kqc' => 'Mexiko, Centralamerika och Västindien',
    'Kqc.' => 'Allmänt: särskilda historiska perioder',
    'Kqc.3' => 'Före 1492',
    'Kqc.4' => '1492-',
    'Kqc.46' => '1821-',
    'Kqc.5' => '1900-talet',
    'Kqc.55' => '1945-',
    'Kqc.58' => '1980-',
    'Kqc.59' => '1990-',
    'Kqc.6' => '2000-',
    'Kqca' => 'Mexiko',
    'Kqca.' => 'Särskilda historiska perioder',
    'Kqca.3' => 'Före 1492',
    'Kqca.4' => '1492-',
    'Kqca.46' => '1823-1911',
    'Kqca.5' => '1911-',
    'Kqca.55' => '1945-',
    'Kqca.58' => '1980-',
    'Kqca.59' => '1990-',
    'Kqca.6' => '2000-',
    'Kqcax' => 'Mexikaner i utlandet',
    'Kqcb' => 'Guatemala',
    'Kqcc' => 'Belize och Honduras',
    'Kqcca' => 'Brittiska Honduras och Belize',
    'Kqccb' => 'Honduras',
    'Kqcd' => 'El Salvador',
    'Kqce' => 'Nicaragua',
    'Kqce.' => 'Särskilda historiska perioder',
    'Kqce.3' => 'Före 1492',
    'Kqce.4' => '1492-',
    'Kqce.5' => '1900-talet',
    'Kqce.55' => '1945-',
    'Kqce.58' => '1979-',
    'Kqce.59' => '1990-',
    'Kqce.6' => '2000-',
    'Kqcf' => 'Costa Rica',
    'Kqcg' => 'Panama',
    'Kqch' => 'Västindien',
    'Kqcha' => 'Stora Antillerna',
    'Kqchaa' => 'Kuba',
    'Kqchaa.' => 'Särskilda historiska perioder',
    'Kqchaa.3' => 'Före 1492',
    'Kqchaa.4' => '1492-',
    'Kqchaa.46' => '1821-',
    'Kqchaa.5' => '1898-',
    'Kqchaa.55' => '1945-',
    'Kqchaa.56' => '1959-',
    'Kqchaa.58' => '1980-',
    'Kqchaa.59' => '1990-',
    'Kqchaa.6' => '2000-',
    'Kqchab' => 'Haiti',
    'Kqchac' => 'Dominikanska republiken',
    'Kqchad' => 'Puerto Rico',
    'Kqchae' => 'Jamaica',
    'Kqchb' => 'Små Antillerna',
    'Kqchc' => 'Bahamas',
    'Kqchd' => 'Bermuda',
    'Kqct' => 'Indianernas historia i Centralamerika',
    'Kqcx' => 'Personer från Mexico, Centralamerika och Västindien i utlandet',
    'Kqd' => 'Sydamerika',
    'Kqd.' => 'Allmänt: särskilda historiska perioder',
    'Kqd.4' => '1500-',
    'Kqd.46' => 'Ca 1820-',
    'Kqd.5' => '1900-talet',
    'Kqd.55' => '1945-',
    'Kqd.58' => '1980-',
    'Kqd.59' => '1990-',
    'Kqd.6' => '2000-',
    'Kqda' => 'Colombia',
    'Kqda.' => 'Särskilda historiska perioder',
    'Kqda.4' => '1500-',
    'Kqda.46' => '1819-',
    'Kqda.5' => '1900-talet',
    'Kqda.55' => '1945-',
    'Kqda.58' => '1980-',
    'Kqda.59' => '1990-',
    'Kqda.6' => '2000-',
    'Kqdb' => 'Venezuela',
    'Kqdc' => 'Guyanastaterna',
    'Kqdca' => 'Brittiska Guyana och Guyana',
    'Kqdcb' => 'Franska Guyana',
    'Kqdcc' => 'Holländska Guyana och Surinam',
    'Kqdd' => 'Brasilien',
    'Kqdd.' => 'Särskilda historiska perioder',
    'Kqdd.4' => '1500-',
    'Kqdd.46' => '1822-',
    'Kqdd.5' => '1900-talet',
    'Kqdd.55' => '1945-',
    'Kqdd.58' => '1980-',
    'Kqdd.59' => '1990-',
    'Kqdd.6' => '2000-',
    'Kqde' => 'Paraguay',
    'Kqdf' => 'Uruguay',
    'Kqdg' => 'Argentina',
    'Kqdg.' => 'Särskilda historiska perioder',
    'Kqdg.4' => '1500-',
    'Kqdg.46' => '1816-',
    'Kqdg.5' => '1900-talet',
    'Kqdg.55' => '1945-',
    'Kqdg.57' => '1973-',
    'Kqdg.58' => '1980-',
    'Kqdg.59' => '1990-',
    'Kqdg.6' => '2000-',
    'Kqdgi' => 'Falklandsöarna',
    'Kqdh' => 'Chile',
    'Kqdh.' => 'Särskilda historiska perioder',
    'Kqdh.4' => '1500-',
    'Kqdh.46' => '1818-',
    'Kqdh.5' => '1900-talet',
    'Kqdh.55' => '1945-',
    'Kqdh.57' => '1973-',
    'Kqdh.58' => '1980-',
    'Kqdh.59' => '1990-',
    'Kqdh.6' => '2000-',
    'Kqdi' => 'Bolivia',
    'Kqdk' => 'Peru',
    'Kqdk.' => 'Särskilda historiska perioder',
    'Kqdk.4' => '1500-',
    'Kqdk.46' => '1821-',
    'Kqdk.5' => '1900-talet',
    'Kqdk.55' => '1945-',
    'Kqdk.58' => '1980-',
    'Kqdk.59' => '1990-',
    'Kqdk.6' => '2000-',
    'Kqdl' => 'Ecuador',
    'Kqdt' => 'Indianernas historia i Sydamerika',
    'Kqdt.' => 'Särskilda historiska perioder',
    'Kqdt.4' => '1500-',
    'Kqdt.5' => '1900-talet',
    'Kqdt.6' => '2000-',
    'Kqdx' => 'Personer från Sydamerika i utlandet',
    'Kr' => 'Oceanien',
    'Kr.' => 'Allmänt: särskilda historiska perioder',
    'Kr.4' => 'Ca 1500-',
    'Kr.5' => '1900-talet',
    'Kr.6' => '2000-',
    'Kra' => 'Australien',
    'Kra.' => 'Allmänt: särskilda historiska perioder',
    'Kra.4' => 'Ca 1500',
    'Kra.5' => 'Australiska statsförbundet 1901-',
    'Kra.6' => '2000-',
    'Krb' => 'Nya Zeeland',
    'Krc' => 'Melanesien, Polynesien och Mikronesien',
    'Krca' => 'Melanesien',
    'Krcb' => 'Polynesien',
    'Krcc' => 'Mikronesien',
    'Krcd' => 'Isolerade öar i Stilla havet',
    'Krd' => 'Nya Guinea',
    'Ks' => 'Polarländerna',
    'Ksa' => 'Arktis',
    'Ksaa' => 'Grönland',
    'Ksab' => 'Spetsbergen',
    'Ksb' => 'Antarktis',
    'Kt' => 'Allmän kulturhistoria',
    'Kt.' => 'Särskilda historiska perioder',
    'Kt.2' => 'Forntiden',
    'Kt.21' => 'Egypten',
    'Kt.22' => 'Främre Asien',
    'Kt.23' => 'Antikens historia: allmänt',
    'Kt.24' => 'Den grekiska forntiden',
    'Kt.26' => 'Den romerska forntiden',
    'Kt.29' => 'Germanerna under forntiden',
    'Kt.3' => 'Medeltiden',
    'Kt.31' => 'Bysantinska riket 395-1453',
    'Kt.32' => 'Arabiska väldet 622-1517',
    'Kt.33' => 'Äldre medeltiden ca 476 - 1050',
    'Kt.35' => 'Högmedeltiden ca 1050 - 1300',
    'Kt.38' => 'Senmedeltiden ca 1300-1500',
    'Kt.4' => 'Nya tiden',
    'Kt.41' => '1500-1648',
    'Kt.43' => '1648-1789',
    'Kt.45' => '1789-1815',
    'Kt.46' => '1815-1914',
    'Kt.5' => '1914-',
    'Kt.51' => 'Första världskriget 1914-1918',
    'Kt.52' => 'Mellankrigstiden 1918-1939',
    'Kt.54' => 'Andra världskriget 1939-1945',
    'Kt.55' => '1945-',
    'Kt.58' => '1980-',
    'Kt.59' => '1990-',
    'Kt.6' => '2000-',
    'Kt-' => 'Särskilda länder och områden',
    'Kt-a' => 'Europa: allmänt',
    'Kt-b' => 'Norden: allmänt',
    'Kt-c' => 'Sverige',
    'Kt-c.' => 'Särskilda historiska perioder',
    'Kt-c.3' => 'Medeltiden ca 1060-1520',
    'Kt-c.4' => 'Nya tiden 1520-',
    'Kt-c.41' => 'Vasatiden 1520-1611',
    'Kt-c.42' => 'Stormaktstiden 1611-1718',
    'Kt-c.43' => '1700-talet',
    'Kt-c.44' => 'Frihetstiden 1718-1772',
    'Kt-c.45' => 'Gustavianska tiden 1772-1809',
    'Kt-c.46' => '1800-talet',
    'Kt-c.47' => '1809-1844',
    'Kt-c.48' => '1844-1865',
    'Kt-c.49' => '1865-1905',
    'Kt-c.5' => '1905-',
    'Kt-c.51' => 'Första världskriget 1914-1918',
    'Kt-c.52' => 'Mellankrigstiden 1918-1939',
    'Kt-c.54' => 'Andra världskriget 1939-1945',
    'Kt-c.55' => '1945-',
    'Kt-c.58' => '1980-',
    'Kt-c.6' => '2000-',
    'Kt-cs' => 'Samer',
    'Kt-d' => 'Övriga Norden',
    'Kt-da' => 'Danmark',
    'Kt-db' => 'Norge',
    'Kt-dc' => 'Island och Färöarna',
    'Kt-dd' => 'Finland',
    'Kt-e' => 'Brittiska öarna (Storbritannien)',
    'Kt-f' => 'Mellaneuropa',
    'Kt-fa' => 'Tyskland',
    'Kt-fb' => 'Österrike och Liechtenstein',
    'Kt-fc' => 'Ungern',
    'Kt-fd' => 'Tjeckien och Slovakien',
    'Kt-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kt-h' => 'Schweiz',
    'Kt-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kt-j' => 'Frankrike och Monaco',
    'Kt-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kt-l' => 'Portugal',
    'Kt-m' => 'Östeuropa',
    'Kt-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kt-mb' => 'Polen',
    'Kt-mc' => 'Estland, Lettland, Litauen',
    'Kt-n' => 'Balkanländerna',
    'Kt-na' => 'Rumänien',
    'Kt-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Kt-nc' => 'Bulgarien',
    'Kt-nd' => 'Grekland',
    'Kt-o' => 'Asien',
    'Kt-oa' => 'Främre Asien',
    'Kt-oafh' => 'Judar',
    'Kt-ob' => 'Främre Indien',
    'Kt-oc' => 'Bortre Indien',
    'Kt-od' => 'Ostindiska öarna',
    'Kt-oe' => 'Östasien',
    'Kt-oea' => 'Kina',
    'Kt-oeb' => 'Korea',
    'Kt-oec' => 'Japan',
    'Kt-of' => 'Centralasien',
    'Kt-og' => 'Sibirien',
    'Kt-p' => 'Afrika',
    'Kt-pa' => 'Nordafrika utom Egypten',
    'Kt-pb' => 'Egypten och Sudan',
    'Kt-pc' => 'Västafrika',
    'Kt-pd' => 'Centralafrika',
    'Kt-pe' => 'Södra Afrika',
    'Kt-pf' => 'Östafrika',
    'Kt-pg' => 'Nordöstafrika',
    'Kt-q' => 'Amerika',
    'Kt-qa' => 'Förenta staterna',
    'Kt-qb' => 'Kanada',
    'Kt-qc' => 'Mexiko, Centralamerika och Västindien',
    'Kt-qd' => 'Sydamerika',
    'Kt-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Kt-s' => 'Polarländerna',
    'Ku' => 'Allmän socialhistoria',
    'Ku.' => 'Särskilda historiska perioder',
    'Ku.2' => 'Forntiden',
    'Ku.21' => 'Egypten',
    'Ku.22' => 'Främre Asien',
    'Ku.23' => 'Antikens historia: allmänt',
    'Ku.24' => 'Den grekiska forntiden',
    'Ku.26' => 'Den romerska forntiden',
    'Ku.3' => 'Medeltiden',
    'Ku.31' => 'Bysantinska riket 395-1453',
    'Ku.32' => 'Arabiska väldet 622-1517',
    'Ku.33' => 'Äldre medeltiden ca 476 - 1050',
    'Ku.35' => 'Högmedeltiden ca 1050 - 1300',
    'Ku.38' => 'Senmedeltiden ca 1300-1500',
    'Ku.4' => 'Nya tiden',
    'Ku.41' => '1500-1648',
    'Ku.43' => '1648-1789',
    'Ku.45' => '1789-1815',
    'Ku.46' => '1815-1914',
    'Ku.5' => '1914-',
    'Ku.51' => 'Första världskriget 1914-1918',
    'Ku.52' => 'Mellankrigstiden 1918-1939',
    'Ku.54' => 'Andra världskriget 1939-1945',
    'Ku.55' => '1945-',
    'Ku.58' => '1980-',
    'Ku.59' => '1990-',
    'Ku.6' => '2000-',
    'Ku-' => 'särskilda länder och områden',
    'Ku-a' => 'Europa: allmänt',
    'Ku-b' => 'Norden: allmänt',
    'Ku-c' => 'Sverige',
    'Ku-c.' => 'Särskilda historiska perioder',
    'Ku-c.2' => 'Forntiden till ca 1060',
    'Ku-c.3' => 'Medeltiden ca 1060-1520',
    'Ku-c.31' => 'Äldre medeltiden ca 1060-1319',
    'Ku-c.34' => 'Senare medeltiden 1319-1520',
    'Ku-c.4' => 'Nya tiden 1520-',
    'Ku-c.41' => 'Vasatiden 1520-1611',
    'Ku-c.42' => 'Stormaktstiden 1611-1718',
    'Ku-c.43' => '1700-talet',
    'Ku-c.44' => 'Frihetstiden 1718-1772',
    'Ku-c.45' => 'Gustavianska tiden 1772-1809',
    'Ku-c.46' => '1800-talet',
    'Ku-c.47' => '1809-1844',
    'Ku-c.48' => '1844-1865',
    'Ku-c.49' => '1865-1905',
    'Ku-c.5' => '1905-',
    'Ku-c.51' => 'Första världskriget 1914-1918',
    'Ku-c.52' => '1918-1939',
    'Ku-c.54' => 'Andra världskriget 1939-1945',
    'Ku-c.55' => '1945-',
    'Ku-c.58' => '1980-',
    'Ku-c.6' => '2000-',
    'Ku-d' => 'Övriga Norden',
    'Ku-da' => 'Danmark',
    'Ku-db' => 'Norge',
    'Ku-dc' => 'Island och Färöarna',
    'Ku-dd' => 'Finland',
    'Ku-e' => 'Brittiska öarna (Storbritannien)',
    'Ku-f' => 'Mellaneuropa',
    'Ku-fa' => 'Tyskland',
    'Ku-fb' => 'Österrike och Liechtenstein',
    'Ku-fc' => 'Ungern',
    'Ku-fd' => 'Tjeckien och Slovakien',
    'Ku-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ku-h' => 'Schweiz',
    'Ku-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ku-j' => 'Frankrike och Monaco',
    'Ku-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ku-l' => 'Portugal',
    'Ku-m' => 'Östeuropa',
    'Ku-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ku-mb' => 'Polen',
    'Ku-mc' => 'Estland, Lettland, Litauen',
    'Ku-n' => 'Balkanländerna',
    'Ku-na' => 'Rumänien',
    'Ku-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ku-nc' => 'Bulgarien',
    'Ku-nd' => 'Grekland',
    'Ku-o' => 'Asien',
    'Ku-oa' => 'Främre Asien',
    'Ku-oafh' => 'Judar',
    'Ku-ob' => 'Främre Indien',
    'Ku-oc' => 'Bortre Indien',
    'Ku-od' => 'Ostindiska öarna',
    'Ku-oe' => 'Östasien',
    'Ku-oea' => 'Kina',
    'Ku-oeb' => 'Korea',
    'Ku-oec' => 'Japan',
    'Ku-oek' => 'Hongkong och Macau',
    'Ku-of' => 'Centralasien',
    'Ku-og' => 'Sibirien',
    'Ku-p' => 'Afrika',
    'Ku-pa' => 'Nordafrika utom Egypten',
    'Ku-pb' => 'Egypten och Sudan',
    'Ku-pc' => 'Västafrika',
    'Ku-pd' => 'Centralafrika',
    'Ku-pe' => 'Södra Afrika',
    'Ku-pf' => 'Östafrika',
    'Ku-pg' => 'Nordöstafrika',
    'Ku-q' => 'Amerika',
    'Ku-qa' => 'Förenta staterna',
    'Ku-qb' => 'Kanada',
    'Ku-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ku-qd' => 'Sydamerika',
    'Ku-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ku-ra' => 'Australien',
    'Ku-rb' => 'Nya Zeeland',
    'Ku-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Kv' => 'Allmän ekonomisk historia',
    'Kv.' => 'Särskilda historiska perioder',
    'Kv.2' => 'Forntiden',
    'Kv.21' => 'Egypten',
    'Kv.22' => 'Främre Asien',
    'Kv.23' => 'Antikens historia: allmänt',
    'Kv.24' => 'Den grekiska forntiden',
    'Kv.26' => 'Den romerska forntiden',
    'Kv.3' => 'Medeltiden',
    'Kv.31' => 'Bysantinska riket 395-1453',
    'Kv.32' => 'Arabiska väldet 622-1517',
    'Kv.33' => 'Äldre medeltiden ca 476 - 1050',
    'Kv.35' => 'Högmedeltiden ca 1050 - 1300',
    'Kv.38' => 'Senmedeltiden ca 1300-1500',
    'Kv.4' => 'Nya tiden',
    'Kv.41' => '1500-1648',
    'Kv.43' => '1648-1789',
    'Kv.45' => '1789-1815',
    'Kv.46' => '1815-1914',
    'Kv.5' => '1914-',
    'Kv.51' => 'Första världskriget 1914-1918',
    'Kv.52' => 'Mellankrigstiden 1918-1939',
    'Kv.54' => 'Andra världskriget 1939-1945',
    'Kv.55' => '1945-',
    'Kv.58' => '1980-',
    'Kv.59' => '1990-',
    'Kv.6' => '2000-',
    'Kv-' => 'särskilda länder och områden',
    'Kv-a' => 'Europa: allmänt',
    'Kv-b' => 'Norden: allmänt',
    'Kv-c' => 'Sverige',
    'Kv-c.' => 'Särskilda historiska perioder',
    'Kv-c.2' => 'Forntiden till ca 1060',
    'Kv-c.3' => 'Medeltiden ca 1060-1520',
    'Kv-c.31' => 'Äldre medeltiden ca 1060-1319',
    'Kv-c.34' => 'Senare medeltiden 1319-1520',
    'Kv-c.4' => 'Nya tiden 1520-',
    'Kv-c.41' => 'Vasatiden 1520-1611',
    'Kv-c.42' => 'Stormaktstiden 1611-1718',
    'Kv-c.421' => 'Gustav II Adolf 1611-1632',
    'Kv-c.423' => 'Kristina 1632-1654',
    'Kv-c.425' => 'Karl X Gustav 1654-1660',
    'Kv-c.426' => 'Karl XI 1660-1697',
    'Kv-c.428' => 'Karl XII 1697-1718',
    'Kv-c.43' => '1700-talet',
    'Kv-c.44' => 'Frihetstiden 1718-1772',
    'Kv-c.45' => 'Gustavianska tiden 1772-1809',
    'Kv-c.46' => '1800-talet',
    'Kv-c.47' => '1809-1844',
    'Kv-c.48' => '1844-1865',
    'Kv-c.49' => '1865-1905',
    'Kv-c.5' => '1905-',
    'Kv-c.51' => 'Första världskriget 1914-1918',
    'Kv-c.52' => '1918-1939',
    'Kv-c.54' => 'Andra världskriget 1939-1945',
    'Kv-c.55' => '1945-',
    'Kv-c.58' => '1980-',
    'Kv-c.6' => '2000-',
    'Kv-d' => 'Övriga Norden',
    'Kv-da' => 'Danmark',
    'Kv-db' => 'Norge',
    'Kv-dc' => 'Island och Färöarna',
    'Kv-dd' => 'Finland',
    'Kv-e' => 'Brittiska öarna (Storbritannien)',
    'Kv-f' => 'Mellaneuropa',
    'Kv-fa' => 'Tyskland',
    'Kv-fb' => 'Österrike och Liechtenstein',
    'Kv-fc' => 'Ungern',
    'Kv-fd' => 'Tjeckien och Slovakien',
    'Kv-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kv-h' => 'Schweiz',
    'Kv-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kv-j' => 'Frankrike och Monaco',
    'Kv-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kv-l' => 'Portugal',
    'Kv-m' => 'Östeuropa',
    'Kv-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kv-mb' => 'Polen',
    'Kv-mc' => 'Estland, Lettland, Litauen',
    'Kv-n' => 'Balkanländerna',
    'Kv-na' => 'Rumänien',
    'Kv-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Kv-nc' => 'Bulgarien',
    'Kv-nd' => 'Grekland',
    'Kv-nf' => 'Albanien',
    'Kv-o' => 'Asien',
    'Kv-oa' => 'Främre Asien',
    'Kv-oafh' => 'Judar',
    'Kv-ob' => 'Främre Indien',
    'Kv-oc' => 'Bortre Indien',
    'Kv-od' => 'Ostindiska öarna',
    'Kv-oe' => 'Östasien',
    'Kv-oea' => 'Kina',
    'Kv-oeb' => 'Korea',
    'Kv-oec' => 'Japan',
    'Kv-oek' => 'Hongkong och Macau',
    'Kv-of' => 'Centralasien',
    'Kv-og' => 'Sibirien',
    'Kv-p' => 'Afrika',
    'Kv-pa' => 'Nordafrika utom Egypten',
    'Kv-pb' => 'Egypten och Sudan',
    'Kv-pc' => 'Västafrika',
    'Kv-pd' => 'Centralafrika',
    'Kv-pe' => 'Södra Afrika',
    'Kv-pf' => 'Östafrika',
    'Kv-pg' => 'Nordöstafrika',
    'Kv-q' => 'Amerika',
    'Kv-qa' => 'Förenta staterna',
    'Kv-qb' => 'Kanada',
    'Kv-qc' => 'Mexiko, Centralamerika och Västindien',
    'Kv-qd' => 'Sydamerika',
    'Kv-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Kv-s' => 'Polarländerna',
    'Ky' => 'Historiska hjälpvetenskaper',
    'Kya' => 'Diplomatik',
    'Kya-' => 'särskilda länder och områden',
    'Kya-b' => 'Norden: allmänt',
    'Kya-c' => 'Sverige',
    'Kya-d' => 'Övriga Norden',
    'Kya-e' => 'Brittiska öarna (Storbritannien)',
    'Kya-f' => 'Mellaneuropa',
    'Kya-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kya-h' => 'Schweiz',
    'Kya-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kya-j' => 'Frankrike och Monaco',
    'Kya-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kya-m' => 'Östeuropa',
    'Kya-n' => 'Balkanländerna',
    'Kya-o' => 'Asien',
    'Kya-p' => 'Afrika',
    'Kyb' => 'Heraldik',
    'Kyb-' => 'särskilda länder och områden',
    'Kyb-a' => 'Europa: allmänt',
    'Kyb-b' => 'Norden: allmänt',
    'Kyb-c' => 'Sverige',
    'Kyb-d' => 'Övriga Norden',
    'Kyb-da' => 'Danmark',
    'Kyb-db' => 'Norge',
    'Kyb-dd' => 'Finland',
    'Kyb-e' => 'Brittiska öarna (Storbritannien)',
    'Kyb-f' => 'Mellaneuropa',
    'Kyb-fa' => 'Tyskland',
    'Kyb-fb' => 'Österrike och Liechtenstein',
    'Kyb-fc' => 'Ungern',
    'Kyb-fd' => 'Tjeckien och Slovakien',
    'Kyb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kyb-h' => 'Schweiz',
    'Kyb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kyb-j' => 'Frankrike och Monaco',
    'Kyb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kyb-l' => 'Portugal',
    'Kyb-m' => 'Östeuropa',
    'Kyb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kyb-mb' => 'Polen',
    'Kyb-mc' => 'Estland, Lettland, Litauen',
    'Kyb-n' => 'Balkanländerna',
    'Kyb-o' => 'Asien',
    'Kyb-p' => 'Afrika',
    'Kyb-q' => 'Amerika',
    'Kyc' => 'Sfragistik (sigillkunskap)',
    'Kyc-' => 'särskilda länder och områden',
    'Kyc-a' => 'Europa: allmänt',
    'Kyc-b' => 'Norden: allmänt',
    'Kyc-c' => 'Sverige',
    'Kyc-d' => 'Övriga Norden',
    'Kyc-e' => 'Brittiska öarna (Storbritannien)',
    'Kyc-f' => 'Mellaneuropa',
    'Kyc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kyc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kyc-j' => 'Frankrike och Monaco',
    'Kyc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kyc-m' => 'Östeuropa',
    'Kyc-n' => 'Balkanländerna',
    'Kyc-o' => 'Asien',
    'Kyc-p' => 'Afrika',
    'Kyc-q' => 'Amerika',
    'Kyd' => 'Flaggor',
    'Kyd-' => 'särskilda länder och områden',
    'Kyd-a' => 'Europa: allmänt',
    'Kyd-b' => 'Norden: allmänt',
    'Kyd-c' => 'Sverige',
    'Kyd-d' => 'Övriga Norden',
    'Kyd-e' => 'Brittiska öarna (Storbritannien)',
    'Kyd-f' => 'Mellaneuropa',
    'Kyd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kyd-h' => 'Schweiz',
    'Kyd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kyd-j' => 'Frankrike och Monaco',
    'Kyd-m' => 'Östeuropa',
    'Kyd-o' => 'Asien',
    'Kyd-p' => 'Afrika',
    'Kyd-q' => 'Amerika',
    'Kye' => 'Emblematik',
    'Kye-' => 'särskilda länder och områden',
    'Kye-a' => 'Europa: allmänt',
    'Kye-c' => 'Sverige',
    'Kye-d' => 'Övriga Norden',
    'Kye-e' => 'Brittiska öarna (Storbritannien)',
    'Kye-f' => 'Mellaneuropa',
    'Kye-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kye-j' => 'Frankrike och Monaco',
    'Kye-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kye-m' => 'Östeuropa',
    'Kye-n' => 'Balkanländerna',
    'Kye-o' => 'Asien',
    'Kye-q' => 'Amerika',
    'Kyf' => 'Rang- och titelväsen',
    'Kyf-c' => 'Sverige',
    'Kyg' => 'Historisk kronologi (inkl tideräkning och kalendrar)',
    'Kyg-' => 'särskilda länder och områden',
    'Kyg-b' => 'Norden: allmänt',
    'Kyg-c' => 'Sverige',
    'Kyg-d' => 'Övriga Norden',
    'Kyg-e' => 'Brittiska öarna (Storbritannien)',
    'Kyg-f' => 'Mellaneuropa',
    'Kyg-m' => 'Östeuropa',
    'Kyg-n' => 'Balkanländerna',
    'Kyg-o' => 'Asien',
    'Kyg-oa' => 'Främre Asien',
    'Kyg-ob' => 'Främre Indien',
    'Kyg-oc' => 'Bortre Indien',
    'Kyg-od' => 'Ostindiska öarna',
    'Kyg-oe' => 'Östasien',
    'Kyg-of' => 'Centralasien',
    'Kyg-p' => 'Afrika',
    'Kyg-q' => 'Amerika',
    'Kyh' => 'Numismatik',
    'Kyh-' => 'särskilda länder och områden',
    'Kyh-a' => 'Europa: allmänt',
    'Kyh-ak' => 'Kelter',
    'Kyh-b' => 'Norden: allmänt',
    'Kyh-c' => 'Sverige',
    'Kyh-c:bf' => 'Organisationer och institutioner',
    'Kyh-c.' => 'Särskilda historiska perioder',
    'Kyh-c.2' => 'Forntiden till ca 1060',
    'Kyh-c.3' => 'Medeltiden ca 1060-1520',
    'Kyh-c.31' => 'Äldre medeltiden ca 1060-1319',
    'Kyh-c.34' => 'Senare medeltiden 1319-1520',
    'Kyh-c.4' => 'Nya tiden 1520-',
    'Kyh-c.41' => 'Vasatiden 1520-1611',
    'Kyh-c.42' => 'Stormaktstiden 1611-1718',
    'Kyh-c.43' => '1700-talet',
    'Kyh-c.44' => 'Frihetstiden 1718-1772',
    'Kyh-c.45' => 'Gustavianska tiden 1772-1809',
    'Kyh-c.46' => '1800-talet',
    'Kyh-c.47' => '1809-1844',
    'Kyh-c.48' => '1844-1865',
    'Kyh-c.49' => '1865-1905',
    'Kyh-c.5' => '1905-',
    'Kyh-c.6' => '2000-',
    'Kyh-d' => 'Övriga Norden',
    'Kyh-da' => 'Danmark',
    'Kyh-db' => 'Norge',
    'Kyh-dc' => 'Island och Färöarna',
    'Kyh-dd' => 'Finland',
    'Kyh-e' => 'Brittiska öarna (Storbritannien)',
    'Kyh-e.' => 'Särskilda historiska perioder',
    'Kyh-e.2' => 'Före 1066',
    'Kyh-e.3' => 'Medeltiden 1066-1485',
    'Kyh-e.4' => 'Nya tiden 1485-',
    'Kyh-e.5' => '1914-',
    'Kyh-e.6' => '2000-',
    'Kyh-f' => 'Mellaneuropa',
    'Kyh-fa' => 'Tyskland',
    'Kyh-fa.' => 'Särskilda historiska perioder',
    'Kyh-fa.2' => 'Före 843',
    'Kyh-fa.3' => '843 - ca 1500',
    'Kyh-fa.4' => 'Ca 1500-',
    'Kyh-fa.41' => '1500-1648',
    'Kyh-fa.43' => '1648-1806',
    'Kyh-fa.46' => '1806-1870',
    'Kyh-fa.47' => '1870-1918',
    'Kyh-fa.5' => '1900-talet',
    'Kyh-fa.6' => '2000-',
    'Kyh-fb' => 'Österrike och Liechtenstein',
    'Kyh-fc' => 'Ungern',
    'Kyh-fd' => 'Tjeckien och Slovakien',
    'Kyh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kyh-ga' => 'Nederländerna',
    'Kyh-gb' => 'Belgien',
    'Kyh-gc' => 'Luxemburg',
    'Kyh-h' => 'Schweiz',
    'Kyh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kyh-j' => 'Frankrike och Monaco',
    'Kyh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kyh-l' => 'Portugal',
    'Kyh-m' => 'Östeuropa',
    'Kyh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Kyh-mb' => 'Polen',
    'Kyh-mc' => 'Estland, Lettland, Litauen',
    'Kyh-n' => 'Balkanländerna',
    'Kyh-na' => 'Rumänien',
    'Kyh-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Kyh-nc' => 'Bulgarien',
    'Kyh-nd' => 'Grekland',
    'Kyh-o' => 'Asien',
    'Kyh-oa' => 'Främre Asien',
    'Kyh-oaa' => 'Turkiet',
    'Kyh-oab' => 'Cypern',
    'Kyh-oac' => 'Kaukasien',
    'Kyh-oae' => 'Syrien och Libanon',
    'Kyh-oaf' => 'Palestina och Israel',
    'Kyh-oah' => 'Arabiska halvön',
    'Kyh-oai' => 'Irak',
    'Kyh-oak' => 'Iran (Persien)',
    'Kyh-oal' => 'Afghanistan',
    'Kyh-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Kyh-ob' => 'Främre Indien',
    'Kyh-oc' => 'Bortre Indien',
    'Kyh-od' => 'Ostindiska öarna',
    'Kyh-oe' => 'Östasien',
    'Kyh-p' => 'Afrika',
    'Kyh-q' => 'Amerika',
    'Kyh-qa' => 'Förenta staterna',
    'Kyh-qb' => 'Kanada',
    'Kyh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Kyh-qd' => 'Sydamerika',
    'Kyh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Kyi' => 'Ordensväsen',
    'Kyi-' => 'särskilda länder och områden',
    'Kyi-a' => 'Europa: allmänt',
    'Kyi-b' => 'Norden: allmänt',
    'Kyi-c' => 'Sverige',
    'Kyi-d' => 'Övriga Norden',
    'Kyi-e' => 'Brittiska öarna (Storbritannien)',
    'Kyi-f' => 'Mellaneuropa',
    'Kyi-fa' => 'Tyskland',
    'Kyi-fb' => 'Österrike och Liechtenstein',
    'Kyi-fd' => 'Tjeckien och Slovakien',
    'Kyi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Kyi-h' => 'Schweiz',
    'Kyi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Kyi-j' => 'Frankrike och Monaco',
    'Kyi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Kyi-l' => 'Portugal',
    'Kyi-m' => 'Östeuropa',
    'Kyi-n' => 'Balkanländerna',
    'Kyi-o' => 'Asien',
    'Kyi-q' => 'Amerika',
    'Kyiz' => 'Särskilda ordnar',
    'L' => 'Biografi med genealogi',
    'L:k' => 'Vetenskapshistoria',
    'Ld' => 'Genealogi',
    'Ld:bf' => 'Genealogiska organisationer och institutioner',
    'Ld:k' => 'Vetenskapshistoria',
    'Ld-' => 'Särskilda länder och områden',
    'Ld-c' => 'Sverige',
    'Ld-c:bf' => 'Organisationer och institutioner',
    'Ld-d' => 'Övriga Norden',
    'Ld-e' => 'Brittiska öarna (Storbritannien)',
    'Ld-f' => 'Mellaneuropa',
    'Ld-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ld-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ld-j' => 'Frankrike och Monaco',
    'Ld-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ld-l' => 'Portugal',
    'Ld-m' => 'Östeuropa',
    'Ld-o' => 'Asien',
    'Ld-q' => 'Amerika',
    'Lda' => 'Genealogi: metodlära',
    'Ldm' => 'Genealogiska uppslagsverk',
    'Ldm-' => 'Särskilda länder och områden',
    'Ldm-a' => 'Europa: allmänt',
    'Ldm-c' => 'Sverige',
    'Ldm-d' => 'Övriga Norden',
    'Ldm-da' => 'Danmark',
    'Ldm-db' => 'Norge',
    'Ldm-dc' => 'Island och Färöarna',
    'Ldm-dd' => 'Finland',
    'Ldm-e' => 'Brittiska öarna (Storbritannien)',
    'Ldm-f' => 'Mellaneuropa',
    'Ldm-fa' => 'Tyskland',
    'Ldm-fb' => 'Österrike och Liechtenstein',
    'Ldm-fc' => 'Ungern',
    'Ldm-fd' => 'Tjeckien och Slovakien',
    'Ldm-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ldm-h' => 'Schweiz',
    'Ldm-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ldm-j' => 'Frankrike och Monaco',
    'Ldm-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ldm-l' => 'Portugal',
    'Ldm-m' => 'Östeuropa',
    'Ldm-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ldm-mb' => 'Polen',
    'Ldm-mc' => 'Estland, Lettland, Litauen',
    'Ldm-n' => 'Balkanländerna',
    'Ldm-o' => 'Asien',
    'Ldm-p' => 'Afrika',
    'Ldm-q' => 'Amerika',
    'Ldm-qa' => 'Förenta staterna',
    'Ldm-qb' => 'Kanada',
    'Lds' => 'Genealogiska samlingar',
    'Lds-' => 'Särskilda länder och områden',
    'Lds-a' => 'Europa: allmänt',
    'Lds-b' => 'Norden: allmänt',
    'Lds-c' => 'Sverige',
    'Lds-cs' => 'Samer',
    'Lds-d' => 'Övriga Norden',
    'Lds-da' => 'Danmark',
    'Lds-db' => 'Norge',
    'Lds-dc' => 'Island och Färöarna',
    'Lds-dd' => 'Finland',
    'Lds-e' => 'Brittiska öarna (Storbritannien)',
    'Lds-f' => 'Mellaneuropa',
    'Lds-g' => 'Nederländerna, Belgien och Luxemburg',
    'Lds-h' => 'Schweiz',
    'Lds-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Lds-j' => 'Frankrike och Monaco',
    'Lds-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Lds-l' => 'Portugal',
    'Lds-m' => 'Östeuropa',
    'Lds-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Lds-mb' => 'Polen',
    'Lds-mc' => 'Estland, Lettland, Litauen',
    'Lds-n' => 'Balkanländerna',
    'Lds-o' => 'Asien',
    'Lds-q' => 'Amerika',
    'Lds-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ldz' => 'Särskilda släkter',
    'Lk' => 'Biografisk vetenskap',
    'Lk:k' => 'Vetenskapshistoria',
    'Lm' => 'Biografiska uppslagsverk',
    'Lm-' => 'Särskilda länder och områden',
    'Lm-a' => 'Europa: allmänt',
    'Lm-b' => 'Norden: allmänt',
    'Lm-c' => 'Sverige',
    'Lm-c.' => 'Personer verksamma inom särskilda områden',
    'Lm-c.a' => 'Bok- och biblioteksväsen',
    'Lm-c.b' => 'Allmän vetenskaplig och kulturell verksamhet m m',
    'Lm-c.bk' => 'Allmänna sällskap och föreningar',
    'Lm-c.bt' => 'Publicistik och tidningsväsen',
    'Lm-c.c' => 'Religion',
    'Lm-c.d' => 'Filosofi och psykologi',
    'Lm-c.e' => 'Uppfostran och undervisning',
    'Lm-c.f' => 'Språkvetenskap',
    'Lm-c.g' => 'Litteraturvetenskap',
    'Lm-c.i' => 'Konst, musik, teater, film, fotokonst',
    'Lm-c.ib' => 'Konst',
    'Lm-c.ic' => 'Arkitektur',
    'Lm-c.ih' => 'Konsthantverk',
    'Lm-c.ij' => 'Musik',
    'Lm-c.ik' => 'Teater',
    'Lm-c.k' => 'Historia',
    'Lm-c.l' => 'Biografi med genealogi',
    'Lm-c.o' => 'Samhälls- och rättsvetenskap',
    'Lm-c.ob' => 'Internationella relationer',
    'Lm-c.oc' => 'Statskunskap och politik',
    'Lm-c.od' => 'Förvaltning',
    'Lm-c.oe' => 'Rättsvetenskap',
    'Lm-c.oh' => 'Sociala frågor och socialpolitik',
    'Lm-c.p' => 'Teknik, industri och kommunikationer',
    'Lm-c.pd' => 'Bergsbruk',
    'Lm-c.pe' => 'Metallbearbetning och metallindustri',
    'Lm-c.pm' => 'Kemisk teknik och kemisk industri',
    'Lm-c.pn' => 'Fotografi och filmteknik',
    'Lm-c.pp' => 'Byggnadsteknik, byggnadskonstruktion, teknisk hygien',
    'Lm-c.pr' => 'Transportmedel och kommunikationer',
    'Lm-c.q' => 'Ekonomi och näringsväsen',
    'Lm-c.qa' => 'Nationalekonomi och finansväsen',
    'Lm-c.qb' => 'Företagsekonomi',
    'Lm-c.qd' => 'Lantbruk',
    'Lm-c.qe' => 'Trädgårdsskötsel',
    'Lm-c.qf' => 'Skogsbruk',
    'Lm-c.qg' => 'Jakt och fiske',
    'Lm-c.qi' => 'Handel',
    'Lm-c.qj' => 'Post- och televäsen',
    'Lm-c.r' => 'Idrott, lek och spel',
    'Lm-c.s' => 'Militärväsen',
    'Lm-c.u' => 'Naturvetenskap',
    'Lm-c.v' => 'Medicin',
    'Lm-cz' => 'Särskilda orter',
    'Lm-d' => 'Övriga Norden',
    'Lm-da' => 'Danmark',
    'Lm-db' => 'Norge',
    'Lm-dc' => 'Island och Färöarna',
    'Lm-dd' => 'Finland',
    'Lm-e' => 'Brittiska öarna (Storbritannien)',
    'Lm-f' => 'Mellaneuropa',
    'Lm-fa' => 'Tyskland',
    'Lm-fb' => 'Österrike och Liechtenstein',
    'Lm-fc' => 'Ungern',
    'Lm-fd' => 'Tjeckien och Slovakien',
    'Lm-g' => 'Nederländerna, Belgien och Luxemburg',
    'Lm-h' => 'Schweiz',
    'Lm-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Lm-j' => 'Frankrike och Monaco',
    'Lm-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Lm-l' => 'Portugal',
    'Lm-m' => 'Östeuropa',
    'Lm-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Lm-mb' => 'Polen',
    'Lm-mc' => 'Estland, Lettland, Litauen',
    'Lm-n' => 'Balkanländerna',
    'Lm-o' => 'Asien',
    'Lm-oa' => 'Främre Asien',
    'Lm-ob' => 'Främre Indien',
    'Lm-oc' => 'Bortre Indien',
    'Lm-od' => 'Ostindiska öarna',
    'Lm-oe' => 'Östasien',
    'Lm-oea' => 'Kina',
    'Lm-oeb' => 'Korea',
    'Lm-oec' => 'Japan',
    'Lm-of' => 'Centralasien',
    'Lm-p' => 'Afrika',
    'Lm-q' => 'Amerika',
    'Lm-qa' => 'Förenta staterna',
    'Lm-qb' => 'Kanada',
    'Lm-qc' => 'Mexiko, Centralamerika och Västindien',
    'Lm-qd' => 'Sydamerika',
    'Lm-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Lm-ra' => 'Australien',
    'Lm-rb' => 'Nya Zeeland',
    'Lm-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Lma' => 'Bok- och biblioteksväsen',
    'Lmb' => 'Allmän idé- och lärdomshistoria, publicistik, tidningsväsen m m',
    'Lmc' => 'Religion',
    'Lmd' => 'Filosofi och psykologi',
    'Lme' => 'Uppforstran och undervisning',
    'Lmf' => 'Språkvetenskap',
    'Lmg' => 'Litteraturvetenskap',
    'Lmh' => 'Skönlitteratur',
    'Lmi' => 'Konst, musik, teater, film, fotokonst',
    'Lmib' => 'Konsthistoria',
    'Lmic' => 'Arkitektur',
    'Lmif' => 'Grafisk konst',
    'Lmih' => 'Konsthantverk',
    'Lmij' => 'Musik',
    'Lmik' => 'Teater',
    'Lmim' => 'Film',
    'Lmj' => 'Arkeologi',
    'Lmk' => 'Historia',
    'Lml' => 'Biografi med genealogi',
    'Lmm' => 'Etnografi, socialantropologi och etnologi',
    'Lmn' => 'Geografi och lokalhistoria',
    'Lmo' => 'Samhälls- och rättsvetenskap',
    'Lmob' => 'Interationella relationer',
    'Lmoc' => 'Statskunskap och politik',
    'Lmod' => 'Förvaltning',
    'Lmoe' => 'Rättsevetenskap',
    'Lmoh' => 'Sociala frågor och socialpolitik',
    'Lmp' => 'Teknik, industri och kommunikationer',
    'Lmq' => 'Ekonomi och näringsväsen',
    'Lmr' => 'Idrott, lek och spel',
    'Lms' => 'Militärväsen',
    'Lmt' => 'Matematik',
    'Lmu' => 'Naturvetenskap',
    'Lmua' => 'Astronomi',
    'Lmuc' => 'Fysik och kemi',
    'Lmud' => 'Geologi och paleontologi',
    'Lmue' => 'Biologi',
    'Lmuf' => 'Botanik',
    'Lmug' => 'Zoologi',
    'Lmuh' => 'Miljöfrågor och naturskydd',
    'Lmv' => 'Medicin',
    'Ls' => 'Biografiska samlingar',
    'Ls-' => 'Särskilda länder och områden',
    'Ls-a' => 'Europa: allmänt',
    'Ls-b' => 'Norden: allmänt',
    'Ls-c' => 'Sverige',
    'Ls-c.' => 'Personer verksamma inom särskilda områden',
    'Ls-c.a' => 'Bok- och biblioteksväsen',
    'Ls-c.b' => 'Allmän vetenskaplig och kulturell verksamhet, allmänna sällskap och föreningar m m',
    'Ls-c.c' => 'Religion',
    'Ls-c.e' => 'Uppfostran och undervisning',
    'Ls-c.g' => 'Litteraturvetenskap',
    'Ls-c.i' => 'Konst, musik, teater, film, fotokonst',
    'Ls-c.j' => 'Arkeologi',
    'Ls-c.m' => 'Etnografi, socialantropologi och etnologi',
    'Ls-c.n' => 'Geografi och lokalhistoria',
    'Ls-c.o' => 'Samhälls- och rättsvetenskap',
    'Ls-c.p' => 'Teknik, industri och kommunikationer',
    'Ls-c.q' => 'Ekonomi och näringsväsen',
    'Ls-c.r' => 'Idrott, lek och spel',
    'Ls-c.s' => 'Militärväsen',
    'Ls-c.u' => 'Naturvetenskap',
    'Ls-c.v' => 'Medicin',
    'Ls-cz' => 'Särskilda orter',
    'Ls-d' => 'Övriga Norden',
    'Ls-da' => 'Danmark',
    'Ls-db' => 'Norge',
    'Ls-dc' => 'Island och Färöarna',
    'Ls-dd' => 'Finland',
    'Ls-e' => 'Brittiska öarna (Storbritannien)',
    'Ls-f' => 'Mellaneuropa',
    'Ls-fa' => 'Tyskland',
    'Ls-fb' => 'Österrike och Liechtenstein',
    'Ls-fc' => 'Ungern',
    'Ls-fd' => 'Tjeckien och Slovakien',
    'Ls-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ls-h' => 'Schweiz',
    'Ls-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ls-j' => 'Frankrike och Monaco',
    'Ls-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ls-l' => 'Portugal',
    'Ls-m' => 'Östeuropa',
    'Ls-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ls-mb' => 'Polen',
    'Ls-mc' => 'Estland, Lettland, Litauen',
    'Ls-n' => 'Balkanländerna',
    'Ls-na' => 'Rumänien',
    'Ls-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ls-nc' => 'Bulgarien',
    'Ls-nd' => 'Grekland',
    'Ls-o' => 'Asien',
    'Ls-oa' => 'Främre Asien',
    'Ls-ob' => 'Främre Indien',
    'Ls-oc' => 'Bortre Indien',
    'Ls-od' => 'Ostindiska öarna',
    'Ls-oe' => 'Östasien',
    'Ls-oea' => 'Kina',
    'Ls-oeb' => 'Korea',
    'Ls-oec' => 'Japan',
    'Ls-oek' => 'Hongkong och Macau',
    'Ls-p' => 'Afrika',
    'Ls-q' => 'Amerika',
    'Ls-qa' => 'Förenta staterna',
    'Ls-qb' => 'Kanada',
    'Ls-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ls-qd' => 'Sydamerika',
    'Ls-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Lsa' => 'Bok- och biblioteksväsen',
    'Lsb' => 'Allmän vetenskaplig och kulturell verksamhet, masskommunikation, informationsteknik m m',
    'Lsc' => 'Religion',
    'Lsd' => 'Filosofi och psykologi',
    'Lse' => 'Uppfostran och undervisning',
    'Lsf' => 'Språkvetenskap',
    'Lsg' => 'Litteraturvetenskap',
    'Lsh' => 'Skönlitteratur',
    'Lsi' => 'Konst, musik, teater, film, fotokonst',
    'Lsib' => 'Konsthistoria',
    'Lsij' => 'Musik',
    'Lsik' => 'Teater',
    'Lsim' => 'Film',
    'Lsj' => 'Arkeologi',
    'Lsk' => 'Historia',
    'Lsm' => 'Etnografi, socialantropologi och etnologi',
    'Lsn' => 'Geografi och lokalhistoria',
    'Lso' => 'Samhälls- och rättsvetenskap',
    'Lsp' => 'Teknik, industri och kommunikationer',
    'Lsq' => 'Ekonomi och näringsväsen',
    'Lsr' => 'Idrott, lek och spel',
    'Lss' => 'Militärväsen',
    'Lst' => 'Matematik',
    'Lsu' => 'Naturvetenskap',
    'Lsv' => 'Medicin',
    'Lz' => 'Biografi: särskilda personer',
    'M' => 'Etnografi, socialantropologi',
    'M(x)' => 'Etnografiska etc. lexikon',
    'M:b' => 'Etnografisk etc. forskning. Institutioner',
    'M:bf' => 'Institutioner och organisationer',
    'M:d' => 'Etnografisk etc teori, filosofi och metodlära',
    'M:dd' => 'Metodlära',
    'M:k' => 'Etnografins etc historia',
    'M:kc' => 'Sverige',
    'Ma' => 'Europa: allmänt',
    'Mak' => 'Kelternas folkkultur',
    'Mat' => 'Romernas folkkultur',
    'Mb' => 'Norden: allmänt',
    'Mbc' => 'Etnografi, socialantropologi och etnologi',
    'Mc' => 'Sverige',
    'Mca' => 'Svealand',
    'Mcaa' => 'Stockholm och Stockholms län',
    'Mcab' => 'Uppland och Uppsala län',
    'Mcac' => 'Södermanland och Södermanlands län',
    'Mcad' => 'Närke och Örebro län',
    'Mcae' => 'Västmanland och Västmanlands län',
    'Mcaf' => 'Dalarna och Dalarnas län',
    'Mcag' => 'Värmland och Värmlands län',
    'Mcb' => 'Götaland (inkl Västra Götalands län)',
    'Mcba' => 'Skåne och Skåne län',
    'Mcbb' => 'Halland och Hallands län',
    'Mcbc' => 'Blekinge och Blekinge län',
    'Mcbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Mcbe' => 'Öland',
    'Mcbf' => 'Gotland och Gotlands län',
    'Mcbg' => 'Östergötland och Östergötlands län',
    'Mcbh' => 'Västergötland',
    'Mcbi' => 'Göteborg',
    'Mcbk' => 'Bohuslän',
    'Mcbl' => 'Dalsland',
    'Mcc' => 'Norrland',
    'Mcca' => 'Gästrikland och Gävleborgs län',
    'Mccb' => 'Hälsingland',
    'Mccc' => 'Jämtland och Jämtlands län',
    'Mccd' => 'Härjedalen',
    'Mcce' => 'Medelpad',
    'Mccf' => 'Ångermanland och Västernorrlands län',
    'Mccg' => 'Västerbotten och Västerbottens län',
    'Mcch' => 'Norrbotten och Norrbottens län',
    'Mcci' => 'Lappland',
    'Mcs' => 'Samer',
    'Mcx' => 'Svensk folkkultur i utlandet',
    'Md' => 'Övriga Norden',
    'Mda' => 'Danmark',
    'Mdb' => 'Norge',
    'Mdc' => 'Island och Färöarna',
    'Mdcf' => 'Färöarna',
    'Mdd' => 'Finland',
    'Mddå' => 'Åland',
    'Me' => 'Brittiska öarna (Storbritannien)',
    'Mea' => 'England',
    'Mer' => 'Wales',
    'Mes' => 'Skottland',
    'Met' => 'Irland',
    'Mf' => 'Mellaneuropa',
    'Mfa' => 'Tyskland',
    'Mfb' => 'Österrike och Liechtenstein',
    'Mfc' => 'Ungern',
    'Mfd' => 'Tjeckien och Slovakien',
    'Mg' => 'Nederländerna, Belgien och Luxemburg',
    'Mga' => 'Nederländerna',
    'Mgb' => 'Belgien',
    'Mgc' => 'Luxemburg',
    'Mh' => 'Schweiz',
    'Mi' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Miv' => 'Malta',
    'Mj' => 'Frankrike',
    'Mk' => 'Spanien (inkl Andorra och Gibraltar)',
    'Mkf' => 'Baskernas folkkultur',
    'Ml' => 'Portugal',
    'Mm' => 'Östeuropa',
    'Mma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Mmad' => 'Ukraina',
    'Mmae' => 'Vitryssland',
    'Mmb' => 'Polen',
    'Mmc' => 'Estland, Lettland, Litauen',
    'Mmca' => 'Estland',
    'Mmcb' => 'Lettland',
    'Mmcc' => 'Litauen',
    'Mn' => 'Balkanländerna',
    'Mna' => 'Rumänien',
    'Mnb' => 'F d Jugoslavien  (Serbien, Kroatien, Slovenien etc.)',
    'Mnc' => 'Bulgarien',
    'Mnd' => 'Grekland',
    'Mnf' => 'Albanien',
    'Mo' => 'Asien',
    'Moa' => 'Främre Asien',
    'Moaa' => 'Turkiet',
    'Moab' => 'Cypern',
    'Moac' => 'Kaukasien',
    'Moae' => 'Syrien och Libanon',
    'Moaf' => 'Palestina och Israel',
    'Moag' => 'Jordanien',
    'Moah' => 'Arabiska halvön',
    'Moai' => 'Irak',
    'Moaj' => 'Kurdernas folkkultur',
    'Moak' => 'Iran (Persien)',
    'Moal' => 'Afghanistan',
    'Moam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Moas' => 'Syrianernas folkkultur',
    'Mob' => 'Främre Indien',
    'Moba' => 'Indien',
    'Mobb' => 'Pakistan och Bangladesh',
    'Mobc' => 'Bhutan',
    'Mobd' => 'Nepal',
    'Mobe' => 'Sri Lanka (f d Ceylon)',
    'Mobf' => 'Maldiverna',
    'Moc' => 'Bortre Indien',
    'Moca' => 'Myanmar (f d Burma)',
    'Mocb' => 'Thailand',
    'Mocc' => 'Malaysia, Singapore och Brunei',
    'Mocd' => 'Indokina',
    'Mod' => 'Ostindiska öarna',
    'Moda' => 'Indonesien',
    'Modc' => 'Filippinerna',
    'Moe' => 'Östasien',
    'Moea' => 'Kina',
    'Moeb' => 'Korea',
    'Moec' => 'Japan',
    'Moek' => 'Hongkong och Macau',
    'Mof' => 'Centralasien',
    'Mofc' => 'Mongoliet',
    'Mog' => 'Sibirien',
    'Mp' => 'Afrika',
    'Mpa' => 'Nordafrika utom Egypten',
    'Mpaa' => 'Marocko och Kanarieöarna',
    'Mpab' => 'Algeriet',
    'Mpac' => 'Tunisien',
    'Mpad' => 'Libyen',
    'Mpb' => 'Egypten och Sudan',
    'Mpba' => 'Egypten',
    'Mpbb' => 'Sudan',
    'Mpc' => 'Västafrika',
    'Mpd' => 'Centralafrika',
    'Mpe' => 'Södra Afrika',
    'Mpf' => 'Östafrika',
    'Mpg' => 'Nordöstafrika (Afrikas horn)',
    'Mq' => 'Amerika',
    'Mqa' => 'Förenta staterna',
    'Mqat' => 'Indianerna i Nordamerika',
    'Mqb' => 'Kanada',
    'Mqc' => 'Mexiko, Centralamerika och Västindien',
    'Mqca' => 'Mexiko',
    'Mqcb' => 'Guatemala',
    'Mqcc' => 'Belize och Honduras',
    'Mqcd' => 'El Salvador',
    'Mqce' => 'Nicaragua',
    'Mqcf' => 'Costa Rica',
    'Mqcg' => 'Panama',
    'Mqch' => 'Västindien',
    'Mqct' => 'Indianerna i Mexiko, Centralamerika och Västindien',
    'Mqd' => 'Sydamerika',
    'Mqda' => 'Colombia',
    'Mqdb' => 'Venezuela',
    'Mqdc' => 'Guyanastaterna',
    'Mqdd' => 'Brasilien',
    'Mqde' => 'Paraguay',
    'Mqdf' => 'Uruguay',
    'Mqdg' => 'Argentina',
    'Mqdh' => 'Chile',
    'Mqdi' => 'Bolivia',
    'Mqdk' => 'Peru',
    'Mqdl' => 'Ecuador',
    'Mqdt' => 'Indianerna i Sydamerika',
    'Mr' => 'Oceanien',
    'Mra' => 'Australien',
    'Mrb' => 'Nya Zeeland',
    'Mrc' => 'Melanesien, Polynesien och Mikronesien',
    'Mrd' => 'Nya Guinea',
    'Ms' => 'Polarländerna',
    'Mu' => 'Bebyggelse och byggnader',
    'Mu-' => 'Allmänt: särskilda länder och områden',
    'Mu-b' => 'Norden: allmänt',
    'Mu-c' => 'Sverige',
    'Mu-cs' => 'Samer',
    'Mu-d' => 'Övriga Norden',
    'Mu-q' => 'Amerika',
    'Mua' => 'Bebyggelse',
    'Mub' => 'Byggnader',
    'Muba' => 'Boningshus',
    'Mubb' => 'Ekonomibyggnader',
    'Mv' => 'Föremål',
    'Mv-' => 'Särskilda länder och områden',
    'Mv-a' => 'Europa: allmänt',
    'Mv-b' => 'Norden: allmänt',
    'Mv-c' => 'Sverige',
    'Mv-cs' => 'Samer',
    'Mv-d' => 'Övriga Norden',
    'Mv-e' => 'Brittiska öarna (Storbritannien)',
    'Mv-f' => 'Mellaneuropa',
    'Mv-g' => 'Nederländerna, Belgien och Luxemburg',
    'Mv-h' => 'Schweiz',
    'Mv-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Mv-j' => 'Frankrike och Monaco',
    'Mv-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Mv-l' => 'Portugal',
    'Mv-m' => 'Östeuropa',
    'Mv-n' => 'Balkanländerna',
    'Mv-o' => 'Asien',
    'Mv-p' => 'Afrika',
    'Mv-q' => 'Amerika',
    'Mv-qa' => 'Förenta staterna',
    'Mv-qb' => 'Kanada',
    'Mv-qc' => 'Mexiko, Centralamerika och Västindien',
    'Mv-qd' => 'Sydamerika',
    'Mv-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Mv-s' => 'Polarländerna',
    'Mx' => 'Näringsliv och arbetsliv',
    'Mxk' => 'Kosthåll',
    'My' => 'Samhälls- och familjeliv',
    'My-' => 'Särskilda länder och områden',
    'My-a' => 'Europa: allmänt',
    'My-b' => 'Norden: allmänt',
    'My-c' => 'Sverige',
    'My-d' => 'Övriga Norden',
    'My-da' => 'Danmark',
    'My-db' => 'Norge',
    'My-dc' => 'Island och Färöarna',
    'My-dd' => 'Finland',
    'My-e' => 'Brittiska öarna (Storbritannien)',
    'My-f' => 'Mellaneuropa',
    'My-fa' => 'Tyskland',
    'My-fb' => 'Österrike och Liechtenstein',
    'My-fc' => 'Ungern',
    'My-g' => 'Nederländerna, Belgien och Luxemburg',
    'My-h' => 'Schweiz',
    'My-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'My-j' => 'Frankrike och Monaco',
    'My-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'My-l' => 'Portugal',
    'My-m' => 'Östeuropa',
    'My-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'My-mb' => 'Polen',
    'My-mc' => 'Estland, Lettland, Litauen',
    'My-n' => 'Balkanländerna',
    'My-na' => 'Rumänien',
    'My-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'My-nd' => 'Grekland',
    'My-o' => 'Asien',
    'My-oa' => 'Främre Asien',
    'My-ob' => 'Främre Indien',
    'My-oc' => 'Bortre Indien',
    'My-od' => 'Ostindiska öarna',
    'My-oe' => 'Östasien',
    'My-oea' => 'Kina',
    'My-oeb' => 'Korea',
    'My-oec' => 'Japan',
    'My-oek' => 'Hongkong och Macau',
    'My-of' => 'Centralasien',
    'My-og' => 'Sibirien',
    'My-p' => 'Afrika',
    'My-pa' => 'Nordafrika utom Egypten',
    'My-pb' => 'Egypten och Sudan',
    'My-pc' => 'Västafrika',
    'My-pd' => 'Centralafrika',
    'My-pe' => 'Södra Afrika',
    'My-pf' => 'Östafrika',
    'My-pg' => 'Nordöstafrika',
    'My-q' => 'Amerika',
    'My-qa' => 'Förenta staterna',
    'My-qb' => 'Kanada',
    'My-qc' => 'Mexiko, Centralamerika och Västindien',
    'My-qd' => 'Sydamerika',
    'My-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'My-ra' => 'Australien',
    'My-rb' => 'Nya Zeeland',
    'My-rc' => 'Melanesien, Polynesien och Mikronesien',
    'My-rd' => 'Nya Guinea',
    'My-s' => 'Polarländerna',
    'My-sa' => 'Arktis (Nordpolsområdet)',
    'My-sb' => 'Antarktis',
    'Mz' => 'Folktro och folkseder',
    'Mz-' => 'Särskilda länder och områden',
    'Mz-a' => 'Europa: allmänt',
    'Mz-b' => 'Norden: allmänt',
    'Mz-c' => 'Sverige',
    'Mz-d' => 'Övriga Norden',
    'Mz-da' => 'Danmark',
    'Mz-db' => 'Norge',
    'Mz-dc' => 'Island och Färöarna',
    'Mz-dd' => 'Finland',
    'Mz-e' => 'Brittiska öarna (Storbritannien)',
    'Mz-f' => 'Mellaneuropa',
    'Mz-fa' => 'Tyskland',
    'Mz-fb' => 'Österrike och Liechtenstein',
    'Mz-fc' => 'Ungern',
    'Mz-fd' => 'Tjeckien och Slovakien',
    'Mz-g' => 'Nederländerna, Belgien och Luxemburg',
    'Mz-h' => 'Schweiz',
    'Mz-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Mz-j' => 'Frankrike och Monaco',
    'Mz-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Mz-l' => 'Portugal',
    'Mz-m' => 'Östeuropa',
    'Mz-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Mz-mb' => 'Polen',
    'Mz-mc' => 'Estland, Lettland, Litauen',
    'Mz-n' => 'Balkanländerna',
    'Mz-na' => 'Rumänien',
    'Mz-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Mz-nc' => 'Bulgarien',
    'Mz-nd' => 'Grekland',
    'Mz-o' => 'Asien',
    'Mz-oa' => 'Främre Asien',
    'Mz-ob' => 'Främre Indien',
    'Mz-oc' => 'Bortre Indien',
    'Mz-od' => 'Ostindiska öarna',
    'Mz-oe' => 'Östasien',
    'Mz-oea' => 'Kina',
    'Mz-oeb' => 'Korea',
    'Mz-oec' => 'Japan',
    'Mz-of' => 'Centralasien',
    'Mz-og' => 'Sibirien',
    'Mz-p' => 'Afrika',
    'Mz-pa' => 'Nordafrika utom Egypten',
    'Mz-pb' => 'Egypten och Sudan',
    'Mz-pc' => 'Västafrika',
    'Mz-pd' => 'Centralafrika',
    'Mz-pe' => 'Södra Afrika',
    'Mz-pf' => 'Östafrika',
    'Mz-pg' => 'Nordöstafrika',
    'Mz-q' => 'Amerika',
    'Mz-qa' => 'Förenta staterna',
    'Mz-qb' => 'Kanada',
    'Mz-qc' => 'Mexiko, Centralamerika och Västindien',
    'Mz-qd' => 'Sydamerika',
    'Mz-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Mz-ra' => 'Australien',
    'Mz-rb' => 'Nya Zeeland',
    'Mz-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Mz-rd' => 'Nya Guinea',
    'Mz-s' => 'Polarländerna',
    'Mza' => 'Högtider och fester',
    'Mzaj' => 'Julseder',
    'Mzb' => 'Folkmedicin',
    'Mzd' => 'Övertro och magi',
    'N' => 'Geografi och lokalhistoria',
    'N(x)' => 'Allmänt: geografiska lexikon',
    'N(y)' => 'Allmänt: kartor och bilder',
    'N(ya)' => 'Kartor',
    'N(yb)' => 'Bilder',
    'N:d' => 'Geografisk teori, filosofi och metodlära',
    'N:dd' => 'Metodlära',
    'N:k' => 'Geografiforskningens historia',
    'N:k.' => 'Särskilda perioder',
    'N:k.2' => 'Forntiden',
    'N:k.3' => 'Medeltiden',
    'N:k.4' => 'Nya tiden',
    'N:k.41' => '1500-1648',
    'N:k.43' => '1648-1789',
    'N:k.46' => '1815-1914',
    'N:k.5' => '1900-',
    'N:k.6' => '2000-',
    'N:kc' => 'Sverige',
    'N.0' => 'Allmänt: reseskildringar och -handböcker, särskilda geografiska aspekter',
    'N.01' => 'Naturgeografi',
    'N.02' => 'Kulturgeografi: allmänt',
    'N.03' => 'Bebyggelsegeografi',
    'N.04' => 'Ekonomisk geografi',
    'N.05' => 'Historisk geografi',
    'N.06' => 'Politisk geografi',
    'N.07' => 'Reseskildringar',
    'N.08' => 'Resehandböcker',
    'Na' => 'Europa: allmänt',
    'Na(y)' => 'Kartor och bilder',
    'Na(ya)' => 'Kartor',
    'Na(yb)' => 'Bilder',
    'Na.0' => 'Allmänt: reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Na.01' => 'Naturgeografi',
    'Na.02' => 'Kulturgeografi: allmänt',
    'Na.03' => 'Bebyggelsegeografi',
    'Na.04' => 'Ekonomisk geografi',
    'Na.05' => 'Historisk geografi',
    'Na.06' => 'Politisk geografi',
    'Na.07' => 'Reseskildringar',
    'Na.08' => 'Resehandböcker',
    'Nae' => 'Europeiska unionen (EU)',
    'Naz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Nb' => 'Norden: allmänt',
    'Nb(y)' => 'Kartor och bilder',
    'Nb(ya)' => 'Kartor',
    'Nb(yb)' => 'Bilder',
    'Nb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nb.01' => 'Naturgeografi',
    'Nb.02' => 'Kulturgeografi: allmänt',
    'Nb.03' => 'Bebyggelsegeografi',
    'Nb.04' => 'Ekonomisk geografi',
    'Nb.05' => 'Historisk geografi',
    'Nb.07' => 'Reseskildringar',
    'Nb.08' => 'Resehandböcker',
    'Nbc' => 'Nordkalotten',
    'Nbc(y)' => 'Kartor och bilder',
    'Nbc(ya)' => 'Kartor',
    'Nbc(yb)' => 'Bilder',
    'Nbc.07' => 'Reseskildringar',
    'Nbc.08' => 'Resehandböcker',
    'Nbz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Nc' => 'Sverige',
    'Nc(y)' => 'Kartor och bilder',
    'Nc(ya)' => 'Kartor',
    'Nc(yb)' => 'Bilder',
    'Nc:bf' => 'Hembygdsorganisationer och geografiska institutioner',
    'Nc.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nc.01' => 'Naturgeografi',
    'Nc.02' => 'Kulturgeografi: allmänt',
    'Nc.03' => 'Bebyggelsegeografi',
    'Nc.04' => 'Ekonomisk geografi',
    'Nc.05' => 'Historisk geografi',
    'Nc.06' => 'Politisk geografi',
    'Nc.07' => 'Reseskildringar',
    'Nc.08' => 'Resehandböcker',
    'Nca' => 'Svealand',
    'Nca(y)' => 'Kartor och bilder',
    'Nca(ya)' => 'Kartor',
    'Nca(yb)' => 'Bilder',
    'Nca.07' => 'Reseskildringar',
    'Nca.08' => 'Resehandböcker',
    'Ncaa' => 'Stockholm och Stockholms län',
    'Ncaa(y)' => 'Kartor och bilder',
    'Ncaa(ya)' => 'Kartor',
    'Ncaa(yb)' => 'Bilder',
    'Ncaa.07' => 'Reseskildringar',
    'Ncaa.08' => 'Resehandböcker',
    'Ncaal' => 'Stockholms län',
    'Ncab' => 'Uppland och Uppsala län',
    'Ncab(y)' => 'Kartor och bilder',
    'Ncab(ya)' => 'Kartor',
    'Ncab(yb)' => 'Bilder',
    'Ncab.07' => 'Reseskildringar',
    'Ncab.08' => 'Resehandböcker',
    'Ncaba' => 'Uppsala län',
    'Ncabz' => 'Särskilda orter',
    'Ncac' => 'Södermanland och Södermanlands län',
    'Ncac(y)' => 'Kartor och bilder',
    'Ncac.07' => 'Reseskildringar',
    'Ncac.08' => 'Resehandböcker',
    'Ncacz' => 'Särskilda orter',
    'Ncad' => 'Närke och Örebro län',
    'Ncad(y)' => 'Kartor och bilder',
    'Ncad.07' => 'Reseskildringar',
    'Ncad.08' => 'Resehandböcker',
    'Ncadz' => 'Särskilda orter',
    'Ncae' => 'Västmanland och Västmanlands län',
    'Ncae(y)' => 'Kartor och bilder',
    'Ncae.07' => 'Reseskildringar',
    'Ncae.08' => 'Resehandböcker',
    'Ncaez' => 'Särskilda orter',
    'Ncaf' => 'Dalarna och Dalarnas län',
    'Ncaf(y)' => 'Kartor och bilder',
    'Ncaf.07' => 'Reseskildringar',
    'Ncaf.08' => 'Resehandböcker',
    'Ncafz' => 'Särskilda orter',
    'Ncag' => 'Värmland och Värmlands län',
    'Ncag(y)' => 'Kartor och bilder',
    'Ncag.07' => 'Reseskildringar',
    'Ncag.08' => 'Resehandböcker',
    'Ncagz' => 'Särskilda orter',
    'Ncaz' => 'Särskilda orter, regioner m m (som sträcker sig över flera landskap)',
    'Ncb' => 'Götaland (inkl Västra Götalands län)',
    'Ncb(y)' => 'Kartor och bilder',
    'Ncb(ya)' => 'Kartor',
    'Ncb(yb)' => 'Bilder',
    'Ncb.07' => 'Reseskildringar',
    'Ncb.08' => 'Resehandböcker',
    'Ncba' => 'Skåne och Skåne län',
    'Ncba(y)' => 'Kartor och bilder',
    'Ncba(ya)' => 'Kartor',
    'Ncba(yb)' => 'Bilder',
    'Ncba.07' => 'Reseskildringar',
    'Ncba.08' => 'Resehandböcker',
    'Ncbaz' => 'Särskilda orter',
    'Ncbb' => 'Halland och Hallands län',
    'Ncbb(y)' => 'Kartor och bilder',
    'Ncbb.08' => 'Resehandböcker',
    'Ncbbz' => 'Särskilda orter',
    'Ncbc' => 'Blekinge och Blekinge län',
    'Ncbc(y)' => 'Kartor och bilder',
    'Ncbc.07' => 'Reseskildringar',
    'Ncbc.08' => 'Resehandböcker',
    'Ncbcz' => 'Särskilda orter',
    'Ncbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Ncbd(y)' => 'Kartor och bilder',
    'Ncbd.07' => 'Reseskildringar',
    'Ncbd.08' => 'Resehandböcker',
    'Ncbda' => 'Kronobergs län',
    'Ncbdb' => 'Jönköpings län',
    'Ncbdc' => 'Kalmar län',
    'Ncbdz' => 'Särskilda orter',
    'Ncbe' => 'Öland',
    'Ncbe(y)' => 'Kartor och bilder',
    'Ncbe.07' => 'Reseskildringar',
    'Ncbe.08' => 'Resehandböcker',
    'Ncbez' => 'Särskilda orter',
    'Ncbf' => 'Gotland och Gotlands län',
    'Ncbf(y)' => 'Kartor och bilder',
    'Ncbf(ya)' => 'Kartor',
    'Ncbf(yb)' => 'Bilder',
    'Ncbf.07' => 'Reseskildringar',
    'Ncbf.08' => 'Resehandböcker',
    'Ncbfz' => 'Särskilda orter',
    'Ncbg' => 'Östergötland och Östergötlands län',
    'Ncbg(y)' => 'Kartor och bilder',
    'Ncbg.07' => 'Reseskildringar',
    'Ncbg.08' => 'Resehandböcker',
    'Ncbgz' => 'Särskilda orter',
    'Ncbh' => 'Västergötland',
    'Ncbh(y)' => 'Kartor och bilder',
    'Ncbh.07' => 'Reseskildringar',
    'Ncbh.08' => 'Resehandböcker',
    'Ncbhz' => 'Särskilda orter',
    'Ncbi' => 'Göteborg',
    'Ncbi(y)' => 'Kartor och bilder',
    'Ncbi(ya)' => 'Kartor',
    'Ncbi(yb)' => 'Bilder',
    'Ncbi.08' => 'Resehandböcker',
    'Ncbiz' => 'Särskilda orter',
    'Ncbk' => 'Bohuslän',
    'Ncbk(y)' => 'Kartor och bilder',
    'Ncbk(ya)' => 'Kartor',
    'Ncbk(yb)' => 'Bilder',
    'Ncbk.07' => 'Reseskildringar',
    'Ncbk.08' => 'Resehandböcker',
    'Ncbkz' => 'Särskilda orter',
    'Ncbl' => 'Dalsland',
    'Ncbl(y)' => 'Kartor och bilder',
    'Ncbl.07' => 'Reseskildringar',
    'Ncbl.08' => 'Resehandböcker',
    'Ncblz' => 'Särskilda orter',
    'Ncbz' => 'Särskilda orter, regioner m m (som sträcker sig över flera landskap)',
    'Ncc' => 'Norrland',
    'Ncc(y)' => 'Kartor och bilder',
    'Ncc(ya)' => 'Kartor',
    'Ncc(yb)' => 'Bilder',
    'Ncc.07' => 'Reseskildringar',
    'Ncc.08' => 'Resehandböcker',
    'Ncca' => 'Gästrikland och Gävleborgs län',
    'Ncca(y)' => 'Kartor och bilder',
    'Ncca.07' => 'Reseskildringar',
    'Ncca.08' => 'Resehandböcker',
    'Nccaz' => 'Särskilda orter',
    'Nccb' => 'Hälsingland',
    'Nccb(y)' => 'Kartor och bilder',
    'Nccb(ya)' => 'Kartor',
    'Nccb(yb)' => 'Bilder',
    'Nccb.07' => 'Reseskildringar',
    'Nccb.08' => 'Resehandböcker',
    'Nccbz' => 'Särskilda orter',
    'Nccc' => 'Jämtland och Jämtlands län',
    'Nccc(y)' => 'Kartor och bilder',
    'Nccc(ya)' => 'Kartor',
    'Nccc(yb)' => 'Bilder',
    'Nccc.07' => 'Reseskildringar',
    'Nccc.08' => 'Resehandböcker',
    'Ncccz' => 'Särskilda orter',
    'Nccd' => 'Härjedalen',
    'Nccd(y)' => 'Kartor och bilder',
    'Nccd(ya)' => 'Kartor',
    'Nccd(yb)' => 'Bilder',
    'Nccd.07' => 'Reseskildringar',
    'Nccd.08' => 'Resehandböcker',
    'Nccdz' => 'Särskilda orter',
    'Ncce' => 'Medelpad',
    'Ncce(y)' => 'Kartor och bilder',
    'Ncce.08' => 'Resehandböcker',
    'Nccez' => 'Särskilda orter',
    'Nccf' => 'Ångermanland och Västernorrlands län',
    'Nccf(y)' => 'Kartor och bilder',
    'Nccf(ya)' => 'Kartor',
    'Nccf(yb)' => 'Bilder',
    'Nccf.07' => 'Reseskildringar',
    'Nccf.08' => 'Resehandböcker',
    'Nccfz' => 'Särskilda orter',
    'Nccg' => 'Västerbotten och Västerbottens län',
    'Nccg(y)' => 'Kartor och bilder',
    'Nccg(ya)' => 'Kartor',
    'Nccg(yb)' => 'Bilder',
    'Nccg.07' => 'Reseskildringar',
    'Nccg.08' => 'Resehandböcker',
    'Nccgz' => 'Särskilda orter',
    'Ncch' => 'Norrbotten och Norrbottens län',
    'Ncch(y)' => 'Kartor och bilder',
    'Ncch(ya)' => 'Kartor',
    'Ncch(yb)' => 'Bilder',
    'Ncch.07' => 'Reseskildringar',
    'Ncch.08' => 'Resehandböcker',
    'Ncchz' => 'Särskilda orter',
    'Ncci' => 'Lappland',
    'Ncci(y)' => 'Kartor och bilder',
    'Ncci(yb)' => 'Bilder',
    'Ncci.07' => 'Reseskildringar',
    'Ncci.08' => 'Resehandböcker',
    'Ncciz' => 'Särskilda orter',
    'Nccz' => 'Särskilda orter, regioner m m (som sträcker sig över flera landskap)',
    'Ncz' => 'Särskilda orter, regioner m m (som sträcker sig över flera landskap)',
    'Nd' => 'Övriga Norden',
    'Nda' => 'Danmark',
    'Nda(y)' => 'Kartor och bilder',
    'Nda(ya)' => 'Kartor',
    'Nda(yb)' => 'Bilder',
    'Nda.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nda.01' => 'Naturgeografi',
    'Nda.02' => 'Kulturgeografi: allmänt',
    'Nda.03' => 'Bebyggelsegeografi',
    'Nda.04' => 'Ekonomisk geografi',
    'Nda.05' => 'Historisk geografi',
    'Nda.07' => 'Reseskildringar',
    'Nda.08' => 'Resehandböcker',
    'Ndaz' => 'Särskilda orter',
    'Ndb' => 'Norge',
    'Ndb(y)' => 'Kartor och bilder',
    'Ndb(ya)' => 'Kartor',
    'Ndb(yb)' => 'Bilder',
    'Ndb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ndb.01' => 'Naturgeografi',
    'Ndb.02' => 'Kulturgeografi: allmänt',
    'Ndb.03' => 'Bebyggelsegeografi',
    'Ndb.04' => 'Ekonomisk geografi',
    'Ndb.05' => 'Historisk geografi',
    'Ndb.06' => 'Politisk geografi',
    'Ndb.07' => 'Reseskildringar',
    'Ndb.08' => 'Resehandböcker',
    'Ndbz' => 'Särskilda orter',
    'Ndc' => 'Island och Färöarna',
    'Ndc(y)' => 'Kartor och bilder',
    'Ndc(ya)' => 'Kartor',
    'Ndc(yb)' => 'Bilder',
    'Ndc.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ndc.01' => 'Naturgeografi',
    'Ndc.02' => 'Kulturgeografi: allmänt',
    'Ndc.04' => 'Ekonomisk geografi',
    'Ndc.05' => 'Historisk geografi',
    'Ndc.07' => 'Reseskildringar',
    'Ndc.08' => 'Resehandböcker',
    'Ndcf' => 'Färöarna',
    'Ndcf(y)' => 'Kartor och bilder',
    'Ndcfz' => 'Särskilda orter',
    'Ndcf.07' => 'Reseskildringar',
    'Ndcf.08' => 'Resehandböcker',
    'Ndcz' => 'Island: särskilda orter',
    'Ndd' => 'Finland',
    'Ndd(y)' => 'Kartor och bilder',
    'Ndd(ya)' => 'Kartor',
    'Ndd(yb)' => 'Bilder',
    'Ndd.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ndd.01' => 'Naturgeografi',
    'Ndd.02' => 'Kulturgeografi: allmänt',
    'Ndd.03' => 'Bebyggelsegeografi',
    'Ndd.04' => 'Ekonomisk geografi',
    'Ndd.05' => 'Historisk geografi',
    'Ndd.06' => 'Politisk geografi',
    'Ndd.07' => 'Reseskildringar',
    'Ndd.08' => 'Resehandböcker',
    'Nddz' => 'Särskilda orter',
    'Nddå' => 'Åland',
    'Nddå(y)' => 'Kartor och bilder',
    'Nddå.07' => 'Reseskildringar',
    'Nddå.08' => 'Resehandböcker',
    'Nddåz' => 'Särskilda orter',
    'Ne' => 'Brittiska öarna (Storbritannien)',
    'Ne(y)' => 'Allmänt: kartor och bilder',
    'Ne(ya)' => 'Kartor',
    'Ne(yb)' => 'Bilder',
    'Ne.0' => 'Allmänt: reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ne.01' => 'Naturgeografi',
    'Ne.02' => 'Kulturgeografi: allmänt',
    'Ne.03' => 'Bebyggelsegeografi',
    'Ne.04' => 'Ekonomisk geografi',
    'Ne.05' => 'Historisk geografi',
    'Ne.06' => 'Politisk geografi',
    'Ne.07' => 'Reseskildringar',
    'Ne.08' => 'Resehandböcker',
    'Nea' => 'England',
    'Nea(y)' => 'Kartor och bilder',
    'Nea.07' => 'Reseskildringar',
    'Nea.08' => 'Resehandböcker',
    'Ner' => 'Wales',
    'Ner.08' => 'Resehandböcker',
    'Nes' => 'Skottland',
    'Nes.07' => 'Reseskildringar',
    'Nes.08' => 'Resehandböcker',
    'Net' => 'Irland',
    'Net(y)' => 'Kartor och bilder',
    'Net.07' => 'Reseskildringar',
    'Net.08' => 'Resehandböcker',
    'Neta' => 'Irland (republiken)',
    'Netb' => 'Nordirland',
    'Nez' => 'Särskilda orter',
    'Nf' => 'Mellaneuropa',
    'Nf(y)' => 'Allmänt: kartor och bilder',
    'Nf(ya)' => 'Kartor',
    'Nf.07' => 'Allmänt: reseskildringar',
    'Nf.08' => 'Allmänt: resehandböcker',
    'Nfa' => 'Tyskland',
    'Nfa(y)' => 'Tyskland: kartor och bilder',
    'Nfa(ya)' => 'Kartor',
    'Nfa(yb)' => 'Bilder',
    'Nfa.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nfa.01' => 'Naturgeografi',
    'Nfa.02' => 'Kulturgeografi: allmänt',
    'Nfa.03' => 'Bebyggelsegeografi',
    'Nfa.04' => 'Ekonomisk geografi',
    'Nfa.05' => 'Historisk geografi',
    'Nfa.06' => 'Politisk geografi',
    'Nfa.07' => 'Reseskildringar',
    'Nfa.08' => 'Resehandböcker',
    'Nfag' => 'Västra Tyskland',
    'Nfah' => 'Östra Tyskland',
    'Nfai' => 'Berlin',
    'Nfaz' => 'Särskilda orter',
    'Nfb' => 'Österrike och Liechtenstein',
    'Nfb(y)' => 'Österrike: kartor och bilder',
    'Nfb(ya)' => 'Kartor',
    'Nfb(yb)' => 'Bilder',
    'Nfb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nfb.01' => 'Naturgeografi',
    'Nfb.02' => 'Kulturgeografi: allmänt',
    'Nfb.03' => 'Bebyggelsegeografi',
    'Nfb.04' => 'Ekonomisk geografi',
    'Nfb.05' => 'Historisk geografi',
    'Nfb.07' => 'Reseskildringar',
    'Nfb.08' => 'Resehandböcker',
    'Nfbi' => 'Liechtenstein',
    'Nfbz' => 'Österrike: särskilda orter',
    'Nfc' => 'Ungern',
    'Nfc(y)' => 'Kartor och bilder',
    'Nfc.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nfc.01' => 'Naturgeografi',
    'Nfc.02' => 'Kulturgeografi: allmänt',
    'Nfc.03' => 'Bebyggelsegeografi',
    'Nfc.04' => 'Ekonomisk geografi',
    'Nfc.05' => 'Historisk geografi',
    'Nfc.07' => 'Reseskildringar',
    'Nfc.08' => 'Resehandböcker',
    'Nfcz' => 'Särskilda orter',
    'Nfd' => 'Tjeckien och Slovakien',
    'Nfd(y)' => 'Kartor och bilder',
    'Nfd(ya)' => 'Kartor',
    'Nfd(yb)' => 'Bilder',
    'Nfd.07' => 'Reseskildringar',
    'Nfd.08' => 'Resehandböcker',
    'Nfda' => 'Tjeckien',
    'Nfdaz' => 'Särskilda orter',
    'Nfdb' => 'Slovakien',
    'Nfdbz' => 'Särskilda orter',
    'Ng' => 'Nederländerna, Belgien och Luxemburg',
    'Ng(y)' => 'Allmänt: kartor och bilder',
    'Ng(ya)' => 'Kartor',
    'Ng.07' => 'Allmänt: reseskildringar',
    'Ng.08' => 'Allmänt: resehandböcker',
    'Nga' => 'Nederländerna',
    'Nga(y)' => 'Kartor och bilder',
    'Nga(ya)' => 'Kartor',
    'Nga(yb)' => 'Bilder',
    'Nga.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nga.01' => 'Naturgeografi',
    'Nga.02' => 'Kulturgeografi: allmänt',
    'Nga.03' => 'Bebyggelsegeografi',
    'Nga.04' => 'Ekonomisk geografi',
    'Nga.05' => 'Historisk geografi',
    'Nga.07' => 'Reseskildringar',
    'Nga.08' => 'Resehandböcker',
    'Ngaz' => 'Särskilda orter',
    'Ngb' => 'Belgien',
    'Ngb(y)' => 'Kartor och bilder',
    'Ngb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ngb.04' => 'Ekonomisk geografi',
    'Ngb.05' => 'Historisk geografi',
    'Ngb.07' => 'Reseskildringar',
    'Ngb.08' => 'Resehandböcker',
    'Ngbz' => 'Särskilda orter',
    'Ngc' => 'Luxemburg',
    'Ngcz' => 'Särskilda orter',
    'Nh' => 'Schweiz',
    'Nh(y)' => 'Kartor och bilder',
    'Nh(ya)' => 'Kartor',
    'Nh(yb)' => 'Bilder',
    'Nh.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nh.01' => 'Naturgeografi',
    'Nh.02' => 'Kulturgeografi: allmänt',
    'Nh.03' => 'Bebyggelsegeografi',
    'Nh.04' => 'Ekonomisk geografi',
    'Nh.05' => 'Historisk geografi',
    'Nh.07' => 'Reseskildringar',
    'Nh.08' => 'Resehandböcker',
    'Nhz' => 'Särskilda orter',
    'Ni' => 'Italien',
    'Ni(y)' => 'Kartor och bilder',
    'Ni(ya)' => 'Kartor',
    'Ni(yb)' => 'Bilder',
    'Ni.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Ni.01' => 'Naturgeografi',
    'Ni.02' => 'Kulturgeografi: allmänt',
    'Ni.03' => 'Bebyggelsegeografi',
    'Ni.04' => 'Ekonomisk geografi',
    'Ni.05' => 'Historisk geografi',
    'Ni.07' => 'Reseskildringar',
    'Ni.08' => 'Resehandböcker',
    'Nig' => 'Vatikanstaten',
    'Nij' => 'San Marino',
    'Niv' => 'Malta',
    'Niz' => 'Särskilda orter',
    'Nj' => 'Frankrike',
    'Nj(y)' => 'Kartor och bilder',
    'Nj(ya)' => 'Kartor',
    'Nj(yb)' => 'Bilder',
    'Nj.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nj.01' => 'Naturgeografi',
    'Nj.02' => 'Kulturgeografi: allmänt',
    'Nj.03' => 'Bebyggelsegeografi',
    'Nj.04' => 'Ekonomisk geografi',
    'Nj.05' => 'Historisk geografi',
    'Nj.07' => 'Reseskildringar',
    'Nj.08' => 'Resehandböcker',
    'Njv' => 'Monaco',
    'Njz' => 'Särskilda orter',
    'Nk' => 'Spanien',
    'Nk(y)' => 'Kartor och bilder',
    'Nk(ya)' => 'Kartor',
    'Nk(yb)' => 'Bilder',
    'Nk.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nk.01' => 'Naturgeografi',
    'Nk.02' => 'Kulturgeografi: allmänt',
    'Nk.03' => 'Bebyggelsegeografi',
    'Nk.04' => 'Ekonomisk geografi',
    'Nk.05' => 'Historisk geografi',
    'Nk.07' => 'Reseskildringar',
    'Nk.08' => 'Resehandböcker',
    'Nki' => 'Andorra',
    'Nkk' => 'Gibraltar',
    'Nkz' => 'Särskilda orter',
    'Nl' => 'Portugal',
    'Nl(y)' => 'Kartor och bilder',
    'Nl.07' => 'Reseskildringar',
    'Nl.08' => 'Resehandböcker',
    'Nlz' => 'Särskilda orter',
    'Nm' => 'Östeuropa',
    'Nm(y)' => 'Allmänt: kartor och bilder',
    'Nm.07' => 'Allmänt: reseskildringar',
    'Nm.08' => 'Allmänt: resehandböcker',
    'Nma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Nma(y)' => 'Kartor och bilder',
    'Nma(ya)' => 'Kartor',
    'Nma(yb)' => 'Bilder',
    'Nma.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nma.01' => 'Naturgeografi',
    'Nma.02' => 'Kulturgeografi: allmänt',
    'Nma.03' => 'Bebyggelsegeografi',
    'Nma.04' => 'Ekonomisk geografi',
    'Nma.05' => 'Historisk geografi',
    'Nma.06' => 'Politisk geografi',
    'Nma.07' => 'Reseskildringar',
    'Nma.08' => 'Resehandböcker',
    'Nmad' => 'Ukraina',
    'Nmadz' => 'Särskilda orter',
    'Nmae' => 'Vitryssland',
    'Nmaez' => 'Särskilda orter',
    'Nmaf' => 'Moldavien',
    'Nmafz' => 'Särskilda orter',
    'Nmaz' => 'Ryssland: särskilda orter',
    'Nmb' => 'Polen',
    'Nmb(y)' => 'Kartor och bilder',
    'Nmb(ya)' => 'Kartor',
    'Nmb(yb)' => 'Bilder',
    'Nmb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nmb.01' => 'Naturgeografi',
    'Nmb.02' => 'Kulturgeografi: allmänt',
    'Nmb.03' => 'Bebyggelsegeografi',
    'Nmb.04' => 'Ekonomisk geografi',
    'Nmb.05' => 'Historisk geografi',
    'Nmb.06' => 'Politisk geografi',
    'Nmb.07' => 'Reseskildringar',
    'Nmb.08' => 'Resehandböcker',
    'Nmbz' => 'Särskilda orter',
    'Nmc' => 'Estland, Lettland, Litauen',
    'Nmc(y)' => 'Allmänt: kartor och bilder',
    'Nmc.07' => 'Allmänt: reseskildringar',
    'Nmc.08' => 'Allmänt: resehandböcker',
    'Nmca' => 'Estland',
    'Nmca(y)' => 'Kartor och bilder',
    'Nmca(ya)' => 'Kartor',
    'Nmca(yb)' => 'Bilder',
    'Nmca.07' => 'Reseskildringar',
    'Nmca.08' => 'Resehandböcker',
    'Nmcaz' => 'Särskilda orter',
    'Nmcb' => 'Lettland',
    'Nmcb(y)' => 'Kartor och bilder',
    'Nmcb.07' => 'Reseskildringar',
    'Nmcb.08' => 'Resehandböcker',
    'Nmcbz' => 'Särskilda orter',
    'Nmcc' => 'Litauen',
    'Nmcc(y)' => 'Kartor och bilder',
    'Nmcc.08' => 'Resehandböcker',
    'Nmcz' => 'Särskilda orter',
    'Nn' => 'Balkanländerna',
    'Nna' => 'Rumänien',
    'Nna(y)' => 'Kartor och bilder',
    'Nna(ya)' => 'Kartor',
    'Nna(yb)' => 'Bilder',
    'Nna.07' => 'Reseskildringar',
    'Nna.08' => 'Resehandböcker',
    'Nnaz' => 'Särskilda orter',
    'Nnb' => 'F d Jugoslavien  (Serbien, Kroatien, Slovenien etc.)',
    'Nnb(y)' => 'Kartor och bilder',
    'Nnb(ya)' => 'Kartor',
    'Nnb(yb)' => 'Bilder',
    'Nnb.07' => 'Reseskildringar',
    'Nnb.08' => 'Resehandböcker',
    'Nnba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Nnbb' => 'Kroatien',
    'Nnbc' => 'Slovenien',
    'Nnbd' => 'Bosnien-Hercegovina',
    'Nnbe' => 'Montengro',
    'Nnbf' => 'Makedonien',
    'Nnbz' => 'Särskilda orter',
    'Nnc' => 'Bulgarien',
    'Nnc(y)' => 'Kartor och bilder',
    'Nnc.07' => 'Reseskildringar',
    'Nnc.08' => 'Resehandböcker',
    'Nncz' => 'Särskilda orter',
    'Nnd' => 'Grekland',
    'Nnd(y)' => 'Kartor och bilder',
    'Nnd(yb)' => 'Bilder',
    'Nnd.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nnd.05' => 'Historisk geografi',
    'Nnd.07' => 'Reseskildringar',
    'Nnd.08' => 'Resehandböcker',
    'Nndi' => 'Grekiska arkipelagen: allmänt',
    'Nndi(y)' => 'Kartor och bilder',
    'Nndi.07' => 'Reseskildringar',
    'Nndi.08' => 'Resehandböcker',
    'Nndk' => 'Kreta',
    'Nndk(y)' => 'Kartor och bilder',
    'Nndk.07' => 'Reseskildringar',
    'Nndk.08' => 'Resehandböcker',
    'Nndz' => 'Särskilda orter och övriga särskilda öar',
    'Nnf' => 'Albanien',
    'Nnfz' => 'Särskilda orter',
    'No' => 'Asien',
    'No(y)' => 'Allmänt: kartor och bilder',
    'No(ya)' => 'Kartor',
    'No(yb)' => 'Bilder',
    'No.07' => 'Allmänt: reseskildringar',
    'No.08' => 'Allmänt: resehandböcker',
    'Noa' => 'Främre Asien',
    'Noa(y)' => 'Allmänt: kartor och bilder',
    'Noa(ya)' => 'Kartor',
    'Noa(yb)' => 'Bilder',
    'Noa.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noa.01' => 'Naturgeografi',
    'Noa.02' => 'Kulturgeografi: allmänt',
    'Noa.03' => 'Bebyggelsegeografi',
    'Noa.04' => 'Ekonomisk geografi',
    'Noa.05' => 'Historisk geografi',
    'Noa.07' => 'Reseskildringar',
    'Noa.08' => 'Resehandböcker',
    'Noaa' => 'Turkiet',
    'Noaa(y)' => 'Kartor och bilder',
    'Noaa.07' => 'Reseskildringar',
    'Noaa.08' => 'Resehandböcker',
    'Noaaz' => 'Särskilda orter',
    'Noab' => 'Cypern',
    'Noab.07' => 'Reseskildringar',
    'Noab.08' => 'Resehandböcker',
    'Noabz' => 'Särskilda orter',
    'Noac' => 'Kaukasien',
    'Noac(y)' => 'Kartor och bilder',
    'Noac(yb)' => 'Bilder',
    'Noac.07' => 'Reseskildringar',
    'Noac.08' => 'Resehandböcker',
    'Noaca' => 'Azerbajdzjan',
    'Noacb' => 'Armenien',
    'Noacc' => 'Georgien',
    'Noacz' => 'Särskilda orter',
    'Noae' => 'Syrien och Libanon',
    'Noae.07' => 'Reseskildringar',
    'Noae.08' => 'Resehandböcker',
    'Noaea' => 'Syrien',
    'Noaeaz' => 'Särskilda orter',
    'Noaeb' => 'Libanon',
    'Noaebz' => 'Särskilda orter',
    'Noaf' => 'Palestina och Israel',
    'Noaf(y)' => 'Palestina: kartor och bilder',
    'Noaf(ya)' => 'Kartor',
    'Noaf(yb)' => 'Bilder',
    'Noaf.0' => 'Palestina: reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noaf.01' => 'Naturgeografi',
    'Noaf.02' => 'Kulturgeografi: allmänt',
    'Noaf.03' => 'Bebyggelsegeografi',
    'Noaf.04' => 'Ekonomisk geografi',
    'Noaf.05' => 'Historisk geografi',
    'Noaf.06' => 'Politisk geografi',
    'Noaf.07' => 'Reseskildringar',
    'Noaf.08' => 'Resehandböcker',
    'Noafi' => 'Israel',
    'Noafi(y)' => 'Kartor och bilder',
    'Noafi(ya)' => 'Kartor',
    'Noafi(yb)' => 'Bilder',
    'Noafi.07' => 'Reseskildringar',
    'Noafi.08' => 'Resehandböcker',
    'Noafz' => 'Särskilda orter',
    'Noag' => 'Jordanien',
    'Noag.07' => 'Reseskildringar',
    'Noag.08' => 'Resehandböcker',
    'Noagz' => 'Särskilda orter',
    'Noah' => 'Arabiska halvön',
    'Noah.07' => 'Reseskildringar',
    'Noah.08' => 'Resehandböcker',
    'Noaha' => 'Saudi-Arabien',
    'Noahaz' => 'Särskilda orter',
    'Noahb' => 'Nordjemen',
    'Noahbz' => 'Särskilda orter',
    'Noahc' => 'Sydjemen',
    'Noahcz' => 'Särskilda orter',
    'Noahd' => 'Oman',
    'Noahdz' => 'Särskilda orter',
    'Noahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Noahea' => 'Förenade Arabemiraten',
    'Noahed' => 'Qatar',
    'Noaheg' => 'Bahrain',
    'Noahf' => 'Kuwait',
    'Noai' => 'Irak',
    'Noaiz' => 'Särskilda orter',
    'Noak' => 'Iran (Persien)',
    'Noak(y)' => 'Kartor och bilder',
    'Noak(ya)' => 'Kartor',
    'Noak(yb)' => 'Bilder',
    'Noak.07' => 'Reseskildringar',
    'Noak.08' => 'Resehandböcker',
    'Noakz' => 'Särskilda orter',
    'Noal' => 'Afghanistan',
    'Noal(y)' => 'Kartor och bilder',
    'Noal.07' => 'Reseskildringar',
    'Noal.08' => 'Resehandböcker',
    'Noalz' => 'Särskilda orter',
    'Noam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Noam(y)' => 'Kartor och bilder',
    'Noam.07' => 'Reseskildringar',
    'Noam.08' => 'Resehandböcker',
    'Noama' => 'Kazakstan',
    'Noamb' => 'Turkmenistan',
    'Noamc' => 'Uzbekistan',
    'Noamd' => 'Kirgisistan',
    'Noame' => 'Tadzjikistan',
    'Noamz' => 'Särskilda orter',
    'Noaz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Nob' => 'Främre Indien',
    'Nob(y)' => 'Allmänt: kartor och bilder',
    'Nob.07' => 'Allmänt: reseskildringar',
    'Nob.08' => 'Allmänt: resehandböcker',
    'Noba' => 'Indien',
    'Noba(y)' => 'Kartor och bilder',
    'Noba(ya)' => 'Kartor',
    'Noba(yb)' => 'Bilder',
    'Noba.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noba.01' => 'Naturgeografi',
    'Noba.02' => 'Kulturgeografi: allmänt',
    'Noba.03' => 'Bebyggelsegeografi',
    'Noba.04' => 'Ekonomisk geografi',
    'Noba.07' => 'Reseskildringar',
    'Noba.08' => 'Resehandböcker',
    'Nobaz' => 'Särskilda orter',
    'Nobb' => 'Pakistan och Bangladesh',
    'Nobba' => 'Pakistan',
    'Nobbaz' => 'Särskilda orter',
    'Nobbb' => 'Bangladesh',
    'Nobbbz' => 'Särskilda orter',
    'Nobc' => 'Bhutan',
    'Nobd' => 'Nepal',
    'Nobdz' => 'Särskilda orter',
    'Nobe' => 'Sri Lanka (f d Ceylon)',
    'Nobez' => 'Särskilda orter',
    'Nobf' => 'Maldiverna',
    'Nobz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Noc' => 'Bortre Indien',
    'Noc(y)' => 'Allmänt: kartor och bilder',
    'Noc.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noc.02' => 'Kulturgeografi: allmänt',
    'Noc.04' => 'Ekonomisk geografi',
    'Noc.07' => 'Reseskildringar',
    'Noc.08' => 'Resehandböcker',
    'Noca' => 'Myanmar (f d Burma)',
    'Noca.07' => 'Reseskildringar',
    'Noca.08' => 'Resehandböcker',
    'Nocaz' => 'Särskilda orter',
    'Nocb' => 'Thailand',
    'Nocb.07' => 'Reseskildringar',
    'Nocb.08' => 'Resehandböcker',
    'Nocbz' => 'Särskilda orter',
    'Nocc' => 'Malaysia, Singapore och Brunei',
    'Nocca' => 'Malaysia',
    'Noccaz' => 'Särskilda orter',
    'Noccb' => 'Singapore',
    'Noccd' => 'Brunei',
    'Nocd' => 'Indokina',
    'Nocda' => 'Laos',
    'Nocdb' => 'Kambodja',
    'Nocdbz' => 'Särskilda orter',
    'Nocdc' => 'Vietnam',
    'Nocdc.07' => 'Reseskildringar',
    'Nocdc.08' => 'Resehandböcker',
    'Nocdcz' => 'Särskilda orter',
    'Nod' => 'Ostindiska öarna',
    'Nod(y)' => 'Allmänt: kartor och bilder',
    'Nod.07' => 'Allmänt: reseskildringar',
    'Nod.08' => 'Allmänt: resehandböcker',
    'Noda' => 'Indonesien',
    'Noda.07' => 'Reseskildringar',
    'Noda.08' => 'Resehandböcker',
    'Nodaa' => 'Sumatra',
    'Nodab' => 'Java',
    'Nodac' => 'Kalimantan (Borneo)',
    'Nodad' => 'Sulawesi (Celebes)',
    'Nodae' => 'Moluckerna',
    'Nodaf' => 'Timor och Östtimor',
    'Nodaz' => 'Särskilda orter',
    'Nodc' => 'Filippinerna',
    'Nodcz' => 'Särskilda orter',
    'Noe' => 'Östasien',
    'Noe.07' => 'Reseskildringar',
    'Noea' => 'Kina',
    'Noea(y)' => 'Kartor och bilder',
    'Noea(ya)' => 'Kartor',
    'Noea(yb)' => 'Bilder',
    'Noea.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noea.01' => 'Naturgeografi',
    'Noea.02' => 'Kulturgeografi: allmänt',
    'Noea.03' => 'Bebyggelsegeografi',
    'Noea.04' => 'Ekonomisk geografi',
    'Noea.05' => 'Historisk geografi',
    'Noea.06' => 'Politisk geografi',
    'Noea.07' => 'Reseskildringar',
    'Noea.08' => 'Resehandböcker',
    'Noeaf' => 'Taiwan',
    'Noeai' => 'Manchuriet',
    'Noeak' => 'Tibet',
    'Noeak(y)' => 'Kartor och bilder',
    'Noeal' => 'Sinkiang (Xinjiang Uygur)',
    'Noeam' => 'Inre Mongoliet',
    'Noeaz' => 'Särskilda orter',
    'Noeb' => 'Korea',
    'Noeb.07' => 'Reseskildringar',
    'Noeb.08' => 'Resehandböcker',
    'Noeba' => 'Nordkorea',
    'Noebb' => 'Sydkorea',
    'Noebz' => 'Särskilda orter',
    'Noec' => 'Japan',
    'Noec(y)' => 'Kartor och bilder',
    'Noec(ya)' => 'Kartor',
    'Noec(yb)' => 'Bilder',
    'Noec.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Noec.02' => 'Kulturgeografi: allmänt',
    'Noec.03' => 'Bebyggelsegeografi',
    'Noec.04' => 'Ekonomisk geografi',
    'Noec.05' => 'Historisk geografi',
    'Noec.07' => 'Reseskildringar',
    'Noec.08' => 'Resehandböcker',
    'Noecz' => 'Särskilda orter',
    'Noek' => 'Hongkong och Macau',
    'Noeka' => 'Hongkong',
    'Noekc' => 'Macau',
    'Nof' => 'Centralasien',
    'Nof(y)' => 'Kartor och bilder',
    'Nof.07' => 'Reseskildringar',
    'Nofc' => 'Mongoliet',
    'Nofc(y)' => 'Kartor och bilder',
    'Nofc.07' => 'Reseskildringar',
    'Nog' => 'Sibirien',
    'Nog(y)' => 'Kartor och bilder',
    'Nog(ya)' => 'Kartor',
    'Nog(yb)' => 'Bilder',
    'Nog.07' => 'Reseskildringar',
    'Nogz' => 'Särskilda orter',
    'Np' => 'Afrika',
    'Np(y)' => 'Allmänt: kartor och bilder',
    'Np(ya)' => 'Kartor',
    'Np(yb)' => 'Bilder',
    'Np.0' => 'Allmänt: reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Np.01' => 'Naturgeografi',
    'Np.02' => 'Kulturgeografi: allmänt',
    'Np.03' => 'Bebyggelsegeografi',
    'Np.04' => 'Ekonomisk geografi',
    'Np.05' => 'Historisk geografi',
    'Np.06' => 'Politisk geografi',
    'Np.07' => 'Reseskildringar',
    'Np.08' => 'Resehandböcker',
    'Npa' => 'Nordafrika utom Egypten',
    'Npa.07' => 'Allmänt: reseskildringar',
    'Npa.08' => 'Allmänt: resehandböcker',
    'Npaa' => 'Marocko och Kanarieöarna',
    'Npaa.07' => 'Marocko: reseskildringar',
    'Npaa.08' => 'Marocko: resehandböcker',
    'Npaai' => 'Kanarieöarna',
    'Npaai.07' => 'Reseskildringar',
    'Npaai.08' => 'Resehandböcker',
    'Npaaz' => 'Särskilda orter',
    'Npab' => 'Algeriet',
    'Npab(y)' => 'Kartor och bilder',
    'Npab.07' => 'Reseskildringar',
    'Npab.08' => 'Reesehandböcker',
    'Npabz' => 'Särskilda orter',
    'Npac' => 'Tunisien',
    'Npac(y)' => 'Kartor och bilder',
    'Npac.07' => 'Reseskildringar',
    'Npac.08' => 'Resehandböcker',
    'Npacz' => 'Särskilda orter',
    'Npad' => 'Libyen',
    'Npad(y)' => 'Kartor och bilder',
    'Npad.07' => 'Reseskildringar',
    'Npad.08' => 'Resehandböcker',
    'Npadz' => 'Särskilda orter',
    'Npaz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Npb' => 'Egypten och Sudan',
    'Npb.07' => 'Allmänt: reseskildringar',
    'Npb.08' => 'Allmänt: resehandböcker',
    'Npba' => 'Egypten',
    'Npba(y)' => 'Kartor och bilder',
    'Npba(ya)' => 'Kartor',
    'Npba(yb)' => 'Bilder',
    'Npba.07' => 'Reseskildringar',
    'Npba.08' => 'Resehandböcker',
    'Npbaz' => 'Särskilda orter',
    'Npbb' => 'Sudan',
    'Npbbz' => 'Särskilda orter',
    'Npbz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Npc' => 'Västafrika',
    'Npc.07' => 'Allmänt: reseskildringar',
    'Npc.08' => 'Allmänt: resehandböcker',
    'Npcb' => 'Ekvatorialafrika',
    'Npcba' => 'Tchad',
    'Npcbb' => 'Centralafrikanska republiken',
    'Npcbc' => 'Kongo (Brazzaville)',
    'Npcbd' => 'Gabon',
    'Npcbe' => 'Kamerun',
    'Npcc' => 'Norra Västafrika',
    'Npcca' => 'Västra Sahara',
    'Npccb' => 'Mauretanien',
    'Npccc' => 'Senegal',
    'Npccd' => 'Gambia',
    'Npcce' => 'Mali',
    'Npccg' => 'Burkina Faso',
    'Npcch' => 'Niger',
    'Npcci' => 'Guinea-Bissau',
    'Npccj' => 'Cap Verde',
    'Npcck' => 'Guinea',
    'Npccl' => 'Elfenbenskusten',
    'Npccm' => 'Sierra Leone',
    'Npccn' => 'Liberia',
    'Npcd' => 'Södra Västafrika',
    'Npcda' => 'Ghana',
    'Npcdaz' => 'Särskilda orter',
    'Npcdb' => 'Togo',
    'Npcdc' => 'Benin',
    'Npcdd' => 'Nigeria',
    'Npcddz' => 'Särskilda orter',
    'Npcde' => 'Ekvatorialguinea',
    'Npcdf' => 'Sao Thomé och Principe',
    'Npd' => 'Centralafrika',
    'Npd.07' => 'Allmänt: reseskildringar',
    'Npd.08' => 'Allmänt: resehandböcker',
    'Npda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Npdaa' => 'Kongo (Kinshasa)',
    'Npdaaz' => 'Särskilda orter',
    'Npdab' => 'Rwanda',
    'Npdac' => 'Burundi',
    'Npdb' => 'Angola',
    'Npe' => 'Södra Afrika',
    'Npe(y)' => 'Allmänt: kartor och bilder',
    'Npe.07' => 'Allmänt: reseskildringar',
    'Npe.08' => 'Allmänt: resehandböcker',
    'Npea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Npeaa' => 'Sydafrikanska republiken',
    'Npeaa.07' => 'Reseskildringar',
    'Npeaa.08' => 'Resehandböcker',
    'Npeaaz' => 'Särskilda hemländer och orter',
    'Npeab' => 'Namibia',
    'Npeab(y)' => 'Kartor och bilder',
    'Npeab.07' => 'Reseskildringar',
    'Npeab.08' => 'Resehandböcker',
    'Npeac' => 'Lesotho',
    'Npead' => 'Swaziland',
    'Npeaz' => 'Särskilda orter',
    'Npeb' => 'Botswana',
    'Npeb.07' => 'Reseskildringar',
    'Npeb.08' => 'Resehandböcker',
    'Npec' => 'Zimbabwe, Zambia, Malawi',
    'Npeca' => 'Zimbabwe',
    'Npeca(y)' => 'Kartor och bilder',
    'Npeca.07' => 'Reseskildringar',
    'Npeca.08' => 'Resehandböcker',
    'Npecb' => 'Zambia',
    'Npecb.07' => 'Reseskildringar',
    'Npecb.08' => 'Resehandböcker',
    'Npecbz' => 'Särskilda orter',
    'Npecc' => 'Malawi',
    'Nped' => 'Mocambique',
    'Nped(y)' => 'Kartor och bilder',
    'Npedz' => 'Särskilda orter',
    'Nped.07' => 'Reseskildringar',
    'Nped.08' => 'Resehandböcker',
    'Npee' => 'Madagaskar (Malagasy)',
    'Npee.07' => 'Reseskildringar',
    'Npee.08' => 'Resehandböcker',
    'Npef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Npefa' => 'Komorerna',
    'Npefb' => 'Mauritius',
    'Npefc' => 'Réunion',
    'Npf' => 'Östafrika',
    'Npf(y)' => 'Allmänt: kartor och bilder',
    'Npf.07' => 'Allmänt: reseskildringar',
    'Npf.08' => 'Allmänt: resehandböcker',
    'Npfa' => 'Uganda',
    'Npfa.07' => 'Reseskildringar',
    'Npfa.08' => 'Resehandböcker',
    'Npfaz' => 'Särskilda orter',
    'Npfb' => 'Kenya',
    'Npfb(y)' => 'Kartor och bilder',
    'Npfb.07' => 'Reseskildringar',
    'Npfb.08' => 'Resehandböcker',
    'Npfbz' => 'Särskilda orter',
    'Npfc' => 'Tanzania',
    'Npfc(y)' => 'Kartor och bilder',
    'Npfc.07' => 'Reseskildringar',
    'Npfc.08' => 'Resehandböcker',
    'Npfcb' => 'Zanzibar',
    'Npfcz' => 'Särskilda orter',
    'Npfd' => 'Öar i nordvästra Indiska Oceanen',
    'Npfda' => 'Seychellerna',
    'Npg' => 'Nordöstafrika (Afrikas horn)',
    'Npga' => 'Etiopien med Eritrea',
    'Npga(y)' => 'Kartor och bilder',
    'Npga.07' => 'Reseskildringar',
    'Npga.08' => 'Resehandböcker',
    'Npgae' => 'Eritrea',
    'Npgaz' => 'Särskilda orter',
    'Npgb' => 'Somalia',
    'Npgc' => 'Djibouti',
    'Nq' => 'Amerika',
    'Nq(y)' => 'Allmänt: kartor och bilder',
    'Nqa' => 'Förenta staterna',
    'Nqa(y)' => 'Förenta staterna: kartor och bilder',
    'Nqa(ya)' => 'Kartor',
    'Nqa(yb)' => 'Bilder',
    'Nqa.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nqa.01' => 'Naturgeografi',
    'Nqa.02' => 'Kulturgeografi: allmänt',
    'Nqa.03' => 'Bebyggelsegeografi',
    'Nqa.04' => 'Ekonomisk geografi',
    'Nqa.05' => 'Historisk geografi',
    'Nqa.06' => 'Politisk geografi',
    'Nqa.07' => 'Reseskildringar',
    'Nqa.08' => 'Resehandböcker',
    'Nqaa' => 'Nordöstra staterna',
    'Nqaaa' => 'Maine',
    'Nqaab' => 'New Hampshire',
    'Nqaac' => 'Vermont',
    'Nqaad' => 'Massachusetts',
    'Nqaae' => 'Rhode Island',
    'Nqaaf' => 'Connecticut',
    'Nqaag' => 'New York',
    'Nqaah' => 'Pennsylvania',
    'Nqaai' => 'New Jersey',
    'Nqab' => 'Sydöstra staterna',
    'Nqaba' => 'Delaware',
    'Nqabb' => 'Maryland',
    'Nqabc' => 'District of Columbia (Washington D.C.)',
    'Nqabd' => 'West Virginia',
    'Nqabe' => 'Virginia',
    'Nqabf' => 'North Carolina',
    'Nqabg' => 'South Carolina',
    'Nqabh' => 'Georgia',
    'Nqabi' => 'Florida',
    'Nqac' => 'Södra centralstaterna',
    'Nqaca' => 'Alabama',
    'Nqacb' => 'Mississippi',
    'Nqacc' => 'Louisiana',
    'Nqacd' => 'Texas',
    'Nqacf' => 'Oklahoma',
    'Nqacg' => 'Arkansas',
    'Nqach' => 'Tennessee',
    'Nqaci' => 'Kentucky',
    'Nqad' => 'Norra centralstaterna',
    'Nqada' => 'Ohio',
    'Nqadb' => 'Indiana',
    'Nqadc' => 'Illinois',
    'Nqadd' => 'Michigan',
    'Nqade' => 'Wisconsin',
    'Nqadf' => 'Minnesota',
    'Nqadg' => 'Iowa',
    'Nqadh' => 'Missouri',
    'Nqae' => 'Bergsstaterna',
    'Nqaea' => 'Kansas',
    'Nqaeb' => 'Nebraska',
    'Nqaec' => 'South Dakota',
    'Nqaed' => 'North Dakota',
    'Nqaef' => 'Montana',
    'Nqaeg' => 'Wyoming',
    'Nqaeh' => 'Colorado',
    'Nqaei' => 'New Mexico',
    'Nqaf' => 'Stillahavsstaterna',
    'Nqafa' => 'Arizona',
    'Nqafb' => 'Utah',
    'Nqafc' => 'Nevada',
    'Nqafd' => 'Kalifornien',
    'Nqafe' => 'Oregon',
    'Nqaff' => 'Idaho',
    'Nqafg' => 'Washington',
    'Nqafh' => 'Alaska',
    'Nqaz' => 'Särskilda orter',
    'Nqb' => 'Kanada',
    'Nqb(y)' => 'Kanada: kartor och bilder',
    'Nqb(ya)' => 'Kartor',
    'Nqb(yb)' => 'Bilder',
    'Nqb.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nqb.01' => 'Naturgeografi',
    'Nqb.02' => 'Kulturgeografi: allmänt',
    'Nqb.03' => 'Bebyggelsegeografi',
    'Nqb.04' => 'Ekonomisk geografi',
    'Nqb.05' => 'Historisk geografi',
    'Nqb.07' => 'Reseskildringar',
    'Nqb.08' => 'Resehandböcker',
    'Nqbb' => 'New Foundland',
    'Nqbc' => 'Prince Edward Island',
    'Nqbd' => 'Nova Scotia',
    'Nqbe' => 'New Brunswick',
    'Nqbf' => 'Québec',
    'Nqbg' => 'Ontario',
    'Nqbh' => 'Manitoba',
    'Nqbi' => 'Saskatchewan',
    'Nqbj' => 'Alberta',
    'Nqbk' => 'Nordvästterritorierna',
    'Nqbl' => 'Yukonterritoriet',
    'Nqbm' => 'British Columbia',
    'Nqbz' => 'Särskilda orter',
    'Nqc' => 'Mexiko, Centralamerika och Västindien',
    'Nqc(y)' => 'Allmänt: kartor och bilder',
    'Nqc.07' => 'Allmänt: reseskildringar',
    'Nqc.08' => 'Allmänt: resehandböcker',
    'Nqca' => 'Mexiko',
    'Nqca(y)' => 'Kartor och bilder',
    'Nqca.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nqca.01' => 'Naturgeografi',
    'Nqca.02' => 'Kulturgeografi: allmänt',
    'Nqca.04' => 'Ekonomisk geografi',
    'Nqca.05' => 'Historisk geografi',
    'Nqca.07' => 'Reseskildringar',
    'Nqca.08' => 'Resehandböcker',
    'Nqcaz' => 'Särskilda orter',
    'Nqcb' => 'Guatemala',
    'Nqcbz' => 'Särskilda orter',
    'Nqcc' => 'Belize och Honduras',
    'Nqcca' => 'Belize',
    'Nqccb' => 'Honduras',
    'Nqcd' => 'El Salvador',
    'Nqce' => 'Nicaragua',
    'Nqcf' => 'Costa Rica',
    'Nqcg' => 'Panama',
    'Nqcgz' => 'Särskilda orter',
    'Nqch' => 'Västindien',
    'Nqcha' => 'Stora Antillerna',
    'Nqcha.07' => 'Allmänt: reseskildringar',
    'Nqcha.08' => 'Allmänt: resehandböcker',
    'Nqchaa' => 'Kuba',
    'Nqchaa(y)' => 'Kartor och bilder',
    'Nqchaa.07' => 'Reseskildringar',
    'Nqchaa.08' => 'Resehandböcker',
    'Nqchaaz' => 'Särskilda orter',
    'Nqchab' => 'Haiti',
    'Nqchac' => 'Dominikanska republiken',
    'Nqchad' => 'Puerto Rico',
    'Nqchae' => 'Jamaica',
    'Nqchb' => 'Små Antillerna',
    'Nqchba' => 'Trinidad och Tobago',
    'Nqchbb' => 'Barbados',
    'Nqchbi' => 'Dominica',
    'Nqchbk' => 'St Lucia',
    'Nqchbm' => 'Grenada',
    'Nqchbö' => 'Övriga öar',
    'Nqchböz' => 'Särskilda öar',
    'Nqchc' => 'Bahamas',
    'Nqchd' => 'Bermuda',
    'Nqd(y)' => 'Allmänt: kartor och bilder',
    'Nqd.07' => 'Allmänt: reseskildringar',
    'Nqd.08' => 'Allmänt: resehandböcker',
    'Nqd' => 'Sydamerika',
    'Nqda' => 'Colombia',
    'Nqda(y)' => 'Kartor och bilder',
    'Nqda.07' => 'Reseskildringar',
    'Nqdaz' => 'Särskilda orter',
    'Nqdb' => 'Venezuela',
    'Nqdb.07' => 'Reseskildringar',
    'Nqdb.08' => 'Resehandböcker',
    'Nqdbz' => 'Särskilda orter',
    'Nqdc' => 'Guyanastaterna',
    'Nqdca' => 'Guyana',
    'Nqdcb' => 'Franska Guyana',
    'Nqdcc' => 'Surinam',
    'Nqdd' => 'Brasilien',
    'Nqdd(y)' => 'Kartor och bilder',
    'Nqdd.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nqdd.02' => 'Kulturgeografi: allmänt',
    'Nqdd.03' => 'Bebyggelsegeografi',
    'Nqdd.04' => 'Ekonomisk geografi',
    'Nqdd.05' => 'Historisk geografi',
    'Nqdd.07' => 'Reseskildringar',
    'Nqdd.08' => 'Resehandböcker',
    'Nqddz' => 'Särskilda orter',
    'Nqde' => 'Paraguay',
    'Nqdf' => 'Uruguay',
    'Nqdg' => 'Argentina',
    'Nqdg(y)' => 'Kartor och bilder',
    'Nqdg.07' => 'Reseskildringar',
    'Nqdg.08' => 'Resehandböcker',
    'Nqdgi' => 'Falklandsöarna',
    'Nqdgz' => 'Särskilda orter',
    'Nqdh' => 'Chile',
    'Nqdh(y)' => 'Kartor och bilder',
    'Nqdh.07' => 'Reseskildringar',
    'Nqdh.08' => 'Resehandböcker',
    'Nqdhz' => 'Särskilda orter',
    'Nqdi' => 'Bolivia',
    'Nqdiz' => 'Särskilda orter',
    'Nqdk' => 'Peru',
    'Nqdk(y)' => 'Kartor och bilder',
    'Nqdk.07' => 'Reseskildringar',
    'Nqdk.08' => 'Resehandböcker',
    'Nqdkz' => 'Särskilda orter',
    'Nqdl' => 'Ecuador',
    'Nqdl.07' => 'Reseskildringar',
    'Nqdl.08' => 'Resehandböcker',
    'Nqdli' => 'Galapagosöarna',
    'Nqdlz' => 'Särskilda orter',
    'Nqdz' => 'Särskilda orter, regioner m m (som sträcker sig över flera länder)',
    'Nr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Nr.07' => 'Allmänt: reseskildringar',
    'Nr.08' => 'Allmänt: resehandböcker',
    'Nra' => 'Australien',
    'Nra(y)' => 'Australien: kartor och bilder',
    'Nra(ya)' => 'Kartor',
    'Nra(yb)' => 'Bilder',
    'Nra.0' => 'Reseskildringar och -handböcker, särskilda geografiska aspekter',
    'Nra.01' => 'Naturgeografi',
    'Nra.02' => 'Kulturgeografi: allmänt',
    'Nra.03' => 'Bebyggelsegeografi',
    'Nra.04' => 'Ekonomisk geografi',
    'Nra.05' => 'Historisk geografi',
    'Nra.07' => 'Reseskildringar',
    'Nra.08' => 'Resehandböcker',
    'Nraa' => 'New South Wales',
    'Nrab' => 'Victoria',
    'Nrac' => 'Queensland',
    'Nrad' => 'Soth Australia',
    'Nrae' => 'Western Australia',
    'Nraf' => 'Northern Territory',
    'Nrag' => 'Australian Capital Territory',
    'Nrah' => 'Tasmanien',
    'Nraz' => 'Särskilda orter',
    'Nrb' => 'Nya Zeeland',
    'Nrb(y)' => 'Kartor och bilder',
    'Nrb(ya)' => 'Kartor',
    'Nrb(yb)' => 'Bilder',
    'Nrb.07' => 'Reseskildringar',
    'Nrb.08' => 'Resehandböcker',
    'Nrc' => 'Melanesien, Polynesien och Mikronesien',
    'Nrca' => 'Melanesien',
    'Nrcaz' => 'Särskilda orter',
    'Nrcb' => 'Polynesien',
    'Nrcba' => 'Fiji',
    'Nrcbb' => 'Tonga',
    'Nrcbd' => 'Västra Samoa',
    'Nrcc' => 'Mikronesien',
    'Nrcch' => 'Hawaii',
    'Nrcd' => 'Isolerade öar i Stilla havet (Påskön, Sala y Gomez ...)',
    'Nrd' => 'Nya Guinea',
    'Nrda' => 'Papua Nya Guinea',
    'Nrdb' => 'Väst-Irian',
    'Ns' => 'Polarländerna',
    'Ns(y)' => 'Allmänt: kartor och bilder',
    'Ns(ya)' => 'Kartor',
    'Ns(yb)' => 'Bilder',
    'Nsa' => 'Arktis (Nordpolsområdet)',
    'Nsa(y)' => 'Kartor och bilder',
    'Nsa(ya)' => 'Kartor',
    'Nsa(yb)' => 'Bilder',
    'Nsa.07' => 'Reseskildringar',
    'Nsa.08' => 'Resehandböcker',
    'Nsaa' => 'Grönland',
    'Nsaa(y)' => 'Kartor och bilder',
    'Nsaa.07' => 'Reseskildringar',
    'Nsaa.08' => 'Resehandböcker',
    'Nsaaz' => 'Särskilda orter',
    'Nsab' => 'Spetsbergen (Svalbard)',
    'Nsab(y)' => 'Kartor och bilder',
    'Nsab.07' => 'Reseskildringar',
    'Nsac' => 'Arktiska öar i Ryssland',
    'Nsad' => 'Arktiska områden i Kanada',
    'Nsb' => 'Antarktis',
    'Nsb(y)' => 'Kartor och bilder',
    'Nsb.07' => 'Reseskildringar',
    'Nt' => 'Oceaner och hav',
    'Nt(y)' => 'Allmänt: kartor och bilder',
    'Nta' => 'Atlanten',
    'Ntam' => 'Medelhavet',
    'Ntas' => 'Svarta havet',
    'Ntb' => 'Stilla havet',
    'Ntc' => 'Indiska Oceanen',
    'Ny' => 'Kartografi',
    'Ny:bf' => 'Kartografiska institutioner',
    'Ny:dd' => 'Kartografisk metodlära',
    'Ny:k' => 'Kartografins historia',
    'Ny:k.' => 'Särskilda perioder',
    'Ny:k.2' => 'Forntiden',
    'Ny:k.3' => 'Medeltiden',
    'Ny:k.4' => 'Nya tiden',
    'Ny:k.41' => '1500-1648',
    'Ny:k.43' => '1648-1789',
    'Ny:k.46' => '1815-1914',
    'Ny:kc' => 'Sverige',
    'O' => 'Samhälls- och rättsvetenskap',
    'O(x)' => 'Samhälls- och rättsvetenskapliga lexikon',
    'O:bf' => 'Samhälls- och rättsevetenskapliga institutioner',
    'O:d' => 'Samhälls- och rättsvetenskapens filosofi och metodlära',
    'O:dd' => 'Metodlära',
    'O:k' => 'Samhälls- och rättsvetenskapens historia',
    'O:ka' => 'Europa: allmänt',
    'O:kc' => 'Sverige',
    'O:ke' => 'Brittiska öarna (Storbritannien)',
    'O:kf' => 'Mellaneuropa',
    'O-' => 'Allmänt: särskilda länder och områden',
    'O-a' => 'Europa: allmänt',
    'O-b' => 'Norden: allmänt',
    'O-c' => 'Sverige',
    'O-cs' => 'Samer',
    'O-d' => 'Övriga Norden',
    'O-da' => 'Danmark',
    'O-db' => 'Norge',
    'O-dc' => 'Island och Färöarna',
    'O-dd' => 'Finland',
    'O-e' => 'Brittiska öarna (Storbritannien)',
    'O-ea' => 'England',
    'O-er' => 'Wales',
    'O-es' => 'Skottland',
    'O-et' => 'Irland',
    'O-f' => 'Mellaneuropa',
    'O-fa' => 'Tyskland',
    'O-fa(x)' => 'Lexikon',
    'O-fb' => 'Österrike och Liechtenstein',
    'O-fc' => 'Ungern',
    'O-fd' => 'Tjeckien och Slovakien',
    'O-g' => 'Nederländerna, Belgien och Luxemburg',
    'O-ga' => 'Nederländerna',
    'O-gb' => 'Belgien',
    'O-gc' => 'Luxemburg',
    'O-h' => 'Schweiz',
    'O-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'O-j' => 'Frankrike och Monaco',
    'O-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'O-l' => 'Portugal',
    'O-m' => 'Östeuropa',
    'O-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'O-mb' => 'Polen',
    'O-mc' => 'Estland, Lettland, Litauen',
    'O-mca' => 'Estland',
    'O-mcb' => 'Lettland',
    'O-mcc' => 'Litauen',
    'O-n' => 'Balkanländerna',
    'O-na' => 'Rumänien',
    'O-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'O-nc' => 'Bulgarien',
    'O-nd' => 'Grekland',
    'O-nf' => 'Albanien',
    'O-o' => 'Asien',
    'O-oa' => 'Främre Asien',
    'O-oaa' => 'Turkiet',
    'O-oab' => 'Cypern',
    'O-oac' => 'Kaukasien',
    'O-oae' => 'Syrien och Libanon',
    'O-oaf' => 'Palestina och Israel',
    'O-oafh' => 'Judar',
    'O-oafi' => 'Israel',
    'O-oag' => 'Jordanien',
    'O-oah' => 'Arabiska halvön',
    'O-oai' => 'Irak',
    'O-oak' => 'Iran (Persien)',
    'O-oal' => 'Afghanistan',
    'O-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'O-ob' => 'Främre Indien',
    'O-oba' => 'Indien',
    'O-obb' => 'Pakistan och Bangladesh',
    'O-obba' => 'Pakistan',
    'O-obbb' => 'Bangladesh',
    'O-obc' => 'Bhutan',
    'O-obd' => 'Nepal',
    'O-obe' => 'Sri Lanka (f d Ceylon)',
    'O-oc' => 'Bortre Indien',
    'O-oca' => 'Myanmar (f d Burma)',
    'O-ocb' => 'Thailand',
    'O-occ' => 'Malaysia, Singapore och Brunei',
    'O-occa' => 'Malaysia',
    'O-occb' => 'Singapore',
    'O-ocd' => 'Indokina',
    'O-ocda' => 'Laos',
    'O-ocdb' => 'Kambodja',
    'O-ocdc' => 'Vietnam',
    'O-od' => 'Ostindiska öarna',
    'O-oda' => 'Indonesien',
    'O-odc' => 'Filippinerna',
    'O-oe' => 'Östasien',
    'O-oea' => 'Kina',
    'O-oeaf' => 'Taiwan',
    'O-oeak' => 'Tibet',
    'O-oeb' => 'Korea',
    'O-oec' => 'Japan',
    'O-oek' => 'Hongkong och Macau',
    'O-of' => 'Centralasien',
    'O-p' => 'Afrika',
    'O-pa' => 'Nordafrika utom Egypten',
    'O-paa' => 'Marocko och Kanarieöarna',
    'O-pab' => 'Algeriet',
    'O-pac' => 'Tunisien',
    'O-pad' => 'Libyen',
    'O-pb' => 'Egypten och Sudan',
    'O-pba' => 'Egypten',
    'O-pbb' => 'Sudan',
    'O-pc' => 'Västafrika',
    'O-pcb' => 'Ekvatorialfrika',
    'O-pcba' => 'Tchad',
    'O-pcc' => 'Norra Västafrika',
    'O-pcd' => 'Södra Västafrika',
    'O-pd' => 'Centralafrika',
    'O-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'O-pdb' => 'Angola',
    'O-pe' => 'Södra Afrika',
    'O-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'O-peaa' => 'Sydafrikanska republiken',
    'O-peab' => 'Namibia',
    'O-peb' => 'Botswana',
    'O-pec' => 'Zimbabwe, Zambia, Malawi',
    'O-ped' => 'Mocambique',
    'O-pee' => 'Madagaskar (Malagasy)',
    'O-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'O-pf' => 'Östafrika',
    'O-pfa' => 'Uganda',
    'O-pfb' => 'Kenya',
    'O-pfc' => 'Tanzania',
    'O-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'O-pg' => 'Nordöstafrika',
    'O-pga' => 'Etiopien med Eritrea',
    'O-pgae' => 'Eritrea',
    'O-q' => 'Amerika',
    'O-qa' => 'Förenta staterna',
    'O-qb' => 'Kanada',
    'O-qc' => 'Mexiko, Centralamerika och Västindien',
    'O-qca' => 'Mexiko',
    'O-qcb' => 'Guatemala',
    'O-qcc' => 'Belize och Honduras',
    'O-qcd' => 'El Salvador',
    'O-qce' => 'Nicaragua',
    'O-qcf' => 'Costa Rica',
    'O-qcg' => 'Panama',
    'O-qch' => 'Västindien',
    'O-qcha' => 'Stora Antillerna',
    'O-qchaa' => 'Kuba',
    'O-qchab' => 'Haiti',
    'O-qchac' => 'Dominikanska republiken',
    'O-qchae' => 'Jamaica',
    'O-qchb' => 'Små Antillerna',
    'O-qd' => 'Sydamerika',
    'O-qda' => 'Colombia',
    'O-qdb' => 'Venezuela',
    'O-qdc' => 'Guyanastaterna',
    'O-qdd' => 'Brasilien',
    'O-qde' => 'Paraguay',
    'O-qdf' => 'Uruguay',
    'O-qdg' => 'Argentina',
    'O-qdh' => 'Chile',
    'O-qdi' => 'Bolivia',
    'O-qdk' => 'Peru',
    'O-qdl' => 'Ecuador',
    'O-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'O-ra' => 'Australien',
    'O-rb' => 'Nya Zeeland',
    'O-rc' => 'Melanesien, Polynesien och Mikronesien',
    'O-rd' => 'Nya Guinea',
    'O-s' => 'Polarländerna',
    'Oa' => 'Sociologi',
    'Oa(x)' => 'Sociologiska lexikon',
    'Oa:bf' => 'Sociologiska institutioner',
    'Oa:d' => 'Sociologisik teori, filosofi och metodlära',
    'Oa:dd' => 'Metodlära',
    'Oa:k' => 'Sociologins historia',
    'Oa:ka' => 'Europa: allmänt',
    'Oa:kc' => 'Sverige',
    'Oa:kd' => 'Övriga Norden',
    'Oa:ke' => 'Brittiska öarna (Storbritannien)',
    'Oa:kf' => 'Mellaneuropa',
    'Oa:kfa' => 'Tyskland',
    'Oa:kfb' => 'Österrike och Liechtenstein',
    'Oa:kj' => 'Frankrike och Monaco',
    'Oa:km' => 'Östeuropa',
    'Oa:kn' => 'Balkanländerna',
    'Oa:ko' => 'Asien',
    'Oa:kq' => 'Amerika',
    'Oa:kqa' => 'Förenta staterna',
    'Oa:kqd' => 'Sydamerika',
    'Oaa' => 'Socialpsykologi',
    'Oab' => 'Sociala strukturer',
    'Oab-' => 'Särskilda länder och områden',
    'Oab-a' => 'Europa: allmänt',
    'Oab-ae' => 'Europeiska unionen (EU)',
    'Oab-b' => 'Norden: allmänt',
    'Oab-c' => 'Sverige',
    'Oab-cs' => 'Samer',
    'Oab-d' => 'Övriga Norden',
    'Oab-da' => 'Danmark',
    'Oab-db' => 'Norge',
    'Oab-dc' => 'Island och Färöarna',
    'Oab-dd' => 'Finland',
    'Oab-e' => 'Brittiska öarna (Storbritannien)',
    'Oab-ea' => 'England',
    'Oab-es' => 'Skottland',
    'Oab-et' => 'Irland',
    'Oab-f' => 'Mellaneuropa',
    'Oab-fa' => 'Tyskland',
    'Oab-fb' => 'Österrike och Liechtenstein',
    'Oab-fc' => 'Ungern',
    'Oab-fd' => 'Tjeckien och Slovakien',
    'Oab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oab-ga' => 'Nederländerna',
    'Oab-gb' => 'Belgien',
    'Oab-h' => 'Schweiz',
    'Oab-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oab-j' => 'Frankrike och Monaco',
    'Oab-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oab-l' => 'Portugal',
    'Oab-m' => 'Östeuropa',
    'Oab-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oab-mb' => 'Polen',
    'Oab-mc' => 'Estland, Lettland, Litauen',
    'Oab-mca' => 'Estland',
    'Oab-mcb' => 'Lettland',
    'Oab-mcc' => 'Litauen',
    'Oab-n' => 'Balkanländerna',
    'Oab-na' => 'Rumänien',
    'Oab-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oab-nc' => 'Bulgarien',
    'Oab-nd' => 'Grekland',
    'Oab-o' => 'Asien',
    'Oab-oa' => 'Främre Asien',
    'Oab-oaa' => 'Turkiet',
    'Oab-oae' => 'Syrien och Libanon',
    'Oab-oaf' => 'Palestina och Israel',
    'Oab-oafh' => 'Judar',
    'Oab-oafi' => 'Israel',
    'Oab-oah' => 'Arabiska halvön',
    'Oab-oai' => 'Irak',
    'Oab-oak' => 'Iran (Persien)',
    'Oab-oal' => 'Afghanistan',
    'Oab-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oab-ob' => 'Främre Indien',
    'Oab-oba' => 'Indien',
    'Oab-obb' => 'Pakistan och Bangladesh',
    'Oab-obba' => 'Pakistan',
    'Oab-obbb' => 'Bangladesh',
    'Oab-oc' => 'Bortre Indien',
    'Oab-ocb' => 'Thailand',
    'Oab-occ' => 'Malaysia, Singapore och Brunei',
    'Oab-ocd' => 'Indokina',
    'Oab-od' => 'Ostindiska öarna',
    'Oab-oda' => 'Indonesien',
    'Oab-odc' => 'Filippinerna',
    'Oab-oe' => 'Östasien',
    'Oab-oea' => 'Kina',
    'Oab-oeak' => 'Tibet',
    'Oab-oeb' => 'Korea',
    'Oab-oec' => 'Japan',
    'Oab-oek' => 'Hongkong och Macau',
    'Oab-p' => 'Afrika',
    'Oab-pa' => 'Nordafrika utom Egypten',
    'Oab-paa' => 'Marocko och Kanarieöarna',
    'Oab-pab' => 'Algeriet',
    'Oab-pac' => 'Tunisien',
    'Oab-pb' => 'Egypten och Sudan',
    'Oab-pba' => 'Egypten',
    'Oab-pbb' => 'Sudan',
    'Oab-pc' => 'Västafrika',
    'Oab-pcb' => 'Ekvatorialfrika',
    'Oab-pcc' => 'Norra Västafrika',
    'Oab-pcd' => 'Södra Västafrika',
    'Oab-pcda' => 'Ghana',
    'Oab-pcdd' => 'Nigeria',
    'Oab-pd' => 'Centralafrika',
    'Oab-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Oab-pdb' => 'Angola',
    'Oab-pe' => 'Södra Afrika',
    'Oab-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oab-peb' => 'Botswana',
    'Oab-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oab-peca' => 'Zimbabwe',
    'Oab-pecb' => 'Zambia',
    'Oab-pee' => 'Madagaskar (Malagasy)',
    'Oab-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Oab-pf' => 'Östafrika',
    'Oab-pfa' => 'Uganda',
    'Oab-pfb' => 'Kenya',
    'Oab-pfc' => 'Tanzania',
    'Oab-pg' => 'Nordöstafrika',
    'Oab-q' => 'Amerika',
    'Oab-qa' => 'Förenta staterna',
    'Oab-qb' => 'Kanada',
    'Oab-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oab-qca' => 'Mexiko',
    'Oab-qce' => 'Nicaragua',
    'Oab-qch' => 'Västindien',
    'Oab-qcha' => 'Stora Antillerna',
    'Oab-qchaa' => 'Kuba',
    'Oab-qchae' => 'Jamaica',
    'Oab-qchb' => 'Små Antillerna',
    'Oab-qd' => 'Sydamerika',
    'Oab-qda' => 'Colombia',
    'Oab-qdc' => 'Guyanastaterna',
    'Oab-qdd' => 'Brasilien',
    'Oab-qdf' => 'Uruguay',
    'Oab-qdg' => 'Argentina',
    'Oab-qdh' => 'Chile',
    'Oab-qdi' => 'Bolivia',
    'Oab-qdk' => 'Peru',
    'Oab-qdl' => 'Ecuador',
    'Oab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oab-ra' => 'Australien',
    'Oab-rb' => 'Nya Zeeland',
    'Oab-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oab-rd' => 'Nya Guinea',
    'Oab-s' => 'Polarländerna',
    'Oaba' => 'Arbetslivs- och organisationssociologi',
    'Oaba-' => 'Särskilda länder och områden',
    'Oaba-a' => 'Europa: allmänt',
    'Oaba-ae' => 'Europeiska unionen (EU)',
    'Oaba-b' => 'Norden: allmänt',
    'Oaba-c' => 'Sverige',
    'Oaba-d' => 'Övriga Norden',
    'Oaba-da' => 'Danmark',
    'Oaba-db' => 'Norge',
    'Oaba-dd' => 'Finland',
    'Oaba-e' => 'Brittiska öarna (Storbritannien)',
    'Oaba-f' => 'Mellaneuropa',
    'Oaba-fa' => 'Tyskland',
    'Oaba-fb' => 'Österrike och Liechtenstein',
    'Oaba-fd' => 'Tjeckien och Slovakien',
    'Oaba-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oaba-h' => 'Schweiz',
    'Oaba-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oaba-j' => 'Frankrike och Monaco',
    'Oaba-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oaba-m' => 'Östeuropa',
    'Oaba-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oaba-mb' => 'Polen',
    'Oaba-mc' => 'Estland, Lettland, Litauen',
    'Oaba-n' => 'Balkanländerna',
    'Oaba-o' => 'Asien',
    'Oaba-oa' => 'Främre Asien',
    'Oaba-ob' => 'Främre Indien',
    'Oaba-oc' => 'Bortre Indien',
    'Oaba-od' => 'Ostindiska öarna',
    'Oaba-oe' => 'Östasien',
    'Oaba-oea' => 'Kina',
    'Oaba-oec' => 'Japan',
    'Oaba-p' => 'Afrika',
    'Oaba-q' => 'Amerika',
    'Oaba-qa' => 'Förenta staterna',
    'Oaba-qb' => 'Kanada',
    'Oaba-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oaba-qd' => 'Sydamerika',
    'Oaba-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabb' => 'Bebyggelsesociologi',
    'Oabb-' => 'Särskilda länder och områden',
    'Oabb-a' => 'Europa: allmänt',
    'Oabb-ae' => 'Europeiska unionen (EU)',
    'Oabb-b' => 'Norden: allmänt',
    'Oabb-c' => 'Sverige',
    'Oabb-d' => 'Övriga Norden',
    'Oabb-da' => 'Danmark',
    'Oabb-db' => 'Norge',
    'Oabb-dd' => 'Finland',
    'Oabb-e' => 'Brittiska öarna (Storbritannien)',
    'Oabb-f' => 'Mellaneuropa',
    'Oabb-fa' => 'Tyskland',
    'Oabb-fb' => 'Österrike och Liechtenstein',
    'Oabb-fc' => 'Ungern',
    'Oabb-fd' => 'Tjeckien och Slovakien',
    'Oabb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oabb-h' => 'Schweiz',
    'Oabb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oabb-j' => 'Frankrike och Monaco',
    'Oabb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oabb-l' => 'Portugal',
    'Oabb-m' => 'Östeuropa',
    'Oabb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oabb-mb' => 'Polen',
    'Oabb-mc' => 'Estland, Lettland, Litauen',
    'Oabb-n' => 'Balkanländerna',
    'Oabb-o' => 'Asien',
    'Oabb-oa' => 'Främre Asien',
    'Oabb-oaa' => 'Turkiet',
    'Oabb-oab' => 'Cypern',
    'Oabb-oae' => 'Syrien och Libanon',
    'Oabb-oaf' => 'Palestina och Israel',
    'Oabb-ob' => 'Främre Indien',
    'Oabb-oba' => 'Indien',
    'Oabb-obb' => 'Pakistan och Bangladesh',
    'Oabb-oc' => 'Bortre Indien',
    'Oabb-ocb' => 'Thailand',
    'Oabb-occ' => 'Malaysia, Singapore och Brunei',
    'Oabb-ocd' => 'Indokina',
    'Oabb-od' => 'Ostindiska öarna',
    'Oabb-oe' => 'Östasien',
    'Oabb-oea' => 'Kina',
    'Oabb-oeb' => 'Korea',
    'Oabb-oec' => 'Japan',
    'Oabb-oek' => 'Hongkong och Macau',
    'Oabb-p' => 'Afrika',
    'Oabb-pa' => 'Nordafrika utom Egypten',
    'Oabb-paa' => 'Marocko och Kanarieöarna',
    'Oabb-pab' => 'Algeriet',
    'Oabb-pac' => 'Tunisien',
    'Oabb-pb' => 'Egypten och Sudan',
    'Oabb-pc' => 'Västafrika',
    'Oabb-pcb' => 'Ekvatorialfrika',
    'Oabb-pcc' => 'Norra Västafrika',
    'Oabb-pcd' => 'Södra Västafrika',
    'Oabb-pcda' => 'Ghana',
    'Oabb-pcdd' => 'Nigeria',
    'Oabb-pd' => 'Centralafrika',
    'Oabb-pe' => 'Södra Afrika',
    'Oabb-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oabb-peb' => 'Botswana',
    'Oabb-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oabb-pf' => 'Östafrika',
    'Oabb-pfa' => 'Uganda',
    'Oabb-pfb' => 'Kenya',
    'Oabb-pfc' => 'Tanzania',
    'Oabb-pg' => 'Nordöstafrika',
    'Oabb-q' => 'Amerika',
    'Oabb-qa' => 'Förenta staterna',
    'Oabb-qb' => 'Kanada',
    'Oabb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabb-qca' => 'Mexiko',
    'Oabb-qch' => 'Västindien',
    'Oabb-qd' => 'Sydamerika',
    'Oabb-qda' => 'Colombia',
    'Oabb-qdb' => 'Venezuela',
    'Oabb-qdd' => 'Brasilien',
    'Oabb-qdh' => 'Chile',
    'Oabb-qdk' => 'Peru',
    'Oabb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabb-ra' => 'Australien',
    'Oabb-rb' => 'Nya Zeeland',
    'Oabb-rd' => 'Nya Guinea',
    'Oabba' => 'Stadssociologi',
    'Oabba-' => 'Särskilda länder och områden',
    'Oabba-a' => 'Europa: allmänt',
    'Oabba-ae' => 'Europeiska unionen (EU)',
    'Oabba-b' => 'Norden: allmänt',
    'Oabba-c' => 'Sverige',
    'Oabba-d' => 'Övriga Norden',
    'Oabba-da' => 'Danmark',
    'Oabba-db' => 'Norge',
    'Oabba-dd' => 'Finland',
    'Oabba-e' => 'Brittiska öarna (Storbritannien)',
    'Oabba-f' => 'Mellaneuropa',
    'Oabba-fa' => 'Tyskland',
    'Oabba-fb' => 'Österrike och Liechtenstein',
    'Oabba-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oabba-h' => 'Schweiz',
    'Oabba-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oabba-j' => 'Frankrike och Monaco',
    'Oabba-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oabba-l' => 'Portugal',
    'Oabba-m' => 'Östeuropa',
    'Oabba-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oabba-mb' => 'Polen',
    'Oabba-mc' => 'Estland, Lettland, Litauen',
    'Oabba-n' => 'Balkanländerna',
    'Oabba-o' => 'Asien',
    'Oabba-oa' => 'Främre Asien',
    'Oabba-ob' => 'Främre Indien',
    'Oabba-oc' => 'Bortre Indien',
    'Oabba-od' => 'Ostindiska öarna',
    'Oabba-oe' => 'Östasien',
    'Oabba-oea' => 'Kina',
    'Oabba-oec' => 'Japan',
    'Oabba-oek' => 'Hongkong och Macau',
    'Oabba-p' => 'Afrika',
    'Oabba-pa' => 'Nordafrika utom Egypten',
    'Oabba-pb' => 'Egypten och Sudan',
    'Oabba-pc' => 'Västafrika',
    'Oabba-pcb' => 'Ekvatorialfrika',
    'Oabba-pcc' => 'Norra Västafrika',
    'Oabba-pcd' => 'Södra Västafrika',
    'Oabba-pe' => 'Södra Afrika',
    'Oabba-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oabba-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oabba-pf' => 'Östafrika',
    'Oabba-pg' => 'Nordöstafrika',
    'Oabba-q' => 'Amerika',
    'Oabba-qa' => 'Förenta staterna',
    'Oabba-qb' => 'Kanada',
    'Oabba-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabba-qca' => 'Mexiko',
    'Oabba-qcb' => 'Guatemala',
    'Oabba-qch' => 'Västindien',
    'Oabba-qd' => 'Sydamerika',
    'Oabba-qda' => 'Colombia',
    'Oabba-qdb' => 'Venezuela',
    'Oabba-qdd' => 'Brasilien',
    'Oabba-qde' => 'Paraguay',
    'Oabba-qdg' => 'Argentina',
    'Oabba-qdh' => 'Chile',
    'Oabba-qdi' => 'Bolivia',
    'Oabba-qdk' => 'Peru',
    'Oabba-qdl' => 'Ecuador',
    'Oabba-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabbc' => 'Landsbygdssociologi',
    'Oabbc-' => 'Särskilda länder och områden',
    'Oabbc-a' => 'Europa: allmänt',
    'Oabbc-b' => 'Norden: allmänt',
    'Oabbc-c' => 'Sverige',
    'Oabbc-d' => 'Övriga Norden',
    'Oabbc-da' => 'Danmark',
    'Oabbc-db' => 'Norge',
    'Oabbc-dd' => 'Finland',
    'Oabbc-e' => 'Brittiska öarna (Storbritannien)',
    'Oabbc-f' => 'Mellaneuropa',
    'Oabbc-fa' => 'Tyskland',
    'Oabbc-fc' => 'Ungern',
    'Oabbc-fd' => 'Tjeckien och Slovakien',
    'Oabbc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oabbc-h' => 'Schweiz',
    'Oabbc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oabbc-j' => 'Frankrike och Monaco',
    'Oabbc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oabbc-m' => 'Östeuropa',
    'Oabbc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oabbc-mb' => 'Polen',
    'Oabbc-n' => 'Balkanländerna',
    'Oabbc-o' => 'Asien',
    'Oabbc-oa' => 'Främre Asien',
    'Oabbc-ob' => 'Främre Indien',
    'Oabbc-oba' => 'Indien',
    'Oabbc-obb' => 'Pakistan och Bangladesh',
    'Oabbc-obd' => 'Nepal',
    'Oabbc-oc' => 'Bortre Indien',
    'Oabbc-od' => 'Ostindiska öarna',
    'Oabbc-oe' => 'Östasien',
    'Oabbc-oea' => 'Kina',
    'Oabbc-oec' => 'Japan',
    'Oabbc-p' => 'Afrika',
    'Oabbc-pa' => 'Nordafrika utom Egypten',
    'Oabbc-pb' => 'Egypten och Sudan',
    'Oabbc-pc' => 'Västafrika',
    'Oabbc-pd' => 'Centralafrika',
    'Oabbc-pe' => 'Södra Afrika',
    'Oabbc-pf' => 'Östafrika',
    'Oabbc-pg' => 'Nordöstafrika',
    'Oabbc-q' => 'Amerika',
    'Oabbc-qa' => 'Förenta staterna',
    'Oabbc-qb' => 'Kanada',
    'Oabbc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabbc-qca' => 'Mexiko',
    'Oabbc-qcb' => 'Guatemala',
    'Oabbc-qce' => 'Nicaragua',
    'Oabbc-qcf' => 'Costa Rica',
    'Oabbc-qch' => 'Västindien',
    'Oabbc-qd' => 'Sydamerika',
    'Oabbc-qda' => 'Colombia',
    'Oabbc-qdb' => 'Venezuela',
    'Oabbc-qdd' => 'Brasilien',
    'Oabbc-qde' => 'Paraguay',
    'Oabbc-qdf' => 'Uruguay',
    'Oabbc-qdg' => 'Argentina',
    'Oabbc-qdh' => 'Chile',
    'Oabbc-qdi' => 'Bolivia',
    'Oabbc-qdk' => 'Peru',
    'Oabbc-qdl' => 'Ecuador',
    'Oabbc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabk' => 'Social differentiering',
    'Oabk-' => 'Särskilda länder och områden',
    'Oabk-a' => 'Europa: allmänt',
    'Oabk-b' => 'Norden: allmänt',
    'Oabk-c' => 'Sverige',
    'Oabk-d' => 'Övriga Norden',
    'Oabk-e' => 'Brittiska öarna (Storbritannien)',
    'Oabk-f' => 'Mellaneuropa',
    'Oabk-j' => 'Frankrike och Monaco',
    'Oabk-m' => 'Östeuropa',
    'Oabk-o' => 'Asien',
    'Oabk-p' => 'Afrika',
    'Oabk-q' => 'Amerika',
    'Oabk-qa' => 'Förenta staterna',
    'Oabk-qb' => 'Kanada',
    'Oabk-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabk-qd' => 'Sydamerika',
    'Oabka' => 'Sociala klasser',
    'Oabka-' => 'Särskilda länder och områden',
    'Oabka-a' => 'Europa: allmänt',
    'Oabka-b' => 'Norden: allmänt',
    'Oabka-c' => 'Sverige',
    'Oabka-d' => 'Övriga Norden',
    'Oabka-da' => 'Danmark',
    'Oabka-db' => 'Norge',
    'Oabka-dc' => 'Island och Färöarna',
    'Oabka-dd' => 'Finland',
    'Oabka-e' => 'Brittiska öarna (Storbritannien)',
    'Oabka-et' => 'Irland',
    'Oabka-f' => 'Mellaneuropa',
    'Oabka-fa' => 'Tyskland',
    'Oabka-fb' => 'Österrike och Liechtenstein',
    'Oabka-fc' => 'Ungern',
    'Oabka-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oabka-h' => 'Schweiz',
    'Oabka-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oabka-j' => 'Frankrike och Monaco',
    'Oabka-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oabka-m' => 'Östeuropa',
    'Oabka-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oabka-mb' => 'Polen',
    'Oabka-mc' => 'Estland, Lettland, Litauen',
    'Oabka-n' => 'Balkanländerna',
    'Oabka-o' => 'Asien',
    'Oabka-oa' => 'Främre Asien',
    'Oabka-ob' => 'Främre Indien',
    'Oabka-oba' => 'Indien',
    'Oabka-obb' => 'Pakistan och Bangladesh',
    'Oabka-obe' => 'Sri Lanka (f d Ceylon)',
    'Oabka-oc' => 'Bortre Indien',
    'Oabka-od' => 'Ostindiska öarna',
    'Oabka-oe' => 'Östasien',
    'Oabka-oea' => 'Kina',
    'Oabka-oeb' => 'Korea',
    'Oabka-oec' => 'Japan',
    'Oabka-oek' => 'Hongkong och Macau',
    'Oabka-p' => 'Afrika',
    'Oabka-pa' => 'Nordafrika utom Egypten',
    'Oabka-pb' => 'Egypten och Sudan',
    'Oabka-pc' => 'Västafrika',
    'Oabka-pd' => 'Centralafrika',
    'Oabka-pe' => 'Södra Afrika',
    'Oabka-pf' => 'Östafrika',
    'Oabka-pg' => 'Nordöstafrika',
    'Oabka-q' => 'Amerika',
    'Oabka-qa' => 'Förenta staterna',
    'Oabka-qb' => 'Kanada',
    'Oabka-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabka-qca' => 'Mexiko',
    'Oabka-qcb' => 'Guatemala',
    'Oabka-qcc' => 'Belize och Honduras',
    'Oabka-qcd' => 'El Salvador',
    'Oabka-qce' => 'Nicaragua',
    'Oabka-qcf' => 'Costa Rica',
    'Oabka-qcg' => 'Panama',
    'Oabka-qch' => 'Västindien',
    'Oabka-qd' => 'Sydamerika',
    'Oabka-qda' => 'Colombia',
    'Oabka-qdb' => 'Venezuela',
    'Oabka-qdd' => 'Brasilien',
    'Oabka-qdf' => 'Uruguay',
    'Oabka-qdg' => 'Argentina',
    'Oabka-qdh' => 'Chile',
    'Oabka-qdi' => 'Bolivia',
    'Oabka-qdk' => 'Peru',
    'Oabka-qdl' => 'Ecuador',
    'Oabka-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabkb' => 'Åldersgrupper',
    'Oabkb-' => 'Särskilda länder och områden',
    'Oabkb-c' => 'Sverige',
    'Oabkb-d' => 'Övriga Norden',
    'Oabkb-e' => 'Brittiska öarna (Storbritannien)',
    'Oabkb-f' => 'Mellaneuropa',
    'Oabkb-q' => 'Amerika',
    'Oabkba' => 'Barn och ungdom',
    'Oabkba-' => 'Särskilda länder och områden',
    'Oabkba-a' => 'Europa: allmänt',
    'Oabkba-ae' => 'Europeiska unionen (EU)',
    'Oabkba-b' => 'Norden: allmänt',
    'Oabkba-c' => 'Sverige',
    'Oabkba-cs' => 'Samer',
    'Oabkba-cz' => 'Särskilda orter',
    'Oabkba-d' => 'Övriga Norden',
    'Oabkba-da' => 'Danmark',
    'Oabkba-db' => 'Norge',
    'Oabkba-dc' => 'Island och Färöarna',
    'Oabkba-dd' => 'Finland',
    'Oabkba-e' => 'Brittiska öarna (Storbritannien)',
    'Oabkba-f' => 'Mellaneuropa',
    'Oabkba-fa' => 'Tyskland',
    'Oabkba-fb' => 'Österrike och Liechtenstein',
    'Oabkba-fd' => 'Tjeckien och Slovakien',
    'Oabkba-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oabkba-h' => 'Schweiz',
    'Oabkba-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oabkba-j' => 'Frankrike och Monaco',
    'Oabkba-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oabkba-m' => 'Östeuropa',
    'Oabkba-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oabkba-mb' => 'Polen',
    'Oabkba-mc' => 'Estland, Lettland, Litauen',
    'Oabkba-n' => 'Balkanländerna',
    'Oabkba-o' => 'Asien',
    'Oabkba-oa' => 'Främre Asien',
    'Oabkba-oaa' => 'Turkiet',
    'Oabkba-oaf' => 'Palestina och Israel',
    'Oabkba-ob' => 'Främre Indien',
    'Oabkba-oc' => 'Bortre Indien',
    'Oabkba-od' => 'Ostindiska öarna',
    'Oabkba-oe' => 'Östasien',
    'Oabkba-oea' => 'Kina',
    'Oabkba-oec' => 'Japan',
    'Oabkba-p' => 'Afrika',
    'Oabkba-pc' => 'Västafrika',
    'Oabkba-pd' => 'Centralafrika',
    'Oabkba-pe' => 'Södra Afrika',
    'Oabkba-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oabkba-peb' => 'Botswana',
    'Oabkba-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oabkba-ped' => 'Mocambique',
    'Oabkba-pf' => 'Östafrika',
    'Oabkba-pg' => 'Nordöstafrika',
    'Oabkba-q' => 'Amerika',
    'Oabkba-qa' => 'Förenta staterna',
    'Oabkba-qb' => 'Kanada',
    'Oabkba-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oabkba-qd' => 'Sydamerika',
    'Oabkba-qda' => 'Colombia',
    'Oabkba-qdb' => 'Venezuela',
    'Oabkba-qdd' => 'Brasilien',
    'Oabkba-qdg' => 'Argentina',
    'Oabkba-qdh' => 'Chile',
    'Oabkba-qdi' => 'Bolivia',
    'Oabkba-qdk' => 'Peru',
    'Oabkba-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oabkbb' => 'Vuxna',
    'Oabkbb-c' => 'Sverige',
    'Oabkbc' => 'Äldre',
    'Oabkbc-' => 'Särskilda länder och områden',
    'Oabkbc-a' => 'Europeiska unionen (EU)',
    'Oabkbc-b' => 'Norden: allmänt',
    'Oabkbc-c' => 'Sverige',
    'Oabkbc-d' => 'Övriga Norden',
    'Oabkbc-da' => 'Danmark',
    'Oabkbc-db' => 'Norge',
    'Oabkbc-dd' => 'Finland',
    'Oabkbc-e' => 'Brittiska öarna (Storbritannien)',
    'Oabkbc-f' => 'Mellaneuropa',
    'Oabkbc-h' => 'Schweiz',
    'Oabkbc-m' => 'Östeuropa',
    'Oabkbc-o' => 'Asien',
    'Oabkbc-p' => 'Afrika',
    'Oabkbc-q' => 'Amerika',
    'Oabkbc-qa' => 'Förenta staterna',
    'Oabkbc-qb' => 'Kanada',
    'Oabkbc-qd' => 'Sydamerika',
    'Oabkbc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oac' => 'Familjesociologi',
    'Oac:k' => 'Familjesociologins historia',
    'Oac-' => 'Allmänt: särskilda länder och områden',
    'Oac-a' => 'Europa: allmänt',
    'Oac-ae' => 'Europeiska unionen (EU)',
    'Oac-b' => 'Norden: allmänt',
    'Oac-c' => 'Sverige',
    'Oac-d' => 'Övriga Norden',
    'Oac-da' => 'Danmark',
    'Oac-db' => 'Norge',
    'Oac-dc' => 'Island och Färöarna',
    'Oac-dd' => 'Finland',
    'Oac-e' => 'Brittiska öarna (Storbritannien)',
    'Oac-f' => 'Mellaneuropa',
    'Oac-fa' => 'Tyskland',
    'Oac-fb' => 'Österrike och Liechtenstein',
    'Oac-fc' => 'Ungern',
    'Oac-fd' => 'Tjeckien och Slovakien',
    'Oac-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oac-ga' => 'Nederländerna',
    'Oac-gb' => 'Belgien',
    'Oac-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oac-j' => 'Frankrike och Monaco',
    'Oac-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oac-l' => 'Portugal',
    'Oac-m' => 'Östeuropa',
    'Oac-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oac-mb' => 'Polen',
    'Oac-mc' => 'Estland, Lettland, Litauen',
    'Oac-n' => 'Balkanländerna',
    'Oac-o' => 'Asien',
    'Oac-oa' => 'Främre Asien',
    'Oac-oaa' => 'Turkiet',
    'Oac-oab' => 'Cypern',
    'Oac-oae' => 'Syrien och Libanon',
    'Oac-oaf' => 'Palestina och Israel',
    'Oac-oak' => 'Iran (Persien)',
    'Oac-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oac-ob' => 'Främre Indien',
    'Oac-oba' => 'Indien',
    'Oac-oc' => 'Bortre Indien',
    'Oac-od' => 'Ostindiska öarna',
    'Oac-oe' => 'Östasien',
    'Oac-oea' => 'Kina',
    'Oac-oeb' => 'Korea',
    'Oac-oec' => 'Japan',
    'Oac-oek' => 'Hongkong och Macau',
    'Oac-p' => 'Afrika',
    'Oac-pa' => 'Nordafrika utom Egypten',
    'Oac-pb' => 'Egypten och Sudan',
    'Oac-pc' => 'Västafrika',
    'Oac-pd' => 'Centralafrika',
    'Oac-pe' => 'Södra Afrika',
    'Oac-pf' => 'Östafrika',
    'Oac-pg' => 'Nordöstafrika',
    'Oac-q' => 'Amerika',
    'Oac-qa' => 'Förenta staterna',
    'Oac-qb' => 'Kanada',
    'Oac-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oac-qd' => 'Sydamerika',
    'Oac-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oac-ra' => 'Australien',
    'Oac-rb' => 'Nya Zeeland',
    'Oac-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oac-s' => 'Polarländerna',
    'Ob' => 'Internationella relationer',
    'Ob(x)' => 'Allmänt: lexikon',
    'Ob:bf' => 'Allmänt: institutioner',
    'Ob:k' => 'Allmänt: historia',
    'Ob.09' => 'Allmänt: politiska skrifter',
    'Oba' => 'Folkrätt',
    'Oba(x)' => 'Folkrättsliga lexikon',
    'Oba:bf' => 'Internationella folkrättsliga institutioner',
    'Oba:k' => 'Folkrättshistoria',
    'Obah' => 'Havsrätt',
    'Obah:bf' => 'Institutioner',
    'Obaj' => 'Rymdrätt',
    'Obak' => 'Diplomati',
    'Obak:k' => 'Diplomatins historia',
    'Obal' => 'Asylrätt',
    'Obam' => 'Folkrätt i krig',
    'Obam:k' => 'Historia',
    'Obb' => 'Freds- och nedrustningsfrågor',
    'Obb(x)' => 'Allmänt: lexikon',
    'Obb:bf' => 'Allmänt: institutioner',
    'Obb:k' => 'Allmänt: historia',
    'Obba' => 'Freds- och konfliktforskning',
    'Obba:bf' => 'Institutioner',
    'Obba:k' => 'Freds- och konfliktforskningens historia',
    'Obbb' => 'Nedrustning och rustningskontroll',
    'Obbb:bf' => 'Institutioner',
    'Obbb:k' => 'Nedrustningens och rustningskontrollens historia',
    'Obd' => 'Internationellt samarbete: allmänt',
    'Obd:bf' => 'Internationella samarbetsinstitutioner',
    'Obd:k' => 'Det internationella samarbetes histora',
    'Obd:oe' => 'Lagstiftning',
    'Obe' => 'Nationernas förbund (NF)',
    'Obe:k' => 'NF:s historia',
    'Obf' => 'Förenta nationerna (FN)',
    'Obf(x)' => 'Allmänt: lexikon',
    'Obf:k' => 'FN:s historia',
    'Obfa' => 'Säkerhetsrådet (Security Council)',
    'Obfaa' => 'FN:s fredsbevarande styrkor',
    'Obfb' => 'Ekonomiska och sociala rådet (Economic and Social Council)',
    'Obfc' => 'Förvaltarskapsrådet (Trusteeship Council)',
    'Obfe' => 'Generalförsamlingen (General Assembly)',
    'Obfi' => 'Sekretariatet (Secretariat)',
    'Obfk' => 'FN:s fackorgan',
    'Obfk:bf' => 'Särskilda fackorgan',
    'Obk' => 'Regionalt mellanfolkligt samarbete',
    'Obk:bf' => 'Organisationer och institutioner',
    'Obk-' => 'Särskilda länder och områden',
    'Obk-a' => 'Europa: allmänt',
    'Obk-a:bf' => 'Regionala mellanstatliga organisationer',
    'Obk-a:k' => 'Historia',
    'Obk-ae' => 'Europeiska unionen (EU)',
    'Obk-ae:bf' => 'Regionala mellanstatliga organisationer',
    'Obk-ae:k' => 'Historia',
    'Obk-b' => 'Norden: allmänt',
    'Obk-c' => 'Sverige',
    'Obk-d' => 'Övriga Norden',
    'Obk-e' => 'Brittiska öarna (Storbritannien)',
    'Obk-f' => 'Mellaneuropa',
    'Obk-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Obk-m' => 'Östeuropa',
    'Obk-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Obk-mb' => 'Polen',
    'Obk-mc' => 'Estland, Lettland, Litauen',
    'Obk-n' => 'Balkanländerna',
    'Obk-o' => 'Asien',
    'Obk-oa' => 'Främre Asien',
    'Obk-ob' => 'Främre Indien',
    'Obk-oc' => 'Bortre Indien',
    'Obk-od' => 'Ostindiska öarna',
    'Obk-oe' => 'Östasien',
    'Obk-p' => 'Afrika',
    'Obk-p:bf' => 'Regionala mellanstatliga organisationer',
    'Obk-pa' => 'Nordafrika utom Egypten',
    'Obk-pb' => 'Egypten och Sudan',
    'Obk-pc' => 'Västafrika',
    'Obk-pe' => 'Södra Afrika',
    'Obk-pf' => 'Östafrika',
    'Obk-q' => 'Amerika',
    'Obk-qa' => 'Förenta staterna',
    'Obk-qc' => 'Mexiko, Centralamerika och Västindien',
    'Obk-qd' => 'Sydamerika',
    'Obk-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Obk-s' => 'Polarländerna',
    'Obl' => 'Försvarspakter',
    'Obl:bf' => 'Särskilda försvarspakter',
    'Obn' => 'Nordiskt samarbete',
    'Obn:bf' => 'Organisationer och institutioner',
    'Obn:k' => 'Det nordiska samarbetets historia',
    'Obq' => 'Utvecklingsbistånd och internationell hjälpverksamhet',
    'Obq:bf' => 'Bistånds- och hjälporganisationer',
    'Obq-' => 'Särskilda länder och områden',
    'Obq-a' => 'Europa: allmänt',
    'Obq-ae' => 'Europeiska unionen (EU)',
    'Obq-b' => 'Norden: allmänt',
    'Obq-c' => 'Sverige',
    'Obq-c:bf' => 'Bistånds- och hjälporganisationer',
    'Obq-c:k' => 'Historia',
    'Obq-d' => 'Övriga Norden',
    'Obq-da' => 'Danmark',
    'Obq-db' => 'Norge',
    'Obq-dd' => 'Finland',
    'Obq-e' => 'Brittiska öarna (Storbritannien)',
    'Obq-f' => 'Mellaneuropa',
    'Obq-fa' => 'Tyskland',
    'Obq-fb' => 'Österrike och Liechtenstein',
    'Obq-g' => 'Nederländerna, Belgien och Luxemburg',
    'Obq-h' => 'Schweiz',
    'Obq-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Obq-j' => 'Frankrike och Monaco',
    'Obq-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Obq-m' => 'Östeuropa',
    'Obq-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Obq-mb' => 'Polen',
    'Obq-mc' => 'Estland, Lettland, Litauen',
    'Obq-mca' => 'Estland',
    'Obq-mcb' => 'Lettland',
    'Obq-mcc' => 'Litauen',
    'Obq-n' => 'Balkanländerna',
    'Obq-o' => 'Asien',
    'Obq-oa' => 'Främre Asien',
    'Obq-oaa' => 'Turkiet',
    'Obq-oac' => 'Kaukasien',
    'Obq-oaf' => 'Palestina och Israel',
    'Obq-oafh' => 'Judar',
    'Obq-oafi' => 'Israel',
    'Obq-oah' => 'Arabiska halvön',
    'Obq-oai' => 'Irak',
    'Obq-oal' => 'Afghanistan',
    'Obq-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Obq-ob' => 'Främre Indien',
    'Obq-oba' => 'Indien',
    'Obq-obb' => 'Pakistan och Bangladesh',
    'Obq-obba' => 'Pakistan',
    'Obq-obbb' => 'Bangladesh',
    'Obq-obc' => 'Bhutan',
    'Obq-obd' => 'Nepal',
    'Obq-obe' => 'Sri Lanka (f d Ceylon)',
    'Obq-obf' => 'Maldiverna',
    'Obq-oc' => 'Bortre Indien',
    'Obq-ocb' => 'Thailand',
    'Obq-ocd' => 'Indokina',
    'Obq-ocda' => 'Laos',
    'Obq-ocdb' => 'Kambodja',
    'Obq-ocdc' => 'Vietnam',
    'Obq-od' => 'Ostindiska öarna',
    'Obq-oda' => 'Indonesien',
    'Obq-odc' => 'Filippinerna',
    'Obq-oe' => 'Östasien',
    'Obq-oea' => 'Kina',
    'Obq-oec' => 'Japan',
    'Obq-of' => 'Centralasien',
    'Obq-p' => 'Afrika',
    'Obq-pa' => 'Nordafrika utom Egypten',
    'Obq-pb' => 'Egypten och Sudan',
    'Obq-pc' => 'Västafrika',
    'Obq-pcb' => 'Ekvatorialfrika',
    'Obq-pcc' => 'Norra Västafrika',
    'Obq-pcd' => 'Södra Västafrika',
    'Obq-pd' => 'Centralafrika',
    'Obq-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Obq-pdb' => 'Angola',
    'Obq-pe' => 'Södra Afrika',
    'Obq-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Obq-peaa' => 'Sydafrikanska republiken',
    'Obq-peab' => 'Namibia',
    'Obq-peac' => 'Lesotho',
    'Obq-pead' => 'Swaziland',
    'Obq-peb' => 'Botswana',
    'Obq-pec' => 'Zimbabwe, Zambia, Malawi',
    'Obq-peca' => 'Zimbabwe',
    'Obq-pecb' => 'Zambia',
    'Obq-pecc' => 'Malawi',
    'Obq-ped' => 'Mocambique',
    'Obq-pf' => 'Östafrika',
    'Obq-pfa' => 'Uganda',
    'Obq-pfb' => 'Kenya',
    'Obq-pfc' => 'Tanzania',
    'Obq-pg' => 'Nordöstafrika',
    'Obq-pga' => 'Etiopien med Eritrea',
    'Obq-pgb' => 'Somalia',
    'Obq-q' => 'Amerika',
    'Obq-qa' => 'Förenta staterna',
    'Obq-qb' => 'Kanada',
    'Obq-qc' => 'Mexiko, Centralamerika och Västindien',
    'Obq-qcb' => 'Guatemala',
    'Obq-qcc' => 'Belize och Honduras',
    'Obq-qcd' => 'El Salvador',
    'Obq-qce' => 'Nicaragua',
    'Obq-qcf' => 'Costa Rica',
    'Obq-qch' => 'Västindien',
    'Obq-qd' => 'Sydamerika',
    'Obq-qda' => 'Colombia',
    'Obq-qdd' => 'Brasilien',
    'Obq-qdh' => 'Chile',
    'Obq-qdi' => 'Bolivia',
    'Obq-qdk' => 'Peru',
    'Obq-qdl' => 'Ecuador',
    'Obq-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Obq-ra' => 'Australien',
    'Obq-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Obq-rd' => 'Nya Guinea',
    'Obr' => 'Röda korset (och likvärdiga organisationer)',
    'Obr:k' => 'Röda korsets historia',
    'Oc' => 'Statskunskap och politik',
    'Oc(x)' => 'Allmänt: lexikon',
    'Oc:bf' => 'Organisationer och institutioner',
    'Oc:d' => 'Politisk teori, politisk psykologi och metodlära',
    'Oc:dd' => 'Metodlära',
    'Oc:do' => 'Politisk psykologi',
    'Oc:k' => 'Statskunskapens vetenskapshistoria',
    'Oc:k.' => 'Särskilda perioder',
    'Oc:k.2' => 'Forntiden',
    'Oc:k.3' => 'Medeltiden',
    'Oc:k.4' => 'Nya tiden',
    'Oc:k.5' => '1900-',
    'Oc:k.6' => '2000-',
    'Oc:ka' => 'Europa: allmänt',
    'Oc:kc' => 'Sverige',
    'Oc:kd' => 'Övriga Norden',
    'Oc:ke' => 'Brittiska öarna (Storbritannien)',
    'Oc:kf' => 'Mellaneuropa',
    'Oc:kj' => 'Frankrike och Monaco',
    'Oc:km' => 'Östeuropa',
    'Oc:ko' => 'Asien',
    'Oc:kq' => 'Amerika',
    'Oc:oa' => 'Politisk sociologi',
    'Oc.0' => 'Särskilda statsvetenskapliga och politiska delområden, politiska skrifter',
    'Oc.01' => 'Grundrättigheter',
    'Oc.03' => 'Regering',
    'Oc.05' => 'Folkrepresentation',
    'Oc.06' => 'Politiska partier',
    'Oc.07' => 'Val',
    'Oc.08' => 'Medborgarskap',
    'Oc.09' => 'Politiska skrifter',
    'Ocb' => 'Statsrätt',
    'Ocb(x)' => 'Statsrättsliga lexikon',
    'Ocb:k' => 'Statsrättens historia',
    'Ocb-' => 'Särskilda länder och områden',
    'Ocb-a' => 'Europa: allmänt',
    'Ocb-ae' => 'Europeiska unionen (EU)',
    'Ocb-b' => 'Norden: allmänt',
    'Ocb-c' => 'Sverige',
    'Ocb-c:k' => 'Den svenska statrsättens historia',
    'Ocb-d' => 'Övriga Norden',
    'Ocb-da' => 'Danmark',
    'Ocb-db' => 'Norge',
    'Ocb-dc' => 'Island och Färöarna',
    'Ocb-dd' => 'Finland',
    'Ocb-e' => 'Brittiska öarna (Storbritannien)',
    'Ocb-ea' => 'England',
    'Ocb-er' => 'Wales',
    'Ocb-es' => 'Skottland',
    'Ocb-et' => 'Irland',
    'Ocb-eta' => 'Irland (republiken)',
    'Ocb-etb' => 'Nordirland',
    'Ocb-f' => 'Mellaneuropa',
    'Ocb-fa' => 'Tyskland',
    'Ocb-fa:k' => 'Den tyska statsrättens historia',
    'Ocb-fb' => 'Österrike och Liechtenstein',
    'Ocb-fc' => 'Ungern',
    'Ocb-fd' => 'Tjeckien och Slovakien',
    'Ocb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocb-ga' => 'Nederländerna',
    'Ocb-gb' => 'Belgien',
    'Ocb-h' => 'Schweiz',
    'Ocb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocb-j' => 'Frankrike och Monaco',
    'Ocb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocb-l' => 'Portugal',
    'Ocb-m' => 'Östeuropa',
    'Ocb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocb-mb' => 'Polen',
    'Ocb-mc' => 'Estland, Lettland, Litauen',
    'Ocb-mca' => 'Estland',
    'Ocb-mcb' => 'Lettland',
    'Ocb-mcc' => 'Litauen',
    'Ocb-n' => 'Balkanländerna',
    'Ocb-na' => 'Rumänien',
    'Ocb-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocb-nc' => 'Bulgarien',
    'Ocb-nd' => 'Grekland',
    'Ocb-o' => 'Asien',
    'Ocb-oa' => 'Främre Asien',
    'Ocb-oaa' => 'Turkiet',
    'Ocb-oab' => 'Cypern',
    'Ocb-oac' => 'Kaukasien',
    'Ocb-oae' => 'Syrien och Libanon',
    'Ocb-oaf' => 'Palestina och Israel',
    'Ocb-oah' => 'Arabiska halvön',
    'Ocb-oak' => 'Iran (Persien)',
    'Ocb-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ocb-ob' => 'Främre Indien',
    'Ocb-oba' => 'Indien',
    'Ocb-obb' => 'Pakistan och Bangladesh',
    'Ocb-obe' => 'Sri Lanka (f d Ceylon)',
    'Ocb-oc' => 'Bortre Indien',
    'Ocb-ocb' => 'Thailand',
    'Ocb-occ' => 'Malaysia, Singapore och Brunei',
    'Ocb-ocd' => 'Indokina',
    'Ocb-od' => 'Ostindiska öarna',
    'Ocb-oe' => 'Östasien',
    'Ocb-oea' => 'Kina',
    'Ocb-oeb' => 'Korea',
    'Ocb-oec' => 'Japan',
    'Ocb-oek' => 'Hongkong och Macau',
    'Ocb-of' => 'Centralasien',
    'Ocb-p' => 'Afrika',
    'Ocb-pa' => 'Nordafrika utom Egypten',
    'Ocb-pb' => 'Egypten och Sudan',
    'Ocb-pc' => 'Västafrika',
    'Ocb-pcb' => 'Ekvatorialfrika',
    'Ocb-pcc' => 'Norra Västafrika',
    'Ocb-pcd' => 'Södra Västafrika',
    'Ocb-pd' => 'Centralafrika',
    'Ocb-pe' => 'Södra Afrika',
    'Ocb-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ocb-peaa' => 'Sydafrikanska republiken',
    'Ocb-peab' => 'Namibia',
    'Ocb-peb' => 'Botswana',
    'Ocb-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ocb-pee' => 'Madagaskar (Malagasy)',
    'Ocb-pf' => 'Östafrika',
    'Ocb-pfa' => 'Uganda',
    'Ocb-pfb' => 'Kenya',
    'Ocb-pfc' => 'Tanzania',
    'Ocb-pg' => 'Nordöstafrika',
    'Ocb-q' => 'Amerika',
    'Ocb-qa' => 'Förenta staterna',
    'Ocb-qb' => 'Kanada',
    'Ocb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocb-qca' => 'Mexiko',
    'Ocb-qcb' => 'Guatemala',
    'Ocb-qcd' => 'El Salvador',
    'Ocb-qce' => 'Nicaragua',
    'Ocb-qcf' => 'Costa Rica',
    'Ocb-qcg' => 'Panama',
    'Ocb-qch' => 'Västindien',
    'Ocb-qcha' => 'Stora Antillerna',
    'Ocb-qchb' => 'Små Antillerna',
    'Ocb-qd' => 'Sydamerika',
    'Ocb-qda' => 'Colombia',
    'Ocb-qdb' => 'Venezuela',
    'Ocb-qdc' => 'Guyanastaterna',
    'Ocb-qdd' => 'Brasilien',
    'Ocb-qde' => 'Paraguay',
    'Ocb-qdf' => 'Uruguay',
    'Ocb-qdg' => 'Argentina',
    'Ocb-qdh' => 'Chile',
    'Ocb-qdk' => 'Peru',
    'Ocb-qdl' => 'Ecuador',
    'Ocb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocb-ra' => 'Australien',
    'Ocb-rb' => 'Nya Zeeland',
    'Ocb-rd' => 'Nya Guinea',
    'Occ' => 'Sveriges statskunskap och politik',
    'Occ(x)' => 'Politiska lexikon',
    'Occ:bf' => 'Organisationer och institutioner',
    'Occ:oa' => 'Politisk sociologi',
    'Occ.0' => 'Särskilda statsvetenskapliga och politiska delområden, politiska skrifter',
    'Occ.01' => 'Grundrättigheter',
    'Occ.03' => 'Regering',
    'Occ.05' => 'Folkrepresentation',
    'Occ.06' => 'Politiska partier',
    'Occ.06z' => 'Särskilda partier',
    'Occ.07' => 'Val',
    'Occ.08' => 'Medborgarskap',
    'Occ.09' => 'Politiska skrifter',
    'Ocf' => 'Främmande länders statskunskap och politik',
    'Ocf(x)' => 'Politiska lexikon',
    'Ocf.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf.01' => 'Grundrättigheter',
    'Ocf.03' => 'Regering',
    'Ocf.05' => 'Folkrepresentation',
    'Ocf.06' => 'Politiska partier',
    'Ocf.06z' => 'Särskilda partier',
    'Ocf.07' => 'Val',
    'Ocf.08' => 'Medborgarskap',
    'Ocf.09' => 'Politiska skrifter',
    'Ocf-' => 'Särskilda länder och områden',
    'Ocf-a' => 'Europa: allmänt',
    'Ocf-a.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-a.01' => 'Grundrättigheter',
    'Ocf-a.03' => 'Regering',
    'Ocf-a.05' => 'Folkrepresentation',
    'Ocf-a.06' => 'Politiska partier',
    'Ocf-a.07' => 'Val',
    'Ocf-a.08' => 'Medborgarskap',
    'Ocf-ae' => 'Europeiska unionen (EU)',
    'Ocf-ae.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-ae.01' => 'Grundrättigheter',
    'Ocf-ae.05' => 'Folkrepresentation',
    'Ocf-ae.06' => 'Politiska partier',
    'Ocf-ae.07' => 'Val',
    'Ocf-ae.08' => 'Medborgarskap',
    'Ocf-b' => 'Norden: allmänt',
    'Ocf-b.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-b.01' => 'Grundrättigheter',
    'Ocf-b.03' => 'Regering',
    'Ocf-b.05' => 'Folkrepresentation',
    'Ocf-b.06' => 'Politiska partier',
    'Ocf-b.07' => 'Val',
    'Ocf-b.08' => 'Medborgarskap',
    'Ocf-b.09' => 'Politiska skrifter',
    'Ocf-bc' => 'Nordkalotten',
    'Ocf-d' => 'Övriga Norden',
    'Ocf-da' => 'Danmark',
    'Ocf-da.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-da.01' => 'Grundrättigheter',
    'Ocf-da.03' => 'Regering',
    'Ocf-da.05' => 'Folkrepresentation',
    'Ocf-da.06' => 'Politiska partier',
    'Ocf-da.06z' => 'Särskilda partier',
    'Ocf-da.07' => 'Val',
    'Ocf-da.08' => 'Medborgarskap',
    'Ocf-da.09' => 'Politiska skrifter',
    'Ocf-db' => 'Norge',
    'Ocf-db.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-db.01' => 'Grundrättigheter',
    'Ocf-db.03' => 'Regering',
    'Ocf-db.05' => 'Folkrepresentation',
    'Ocf-db.06' => 'Politiska partier',
    'Ocf-db.06z' => 'Särskilda partier',
    'Ocf-db.07' => 'Val',
    'Ocf-db.08' => 'Medborgarskap',
    'Ocf-db.09' => 'Politiska skrifter',
    'Ocf-dc' => 'Island och Färöarna',
    'Ocf-dc.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-dc.05' => 'Folkrepresentation',
    'Ocf-dc.06' => 'Politiska partier',
    'Ocf-dc.07' => 'Val',
    'Ocf-dc.09' => 'Politiska skrifter',
    'Ocf-dcf' => 'Färöarna',
    'Ocf-dd' => 'Finland',
    'Ocf-dd.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-dd.01' => 'Grundrättigheter',
    'Ocf-dd.03' => 'Regering',
    'Ocf-dd.05' => 'Folkrepresentation',
    'Ocf-dd.06' => 'Politiska partier',
    'Ocf-dd.06z' => 'Särskilda partier',
    'Ocf-dd.07' => 'Val',
    'Ocf-dd.08' => 'Medborgarskap',
    'Ocf-dd.09' => 'Politiska skrifter',
    'Ocf-ddå' => 'Åland',
    'Ocf-e' => 'Brittiska öarna (Storbritannien)',
    'Ocf-e.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-e.01' => 'Grundrättigheter',
    'Ocf-e.03' => 'Regering',
    'Ocf-e.05' => 'Folkrepresentation',
    'Ocf-e.06' => 'Politiska partier',
    'Ocf-e.06z' => 'Särskilda partier',
    'Ocf-e.07' => 'Val',
    'Ocf-e.08' => 'Medborgarskap',
    'Ocf-e.09' => 'Politiska skrifter',
    'Ocf-ea' => 'England',
    'Ocf-er' => 'Wales',
    'Ocf-es' => 'Skottland',
    'Ocf-es.06' => 'Politiska partier',
    'Ocf-es.07' => 'Val',
    'Ocf-et' => 'Irland',
    'Ocf-eta' => 'Irland (republiken)',
    'Ocf-eta.01' => 'Grundrättigheter',
    'Ocf-eta.06' => 'Politiska partier',
    'Ocf-eta.07' => 'Val',
    'Ocf-etb' => 'Nordirland',
    'Ocf-etb.01' => 'Grundrättigheter',
    'Ocf-etb.06' => 'Politiska partier',
    'Ocf-etb.09' => 'Politiska skrifter',
    'Ocf-f' => 'Mellaneuropa',
    'Ocf-fa' => 'Tyskland',
    'Ocf-fa.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fa.01' => 'Grundrättigheter',
    'Ocf-fa.03' => 'Regering',
    'Ocf-fa.05' => 'Folkrepresentation',
    'Ocf-fa.06' => 'Politiska partier',
    'Ocf-fa.06z' => 'Särskilda partier',
    'Ocf-fa.07' => 'Val',
    'Ocf-fa.08' => 'Medborgarskap',
    'Ocf-fa.09' => 'Politiska skrifter',
    'Ocf-fag' => 'Västra Tyskland',
    'Ocf-fag.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fag.01' => 'Grundrättigheter',
    'Ocf-fag.03' => 'Regering',
    'Ocf-fag.05' => 'Folkrepresentation',
    'Ocf-fag.06' => 'Politiska partier',
    'Ocf-fag.06z' => 'Särskilda partier',
    'Ocf-fag.07' => 'Val',
    'Ocf-fag.08' => 'Medborgarskap',
    'Ocf-fag.09' => 'Politiska skrifter',
    'Ocf-fah' => 'Östra Tyskland',
    'Ocf-fah.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fah.01' => 'Grundrättigheter',
    'Ocf-fah.03' => 'Regering',
    'Ocf-fah.05' => 'Folkrepresentation',
    'Ocf-fah.06' => 'Politiska partier',
    'Ocf-fah.06z' => 'Särskilda partier',
    'Ocf-fah.07' => 'Val',
    'Ocf-fah.09' => 'Politiska skrifter',
    'Ocf-fb' => 'Österrike och Liechtenstein',
    'Ocf-fb.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fb.01' => 'Grundrättigheter',
    'Ocf-fb.03' => 'Regering',
    'Ocf-fb.05' => 'Folkrepresentation',
    'Ocf-fb.06' => 'Politiska partier',
    'Ocf-fb.06z' => 'Särskilda partier',
    'Ocf-fb.07' => 'Val',
    'Ocf-fb.09' => 'Politiska skrifter',
    'Ocf-fbi' => 'Liechtenstein',
    'Ocf-fc' => 'Ungern',
    'Ocf-fc.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fc.01' => 'Grundrättigheter',
    'Ocf-fc.03' => 'Regering',
    'Ocf-fc.05' => 'Folkrepresentation',
    'Ocf-fc.06' => 'Politiska partier',
    'Ocf-fc.06z' => 'Särskilda partier',
    'Ocf-fc.07' => 'Val',
    'Ocf-fc.09' => 'Politiska skrifter',
    'Ocf-fd' => 'Tjeckien och Slovakien',
    'Ocf-fd.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-fd.01' => 'Grundrättigheter',
    'Ocf-fd.06' => 'Politiska partier',
    'Ocf-fd.06z' => 'Särskilda partier',
    'Ocf-fd.08' => 'Medborgarskap',
    'Ocf-fd.09' => 'Politiska skrifter',
    'Ocf-fda' => 'Tjeckien',
    'Ocf-fdb' => 'Slovakien',
    'Ocf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocf-ga' => 'Nederländerna',
    'Ocf-ga.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-ga.01' => 'Grundrättigheter',
    'Ocf-ga.03' => 'Regering',
    'Ocf-ga.05' => 'Folkrepresentation',
    'Ocf-ga.06' => 'Politiska partier',
    'Ocf-ga.07' => 'Val',
    'Ocf-gb' => 'Belgien',
    'Ocf-gb.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-gb.01' => 'Grundrättigheter',
    'Ocf-gb.03' => 'Regering',
    'Ocf-gb.05' => 'Folkrepresentation',
    'Ocf-gb.06' => 'Politiska partier',
    'Ocf-gb.07' => 'Val',
    'Ocf-gc' => 'Luxemburg',
    'Ocf-h' => 'Schweiz',
    'Ocf-h.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-h.01' => 'Grundrättigheter',
    'Ocf-h.03' => 'Regering',
    'Ocf-h.05' => 'Folkrepresentation',
    'Ocf-h.06' => 'Politiska partier',
    'Ocf-h.06z' => 'Särskilda partier',
    'Ocf-h.07' => 'Val',
    'Ocf-h.08' => 'Medborgarskap',
    'Ocf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocf-i.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-i.01' => 'Grundrättigheter',
    'Ocf-i.03' => 'Regering',
    'Ocf-i.05' => 'Folkrepresentation',
    'Ocf-i.06' => 'Politiska partier',
    'Ocf-i.06z' => 'Särskilda partier',
    'Ocf-i.07' => 'Val',
    'Ocf-i.08' => 'Medborgarskap',
    'Ocf-i.09' => 'Politiska skrifter',
    'Ocf-ig' => 'Vatikanstaten',
    'Ocf-iv' => 'Malta',
    'Ocf-j' => 'Frankrike och Monaco',
    'Ocf-j.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-j.01' => 'Grundrättigheter',
    'Ocf-j.03' => 'Regering',
    'Ocf-j.05' => 'Folkrepresentation',
    'Ocf-j.06' => 'Politiska partier',
    'Ocf-j.06z' => 'Särskilda partier',
    'Ocf-j.07' => 'Val',
    'Ocf-j.08' => 'Medborgarskap',
    'Ocf-j.09' => 'Politiska skrifter',
    'Ocf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocf-k.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-k.01' => 'Grundrättigheter',
    'Ocf-k.03' => 'Regering',
    'Ocf-k.05' => 'Folkrepresentation',
    'Ocf-k.06' => 'Politiska partier',
    'Ocf-k.06z' => 'Särskilda partier',
    'Ocf-k.07' => 'Val',
    'Ocf-k.09' => 'Politiska skrifter',
    'Ocf-l' => 'Portugal',
    'Ocf-l.01' => 'Grundrättigheter',
    'Ocf-l.06' => 'Politiska partier',
    'Ocf-l.09' => 'Politiska skrifter',
    'Ocf-m' => 'Östeuropa',
    'Ocf-m.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-m.01' => 'Grundrättigheter',
    'Ocf-m.03' => 'Regering',
    'Ocf-m.05' => 'Folkrepresentation',
    'Ocf-m.06' => 'Politiska partier',
    'Ocf-m.07' => 'Val',
    'Ocf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocf-ma.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-ma.01' => 'Grundrättigheter',
    'Ocf-ma.03' => 'Regering',
    'Ocf-ma.05' => 'Folkrepresentation',
    'Ocf-ma.06' => 'Politiska partier',
    'Ocf-ma.06z' => 'Särskilda partier',
    'Ocf-ma.07' => 'Val',
    'Ocf-ma.09' => 'Politiska skrifter',
    'Ocf-mad' => 'Ukraina',
    'Ocf-mae' => 'Vitryssland',
    'Ocf-maf' => 'Moldavien',
    'Ocf-mb' => 'Polen',
    'Ocf-mb.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-mb.01' => 'Grundrättigheter',
    'Ocf-mb.03' => 'Regering',
    'Ocf-mb.05' => 'Folkrepresentation',
    'Ocf-mb.06' => 'Politiska partier',
    'Ocf-mb.06z' => 'Särskilda partier',
    'Ocf-mb.07' => 'Val',
    'Ocf-mb.09' => 'Politiska skrifter',
    'Ocf-mc' => 'Estland, Lettland, Litauen',
    'Ocf-mca' => 'Estland',
    'Ocf-mca.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-mca.01' => 'Grundrättigheter',
    'Ocf-mca.05' => 'Folkrepresentation',
    'Ocf-mca.06' => 'Politiska partier',
    'Ocf-mca.07' => 'Val',
    'Ocf-mca.08' => 'Medborgarskap',
    'Ocf-mcb' => 'Lettland',
    'Ocf-mcb.01' => 'Grundrättigheter',
    'Ocf-mcb.05' => 'Folkrepresentation',
    'Ocf-mcb.06' => 'Politiska partier',
    'Ocf-mcc' => 'Litauen',
    'Ocf-mcc.06' => 'Politiska partier',
    'Ocf-n' => 'Balkanländerna',
    'Ocf-na' => 'Rumänien',
    'Ocf-na.01' => 'Grundrättigheter',
    'Ocf-na.06' => 'Politiska partier',
    'Ocf-na.09' => 'Politiska skrifter',
    'Ocf-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocf-nb.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-nb.01' => 'Grundrättigheter',
    'Ocf-nb.05' => 'Folkrepresentation',
    'Ocf-nb.06' => 'Politiska partier',
    'Ocf-nb.09' => 'Politiska skrifter',
    'Ocf-nba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Ocf-nbb' => 'Kroatien',
    'Ocf-nbc' => 'Slovenien',
    'Ocf-nbd' => 'Bosnien-Hercegovina',
    'Ocf-nbe' => 'Montengro',
    'Ocf-nbf' => 'Makedonien',
    'Ocf-nc' => 'Bulgarien',
    'Ocf-nc.01' => 'Grundrättigheter',
    'Ocf-nc.06' => 'Politiska partier',
    'Ocf-nc.09' => 'Politiska skrifter',
    'Ocf-nd' => 'Grekland',
    'Ocf-nd.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-nd.01' => 'Grundrättigheter',
    'Ocf-nd.05' => 'Folkrepresentation',
    'Ocf-nd.06' => 'Politiska partier',
    'Ocf-nd.06z' => 'Särskilda partier',
    'Ocf-nd.09' => 'Politiska skrifter',
    'Ocf-nf' => 'Albanien',
    'Ocf-nf.01' => 'Grundrättigheter',
    'Ocf-nf.06' => 'Politiska partier',
    'Ocf-nf.09' => 'Politiska skrifter',
    'Ocf-o' => 'Asien',
    'Ocf-o.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-o.01' => 'Grundrättigheter',
    'Ocf-o.03' => 'Regering',
    'Ocf-o.06' => 'Politiska partier',
    'Ocf-o.07' => 'Val',
    'Ocf-oa' => 'Främre Asien',
    'Ocf-oaa' => 'Turkiet',
    'Ocf-oaa.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oaa.01' => 'Grundrättigheter',
    'Ocf-oaa.05' => 'Folkrepresentation',
    'Ocf-oaa.06' => 'Politiska partier',
    'Ocf-oaa.09' => 'Politiska skrifter',
    'Ocf-oab' => 'Cypern',
    'Ocf-oac' => 'Kaukasien',
    'Ocf-oae' => 'Syrien och Libanon',
    'Ocf-oaea' => 'Syrien',
    'Ocf-oaeb' => 'Libanon',
    'Ocf-oaf' => 'Palestina och Israel',
    'Ocf-oaf.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oaf.01' => 'Grundrättigheter',
    'Ocf-oaf.05' => 'Folkrepresentation',
    'Ocf-oaf.06' => 'Politiska partier',
    'Ocf-oaf.07' => 'Val',
    'Ocf-oaf.09' => 'Politiska skrifter',
    'Ocf-oafh' => 'Judar',
    'Ocf-oafi' => 'Israel',
    'Ocf-oafi.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-oafi.01' => 'Grundrättigheter',
    'Ocf-oafi.05' => 'Folkrepresentation',
    'Ocf-oafi.06' => 'Politiska partier',
    'Ocf-oafi.07' => 'Val',
    'Ocf-oag' => 'Jordanien',
    'Ocf-oah' => 'Arabiska halvön',
    'Ocf-oaha' => 'Saudi-Arabien',
    'Ocf-oahb' => 'Nordjemen',
    'Ocf-oahc' => 'Sydjemen',
    'Ocf-oahd' => 'Oman',
    'Ocf-oahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Ocf-oahf' => 'Kuwait',
    'Ocf-oai' => 'Irak',
    'Ocf-oai.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oai.01' => 'Grundrättigheter',
    'Ocf-oai.03' => 'Regering',
    'Ocf-oai.06' => 'Politiska partier',
    'Ocf-oai.09' => 'Politiska skrifter',
    'Ocf-oaj' => 'Kurder',
    'Ocf-oak' => 'Iran (Persien)',
    'Ocf-oak.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oak.01' => 'Grundrättigheter',
    'Ocf-oak.03' => 'Regering',
    'Ocf-oak.06' => 'Politiska partier',
    'Ocf-oak.09' => 'Politiska skrifter',
    'Ocf-oal' => 'Afghanistan',
    'Ocf-oal.01' => 'Grundrättigheter',
    'Ocf-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ocf-oama' => 'Kazakstan',
    'Ocf-oamb' => 'Turkmenistan',
    'Ocf-oamc' => 'Uzbekistan',
    'Ocf-oamd' => 'Kirgisistan',
    'Ocf-oame' => 'Tadzjikistan',
    'Ocf-ob' => 'Främre Indien',
    'Ocf-oba' => 'Indien',
    'Ocf-oba.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oba.01' => 'Grundrättigheter',
    'Ocf-oba.03' => 'Regering',
    'Ocf-oba.05' => 'Folkrepresentation',
    'Ocf-oba.06' => 'Politiska partier',
    'Ocf-oba.06z' => 'Särskilda partier',
    'Ocf-oba.07' => 'Val',
    'Ocf-oba.09' => 'Politiska skrifter',
    'Ocf-obb' => 'Pakistan och Bangladesh',
    'Ocf-obba' => 'Pakistan',
    'Ocf-obbb' => 'Bangladesh',
    'Ocf-obc' => 'Bhutan',
    'Ocf-obd' => 'Nepal',
    'Ocf-obe' => 'Sri Lanka (f d Ceylon)',
    'Ocf-oc' => 'Bortre Indien',
    'Ocf-oca' => 'Myanmar (f d Burma)',
    'Ocf-ocb' => 'Thailand',
    'Ocf-occ' => 'Malaysia, Singapore och Brunei',
    'Ocf-occa' => 'Malaysia',
    'Ocf-occb' => 'Singapore',
    'Ocf-ocd' => 'Indokina',
    'Ocf-ocda' => 'Laos',
    'Ocf-ocdb' => 'Kambodja',
    'Ocf-ocdc' => 'Vietnam',
    'Ocf-ocdc.01' => 'Grundrättigheter',
    'Ocf-ocdc.06' => 'Politiska partier',
    'Ocf-ocdc.09' => 'Politiska skrifter',
    'Ocf-od' => 'Ostindiska öarna',
    'Ocf-oda' => 'Indonesien',
    'Ocf-oda.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-oda.01' => 'Grundrättigheter',
    'Ocf-oda.03' => 'Regering',
    'Ocf-oda.06' => 'Politiska partier',
    'Ocf-oda.07' => 'Val',
    'Ocf-odab' => 'Java',
    'Ocf-odaf' => 'Timor och Östtimor',
    'Ocf-odc' => 'Filippinerna',
    'Ocf-oe' => 'Östasien',
    'Ocf-oea' => 'Kina',
    'Ocf-oea.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oea.01' => 'Grundrättigheter',
    'Ocf-oea.03' => 'Regering',
    'Ocf-oea.05' => 'Folkrepresentation',
    'Ocf-oea.06' => 'Politiska partier',
    'Ocf-oea.06z' => 'Särskilda partier',
    'Ocf-oea.07' => 'Val',
    'Ocf-oea.08' => 'Medborgarskap',
    'Ocf-oea.09' => 'Politiska skrifter',
    'Ocf-oeaf' => 'Taiwan',
    'Ocf-oeak' => 'Tibet',
    'Ocf-oeb' => 'Korea',
    'Ocf-oeb.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oeb.05' => 'Folkrepresentation',
    'Ocf-oeb.06' => 'Politiska partier',
    'Ocf-oeb.09' => 'Politiska skrifter',
    'Ocf-oeba' => 'Nordkorea',
    'Ocf-oebb' => 'Sydkorea',
    'Ocf-oec' => 'Japan',
    'Ocf-oec.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-oec.01' => 'Grundrättigheter',
    'Ocf-oec.03' => 'Regering',
    'Ocf-oec.05' => 'Folkrepresentation',
    'Ocf-oec.06' => 'Politiska partier',
    'Ocf-oec.07' => 'Val',
    'Ocf-oec.09' => 'Politiska skrifter',
    'Ocf-oek' => 'Hongkong och Macau',
    'Ocf-oeka' => 'Hongkong',
    'Ocf-oekc' => 'Macau',
    'Ocf-of' => 'Centralasien',
    'Ocf-ofc' => 'Mongoliet',
    'Ocf-p' => 'Afrika',
    'Ocf-p.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-p.01' => 'Grundrättigheter',
    'Ocf-p.03' => 'Regering',
    'Ocf-p.06' => 'Politiska partier',
    'Ocf-p.07' => 'Val',
    'Ocf-p.08' => 'Medborgarskap',
    'Ocf-p.09' => 'Politiska skrifter',
    'Ocf-pa' => 'Nordafrika utom Egypten',
    'Ocf-paa' => 'Marocko och Kanarieöarna',
    'Ocf-pab' => 'Algeriet',
    'Ocf-pac' => 'Tunisien',
    'Ocf-pad' => 'Libyen',
    'Ocf-pb' => 'Egypten och Sudan',
    'Ocf-pba' => 'Egypten',
    'Ocf-pba.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-pba.01' => 'Grundrättigheter',
    'Ocf-pba.03' => 'Regering',
    'Ocf-pba.06' => 'Politiska partier',
    'Ocf-pba.09' => 'Politiska skrifter',
    'Ocf-pbb' => 'Sudan',
    'Ocf-pc' => 'Västafrika',
    'Ocf-pcb' => 'Ekvatorialfrika',
    'Ocf-pcba' => 'Tchad',
    'Ocf-pcbb' => 'Centralafrikanska republiken',
    'Ocf-pcbc' => 'Kongo (Brazzaville)',
    'Ocf-pcbd' => 'Gabon',
    'Ocf-pcbe' => 'Kamerun',
    'Ocf-pcc' => 'Norra Västafrika',
    'Ocf-pcca' => 'Västra Sahara',
    'Ocf-pccb' => 'Mauretanien',
    'Ocf-pccc' => 'Senegal',
    'Ocf-pccd' => 'Gambia',
    'Ocf-pcce' => 'Mali',
    'Ocf-pccg' => 'Burkina Faso',
    'Ocf-pcch' => 'Niger',
    'Ocf-pcci' => 'Guniea-Bissau',
    'Ocf-pccj' => 'Cap Verde',
    'Ocf-pcck' => 'Guinea',
    'Ocf-pccl' => 'Elfenbenskusten',
    'Ocf-pccm' => 'Sierra Leone',
    'Ocf-pccn' => 'Liberia',
    'Ocf-pcd' => 'Södra Västafrika',
    'Ocf-pcda' => 'Ghana',
    'Ocf-pcdb' => 'Togo',
    'Ocf-pcdc' => 'Benin',
    'Ocf-pcdd' => 'Nigeria',
    'Ocf-pcddd.01' => 'Grundrättigheter',
    'Ocf-pcdd.07' => 'Val',
    'Ocf-pcdd.09' => 'Politiska skrifter',
    'Ocf-pcde' => 'Ekvatorialguinea',
    'Ocf-pcdf' => 'Sao Thomé och Principe',
    'Ocf-pd' => 'Centralafrika',
    'Ocf-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Ocf-pdaa' => 'Kongo (Kinshasa)',
    'Ocf-pdab' => 'Rwanda',
    'Ocf-pdac' => 'Burundi',
    'Ocf-pdb' => 'Angola',
    'Ocf-pe' => 'Södra Afrika',
    'Ocf-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ocf-peaa' => 'Sydafrikanska republiken',
    'Ocf-peaa.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-peaa.01' => 'Grundrättigheter',
    'Ocf-peaa.05' => 'Folkrepresentation',
    'Ocf-peaa.06' => 'Politiska partier',
    'Ocf-peaa.07' => 'Val',
    'Ocf-peaa.09' => 'Politiska skrifter',
    'Ocf-peab' => 'Namibia',
    'Ocf-peac' => 'Lesotho',
    'Ocf-pead' => 'Swaziland',
    'Ocf-peb' => 'Botswana',
    'Ocf-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ocf-peca' => 'Zimbabwe',
    'Ocf-pecb' => 'Zambia',
    'Ocf-pecc' => 'Malawi',
    'Ocf-ped' => 'Mocambique',
    'Ocf-pee' => 'Madagaskar (Malagasy)',
    'Ocf-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Ocf-pf' => 'Östafrika',
    'Ocf-pfa' => 'Uganda',
    'Ocf-pfb' => 'Kenya',
    'Ocf-pfb.01' => 'Grundrättigheter',
    'Ocf-pfb.06' => 'Politiska partier',
    'Ocf-pfb.07' => 'Val',
    'Ocf-pfc' => 'Tanzania',
    'Ocf-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'Ocf-pg' => 'Nordöstafrika',
    'Ocf-pga' => 'Etiopien med Eritrea',
    'Ocf-pgae' => 'Eritrea',
    'Ocf-pgb' => 'Somalia',
    'Ocf-pgc' => 'Djibouti',
    'Ocf-q' => 'Amerika',
    'Ocf-qa' => 'Förenta staterna',
    'Ocf-qa.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qa.01' => 'Grundrättigheter',
    'Ocf-qa.03' => 'Regering',
    'Ocf-qa.05' => 'Folkrepresentation',
    'Ocf-qa.06' => 'Politiska partier',
    'Ocf-qa.06z' => 'Särskilda partier',
    'Ocf-qa.07' => 'Val',
    'Ocf-qa.08' => 'Medborgarskap',
    'Ocf-qa.09' => 'Politiska skrifter',
    'Ocf-qaa' => 'Nordöstra staterna',
    'Ocf-qab' => 'Sydöstra staterna',
    'Ocf-qac' => 'Södra centralstaterna',
    'Ocf-qad' => 'Norra centralstaterna',
    'Ocf-qae' => 'Bergsstaterna',
    'Ocf-qaf' => 'Stillahavsstaterna',
    'Ocf-qb' => 'Kanada',
    'Ocf-qb.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qb.01' => 'Grundrättigheter',
    'Ocf-qb.03' => 'Regering',
    'Ocf-qb.05' => 'Folkrepresentation',
    'Ocf-qb.06' => 'Politiska partier',
    'Ocf-qb.07' => 'Val',
    'Ocf-qb.09' => 'Politiska skrifter',
    'Ocf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocf-qca' => 'Mexiko',
    'Ocf-qca.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qca.01' => 'Grundrättigheter',
    'Ocf-qca.03' => 'Regering',
    'Ocf-qca.06' => 'Politiska partier',
    'Ocf-qca.07' => 'Val',
    'Ocf-qca.09' => 'Politiska skrifter',
    'Ocf-qcb' => 'Guatemala',
    'Ocf-qcb.01' => 'Grundrättigheter',
    'Ocf-qcb.06' => 'Politiska partier',
    'Ocf-qcc' => 'Belize och Honduras',
    'Ocf-qcca' => 'Belize',
    'Ocf-qccb' => 'Honduras',
    'Ocf-qcd' => 'El Salvador',
    'Ocf-qce' => 'Nicaragua',
    'Ocf-qcf' => 'Costa Rica',
    'Ocf-qcg' => 'Panama',
    'Ocf-qch' => 'Västindien',
    'Ocf-qcha' => 'Stora Antillerna',
    'Ocf-qchaa' => 'Kuba',
    'Ocf-qchaa.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qchaa.01' => 'Grundrättigheter',
    'Ocf-qchaa.05' => 'Folkrepresentation',
    'Ocf-qchaa.06' => 'Politiska partier',
    'Ocf-qchaa.09' => 'Politiska skrifter',
    'Ocf-qchab' => 'Haiti',
    'Ocf-qchac' => 'Dominikanska republiken',
    'Ocf-qchad' => 'Puerto Rico',
    'Ocf-qchae' => 'Jamaica',
    'Ocf-qchb' => 'Små Antillerna',
    'Ocf-qchba' => 'Trinidad och Tobago',
    'Ocf-qchbm' => 'Grenada',
    'Ocf-qchbö' => 'Övriga öar',
    'Ocf-qd' => 'Sydamerika',
    'Ocf-qd.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qd.01' => 'Grundrättigheter',
    'Ocf-qd.03' => 'Regering',
    'Ocf-qd.05' => 'Folkrepresentation',
    'Ocf-qd.06' => 'Politiska partier',
    'Ocf-qd.09' => 'Politiska skrifter',
    'Ocf-qda' => 'Colombia',
    'Ocf-qda.01' => 'Grundrättigheter',
    'Ocf-qda.06' => 'Politiska partier',
    'Ocf-qda.09' => 'Politiska skrifter',
    'Ocf-qdb' => 'Venezuela',
    'Ocf-qdc' => 'Guyanastaterna',
    'Ocf-qdd' => 'Brasilien',
    'Ocf-qdd.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qdd.01' => 'Grundrättigheter',
    'Ocf-qdd.03' => 'Regering',
    'Ocf-qdd.05' => 'Folkrepresentation',
    'Ocf-qdd.06' => 'Politiska partier',
    'Ocf-qdd.07' => 'Val',
    'Ocf-qdd.08' => 'Medborgarskap',
    'Ocf-qdd.09' => 'Politiska skrifter',
    'Ocf-qde' => 'Paraguay',
    'Ocf-qdf' => 'Uruguay',
    'Ocf-qdg' => 'Argentina',
    'Ocf-qdg.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qdg.01' => 'Grundrättigheter',
    'Ocf-qdg.03' => 'Regering',
    'Ocf-qdg.05' => 'Folkrepresentation',
    'Ocf-qdg.06' => 'Politiska partier',
    'Ocf-qdg.07' => 'Val',
    'Ocf-qdg.08' => 'Medborgarskap',
    'Ocf-qdg.09' => 'Politiska skrifter',
    'Ocf-qdh' => 'Chile',
    'Ocf-qdh.0' => 'Särskilda statsvetenskapliga delområden, politiska skrifter',
    'Ocf-qdh.01' => 'Grundrättigheter',
    'Ocf-qdh.03' => 'Regering',
    'Ocf-qdh.06' => 'Politiska partier',
    'Ocf-qdh.07' => 'Val',
    'Ocf-qdh.08' => 'Medborgarskap',
    'Ocf-qdh.09' => 'Politiska skrifter',
    'Ocf-qdi' => 'Bolivia',
    'Ocf-qdk' => 'Peru',
    'Ocf-qdk.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-qdk.01' => 'Grundrättigheter',
    'Ocf-qdk.03' => 'Regering',
    'Ocf-qdk.06' => 'Politiska partier',
    'Ocf-qdk.07' => 'Val',
    'Ocf-qdl' => 'Ecuador',
    'Ocf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocf-ra' => 'Australien',
    'Ocf-ra.0' => 'Särskilda statsvetenskapliga delområden',
    'Ocf-ra.01' => 'Grundrättigheter',
    'Ocf-ra.03' => 'Regering',
    'Ocf-ra.05' => 'Folkrepresentation',
    'Ocf-ra.06' => 'Politiska partier',
    'Ocf-ra.07' => 'Val',
    'Ocf-ra.08' => 'Medborgarskap',
    'Ocf-rb' => 'Nya Zeeland',
    'Ocf-rb.01' => 'Grundrättigheter',
    'Ocf-rb.05' => 'Folkrepresentation',
    'Ocf-rb.07' => 'Val',
    'Ocf-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ocf-rca' => 'Melanesien',
    'Ocf-rcb' => 'Polynesien',
    'Ocf-rcc' => 'Mikronesien',
    'Ocf-rd' => 'Nya Guinea',
    'Ocf-s' => 'Polarländerna',
    'Ocf-sa' => 'Arktis (Nordpolsområdet)',
    'Ocf-saa' => 'Grönland',
    'Ocf-sb' => 'Antarktis',
    'Ocg' => 'Politiska begrepp och politiska åskådningar',
    'Ocg-' => 'Allmänt: särskilda länder och områden',
    'Ocg-a' => 'Europa: allmänt',
    'Ocg-ae' => 'Europeiska unionen (EU)',
    'Ocg-b' => 'Norden: allmänt',
    'Ocg-c' => 'Sverige',
    'Ocg-d' => 'Övriga Norden',
    'Ocg-da' => 'Danmark',
    'Ocg-db' => 'Norge',
    'Ocg-dd' => 'Finland',
    'Ocg-e' => 'Brittiska öarna (Storbritannien)',
    'Ocg-et' => 'Irland',
    'Ocg-f' => 'Mellaneuropa',
    'Ocg-fa' => 'Tyskland',
    'Ocg-fag' => 'Västra Tyskland',
    'Ocg-fah' => 'Östra Tyskland',
    'Ocg-fb' => 'Österrike och Liechtenstein',
    'Ocg-fc' => 'Ungern',
    'Ocg-fd' => 'Tjeckien och Slovakien',
    'Ocg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocg-h' => 'Schweiz',
    'Ocg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocg-j' => 'Frankrike och Monaco',
    'Ocg-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocg-m' => 'Östeuropa',
    'Ocg-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocg-mad' => 'Ukraina',
    'Ocg-mae' => 'Vitryssland',
    'Ocg-mb' => 'Polen',
    'Ocg-mc' => 'Estland, Lettland, Litauen',
    'Ocg-n' => 'Balkanländerna',
    'Ocg-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocg-nf' => 'Albanien',
    'Ocg-o' => 'Asien',
    'Ocg-oa' => 'Främre Asien',
    'Ocg-oaa' => 'Turkiet',
    'Ocg-oaf' => 'Palestina och Israel',
    'Ocg-oak' => 'Iran (Persien)',
    'Ocg-ob' => 'Främre Indien',
    'Ocg-oba' => 'Indien',
    'Ocg-obb' => 'Pakistan och Bangladesh',
    'Ocg-oc' => 'Bortre Indien',
    'Ocg-od' => 'Ostindiska öarna',
    'Ocg-oe' => 'Östasien',
    'Ocg-oea' => 'Kina',
    'Ocg-oeb' => 'Korea',
    'Ocg-oec' => 'Japan',
    'Ocg-p' => 'Afrika',
    'Ocg-pa' => 'Nordafrika utom Egypten',
    'Ocg-pb' => 'Egypten och Sudan',
    'Ocg-pc' => 'Västafrika',
    'Ocg-pe' => 'Södra Afrika',
    'Ocg-pf' => 'Östafrika',
    'Ocg-pg' => 'Nordöstafrika',
    'Ocg-q' => 'Amerika',
    'Ocg-qa' => 'Förenta staterna',
    'Ocg-qb' => 'Kanada',
    'Ocg-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocg-qd' => 'Sydamerika',
    'Ocg-qdb' => 'Venezuela',
    'Ocg-qdd' => 'Brasilien',
    'Ocg-qdg' => 'Argentina',
    'Ocg-qdh' => 'Chile',
    'Ocg-qdk' => 'Peru',
    'Ocg-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocga' => 'Politiska begrepp',
    'Ocga-' => 'Särskilda länder och områden',
    'Ocga-a' => 'Europa: allmänt',
    'Ocga-ae' => 'Europeiska unionen (EU)',
    'Ocga-b' => 'Norden: allmänt',
    'Ocga-c' => 'Sverige',
    'Ocga-d' => 'Övriga Norden',
    'Ocga-e' => 'Brittiska öarna (Storbritannien)',
    'Ocga-f' => 'Mellaneuropa',
    'Ocga-fa' => 'Tyskland',
    'Ocga-fb' => 'Österrike och Liechtenstein',
    'Ocga-fd' => 'Tjeckien och Slovakien',
    'Ocga-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocga-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocga-j' => 'Frankrike och Monaco',
    'Ocga-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocga-m' => 'Östeuropa',
    'Ocga-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocga-n' => 'Balkanländerna',
    'Ocga-o' => 'Asien',
    'Ocga-oa' => 'Främre Asien',
    'Ocga-ob' => 'Främre Indien',
    'Ocga-oc' => 'Bortre Indien',
    'Ocga-od' => 'Ostindiska öarna',
    'Ocga-oe' => 'Östasien',
    'Ocga-p' => 'Afrika',
    'Ocga-q' => 'Amerika',
    'Ocga-qa' => 'Förenta staterna',
    'Ocga-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocga-qd' => 'Sydamerika',
    'Ocga-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgaa' => 'Demokrati och diktatur',
    'Ocgaa-' => 'Särskilda länder och områden',
    'Ocgaa-a' => 'Europa: allmänt',
    'Ocgaa-ae' => 'Europeiska unionen (EU)',
    'Ocgaa-b' => 'Norden: allmänt',
    'Ocgaa-c' => 'Sverige',
    'Ocgaa-d' => 'Övriga Norden',
    'Ocgaa-da' => 'Danmark',
    'Ocgaa-db' => 'Norge',
    'Ocgaa-dd' => 'Finland',
    'Ocgaa-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgaa-et' => 'Irland',
    'Ocgaa-f' => 'Mellaneuropa',
    'Ocgaa-fa' => 'Tyskland',
    'Ocgaa-fc' => 'Ungern',
    'Ocgaa-fd' => 'Tjeckien och Slovakien',
    'Ocgaa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgaa-h' => 'Schweiz',
    'Ocgaa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgaa-j' => 'Frankrike och Monaco',
    'Ocgaa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgaa-l' => 'Portugal',
    'Ocgaa-m' => 'Östeuropa',
    'Ocgaa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgaa-mb' => 'Polen',
    'Ocgaa-mc' => 'Estland, Lettland, Litauen',
    'Ocgaa-n' => 'Balkanländerna',
    'Ocgaa-na' => 'Rumänien',
    'Ocgaa-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocgaa-nd' => 'Grekland',
    'Ocgaa-o' => 'Asien',
    'Ocgaa-oa' => 'Främre Asien',
    'Ocgaa-oaa' => 'Turkiet',
    'Ocgaa-oac' => 'Kaukasien',
    'Ocgaa-oaf' => 'Palestina och Israel',
    'Ocgaa-oai' => 'Irak',
    'Ocgaa-oak' => 'Iran (Persien)',
    'Ocgaa-ob' => 'Främre Indien',
    'Ocgaa-oba' => 'Indien',
    'Ocgaa-obb' => 'Pakistan och Bangladesh',
    'Ocgaa-obd' => 'Nepal',
    'Ocgaa-oc' => 'Bortre Indien',
    'Ocgaa-od' => 'Ostindiska öarna',
    'Ocgaa-oe' => 'Östasien',
    'Ocgaa-oea' => 'Kina',
    'Ocgaa-oeaf' => 'Taiwan',
    'Ocgaa-oeb' => 'Korea',
    'Ocgaa-oec' => 'Japan',
    'Ocgaa-oek' => 'Hongkong och Macau',
    'Ocgaa-p' => 'Afrika',
    'Ocgaa-pa' => 'Nordafrika utom Egypten',
    'Ocgaa-pb' => 'Egypten och Sudan',
    'Ocgaa-pc' => 'Västafrika',
    'Ocgaa-pe' => 'Södra Afrika',
    'Ocgaa-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ocgaa-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ocgaa-ped' => 'Mocambique',
    'Ocgaa-pf' => 'Östafrika',
    'Ocgaa-pg' => 'Nordöstafrika',
    'Ocgaa-q' => 'Amerika',
    'Ocgaa-qa' => 'Förenta staterna',
    'Ocgaa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgaa-qca' => 'Mexiko',
    'Ocgaa-qcb' => 'Guatemala',
    'Ocgaa-qcc' => 'Belize och Honduras',
    'Ocgaa-qcd' => 'El Salvador',
    'Ocgaa-qce' => 'Nicaragua',
    'Ocgaa-qcf' => 'Costa Rica',
    'Ocgaa-qch' => 'Västindien',
    'Ocgaa-qd' => 'Sydamerika',
    'Ocgaa-qda' => 'Colombia',
    'Ocgaa-qdb' => 'Venezuela',
    'Ocgaa-qdd' => 'Brasilien',
    'Ocgaa-qde' => 'Paraguay',
    'Ocgaa-qdf' => 'Uruguay',
    'Ocgaa-qdg' => 'Argentina',
    'Ocgaa-qdh' => 'Chile',
    'Ocgaa-qdi' => 'Bolivia',
    'Ocgaa-qdk' => 'Peru',
    'Ocgaa-qdl' => 'Ecuador',
    'Ocgaa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgab' => 'Monarki och republik',
    'Ocgab-a' => 'Europa: allmänt',
    'Ocgab-c' => 'Sverige',
    'Ocgab-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgab-j' => 'Frankrike och Monaco',
    'Ocgab-o' => 'ASien',
    'Ocgab-q' => 'Amerika',
    'Ocgac' => 'Nationalism',
    'Ocgac-' => 'Särskilda länder och områden',
    'Ocgac-a' => 'Europa: allmänt',
    'Ocgac-ae' => 'Europeiska unionen (EU)',
    'Ocgac-b' => 'Norden: allmänt',
    'Ocgac-c' => 'Sverige',
    'Ocgac-d' => 'Övriga Norden',
    'Ocgac-da' => 'Danmark',
    'Ocgac-db' => 'Norge',
    'Ocgac-dc' => 'Island och Färöarna',
    'Ocgac-dd' => 'Finland',
    'Ocgac-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgac-ea' => 'England',
    'Ocgac-er' => 'Wales',
    'Ocgac-es' => 'Skottland',
    'Ocgac-et' => 'Irland',
    'Ocgac-f' => 'Mellaneuropa',
    'Ocgac-fa' => 'Tyskland',
    'Ocgac-fb' => 'Österrike och Liechtenstein',
    'Ocgac-fc' => 'Ungern',
    'Ocgac-fd' => 'Tjeckien och Slovakien',
    'Ocgac-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgac-h' => 'Schweiz',
    'Ocgac-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgac-j' => 'Frankrike och Monaco',
    'Ocgac-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgac-kf' => 'Basker',
    'Ocgac-m' => 'Östeuropa',
    'Ocgac-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgac-mad' => 'Ukraina',
    'Ocgac-mae' => 'Vitryssland',
    'Ocgac-mb' => 'Polen',
    'Ocgac-mc' => 'Estland, Lettland, Litauen',
    'Ocgac-n' => 'Balkanländerna',
    'Ocgac-na' => 'Rumänien',
    'Ocgac-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocgac-nba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Ocgac-nbd' => 'Bosnien-Hercegovina',
    'Ocgac-nbf' => 'Makedonien',
    'Ocgac-nc' => 'Bulgarien',
    'Ocgac-nd' => 'Grekland',
    'Ocgac-nf' => 'Albanien',
    'Ocgac-o' => 'Asien',
    'Ocgac-oa' => 'Främre Asien',
    'Ocgac-oaa' => 'Turkiet',
    'Ocgac-oac' => 'Kaukasien',
    'Ocgac-oae' => 'Syrien och Libanon',
    'Ocgac-oaf' => 'Palestina och Israel',
    'Ocgac-oag' => 'Jordanien',
    'Ocgac-oai' => 'Irak',
    'Ocgac-oaj' => 'Kurder',
    'Ocgac-oak' => 'Iran (Persien)',
    'Ocgac-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ocgac-ob' => 'Främre Indien',
    'Ocgac-oba' => 'Indien',
    'Ocgac-obb' => 'Pakistan och Bangladesh',
    'Ocgac-obe' => 'Sri Lanka (f d Ceylon)',
    'Ocgac-oc' => 'Bortre Indien',
    'Ocgac-oca' => 'Myanmar (f d Burma)',
    'Ocgac-ocb' => 'Thailand',
    'Ocgac-occ' => 'Malaysia, Singapore och Brunei',
    'Ocgac-ocd' => 'Indokina',
    'Ocgac-od' => 'Ostindiska öarna',
    'Ocgac-oe' => 'Östasien',
    'Ocgac-oea' => 'Kina',
    'Ocgac-oeaf' => 'Taiwan',
    'Ocgac-oeak' => 'Tibet',
    'Ocgac-oeb' => 'Korea',
    'Ocgac-oec' => 'Japan',
    'Ocgac-of' => 'Centralasien',
    'Ocgac-og' => 'Sibirien',
    'Ocgac-p' => 'Afrika',
    'Ocgac-pa' => 'Nordafrika utom Egypten',
    'Ocgac-pb' => 'Egypten och Sudan',
    'Ocgac-pc' => 'Västafrika',
    'Ocgac-pe' => 'Södra Afrika',
    'Ocgac-pf' => 'Östafrika',
    'Ocgac-pg' => 'Nordöstafrika',
    'Ocgac-q' => 'Amerika',
    'Ocgac-qa' => 'Förenta staterna',
    'Ocgac-qb' => 'Kanada',
    'Ocgac-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgac-qca' => 'Mexiko',
    'Ocgac-qch' => 'Västindien',
    'Ocgac-qd' => 'Sydamerika',
    'Ocgac-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgb' => 'Konservatism',
    'Ocgb-' => 'Särskilda länder och områden',
    'Ocgb-a' => 'Europa: allmänt',
    'Ocgb-b' => 'Norden: allmänt',
    'Ocgb-c' => 'Sverige',
    'Ocgb-d' => 'Övriga Norden',
    'Ocgb-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgb-f' => 'Mellaneuropa',
    'Ocgb-fa' => 'Tyskland',
    'Ocgb-fb' => 'Österrike och Liechtenstein',
    'Ocgb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgb-j' => 'Frankrike och Monaco',
    'Ocgb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgb-m' => 'Östeuropa',
    'Ocgb-o' => 'Asien',
    'Ocgb-p' => 'Afrika',
    'Ocgb-q' => 'Amerika',
    'Ocgb-qa' => 'Förenta staterna',
    'Ocgb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgb-qd' => 'Sydamerika',
    'Ocgb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgc' => 'Liberalism',
    'Ocgc-' => 'Särskilda länder och områden',
    'Ocgc-a' => 'Europa: allmänt',
    'Ocgc-b' => 'Norden: allmänt',
    'Ocgc-c' => 'Sverige',
    'Ocgc-d' => 'Övriga Norden',
    'Ocgc-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgc-f' => 'Mellaneuropa',
    'Ocgc-fa' => 'Tyskland',
    'Ocgc-fb' => 'Österrike och Liechtenstein',
    'Ocgc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgc-h' => 'Schweiz',
    'Ocgc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgc-j' => 'Frankrike och Monaco',
    'Ocgc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgc-m' => 'Östeuropa',
    'Ocgc-n' => 'Balkanländerna',
    'Ocgc-o' => 'Asien',
    'Ocgc-p' => 'Afrika',
    'Ocgc-q' => 'Amerika',
    'Ocgc-qa' => 'Förenta staterna',
    'Ocgc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgc-qd' => 'Sydamerika',
    'Ocgc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgd' => 'Socialism',
    'Ocgd-' => 'Särskilda länder och områden',
    'Ocgd-a' => 'Europa: allmänt',
    'Ocgd-b' => 'Norden: allmänt',
    'Ocgd-c' => 'Sverige',
    'Ocgd-c:k' => 'Historia',
    'Ocgd-d' => 'Övriga Norden',
    'Ocgd-da' => 'Danmark',
    'Ocgd-db' => 'Norge',
    'Ocgd-dd' => 'Finland',
    'Ocgd-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgd-es' => 'Skottland',
    'Ocgd-et' => 'Irland',
    'Ocgd-f' => 'Mellaneuropa',
    'Ocgd-fa' => 'Tyskland',
    'Ocgd-fa:k' => 'Historia',
    'Ocgd-fag' => 'Västra Tyskland',
    'Ocgd-fah' => 'Östra Tyskland',
    'Ocgd-fb' => 'Österrike och Liechtenstein',
    'Ocgd-fc' => 'Ungern',
    'Ocgd-fd' => 'Tjeckien och Slovakien',
    'Ocgd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgd-ga' => 'Nederländerna',
    'Ocgd-gb' => 'Belgien',
    'Ocgd-h' => 'Schweiz',
    'Ocgd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgd-j' => 'Frankrike och Monaco',
    'Ocgd-j:k' => 'Historia',
    'Ocgd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgd-l' => 'Portugal',
    'Ocgd-m' => 'Östeuropa',
    'Ocgd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgd-mb' => 'Polen',
    'Ocgd-mc' => 'Estland, Lettland, Litauen',
    'Ocgd-n' => 'Balkanländerna',
    'Ocgd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocgd-nc' => 'Bulgarien',
    'Ocgd-nd' => 'Grekland',
    'Ocgd-nf' => 'Albanien',
    'Ocgd-o' => 'Asien',
    'Ocgd-oa' => 'Främre Asien',
    'Ocgd-oaa' => 'Turkiet',
    'Ocgd-oaf' => 'Palestina och Israel',
    'Ocgd-oafh' => 'Judar',
    'Ocgd-oafi' => 'Israel',
    'Ocgd-oak' => 'Iran (Persien)',
    'Ocgd-ob' => 'Främre Indien',
    'Ocgd-oba' => 'Indien',
    'Ocgd-oc' => 'Bortre Indien',
    'Ocgd-od' => 'Ostindiska öarna',
    'Ocgd-oe' => 'Östasien',
    'Ocgd-oea' => 'Kina',
    'Ocgd-oeb' => 'Korea',
    'Ocgd-oec' => 'Japan',
    'Ocgd-p' => 'Afrika',
    'Ocgd-pa' => 'Nordafrika utom Egypten',
    'Ocgd-pb' => 'Egypten och Sudan',
    'Ocgd-pc' => 'Västafrika',
    'Ocgd-pe' => 'Södra Afrika',
    'Ocgd-pf' => 'Östafrika',
    'Ocgd-pg' => 'Nordöstafrika',
    'Ocgd-q' => 'Amerika',
    'Ocgd-qa' => 'Förenta staterna',
    'Ocgd-qb' => 'Kanada',
    'Ocgd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgd-qca' => 'Mexiko',
    'Ocgd-qce' => 'Nicaragua',
    'Ocgd-qch' => 'Västindien',
    'Ocgd-qd' => 'Sydamerika',
    'Ocgd-qdd' => 'Brasilien',
    'Ocgd-qdf' => 'Uruguay',
    'Ocgd-qdg' => 'Argentina',
    'Ocgd-qdh' => 'Chile',
    'Ocgd-qdk' => 'Peru',
    'Ocgd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgdd' => 'Reformistisk socialism och socialdemokrati',
    'Ocgdd-' => 'Särskilda länder och områden',
    'Ocgdd-a' => 'Europa: allmänt',
    'Ocgdd-ae' => 'Europeiska unionen (EU)',
    'Ocgdd-b' => 'Norden: allmänt',
    'Ocgdd-c' => 'Sverige',
    'Ocgdd-c:bf' => 'Organisationer och institutioner',
    'Ocgdd-c:k' => 'Historia',
    'Ocgdd-d' => 'Övriga Norden',
    'Ocgdd-da' => 'Danmark',
    'Ocgdd-db' => 'Norge',
    'Ocgdd-dc' => 'Island och Färöarna',
    'Ocgdd-dd' => 'Finland',
    'Ocgdd-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgdd-f' => 'Mellaneuropa',
    'Ocgdd-fa' => 'Tyskland',
    'Ocgdd-fb' => 'Österrike och Liechtenstein',
    'Ocgdd-fc' => 'Ungern',
    'Ocgdd-fd' => 'Tjeckien och Slovakien',
    'Ocgdd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgdd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgdd-j' => 'Frankrike och Monaco',
    'Ocgdd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgdd-m' => 'Östeuropa',
    'Ocgdd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgdd-mb' => 'Polen',
    'Ocgdd-mc' => 'Estland, Lettland, Litauen',
    'Ocgdd-n' => 'Balkanländerna',
    'Ocgdd-o' => 'Asien',
    'Ocgdd-p' => 'Afrika',
    'Ocgdd-q' => 'Amerika',
    'Ocgdd-qa' => 'Förenta staterna',
    'Ocgdd-qb' => 'Kanada',
    'Ocgdd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgdd-qd' => 'Sydamerika',
    'Ocgdd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgde' => 'Revolutionär socialism och kommunism',
    'Ocgde-' => 'Särskilda länder och områden',
    'Ocgde-a' => 'Europa: allmänt',
    'Ocgde-b' => 'Norden: allmänt',
    'Ocgde-c' => 'Sverige',
    'Ocgde-c:bf' => 'Organisationer och institutioner',
    'Ocgde-c:k' => 'Historia',
    'Ocgde-d' => 'Övriga Norden',
    'Ocgde-da' => 'Danmark',
    'Ocgde-db' => 'Norge',
    'Ocgde-dd' => 'Finland',
    'Ocgde-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgde-et' => 'Irland',
    'Ocgde-f' => 'Mellaneuropa',
    'Ocgde-fa' => 'Tyskland',
    'Ocgde-fag' => 'Västra Tyskland',
    'Ocgde-fah' => 'Östra Tyskland',
    'Ocgde-fb' => 'Österrike och Liechtenstein',
    'Ocgde-fc' => 'Ungern',
    'Ocgde-fd' => 'Tjeckien och Slovakien',
    'Ocgde-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgde-h' => 'Schweiz',
    'Ocgde-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgde-j' => 'Frankrike och Monaco',
    'Ocgde-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgde-m' => 'Östeuropa',
    'Ocgde-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgde-mad' => 'Ukraina',
    'Ocgde-mae' => 'Vitryssland',
    'Ocgde-mb' => 'Polen',
    'Ocgde-mc' => 'Estland, Lettland, Litauen',
    'Ocgde-n' => 'Balkanländerna',
    'Ocgde-na' => 'Rumänien',
    'Ocgde-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ocgde-nc' => 'Bulgarien',
    'Ocgde-nd' => 'Grekland',
    'Ocgde-nf' => 'Albanien',
    'Ocgde-o' => 'Asien',
    'Ocgde-oa' => 'Främre Asien',
    'Ocgde-oac' => 'Kaukasien',
    'Ocgde-oaf' => 'Palestina och Israel',
    'Ocgde-oak' => 'Iran (Persien)',
    'Ocgde-oal' => 'Afghanistan',
    'Ocgde-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ocgde-ob' => 'Främre Indien',
    'Ocgde-oc' => 'Bortre Indien',
    'Ocgde-ocd' => 'Indokina',
    'Ocgde-ocda' => 'Laos',
    'Ocgde-ocdb' => 'Kambodja',
    'Ocgde-ocdc' => 'Vietnam',
    'Ocgde-od' => 'Ostindiska öarna',
    'Ocgde-oe' => 'Östasien',
    'Ocgde-oea' => 'Kina',
    'Ocgde-oeb' => 'Korea',
    'Ocgde-oec' => 'Japan',
    'Ocgde-p' => 'Afrika',
    'Ocgde-pa' => 'Nordafrika utom Egypten',
    'Ocgde-pb' => 'Egypten och Sudan',
    'Ocgde-pc' => 'Västafrika',
    'Ocgde-pe' => 'Södra Afrika',
    'Ocgde-pg' => 'Nordöstafrika',
    'Ocgde-q' => 'Amerika',
    'Ocgde-qa' => 'Förenta staterna',
    'Ocgde-qa:k' => 'Historia',
    'Ocgde-qb' => 'Kanada',
    'Ocgde-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgde-qca' => 'Mexiko',
    'Ocgde-qcd' => 'El Salvador',
    'Ocgde-qce' => 'Nicaragua',
    'Ocgde-qch' => 'Västindien',
    'Ocgde-qcha' => 'Stora Antillerna (Kuba)',
    'Ocgde-qchb' => 'Små Antillerna',
    'Ocgde-qd' => 'Sydamerika',
    'Ocgde-qda' => 'Colombia',
    'Ocgde-qdd' => 'Brasilien',
    'Ocgde-qdg' => 'Argentina',
    'Ocgde-qdh' => 'Chile',
    'Ocgde-qdi' => 'Bolivia',
    'Ocgde-qdk' => 'Peru',
    'Ocgde-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocgdf' => 'Frihetlig socialism',
    'Ocgdf-' => 'Särskilda länder och områden',
    'Ocgdf-a' => 'Europa: allmänt',
    'Ocgdf-b' => 'Norden: allmänt',
    'Ocgdf-c' => 'Sverige',
    'Ocgdf-d' => 'Övriga Norden',
    'Ocgdf-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgdf-f' => 'Mellaneuropa',
    'Ocgdf-fd' => 'Tjeckien och Slovakien',
    'Ocgdf-h' => 'Schweiz',
    'Ocgdf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgdf-j' => 'Frankrike och Monaco',
    'Ocgdf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgdf-l' => 'Portugal',
    'Ocgdf-m' => 'Östeuropa',
    'Ocgdf-o' => 'Asien',
    'Ocgdf-p' => 'Afrika',
    'Ocgdf-q' => 'Amerika',
    'Ocgdf-qa' => 'Förenta staterna',
    'Ocgdf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgdf-qd' => 'Sydamerika',
    'Ocgg' => 'Nazism och fascism',
    'Ocgg-' => 'Särskilda länder och områden',
    'Ocgg-a' => 'Europa: allmänt',
    'Ocgg-ae' => 'Europeiska unionen (EU)',
    'Ocgg-b' => 'Norden: allmänt',
    'Ocgg-c' => 'Sverige',
    'Ocgg-c:k' => 'Historia',
    'Ocgg-d' => 'Övriga Norden',
    'Ocgg-da' => 'Danmark',
    'Ocgg-db' => 'Norge',
    'Ocgg-dc' => 'Island och Färöarna',
    'Ocgg-dd' => 'Finland',
    'Ocgg-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgg-f' => 'Mellaneuropa',
    'Ocgg-fa' => 'Tyskland',
    'Ocgg-fa:bf' => 'Organisationer och institutioner',
    'Ocgg-fa:k' => 'Historia',
    'Ocgg-fag' => 'Västra Tyskland',
    'Ocgg-fah' => 'Östra Tyskland',
    'Ocgg-fb' => 'Österrike och Liechtenstein',
    'Ocgg-fc' => 'Ungern',
    'Ocgg-fd' => 'Tjeckien och Slovakien',
    'Ocgg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgg-h' => 'Schweiz',
    'Ocgg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgg-j' => 'Frankrike och Monaco',
    'Ocgg-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocgg-l' => 'Portugal',
    'Ocgg-m' => 'Östeuropa',
    'Ocgg-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ocgg-mb' => 'Polen',
    'Ocgg-mc' => 'Estland, Lettland, Litauen',
    'Ocgg-n' => 'Balkanländerna',
    'Ocgg-o' => 'Asien',
    'Ocgg-p' => 'Afrika',
    'Ocgg-q' => 'Amerika',
    'Ocgg-qa' => 'Förenta staterna',
    'Ocgg-qd' => 'Sydamerika',
    'Ocgm' => 'Politiska miljö- och alternativrörelser',
    'Ocgm-' => 'Särskilda länder och områden',
    'Ocgm-a' => 'Europa: allmänt',
    'Ocgm-ae' => 'Europeiska unionen (EU)',
    'Ocgm-b' => 'Norden: allmänt',
    'Ocgm-c' => 'Sverige',
    'Ocgm-d' => 'Övriga Norden',
    'Ocgm-e' => 'Brittiska öarna (Storbritannien)',
    'Ocgm-f' => 'Mellaneuropa',
    'Ocgm-fa' => 'Tyskland',
    'Ocgm-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ocgm-h' => 'Schweiz',
    'Ocgm-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocgm-j' => 'Frankrike och Monaco',
    'Ocgm-m' => 'Östeuropa',
    'Ocgm-o' => 'Asien',
    'Ocgm-oa' => 'Främre Asien',
    'Ocgm-ob' => 'Främre Indien',
    'Ocgm-oc' => 'Bortre Indien',
    'Ocgm-od' => 'Ostindiska öarna',
    'Ocgm-oe' => 'Östasien',
    'Ocgm-p' => 'Afrika',
    'Ocgm-q' => 'Amerika',
    'Ocgm-qa' => 'Förenta staterna',
    'Ocgm-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocgm-qd' => 'Sydamerika',
    'Ocgm-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ocl' => 'Utomparlamentariska metoder, konspirativ verksamhet, terrorism m m',
    'Ocla' => 'Utomparlamentariska metoder',
    'Ocla-' => 'Särskilda länder och områden',
    'Ocla-a' => 'Europa: allmänt',
    'Ocla-b' => 'Norden: allmänt',
    'Ocla-c' => 'Sverige',
    'Ocla-cs' => 'Samer',
    'Ocla-d' => 'Övriga Norden',
    'Ocla-e' => 'Brittiska öarna (Storbritannien)',
    'Ocla-f' => 'Mellaneuropa (Tyskland)',
    'Ocla-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ocla-j' => 'Frankrike och Monaco',
    'Ocla-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ocla-m' => 'Östeuropa',
    'Ocla-n' => 'Balkanländerna',
    'Ocla-o' => 'Asien',
    'Ocla-oa' => 'Främre Asien',
    'Ocla-ob' => 'Främre Indien',
    'Ocla-oc' => 'Bortre Indien',
    'Ocla-od' => 'Ostindiska öarna',
    'Ocla-oe' => 'Östasien',
    'Ocla-p' => 'Afrika',
    'Ocla-q' => 'Amerika',
    'Ocla-qa' => 'Förenta staterna',
    'Ocla-qb' => 'Kanada',
    'Ocla-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ocla-qd' => 'Sydamerika',
    'Oclb' => 'Konspirativ verksamhet, terrorism m m',
    'Oclb-' => 'Särskilda länder och områden',
    'Oclb-a' => 'Europa: allmänt',
    'Oclb-b' => 'Norden: allmänt',
    'Oclb-c' => 'Sverige',
    'Oclb-d' => 'Övriga Norden',
    'Oclb-e' => 'Brittiska öarna (Storbritannien och Nordirland)',
    'Oclb-et' => 'Irland',
    'Oclb-f' => 'Mellaneuropa (Tyskland)',
    'Oclb-h' => 'Schweiz',
    'Oclb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oclb-j' => 'Frankrike och Monaco',
    'Oclb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oclb-m' => 'Östeuropa',
    'Oclb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oclb-mb' => 'Polen',
    'Oclb-n' => 'Balkanländerna',
    'Oclb-o' => 'Asien',
    'Oclb-oa' => 'Främre Asien',
    'Oclb-oac' => 'Kaukasien',
    'Oclb-oae' => 'Syrien och Libanon',
    'Oclb-oaf' => 'Palestina och Israel',
    'Oclb-oah' => 'Arabiska halvön',
    'Oclb-oak' => 'Iran (Persien)',
    'Oclb-oal' => 'Afghanistan',
    'Oclb-ob' => 'Främre Indien',
    'Oclb-oc' => 'Bortre Indien',
    'Oclb-od' => 'Ostindiska öarna',
    'Oclb-oe' => 'Östasien',
    'Oclb-oea' => 'Kina',
    'Oclb-oec' => 'Japan',
    'Oclb-of' => 'Centralasien',
    'Oclb-p' => 'Afrika',
    'Oclb-q' => 'Amerika',
    'Oclb-qa' => 'Förenta staterna',
    'Oclb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oclb-qca' => 'Mexiko',
    'Oclb-qcb' => 'Guatemala',
    'Oclb-qcc' => 'Belize och Honduras',
    'Oclb-qcd' => 'El Salvador',
    'Oclb-qce' => 'Nicaragua',
    'Oclb-qcg' => 'Panama',
    'Oclb-qch' => 'Västindien',
    'Oclb-qd' => 'Sydamerika',
    'Oclb-qda' => 'Colombia',
    'Oclb-qdb' => 'Venezuela',
    'Oclb-qdd' => 'Brasilien',
    'Oclb-qde' => 'Paraguay',
    'Oclb-qdf' => 'Uruguay',
    'Oclb-qdg' => 'Argentina',
    'Oclb-qdh' => 'Chile',
    'Oclb-qdk' => 'Peru',
    'Oclb-qdl' => 'Ecuador',
    'Od' => 'Förvaltning',
    'Od(x)' => 'Allmänna förvaltningslexikon',
    'Od:d' => 'Allmän förvaltningseori och metodlära',
    'Od:dd' => 'Metodlära',
    'Od:k' => 'Allmän förvaltningshistoria',
    'Od.0' => 'Allmän central- och lokalförvaltning',
    'Od.01' => 'Centralförvaltning',
    'Od.04' => 'Lokalförvaltning: allmänt',
    'Od.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Od.08' => 'Lokalförvaltning: kommunal: orter',
    'Odb' => 'Förvaltningsrätt',
    'Odb-' => 'Allmänt: särskilda länder och områden',
    'Odb-a' => 'Europa: allmänt',
    'Odb-ae' => 'Europeiska unionen (EU)',
    'Odb-b' => 'Norden: allmänt',
    'Odb-c' => 'Sverige',
    'Odb-c:k' => 'Förvaltningsrättens historia',
    'Odb-d' => 'Övriga Norden',
    'Odb-da' => 'Danmark',
    'Odb-db' => 'Norge',
    'Odb-dc' => 'Island och Färöarna',
    'Odb-dd' => 'Finland',
    'Odb-ddå' => 'Åland',
    'Odb-e' => 'Brittiska öarna (Storbritannien)',
    'Odb-ea' => 'England',
    'Odb-er' => 'Wales',
    'Odb-f' => 'Mellaneuropa',
    'Odb-fa' => 'Tyskland',
    'Odb-fa:k' => 'Förvaltningsrättens historia',
    'Odb-fb' => 'Österrike och Liechtenstein',
    'Odb-fc' => 'Ungern',
    'Odb-fd' => 'Tjeckien och Slovakien',
    'Odb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odb-ga' => 'Nederländerna',
    'Odb-gb' => 'Belgien',
    'Odb-h' => 'Schweiz',
    'Odb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Odb-j' => 'Frankrike och Monaco',
    'Odb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Odb-m' => 'Östeuropa',
    'Odb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Odb-mb' => 'Polen',
    'Odb-mc' => 'Estland, Lettland, Litauen',
    'Odb-n' => 'Balkanländerna',
    'Odb-o' => 'Asien',
    'Odb-oa' => 'Främre Asien',
    'Odb-oaa' => 'Turkiet',
    'Odb-oac' => 'Kaukasien',
    'Odb-oaf' => 'Palestina och Israel',
    'Odb-oah' => 'Arabiska halvön',
    'Odb-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Odb-ob' => 'Främre Indien',
    'Odb-oc' => 'Bortre Indien',
    'Odb-oe' => 'Östasien',
    'Odb-p' => 'Afrika',
    'Odb-q' => 'Amerika',
    'Odb-qa' => 'Förenta staterna',
    'Odb-qb' => 'Kanada',
    'Odb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odb-qd' => 'Sydamerika',
    'Odb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odc' => 'Förvaltning: Sverige',
    'Odc(x)' => 'Förvaltningslexikon',
    'Odc:bf' => 'Förvaltningsinstitutioner',
    'Odc:k' => 'Förvaltningshistoria',
    'Odc:k.3' => 'Medeltiden ca 1060-1520',
    'Odc:k.4' => 'Nya tiden 1520-',
    'Odc:k.5' => '1905-',
    'Odc:k.6' => '2000-',
    'Odc:oe' => 'Förvaltningslagstiftning',
    'Odca' => 'Centralförvaltning',
    'Odca:k' => 'Historia',
    'Odca:oe' => 'Lagstiftning',
    'Odcaz' => 'Särskilda ämbetsverk',
    'Odcb' => 'Länsförvaltning',
    'Odcb:k' => 'Historia',
    'Odcbz' => 'Särskilda län',
    'Odcc' => 'Kommunalförvaltning: allmänt',
    'Odcc:k' => 'Historia',
    'Odcc:oe' => 'Lagstiftning',
    'Odcd' => 'Kommunalförvaltning: landsting',
    'Odcd:k' => 'Historia',
    'Odcdz' => 'Särskilda landsting',
    'Odce' => 'Kommunalförvaltning: kommuner',
    'Odce:k' => 'Historia',
    'Odce:k.3' => 'Medeltiden ca 1060-1520',
    'Odce:k.4' => 'Nya tiden 1520-',
    'Odce:k.5' => '1905-',
    'Odce:k.6' => '2000-',
    'Odcez' => 'Särskilda kommuner',
    'Odf' => 'Främmande länders förvaltning',
    'Odf.0' => 'Central- och lokalförvaltning: allmänt',
    'Odf.01' => 'Centralförvaltning',
    'Odf.04' => 'Lokalförvaltning: allmänt',
    'Odf.05' => 'Lokalförvaltning: statlig',
    'Odf.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-' => 'Särskilda länder och områden',
    'Odf-a' => 'Europa: allmänt',
    'Odf-a:k' => 'Historia',
    'Odf-a.0' => 'Central- och lokalförvaltning',
    'Odf-a.01' => 'Centralförvaltning',
    'Odf-a.04' => 'Lokalförvaltning: allmänt',
    'Odf-a.05' => 'Lokalförvaltning: statlig',
    'Odf-a.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-a.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-a.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-ae' => 'Europeiska unionen (EU)',
    'Odf-ae.0' => 'Central- och lokalförvaltning',
    'Odf-ae.01' => 'Centralförvaltning',
    'Odf-ae.04' => 'Lokalförvaltning: allmänt',
    'Odf-ae.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-ae.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-ae.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-b' => 'Norden: allmänt',
    'Odf-b.0' => 'Central- och lokalförvaltning',
    'Odf-b.01' => 'Centralförvaltning',
    'Odf-b.04' => 'Lokalförvaltning: allmänt',
    'Odf-b.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-b.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-b.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-bc' => 'Nordkalotten',
    'Odf-d' => 'Övriga Norden',
    'Odf-da' => 'Danmark',
    'Odf-da:k' => 'Historia',
    'Odf-da.0' => 'Central- och lokalförvaltning',
    'Odf-da.01' => 'Centralförvaltning',
    'Odf-da.04' => 'Lokalförvaltning: allmänt',
    'Odf-da.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-da.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-da.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-db' => 'Norge',
    'Odf-db:k' => 'Historia',
    'Odf-db.0' => 'Central- och lokalförvaltning',
    'Odf-db.01' => 'Centralförvaltning',
    'Odf-db.04' => 'Lokalförvaltning: allmänt',
    'Odf-db.05' => 'Lokalförvaltning: statlig',
    'Odf-db.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-db.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-db.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-dc' => 'Island och Färöarna',
    'Odf-dcf' => 'Färöarna',
    'Odf-dd' => 'Finland',
    'Odf-dd:k' => 'Historia',
    'Odf-dd.0' => 'Central- och lokalförvaltning',
    'Odf-dd.01' => 'Centralförvaltning',
    'Odf-dd.04' => 'Lokalförvaltning: allmänt',
    'Odf-dd.05' => 'Lokalförvaltning: statlig',
    'Odf-dd.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-dd.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-dd.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-ddå' => 'Åland',
    'Odf-e' => 'Brittiska öarna (Storbritannien)',
    'Odf-e:k' => 'Historia',
    'Odf-e.0' => 'Central- och lokalförvaltning',
    'Odf-e.01' => 'Centralförvaltning',
    'Odf-e.04' => 'Lokalförvaltning: allmänt',
    'Odf-e.05' => 'Lokalförvaltning: statlig',
    'Odf-e.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-e.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-e.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-ea' => 'England',
    'Odf-es' => 'Skottland',
    'Odf-et' => 'Irland',
    'Odf-f' => 'Mellaneuropa',
    'Odf-fa' => 'Tyskland',
    'Odf-fa:k' => 'Historia',
    'Odf-fa.0' => 'Central- och lokalförvaltning',
    'Odf-fa.01' => 'Centralförvaltning',
    'Odf-fa.04' => 'Lokalförvaltning: allmänt',
    'Odf-fa.05' => 'Lokalförvaltning: statlig',
    'Odf-fa.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-fa.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-fa.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-fag' => 'Västra Tyskland',
    'Odf-fah' => 'Östra Tyskland',
    'Odf-fai' => 'Berlin',
    'Odf-fb' => 'Österrike och Liechtenstein',
    'Odf-fc' => 'Ungern',
    'Odf-fd' => 'Tjeckien och Slovakien',
    'Odf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odf-ga' => 'Nederländerna',
    'Odf-gb' => 'Belgien',
    'Odf-gc' => 'Luxemburg',
    'Odf-h' => 'Schweiz',
    'Odf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Odf-j' => 'Frankrike och Monaco',
    'Odf-j:k' => 'Historia',
    'Odf-j.0' => 'Central- och lokalförvaltning',
    'Odf-j.01' => 'Centralförvaltning',
    'Odf-j.04' => 'Lokalförvaltning: allmänt',
    'Odf-j.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-j.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-j.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Odf-l' => 'Portugal',
    'Odf-m' => 'Östeuropa',
    'Odf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Odf-ma:k' => 'Historia',
    'Odf-ma.0' => 'Central- och lokalförvaltning',
    'Odf-ma.01' => 'Centralförvaltning',
    'Odf-ma.04' => 'Lokalförvaltning: allmänt',
    'Odf-ma.05' => 'Lokalförvaltning: statlig',
    'Odf-ma.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-ma.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-ma.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-mb' => 'Polen',
    'Odf-mc' => 'Estland, Lettland, Litauen',
    'Odf-mca' => 'Estland',
    'Odf-mcb' => 'Lettland',
    'Odf-mcc' => 'Litauen',
    'Odf-n' => 'Balkanländerna',
    'Odf-na' => 'Rumänien',
    'Odf-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Odf-nc' => 'Bulgarien',
    'Odf-nd' => 'Grekland',
    'Odf-o' => 'Asien',
    'Odf-oa' => 'Främre Asien',
    'Odf-oaa' => 'Turkiet',
    'Odf-oae' => 'Syrien och Libanon',
    'Odf-oaf' => 'Palestina och Israel',
    'Odf-oafi' => 'Israel',
    'Odf-oah' => 'Arabiska halvön',
    'Odf-oai' => 'Irak',
    'Odf-oal' => 'Afghanistan',
    'Odf-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Odf-ob' => 'Främre Indien',
    'Odf-oba' => 'Indien',
    'Odf-obb' => 'Pakistan och Bangladesh',
    'Odf-oc' => 'Bortre Indien',
    'Odf-ocb' => 'Thailand',
    'Odf-occ' => 'Malaysia, Singapore och Brunei',
    'Odf-ocd' => 'Indokina',
    'Odf-od' => 'Ostindiska öarna',
    'Odf-oda' => 'Indonesien',
    'Odf-odc' => 'Filippinerna',
    'Odf-oe' => 'Östasien',
    'Odf-oea' => 'Kina',
    'Odf-oea:k' => 'Historia',
    'Odf-oeb' => 'Korea',
    'Odf-oec' => 'Japan',
    'Odf-oek' => 'Hongkong och Macau',
    'Odf-p' => 'Afrika',
    'Odf-pa' => 'Nordafrika utom Egypten',
    'Odf-pb' => 'Egypten och Sudan',
    'Odf-pba' => 'Egypten',
    'Odf-pbb' => 'Sudan',
    'Odf-pc' => 'Västafrika',
    'Odf-pcb' => 'Ekvatorialfrika',
    'Odf-pcc' => 'Norra Västafrika',
    'Odf-pcd' => 'Södra Västafrika',
    'Odf-pcda' => 'Ghana',
    'Odf-pcdd' => 'Nigeria',
    'Odf-pd' => 'Centralafrika',
    'Odf-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Odf-pe' => 'Södra Afrika',
    'Odf-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Odf-peb' => 'Botswana',
    'Odf-pec' => 'Zimbabwe, Zambia, Malawi',
    'Odf-peca' => 'Zimbabwe',
    'Odf-pecb' => 'Zambia',
    'Odf-pecc' => 'Malawi',
    'Odf-pee' => 'Madagaskar (Malagasy)',
    'Odf-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Odf-pf' => 'Östafrika',
    'Odf-pfa' => 'Uganda',
    'Odf-pfb' => 'Kenya',
    'Odf-pfc' => 'Tanzania',
    'Odf-pg' => 'Nordöstafrika',
    'Odf-q' => 'Amerika',
    'Odf-qa' => 'Förenta staterna',
    'Odf-qa.0' => 'Central- och lokalförvaltning',
    'Odf-qa.01' => 'Centralförvaltning',
    'Odf-qa.04' => 'Lokalförvaltning: allmänt',
    'Odf-qa.05' => 'Lokalförvaltning: statlig',
    'Odf-qa.06' => 'Lokalförvaltnig: kommunal: allmänt',
    'Odf-qa.07' => 'Lokalförvaltning: kommunal: landsdelar',
    'Odf-qa.08' => 'Lokalförvaltning: kommunal: orter',
    'Odf-qb' => 'Kanada',
    'Odf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odf-qca' => 'Mexiko',
    'Odf-qce' => 'Nicaragua',
    'Odf-qch' => 'Västindien',
    'Odf-qd' => 'Sydamerika',
    'Odf-qda' => 'Colombia',
    'Odf-qdb' => 'Venezuela',
    'Odf-qdd' => 'Brasilien',
    'Odf-qdg' => 'Argentina',
    'Odf-qdh' => 'Chile',
    'Odf-qdi' => 'Bolivia',
    'Odf-qdk' => 'Peru',
    'Odf-qdl' => 'Ecuador',
    'Odf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odf-ra' => 'Australien',
    'Odf-rb' => 'Nya Zeeland',
    'Odf-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Odf-rd' => 'Nya Guinea',
    'Odf-s' => 'Polarländerna',
    'Odg' => 'Samhällsplanering',
    'Odg(x)' => 'Allmänt: lexikon',
    'Odg:bf' => 'Organisationer och institutioner',
    'Odg:d' => 'Samhällsplneringens teori, filosofi och metodlär',
    'Odg:dd' => 'Metodlära',
    'Odg:k' => 'Samhällsplaneringens histori',
    'Odg:oe' => 'Lagstiftning',
    'Odg-' => 'Allmänt: särskilda länder och områden',
    'Odg-a' => 'Europa: allmänt',
    'Odg-ae' => 'Europeiska unionen (EU)',
    'Odg-b' => 'Norden: allmänt',
    'Odg-c' => 'Sverige',
    'Odg-c:bf' => 'Organisationer och institutioner',
    'Odg-c:k' => 'Historia',
    'Odg-c:oe' => 'Lagstiftning',
    'Odg-ca' => 'Svealand',
    'Odg-caa' => 'Stockholm och Stockholms län',
    'Odg-caal' => 'Stockholms län',
    'Odg-cab' => 'Uppland och Uppsala län',
    'Odg-caba' => 'Uppsala län',
    'Odg-cac' => 'Södermanland och Södermanlands län',
    'Odg-cad' => 'Närke och Örebro län',
    'Odg-cae' => 'Västmanland och Västmanlands län',
    'Odg-caf' => 'Dalarna och Dalarnas län',
    'Odg-cag' => 'Värmland och Värmlands län',
    'Odg-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odg-cba' => 'Skåne och Skåne län',
    'Odg-cbb' => 'Halland och Hallands län',
    'Odg-cbc' => 'Blekinge och Blekinge län',
    'Odg-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Odg-cbda' => 'Kronobergs län',
    'Odg-cbdb' => 'Jönköpings län',
    'Odg-cbdc' => 'Kalmar län',
    'Odg-cbe' => 'Öland',
    'Odg-cbf' => 'Gotland och Gotlands län',
    'Odg-cbg' => 'Östergötland och Östergötlands län',
    'Odg-cbh' => 'Västergötland',
    'Odg-cbi' => 'Göteborg',
    'Odg-cbk' => 'Bohuslän',
    'Odg-cbl' => 'Dalsland',
    'Odg-cc' => 'Norrland',
    'Odg-cca' => 'Gästrikland och Gävleborgs län',
    'Odg-ccb' => 'Hälsingland',
    'Odg-ccc' => 'Jämtland och Jämtlands län',
    'Odg-ccd' => 'Härjedalen',
    'Odg-cce' => 'Medelpad',
    'Odg-ccf' => 'Ångermanland och Västernorrlands län',
    'Odg-ccg' => 'Västerbotten och Västerbottens län',
    'Odg-cch' => 'Norrbotten och Norrbottens län',
    'Odg-cci' => 'Lappland',
    'Odg-cs' => 'Samer',
    'Odg-cz' => 'särskilda orter',
    'Odg-d' => 'Övriga Norden',
    'Odg-da' => 'Danmark',
    'Odg-da:oe' => 'Lagstiftning',
    'Odg-db' => 'Norge',
    'Odg-db:oe' => 'Lagstiftning',
    'Odg-dc' => 'Island och Färöarna',
    'Odg-dd' => 'Finland',
    'Odg-e' => 'Brittiska öarna (Storbritannien)',
    'Odg-e:k' => 'Historia',
    'Odg-ea' => 'England',
    'Odg-es' => 'Skottland',
    'Odg-et' => 'Irland',
    'Odg-f' => 'Mellaneuropa',
    'Odg-fa' => 'Tyskland',
    'Odg-fag' => 'Västra Tyskland',
    'Odg-fah' => 'Östra Tyskland',
    'Odg-fb' => 'Österrike och Liechtenstein',
    'Odg-fc' => 'Ungern',
    'Odg-fd' => 'Tjeckien och Slovakien',
    'Odg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odg-ga' => 'Nederländerna',
    'Odg-gb' => 'Belgien',
    'Odg-gc' => 'Luxemburg',
    'Odg-h' => 'Schweiz',
    'Odg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Odg-j' => 'Frankrike och Monaco',
    'Odg-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Odg-l' => 'Portugal',
    'Odg-m' => 'Östeuropa',
    'Odg-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Odg-mb' => 'Polen',
    'Odg-mc' => 'Estland, Lettland, Litauen',
    'Odg-n' => 'Balkanländerna',
    'Odg-o' => 'Asien',
    'Odg-oa' => 'Främre Asien',
    'Odg-oaa' => 'Turkiet',
    'Odg-oab' => 'Cypern',
    'Odg-oae' => 'Syrien och Libanon',
    'Odg-oaf' => 'Palestina och Israel',
    'Odg-oafi' => 'Israel',
    'Odg-oak' => 'Iran (Persien)',
    'Odg-ob' => 'Främre Indien',
    'Odg-oba' => 'Indien',
    'Odg-obb' => 'Pakistan och Bangladesh',
    'Odg-oc' => 'Bortre Indien',
    'Odg-od' => 'Ostindiska öarna',
    'Odg-oe' => 'Östasien',
    'Odg-oea' => 'Kina',
    'Odg-oeb' => 'Korea',
    'Odg-oec' => 'Japan',
    'Odg-oek' => 'Hongkong och Macau',
    'Odg-og' => 'Sibirien',
    'Odg-p' => 'Afrika',
    'Odg-pa' => 'Nordafrika utom Egypten',
    'Odg-paa' => 'Marocko och Kanarieöarna',
    'Odg-pab' => 'Algeriet',
    'Odg-pac' => 'Tunisien',
    'Odg-pad' => 'Libyen',
    'Odg-pb' => 'Egypten och Sudan',
    'Odg-pba' => 'Egypten',
    'Odg-pbb' => 'Sudan',
    'Odg-pc' => 'Västafrika',
    'Odg-pcb' => 'Ekvatorialfrika',
    'Odg-pcc' => 'Norra Västafrika',
    'Odg-pcd' => 'Södra Västafrika',
    'Odg-pd' => 'Centralafrika',
    'Odg-pe' => 'Södra Afrika',
    'Odg-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Odg-peaa' => 'Sydafrikanska republiken',
    'Odg-peab' => 'Namibia',
    'Odg-peac' => 'Lesotho',
    'Odg-peb' => 'Botswana',
    'Odg-pec' => 'Zimbabwe, Zambia, Malawi',
    'Odg-peca' => 'Zimbabwe',
    'Odg-pecb' => 'Zambia',
    'Odg-pecc' => 'Malawi',
    'Odg-ped' => 'Mocambique',
    'Odg-pf' => 'Östafrika',
    'Odg-pfa' => 'Uganda',
    'Odg-pfb' => 'Kenya',
    'Odg-pfc' => 'Tanzania',
    'Odg-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'Odg-pg' => 'Nordöstafrika',
    'Odg-pga' => 'Etiopien med Eritrea',
    'Odg-pgb' => 'Somalia',
    'Odg-q' => 'Amerika',
    'Odg-qa' => 'Förenta staterna',
    'Odg-qb' => 'Kanada',
    'Odg-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odg-qd' => 'Sydamerika',
    'Odg-qda' => 'Colombia',
    'Odg-qdb' => 'Venezuela',
    'Odg-qdd' => 'Brasilien',
    'Odg-qdh' => 'Chile',
    'Odg-qdi' => 'Bolivia',
    'Odg-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odg-ra' => 'Australien',
    'Odg-rb' => 'Nya Zeeland',
    'Odg-s' => 'Polarländerna',
    'Odgb' => 'Riksplanering',
    'Odgb-b' => 'Norden: allmänt',
    'Odgb-c' => 'Sverige',
    'Odgb-d' => 'Övriga Norden',
    'Odgb-o' => 'Asien',
    'Odgb-q' => 'Amerika',
    'Odgc' => 'Regionplanering',
    'Odgc-' => 'Allmänt: särskilda länder och områden',
    'Odgc-a' => 'Europa: allmänt',
    'Odgc-ae' => 'Europeiska unionen (EU)',
    'Odgc-b' => 'Norden: allmänt',
    'Odgc-bc' => 'Nordkalotten',
    'Odgc-c' => 'Sverige',
    'Odgc-ca' => 'Svealand',
    'Odgc-caa' => 'Stockholm och Stockholms län',
    'Odgc-caal' => 'Stockholms län',
    'Odgc-cab' => 'Uppland och Uppsala län',
    'Odgc-cac' => 'Södermanland och Södermanlands län',
    'Odgc-caf' => 'Dalarna och Dalarnas län',
    'Odgc-cag' => 'Värmland och Värmlands län',
    'Odgc-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgc-cba' => 'Skåne och Skåne län',
    'Odgc-cbb' => 'Halland och Hallands län',
    'Odgc-cbc' => 'Blekinge och Blekinge län',
    'Odgc-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Odgc-cbf' => 'Gotland och Gotlands län',
    'Odgc-cbg' => 'Östergötland och Östergötlands län',
    'Odgc-cbh' => 'Västergötland',
    'Odgc-cbk' => 'Bohuslän',
    'Odgc-cc' => 'Norrland',
    'Odgc-cca' => 'Gästrikland och Gävleborgs län',
    'Odgc-ccc' => 'Jämtland och Jämtlands län',
    'Odgc-ccf' => 'Ångermanland och Västernorrlands län',
    'Odgc-ccg' => 'Västerbotten och Västerbottens län',
    'Odgc-cch' => 'Norrbotten och Norrbottens län',
    'Odgc-cci' => 'Lappland',
    'Odgc-cz' => 'Särskild orter',
    'Odgc-d' => 'Övriga Norden',
    'Odgc-da' => 'Danmark',
    'Odgc-db' => 'Norge',
    'Odgc-dd' => 'Finland',
    'Odgc-e' => 'Brittiska öarna (Storbritannien)',
    'Odgc-ea' => 'England',
    'Odgc-er' => 'Wales',
    'Odgc-es' => 'Skottland',
    'Odgc-et' => 'Irland',
    'Odgc-f' => 'Mellaneuropa',
    'Odgc-fa' => 'Tyskland',
    'Odgc-fb' => 'Österrike och Liechtenstein',
    'Odgc-fc' => 'Ungern',
    'Odgc-fd' => 'Tjeckien och Slovakien',
    'Odgc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odgc-ga' => 'Nederländerna',
    'Odgc-gb' => 'Belgien',
    'Odgc-gc' => 'Luxemburg',
    'Odgc-h' => 'Schweiz',
    'Odgc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Odgc-j' => 'Frankrike och Monaco',
    'Odgc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Odgc-l' => 'Portugal',
    'Odgc-m' => 'Östeuropa',
    'Odgc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Odgc-mb' => 'Polen',
    'Odgc-mc' => 'Estland, Lettland, Litauen',
    'Odgc-n' => 'Balkanländerna',
    'Odgc-o' => 'Asien',
    'Odgc-oa' => 'Främre Asien',
    'Odgc-ob' => 'Främre Indien',
    'Odgc-oc' => 'Bortre Indien',
    'Odgc-oe' => 'Östasien',
    'Odgc-p' => 'Afrika',
    'Odgc-q' => 'Amerika',
    'Odgc-qa' => 'Förenta staterna',
    'Odgc-qb' => 'Kanada',
    'Odgc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odgc-qd' => 'Sydamerika',
    'Odgc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odgd' => 'Kommunal planering',
    'Odgd:k' => 'Historia',
    'Odgd-' => 'Allmänt: särskilda länder och områden',
    'Odgd-a' => 'Europa: allmänt',
    'Odgd-a:k' => 'Historia',
    'Odgd-ae' => 'Europeiska unionen (EU)',
    'Odgd-b' => 'Norden: allmänt',
    'Odgd-c' => 'Sverige',
    'Odgd-c:bf' => 'Organisationer och institutioner',
    'Odgd-c:k' => 'Historia',
    'Odgd-c:oe' => 'Lagstiftning',
    'Odgd-ca' => 'Svealand',
    'Odgd-caa' => 'Stockholm och Stockholms län',
    'Odgd-caal' => 'Stockholms län',
    'Odgd-cab' => 'Uppland och Uppsala län',
    'Odgd-cac' => 'Södermanland och Södermanlands län',
    'Odgd-cad' => 'Närke och Örebro län',
    'Odgd-cag' => 'Värmland och Värmlands län',
    'Odgd-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgd-cba' => 'Skåne och Skåne län',
    'Odgd-cbb' => 'Halland och Hallands län',
    'Odgd-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Odgd-cbda' => 'Kronobergs län',
    'Odgd-cbdb' => 'Jönköpings län',
    'Odgd-cbdc' => 'Kalmar län',
    'Odgd-cbf' => 'Gotland och Gotlands län',
    'Odgd-cbg' => 'Östergötland och Östergötlands län',
    'Odgd-cbh' => 'Västergötland',
    'Odgd-cbi' => 'Göteborg',
    'Odgd-cbk' => 'Bohuslän',
    'Odgd-cc' => 'Norrland',
    'Odgd-cca' => 'Gästrikland och Gävleborgs län',
    'Odgd-ccb' => 'Hälsingland',
    'Odgd-ccc' => 'Jämtland och Jämtlands län',
    'Odgd-ccg' => 'Västerbotten och Västerbottens län',
    'Odgd-cch' => 'Norrbotten och Norrbottens län',
    'Odgd-cz' => 'särskilda orter',
    'Odgd-d' => 'Övriga Norden',
    'Odgd-da' => 'Danmark',
    'Odgd-db' => 'Norge',
    'Odgd-dc' => 'Island och Färöarna',
    'Odgd-dd' => 'Finland',
    'Odgd-e' => 'Brittiska öarna (Storbritannien)',
    'Odgd-e:k' => 'Historia',
    'Odgd-ea' => 'England',
    'Odgd-er' => 'Wales',
    'Odgd-es' => 'Skottland',
    'Odgd-et' => 'Irland',
    'Odgd-f' => 'Mellaneuropa',
    'Odgd-fa' => 'Tyskland',
    'Odgd-fa:k' => 'Historia',
    'Odgd-fag' => 'Västra Tyskland',
    'Odgd-fah' => 'Östra Tyskland',
    'Odgd-fai' => 'Berlin',
    'Odgd-fb' => 'Österrike och Liechtenstein',
    'Odgd-fc' => 'Ungern',
    'Odgd-fd' => 'Tjeckien och Slovakien',
    'Odgd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odgd-h' => 'Schweiz',
    'Odgd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Odgd-j' => 'Frankrike och Monaco',
    'Odgd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Odgd-m' => 'Östeuropa',
    'Odgd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Odgd-mb' => 'Polen',
    'Odgd-mc' => 'Estland, Lettland, Litauen',
    'Odgd-n' => 'Balkanländerna',
    'Odgd-o' => 'Asien',
    'Odgd-oa' => 'Främre Asien',
    'Odgd-ob' => 'Främre Indien',
    'Odgd-oc' => 'Bortre Indien',
    'Odgd-od' => 'Ostindiska öarna',
    'Odgd-oe' => 'Östasien',
    'Odgd-oea' => 'Kina',
    'Odgd-oec' => 'Japan',
    'Odgd-oek' => 'Hongkong och Macau',
    'Odgd-p' => 'Afrika',
    'Odgd-pa' => 'Nordafrika utom Egypten',
    'Odgd-pb' => 'Egypten och Sudan',
    'Odgd-pc' => 'Västafrika',
    'Odgd-pe' => 'Södra Afrika',
    'Odgd-pf' => 'Östafrika',
    'Odgd-pg' => 'Nordöstafrika',
    'Odgd-q' => 'Amerika',
    'Odgd-qa' => 'Förenta staterna',
    'Odgd-qa:k' => 'Historia',
    'Odgd-qb' => 'Kanada',
    'Odgd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odgd-qd' => 'Sydamerika',
    'Odgd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odgl' => 'Planering för bostäder',
    'Odgl-' => 'Allmänt: särskilda länder och områden',
    'Odgl-a' => 'Europa: allmänt',
    'Odgl-b' => 'Norden: allmänt',
    'Odgl-c' => 'Sverige',
    'Odgl-c:k' => 'Historia',
    'Odgl-ca' => 'Svealand',
    'Odgl-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgl-cc' => 'Norrland',
    'Odgl-cz' => 'särskilda orter',
    'Odgl-d' => 'Övriga Norden',
    'Odgl-da' => 'Danmark',
    'Odgl-db' => 'Norge',
    'Odgl-dd' => 'Finland',
    'Odgl-e' => 'Brittiska öarna (Storbritannien)',
    'Odgl-e:k' => 'Historia',
    'Odgl-f' => 'Mellaneuropa',
    'Odgl-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odgl-j' => 'Frankrike och Monaco',
    'Odgl-m' => 'Östeuropa',
    'Odgl-n' => 'Balkanländerna',
    'Odgl-o' => 'Asien',
    'Odgl-p' => 'Afrika',
    'Odgl-q' => 'Amerika',
    'Odgl-qa' => 'Förenta staterna',
    'Odgl-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odgl-qd' => 'Sydamerika',
    'Odgm' => 'Planering för rekreation, lek, fritid och kultur',
    'Odgm-' => 'Allmänt: särskilda länder och områden',
    'Odgm-a' => 'Europa: allmänt',
    'Odgm-b' => 'Norden: allmänt',
    'Odgm-c' => 'Sverige',
    'Odgm-ca' => 'Svealand',
    'Odgm-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgm-cc' => 'Norrland',
    'Odgm-cz' => 'särskilda orter',
    'Odgm-d' => 'Övriga Norden',
    'Odgm-da' => 'Danmark',
    'Odgm-db' => 'Norge',
    'Odgm-dd' => 'Finland',
    'Odgm-e' => 'Brittiska öarna (Storbritannien)',
    'Odgm-f' => 'Mellaneuropa',
    'Odgm-j' => 'Frankrike och Monaco',
    'Odgm-p' => 'Afrika',
    'Odgm-q' => 'Amerika',
    'Odgm-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Odgp' => 'Planering för handel, industri och arbetsplatser',
    'Odgp-' => 'Allmänt: särskilda länder och områden',
    'Odgp-a' => 'Europa: allmänt',
    'Odgp-ae' => 'Europeiska unionen (EU)',
    'Odgp-b' => 'Norden: allmänt',
    'Odgp-c' => 'Sverige',
    'Odgp-ca' => 'Svealand',
    'Odgp-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgp-cc' => 'Norrland',
    'Odgp-cz' => 'särskilda orter',
    'Odgp-d' => 'Övriga Norden',
    'Odgp-da' => 'Danmark',
    'Odgp-db' => 'Norge',
    'Odgp-dd' => 'Finland',
    'Odgp-e' => 'Brittiska öarna (Storbritannien)',
    'Odgp-f' => 'Mellaneuropa',
    'Odgp-m' => 'Östeuropa',
    'Odgp-o' => 'Asien',
    'Odgp-p' => 'Afrika',
    'Odgp-q' => 'Amerika',
    'Odgq' => 'Planering för kommunikationer och transporter',
    'Odgq-' => 'Allmänt: särskilda länder och områden',
    'Odgq-a' => 'Europa: allmänt',
    'Odgq-ae' => 'Europeiska unionen (EU)',
    'Odgq-b' => 'Norden: allmänt',
    'Odgq-c' => 'Sverige',
    'Odgq-c:k' => 'Historia',
    'Odgq-ca' => 'Svealand',
    'Odgq-caa' => 'Stockholm och Stockholms län',
    'Odgq-caal' => 'Stockholms län',
    'Odgq-cab' => 'Uppland och Uppsala län',
    'Odgq-cae' => 'Västmanland och Västmanlands län',
    'Odgq-caf' => 'Dalarna och Dalarnas län',
    'Odgq-cag' => 'Värmland och Värmlands län',
    'Odgq-cb' => 'Götaland (inkl Västra Götalands län)',
    'Odgq-cba' => 'Skåne och Skåne län',
    'Odgq-cbb' => 'Halland och Hallands län',
    'Odgq-cbc' => 'Blekinge och Blekinge län',
    'Odgq-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Odgq-cbf' => 'Gotland och Gotlands län',
    'Odgq-cbg' => 'Östergötland och Östergötlands län',
    'Odgq-cbh' => 'Västergötland',
    'Odgq-cbi' => 'Göteborg',
    'Odgq-cbk' => 'Bohuslän',
    'Odgq-cc' => 'Norrland',
    'Odgq-cz' => 'särskilda orter',
    'Odgq-d' => 'Övriga Norden',
    'Odgq-da' => 'Danmark',
    'Odgq-db' => 'Norge',
    'Odgq-e' => 'Brittiska öarna (Storbritannien)',
    'Odgq-f' => 'Mellaneuropa',
    'Odgq-fa' => 'Tyskland',
    'Odgq-fb' => 'Österrike och Liechtenstein',
    'Odgq-g' => 'Nederländerna, Belgien och Luxemburg',
    'Odgq-j' => 'Frankrike och Monaco',
    'Odgq-m' => 'Östeuropa',
    'Odgq-o' => 'Asien',
    'Odgq-p' => 'Afrika',
    'Odgq-q' => 'Amerika',
    'Odgq-qa' => 'Förenta staterna',
    'Odgq-qc' => 'Mexiko, Centralamerika och Västindien',
    'Odgq-qd' => 'Sydamerika',
    'Odgq-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oe' => 'Rättsvetenskap',
    'Oe(x)' => 'Juridiska lexikon',
    'Oe(u)' => 'Lagar och lagförslag: allmänt',
    'Oe:d' => 'Rättsfilosofi och rättsvetenskaplig metodlära',
    'Oe:dd' => 'Metodlära',
    'Oe:oa' => 'Rättssociologi',
    'Oe-' => 'Juridik: särskilda länder och områden',
    'Oe-a' => 'Europa: allmänt',
    'Oe-ae' => 'Europeiska unionen (EU)',
    'Oe-b' => 'Norden: allmänt',
    'Oe-c' => 'Sverige',
    'Oe-c(x)' => 'Juridiska lexikon',
    'Oe-c(u)' => 'Lagar och lagförslag',
    'Oe-c:bf' => 'Juridiska organisationer och institutioner',
    'Oe-cs' => 'Samer',
    'Oe-d' => 'Övriga Norden',
    'Oe-da' => 'Danmark',
    'Oe-da(u)' => 'Lagar och lagförslag',
    'Oe-db' => 'Norge',
    'Oe-db(u)' => 'Lagar och lagförslag',
    'Oe-dc' => 'Island och Färöarna',
    'Oe-dc(u)' => 'Lagar och lagförslag',
    'Oe-dcf' => 'Färöarna',
    'Oe-dd' => 'Finland',
    'Oe-dd(u)' => 'Lagar och lagförslag',
    'Oe-ddå' => 'Åland',
    'Oe-e' => 'Brittiska öarna (Storbritannien)',
    'Oe-e(u)' => 'Lagar och lagförslag',
    'Oe-ea' => 'England',
    'Oe-er' => 'Wales',
    'Oe-es' => 'Skottland',
    'Oe-et' => 'Irland',
    'Oe-f' => 'Mellaneuropa',
    'Oe-fa' => 'Tyskland',
    'Oe-fa(u)' => 'Lagar och lagförslag',
    'Oe-fa:bf' => 'Juridiska organisationer och institutioner',
    'Oe-fag' => 'Västra Tyskland',
    'Oe-fah' => 'Östra Tyskland',
    'Oe-fb' => 'Österrike och Liechtenstein',
    'Oe-fb(u)' => 'Lagar och lagförslag',
    'Oe-fc' => 'Ungern',
    'Oe-fd' => 'Tjeckien och Slovakien',
    'Oe-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oe-ga' => 'Nederländerna',
    'Oe-gb' => 'Belgien',
    'Oe-gb(u)' => 'Lagar och lagförslag',
    'Oe-h' => 'Schweiz',
    'Oe-h(u)' => 'Lagar och lagförslag',
    'Oe-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oe-j' => 'Frankrike och Monaco',
    'Oe-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oe-k(u)' => 'Lagar och lagförslag',
    'Oe-l' => 'Portugal',
    'Oe-m' => 'Östeuropa',
    'Oe-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oe-ma(u)' => 'Lagar och lagförslag',
    'Oe-mb' => 'Polen',
    'Oe-mc' => 'Estland, Lettland, Litauen',
    'Oe-mca' => 'Estland',
    'Oe-mcb' => 'Lettland',
    'Oe-mcc' => 'Litauen',
    'Oe-n' => 'Balkanländerna',
    'Oe-na' => 'Rumänien',
    'Oe-na(u)' => 'Lagar och lagförslag',
    'Oe-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oe-nc' => 'Bulgarien',
    'Oe-nd' => 'Grekland',
    'Oe-nf' => 'Albanien',
    'Oe-o' => 'Asien',
    'Oe-oa' => 'Främre Asien',
    'Oe-oaa' => 'Turkiet',
    'Oe-oac' => 'Kaukasien',
    'Oe-oae' => 'Syrien och Libanon',
    'Oe-oaf' => 'Palestina och Israel',
    'Oe-oafh' => 'Judar',
    'Oe-oafi' => 'Israel',
    'Oe-oah' => 'Arabiska halvön',
    'Oe-oak' => 'Iran (Persien)',
    'Oe-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oe-ob' => 'Främre Indien',
    'Oe-oba' => 'Indien',
    'Oe-obb' => 'Pakistan och Bangladesh',
    'Oe-oc' => 'Bortre Indien',
    'Oe-ocb' => 'Thailand',
    'Oe-occ' => 'Malaysia, Singapore och Brunei',
    'Oe-ocd' => 'Indokina',
    'Oe-od' => 'Ostindiska öarna',
    'Oe-oe' => 'Östasien',
    'Oe-oea' => 'Kina',
    'Oe-oea(u)' => 'Lagar och lagförslag',
    'Oe-oeb' => 'Korea',
    'Oe-oec' => 'Japan',
    'Oe-oek' => 'Hongkong och Macau',
    'Oe-p' => 'Afrika',
    'Oe-pa' => 'Nordafrika utom Egypten',
    'Oe-paa' => 'Marocko och Kanarieöarna',
    'Oe-pab' => 'Algeriet',
    'Oe-pad' => 'Libyen',
    'Oe-pb' => 'Egypten och Sudan',
    'Oe-pba' => 'Egypten',
    'Oe-pbb' => 'Sudan',
    'Oe-pc' => 'Västafrika',
    'Oe-pcb' => 'Ekvatorialfrika',
    'Oe-pcc' => 'Norra Västafrika',
    'Oe-pcd' => 'Södra Västafrika',
    'Oe-pcda' => 'Ghana',
    'Oe-pcdd' => 'Nigeria',
    'Oe-pd' => 'Centralafrika',
    'Oe-pe' => 'Södra Afrika',
    'Oe-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oe-peaa' => 'Sydafrikanska republiken',
    'Oe-peac' => 'Lesotho',
    'Oe-pead' => 'Swaziland',
    'Oe-peb' => 'Botswana',
    'Oe-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oe-ped' => 'Mocambique',
    'Oe-pee' => 'Madagaskar (Malagasy)',
    'Oe-pf' => 'Östafrika',
    'Oe-pfa' => 'Uganda',
    'Oe-pfb' => 'Kenya',
    'Oe-pfc' => 'Tanzania',
    'Oe-pg' => 'Nordöstafrika',
    'Oe-q' => 'Amerika',
    'Oe-qa' => 'Förenta staterna',
    'Oe-qa(u)' => 'Lagar och lagförslag',
    'Oe-qat' => 'Indianer i Nordamerika',
    'Oe-qb' => 'Kanada',
    'Oe-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oe-qca' => 'Mexiko',
    'Oe-qcb' => 'Guatemala',
    'Oe-qcd' => 'El Salvador',
    'Oe-qce' => 'Nicaragua',
    'Oe-qcf' => 'Costa Rica',
    'Oe-qcg' => 'Panama',
    'Oe-qch' => 'Västindien',
    'Oe-qd' => 'Sydamerika',
    'Oe-qda' => 'Colombia',
    'Oe-qdb' => 'Venezuela',
    'Oe-qdd' => 'Brasilien',
    'Oe-qde' => 'Paraguay',
    'Oe-qdf' => 'Uruguay',
    'Oe-qdg' => 'Argentina',
    'Oe-qdh' => 'Chile',
    'Oe-qdk' => 'Peru',
    'Oe-qdl' => 'Ecuador',
    'Oe-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oe-ra' => 'Australien',
    'Oe-ra(u)' => 'Lagar och lagförslag',
    'Oe-rb' => 'Nya Zeeland',
    'Oe-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oe-rd' => 'Nya Guinea',
    'Oe-s' => 'Polarländerna',
    'Oe-sa' => 'Arktis (Nordpolsområdet)',
    'Oe-sb' => 'Antarktis',
    'Oea' => 'Civilrätt',
    'Oea-' => 'Särskilda länder och områden',
    'Oea-a' => 'Europa: allmänt',
    'Oea-ae' => 'Europeiska unionen (EU)',
    'Oea-b' => 'Norden: allmänt',
    'Oea-c' => 'Sverige',
    'Oea-c(u)' => 'Lagar och lagförslag',
    'Oea-cs' => 'Samer',
    'Oea-d' => 'Övriga Norden',
    'Oea-da' => 'Danmark',
    'Oea-db' => 'Norge',
    'Oea-dd' => 'Finland',
    'Oea-e' => 'Brittiska öarna (Storbritannien)',
    'Oea-ea' => 'England',
    'Oea-es' => 'Skottland',
    'Oea-f' => 'Mellaneuropa',
    'Oea-fa' => 'Tyskland',
    'Oea-fa(u)' => 'Lagar och lagförslag',
    'Oea-fag' => 'Västra Tyskland',
    'Oea-fag(u)' => 'Lagar och lagförslag',
    'Oea-fah' => 'Östra Tyskland',
    'Oea-fb' => 'Österrike och Liechtenstein',
    'Oea-fc' => 'Ungern',
    'Oea-fd' => 'Tjeckien och Slovakien',
    'Oea-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oea-ga' => 'Nederländerna',
    'Oea-gb' => 'Belgien',
    'Oea-h' => 'Schweiz',
    'Oea-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oea-j' => 'Frankrike och Monaco',
    'Oea-j(u)' => 'Lagar och lagförslag',
    'Oea-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oea-l' => 'Portugal',
    'Oea-m' => 'Östeuropa',
    'Oea-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oea-ma(u)' => 'Lagar och lagförslag',
    'Oea-mb' => 'Polen',
    'Oea-mc' => 'Estland, Lettland, Litauen',
    'Oea-mca' => 'Estland',
    'Oea-mcb' => 'Lettland',
    'Oea-mcc' => 'Litauen',
    'Oea-n' => 'Balkanländerna',
    'Oea-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oea-nc' => 'Bulgarien',
    'Oea-nd' => 'Grekland',
    'Oea-o' => 'Asien',
    'Oea-oa' => 'Främre Asien',
    'Oea-ob' => 'Främre Indien',
    'Oea-oc' => 'Bortre Indien',
    'Oea-ocb' => 'Thailand',
    'Oea-occ' => 'Malaysia, Singapore och Brunei',
    'Oea-ocd' => 'Indokina',
    'Oea-od' => 'Ostindiska öarna',
    'Oea-oe' => 'Östasien',
    'Oea-oea' => 'Kina',
    'Oea-oeb' => 'Korea',
    'Oea-oec' => 'Japan',
    'Oea-p' => 'Afrika',
    'Oea-pb' => 'Egypten och Sudan',
    'Oea-pc' => 'Västafrika',
    'Oea-pd' => 'Centralafrika',
    'Oea-pe' => 'Södra Afrika',
    'Oea-pg' => 'Nordöstafrika',
    'Oea-q' => 'Amerika',
    'Oea-qa' => 'Förenta staterna',
    'Oea-qb' => 'Kanada',
    'Oea-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oea-qd' => 'Sydamerika',
    'Oea-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaa' => 'Allmän förmögenhetsrätt',
    'Oeaa-' => 'Särskilda länder och områden',
    'Oeaa-a' => 'Europa: allmänt',
    'Oeaa-ae' => 'Europeiska unionen (EU)',
    'Oeaa-b' => 'Norden: allmänt',
    'Oeaa-c' => 'Sverige',
    'Oeaa-c(u)' => 'Lagar och lagförslag',
    'Oeaa-d' => 'Övriga Norden',
    'Oeaa-da' => 'Danmark',
    'Oeaa-db' => 'Norge',
    'Oeaa-dd' => 'Finland',
    'Oeaa-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaa-ea' => 'England',
    'Oeaa-er' => 'Wales',
    'Oeaa-f' => 'Mellaneuropa',
    'Oeaa-fa' => 'Tyskland',
    'Oeaa-fag' => 'Västra Tyskland',
    'Oeaa-fah' => 'Östra Tyskland',
    'Oeaa-fb' => 'Österrike och Liechtenstein',
    'Oeaa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaa-h' => 'Schweiz',
    'Oeaa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaa-j' => 'Frankrike och Monaco',
    'Oeaa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeaa-m' => 'Östeuropa',
    'Oeaa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeaa-mb' => 'Polen',
    'Oeaa-n' => 'Balkanländerna',
    'Oeaa-o' => 'Asien',
    'Oeaa-p' => 'Afrika',
    'Oeaa-q' => 'Amerika',
    'Oeaa-qa' => 'Förenta staterna',
    'Oeaa-qb' => 'Kanada',
    'Oeaa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeaa-qd' => 'Sydamerika',
    'Oeaa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaaa' => 'Allmän avtalsrätt',
    'Oeaaa-' => 'Särskilda länder och områden',
    'Oeaaa-a' => 'Europa: allmänt',
    'Oeaaa-ae' => 'Europeiska unionen (EU)',
    'Oeaaa-b' => 'Norden: allmänt',
    'Oeaaa-c' => 'Sverige',
    'Oeaaa-c(u)' => 'Lagar och lagförslag',
    'Oeaaa-d' => 'Övriga Norden',
    'Oeaaa-da' => 'Danmark',
    'Oeaaa-db' => 'Norge',
    'Oeaaa-dd' => 'Finland',
    'Oeaaa-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaaa-f' => 'Mellaneuropa',
    'Oeaaa-fa' => 'Tyskland',
    'Oeaaa-fc' => 'Ungern',
    'Oeaaa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaaa-h' => 'Schweiz',
    'Oeaaa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaaa-j' => 'Frankrike och Monaco',
    'Oeaaa-m' => 'Östeuropa',
    'Oeaaa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeaaa-n' => 'Balkanländerna',
    'Oeaaa-o' => 'Asien',
    'Oeaaa-q' => 'Amerika',
    'Oeaaa-qa' => 'Förenta staterna',
    'Oeaaa-qa(u)' => 'Lagar och lagförslag',
    'Oeaaa-qat' => 'Indianer i Nordamerika',
    'Oeaaa-qb' => 'Kanada',
    'Oeaaa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaac' => 'Uppdrag',
    'Oeaac-a' => 'Europa: allmänt',
    'Oeaac-c' => 'Sverige',
    'Oeaac-d' => 'Övriga Norden',
    'Oeaad' => 'Kommission och förmedling',
    'Oeaad-' => 'Särskilda länder och områden',
    'Oeaad-a' => 'Europa: allmänt',
    'Oeaad-ae' => 'Europeiska unionen (EU)',
    'Oeaad-b' => 'Norden: allmänt',
    'Oeaad-c' => 'Sverige',
    'Oeaad-d' => 'Övriga Norden',
    'Oeaad-da' => 'Danmark',
    'Oeaad-db' => 'Norge',
    'Oeaad-dd' => 'Finland',
    'Oeaad-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaad-f' => 'Mellaneuropa',
    'Oeaad-fa' => 'Tyskland',
    'Oeaad-fc' => 'Ungern',
    'Oeaad-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaad-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaad-j' => 'Frankrike och Monaco',
    'Oeaad-m' => 'Östeuropa',
    'Oeaad-n' => 'Balkanländerna',
    'Oeaad-o' => 'Asien',
    'Oeaad-oa' => 'Främre Asien',
    'Oeaad-oaa' => 'Turkiet',
    'Oeaad-oae' => 'Syrien och Libanon',
    'Oeaad-oag' => 'Jordanien',
    'Oeaad-oah' => 'Arabiska halvön',
    'Oeaad-oe' => 'Östasien',
    'Oeaad-p' => 'Afrika',
    'Oeaad-q' => 'Amerika',
    'Oeaae' => 'Marknads- och konsumenträtt',
    'Oeaae-' => 'Särskilda länder och områden',
    'Oeaae-a' => 'Europa: allmänt',
    'Oeaae-ae' => 'Europeiska unionen (EU)',
    'Oeaae-b' => 'Norden: allmänt',
    'Oeaae-c' => 'Sverige',
    'Oeaae-c(u)' => 'Lagar och lagförslag',
    'Oeaae-c:bf' => 'Organisationer och institutioner',
    'Oeaae-d' => 'Övriga Norden',
    'Oeaae-da' => 'Danmark',
    'Oeaae-db' => 'Norge',
    'Oeaae-dd' => 'Finland',
    'Oeaae-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaae-f' => 'Mellaneuropa',
    'Oeaae-fa' => 'Tyskland',
    'Oeaae-fb' => 'Österrike och Liechtenstein',
    'Oeaae-fc' => 'Ungern',
    'Oeaae-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaae-h' => 'Schweiz',
    'Oeaae-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaae-j' => 'Frankrike och Monaco',
    'Oeaae-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeaae-l' => 'Portugal',
    'Oeaae-m' => 'Östeuropa',
    'Oeaae-n' => 'Balkanländerna',
    'Oeaae-o' => 'Asien',
    'Oeaae-oa' => 'Främre Asien',
    'Oeaae-oc' => 'Bortre Indien',
    'Oeaae-oe' => 'Östasien',
    'Oeaae-p' => 'Afrika',
    'Oeaae-q' => 'Amerika',
    'Oeaae-qa' => 'Förenta staterna',
    'Oeaae-qb' => 'Kanada',
    'Oeaae-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeaae-qd' => 'Sydamerika',
    'Oeaae-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaas' => 'Skadestånd',
    'Oeaas-' => 'Särskilda länder och områden',
    'Oeaas-a' => 'Europa: allmänt',
    'Oeaas-ae' => 'Europeiska unionen (EU)',
    'Oeaas-b' => 'Norden: allmänt',
    'Oeaas-c' => 'Sverige',
    'Oeaas-c(u)' => 'Lagar och lagförslag',
    'Oeaas-d' => 'Övriga Norden',
    'Oeaas-da' => 'Danmark',
    'Oeaas-db' => 'Norge',
    'Oeaas-dc' => 'Island och Färöarna',
    'Oeaas-dd' => 'Finland',
    'Oeaas-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaas-f' => 'Mellaneuropa',
    'Oeaas-fa' => 'Tyskland',
    'Oeaas-fb' => 'Österrike och Liechtenstein',
    'Oeaas-h' => 'Schweiz',
    'Oeaas-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaas-j' => 'Frankrike och Monaco',
    'Oeaas-m' => 'Östeuropa',
    'Oeaas-o' => 'Asien',
    'Oeaas-oa' => 'Främre Asien',
    'Oeaas-oe' => 'Östasien',
    'Oeaas-p' => 'Afrika',
    'Oeaas-q' => 'Amerika',
    'Oeaas-qa' => 'Förenta staterna',
    'Oeaas-qb' => 'Kanada',
    'Oeaas-qd' => 'Sydamerika',
    'Oeaas-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeab' => 'Förmögenhetsrätt: fast egendom',
    'Oeab-' => 'Särskilda länder och områden',
    'Oeab-a' => 'Europa: allmänt',
    'Oeab-b' => 'Norden: allmänt',
    'Oeab-c' => 'Sverige',
    'Oeab-c(u)' => 'Lagar och lagförslag',
    'Oeab-ca' => 'Svealand',
    'Oeab-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oeab-cc' => 'Norrland',
    'Oeab-cs' => 'Samer',
    'Oeab-d' => 'Övriga Norden',
    'Oeab-da' => 'Danmark',
    'Oeab-da(u)' => 'Lagar och lagförslag',
    'Oeab-db' => 'Norge',
    'Oeab-db(u)' => 'Lagar och lagförslag',
    'Oeab-dc' => 'Island och Färöarna',
    'Oeab-dd' => 'Finland',
    'Oeab-e' => 'Brittiska öarna (Storbritannien)',
    'Oeab-f' => 'Mellaneuropa',
    'Oeab-fa' => 'Tyskland',
    'Oeab-fag' => 'Västra Tyskland',
    'Oeab-fah' => 'Östra Tyskland',
    'Oeab-fb' => 'Österrike och Liechtenstein',
    'Oeab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeab-h' => 'Schweiz',
    'Oeab-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeab-j' => 'Frankrike och Monaco',
    'Oeab-m' => 'Östeuropa',
    'Oeab-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeab-mb' => 'Polen',
    'Oeab-mc' => 'Estland, Lettland, Litauen',
    'Oeab-n' => 'Balkanländerna',
    'Oeab-o' => 'Asien',
    'Oeab-oa' => 'Främre Asien',
    'Oeab-ob' => 'Främre Indien',
    'Oeab-oe' => 'Östasien',
    'Oeab-p' => 'Afrika',
    'Oeab-pc' => 'Västafrika',
    'Oeab-pe' => 'Södra Afrika',
    'Oeab-pf' => 'Östafrika',
    'Oeab-pg' => 'Nordöstafrika',
    'Oeab-q' => 'Amerika',
    'Oeab-qa' => 'Förenta staterna',
    'Oeab-qd' => 'Sydamerika',
    'Oeab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaba' => 'Fastighetsförvärv',
    'Oeaba-c' => 'Sverige',
    'Oeaba-c(u)' => 'Lagar och lagförslag',
    'Oeaba-d' => 'Övriga Norden',
    'Oeaba-da' => 'Danmark',
    'Oeaba-db' => 'Norge',
    'Oeaba-dd' => 'Finland',
    'Oeaba-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaba-f' => 'Mellaneuropa',
    'Oeaba-j' => 'Frankrike och Monaco',
    'Oeaba-q' => 'Amerika',
    'Oeabb' => 'Nyttjanderätt: fast egendom',
    'Oeabb-b' => 'Norden: allmänt',
    'Oeabb-c' => 'Sverige',
    'Oeabb-c(u)' => 'Lagar och lagförslag',
    'Oeabb-cs' => 'Samer',
    'Oeabb-d' => 'Övriga Norden',
    'Oeabb-da' => 'Danmark',
    'Oeabb-db' => 'Norge',
    'Oeabb-dd' => 'Finland',
    'Oeabb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeabb-f' => 'Mellaneuropa',
    'Oeabb-m' => 'Östeuropa',
    'Oeabd' => 'Fastighetsbildning',
    'Oeabd-c' => 'Sverige',
    'Oeabd-c(u)' => 'Lagar och lagförslag',
    'Oeabd-d' => 'Övriga Norden',
    'Oeabd-da' => 'Danmark',
    'Oeabd-db' => 'Norge',
    'Oeabd-dd' => 'Finland',
    'Oeabd-f' => 'Mellaneuropa',
    'Oeabe' => 'Sakrätt: fast egendom',
    'Oeabe-c' => 'Sverige',
    'Oeabe-d' => 'Övriga Norden',
    'Oeabe-da' => 'Danmark',
    'Oeabe-db' => 'Norge',
    'Oeabe-dd' => 'Finland',
    'Oeabe-e' => 'Brittiska öarna (Storbritannien)',
    'Oeabe-f' => 'Mellaneuropa',
    'Oeabe-q' => 'Amerika',
    'Oeac' => 'Förmögenhetsrätt: lös egendom',
    'Oeac-' => 'Särskilda länder och områden',
    'Oeac-a' => 'Europa: allmänt',
    'Oeac-ae' => 'Europeiska unionen (EU)',
    'Oeac-b' => 'Norden: allmänt',
    'Oeac-c' => 'Sverige',
    'Oeac-c(u)' => 'Lagar och lagförslag',
    'Oeac-d' => 'Övriga Norden',
    'Oeac-da' => 'Danmark',
    'Oeac-db' => 'Norge',
    'Oeac-dd' => 'Finland',
    'Oeac-e' => 'Brittiska öarna (Storbritannien)',
    'Oeac-f' => 'Mellaneuropa',
    'Oeac-fa' => 'Tyskland',
    'Oeac-fb' => 'Österrike och Liechtenstein',
    'Oeac-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeac-h' => 'Schweiz',
    'Oeac-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeac-j' => 'Frankrike och Monaco',
    'Oeac-m' => 'Östeuropa',
    'Oeac-n' => 'Balkanländerna',
    'Oeac-q' => 'Amerika',
    'Oeac-qa' => 'Förenta staterna',
    'Oeac-qb' => 'Kanada',
    'Oeaca' => 'Köp, byte, gåva',
    'Oeaca-' => 'Särskilda länder och områden',
    'Oeaca-a' => 'Europa: allmänt',
    'Oeaca-b' => 'Norden: allmänt',
    'Oeaca-c' => 'Sverige',
    'Oeaca-c(u)' => 'Lagar och lagförslag',
    'Oeaca-d' => 'Övriga Norden',
    'Oeaca-da' => 'Danmark',
    'Oeaca-db' => 'Norge',
    'Oeaca-dd' => 'Finland',
    'Oeaca-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaca-f' => 'Mellaneuropa',
    'Oeaca-h' => 'Schweiz',
    'Oeaca-j' => 'Frankrike och Monaco',
    'Oeaca-q' => 'Amerika',
    'Oeacb' => 'Nyttjanderätt: lös egendom',
    'Oeacb-c' => 'Sverige',
    'Oeacb-d' => 'Övriga Norden',
    'Oeacb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeacb-f' => 'Mellaneuropa',
    'Oeacb-h' => 'Schweiz',
    'Oeacc' => 'Värdepapper och enkla fordringar',
    'Oeacc-' => 'Särskilda länder och områden',
    'Oeacc-a' => 'Europa: allmänt',
    'Oeacc-b' => 'Norden: allmänt',
    'Oeacc-c' => 'Sverige',
    'Oeacc-c(u)' => 'Lagar och lagförslag',
    'Oeacc-d' => 'Övriga Norden',
    'Oeacc-da' => 'Danmark',
    'Oeacc-db' => 'Norge',
    'Oeacc-dd' => 'Finland',
    'Oeacc-e' => 'Brittiska öarna (Storbritannien)',
    'Oeacc-f' => 'Mellaneuropa',
    'Oeacc-fa' => 'Tyskland',
    'Oeacc-fb' => 'Österrike och Liechtenstein',
    'Oeacc-h' => 'Schweiz',
    'Oeacc-j' => 'Frankrike och Monaco',
    'Oeacc-m' => 'Östeuropa',
    'Oeacc-o' => 'Asien',
    'Oeacc-q' => 'Amerika',
    'Oeace' => 'Sakrätt: lös egendom',
    'Oeace-a' => 'Europa: allmänt',
    'Oeace-c' => 'Sverige',
    'Oeace-d' => 'Övriga Norden',
    'Oeace-da' => 'Danmark',
    'Oeace-db' => 'Norge',
    'Oeace-dd' => 'Finland',
    'Oeace-e' => 'Brittiska öarna (Storbritannien)',
    'Oeace-f' => 'Mellaneuropa',
    'Oeace-q' => 'Amerika',
    'Oead' => 'Förmögenhetsrätt: handelsrätt',
    'Oead(u)' => 'Lagar och förordningar',
    'Oead-' => 'Särskilda länder och områden',
    'Oead-a' => 'Europa: allmänt',
    'Oead-ae' => 'Europeiska unionen (EU)',
    'Oead-b' => 'Norden: allmänt',
    'Oead-c' => 'Sverige',
    'Oead-c(u)' => 'Lagar och lagförslag',
    'Oead-d' => 'Övriga Norden',
    'Oead-da' => 'Danmark',
    'Oead-da(u)' => 'Lagar och lagförslag',
    'Oead-db' => 'Norge',
    'Oead-db(u)' => 'Lagar och lagförslag',
    'Oead-dd' => 'Finland',
    'Oead-dd(u)' => 'Lagar och lagförslag',
    'Oead-e' => 'Brittiska öarna (Storbritannien)',
    'Oead-ea' => 'England',
    'Oead-er' => 'Wales',
    'Oead-es' => 'Skottland',
    'Oead-et' => 'Irland',
    'Oead-f' => 'Mellaneuropa',
    'Oead-fa' => 'Tyskland',
    'Oead-fa(u)' => 'Lagar och lagförslag',
    'Oead-fag' => 'Västra Tyskland',
    'Oead-fah' => 'Östra Tyskland',
    'Oead-fb' => 'Österrike och Liechtenstein',
    'Oead-fc' => 'Ungern',
    'Oead-fd' => 'Tjeckien och Slovakien',
    'Oead-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oead-ga' => 'Nederländerna',
    'Oead-gb' => 'Belgien',
    'Oead-gc' => 'Luxemburg',
    'Oead-h' => 'Schweiz',
    'Oead-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oead-j' => 'Frankrike och Monaco',
    'Oead-j(u)' => 'Lagar och lagförslag',
    'Oead-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oead-l' => 'Portugal',
    'Oead-m' => 'Östeuropa',
    'Oead-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oead-mb' => 'Polen',
    'Oead-mc' => 'Estland, Lettland, Litauen',
    'Oead-n' => 'Balkanländerna',
    'Oead-na' => 'Rumänien',
    'Oead-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oead-nc' => 'Bulgarien',
    'Oead-nd' => 'Grekland',
    'Oead-nf' => 'Albanien',
    'Oead-o' => 'Asien',
    'Oead-oa' => 'Främre Asien',
    'Oead-oaa' => 'Turkiet',
    'Oead-oae' => 'Syrien och Libanon',
    'Oead-oaf' => 'Palestina och Israel',
    'Oead-oah' => 'Arabiska halvön',
    'Oead-oak' => 'Iran (Persien)',
    'Oead-ob' => 'Främre Indien',
    'Oead-oc' => 'Bortre Indien',
    'Oead-od' => 'Ostindiska öarna',
    'Oead-oe' => 'Östasien',
    'Oead-oea' => 'Kina',
    'Oead-oeaf' => 'Taiwan',
    'Oead-oeb' => 'Korea',
    'Oead-oec' => 'Japan',
    'Oead-oek' => 'Hongkong och Macau',
    'Oead-p' => 'Afrika',
    'Oead-pa' => 'Nordafrika utom Egypten',
    'Oead-pb' => 'Egypten och Sudan',
    'Oead-pc' => 'Västafrika',
    'Oead-pd' => 'Centralafrika',
    'Oead-pe' => 'Södra Afrika',
    'Oead-q' => 'Amerika',
    'Oead-qa' => 'Förenta staterna',
    'Oead-qa(u)' => 'Lagar och lagförslag',
    'Oead-qb' => 'Kanada',
    'Oead-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oead-qd' => 'Sydamerika',
    'Oead-qda' => 'Colombia',
    'Oead-qdb' => 'Venezuela',
    'Oead-qdd' => 'Brasilien',
    'Oead-qdg' => 'Argentina',
    'Oead-qdh' => 'Chile',
    'Oead-qdl' => 'Ecuador',
    'Oead-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oead-ra' => 'Australien',
    'Oead-rb' => 'Nya Zeeland',
    'Oeada' => 'Associationsrätt',
    'Oeada-' => 'Särskilda länder och områden',
    'Oeada-a' => 'Europa: allmänt',
    'Oeada-ae' => 'Europeiska unionen (EU)',
    'Oeada-b' => 'Norden: allmänt',
    'Oeada-c' => 'Sverige',
    'Oeada-c(u)' => 'Lagar och lagförslag',
    'Oeada-d' => 'Övriga Norden',
    'Oeada-da' => 'Danmark',
    'Oeada-db' => 'Norge',
    'Oeada-dd' => 'Finland',
    'Oeada-e' => 'Brittiska öarna (Storbritannien)',
    'Oeada-ea' => 'England',
    'Oeada-es' => 'Skottland',
    'Oeada-et' => 'Irland',
    'Oeada-f' => 'Mellaneuropa',
    'Oeada-fa' => 'Tyskland',
    'Oeada-fb' => 'Österrike och Liechtenstein',
    'Oeada-fc' => 'Ungern',
    'Oeada-fd' => 'Tjeckien och Slovakien',
    'Oeada-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeada-ga' => 'Nederländerna',
    'Oeada-gb' => 'Belgien',
    'Oeada-gc' => 'Luxemburg',
    'Oeada-h' => 'Schweiz',
    'Oeada-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeada-j' => 'Frankrike och Monaco',
    'Oeada-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeada-m' => 'Östeuropa',
    'Oeada-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeada-mb' => 'Polen',
    'Oeada-mc' => 'Estland, Lettland, Litauen',
    'Oeada-mca' => 'Estland',
    'Oeada-mcb' => 'Lettland',
    'Oeada-mcc' => 'Litauen',
    'Oeada-n' => 'Balkanländerna',
    'Oeada-na' => 'Rumänien',
    'Oeada-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oeada-nc' => 'Bulgarien',
    'Oeada-nd' => 'Grekland',
    'Oeada-nf' => 'Albanien',
    'Oeada-o' => 'Asien',
    'Oeada-oa' => 'Främre Asien',
    'Oeada-oaa' => 'Turkiet',
    'Oeada-oab' => 'Cypern',
    'Oeada-oac' => 'Kaukasien',
    'Oeada-oae' => 'Syrien och Libanon',
    'Oeada-oaf' => 'Palestina och Israel',
    'Oeada-oag' => 'Jordanien',
    'Oeada-oah' => 'Arabiska halvön',
    'Oeada-oai' => 'Irak',
    'Oeada-oak' => 'Iran (Persien)',
    'Oeada-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oeada-ob' => 'Främre Indien',
    'Oeada-oc' => 'Bortre Indien',
    'Oeada-ocb' => 'Thailand',
    'Oeada-occ' => 'Malaysia, Singapore och Brunei',
    'Oeada-ocd' => 'Indokina',
    'Oeada-od' => 'Ostindiska öarna',
    'Oeada-oe' => 'Östasien',
    'Oeada-oea' => 'Kina',
    'Oeada-oeb' => 'Korea',
    'Oeada-oec' => 'Japan',
    'Oeada-oek' => 'Hongkong och Macau',
    'Oeada-of' => 'Centralasien',
    'Oeada-p' => 'Afrika',
    'Oeada-pa' => 'Nordafrika utom Egypten',
    'Oeada-paa' => 'Marocko och Kanarieöarna',
    'Oeada-pac' => 'Tunisien',
    'Oeada-pad' => 'Libyen',
    'Oeada-pb' => 'Egypten och Sudan',
    'Oeada-pba' => 'Egypten',
    'Oeada-pbb' => 'Sudan',
    'Oeada-pc' => 'Västafrika',
    'Oeada-pe' => 'Södra Afrika',
    'Oeada-pf' => 'Östafrika',
    'Oeada-q' => 'Amerika',
    'Oeada-qa' => 'Förenta staterna',
    'Oeada-qb' => 'Kanada',
    'Oeada-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeada-qd' => 'Sydamerika',
    'Oeada-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeadb' => 'Transporträtt',
    'Oeadb-' => 'Särskilda länder och områden',
    'Oeadb-a' => 'Europa: allmänt',
    'Oeadb-ae' => 'Europeiska unionen (EU)',
    'Oeadb-b' => 'Norden: allmänt',
    'Oeadb-c' => 'Sverige',
    'Oeadb-c(u)' => 'Lagar och lagförslag',
    'Oeadb-d' => 'Övriga Norden',
    'Oeadb-da' => 'Danmark',
    'Oeadb-db' => 'Norge',
    'Oeadb-dd' => 'Finland',
    'Oeadb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeadb-f' => 'Mellaneuropa',
    'Oeadb-fa' => 'Tyskland',
    'Oeadb-fag' => 'Västra Tyskland',
    'Oeadb-fah' => 'Östra Tyskland',
    'Oeadb-fb' => 'Österrike och Liechtenstein',
    'Oeadb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeadb-ga' => 'Nederländerna',
    'Oeadb-gb' => 'Belgien',
    'Oeadb-h' => 'Schweiz',
    'Oeadb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeadb-j' => 'Frankrike och Monaco',
    'Oeadb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeadb-m' => 'Östeuropa',
    'Oeadb-n' => 'Balkanländerna',
    'Oeadb-o' => 'Asien',
    'Oeadb-p' => 'Afrika',
    'Oeadb-q' => 'Amerika',
    'Oeadb-qa' => 'Förenta staterna',
    'Oeadb-qb' => 'Kanada',
    'Oeadb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeadb-qd' => 'Sydamerika',
    'Oeadb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeae' => 'Förmögenhetsrätt: immaterialrätt',
    'Oeae(u)' => 'Lagar och lagförslag',
    'Oeae-' => 'Särskilda länder och områden',
    'Oeae-a' => 'Europa: allmänt',
    'Oeae-ae' => 'Europeiska unionen (EU)',
    'Oeae-b' => 'Norden: allmänt',
    'Oeae-c' => 'Sverige',
    'Oeae-c(u)' => 'Lagar och lagförslag',
    'Oeae-d' => 'Övriga Norden',
    'Oeae-da' => 'Danmark',
    'Oeae-db' => 'Norge',
    'Oeae-dd' => 'Finland',
    'Oeae-e' => 'Brittiska öarna (Storbritannien)',
    'Oeae-f' => 'Mellaneuropa',
    'Oeae-fa' => 'Tyskland',
    'Oeae-fag' => 'Västra Tyskland',
    'Oeae-fah' => 'Östra Tyskland',
    'Oeae-fb' => 'Österrike och Liechtenstein',
    'Oeae-fc' => 'Ungern',
    'Oeae-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeae-h' => 'Schweiz',
    'Oeae-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeae-j' => 'Frankrike och Monaco',
    'Oeae-m' => 'Östeuropa',
    'Oeae-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeae-mb' => 'Polen',
    'Oeae-n' => 'Balkanländerna',
    'Oeae-o' => 'Asien',
    'Oeae-p' => 'Afrika',
    'Oeae-q' => 'Amerika',
    'Oeae-qa' => 'Förenta staterna',
    'Oeae-qa(u)' => 'Lagar och lagförslag',
    'Oeae-qb' => 'Kanada',
    'Oeae-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaea' => 'Upphovsrätt',
    'Oeaea-' => 'Särskilda länder och områden',
    'Oeaea-a' => 'Europa: allmänt',
    'Oeaea-ae' => 'Europeiska unionen (EU)',
    'Oeaea-b' => 'Norden: allmänt',
    'Oeaea-c' => 'Sverige',
    'Oeaea-c(u)' => 'Lagar och lagförslag',
    'Oeaea-d' => 'Övriga Norden',
    'Oeaea-da' => 'Danmark',
    'Oeaea-db' => 'Norge',
    'Oeaea-dd' => 'Finland',
    'Oeaea-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaea-f' => 'Mellaneuropa',
    'Oeaea-fa' => 'Tyskland',
    'Oeaea-fag' => 'Västra Tyskland',
    'Oeaea-fah' => 'Östra Tyskland',
    'Oeaea-fb' => 'Österrike och Liechtenstein',
    'Oeaea-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaea-h' => 'Schweiz',
    'Oeaea-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaea-j' => 'Frankrike och Monaco',
    'Oeaea-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeaea-m' => 'Östeuropa',
    'Oeaea-o' => 'Asien',
    'Oeaea-p' => 'Afrika',
    'Oeaea-q' => 'Amerika',
    'Oeaea-qa' => 'Förenta staterna',
    'Oeaea-qb' => 'Kanada',
    'Oeaea-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaeb' => 'Patenträtt',
    'Oeaeb-' => 'Särskilda länder och områden',
    'Oeaeb-a' => 'Europa: allmänt',
    'Oeaeb-ae' => 'Europeiska unionen (EU)',
    'Oeaeb-b' => 'Norden: allmänt',
    'Oeaeb-c' => 'Sverige',
    'Oeaeb-c(u)' => 'Lagar och lagförslag',
    'Oeaeb-d' => 'Övriga Norden',
    'Oeaeb-da' => 'Danmark',
    'Oeaeb-db' => 'Norge',
    'Oeaeb-dd' => 'Finland',
    'Oeaeb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaeb-ea' => 'England',
    'Oeaeb-er' => 'Wales',
    'Oeaeb-es' => 'Skottland',
    'Oeaeb-et' => 'Irland',
    'Oeaeb-f' => 'Mellaneuropa',
    'Oeaeb-fa' => 'Tyskland',
    'Oeaeb-fag' => 'Västra Tyskland',
    'Oeaeb-fah' => 'Östra Tyskland',
    'Oeaeb-fb' => 'Österrike och Liechtenstein',
    'Oeaeb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaeb-h' => 'Schweiz',
    'Oeaeb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaeb-j' => 'Frankrike och Monaco',
    'Oeaeb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeaeb-m' => 'Östeuropa',
    'Oeaeb-n' => 'Balkanländerna',
    'Oeaeb-o' => 'Asien',
    'Oeaeb-oa' => 'Främre Asien',
    'Oeaeb-od' => 'Ostindiska öarna',
    'Oeaeb-oe' => 'Östasien',
    'Oeaeb-p' => 'Afrika',
    'Oeaeb-q' => 'Amerika',
    'Oeaeb-qa' => 'Förenta staterna',
    'Oeaeb-qd' => 'Sydamerika',
    'Oeaeb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeaec' => 'Namnrätt',
    'Oeaec-c' => 'Sverige',
    'Oeaec-d' => 'Övriga Norden',
    'Oeaecd-f' => 'Mellaneuropa',
    'Oeala-' => 'Särskilda länder och områden',
    'Oeala-a' => 'Europa: allmänt',
    'Oeala-ae' => 'Europeiska unionen (EU)',
    'Oeala-b' => 'Norden: allmänt',
    'Oeala-c' => 'Sverige',
    'Oeala-d' => 'Övriga Norden',
    'Oeala-da' => 'Danmark',
    'Oeala-db' => 'Norge',
    'Oeala-dd' => 'Finland',
    'Oeala-e' => 'Brittiska öarna (Storbritannien)',
    'Oeala-f' => 'Mellaneuropa',
    'Oeala-fa' => 'Tyskland',
    'Oeala-fb' => 'Österrike och Liechtenstein',
    'Oeala-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeala-h' => 'Schweiz',
    'Oeala-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeala-j' => 'Frankrike och Monaco',
    'Oeala-m' => 'Östeuropa',
    'Oeala-n' => 'Balkanländerna',
    'Oeala-o' => 'Asien',
    'Oeala-p' => 'Afrika',
    'Oeala-q' => 'Amerika',
    'Oeala-qa' => 'Förenta staterna',
    'Oeala-qb' => 'Kanada',
    'Oeala-qd' => 'Sydamerika',
    'Oeala-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeala-s' => 'Polarländerna',
    'Oeak' => 'Familje- och arvsrätt',
    'Oeak-' => 'Särskilda länder och områden',
    'Oeak-a' => 'Europa: allmänt',
    'Oeak-b' => 'Norden: allmänt',
    'Oeak-c' => 'Sverige',
    'Oeak-c(u)' => 'Lagar och lagförslag',
    'Oeak-d' => 'Övriga Norden',
    'Oeak-da' => 'Danmark',
    'Oeak-db' => 'Norge',
    'Oeak-dd' => 'Finland',
    'Oeak-e' => 'Brittiska öarna (Storbritannien)',
    'Oeak-f' => 'Mellaneuropa',
    'Oeak-fa' => 'Tyskland',
    'Oeak-fb' => 'Österrike och Liechtenstein',
    'Oeak-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeak-h' => 'Schweiz',
    'Oeak-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeak-j' => 'Frankrike och Monaco',
    'Oeak-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeak-m' => 'Östeuropa',
    'Oeak-n' => 'Balkanländerna',
    'Oeak-o' => 'Asien',
    'Oeak-oa' => 'Främre Asien',
    'Oeak-ob' => 'Främre Indien',
    'Oeak-oe' => 'Östasien',
    'Oeak-p' => 'Afrika',
    'Oeak-pa' => 'Nordafrika utom Egypten',
    'Oeak-pb' => 'Egypten och Sudan',
    'Oeak-pc' => 'Västafrika',
    'Oeak-pe' => 'Södra Afrika',
    'Oeak-pf' => 'Östafrika',
    'Oeak-q' => 'Amerika',
    'Oeak-qa' => 'Förenta staterna',
    'Oeak-qb' => 'Kanada',
    'Oeak-qd' => 'Sydamerika',
    'Oeak-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeak-s' => 'Polarländerna (Grönland)',
    'Oeaka' => 'Äktenskaps- och föräldrarätt',
    'Oeaka-' => 'Särskilda länder och områden',
    'Oeaka-a' => 'Europa: allmänt',
    'Oeaka-ae' => 'Europeiska unionen (EU)',
    'Oeaka-b' => 'Norden: allmänt',
    'Oeaka-c' => 'Sverige',
    'Oeaka-c(u)' => 'Lagar och lagförslag',
    'Oeaka-d' => 'Övriga Norden',
    'Oeaka-da' => 'Danmark',
    'Oeaka-db' => 'Norge',
    'Oeaka-dd' => 'Finland',
    'Oeaka-e' => 'Brittiska öarna (Storbritannien)',
    'Oeaka-f' => 'Mellaneuropa',
    'Oeaka-fa' => 'Tyskland',
    'Oeaka-fag' => 'Västra Tyskland',
    'Oeaka-fah' => 'Östra Tyskland',
    'Oeaka-fb' => 'Österrike och Liechtenstein',
    'Oeaka-fd' => 'Tjeckien och Slovakien',
    'Oeaka-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeaka-h' => 'Schweiz',
    'Oeaka-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeaka-j' => 'Frankrike och Monaco',
    'Oeaka-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeaka-m' => 'Östeuropa',
    'Oeaka-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeaka-mb' => 'Polen',
    'Oeaka-n' => 'Balkanländerna',
    'Oeaka-o' => 'Asien',
    'Oeaka-oa' => 'Främre Asien',
    'Oeaka-ob' => 'Främre Indien',
    'Oeaka-oc' => 'Bortre Indien',
    'Oeaka-p' => 'Afrika',
    'Oeaka-q' => 'Amerika',
    'Oeaka-qa' => 'Förenta staterna',
    'Oeaka-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeaka-qd' => 'Sydamerika',
    'Oeakaa' => 'Äktenskapsrätt',
    'Oeakaa-' => 'Särskilda länder och områden',
    'Oeakaa-a' => 'Europa: allmänt',
    'Oeakaa-b' => 'Norden: allmänt',
    'Oeakaa-c' => 'Sverige',
    'Oeakaa-c(u)' => 'Lagar och lagförslag',
    'Oeakaa-d' => 'Övriga Norden',
    'Oeakaa-da' => 'Danmark',
    'Oeakaa-db' => 'Norge',
    'Oeakaa-dd' => 'Finland',
    'Oeakaa-e' => 'Brittiska öarna (Storbritannien)',
    'Oeakaa-f' => 'Mellaneuropa',
    'Oeakaa-fa' => 'Tyskland',
    'Oeakaa-h' => 'Schweiz',
    'Oeakaa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeakaa-j' => 'Frankrike och Monaco',
    'Oeakaa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeakaa-m' => 'Östeuropa',
    'Oeakaa-o' => 'Asien',
    'Oeakaa-oa' => 'Främre Asien',
    'Oeakaa-oc' => 'Bortre Indien',
    'Oeakaa-p' => 'Afrika',
    'Oeakaa-q' => 'Amerika',
    'Oeakaa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeakab' => 'Föräldrar och barn. Förmynderskap',
    'Oeakab-' => 'Särskilda länder och områden',
    'Oeakab-a' => 'Europa: allmänt',
    'Oeakab-b' => 'Norden: allmänt',
    'Oeakab-c' => 'Sverige',
    'Oeakab-c(u)' => 'Lagar och lagförslag',
    'Oeakab-d' => 'Övriga Norden',
    'Oeakab-da' => 'Danmark',
    'Oeakab-db' => 'Norge',
    'Oeakab-dd' => 'Finland',
    'Oeakab-e' => 'Brittiska öarna (Storbritannien)',
    'Oeakab-f' => 'Mellaneuropa',
    'Oeakab-fa' => 'Tyskland',
    'Oeakab-fb' => 'Österrike och Liechtenstein',
    'Oeakab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeakab-h' => 'Schweiz',
    'Oeakab-j' => 'Frankrike och Monaco',
    'Oeakab-m' => 'Östeuropa',
    'Oeakab-n' => 'Balkanländerna',
    'Oeakab-o' => 'Asien',
    'Oeakab-p' => 'Afrika',
    'Oeakab-q' => 'Amerika',
    'Oeakab-qa' => 'Förenta staterna',
    'Oeakab-qb' => 'Kanada',
    'Oeakab-qd' => 'Sydamerika',
    'Oeakb' => 'Arvs- och testamentsrätt',
    'Oeakb-' => 'Särskilda länder och områden',
    'Oeakb-a' => 'Europa: allmänt',
    'Oeakb-b' => 'Norden: allmänt',
    'Oeakb-c' => 'Sverige',
    'Oeakb-c(u)' => 'Lagar och lagförslag',
    'Oeakb-cs' => 'Samer',
    'Oeakb-d' => 'Övriga Norden',
    'Oeakb-da' => 'Danmark',
    'Oeakb-db' => 'Norge',
    'Oeakb-dd' => 'Finland',
    'Oeakb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeakb-f' => 'Mellaneuropa',
    'Oeakb-fa' => 'Tyskland',
    'Oeakb-fag' => 'Västra Tyskland',
    'Oeakb-fah' => 'Östra Tyskland',
    'Oeakb-fb' => 'Österrike och Liechtenstein',
    'Oeakb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeakb-h' => 'Schweiz',
    'Oeakb-j' => 'Frankrike och Monaco',
    'Oeakb-m' => 'Östeuropa',
    'Oeakb-o' => 'Asien',
    'Oeakb-p' => 'Afrika',
    'Oeakb-q' => 'Amerika',
    'Oeal' => 'Internationell rätt',
    'Oeal(u)' => 'Lagar och lagförslag',
    'Oeal-' => 'Särskilda länder och områden',
    'Oeal-a' => 'Europa: allmänt',
    'Oeal-c' => 'Sverige',
    'Oeal-d' => 'Övriga Norden',
    'Oeal-e' => 'Brittiska öarna (Storbritannien)',
    'Oeal-f' => 'Mellaneuropa',
    'Oeal-fa' => 'Tyskland',
    'Oeal-fag' => 'Västra Tyskland',
    'Oeal-fah' => 'Östra Tyskland',
    'Oeal-fb' => 'Österrike och Liechtenstein',
    'Oeal-fc' => 'Ungern',
    'Oeal-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeal-h' => 'Schweiz',
    'Oeal-j' => 'Frankrike och Monaco',
    'Oeal-m' => 'Östeuropa',
    'Oeal-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeal-mb' => 'Polen',
    'Oeal-o' => 'Asien',
    'Oeal-p' => 'Afrika',
    'Oeal-q' => 'Amerika',
    'Oeala' => 'Internationell privat-, straff- och processrätt',
    'Oeale' => 'Europarätt (EG-rätt)',
    'Oeale(u)' => 'Lagar och lagförslag',
    'Oeam' => 'Romersk rätt',
    'Oeam(x)' => 'Lexikon',
    'Oeam(u)' => 'Lagar och lagförslag',
    'Oeao' => 'Forngermansk rätt',
    'Oeao(u)' => 'Lagar och lagförslag',
    'Oeb' => 'Straffrätt',
    'Oeb-' => 'Särskilda länder och områden',
    'Oeb-a' => 'Europa: allmänt',
    'Oeb-a(u)' => 'Lagar och lagförslag',
    'Oeb-ae' => 'Europeiska unionen (EU)',
    'Oeb-b' => 'Norden: allmänt',
    'Oeb-c' => 'Sverige',
    'Oeb-c(u)' => 'Lagar och lagförslag',
    'Oeb-cs' => 'Samer',
    'Oeb-d' => 'Övriga Norden',
    'Oeb-da' => 'Danmark',
    'Oeb-da(u)' => 'Lagar och lagförslag',
    'Oeb-db' => 'Norge',
    'Oeb-db(u)' => 'Lagar och lagförslag',
    'Oeb-dc' => 'Island och Färöarna',
    'Oeb-dd' => 'Finland',
    'Oeb-dd(u)' => 'Lagar och lagförslag',
    'Oeb-e' => 'Brittiska öarna (Storbritannien)',
    'Oeb-ea' => 'England',
    'Oeb-er' => 'Wales',
    'Oeb-es' => 'Skottland',
    'Oeb-et' => 'Irland',
    'Oeb-f' => 'Mellaneuropa',
    'Oeb-fa' => 'Tyskland',
    'Oeb-fa(u)' => 'Lagar och lagförslag',
    'Oeb-fag' => 'Västra Tyskland',
    'Oeb-fag(u)' => 'Lagar och lagförslag',
    'Oeb-fah' => 'Östra Tyskland',
    'Oeb-fb' => 'Österrike och Liechtenstein',
    'Oeb-fc' => 'Ungern',
    'Oeb-fd' => 'Tjeckien och Slovakien',
    'Oeb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeb-ga' => 'Nederländerna',
    'Oeb-gb' => 'Belgien',
    'Oeb-h' => 'Schweiz',
    'Oeb-h(u)' => 'Lagar och lagförslag',
    'Oeb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeb-j' => 'Frankrike och Monaco',
    'Oeb-j(u)' => 'Lagar och lagförslag',
    'Oeb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeb-l' => 'Portugal',
    'Oeb-m' => 'Östeuropa',
    'Oeb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeb-ma(u)' => 'Lagar och lagförslag',
    'Oeb-mb' => 'Polen',
    'Oeb-mc' => 'Estland, Lettland, Litauen',
    'Oeb-n' => 'Balkanländerna',
    'Oeb-na' => 'Rumänien',
    'Oeb-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oeb-nc' => 'Bulgarien',
    'Oeb-nd' => 'Grekland',
    'Oeb-nf' => 'Albanien',
    'Oeb-o' => 'Asien',
    'Oeb-oa' => 'Främre Asien',
    'Oeb-oaa' => 'Turkiet',
    'Oeb-oaf' => 'Palestina och Israel',
    'Oeb-oak' => 'Iran (Persien)',
    'Oeb-ob' => 'Främre Indien',
    'Oeb-oc' => 'Bortre Indien',
    'Oeb-ocb' => 'Thailand',
    'Oeb-occ' => 'Malaysia, Singapore och Brunei',
    'Oeb-ocd' => 'Indokina',
    'Oeb-oe' => 'Östasien',
    'Oeb-oea' => 'Kina',
    'Oeb-oeb' => 'Korea',
    'Oeb-oec' => 'Japan',
    'Oeb-oek' => 'Hongkong och Macau',
    'Oeb-p' => 'Afrika',
    'Oeb-pc' => 'Västafrika',
    'Oeb-pe' => 'Södra Afrika',
    'Oeb-pf' => 'Östafrika',
    'Oeb-pg' => 'Nordöstafrika',
    'Oeb-q' => 'Amerika',
    'Oeb-qa' => 'Förenta staterna',
    'Oeb-qa(u)' => 'Lagar och lagförslag',
    'Oeb-qb' => 'Kanada',
    'Oeb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeb-qd' => 'Sydamerika',
    'Oeb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeb-s' => 'Polarländerna (Grönland)',
    'Oek' => 'Processrätt',
    'Oek-' => 'Särskilda länder och områden',
    'Oek-a' => 'Europa: allmänt',
    'Oek-ae' => 'Europeiska unionen (EU)',
    'Oek-ae(u)' => 'Lagar och lagförslag',
    'Oek-b' => 'Norden: allmänt',
    'Oek-c' => 'Sverige',
    'Oek-c(u)' => 'Lagar och lagförslag',
    'Oek-d' => 'Övriga Norden',
    'Oek-da' => 'Danmark',
    'Oek-da(u)' => 'Lagar och lagförslag',
    'Oek-db' => 'Norge',
    'Oek-db(u)' => 'Lagar och lagförslag',
    'Oek-dd' => 'Finland',
    'Oek-dd(u)' => 'Lagar och lagförslag',
    'Oek-e' => 'Brittiska öarna (Storbritannien)',
    'Oek-ea' => 'England',
    'Oek-et' => 'Irland',
    'Oek-f' => 'Mellaneuropa',
    'Oek-fa' => 'Tyskland',
    'Oek-fag' => 'Västra Tyskland',
    'Oek-fah' => 'Östra Tyskland',
    'Oek-fb' => 'Österrike och Liechtenstein',
    'Oek-fc' => 'Ungern',
    'Oek-fd' => 'Tjeckien och Slovakien',
    'Oek-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oek-h' => 'Schweiz',
    'Oek-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oek-j' => 'Frankrike och Monaco',
    'Oek-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oek-m' => 'Östeuropa',
    'Oek-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oek-ma(u)' => 'Lagar och lagförslag',
    'Oek-mb' => 'Polen',
    'Oek-mc' => 'Estland, Lettland, Litauen',
    'Oek-n' => 'Balkanländerna',
    'Oek-o' => 'Asien',
    'Oek-oa' => 'Främre Asien',
    'Oek-ob' => 'Främre Indien',
    'Oek-oc' => 'Bortre Indien',
    'Oek-oe' => 'Östasien',
    'Oek-p' => 'Afrika',
    'Oek-q' => 'Amerika',
    'Oek-qa' => 'Förenta staterna',
    'Oek-qa(u)' => 'Lagar och lagförslag',
    'Oek-qb' => 'Kanada',
    'Oek-qd' => 'Sydamerika',
    'Oek-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeka' => 'Civil- och straffprocess',
    'Oeka-' => 'Särskilda länder och områden',
    'Oeka-a' => 'Europa: allmänt',
    'Oeka-ae' => 'Europeiska unionen (EU)',
    'Oeka-b' => 'Norden: allmänt',
    'Oeka-c' => 'Sverige',
    'Oeka-c(u)' => 'Lagar och lagförslag',
    'Oeka-d' => 'Övriga Norden',
    'Oeka-da' => 'Danmark',
    'Oeka-da(u)' => 'Lagar och lagförslag',
    'Oeka-db' => 'Norge',
    'Oeka-db(u)' => 'Lagar och lagförslag',
    'Oeka-dc' => 'Island och Färöarna',
    'Oeka-dd' => 'Finland',
    'Oeka-dd(u)' => 'Lagar och lagförslag',
    'Oeka-e' => 'Brittiska öarna (Storbritannien)',
    'Oeka-ea' => 'England',
    'Oeka-er' => 'Wales',
    'Oeka-es' => 'Skottland',
    'Oeka-et' => 'Irland',
    'Oeka-f' => 'Mellaneuropa',
    'Oeka-fa' => 'Tyskland',
    'Oeka-fa(u)' => 'Lagar och lagförslag',
    'Oeka-fag' => 'Västra Tyskland',
    'Oeka-fag(u)' => 'Lagar och lagförslag',
    'Oeka-fah' => 'Östra Tyskland',
    'Oeka-fb' => 'Österrike och Liechtenstein',
    'Oeka-fc' => 'Ungern',
    'Oeka-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeka-ga' => 'Nederländerna',
    'Oeka-gb' => 'Belgien',
    'Oeka-h' => 'Schweiz',
    'Oeka-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeka-j' => 'Frankrike och Monaco',
    'Oeka-j(u)' => 'Lagar och lagförslag',
    'Oeka-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeka-m' => 'Östeuropa',
    'Oeka-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeka-ma(u)' => 'Lagar och lagförslag',
    'Oeka-mb' => 'Polen',
    'Oeka-mc' => 'Estland, Lettland, Litauen',
    'Oeka-n' => 'Balkanländerna',
    'Oeka-na' => 'Rumänien',
    'Oeka-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oeka-nc' => 'Bulgarien',
    'Oeka-nd' => 'Grekland',
    'Oeka-o' => 'Asien',
    'Oeka-oa' => 'Främre Asien',
    'Oeka-ob' => 'Främre Indien',
    'Oeka-oc' => 'Bortre Indien',
    'Oeka-od' => 'Ostindiska öarna',
    'Oeka-oe' => 'Östasien',
    'Oeka-oea' => 'Kina',
    'Oeka-oec' => 'Japan',
    'Oeka-oek' => 'Hongkong och Macau',
    'Oeka-p' => 'Afrika',
    'Oeka-q' => 'Amerika',
    'Oeka-qa' => 'Förenta staterna',
    'Oeka-qa(u)' => 'Lagar och lagförslag',
    'Oeka-qb' => 'Kanada',
    'Oeka-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeka-qd' => 'Sydamerika',
    'Oeka-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oekb' => 'Exekutionsrätt (inkl utsökning och konkurs)',
    'Oekb-' => 'Särskilda länder och områden',
    'Oekb-a' => 'Europa: allmänt',
    'Oekb-ae' => 'Europeiska unionen (EU)',
    'Oekb-b' => 'Norden: allmänt',
    'Oekb-c' => 'Sverige',
    'Oekb-c(u)' => 'Lagar och lagförslag',
    'Oekb-cs' => 'Samer',
    'Oekb-d' => 'Övriga Norden',
    'Oekb-da' => 'Danmark',
    'Oekb-db' => 'Norge',
    'Oekb-dd' => 'Finland',
    'Oekb-dd(u)' => 'Lagar och lagförslag',
    'Oekb-e' => 'Brittiska öarna (Storbritannien)',
    'Oekb-f' => 'Mellaneuropa',
    'Oekb-fa' => 'Tyskland',
    'Oekb-fa(u)' => 'Lagar och lagförslag',
    'Oekb-fb' => 'Österrike och Liechtenstein',
    'Oekb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oekb-h' => 'Schweiz',
    'Oekb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oekb-j' => 'Frankrike och Monaco',
    'Oekb-m' => 'Östeuropa',
    'Oekb-o' => 'Asien',
    'Oekb-p' => 'Afrika',
    'Oekb-q' => 'Amerika',
    'Oekb-qa' => 'Förenta staterna',
    'Oekb-qb' => 'Kanada',
    'Oekb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oekb-s' => 'Polarländerna (Grönland)',
    'Oekd' => 'Domstols- och åklagarorganisation',
    'Oekd:bf' => 'Organisationer och institutioner',
    'Oekd-' => 'Särskilda länder och områden',
    'Oekd-a' => 'Europa: allmänt',
    'Oekd-ae' => 'Europeiska unionen (EU)',
    'Oekd-c' => 'Sverige',
    'Oekd-c:bf' => 'Organisationer och institutioner',
    'Oekd-d' => 'Övriga Norden',
    'Oekd-da' => 'Danmark',
    'Oekd-db' => 'Norge',
    'Oekd-dd' => 'Finland',
    'Oekd-e' => 'Brittiska öarna (Storbritannien)',
    'Oekd-f' => 'Mellaneuropa',
    'Oekd-fa' => 'Tyskland',
    'Oekd-fag' => 'Västra Tyskland',
    'Oekd-fah' => 'Östra Tyskland',
    'Oekd-fb' => 'Österrike och Liechtenstein',
    'Oekd-fd' => 'Tjeckien och Slovakien',
    'Oekd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oekd-h' => 'Schweiz',
    'Oekd-j' => 'Frankrike och Monaco',
    'Oekd-m' => 'Östeuropa',
    'Oekd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oekd-mb' => 'Polen',
    'Oekd-mc' => 'Estland, Lettland, Litauen',
    'Oekd-n' => 'Balkanländerna',
    'Oekd-o' => 'Asien',
    'Oekd-p' => 'Afrika',
    'Oekd-q' => 'Amerika',
    'Oekd-qa' => 'Förenta staterna',
    'Oekd-qa:bf' => 'Organisationer och institutioner',
    'Oekd-qb' => 'Kanada',
    'Oekd-qd' => 'Sydamerika',
    'Oekd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oekd-ae:bf' => 'Organisationer och institutioner',
    'Oel' => 'Tryckfrihetsrätt',
    'Oel-' => 'Särskilda länder och områden',
    'Oel-a' => 'Europa: allmänt',
    'Oel-b' => 'Norden: allmänt',
    'Oel-c' => 'Sverige',
    'Oel-c(u)' => 'Lagar och lagförslag',
    'Oel-d' => 'Övriga Norden',
    'Oel-da' => 'Danmark',
    'Oel-db' => 'Norge',
    'Oel-dd' => 'Finland',
    'Oel-e' => 'Brittiska öarna (Storbritannien)',
    'Oel-ea' => 'England',
    'Oel-f' => 'Mellaneuropa',
    'Oel-fa' => 'Tyskland',
    'Oel-fag' => 'Västra Tyskland',
    'Oel-fah' => 'Östra Tyskland',
    'Oel-fb' => 'Österrike och Liechtenstein',
    'Oel-fc' => 'Ungern',
    'Oel-fd' => 'Tjeckien och Slovakien',
    'Oel-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oel-h' => 'Schweiz',
    'Oel-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oel-j' => 'Frankrike och Monaco',
    'Oel-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oel-l' => 'Portugal',
    'Oel-m' => 'Östeuropa',
    'Oel-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oel-mb' => 'Polen',
    'Oel-mc' => 'Estland, Lettland, Litauen',
    'Oel-n' => 'Balkanländerna',
    'Oel-o' => 'Asien',
    'Oel-oa' => 'Främre Asien',
    'Oel-ob' => 'Främre Indien',
    'Oel-oe' => 'Östasien',
    'Oel-p' => 'Afrika',
    'Oel-q' => 'Amerika',
    'Oel-qa' => 'Förenta staterna',
    'Oel-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oel-qd' => 'Sydamerika',
    'Oep' => 'Kriminologi och polisväsen',
    'Oep-' => 'Allmänt: särskilda länder och områden',
    'Oep-a' => 'Europa: allmänt',
    'Oep-ae' => 'Europeiska unionen (EU)',
    'Oep-b' => 'Norden: allmänt',
    'Oep-c' => 'Sverige',
    'Oep-c:bf' => 'Organisationer och institutioner',
    'Oep-c:k' => 'Historia',
    'Oep-d' => 'Övriga Norden',
    'Oep-da' => 'Danmark',
    'Oep-db' => 'Norge',
    'Oep-dd' => 'Finland',
    'Oep-e' => 'Brittiska öarna (Storbritannien)',
    'Oep-e:k' => 'Historia',
    'Oep-ea' => 'England',
    'Oep-er' => 'Wales',
    'Oep-es' => 'Skottland',
    'Oep-et' => 'Irland',
    'Oep-f' => 'Mellaneuropa',
    'Oep-fa' => 'Tyskland',
    'Oep-fa:k' => 'Historia',
    'Oep-fag' => 'Västra Tyskland',
    'Oep-fah' => 'Östra Tyskland',
    'Oep-fb' => 'Österrike och Liechtenstein',
    'Oep-fd' => 'Tjeckien och Slovakien',
    'Oep-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oep-h' => 'Schweiz',
    'Oep-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oep-j' => 'Frankrike och Monaco',
    'Oep-m' => 'Östeuropa',
    'Oep-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oep-mb' => 'Polen',
    'Oep-mc' => 'Estland, Lettland, Litauen',
    'Oep-n' => 'Balkanländerna',
    'Oep-o' => 'Asien',
    'Oep-oa' => 'Främre Asien',
    'Oep-ob' => 'Främre Indien',
    'Oep-oe' => 'Östasien',
    'Oep-p' => 'Afrika',
    'Oep-q' => 'Amerika',
    'Oep-qa' => 'Förenta staterna',
    'Oep-qb' => 'Kanada',
    'Oep-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oep-qd' => 'Sydamerika',
    'Oep-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oep-s' => 'Polarländerna (Grönland)',
    'Oepa' => 'Kriminologi',
    'Oepa-' => 'Särskilda länder och områden',
    'Oepa-a' => 'Europa: allmänt',
    'Oepa-ae' => 'Europeiska unionen (EU)',
    'Oepa-b' => 'Norden: allmänt',
    'Oepa-c' => 'Sverige',
    'Oepa-c:k' => 'Historia',
    'Oepa-ca' => 'Svealand',
    'Oepa-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oepa-cc' => 'Norrland',
    'Oepa-d' => 'Övriga Norden',
    'Oepa-da' => 'Danmark',
    'Oepa-db' => 'Norge',
    'Oepa-dd' => 'Finland',
    'Oepa-e' => 'Brittiska öarna (Storbritannien)',
    'Oepa-e:K' => 'Historia',
    'Oepa-f' => 'Mellaneuropa',
    'Oepa-fa' => 'Tyskland',
    'Oepa-fa:k' => 'Historia',
    'Oepa-fag' => 'Västra Tyskland',
    'Oepa-fah' => 'Östra Tyskland',
    'Oepa-fc' => 'Ungern',
    'Oepa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oepa-h' => 'Schweiz',
    'Oepa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oepa-i:k' => 'Historia',
    'Oepa-j' => 'Frankrike och Monaco',
    'Oepa-j:k' => 'Historia',
    'Oepa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oepa-m' => 'Östeuropa',
    'Oepa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oepa-mb' => 'Polen',
    'Oepa-mc' => 'Estland, Lettland, Litauen',
    'Oepa-n' => 'Balkanländerna',
    'Oepa-o' => 'Asien',
    'Oepa-oa' => 'Främre Asien',
    'Oepa-ob' => 'Främre Indien',
    'Oepa-oc' => 'Bortre Indien',
    'Oepa-od' => 'Ostindiska öarna',
    'Oepa-oe' => 'Östasien',
    'Oepa-oea' => 'Kina',
    'Oepa-oec' => 'Japan',
    'Oepa-p' => 'Afrika',
    'Oepa-q' => 'Amerika',
    'Oepa-qa' => 'Förenta staterna',
    'Oepa-qa:k' => 'Historia',
    'Oepa-qb' => 'Kanada',
    'Oepa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oepa-qca' => 'Mexiko',
    'Oepa-qch' => 'Västindien',
    'Oepa-qd' => 'Sydamerika',
    'Oepa-qda' => 'Colombia',
    'Oepa-qdb' => 'Venezuela',
    'Oepa-qdd' => 'Brasilien',
    'Oepa-qdg' => 'Argentina',
    'Oepa-qdi' => 'Bolivia',
    'Oepa-qdk' => 'Peru',
    'Oepa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oepa:k' => 'Kriminologins historia',
    'Oepb' => 'Polisväsen',
    'Oepb-' => 'Särskilda länder och områden',
    'Oepb-a' => 'Europa: allmänt',
    'Oepb-a:k' => 'Polisväsendets historia',
    'Oepb-ae' => 'Europeiska unionen (EU)',
    'Oepb-b' => 'Norden: allmänt',
    'Oepb-c' => 'Sverige',
    'Oepb-c:bf' => 'Organisationer och institutioner',
    'Oepb-c:k' => 'Polisväsendets historia',
    'Oepb-c:oe' => 'Lagstiftning',
    'Oepb-cz' => 'Lokala poliskårer',
    'Oepb-d' => 'Övriga Norden',
    'Oepb-da' => 'Danmark',
    'Oepb-db' => 'Norge',
    'Oepb-dd' => 'Finland',
    'Oepb-e' => 'Brittiska öarna (Storbritannien)',
    'Oepb-e:k' => 'Polisväsendets historia',
    'Oepb-ea' => 'England',
    'Oepb-er' => 'Wales',
    'Oepb-es' => 'Skottland',
    'Oepb-et' => 'Irland',
    'Oepb-ez' => 'Lokala poliskårer',
    'Oepb-f' => 'Mellaneuropa',
    'Oepb-fa' => 'Tyskland',
    'Oepb-fa:bf' => 'Organisationer och institutioner',
    'Oepb-fa:k' => 'Polisväsendets historia',
    'Oepb-fag' => 'Västra Tyskland',
    'Oepb-fah' => 'Östra Tyskland',
    'Oepb-fb' => 'Österrike och Liechtenstein',
    'Oepb-fd' => 'Tjeckien och Slovakien',
    'Oepb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oepb-h' => 'Schweiz',
    'Oepb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oepb-j' => 'Frankrike och Monaco',
    'Oepb-j:k' => 'Polisväsendets historia',
    'Oepb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oepb-m' => 'Östeuropa',
    'Oepb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oepb-ma:bf' => 'Organisationer och institutioner',
    'Oepb-ma:k' => 'Polisväsendets histroria',
    'Oepb-mb' => 'Polen',
    'Oepb-mc' => 'Estland, Lettland, Litauen',
    'Oepb-n' => 'Balkanländerna',
    'Oepb-o' => 'Asien',
    'Oepb-oa' => 'Främre Asien',
    'Oepb-ob' => 'Främre Indien',
    'Oepb-oe' => 'Östasien',
    'Oepb-p' => 'Afrika',
    'Oepb-pc' => 'Västafrika',
    'Oepb-pe' => 'Södra Afrika',
    'Oepb-q' => 'Amerika',
    'Oepb-qa' => 'Förenta staterna',
    'Oepb-qa:bf' => 'Organisationer och institutioner',
    'Oepb-qa:k' => 'Polisväsendets historia',
    'Oepb-qaz' => 'Lokala poliskårer',
    'Oepb-qb' => 'Kanada',
    'Oepb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oepb-qd' => 'Sydamerika',
    'Oepb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oeq' => 'Kriminalvård',
    'Oeq-' => 'Särskilda länder och områden',
    'Oeq-a' => 'Europa: allmänt',
    'Oeq-ae' => 'Europeiska unionen (EU)',
    'Oeq-b' => 'Norden: allmänt',
    'Oeq-c' => 'Sverige',
    'Oeq-c:bf' => 'Organisationer och institutioner',
    'Oeq-c:k' => 'Kriminalvårdens historia',
    'Oeq-c:oi' => 'Kriminalvårdsstatistik',
    'Oeq-d' => 'Övriga Norden',
    'Oeq-da' => 'Danmark',
    'Oeq-db' => 'Norge',
    'Oeq-dd' => 'Finland',
    'Oeq-e' => 'Brittiska öarna (Storbritannien)',
    'Oeq-e:k' => 'Kriminalvårdens historia',
    'Oeq-ea' => 'England',
    'Oeq-er' => 'Wales',
    'Oeq-es' => 'Skottland',
    'Oeq-et' => 'Irland',
    'Oeq-f' => 'Mellaneuropa',
    'Oeq-fa' => 'Tyskland',
    'Oeq-fag' => 'Västra Tyskland',
    'Oeq-fah' => 'Östra Tyskland',
    'Oeq-fb' => 'Österrike och Liechtenstein',
    'Oeq-fc' => 'Ungern',
    'Oeq-fd' => 'Tjeckien och Slovakien',
    'Oeq-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oeq-ga' => 'Nederländerna',
    'Oeq-gb' => 'Belgien',
    'Oeq-h' => 'Schweiz',
    'Oeq-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oeq-j' => 'Frankrike och Monaco',
    'Oeq-j:k' => 'Kriminalvårdens historia',
    'Oeq-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oeq-m' => 'Östeuropa',
    'Oeq-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oeq-mb' => 'Polen',
    'Oeq-mc' => 'Estland, Lettland, Litauen',
    'Oeq-n' => 'Balkanländerna',
    'Oeq-o' => 'Asien',
    'Oeq-oa' => 'Främre Asien',
    'Oeq-oaa' => 'Turkiet',
    'Oeq-oae' => 'Syrien och Libanon',
    'Oeq-oaf' => 'Palestina och Israel',
    'Oeq-oak' => 'Iran (Persien)',
    'Oeq-ob' => 'Främre Indien',
    'Oeq-oc' => 'Bortre Indien',
    'Oeq-od' => 'Ostindiska öarna',
    'Oeq-oe' => 'Östasien',
    'Oeq-oea' => 'Kina',
    'Oeq-oeb' => 'Korea',
    'Oeq-oec' => 'Japan',
    'Oeq-p' => 'Afrika',
    'Oeq-pb' => 'Egypten och Sudan',
    'Oeq-pc' => 'Västafrika',
    'Oeq-pd' => 'Centralafrika',
    'Oeq-pe' => 'Södra Afrika',
    'Oeq-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oeq-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oeq-pf' => 'Östafrika',
    'Oeq-q' => 'Amerika',
    'Oeq-qa' => 'Förenta staterna',
    'Oeq-qb' => 'Kanada',
    'Oeq-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oeq-qd' => 'Sydamerika',
    'Oeq-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oer' => 'Rättsfall',
    'Oer-' => 'Särskilda länder och områden',
    'Oer-a' => 'Europa: allmänt',
    'Oer-ae' => 'Europeiska unionen (EU)',
    'Oer-b' => 'Norden: allmänt',
    'Oer-c' => 'Sverige',
    'Oer-cs' => 'Samer',
    'Oer-cz' => 'Särskilda rättsfall',
    'Oer-d' => 'Övriga Norden',
    'Oer-da' => 'Danmark',
    'Oer-daz' => 'Särskilda rättsfall',
    'Oer-db' => 'Norge',
    'Oer-dbz' => 'Särskilda rättsfall',
    'Oer-dc' => 'Island och Färöarna',
    'Oer-dd' => 'Finland',
    'Oer-e' => 'Brittiska öarna (Storbritannien)',
    'Oer-ez' => 'Särskilda rättsfall',
    'Oer-f' => 'Mellaneuropa',
    'Oer-fa' => 'Tyskland',
    'Oer-fag' => 'Västra Tyskland',
    'Oer-fah' => 'Östra Tyskland',
    'Oer-faz' => 'Särskilda rättsfall',
    'Oer-fb' => 'Österrike och Liechtenstein',
    'Oer-fc' => 'Ungern',
    'Oer-fd' => 'Tjeckien och Slovakien',
    'Oer-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oer-h' => 'Schweiz',
    'Oer-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oer-j' => 'Frankrike och Monaco',
    'Oer-jz' => 'Särskilda rättsfall',
    'Oer-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oer-m' => 'Östeuropa',
    'Oer-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oer-maz' => 'Särskilda rättsfall',
    'Oer-mb' => 'Polen',
    'Oer-n' => 'Balkanländerna',
    'Oer-o' => 'Asien',
    'Oer-oa' => 'Främre Asien',
    'Oer-oaf' => 'Palestina och Israel',
    'Oer-oafh' => 'Judar',
    'Oer-oafi' => 'Israel',
    'Oer-oai' => 'Irak',
    'Oer-oak' => 'Iran (Persien)',
    'Oer-ob' => 'Främre Indien',
    'Oer-oe' => 'Östasien',
    'Oer-oea' => 'Kina',
    'Oer-oec' => 'Japan',
    'Oer-p' => 'Afrika',
    'Oer-pb' => 'Egypten och Sudan',
    'Oer-pc' => 'Västafrika',
    'Oer-pe' => 'Södra Afrika',
    'Oer-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oer-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oer-q' => 'Amerika',
    'Oer-qa' => 'Förenta staterna',
    'Oer-qat' => 'Indianer i Nordamerika',
    'Oer-qaz' => 'Särskilda rätsfall',
    'Oer-qb' => 'Kanada',
    'Oer-qd' => 'Sydamerika',
    'Oer-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oes' => 'Försvars- och krigslagstiftning',
    'Oes(u)' => 'Allmänt: lagar och lagförslag',
    'Oes-' => 'Särskilda länder och områden',
    'Oes-c' => 'Sverige',
    'Oes-c(u)' => 'Lagar och lagförslag',
    'Oes-d' => 'Övriga Norden',
    'Oes-da' => 'Danmark',
    'Oes-da(u)' => 'Lagar och lagförslag',
    'Oes-db' => 'Norge',
    'Oes-db(u)' => 'Lagar och lagförslag',
    'Oes-dd' => 'Finland',
    'Oes-dd(u)' => 'Lagar och lagförslag',
    'Oes-e' => 'Brittiska öarna (Storbritannien)',
    'Oes-f' => 'Mellaneuropa',
    'Oes-fa' => 'Tyskland',
    'Oes-fa(u)' => 'Lagar och lagförslag',
    'Oes-fb' => 'Österrike och Liechtenstein',
    'Oes-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oes-ga' => 'Nederländerna',
    'Oes-gb' => 'Belgien',
    'Oes-h' => 'Schweiz',
    'Oes-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oes-j' => 'Frankrike och Monaco',
    'Oes-j(u)' => 'Lagar och lagförslag',
    'Oes-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oes-m' => 'Östeuropa',
    'Oes-n' => 'Balkanländerna',
    'Oes-o' => 'Asien',
    'Oes-q' => 'Amerika',
    'Oes-qa' => 'Förenta staterna',
    'Oes-qa(u)' => 'Lagar och lagförslag',
    'Oes-qb' => 'Kanada',
    'Oes-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oes-qd' => 'Sydamerika',
    'Oet' => 'Rättshistoria',
    'Oet.' => 'Allmänt: särskilda perioder',
    'Oet.2' => 'Forntiden',
    'Oet.21' => 'Egypten',
    'Oet.22' => 'Främre Asien',
    'Oet.221' => 'Mesopotamien (inkl sumererna, Assyrien, Babylonien)',
    'Oet.223' => 'Syrien, Fenicien och Palestina (inkl judarnas historia före 70 e Kr)',
    'Oet.226' => 'Mindre Asien (inkl lyderna, Pergamon m m)',
    'Oet.228' => 'Perserriket',
    'Oet.23' => 'Antikens historia: allmänt',
    'Oet.24' => 'Den grekiska forntiden',
    'Oet.241' => 'Före ca 500 f Kr',
    'Oet.243' => 'Den klassiska tiden ca 500-336 f Kr',
    'Oet.245' => 'Den hellenistiska tiden ca 336-31 f Kr',
    'Oet.249' => 'Särskilda grekiska stater',
    'Oet.26' => 'Den romerska forntiden (se även Oeam -- Romersk rätt)',
    'Oet.3' => 'Medeltiden',
    'Oet.31' => 'Bysantinska riket 395-1453',
    'Oet.32' => 'Arabiska väldet: allmänt 622-1517',
    'Oet.33' => 'Äldre medeltiden ca 476-1050',
    'Oet.35' => 'Högmedeltiden ca 1050-1300',
    'Oet.38' => 'Senmedeltiden ca 1300-1500',
    'Oet.4' => 'Nya tiden',
    'Oet.41' => '1500-1648',
    'Oet.43' => '1648-1789',
    'Oet.45' => '1789-1815',
    'Oet.46' => '1815-1914',
    'Oet.5' => '1900-talet',
    'Oet.6' => '2000-',
    'Oet-' => 'Särskilda länder och områden',
    'Oet-a' => 'Europa: allmänt',
    'Oet-a.' => 'Särskilda perioder',
    'Oet-a.2' => 'Forntiden',
    'Oet-a.3' => 'Medeltiden',
    'Oet-a.4' => 'Nya tiden',
    'Oet-a.46' => '1800-talet',
    'Oet-a.5' => '1914-',
    'Oet-a.6' => '2000-',
    'Oet-ae' => 'Europeiska unionen (EU)',
    'Oet-b' => 'Norden: allmänt',
    'Oet-b.' => 'Särskilda perioder',
    'Oet-b.2' => 'Forntiden till ca 1050 (inkl vikingafärderna)',
    'Oet-b.3' => 'Medeltiden ca 1050 - ca 1520 (inkl Kalmarunionen)',
    'Oet-b.4' => 'Nya tiden ca 1520-',
    'Oet-b.5' => '1900-talet',
    'Oet-b.6' => '2000-',
    'Oet-c' => 'Sverige',
    'Oet-c.' => 'Särskilda perioder',
    'Oet-c.2' => 'Forntiden till ca 1060',
    'Oet-c.3' => 'Medeltiden ca 1060 - 1520',
    'Oet-c.31' => 'Äldre medeltiden ca 1060-1319',
    'Oet-c.34' => 'Senare medeltiden 1319-1520',
    'Oet-c.4' => 'Nya tiden 1520-',
    'Oet-c.41' => 'Vasatiden 1520-1611',
    'Oet-c.411' => 'Gustav Vasa 1521-1560',
    'Oet-c.413' => 'Erik XIV 1560-1568',
    'Oet-c.415' => 'Johan III 1568-1592',
    'Oet-c.418' => 'Karl IX 1599-1611',
    'Oet-c.42' => 'Stormaktstiden 1611-1718',
    'Oet-c.421' => 'Gustav II Adolf 1611-1632',
    'Oet-c.423' => 'Kristina 1632-1654',
    'Oet-c.425' => 'Karl X Gustav 1654-1660',
    'Oet-c.426' => 'Karl XI 1660-1697',
    'Oet-c.428' => 'Karl XII 1697-1718',
    'Oet-c.43' => '1700-talet',
    'Oet-c.44' => 'Frihetstiden 1718-1772',
    'Oet-c.441' => 'Ulrika Eleonora 1719-1720',
    'Oet-c.442' => 'Fredrik I 1720-1751',
    'Oet-c.445' => 'Adolf Fredrik 1751-1771',
    'Oet-c.45' => 'Gustavianska tiden 1772-1809',
    'Oet-c.451' => 'Gustav III 1771-1792',
    'Oet-c.455' => 'Gustav IV Adolf 1792-1809',
    'Oet-c.46' => '1800-talet',
    'Oet-c.47' => '1809-1844',
    'Oet-c.48' => '1844-1865',
    'Oet-c.49' => '1865-1905',
    'Oet-c.5' => '1905-',
    'Oet-c.52' => 'Mellankrigstiden 1918-1939',
    'Oet-c.54' => 'Andra världskriget 1939-1945',
    'Oet-c.55' => '1945-',
    'Oet-c.58' => '1980-',
    'Oet-c.6' => '2000-',
    'Oet-ca' => 'Svealand',
    'Oet-caa' => 'Stockholm och Stockholms län',
    'Oet-cab' => 'Uppland och Uppsala län',
    'Oet-cac' => 'Södermanland och Södermanlands län',
    'Oet-cad' => 'Närke och Örebro län',
    'Oet-cae' => 'Västmanland och Västmanlands län',
    'Oet-caf' => 'Dalarna och Dalarnas län',
    'Oet-cag' => 'Värmland och Värmlands län',
    'Oet-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oet-cba' => 'Skåne och Skåne län',
    'Oet-cbb' => 'Halland och Hallands län',
    'Oet-cbc' => 'Blekinge och Blekinge län',
    'Oet-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Oet-cbe' => 'Öland',
    'Oet-cbf' => 'Gotland och Gotlands län',
    'Oet-cbg' => 'Östergötland och Östergötlands län',
    'Oet-cbh' => 'Västergötland',
    'Oet-cbk' => 'Bohuslän',
    'Oet-cbl' => 'Dalsland',
    'Oet-cc' => 'Norrland',
    'Oet-cca' => 'Gästrikland och Gävleborgs län',
    'Oet-ccc' => 'Jämtland och Jämtlands län',
    'Oet-ccd' => 'Härjedalen',
    'Oet-cce' => 'Medelpad',
    'Oet-ccf' => 'Ångermanland och Västernorrlands län',
    'Oet-cch' => 'Norrbotten och Norrbottens län',
    'Oet-cci' => 'Lappland',
    'Oet-cs' => 'Samer',
    'Oet-cz' => 'Särskilda orter',
    'Oet-d' => 'Övriga Norden',
    'Oet-da' => 'Danmark',
    'Oet-da.' => 'Särskilda perioder',
    'Oet-da.2' => 'Forntiden till ca 1050',
    'Oet-da.3' => 'Medeltiden ca 1050-1536',
    'Oet-da.4' => 'Nya tiden 1536-',
    'Oet-da.41' => '1536-1660',
    'Oet-da.43' => '1660-1814',
    'Oet-da.46' => '1800-1914',
    'Oet-da.5' => '1914-',
    'Oet-da.54' => 'Andra världskriget 1939-1945',
    'Oet-da.55' => '1945-',
    'Oet-da.6' => '2000-',
    'Oet-db' => 'Norge',
    'Oet-db.' => 'Särskilda perioder',
    'Oet-db.2' => 'Forntiden till ca 1030',
    'Oet-db.3' => 'Medeltiden ca 1030-1536',
    'Oet-db.4' => 'Nya tiden 1536-',
    'Oet-db.41' => '1536-1660',
    'Oet-db.43' => '1660-1814',
    'Oet-db.46' => '1814-1905',
    'Oet-db.5' => '1905-',
    'Oet-db.6' => '2000-',
    'Oet-dc' => 'Island och Färöarna',
    'Oet-dc.' => 'Särskilda perioder',
    'Oet-dc.2' => 'Fristatstiden 870-1262',
    'Oet-dc.3' => 'Island under Norge 1262-1537',
    'Oet-dc.4' => 'Nya tiden 1537-',
    'Oet-dcf' => 'Färöarna',
    'Oet-dd' => 'Finland',
    'Oet-dd.' => 'Särskilda perioder',
    'Oet-dd.3' => 'Medeltiden ca 1060-1520',
    'Oet-dd.4' => 'Nya tiden 1520-',
    'Oet-dd.41' => 'Vasatiden 1520-1611',
    'Oet-dd.42' => 'Stormaktstiden 1611-1718',
    'Oet-dd.43' => '1700-talet',
    'Oet-dd.44' => 'Frihetstiden 1718-1772',
    'Oet-dd.45' => 'Gustavianska tiden 1772-1809',
    'Oet-dd.46' => 'Finland under Ryssland 1809-1918',
    'Oet-dd.5' => '1918-',
    'Oet-dd.6' => '2000-',
    'Oet-ddå' => 'Åland',
    'Oet-e' => 'Brittiska öarna (Storbritannien)',
    'Oet-e.' => 'Särskilda perioder',
    'Oet-e.2' => 'Före 1066',
    'Oet-e.3' => 'Medeltiden 1066-1485',
    'Oet-e.31' => '1066-1154',
    'Oet-e.32' => '1154-1399',
    'Oet-e.33' => '1399-1485',
    'Oet-e.4' => 'Nya tiden 1485-',
    'Oet-e.41' => '1485-1603',
    'Oet-e.42' => '1603-1714',
    'Oet-e.44' => '1714-1815',
    'Oet-e.46' => '1800-1914',
    'Oet-e.5' => '1914-',
    'Oet-e.6' => '2000-',
    'Oet-ea' => 'England',
    'Oet-er' => 'Wales',
    'Oet-es' => 'Skottland',
    'Oet-et' => 'Irland',
    'Oet-f' => 'Mellaneuropa',
    'Oet-fa' => 'Tyskland',
    'Oet-fa.' => 'Särskilda perioder',
    'Oet-fa.2' => 'Före 843',
    'Oet-fa.3' => '843 - ca 1500',
    'Oet-fa.31' => '843-1254',
    'Oet-fa.32' => '1254-1519',
    'Oet-fa.36' => 'Hansan',
    'Oet-fa.4' => 'Ca 1500-',
    'Oet-fa.41' => '1500-1648',
    'Oet-fa.43' => '1648-1806',
    'Oet-fa.46' => '1806-1870',
    'Oet-fa.47' => '1870-1918',
    'Oet-fa.5' => '1900-talet',
    'Oet-fa.51' => 'Första världskriget 1914-1918',
    'Oet-fa.52' => '1918-1933',
    'Oet-fa.53' => '1933-1945',
    'Oet-fa.54' => 'Andra världskriget 1939-1945',
    'Oet-fa.55' => '1945-',
    'Oet-fa.59' => '1990-',
    'Oet-fa.6' => '2000-',
    'Oet-fag' => 'Västra Tyskland',
    'Oet-fah' => 'Östra Tyskland',
    'Oet-faz' => 'Särskilda orter',
    'Oet-fb' => 'Österrike och Liechtenstein',
    'Oet-fb.' => 'Särskilda perioder',
    'Oet-fb.3' => 'Medeltiden',
    'Oet-fb.4' => 'Nya tiden',
    'Oet-fb.5' => '1900-talet',
    'Oet-fb.6' => '2000-',
    'Oet-fbi' => 'Liechtenstein',
    'Oet-fc' => 'Ungern',
    'Oet-fd' => 'Tjeckien och Slovakien',
    'Oet-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oet-ga' => 'Nederländerna',
    'Oet-ga.' => 'Särskilda perioder',
    'Oet-ga.3' => 'Medeltiden',
    'Oet-ga.4' => 'Nya tiden',
    'Oet-ga.5' => '1914-',
    'Oet-ga.6' => '2000-',
    'Oet-gb' => 'Belgien',
    'Oet-gc' => 'Luxemburg',
    'Oet-h' => 'Schweiz',
    'Oet-h.' => 'Särskilda perioder',
    'Oet-h.3' => 'Medeltiden',
    'Oet-h.4' => 'Nya tiden',
    'Oet-h.6' => '2000-',
    'Oet-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oet-i.' => 'Särskilda perioder',
    'Oet-i.3' => 'Medeltiden ca 476-1400',
    'Oet-i.4' => 'Nya tiden 1400-',
    'Oet-i.41' => '1400-1550',
    'Oet-i.43' => '1550-1815',
    'Oet-i.46' => '1815-1870',
    'Oet-i.5' => '1914-',
    'Oet-i.6' => '2000-',
    'Oet-j' => 'Frankrike och Monaco',
    'Oet-j.' => 'Särskilda perioder',
    'Oet-j.2' => 'Före 987',
    'Oet-j.3' => 'Medeltiden 987-1498',
    'Oet-j.31' => '987-1328',
    'Oet-j.32' => '1328-1498',
    'Oet-j.39' => 'Burgund',
    'Oet-j.4' => 'Nya tiden 1498-',
    'Oet-j.41' => '1498-1610',
    'Oet-j.42' => '1610-1715',
    'Oet-j.44' => '1715-1789',
    'Oet-j.45' => 'Franska revolutionen och Napoleon 1789-1815',
    'Oet-j.451' => 'Franska revolutionen',
    'Oet-j.452' => 'Napoleon',
    'Oet-j.46' => '1815-1870',
    'Oet-j.47' => '1870-1914',
    'Oet-j.5' => '1914-',
    'Oet-j.6' => '2000-',
    'Oet-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oet-k.' => 'Särskilda perioder',
    'Oet-k.2' => 'Forntiden ca 400-711',
    'Oet-k.3' => 'Medeltiden 711-1479',
    'Oet-k.4' => 'Nya tiden 1479-',
    'Oet-k.5' => '1900-talet',
    'Oet-k.6' => '2000-',
    'Oet-l' => 'Portugal',
    'Oet-m' => 'Östeuropa',
    'Oet-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oet-ma.' => 'Särskilda perioder',
    'Oet-ma.3' => 'Medeltiden 882-1533',
    'Oet-ma.4' => 'Nya tiden 1533-',
    'Oet-ma.41' => '1533-1682',
    'Oet-ma.43' => '1682-1796',
    'Oet-ma.46' => '1796-1881',
    'Oet-ma.47' => '1881-1917',
    'Oet-ma.5' => 'Sovjetunionen 1917-1991 och Ryssland 1991-',
    'Oet-ma.6' => '2000-',
    'Oet-mb' => 'Polen',
    'Oet-mb.' => 'Särskilda perioder',
    'Oet-mb.3' => 'Medeltiden till 1515',
    'Oet-mb.4' => 'Nya tiden 1515-',
    'Oet-mb.5' => '1914-',
    'Oet-mb.6' => '2000-',
    'Oet-mc' => 'Estland, Lettland, Litauen',
    'Oet-mca' => 'Estland',
    'Oet-mcb' => 'Lettland',
    'Oet-mcc' => 'Litauen',
    'Oet-n' => 'Balkanländerna',
    'Oet-na' => 'Rumänien',
    'Oet-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oet-nc' => 'Bulgarien',
    'Oet-nd' => 'Grekland',
    'Oet-nf' => 'Albanien',
    'Oet-o' => 'Asien',
    'Oet-oa' => 'Främre Asien',
    'Oet-oaa' => 'Turkiet',
    'Oet-oae' => 'Syrien och Libanon',
    'Oet-oaf' => 'Palestina och Israel',
    'Oet-oafh' => 'Judar',
    'Oet-oafi' => 'Israel',
    'Oet-oai' => 'Irak',
    'Oet-oak' => 'Iran (Persien)',
    'Oet-ob' => 'Främre Indien',
    'Oet-oba' => 'Indien',
    'Oet-obe' => 'Sri Lanka (f d Ceylon)',
    'Oet-oc' => 'Bortre Indien',
    'Oet-od' => 'Ostindiska öarna',
    'Oet-oe' => 'Östasien',
    'Oet-oea' => 'Kina',
    'Oet-oeb' => 'Korea',
    'Oet-oec' => 'Japan',
    'Oet-of' => 'Centralasien',
    'Oet-p' => 'Afrika',
    'Oet-pa' => 'Nordafrika utom Egypten',
    'Oet-pb' => 'Egypten och Sudan',
    'Oet-pc' => 'Västafrika',
    'Oet-pd' => 'Centralafrika',
    'Oet-pe' => 'Södra Afrika',
    'Oet-pf' => 'Östafrika',
    'Oet-pg' => 'Nordöstafrika',
    'Oet-q' => 'Amerika',
    'Oet-qa' => 'Förenta staterna',
    'Oet-qa.4' => 'Nordamerika under nya tiden',
    'Oet-qa.41' => 'Nordamerika före 1789',
    'Oet-qa.46' => '1789-1865',
    'Oet-qa.47' => '1865-1914',
    'Oet-qa.5' => '1900-talet',
    'Oet-qa.55' => '1945-',
    'Oet-qa.57' => '1975-',
    'Oet-qa.59' => '1990-',
    'Oet-qa.6' => '2000-',
    'Oet-qb' => 'Kanada',
    'Oet-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oet-qd' => 'Sydamerika',
    'Oet-qda' => 'Colombia',
    'Oet-qdc' => 'Guyanastaterna',
    'Oet-qdd' => 'Brasilien',
    'Oet-qdg' => 'Argentina',
    'Oet-qdh' => 'Chile',
    'Oet-qdl' => 'Ecuador',
    'Oet-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oet-s' => 'Polarländerna (Grönland)',
    'Oeö' => 'Särskilda verksamheters juridik',
    'Oeöa' => 'Bok- och biblioteksväsen',
    'Oeöe' => 'Uppfostran och undervisning',
    'Oeöo' => 'Samhälls- och rättsvetenskap',
    'Oeöod' => 'Förvaltning',
    'Oeöoh' => 'Sociala frågor och socialpolitik',
    'Oeöohd' => 'Emigration och immigration',
    'Oeöohf' => 'Social omsorg',
    'Oeöp' => 'Teknik, industri och kommunikationer',
    'Oeöpd' => 'Bergsbruk',
    'Oeöpp' => 'Byggnadsteknik, byggnadskonstruktion, teknisk hygien',
    'Oeöpr' => 'Transportmedel och kommunikationer',
    'Oeöpu' => 'Datorer och databehandling',
    'Oeöq' => 'Ekonomi och näringsväsen',
    'Oeöqa' => 'Nationalekonomi och finansväsen',
    'Oeöqb' => 'Företagsekonomi',
    'Oeöu' => 'Naturvetenskap (miljöfrågor och naturskydd)',
    'Oeöv' => 'Medicin',
    'Oh' => 'Sociala frågor och socialpolitik',
    'Oh:oe' => 'Allmänt: sociallagstiftning',
    'Oh-' => 'Allmänt: särskilda länder och områden',
    'Oh-a' => 'Europa: allmänt',
    'Oh-a:oe' => 'Sociallagstiftning',
    'Oh-ae' => 'Europeiska unionen (EU)',
    'Oh-ae:oe' => 'Sociallagstiftning',
    'Oh-b' => 'Norden: allmänt',
    'Oh-c' => 'Sverige',
    'Oh-c:bf' => 'Organisationer och institutioner',
    'Oh-c:k' => 'Socialpolitikens historia',
    'Oh-c:k.' => 'Särskilda perioder',
    'Oh-c:k.4' => 'Nya tiden 1520-',
    'Oh-c:k.5' => '1905-',
    'Oh-c:k.6' => '2000-',
    'Oh-ca' => 'Svealand',
    'Oh-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oh-cc' => 'Norrland',
    'Oh-cs' => 'Samer',
    'Oh-d' => 'Övriga Norden',
    'Oh-da' => 'Danmark',
    'Oh-da:k' => 'Socialpolitikens historia',
    'Oh-da:oe' => 'Sociallagstiftning',
    'Oh-db' => 'Norge',
    'Oh-db:oe' => 'Sociallagstiftning',
    'Oh-dd' => 'Finland',
    'Oh-dd:oe' => 'Sociallagstiftning',
    'Oh-e' => 'Brittiska öarna (Storbritannien)',
    'Oh-e:k' => 'Socialpolitikens historia',
    'Oh-e:oe' => 'Sociallagstiftning',
    'Oh-et' => 'Irland',
    'Oh-f' => 'Mellaneuropa',
    'Oh-fa' => 'Tyskland',
    'Oh-fa:k' => 'Socialpolitikens historia',
    'Oh-fa:oe' => 'Sociallagstiftning',
    'Oh-fag' => 'Västra Tyskland',
    'Oh-fah' => 'Östra Tyskland',
    'Oh-fb' => 'Österrike och Liechtenstein',
    'Oh-fc' => 'Ungern',
    'Oh-fd' => 'Tjeckien och Slovakien',
    'Oh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oh-ga' => 'Nederländerna',
    'Oh-gb' => 'Belgien',
    'Oh-h' => 'Schweiz',
    'Oh-hz' => 'Särskilda orter',
    'Oh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oh-j' => 'Frankrike och Monaco',
    'Oh-j:oe' => 'Sociallagstiftning',
    'Oh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oh-l' => 'Portugal',
    'Oh-m' => 'Östeuropa',
    'Oh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oh-mad' => 'Ukraina',
    'Oh-mb' => 'Polen',
    'Oh-mc' => 'Estland, Lettland, Litauen',
    'Oh-mca' => 'Estland',
    'Oh-mcb' => 'Lettland',
    'Oh-mcc' => 'Litauen',
    'Oh-n' => 'Balkanländerna',
    'Oh-na' => 'Rumänien',
    'Oh-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oh-nc' => 'Bulgarien',
    'Oh-nd' => 'Grekland',
    'Oh-nf' => 'Albanien',
    'Oh-o' => 'Asien',
    'Oh-oa' => 'Främre Asien',
    'Oh-oaa' => 'Turkiet',
    'Oh-oab' => 'Cypern',
    'Oh-oac' => 'Kaukasien',
    'Oh-oae' => 'Syrien och Libanon',
    'Oh-oaf' => 'Palestina och Israel',
    'Oh-oafh' => 'Judar',
    'Oh-oafi' => 'Israel',
    'Oh-oag' => 'Jordanien',
    'Oh-oah' => 'Arabiska halvön',
    'Oh-oai' => 'Irak',
    'Oh-oak' => 'Iran (Persien)',
    'Oh-oal' => 'Afghanistan',
    'Oh-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oh-ob' => 'Främre Indien',
    'Oh-oba' => 'Indien',
    'Oh-obb' => 'Pakistan och Bangladesh',
    'Oh-obd' => 'Nepal',
    'Oh-oc' => 'Bortre Indien',
    'Oh-oca' => 'Myanmar (f d Burma)',
    'Oh-ocb' => 'Thailand',
    'Oh-occ' => 'Malaysia, Singapore och Brunei',
    'Oh-ocd' => 'Indokina',
    'Oh-od' => 'Ostindiska öarna',
    'Oh-oda' => 'Indonesien',
    'Oh-odc' => 'Filippinerna',
    'Oh-oe' => 'Östasien',
    'Oh-oea' => 'Kina',
    'Oh-oeaf' => 'Taiwan',
    'Oh-oeb' => 'Korea',
    'Oh-oec' => 'Japan',
    'Oh-oek' => 'Hongkong och Macau',
    'Oh-of' => 'Centralasien',
    'Oh-p' => 'Afrika',
    'Oh-pa' => 'Nordafrika utom Egypten',
    'Oh-pb' => 'Egypten och Sudan',
    'Oh-pba' => 'Egypten',
    'Oh-pbb' => 'Sudan',
    'Oh-pc' => 'Västafrika',
    'Oh-pcb' => 'Ekvatorialfrika',
    'Oh-pcc' => 'Norra Västafrika',
    'Oh-pccc' => 'Senegal',
    'Oh-pcce' => 'Mali',
    'Oh-pccg' => 'Burkina Faso',
    'Oh-pcck' => 'Guinea',
    'Oh-pccl' => 'Elfenbenskusten',
    'Oh-pcd' => 'Södra Västafrika',
    'Oh-pcda' => 'Ghana',
    'Oh-pcdc' => 'Benin',
    'Oh-pcdd' => 'Nigeria',
    'Oh-pd' => 'Centralafrika',
    'Oh-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Oh-pdaa' => 'Kongo (Kinshasa)',
    'Oh-pdab' => 'Rwanda',
    'Oh-pdac' => 'Burundi',
    'Oh-pdb' => 'Angola',
    'Oh-pe' => 'Södra Afrika',
    'Oh-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oh-peaa' => 'Sydafrikanska republiken',
    'Oh-peab' => 'Namibia',
    'Oh-pead' => 'Swaziland',
    'Oh-peb' => 'Botswana',
    'Oh-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oh-peca' => 'Zimbabwe',
    'Oh-pecb' => 'Zambia',
    'Oh-pecc' => 'Malawi',
    'Oh-ped' => 'Mocambique',
    'Oh-pee' => 'Madagaskar (Malagasy)',
    'Oh-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Oh-pf' => 'Östafrika',
    'Oh-pfa' => 'Uganda',
    'Oh-pfb' => 'Kenya',
    'Oh-pfc' => 'Tanzania',
    'Oh-pg' => 'Nordöstafrika',
    'Oh-q' => 'Amerika',
    'Oh-qa' => 'Förenta staterna',
    'Oh-qa:k' => 'Socialpolitikens historia',
    'Oh-qa:oe' => 'Sociallagstiftning',
    'Oh-qat' => 'Indianer i Nordamerika',
    'Oh-qb' => 'Kanada',
    'Oh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oh-qca' => 'Mexiko',
    'Oh-qcb' => 'Guatemala',
    'Oh-qcc' => 'Belize och Honduras',
    'Oh-qcd' => 'El Salvador',
    'Oh-qce' => 'Nicaragua',
    'Oh-qcf' => 'Costa Rica',
    'Oh-qch' => 'Västindien',
    'Oh-qcha' => 'Stora Antillerna (Kuba)',
    'Oh-qchaa' => 'Kuba',
    'Oh-qchab' => 'Haiti',
    'Oh-qchac' => 'Dominikanska republiken',
    'Oh-qchad' => 'Puerto Rico',
    'Oh-qchae' => 'Jamaica',
    'Oh-qd' => 'Sydamerika',
    'Oh-qda' => 'Colombia',
    'Oh-qdb' => 'Venezuela',
    'Oh-qdc' => 'Guyanastaterna',
    'Oh-qdd' => 'Brasilien',
    'Oh-qde' => 'Paraguay',
    'Oh-qdf' => 'Uruguay',
    'Oh-qdg' => 'Argentina',
    'Oh-qdh' => 'Chile',
    'Oh-qdi' => 'Bolivia',
    'Oh-qdk' => 'Peru',
    'Oh-qdl' => 'Ecuador',
    'Oh-qdt' => 'Indianer i Sydamerika',
    'Oh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oh-ra' => 'Australien',
    'Oh-rb' => 'Nya Zeeland',
    'Oh-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oh-rd' => 'Nya Guinea',
    'Oh-s' => 'Polarländerna',
    'Oha' => 'Arbete och arbetsmarknad',
    'Oha(x)' => 'Arbetsmarknadslexikon',
    'Oha:bf' => 'Arbetsmarknadsorganisationer och -institutioner',
    'Oha:k' => 'Allmän arbets- och arbetsmarknadshistoria',
    'Oha:oe' => 'Allmän arbetslagstiftning',
    'Oha:oi' => 'Allmän arbetsmarknadsstatistik',
    'Oha-' => 'Särskilda länder och områden',
    'Oha-a' => 'Europa: allmänt',
    'Oha-ae' => 'Europeiska unionen (EU)',
    'Oha-b' => 'Norden: allmänt',
    'Oha-bc' => 'Nordkalotten',
    'Oha-c' => 'Sverige',
    'Oha-c(x)' => 'Arbetsmarknadslexikon',
    'Oha-c:bf' => 'Arbetsmarknadsorganisationer och -institutioner',
    'Oha-c:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-c:k.' => 'Särskilda perioder',
    'Oha-c:k.4' => 'Nya tiden 1520-',
    'Oha-c:k.5' => '1905-',
    'Oha-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Oha-c:k.55' => '1945-',
    'Oha-c:k.6' => '2000-',
    'Oha-c:oe' => 'Arbetslagstiftning',
    'Oha-c:oi' => 'Arbetsmarknadsstatistik',
    'Oha-ca' => 'Svealand',
    'Oha-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oha-cc' => 'Norrland',
    'Oha-cz' => 'Särskilda orter',
    'Oha-d' => 'Övriga Norden',
    'Oha-da' => 'Danmark',
    'Oha-da:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-db' => 'Norge',
    'Oha-dc' => 'Island och Färöarna',
    'Oha-dd' => 'Finland',
    'Oha-dd:oi' => 'Arbetsmarknadssatistik',
    'Oha-e' => 'Brittiska öarna (Storbritannien)',
    'Oha-e:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-et' => 'Irland',
    'Oha-f' => 'Mellaneuropa',
    'Oha-fa' => 'Tyskland',
    'Oha-fa:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-fag' => 'Västra Tyskland',
    'Oha-fah' => 'Östra Tyskland',
    'Oha-fb' => 'Österrike och Liechtenstein',
    'Oha-fc' => 'Ungern',
    'Oha-fd' => 'Tjeckien och Slovakien',
    'Oha-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oha-ga' => 'Nederländerna',
    'Oha-gb' => 'Belgien',
    'Oha-gc' => 'Luxemburg',
    'Oha-h' => 'Schweiz',
    'Oha-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oha-j' => 'Frankrike och Monaco',
    'Oha-j:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oha-l' => 'Portugal',
    'Oha-m' => 'Östeuropa',
    'Oha-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oha-ma:k' => 'Arbets- och arbetsmarknadshistoria',
    'Oha-mb' => 'Polen',
    'Oha-mc' => 'Estland, Lettland, Litauen',
    'Oha-mca' => 'Estland',
    'Oha-mcb' => 'Lettland',
    'Oha-mcc' => 'Litauen',
    'Oha-n' => 'Balkanländerna',
    'Oha-na' => 'Rumänien',
    'Oha-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oha-nc' => 'Bulgarien',
    'Oha-nd' => 'Grekland',
    'Oha-nf' => 'Albanien',
    'Oha-o' => 'Asien',
    'Oha-oa' => 'Främre Asien',
    'Oha-oaa' => 'Turkiet',
    'Oha-oaf' => 'Palestina och Israel',
    'Oha-oafi' => 'Israel',
    'Oha-oah' => 'Arabiska halvön',
    'Oha-oak' => 'Iran (Persien)',
    'Oha-oal' => 'Afghanistan',
    'Oha-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oha-ob' => 'Främre Indien',
    'Oha-oba' => 'Indien',
    'Oha-obb' => 'Pakistan och Bangladesh',
    'Oha-obe' => 'Sri Lanka (f d Ceylon)',
    'Oha-oc' => 'Bortre Indien',
    'Oha-ocb' => 'Thailand',
    'Oha-occ' => 'Malaysia, Singapore och Brunei',
    'Oha-ocd' => 'Indokina',
    'Oha-od' => 'Ostindiska öarna',
    'Oha-oda' => 'Indonesien',
    'Oha-odc' => 'Filippinerna',
    'Oha-oe' => 'Östasien',
    'Oha-oea' => 'Kina',
    'Oha-oeb' => 'Korea',
    'Oha-oec' => 'Japan',
    'Oha-p' => 'Afrika',
    'Oha-pa' => 'Nordafrika utom Egypten',
    'Oha-pb' => 'Egypten och Sudan',
    'Oha-pba' => 'Egypten',
    'Oha-pbb' => 'Sudan',
    'Oha-pc' => 'Västafrika',
    'Oha-pcb' => 'Ekvatorialfrika',
    'Oha-pcc' => 'Norra Västafrika',
    'Oha-pcd' => 'Södra Västafrika',
    'Oha-pd' => 'Centralafrika',
    'Oha-pe' => 'Södra Afrika',
    'Oha-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oha-peaa' => 'Sydafrikanska republiken',
    'Oha-peab' => 'Namibia',
    'Oha-peac' => 'Lesotho',
    'Oha-peb' => 'Botswana',
    'Oha-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oha-peca' => 'Zimbabwe',
    'Oha-pecb' => 'Zambia',
    'Oha-pecc' => 'Malawi',
    'Oha-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Oha-pf' => 'Östafrika',
    'Oha-pfa' => 'Uganda',
    'Oha-pfb' => 'Kenya',
    'Oha-pfc' => 'Tanzania',
    'Oha-pg' => 'Nordöstafrika',
    'Oha-q' => 'Amerika',
    'Oha-qa' => 'Förenta staterna',
    'Oha-qa:k' => 'Arbets- och arbetsmarknadshistoria',
    'Ohai-qa:k.' => 'Särskilda perioder',
    'Ohai-qa:k.4' => 'Nordamerika under nya tiden',
    'Ohai-qa:k.5' => '1900-talet',
    'Ohai-qa:k.6' => '2000-',
    'Oha-qa:oi' => 'Arbetsmarknadsstatistik',
    'Oha-qb' => 'Kanada',
    'Oha-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oha-qca' => 'Mexiko',
    'Oha-qcb' => 'Guatemala',
    'Oha-qch' => 'Västindien',
    'Oha-qd' => 'Sydamerika',
    'Oha-qda' => 'Colombia',
    'Oha-qdb' => 'Venezuela',
    'Oha-qdd' => 'Brasilien',
    'Oha-qdf' => 'Uruguay',
    'Oha-qdg' => 'Argentina',
    'Oha-qdh' => 'Chile',
    'Oha-qdi' => 'Bolivia',
    'Oha-qdk' => 'Peru',
    'Oha-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oha-ra' => 'Australien',
    'Oha-rb' => 'Nya Zeeland',
    'Oha-rd' => 'Nya Guinea',
    'Oha-s' => 'Polarländerna',
    'Ohab' => 'Arbetsrätt',
    'Ohab-' => 'Särskilda länder och områden',
    'Ohab-a' => 'Europa: allmänt',
    'Ohab-ae' => 'Europeiska unionen (EU)',
    'Ohab-b' => 'Norden: allmänt',
    'Ohab-c' => 'Sverige',
    'Ohab-c:bf' => 'Organisationer och institutioner',
    'Ohab-c:oe' => 'Arbetsrättslagstiftning',
    'Ohab-d' => 'Övriga Norden',
    'Ohab-da' => 'Danmark',
    'Ohab-db' => 'Norge',
    'Ohab-dd' => 'Finland',
    'Ohab-e' => 'Brittiska öarna (Storbritannien)',
    'Ohab-f' => 'Mellaneuropa',
    'Ohab-fa' => 'Tyskland',
    'Ohab-fag' => 'Västra Tyskland',
    'Ohab-fah' => 'Östra Tyskland',
    'Ohab-fb' => 'Österrike och Liechtenstein',
    'Ohab-fc' => 'Ungern',
    'Ohab-fd' => 'Tjeckien och Slovakien',
    'Ohab-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohab-ga' => 'Nederländerna',
    'Ohab-gb' => 'Belgien',
    'Ohab-gc' => 'Luxemburg',
    'Ohab-h' => 'Schweiz',
    'Ohab-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohab-j' => 'Frankrike och Monaco',
    'Ohab-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohab-l' => 'Portugal',
    'Ohab-m' => 'Östeuropa',
    'Ohab-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohab-mb' => 'Polen',
    'Ohab-mc' => 'Estland, Lettland, Litauen',
    'Ohab-n' => 'Balkanländerna',
    'Ohab-o' => 'Asien',
    'Ohab-oa' => 'Främre Asien',
    'Ohab-ob' => 'Främre Indien',
    'Ohab-oc' => 'Bortre Indien',
    'Ohab-od' => 'Ostindiska öarna',
    'Ohab-oe' => 'Östasien',
    'Ohab-p' => 'Afrika',
    'Ohab-q' => 'Amerika',
    'Ohab-qa' => 'Förenta staterna',
    'Ohab-qb' => 'Kanada',
    'Ohab-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohab-qd' => 'Sydamerika',
    'Ohab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohac' => 'Löner',
    'Ohac-' => 'Särskilda länder och områden',
    'Ohac-a' => 'Europa: allmänt',
    'Ohac-ae' => 'Europeiska unionen (EU)',
    'Ohac-b' => 'Norden: allmänt',
    'Ohac-c' => 'Sverige',
    'Ohac-c:k' => 'Historia',
    'Ohac-c:oe' => 'Löneagstiftning',
    'Ohac-c:oi' => 'Lönesstatistik',
    'Ohac-d' => 'Övriga Norden',
    'Ohac-da' => 'Danmark',
    'Ohac-db' => 'Norge',
    'Ohac-dd' => 'Finland',
    'Ohac-e' => 'Brittiska öarna (Storbritannien)',
    'Ohac-f' => 'Mellaneuropa',
    'Ohac-fa' => 'Tyskland',
    'Ohac-fag' => 'Västra Tyskland',
    'Ohac-fah' => 'Östra Tyskland',
    'Ohac-fb' => 'Österrike och Liechtenstein',
    'Ohac-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohac-h' => 'Schweiz',
    'Ohac-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohac-j' => 'Frankrike och Monaco',
    'Ohac-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohac-m' => 'Östeuropa',
    'Ohac-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohac-mb' => 'Polen',
    'Ohac-mc' => 'Estland, Lettland, Litauen',
    'Ohac-n' => 'Balkanländerna',
    'Ohac-o' => 'Asien',
    'Ohac-oa' => 'Främre Asien',
    'Ohac-ob' => 'Främre Indien',
    'Ohac-oc' => 'Bortre Indien',
    'Ohac-oe' => 'Östasien',
    'Ohac-oea' => 'Kina',
    'Ohac-oec' => 'Japan',
    'Ohac-p' => 'Afrika',
    'Ohac-q' => 'Amerika',
    'Ohac-qa' => 'Förenta staterna',
    'Ohac-qb' => 'Kanada',
    'Ohac-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohac-qd' => 'Sydamerika',
    'Ohac-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohac-ra' => 'Australien',
    'Ohac-rb' => 'Nya Zeeland',
    'Ohad' => 'Arbetstid',
    'Ohad-' => 'Särskilda länder och områden',
    'Ohad-a' => 'Europa: allmänt',
    'Ohad-ae' => 'Europeiska unionen (EU)',
    'Ohad-b' => 'Norden: allmänt',
    'Ohad-c' => 'Sverige',
    'Ohad-c:k' => 'Historia',
    'Ohad-c:oe' => 'Arbetstidslagstiftning',
    'Ohad-c:oi' => 'Arbetstidsstatistik',
    'Ohad-d' => 'Övriga Norden',
    'Ohad-da' => 'Danmark',
    'Ohad-da:oe' => 'Arbetstidslagstiftning',
    'Ohad-db' => 'Norge',
    'Ohad-db:oe' => 'Arbetstidslagstiftning',
    'Ohad-dd' => 'Finland',
    'Ohad-e' => 'Brittiska öarna (Storbritannien)',
    'Ohad-f' => 'Mellaneuropa',
    'Ohad-fa' => 'Tyskland',
    'Ohad-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohad-h' => 'Schweiz',
    'Ohad-j' => 'Frankrike och Monaco',
    'Ohad-m' => 'Östeuropa',
    'Ohad-o' => 'Asien',
    'Ohad-p' => 'Afrika',
    'Ohad-q' => 'Amerika',
    'Ohae' => 'Arbetsmiljöfrågor och arbetarskydd',
    'Ohae-' => 'Särskilda länder och områden',
    'Ohae-a' => 'Europa: allmänt',
    'Ohae-ae' => 'Europeiska unionen (EU)',
    'Ohae-b' => 'Norden: allmänt',
    'Ohae-c' => 'Sverige',
    'Ohae(x)' => 'Arbetsmiljölexikon',
    'Ohae-c:bf' => 'Organisationer och institutioner',
    'Ohae-c:k' => 'Historia',
    'Ohae-c:oe' => 'Arbetsmiljölagstiftning',
    'Ohae-c:oi' => 'Arbetsmiljöstatistik',
    'Ohae-d' => 'Övriga Norden',
    'Ohae-da' => 'Danmark',
    'Ohae-da:oe' => 'Arbetsmiljölagstiftning',
    'Ohae-db' => 'Norge',
    'Ohae-dc' => 'Island och Färöarna',
    'Ohae-dd' => 'Finland',
    'Ohae-e' => 'Brittiska öarna (Storbritannien)',
    'Ohae-f' => 'Mellaneuropa',
    'Ohae-fa' => 'Tyskland',
    'Ohae-fag' => 'Västra Tyskland',
    'Ohae-fah' => 'Östra Tyskland',
    'Ohae-fb' => 'Österrike och Liechtenstein',
    'Ohae-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohae-h' => 'Schweiz',
    'Ohae-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohae-j' => 'Frankrike och Monaco',
    'Ohae-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohae-m' => 'Östeuropa',
    'Ohae-o' => 'Asien',
    'Ohae-q' => 'Amerika',
    'Ohae-qa' => 'Förenta staterna',
    'Ohae-qb' => 'Kanada',
    'Ohae-qd' => 'Sydamerika',
    'Ohae-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohaf' => 'Särskilda grupper av arbetstagare',
    'Ohaf-' => 'Särskilda länder och områden',
    'Ohaf-a' => 'Europa: allmänt',
    'Ohaf-ae' => 'Europeiska unionen (EU)',
    'Ohaf-b' => 'Norden: allmänt',
    'Ohaf-c' => 'Sverige',
    'Ohaf-c:k' => 'Historia',
    'Ohaf-c:k.' => 'Särskilda perioder',
    'Ohaf-c:k.4' => 'Nya tiden 1520-',
    'Ohaf-c:k.5' => '1905-',
    'Ohaf-c:k.6' => '2000-',
    'Ohaf-c:oe' => 'Lagstiftning',
    'Ohaf-c:oi' => 'Statistik',
    'Ohaf-ca' => 'Svealand',
    'Ohaf-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohaf-cc' => 'Norrland',
    'Ohaf-d' => 'Övriga Norden',
    'Ohaf-da' => 'Danmark',
    'Ohaf-db' => 'Norge',
    'Ohaf-dd' => 'Finland',
    'Ohaf-e' => 'Brittiska öarna (Storbritannien)',
    'Ohaf-f' => 'Mellaneuropa',
    'Ohaf-fa' => 'Tyskland',
    'Ohaf-fb' => 'Österrike och Liechtenstein',
    'Ohaf-fc' => 'Ungern',
    'Ohaf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohaf-h' => 'Schweiz',
    'Ohaf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohaf-j' => 'Frankrike och Monaco',
    'Ohaf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohaf-l' => 'Portugal',
    'Ohaf-m' => 'Östeuropa',
    'Ohaf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohaf-mb' => 'Polen',
    'Ohaf-n' => 'Balkanländerna',
    'Ohaf-o' => 'Asien',
    'Ohaf-oa' => 'Främre Asien',
    'Ohaf-ob' => 'Främre Indien',
    'Ohaf-oc' => 'Bortre Indien',
    'Ohaf-oe' => 'Östasien',
    'Ohaf-p' => 'Afrika',
    'Ohaf-q' => 'Amerika',
    'Ohaf-qa' => 'Förenta staterna',
    'Ohaf-qa:k' => 'Historia',
    'Ohaf-qb' => 'Kanada',
    'Ohaf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohaf-qd' => 'Sydamerika',
    'Ohafa' => 'Barn och ungdom på arbetsmarknaden',
    'Ohafa-' => 'Särskilda länder och områden',
    'Ohafa-a' => 'Europa: allmänt',
    'Ohafa-ae' => 'Europeiska unionen (EU)',
    'Ohafa-b' => 'Norden: allmänt',
    'Ohafa-c' => 'Sverige',
    'Ohafa-c:k' => 'Historia',
    'Ohafa-d' => 'Övriga Norden',
    'Ohafa-da' => 'Danmark',
    'Ohafa-db' => 'Norge',
    'Ohafa-dc' => 'Island och Färöarna',
    'Ohafa-dd' => 'Finland',
    'Ohafa-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafa-f' => 'Mellaneuropa',
    'Ohafa-fa' => 'Tyskland',
    'Ohafa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohafa-j' => 'Frankrike och Monaco',
    'Ohafa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohafa-m' => 'Östeuropa',
    'Ohafa-o' => 'Asien',
    'Ohafa-ob' => 'Främre Indien',
    'Ohafa-oc' => 'Bortre Indien',
    'Ohafa-od' => 'Ostindiska öarna',
    'Ohafa-oe' => 'Östasien',
    'Ohafa-p' => 'Afrika',
    'Ohafa-q' => 'Amerika',
    'Ohafa-qa' => 'Förenta staterna',
    'Ohafa-qb' => 'Kanada',
    'Ohafa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohafa-qd' => 'Sydamerika',
    'Ohafa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohafb' => 'Kvinnor på arbetsmarknaden',
    'Ohafb-' => 'Särskilda länder och områden',
    'Ohafb-a' => 'Europa: allmänt',
    'Ohafb-a:K' => 'Historia',
    'Ohafb-ae' => 'Europeiska unionen (EU)',
    'Ohafb-ae:oe' => 'Lagstiftning',
    'Ohafb-b' => 'Norden: allmänt',
    'Ohafb-bc' => 'Nordkalotten',
    'Ohafb-c' => 'Sverige',
    'Ohafb-c:k' => 'Historia',
    'Ohafb-c:k.' => 'Särskilda perioder',
    'Ohafb-c:k.4' => 'Nya tiden 1520-',
    'Ohafb-c:k.42' => 'Stormaktstiden 1611-1718',
    'Ohafb-c:k.43' => '1700-talet',
    'Ohafb-c:k.44' => 'Frihetstiden 1718-1772',
    'Ohafb-c:k.46' => '1800-talet',
    'Ohafb-c:k.49' => '1865-1905',
    'Ohafb-c:k.5' => '1905-',
    'Ohafb-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohafb-c:k.55' => '1945-',
    'Ohafb-c:k.6' => '2000-',
    'Ohafb-c:oe' => 'Lagstiftning',
    'Ohafb-c:oi' => 'Sstatistik',
    'Ohafb-ca' => 'Svealand',
    'Ohafb-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohafb-cc' => 'Norrland',
    'Ohafb-cz' => 'Särskilda orter',
    'Ohafb-d' => 'Övriga Norden',
    'Ohafb-da' => 'Danmark',
    'Ohafb-db' => 'Norge',
    'Ohafb-db:k' => 'Historia',
    'Ohafb-dc' => 'Island och Färöarna',
    'Ohafb-dd' => 'Finland',
    'Ohafb-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafb-e:k' => 'Historia',
    'Ohafb-f' => 'Mellaneuropa',
    'Ohafb-fa' => 'Tyskland',
    'Ohafb-fa:k' => 'Historia',
    'Ohafb-fag' => 'Västra Tyskland',
    'Ohafb-fah' => 'Östra Tyskland',
    'Ohafb-fb' => 'Österrike och Liechtenstein',
    'Ohafb-fc' => 'Ungern',
    'Ohafb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohafb-ga' => 'Nederländerna',
    'Ohafb-gb' => 'Belgien',
    'Ohafb-h' => 'Schweiz',
    'Ohafb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohafb-j' => 'Frankrike och Monaco',
    'Ohafb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohafb-l' => 'Portugal',
    'Ohafb-m' => 'Östeuropa',
    'Ohafb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohafb-mb' => 'Polen',
    'Ohafb-mc' => 'Estland, Lettland, Litauen',
    'Ohafb-n' => 'Balkanländerna',
    'Ohafb-o' => 'Asien',
    'Ohafb-oa' => 'Främre Asien',
    'Ohafb-ob' => 'Främre Indien',
    'Ohafb-oba' => 'Indien',
    'Ohafb-obb' => 'Pakistan och Bangladesh',
    'Ohafb-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohafb-oc' => 'Bortre Indien',
    'Ohafb-od' => 'Ostindiska öarna',
    'Ohafb-oe' => 'Östasien',
    'Ohafb-oea' => 'Kina',
    'Ohafb-oeb' => 'Korea',
    'Ohafb-oec' => 'Japan',
    'Ohafb-oek' => 'Hongkong och Macau',
    'Ohafb-of' => 'Centralasien',
    'Ohafb-og' => 'Sibirien',
    'Ohafb-p' => 'Afrika',
    'Ohafb-pa' => 'Nordafrika utom Egypten',
    'Ohafb-pb' => 'Egypten och Sudan',
    'Ohafb-pc' => 'Västafrika',
    'Ohafb-pe' => 'Södra Afrika',
    'Ohafb-pf' => 'Östafrika',
    'Ohafb-q' => 'Amerika',
    'Ohafb-qa' => 'Förenta staterna',
    'Ohafb-qa:k' => 'Historia',
    'Ohafb-qb' => 'Kanada',
    'Ohafb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohafb-qca' => 'Mexiko',
    'Ohafb-qcb' => 'Guatemala',
    'Ohafb-qcd' => 'El Salvador',
    'Ohafb-qce' => 'Nicaragua',
    'Ohafb-qch' => 'Västindien',
    'Ohafb-qd' => 'Sydamerika',
    'Ohafb-qda' => 'Colombia',
    'Ohafb-qdd' => 'Brasilien',
    'Ohafb-qdf' => 'Uruguay',
    'Ohafb-qdg' => 'Argentina',
    'Ohafb-qdh' => 'Chile',
    'Ohafb-qdi' => 'Bolivia',
    'Ohafb-qdk' => 'Peru',
    'Ohafb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohafb-ra' => 'Australien',
    'Ohafb-rb' => 'Nya Zeeland',
    'Ohafc' => 'Hemarbetare',
    'Ohafc-a' => 'Europa: allmänt',
    'Ohafc-c' => 'Sverige',
    'Ohafc-d' => 'Övriga Norden',
    'Ohafc-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafc-f' => 'Mellaneuropa',
    'Ohafc-j' => 'Frankrike och Monaco',
    'Ohafc-q' => 'Amerika',
    'Ohafd' => 'Handikappade på arbetsmarknaden',
    'Ohafd-' => 'Särskilda länder och områden',
    'Ohafd-a' => 'Europa: allmänt',
    'Ohafd-ae' => 'Europeiska unionen (EU)',
    'Ohafd-b' => 'Norden: allmänt',
    'Ohafd-c' => 'Sverige',
    'Ohafd-c:oe' => 'Lagstiftning',
    'Ohafd-d' => 'Övriga Norden',
    'Ohafd-da' => 'Danmark',
    'Ohafd-db' => 'Norge',
    'Ohafd-dd' => 'Finland',
    'Ohafd-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafd-f' => 'Mellaneuropa',
    'Ohafd-m' => 'Östeuropa',
    'Ohafd-q' => 'Amerika',
    'Ohafe' => 'Äldre på arbetsmarknaden',
    'Ohafe-a' => 'Europa: allmänt',
    'Ohafe-ae' => 'Europeiska unionen (EU)',
    'Ohafe-b' => 'Norden: allmänt',
    'Ohafe-c' => 'Sverige',
    'Ohafe-d' => 'Övriga Norden',
    'Ohafe-da' => 'Danmark',
    'Ohafe-db' => 'Norge',
    'Ohafe-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafe-q' => 'Amerika',
    'Ohafi' => 'Invandrare på arbetsmarknaden',
    'Ohafi-' => 'Särskilda länder och områden',
    'Ohafi-a' => 'Europa: allmänt',
    'Ohafi-ae' => 'Europeiska unionen (EU)',
    'Ohafi-b' => 'Norden: allmänt',
    'Ohafi-c' => 'Sverige',
    'Ohafi-cz' => 'Särskilda orter',
    'Ohafi-d' => 'Övriga Norden',
    'Ohafi-da' => 'Danmark',
    'Ohafi-db' => 'Norge',
    'Ohafi-dd' => 'Finland',
    'Ohafi-e' => 'Brittiska öarna (Storbritannien)',
    'Ohafi-f' => 'Mellaneuropa',
    'Ohafi-fa' => 'Tyskland',
    'Ohafi-fb' => 'Österrike och Liechtenstein',
    'Ohafi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohafi-h' => 'Schweiz',
    'Ohafi-j' => 'Frankrike och Monaco',
    'Ohafi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohafi-l' => 'Portugal',
    'Ohafi-m' => 'Östeuropa',
    'Ohafi-o' => 'Asien',
    'Ohafi-oa' => 'Främre Asien',
    'Ohafi-oe' => 'Östasien',
    'Ohafi-q' => 'Amerika',
    'Ohafi-qa' => 'Förenta staterna',
    'Ohafi-qb' => 'Kanada',
    'Ohafi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohafi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohag' => 'Arbetsmarknadsorganisationer: allmänt',
    'Ohag-' => 'Särskilda länder och områden',
    'Ohag-a' => 'Europa: allmänt',
    'Ohag-ae' => 'Europeiska unionen (EU)',
    'Ohag-b' => 'Norden: allmänt',
    'Ohag-c' => 'Sverige',
    'Ohag-d' => 'Övriga Norden',
    'Ohag-da' => 'Danmark',
    'Ohag-db' => 'Norge',
    'Ohag-dd' => 'Finland',
    'Ohag-e' => 'Brittiska öarna (Storbritannien)',
    'Ohag-f' => 'Mellaneuropa',
    'Ohag-j' => 'Frankrike och Monaco',
    'Ohag-m' => 'Östeuropa',
    'Ohag-o' => 'Asien',
    'Ohag-p' => 'Afrika',
    'Ohag-q' => 'Amerika',
    'Ohah' => 'Arbetsgivareorganisationer',
    'Ohah-' => 'Särskilda länder och områden',
    'Ohah-a' => 'Europa: allmänt',
    'Ohah-b' => 'Norden: allmänt',
    'Ohah-c' => 'Sverige',
    'Ohah-cz' => 'Särskilda arbetsgivareorganisationer',
    'Ohah-d' => 'Övriga Norden',
    'Ohah-da' => 'Danmark',
    'Ohah-db' => 'Norge',
    'Ohah-dc' => 'Island och Färöarna',
    'Ohah-dd' => 'Finland',
    'Ohah-e' => 'Brittiska öarna (Storbritannien)',
    'Ohah-f' => 'Mellaneuropa',
    'Ohah-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohah-j' => 'Frankrike och Monaco',
    'Ohah-o' => 'Asien',
    'Ohah-q' => 'Amerika',
    'Ohai' => 'Fackliga organisationer',
    'Ohai:k' => 'Allmänt: historia',
    'Ohai-' => 'Särskilda länder och områden',
    'Ohai-a' => 'Europa: allmänt',
    'Ohai-ae' => 'Europeiska unionen (EU)',
    'Ohai-b' => 'Norden: allmänt',
    'Ohai-bz' => 'Särskilda fackliga organisationer',
    'Ohai-c' => 'Sverige',
    'Ohai-c:k' => 'Historia',
    'Ohai-c:k.' => 'Särskilda perioder',
    'Ohai-c:k.4' => 'Nya tiden 1520-',
    'Ohai-c:k.46' => '1800-talet',
    'Ohai-c:k.49' => '1865-1905',
    'Ohai-c:k.5' => '1905-',
    'Ohai-c:k.51' => 'Första världskriget 1914-1918',
    'Ohai-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohai-c:k.55' => '1945-',
    'Ohai-c:k.6' => '2000-',
    'Ohai-c:oe' => 'Lagstiftning',
    'Ohai-c:oi' => 'Statistik',
    'Ohai-ca' => 'Svealand',
    'Ohai-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohai-cc' => 'Norrland',
    'Ohai-cza' => 'Särskilda fackliga organisationer',
    'Ohai-czb' => 'Fackliga organisationer på särskilda orter',
    'Ohai-d' => 'Övriga Norden',
    'Ohai-da' => 'Danmark',
    'Ohai-daz' => 'Särskilda fackliga organisationer',
    'Ohai-db' => 'Norge',
    'Ohai-dbza' => 'Särskilda fackliga orgnisationer',
    'Ohai-dbzb' => 'Fackliga organisationer på särskilda orter',
    'Ohai-dc' => 'Island och Färöarna',
    'Ohai-dcf' => 'Färöarna',
    'Ohai-dd' => 'Finland',
    'Ohai-ddz' => 'Särskilda fackliga organisationer',
    'Ohai-e' => 'Brittiska öarna (Storbritannien)',
    'Ohai-e:k' => 'Historia',
    'Ohai-et' => 'Irland',
    'Ohai-ez' => 'Särskilda fackliga organisationer',
    'Ohai-f' => 'Mellaneuropa',
    'Ohai-fa' => 'Tyskland',
    'Ohai-fa:k' => 'Historia',
    'Ohai-fag' => 'Västra Tyskland',
    'Ohai-fah' => 'Östra Tyskland',
    'Ohai-faz' => 'Särskilda fackliga organisatoner',
    'Ohai-fb' => 'Österrike och Liechtenstein',
    'Ohai-fbz' => 'Särskilda fackliga organisatoner',
    'Ohai-fc' => 'Ungern',
    'Ohai-fd' => 'Tjeckien och Slovakien',
    'Ohai-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohai-ga' => 'Nederländerna',
    'Ohai-gb' => 'Belgien',
    'Ohai-gc' => 'Luxemburg',
    'Ohai-h' => 'Schweiz',
    'Ohai-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohai-j' => 'Frankrike och Monaco',
    'Ohai-j:k' => 'Historia',
    'Ohai-jz' => 'Särskilda fackliga organisationer',
    'Ohai-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohai-kz' => 'Särskilda fackliga organisationer',
    'Ohai-l' => 'Portugal',
    'Ohai-m' => 'Östeuropa',
    'Ohai-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohai-mb' => 'Polen',
    'Ohai-mbz' => 'Särskilda fackliga organisationer',
    'Ohai-mc' => 'Estland, Lettland, Litauen',
    'Ohai-n' => 'Balkanländerna',
    'Ohai-na' => 'Rumänien',
    'Ohai-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohai-nd' => 'Grekland',
    'Ohai-o' => 'Asien',
    'Ohai-oa' => 'Främre Asien',
    'Ohai-oaa' => 'Turkiet',
    'Ohai-oaf' => 'Palestina och Israel',
    'Ohai-oafh' => 'Judar',
    'Ohai-oafi' => 'Israel',
    'Ohai-oafiz' => 'Särskilda fackliga organisationer',
    'Ohai-oak' => 'Iran (Persien)',
    'Ohai-ob' => 'Främre Indien',
    'Ohai-oc' => 'Bortre Indien',
    'Ohai-od' => 'Ostindiska öarna',
    'Ohai-oe' => 'Östasien',
    'Ohai-oea' => 'Kina',
    'Ohai-oeb' => 'Korea',
    'Ohai-oec' => 'Japan',
    'Ohai-p' => 'Afrika',
    'Ohai-pa' => 'Nordafrika utom Egypten',
    'Ohai-pb' => 'Egypten och Sudan',
    'Ohai-pc' => 'Västafrika',
    'Ohai-pcb' => 'Ekvatorialfrika',
    'Ohai-pcd' => 'Södra Västafrika',
    'Ohai-pcda' => 'Ghana',
    'Ohai-pcdd' => 'Nigeria',
    'Ohai-pe' => 'Södra Afrika',
    'Ohai-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohai-peaa' => 'Sydafrikanska republiken',
    'Ohai-peab' => 'Namibia',
    'Ohai-peb' => 'Botswana',
    'Ohai-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohai-pf' => 'Östafrika',
    'Ohai-pfb' => 'Kenya',
    'Ohai-pfc' => 'Tanzania',
    'Ohai-q' => 'Amerika',
    'Ohai-qa' => 'Förenta staterna',
    'Ohai-qa:k' => 'Historia',
    'Ohai-qaz' => 'Särskilda fackliga organisationer',
    'Ohai-qb' => 'Kanada',
    'Ohai-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohai-qca' => 'Mexiko',
    'Ohai-qcb' => 'Guatemala',
    'Ohai-qcc' => 'Belize och Honduras',
    'Ohai-qcd' => 'El Salvador',
    'Ohai-qce' => 'Nicaragua',
    'Ohai-qcf' => 'Costa Rica',
    'Ohai-qcg' => 'Panama',
    'Ohai-qch' => 'Västindien',
    'Ohai-qcha' => 'Stora Antillerna (Kuba)',
    'Ohai-qchaa' => 'Kuba',
    'Ohai-qchae' => 'Jamaica',
    'Ohai-qchb' => 'Små Antillerna',
    'Ohai-qd' => 'Sydamerika',
    'Ohai-qda' => 'Colombia',
    'Ohai-qdb' => 'Venezuela',
    'Ohai-qdd' => 'Brasilien',
    'Ohai-qde' => 'Paraguay',
    'Ohai-qdf' => 'Uruguay',
    'Ohai-qdg' => 'Argentina',
    'Ohai-qdh' => 'Chile',
    'Ohai-qdi' => 'Bolivia',
    'Ohai-qdk' => 'Peru',
    'Ohai-qdl' => 'Ecuador',
    'Ohai-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohai-ra' => 'Australien',
    'Ohai-rb' => 'Nya Zeeland',
    'Ohaj' => 'Arbetsmarknadskonflikter',
    'Ohaj-' => 'Särskilda länder och områden',
    'Ohaj-a' => 'Europa: allmänt',
    'Ohaj-ae' => 'Europeiska unionen (EU)',
    'Ohaj-b' => 'Norden: allmänt',
    'Ohaj-c' => 'Sverige',
    'Ohaj-c:k' => 'Historia',
    'Ohaj-c:k.' => 'Särskilda perioder',
    'Ohaj-c:k.4' => 'Nya tiden 1520-',
    'Ohaj-c:k.46' => '1800-talet',
    'Ohaj-c:k.48' => '1844-1865',
    'Ohaj-c:k.49' => '1865-1905',
    'Ohaj-c:k.5' => '1905-',
    'Ohaj-c:k.51' => 'Första världskriget 1914-1918',
    'Ohaj-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohaj-c:k.55' => '1945-',
    'Ohaj-c:k.6' => '2000-',
    'Ohaj-c:oe' => 'Lagstiftning',
    'Ohaj-ca' => 'Svealand',
    'Ohaj-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohaj-cc' => 'Norrland',
    'Ohaj-cz' => 'Särskilda orter',
    'Ohaj-d' => 'Övriga Norden',
    'Ohaj-da' => 'Danmark',
    'Ohaj-da:k' => 'Historia',
    'Ohaj-db' => 'Norge',
    'Ohaj-dc' => 'Island och Färöarna',
    'Ohaj-dd' => 'Finland',
    'Ohaj-e' => 'Brittiska öarna (Storbritannien)',
    'Ohaj-f' => 'Mellaneuropa',
    'Ohaj-fa' => 'Tyskland',
    'Ohaj-fag' => 'Västra Tyskland',
    'Ohaj-fah' => 'Östra Tyskland',
    'Ohaj-fb' => 'Österrike och Liechtenstein',
    'Ohaj-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohaj-h' => 'Schweiz',
    'Ohaj-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohaj-j' => 'Frankrike och Monaco',
    'Ohaj-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohaj-m' => 'Östeuropa',
    'Ohaj-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohaj-mb' => 'Polen',
    'Ohaj-mc' => 'Estland, Lettland, Litauen',
    'Ohaj-o' => 'Asien',
    'Ohaj-p' => 'Afrika',
    'Ohaj-q' => 'Amerika',
    'Ohaj-qa' => 'Förenta staterna',
    'Ohaj-qa:k' => 'Historia',
    'Ohaj-qb' => 'Kanada',
    'Ohaj-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohaj-qd' => 'Sydamerika',
    'Ohaj-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohaj-s' => 'Polarländerna (Grönland)',
    'Ohak' => 'Arbetsförmedling och arbetslöshet',
    'Ohak-' => 'Särskilda länder och områden',
    'Ohak-a' => 'Europa: allmänt',
    'Ohak-ae' => 'Europeiska unionen (EU)',
    'Ohak-b' => 'Norden: allmänt',
    'Ohak-c' => 'Sverige',
    'Ohak-c:bf' => 'Organisationer och institutioner',
    'Ohak-c:k' => 'Historia',
    'Ohak-c:oe' => 'Lagstiftning',
    'Ohak-c:oi' => 'Statistik',
    'Ohak-ca' => 'Svealand',
    'Ohak-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohak-cc' => 'Norrland',
    'Ohak-cz' => 'Särskilda orter',
    'Ohak-d' => 'Övriga Norden',
    'Ohak-da' => 'Danmark',
    'Ohak-db' => 'Norge',
    'Ohak-dd' => 'Finland',
    'Ohak-e' => 'Brittiska öarna (Storbritannien)',
    'Ohak-et' => 'Irland',
    'Ohak-f' => 'Mellaneuropa',
    'Ohak-fa' => 'Tyskland',
    'Ohak-fa:k' => 'Historia',
    'Ohak-fag' => 'Västra Tyskland',
    'Ohak-fah' => 'Östra Tyskland',
    'Ohak-fb' => 'Österrike och Liechtenstein',
    'Ohak-fc' => 'Ungern',
    'Ohak-fd' => 'Tjeckien och Slovakien',
    'Ohak-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohak-ga' => 'Nederländerna',
    'Ohak-gb' => 'Belgien',
    'Ohak-gc' => 'Luxemburg',
    'Ohak-h' => 'Schweiz',
    'Ohak-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohak-j' => 'Frankrike och Monaco',
    'Ohak-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohak-l' => 'Portugal',
    'Ohak-m' => 'Östeuropa',
    'Ohak-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohak-mb' => 'Polen',
    'Ohak-n' => 'Balkanländerna',
    'Ohak-o' => 'Asien',
    'Ohak-oa' => 'Främre Asien',
    'Ohak-ob' => 'Främre Indien',
    'Ohak-oc' => 'Bortre Indien',
    'Ohak-oe' => 'Östasien',
    'Ohak-p' => 'Afrika',
    'Ohak-q' => 'Amerika',
    'Ohak-qa' => 'Förenta staterna',
    'Ohak-qb' => 'Kanada',
    'Ohak-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohak-qd' => 'Sydamerika',
    'Ohak-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohal' => 'Medbestämmande',
    'Ohal-' => 'Särskilda länder och områden',
    'Ohal-a' => 'Europa: allmänt',
    'Ohal-ae' => 'Europeiska unionen (EU)',
    'Ohal-b' => 'Norden: allmänt',
    'Ohal-c' => 'Sverige',
    'Ohal-c:k' => 'Historia',
    'Ohal-c:oe' => 'Lagstiftning',
    'Ohal-d' => 'Övriga Norden',
    'Ohal-da' => 'Danmark',
    'Ohal-db' => 'Norge',
    'Ohal-db:oe' => 'Lagstiftning',
    'Ohal-dd' => 'Finland',
    'Ohal-e' => 'Brittiska öarna (Storbritannien)',
    'Ohal-f' => 'Mellaneuropa',
    'Ohal-fa' => 'Tyskland',
    'Ohal-fag' => 'Västra Tyskland',
    'Ohal-fah' => 'Östra Tyskland',
    'Ohal-fb' => 'Österrike och Liechtenstein',
    'Ohal-fc' => 'Ungern',
    'Ohal-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohal-h' => 'Schweiz',
    'Ohal-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohal-j' => 'Frankrike och Monaco',
    'Ohal-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohal-m' => 'Östeuropa',
    'Ohal-n' => 'Balkanländerna',
    'Ohal-o' => 'Asien',
    'Ohal-p' => 'Afrika',
    'Ohal-q' => 'Amerika',
    'Ohal-qa' => 'Förenta staterna',
    'Ohal-qb' => 'Kanada',
    'Ohal-qd' => 'Sydamerika',
    'Ohc' => 'Bostäder',
    'Ohc-' => 'Allmänt: särskilda länder och områden',
    'Ohc-a' => 'Europa: allmänt',
    'Ohc-ae' => 'Europeiska unionen (EU)',
    'Ohc-b' => 'Norden: allmänt',
    'Ohc-c' => 'Sverige',
    'Ohc-c:bf' => 'Bostadsorganisationer och -institutioner',
    'Ohc-c:k' => 'Bostadshistoria',
    'Ohc-c:k.' => 'Särskilda perioder',
    'Ohc-c:k.4' => 'Nya tiden 1520-',
    'Ohc-c:k.46' => '1800-talet',
    'Ohc-c:k.48' => '1844-1865',
    'Ohc-c:k.49' => '1865-1905',
    'Ohc-c:k.5' => '1905-',
    'Ohc-c:k.6' => '2000-',
    'Ohc-c:oa' => 'Bostadssociologi',
    'Ohc-c:oe' => 'Bostadslagstiftning',
    'Ohc-c:oi' => 'Bostadsstatistik',
    'Ohc-ca' => 'Svealand',
    'Ohc-caa' => 'Stockholm och Stockholms län',
    'Ohc-caal' => 'Stockholms län',
    'Ohc-cab' => 'Uppland och Uppsala län',
    'Ohc-cac' => 'Södermanland och Södermanlands län',
    'Ohc-cad' => 'Närke och Örebro län',
    'Ohc-caf' => 'Dalarna och Dalarnas län',
    'Ohc-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohc-cc' => 'Norrland',
    'Ohc-cs' => 'Samer',
    'Ohc-cz' => 'Särskilda orter',
    'Ohc-d' => 'Övriga Norden',
    'Ohc-da' => 'Danmark',
    'Ohc-daz' => 'Särskilda orter',
    'Ohc-db' => 'Norge',
    'Ohc-db:k' => 'Bostadshistoria',
    'Ohc-dbz' => 'Särskilda orter',
    'Ohc-dc' => 'Island och Färöarna',
    'Ohc-dd' => 'Finland',
    'Ohc-dd:oi' => 'Bostadsstatistik',
    'Ohc-e' => 'Brittiska öarna (Storbritannien)',
    'Ohc-e:k' => 'Bostadshistoria',
    'Ohc-f' => 'Mellaneuropa',
    'Ohc-fa' => 'Tyskland',
    'Ohc-fag' => 'Västra Tyskland',
    'Ohc-fah' => 'Östra Tyskland',
    'Ohc-fai' => 'Berlin',
    'Ohc-faz' => 'Särskilda orter',
    'Ohc-fb' => 'Österrike och Liechtenstein',
    'Ohc-fc' => 'Ungern',
    'Ohc-fd' => 'Tjeckien och Slovakien',
    'Ohc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohc-ga' => 'Nederländerna',
    'Ohc-gb' => 'Belgien',
    'Ohc-h' => 'Schweiz',
    'Ohc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohc-j' => 'Frankrike och Monaco',
    'Ohc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohc-l' => 'Portugal',
    'Ohc-m' => 'Östeuropa',
    'Ohc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohc-mb' => 'Polen',
    'Ohc-mc' => 'Estland, Lettland, Litauen',
    'Ohc-n' => 'Balkanländerna',
    'Ohc-o' => 'Asien',
    'Ohc-oa' => 'Främre Asien',
    'Ohc-ob' => 'Främre Indien',
    'Ohc-oc' => 'Bortre Indien',
    'Ohc-od' => 'Ostindiska öarna',
    'Ohc-oe' => 'Östasien',
    'Ohc-oea' => 'Kina',
    'Ohc-oeb' => 'Korea',
    'Ohc-oec' => 'Japan',
    'Ohc-oek' => 'Hongkong och Macau',
    'Ohc-p' => 'Afrika',
    'Ohc-pa' => 'Nordafrika utom Egypten',
    'Ohc-pb' => 'Egypten och Sudan',
    'Ohc-pc' => 'Västafrika',
    'Ohc-pe' => 'Södra Afrika',
    'Ohc-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohc-peaa' => 'Sydafrikanska republiken',
    'Ohc-peab' => 'Namibia',
    'Ohc-peac' => 'Lesotho',
    'Ohc-pead' => 'Swaziland',
    'Ohc-peb' => 'Botswana',
    'Ohc-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohc-peca' => 'Zimbabwe',
    'Ohc-pecb' => 'Zambia',
    'Ohc-ped' => 'Mocambique',
    'Ohc-pf' => 'Östafrika',
    'Ohc-pg' => 'Nordöstafrika',
    'Ohc-q' => 'Amerika',
    'Ohc-qa' => 'Förenta staterna',
    'Ohc-qa:oe' => 'Bostadslagstiftning',
    'Ohc-qb' => 'Kanada',
    'Ohc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohc-qd' => 'Sydamerika',
    'Ohc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohc-ra' => 'Australien',
    'Ohcb' => 'Bostadspolitik och bostadsförsörjning',
    'Ohcb-' => 'Särskilda länder och områden',
    'Ohcb-a' => 'Europa: allmänt',
    'Ohcb-ae' => 'Europeiska unionen (EU)',
    'Ohcb-b' => 'Norden: allmänt',
    'Ohcb-c' => 'Sverige',
    'Ohcb-c:bf' => 'Organisationer och institutioner',
    'Ohcb-c:k' => 'Historia',
    'Ohcb-c:oa' => 'Sociologi',
    'Ohcb-c:oe' => 'Lagstiftning',
    'Ohcb-c:oi' => 'Statistik',
    'Ohcb-ca' => 'Svealand',
    'Ohcb-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohcb-cc' => 'Norrland',
    'Ohcb-cz' => 'Särskilda orter',
    'Ohcb-d' => 'Övriga Norden',
    'Ohcb-da' => 'Danmark',
    'Ohcb-db' => 'Norge',
    'Ohcb-dd' => 'Finland',
    'Ohcb-e' => 'Brittiska öarna (Storbritannien)',
    'Ohcb-f' => 'Mellaneuropa',
    'Ohcb-fa' => 'Tyskland',
    'Ohcb-fa:k' => 'Historia',
    'Ohcb-fc' => 'Ungern',
    'Ohcb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohcb-j' => 'Frankrike och Monaco',
    'Ohcb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohcb-m' => 'Östeuropa',
    'Ohcb-o' => 'Asien',
    'Ohcb-oa' => 'Främre Asien',
    'Ohcb-ob' => 'Främre Indien',
    'Ohcb-oe' => 'Östasien',
    'Ohcb-p' => 'Afrika',
    'Ohcb-q' => 'Amerika',
    'Ohcb-qa' => 'Förenta staterna',
    'Ohcb-qb' => 'Kanada',
    'Ohcb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohcb-qd' => 'Sydamerika',
    'Ohcb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohcf' => 'Bostäder för särskilda grupper',
    'Ohcf-a' => 'Europa: allmänt',
    'Ohcf-c' => 'Sverige',
    'Ohcf-cz' => 'Särskilda orter',
    'Ohcf-d' => 'Övriga Norden',
    'Ohcf-e' => 'Brittiska öarna (Storbritannien)',
    'Ohcf-f' => 'Mellaneuropa',
    'Ohcf-q' => 'Amerika',
    'Ohcfd' => 'Bostäder för handikappade',
    'Ohcfd-c' => 'Sverige',
    'Ohcfd-cz' => 'Särskilda orter',
    'Ohcfe' => 'Bostäder för äldre',
    'Ohcfe-b' => 'Norden: allmänt',
    'Ohcfe-c' => 'Sverige',
    'Ohcfe-cz' => 'Särskilda orter',
    'Ohcfe-d' => 'Övriga Norden',
    'Ohcfe-e' => 'Brittiska öarna (storbritannien)',
    'Ohcfe-o' => 'Asien',
    'Ohcfe-q' => 'Amerika',
    'Ohd' => 'Emigration och immigration',
    'Ohd-' => 'Allmänt: särskilda länder och områden',
    'Ohd-a' => 'Europa: allmänt',
    'Ohd-a:k' => 'Historia',
    'Ohd-ae' => 'Europeiska unionen (EU)',
    'Ohd-ae:oe' => 'Lagstiftning',
    'Ohd-b' => 'Norden: allmänt',
    'Ohd-c' => 'Sverige',
    'Ohd-c:bf' => 'Organisationer och institutioner',
    'Ohd-c:k' => 'Historia',
    'Ohd-c:oe' => 'Lagstiftning',
    'Ohd-c:oi' => 'Statistik',
    'Ohd-ca' => 'Svealand',
    'Ohd-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohd-cc' => 'Norrland',
    'Ohd-cs' => 'Samer',
    'Ohd-cz' => 'Särskilda orter',
    'Ohd-d' => 'Övriga Norden',
    'Ohd-da' => 'Danmark',
    'Ohd-db' => 'Norge',
    'Ohd-dd' => 'Finland',
    'Ohd-e' => 'Brittiska öarna (Storbritannien)',
    'Ohd-et' => 'Irland',
    'Ohd-ez' => 'Särskilda orter',
    'Ohd-f' => 'Mellaneuropa',
    'Ohd-fa' => 'Tyskland',
    'Ohd-fa:k' => 'Historia',
    'Ohd-fag' => 'Västra Tyskland',
    'Ohd-fah' => 'Östra Tyskland',
    'Ohd-fb' => 'Österrike och Liechtenstein',
    'Ohd-fc' => 'Ungern',
    'Ohd-fd' => 'Tjeckien och Slovakien',
    'Ohd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohd-ga' => 'Nederländerna',
    'Ohd-gb' => 'Belgien',
    'Ohd-h' => 'Schweiz',
    'Ohd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohd-j' => 'Frankrike och Monaco',
    'Ohd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohd-l' => 'Portugal',
    'Ohd-m' => 'Östeuropa',
    'Ohd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohd-mb' => 'Polen',
    'Ohd-mc' => 'Estland, Lettland, Litauen',
    'Ohd-n' => 'Balkanländerna',
    'Ohd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohd-nc' => 'Bulgarien',
    'Ohd-nd' => 'Grekland',
    'Ohd-o' => 'Asien',
    'Ohd-oa' => 'Främre Asien',
    'Ohd-oaa' => 'Turkiet',
    'Ohd-oae' => 'Syrien och Libanon',
    'Ohd-oaf' => 'Palestina och Israel',
    'Ohd-oafh' => 'Judar',
    'Ohd-oafi' => 'Israel',
    'Ohd-oah' => 'Arabiska halvön',
    'Ohd-oai' => 'Irak',
    'Ohd-oal' => 'Afghanistan',
    'Ohd-oas' => 'Syrianer',
    'Ohd-ob' => 'Främre Indien',
    'Ohd-oba' => 'Indien',
    'Ohd-obb' => 'Pakistan och Bangladesh',
    'Ohd-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohd-oc' => 'Bortre Indien',
    'Ohd-ocb' => 'Thailand',
    'Ohd-occ' => 'Malaysia, Singapore och Brunei',
    'Ohd-ocd' => 'Indokina',
    'Ohd-od' => 'Ostindiska öarna',
    'Ohd-oe' => 'Östasien',
    'Ohd-oea' => 'Kina',
    'Ohd-oec' => 'Japan',
    'Ohd-p' => 'Afrika',
    'Ohd-pa' => 'Nordafrika utom Egypten',
    'Ohd-pb' => 'Egypten och Sudan',
    'Ohd-pc' => 'Västafrika',
    'Ohd-pd' => 'Centralafrika',
    'Ohd-pe' => 'Södra Afrika',
    'Ohd-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohd-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohd-ped' => 'Mocambique',
    'Ohd-pf' => 'Östafrika',
    'Ohd-pg' => 'Nordöstafrika',
    'Ohd-q' => 'Amerika',
    'Ohd-qa' => 'Förenta staterna',
    'Ohd-qa:k' => 'Historia',
    'Ohd-qb' => 'Kanada',
    'Ohd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohd-qca' => 'Mexiko',
    'Ohd-qcb' => 'Guatemala',
    'Ohd-qcf' => 'Costa Rica',
    'Ohd-qch' => 'Västindien',
    'Ohd-qcha' => 'Stora Antillerna (Kuba)',
    'Ohd-qchb' => 'Små Antillerna',
    'Ohd-qd' => 'Sydamerika',
    'Ohd-qda' => 'Colombia',
    'Ohd-qdb' => 'Venezuela',
    'Ohd-qdc' => 'Guyanastaterna',
    'Ohd-qdd' => 'Brasilien',
    'Ohd-qde' => 'Paraguay',
    'Ohd-qdf' => 'Uruguay',
    'Ohd-qdg' => 'Argentina',
    'Ohd-qdh' => 'Chile',
    'Ohd-qdi' => 'Bolivia',
    'Ohd-qdk' => 'Peru',
    'Ohd-qdl' => 'Ecuador',
    'Ohd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohd-ra' => 'Australien',
    'Ohd-rb' => 'Nya Zeeland',
    'Ohd-s' => 'Polarländerna (Grönland)',
    'Ohdf' => 'Flyktingfrågor och flyktingpolitik',
    'Ohdf:bf' => 'Allmänt: organisationer och institutioner',
    'Ohdf-' => 'Särskilda länder och områden',
    'Ohdf-a' => 'Europa: allmänt',
    'Ohdf-b' => 'Norden: allmänt',
    'Ohdf-b:k' => 'Historia',
    'Ohdf-c' => 'Sverige',
    'Ohdf-c:k' => 'Historia',
    'Ohdf-c:oe' => 'Lagstiftning',
    'Ohdf-cz' => 'Särskilda orter',
    'Ohdf-d' => 'Övriga Norden',
    'Ohdf-da' => 'Danmark',
    'Ohdf-da:k' => 'Historia',
    'Ohdf-db' => 'Norge',
    'Ohdf-dc' => 'Island och Färöarna',
    'Ohdf-dd' => 'Finland',
    'Ohdf-e' => 'Brittiska öarna (Storbritannien)',
    'Ohdf-f' => 'Mellaneuropa',
    'Ohdf-fa' => 'Tyskland',
    'Ohdf-fa:k' => 'Historia',
    'Ohdf-fag' => 'Västra Tyskland',
    'Ohdf-fah' => 'Östra Tyskland',
    'Ohdf-faz' => 'Särskilda orter',
    'Ohdf-fb' => 'Österrike och Liechtenstein',
    'Ohdf-fc' => 'Ungern',
    'Ohdf-fd' => 'Tjeckien och Slovakien',
    'Ohdf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohdf-h' => 'Schweiz',
    'Ohdf-j' => 'Frankrike och Monaco',
    'Ohdf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohdf-m' => 'Östeuropa',
    'Ohdf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohdf-mb' => 'Polen',
    'Ohdf-mc' => 'Estland, Lettland, Litauen',
    'Ohdf-n' => 'Balkanländerna',
    'Ohdf-na' => 'Rumänien',
    'Ohdf-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohdf-nba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Ohdf-nbb' => 'Kroatien',
    'Ohdf-nbd' => 'Bosnien-Hercegovina',
    'Ohdf-nd' => 'Grekland',
    'Ohdf-o' => 'Asien',
    'Ohdf-oa' => 'Främre Asien',
    'Ohdf-oaa' => 'Turkiet',
    'Ohdf-oae' => 'Syrien och Libanon',
    'Ohdf-oaf' => 'Palestina och Israel',
    'Ohdf-oafh' => 'Judar',
    'Ohdf-oafi' => 'Israel',
    'Ohdf-oag' => 'Jordanien',
    'Ohdf-oah' => 'Arabiska halvön',
    'Ohdf-oai' => 'Irak',
    'Ohdf-oak' => 'Iran (Persien)',
    'Ohdf-oal' => 'Afghanistan',
    'Ohdf-ob' => 'Främre Indien',
    'Ohdf-oba' => 'Indien',
    'Ohdf-obb' => 'Pakistan och Bangladesh',
    'Ohdf-obd' => 'Nepal',
    'Ohdf-oc' => 'Bortre Indien',
    'Ohdf-ocb' => 'Thailand',
    'Ohdf-ocd' => 'Indokina',
    'Ohdf-ocdb' => 'Kambodja',
    'Ohdf-ocdc' => 'Vietnam',
    'Ohdf-oe' => 'Östasien',
    'Ohdf-p' => 'Afrika',
    'Ohdf-pb' => 'Egypten och Sudan',
    'Ohdf-pc' => 'Västafrika',
    'Ohdf-pd' => 'Centralafrika',
    'Ohdf-pe' => 'Södra Afrika',
    'Ohdf-pf' => 'Östafrika',
    'Ohdf-pfa' => 'Uganda',
    'Ohdf-pfb' => 'Kenya',
    'Ohdf-pfc' => 'Tanzania',
    'Ohdf-pg' => 'Nordöstafrika',
    'Ohdf-pga' => 'Etiopien med Eritrea',
    'Ohdf-pgb' => 'Somalia',
    'Ohdf-q' => 'Amerika',
    'Ohdf-qa' => 'Förenta staterna',
    'Ohdf-qb' => 'Kanada',
    'Ohdf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohdf-qca' => 'Mexiko',
    'Ohdf-qcb' => 'Guatemala',
    'Ohdf-qcc' => 'Belize och Honduras',
    'Ohdf-qcd' => 'El Salvador',
    'Ohdf-qch' => 'Västindien',
    'Ohdf-qd' => 'Sydamerika',
    'Ohdf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohdfb' => 'Särskilda ålders- och könsgrupper av flyktingar',
    'Ohdfb-a' => 'Europa: allmänt',
    'Ohdfb-b' => 'Norden: allmänt',
    'Ohdfb-c' => 'Sverige',
    'Ohdfb-c:k' => 'Historia',
    'Ohdfb-d' => 'Övriga Norden',
    'Ohdfb-o' => 'Asien',
    'Ohdfb-p' => 'Afrika',
    'Ohdfb-q' => 'Amerika',
    'Ohdh' => 'Emigration',
    'Ohdh-' => 'Allmänt: särskilda länder och områden',
    'Ohdh-a' => 'Europa: allmänt',
    'Ohdh-ae' => 'Europeiska unionen (EU)',
    'Ohdh-b' => 'Norden: allmänt',
    'Ohdh-c' => 'Sverige',
    'Ohdh-c:k' => 'Emigrationens historia',
    'Ohdh-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohdh-cc' => 'Norrland',
    'Ohdh-cz' => 'Särskilda orter',
    'Ohdh-d' => 'Övriga Norden',
    'Ohdh-da' => 'Danmark',
    'Ohdh-db' => 'Norge',
    'Ohdh-dd' => 'Finland',
    'Ohdh-e' => 'Brittiska öarna (Storbritannien)',
    'Ohdh-es' => 'Skottland',
    'Ohdh-et' => 'Irland',
    'Ohdh-f' => 'Mellaneuropa',
    'Ohdh-fa' => 'Tyskland',
    'Ohdh-fa:k' => 'Emigrationens historia',
    'Ohdh-fag' => 'Västra Tyskland',
    'Ohdh-fah' => 'Östra Tyskland',
    'Ohdh-fb' => 'Österrike och Liechtenstein',
    'Ohdh-fc' => 'Ungern',
    'Ohdh-fd' => 'Tjeckien och Slovakien',
    'Ohdh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohdh-h' => 'Schweiz',
    'Ohdh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohdh-j' => 'Frankrike och Monaco',
    'Ohdh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohdh-l' => 'Portugal',
    'Ohdh-m' => 'Östeuropa',
    'Ohdh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohdh-mb' => 'Polen',
    'Ohdh-mb:k' => 'Emigrationens historia',
    'Ohdh-mc' => 'Estland, Lettland, Litauen',
    'Ohdh-n' => 'Balkanländerna',
    'Ohdh-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohdh-nd' => 'Grekland',
    'Ohdh-o' => 'Asien',
    'Ohdh-oa' => 'Främre Asien',
    'Ohdh-oaa' => 'Turkiet',
    'Ohdh-oae' => 'Syrien och Libanon',
    'Ohdh-oaf' => 'Palestina och Israel',
    'Ohdh-oak' => 'Iran (Persien)',
    'Ohdh-oas' => 'Syrianer',
    'Ohdh-ob' => 'Främre Indien',
    'Ohdh-oba' => 'Indien',
    'Ohdh-obb' => 'Pakistan och Bangladesh',
    'Ohdh-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohdh-oc' => 'Bortre Indien',
    'Ohdh-od' => 'Ostindiska öarna',
    'Ohdh-oe' => 'Östasien',
    'Ohdh-oea' => 'Kina',
    'Ohdh-oeb' => 'Korea',
    'Ohdh-oec' => 'Japan',
    'Ohdh-oek' => 'Hongkong och Macau',
    'Ohdh-p' => 'Afrika',
    'Ohdh-pa' => 'Nordafrika utom Egypten',
    'Ohdh-pc' => 'Västafrika',
    'Ohdh-pg' => 'Nordöstafrika',
    'Ohdh-q' => 'Amerika',
    'Ohdh-qa' => 'Förenta staterna',
    'Ohdh-qb' => 'Kanada',
    'Ohdh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohdh-qca' => 'Mexiko',
    'Ohdh-qch' => 'Västindien',
    'Ohdh-qcha' => 'Stora Antillerna (Kuba)',
    'Ohdh-qchaa' => 'Kuba',
    'Ohdh-qchab' => 'Haiti',
    'Ohdh-qchac' => 'Dominikanska republiken',
    'Ohdh-qchb' => 'Små Antillerna',
    'Ohdh-qd' => 'Sydamerika',
    'Ohdh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohdi' => 'Immigration',
    'Ohdi-' => 'Allmänt: särskilda länder och områden',
    'Ohdi-a' => 'Europa: allmänt',
    'Ohdi-a:oe' => 'Immigrationslagstiftning',
    'Ohdi-ae' => 'Europeiska unionen (EU)',
    'Ohdi-ae:oe' => 'Immigrationslagstiftning',
    'Ohdi-b' => 'Norden: allmänt',
    'Ohdi-c' => 'Sverige',
    'Ohdi-c:bf' => 'Organisationer och institutioner',
    'Ohdi-c:k' => 'Historia',
    'Ohdi-c:k.' => 'Särskilda perioder',
    'Ohdi-c:k.3' => 'Medeltiden ca 1060 - 1520',
    'Ohdi-c:k.4' => 'Nya tiden 1520-',
    'Ohdi-c:k.5' => '1905-',
    'Ohdi-c:k.6' => '2000-',
    'Ohdi-c:oa' => 'Immigrationssociologi',
    'Ohdi-c:oe' => 'Immigrationslagstiftning',
    'Ohdi-c:oi' => 'Immigrationsstatistik',
    'Ohdi-ca' => 'Svealand',
    'Ohdi-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohdi-cc' => 'Norrland',
    'Ohdi-cz' => 'Särskilda orter',
    'Ohdi-d' => 'Övriga Norden',
    'Ohdi-da' => 'Danmark',
    'Ohdi-da:oe' => 'Immigrationslagstiftning',
    'Ohdi-db' => 'Norge',
    'Ohdi-db:k' => 'Immigrationens historia',
    'Ohdi-db:oe' => 'Immigrationslagstiftning',
    'Ohdi-dd' => 'Finland',
    'Ohdi-e' => 'Brittiska öarna (Storbritannien)',
    'Ohdi-e:k' => 'Immigrationens historia',
    'Odhi-e:oe' => 'Immigrationslagstiftning',
    'Ohdi-f' => 'Mellaneuropa',
    'Ohdi-fa' => 'Tyskland',
    'Ohdi-fa:k' => 'Immigrationens historia',
    'Ohdi-fa:oe' => 'Immigrationslagstiftning',
    'Ohdi-fag' => 'Västra Tyskland',
    'Ohdi-fb' => 'Österrike och Liechtenstein',
    'Ohdi-fc' => 'Ungern',
    'Ohdi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohdi-ga' => 'Nederländerna',
    'Ohdi-gb' => 'Belgien',
    'Ohdi-h' => 'Schweiz',
    'Ohdi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohdi-j' => 'Frankrike och Monaco',
    'Ohdi-j:k' => 'Immigrationens historia',
    'Ohdi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohdi-l' => 'Portugal',
    'Ohdi-m' => 'Östeuropa',
    'Ohdi-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohdi-mb' => 'Polen',
    'Ohdi-mc' => 'Estland, Lettland, Litauen',
    'Ohdi-n' => 'Balkanländerna',
    'Ohdi-o' => 'Asien',
    'Ohdi-oa' => 'Främre Asien',
    'Ohdi-oaf' => 'Palestina och Israel',
    'Ohdi-oafi' => 'Israel',
    'Ohdi-oah' => 'Arabiska halvön',
    'Ohdi-oas' => 'Syrianer',
    'Ohdi-oc' => 'Bortre Indien',
    'Ohdi-od' => 'Ostindiska öarna',
    'Ohdi-oe' => 'Östasien',
    'Ohdi-p' => 'Afrika',
    'Ohdi-q' => 'Amerika',
    'Ohdi-qa' => 'Förenta staterna',
    'Ohdi-qa:k' => 'Immigrationens historia',
    'Ohdi-qa:oe' => 'Immigrationslagstiftning',
    'Ohdi-qaz' => 'Särskilda orter',
    'Ohdi-qb' => 'Kanada',
    'Ohdi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohdi-qd' => 'Sydamerika',
    'Ohdi-qdb' => 'Venezuela',
    'Ohdi-qdc' => 'Guyanastaterna',
    'Ohdi-qdd' => 'Brasilien',
    'Ohdi-qdf' => 'Uruguay',
    'Ohdi-qdg' => 'Argentina',
    'Ohdi-qdh' => 'Chile',
    'Ohdi-qdl' => 'Ecuador',
    'Ohdi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohdi-ra' => 'Australien',
    'Ohdi-ra:k' => 'Immigrationens historia',
    'Ohdi-rb' => 'Nya Zeeland',
    'Ohdi-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ohdib' => 'Särskilda ålders- och könsgrupper av invandrare',
    'Ohdib-' => 'Allmänt: särskilda länder och områden',
    'Ohdib-a' => 'Europa: allmänt',
    'Ohdib-b' => 'Norden: allmänt',
    'Ohdib-c' => 'Sverige',
    'Ohdib-cz' => 'Särskilda orter',
    'Ohdib-d' => 'Övriga Norden',
    'Ohdib-da' => 'Danmark',
    'Ohdib-db' => 'Norge',
    'Ohdib-dd' => 'Finland',
    'Ohdib-e' => 'Brittiska öarna (Storbritannien)',
    'Ohdib-f' => 'Mellaneuropa (Tyskland)',
    'Ohdib-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohdib-j' => 'Frankrike och Monaco',
    'Ohdib-n' => 'Balkanländerna',
    'Ohdib-o' => 'Asien',
    'Ohdib-q' => 'Amerika',
    'Ohdib-qa' => 'Förenta staterna',
    'Ohdib-qb' => 'Kanada',
    'Ohdib-qd' => 'Sydamerika',
    'Ohe' => 'Minoriteter',
    'Ohe:k' => 'Allmänt: minoriteternas historia',
    'Ohe-' => 'Särskilda länder och områden',
    'Ohe-a' => 'Europa: allmänt',
    'Ohe-a:k' => 'Minoriteternas historia',
    'Ohe-ae' => 'Europeiska unionen (EU)',
    'Ohe-b' => 'Norden: allmänt',
    'Ohe-b:k' => 'Minoriteternas historia',
    'Ohe-c' => 'Sverige',
    'Ohe-c:k' => 'Minoriteternas historia',
    'Ohe-c:oe' => 'Minoritetsagstiftning',
    'Ohe-cs' => 'Samer',
    'Ohe-cs:k' => 'Minoriteternas historia',
    'Ohe-cz' => 'Särskilda orter',
    'Ohe-d' => 'Övriga Norden',
    'Ohe-da' => 'Danmark',
    'Ohe-db' => 'Norge',
    'Ohe-dd' => 'Finland',
    'Ohe-e' => 'Brittiska öarna (Storbritannien)',
    'Ohe-e:k' => 'Minoriteternas historia',
    'Ohe-e:oe' => 'Minoritetslagstiftning',
    'Ohe-ea' => 'England',
    'Ohe-et' => 'Irland',
    'Ohe-eta' => 'Irland (republiken)',
    'Ohe-etb' => 'Nordirland',
    'Ohe-f' => 'Mellaneuropa',
    'Ohe-fa' => 'Tyskland',
    'ohe-fa:k' => 'Minoriteternas historia',
    'Ohe-fag' => 'Västra Tyskland',
    'Ohe-fah' => 'Östra Tyskland',
    'Ohe-faz' => 'Särskilda orter',
    'Ohe-fb' => 'Österrike och Liechtenstein',
    'Ohe-fc' => 'Ungern',
    'Ohe-fd' => 'Tjeckien och Slovakien',
    'Ohe-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohe-ga' => 'Nederländerna',
    'Ohe-gb' => 'Belgien',
    'Ohe-h' => 'Schweiz',
    'Ohe-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohe-j' => 'Frankrike och Monaco',
    'Ohe-j:k' => 'Minoriteternas historia',
    'Ohe-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohe-l' => 'Portugal',
    'Ohe-m' => 'Östeuropa',
    'Ohe-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohe-ma:k' => 'Minoriteternas historia',
    'Ohe-mad' => 'Ukraina',
    'Ohe-mae' => 'Vitryssland',
    'Ohe-maf' => 'Moldavien',
    'Ohe-mb' => 'Polen',
    'Ohe-mb:k' => 'Minoriteternas historia',
    'Ohe-mc' => 'Estland, Lettland, Litauen',
    'Ohe-mca' => 'Estland',
    'Ohe-mcb' => 'Lettland',
    'Ohe-mcc' => 'Litauen',
    'Ohe-n' => 'Balkanländerna',
    'Ohe-na' => 'Rumänien',
    'Ohe-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohe-nba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Ohe-nbb' => 'Kroatien',
    'Ohe-nbc' => 'Slovenien',
    'Ohe-nbd' => 'Bosnien-Hercegovina',
    'Ohe-nbf' => 'Makedonien',
    'Ohe-nc' => 'Bulgarien',
    'Ohe-nd' => 'Grekland',
    'Ohe-nf' => 'Albanien',
    'Ohe-o' => 'Asien',
    'Ohe-oa' => 'Främre Asien',
    'Ohe-oaa' => 'Turkiet',
    'Ohe-oab' => 'Cypern',
    'Ohe-oaf' => 'Palestina och Israel',
    'Ohe-oafh' => 'Judar',
    'Ohe-oafi' => 'Israel',
    'Ohe-oag' => 'Jordanien',
    'Ohe-oah' => 'Arabiska halvön',
    'Ohe-oai' => 'Irak',
    'Ohe-oak' => 'Iran (Persien)',
    'Ohe-oal' => 'Afghanistan',
    'Ohe-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ohe-ob' => 'Främre Indien',
    'Ohe-oba' => 'Indien',
    'Ohe-obb' => 'Pakistan och Bangladesh',
    'Ohe-obba' => 'Pakistan',
    'Ohe-obbb' => 'Bangladesh',
    'Ohe-obc' => 'Bhutan',
    'Ohe-obd' => 'Nepal',
    'Ohe-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohe-oc' => 'Bortre Indien',
    'Ohe-oca' => 'Myanmar (f d Burma)',
    'Ohe-ocb' => 'Thailand',
    'Ohe-occ' => 'Malaysia, Singapore och Brunei',
    'Ohe-occa' => 'Malaysia',
    'Ohe-occb' => 'Singapore',
    'Ohe-ocd' => 'Indokina',
    'Ohe-ocda' => 'Laos',
    'Ohe-ocdc' => 'Vietnam',
    'Ohe-od' => 'Ostindiska öarna',
    'Ohe-oda' => 'Indonesien',
    'Ohe-odc' => 'Filippinerna',
    'Ohe-oe' => 'Östasien',
    'Ohe-oea' => 'Kina',
    'Ohe-oec' => 'Japan',
    'Ohe-oek' => 'Hongkong och Macau',
    'Ohe-of' => 'Centralasien',
    'Ohe-og' => 'Sibirien',
    'Ohe-p' => 'Afrika',
    'Ohe-pa' => 'Nordafrika utom Egypten',
    'Ohe-pb' => 'Egypten och Sudan',
    'Ohe-pba' => 'Egypten',
    'Ohe-pbb' => 'Sudan',
    'Ohe-pc' => 'Västafrika',
    'Ohe-pcb' => 'Ekvatorialfrika',
    'Ohe-pcc' => 'Norra Västafrika',
    'Ohe-pcd' => 'Södra Västafrika',
    'Ohe-pcda' => 'Ghana',
    'Ohe-pcdd' => 'Nigeria',
    'Ohe-pd' => 'Centralafrika',
    'Ohe-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Ohe-pdaa' => 'Kongo (Kinshasa)',
    'Ohe-pdab' => 'Rwanda',
    'Ohe-pdac' => 'Burundi',
    'Ohe-pe' => 'Södra Afrika',
    'Ohe-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohe-peaa' => 'Sydafrikanska republiken',
    'Ohe-peab' => 'Namibia',
    'Ohe-peac' => 'Lesotho',
    'Ohe-peb' => 'Botswana',
    'Ohe-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohe-peca' => 'Zimbabwe',
    'Ohe-pecb' => 'Zambia',
    'Ohe-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Ohe-pf' => 'Östafrika',
    'Ohe-pfa' => 'Uganda',
    'Ohe-pfb' => 'Kenya',
    'Ohe-pfc' => 'Tanzania',
    'Ohe-pg' => 'Nordöstafrika',
    'Ohe-pga' => 'Etiopien med Eritrea',
    'Ohe-pgb' => 'Somalia',
    'Ohe-pgc' => 'Djibouti',
    'Ohe-q' => 'Amerika',
    'Ohe-qa' => 'Förenta staterna',
    'Ohe-qa:k' => 'Minoriteternas historia',
    'Ohe-qa:k.' => 'Särskilda perioder',
    'Ohe-qa:k.4' => 'Nordamerika under nya tiden',
    'Ohe-qa:k.41' => 'Nordamerika före 1789',
    'Ohe-qa:k.46' => '1789-1865',
    'Ohe-qa:k.47' => '1865-1914',
    'Ohe-qa:k.5' => '1900-talet',
    'Ohe-qa:k.55' => '1945-',
    'Ohe-qa:k.57' => '1975-',
    'Ohe-qa:k.6' => '2000-',
    'Ohe-qaa' => 'Nordöstra staterna',
    'Ohe-qab' => 'Sydöstra staterna',
    'Ohe-qac' => 'Södra centralstaterna',
    'Ohe-qad' => 'Norra centralstaterna',
    'Ohe-qaf' => 'Stillahavsstaterna',
    'Ohe-qat' => 'Indianer i Nordamerika',
    'Ohe-qb' => 'Kanada',
    'Ohe-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohe-qca' => 'Mexiko',
    'Ohe-qcb' => 'Guatemala',
    'Ohe-qcc' => 'Belize och Honduras',
    'Ohe-qce' => 'Nicaragua',
    'Ohe-qcf' => 'Costa Rica',
    'Ohe-qcg' => 'Panama',
    'Ohe-qch' => 'Västindien',
    'Ohe-qcha' => 'Stora Antillerna (Kuba)',
    'Ohe-qchaa' => 'Kuba',
    'Ohe-qchad' => 'Puerto Rico',
    'Ohe-qchae' => 'Jamaica',
    'Ohe-qchb' => 'Små Antillerna',
    'Ohe-qct' => 'Indianer i Centralamerika',
    'Ohe-qd' => 'Sydamerika',
    'Ohe-qda' => 'Colombia',
    'Ohe-qdb' => 'Venezuela',
    'Ohe-qdc' => 'Guyanastaterna',
    'Ohe-qdd' => 'Brasilien',
    'Ohe-qde' => 'Paraguay',
    'Ohe-qdg' => 'Argentina',
    'Ohe-qdh' => 'Chile',
    'Ohe-qdi' => 'Bolivia',
    'Ohe-qdk' => 'Peru',
    'Ohe-qdl' => 'Ecuador',
    'Ohe-qdt' => 'Indianer i Sydamerika',
    'Ohe-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohe-ra' => 'Australien',
    'Ohe-rb' => 'Nya Zeeland',
    'Ohe-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ohe-rca' => 'Melanesien',
    'Ohe-rcb' => 'Polynesien',
    'Ohe-rcc' => 'Mikronesien',
    'Ohe-rd' => 'Nya Guinea',
    'Ohe-s' => 'Polarländerna',
    'Ohe-sa' => 'Arktis (Nordpolsområdet)',
    'Ohf' => 'Social omsorg',
    'Ohf:d' => 'Allmänt: teori,filosofi och metodlära',
    'Ohf:dd' => 'Metodlära',
    'Ohf-' => 'Allmänt: särskilda länder och områden',
    'Ohf-a' => 'Europa: allmänt',
    'Ohf-ae' => 'Europeiska unionen (EU)',
    'Ohf-b' => 'Norden: allmänt',
    'Ohf-c' => 'Sverige',
    'Ohf-c:bf' => 'Organisationer och institutioner',
    'Ohf-c:d' => 'Teori, filosofi och metodlära',
    'Ohf-c:k' => 'Historia',
    'Ohf-c:k.' => 'Särskilda perioder',
    'Ohf-c:k.5' => '1905-',
    'Ohf-c:k.6' => '2000-',
    'Ohf-c:oe' => 'Sociallagstiftning',
    'Ohf-c:oi' => 'Socialstatistik',
    'Ohf-ca' => 'Svealand',
    'Ohf-caa' => 'Stockholm och Stockholms län',
    'Ohf-cab' => 'Uppland och Uppsala län',
    'Ohf-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohf-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Ohf-cbi' => 'Göteborg',
    'Ohf-cc' => 'Norrland',
    'Ohf-ccg' => 'Västerbotten och Västerbottens län',
    'Ohf-cch' => 'Norrbotten och Norrbottens län',
    'Ohf-cs' => 'Samer',
    'Ohf-cz' => 'Särskilda orter',
    'Ohf-d' => 'Övriga Norden',
    'Ohf-da' => 'Danmark',
    'Ohf-db' => 'Norge',
    'Ohf-db:oe' => 'Sociallagstiftning',
    'Ohf-db:oi' => 'Socialstatistik',
    'Ohf-dd' => 'Finland',
    'Ohf-dd:oi' => 'Socialstatistik',
    'Ohf-e' => 'Brittiska öarna (Storbritannien)',
    'Ohf-e:k' => 'Historia',
    'Ohf-e:oe' => 'Sociallagstiftning',
    'Ohf-ea' => 'England',
    'Ohf-es' => 'Skottland',
    'Ohf-et' => 'Irland',
    'Ohf-f' => 'Mellaneuropa',
    'Ohf-fa' => 'Tyskland',
    'Ohf-fa:k' => 'Historia',
    'Ohf-fb' => 'Österrike och Liechtenstein',
    'Ohf-fc' => 'Ungern',
    'Ohf-fd' => 'Tjeckien och Slovakien',
    'Ohf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohf-ga' => 'Nederländerna',
    'Ohf-gb' => 'Belgien',
    'Ohf-h' => 'Schweiz',
    'Ohf-j' => 'Frankrike och Monaco',
    'Ohf-j:k' => 'Historia',
    'Ohf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohf-m' => 'Östeuropa',
    'Ohf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohf-mb' => 'Polen',
    'Ohf-mc' => 'Estland, Lettland, Litauen',
    'Ohf-n' => 'Balkanländerna',
    'Ohf-o' => 'Asien',
    'Ohf-oa' => 'Främre Asien',
    'Ohf-oaf' => 'Palestina och Israel',
    'Ohf-ob' => 'Främre Indien',
    'Ohf-oba' => 'Indien',
    'Ohf-oe' => 'Östasien',
    'Ohf-oea' => 'Kina',
    'Ohf-oec' => 'Japan',
    'Ohf-p' => 'Afrika',
    'Ohf-pb' => 'Egypten och Sudan',
    'Ohf-pe' => 'Södra Afrika',
    'Ohf-pf' => 'Östafrika',
    'Ohf-q' => 'Amerika',
    'Ohf-qa' => 'Förenta staterna',
    'Ohf-qa:k' => 'Historia',
    'Ohf-qb' => 'Kanada',
    'Ohf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohf-qd' => 'Sydamerika',
    'Ohf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohfa' => 'Socialhjälp',
    'Ohfa-a' => 'Europa: allmänt',
    'Ohfa-ae' => 'Europeiska unionen (EU)',
    'Ohfa-b' => 'Norden: allmänt',
    'Ohfa-c' => 'Sverige',
    'Ohfa-c:k' => 'Historia',
    'Ohfa-c:oe' => 'Lagstiftning',
    'Ohfa-c:oi' => 'Statistik',
    'Ohfa-cz' => 'Särskilda orter',
    'Ohfa-d' => 'Övriga Norden',
    'Ohfa-da' => 'Danmark',
    'Ohfa-db' => 'Norge',
    'Ohfa-dd' => 'Finland',
    'Ohfa-e' => 'Brittiska öarna (Storbritannien)',
    'Ohfa-f' => 'Mellaneuropa',
    'Ohfa-q' => 'Amerika',
    'Ohfb' => 'Barn- och ungdomsvård',
    'Ohfb:bf' => 'Internationella och frivilliga hjälporganisationer',
    'Ohfb:oe' => 'Lagstiftning',
    'Ohfb-' => 'Särskilda länder och områden',
    'Ohfb-a' => 'Europa: allmänt',
    'Ohfb-ae' => 'Europeiska unionen (EU)',
    'Ohfb-b' => 'Norden: allmänt',
    'Ohfb-c' => 'Sverige',
    'Ohfb-c:bf' => 'Organisationer och institutioner',
    'Ohfb-c:k' => 'Historia',
    'Ohfb-c:k.' => 'Särskilda perioder',
    'Ohfb-c:k.4' => 'Nya tiden 1520-',
    'Ohfb-c:k.43' => '1700-talet',
    'Ohfb-c:k.46' => '1800-talet',
    'Ohfb-c:k.49' => '1865-1905',
    'Ohfb-c:k.5' => '1905-',
    'Ohfb-c:k.6' => '2000-',
    'Ohfb-c:oe' => 'Lagstiftning',
    'Ohfb-c:oi' => 'Statistik',
    'Ohfb-ca' => 'Svealand',
    'Ohfb-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohfb-cc' => 'Norrland',
    'Ohfb-cs' => 'Samer',
    'Ohfb-cz' => 'Särskilda orter',
    'Ohfb-d' => 'Övriga Norden',
    'Ohfb-da' => 'Danmark',
    'Ohfb-db' => 'Norge',
    'Ohfb-db:oe' => 'Lagstiftning',
    'Ohfb-db:oi' => 'Statistik',
    'Ohfb-dc' => 'Island och Färöarna',
    'Ohfb-dd' => 'Finland',
    'Ohfb-e' => 'Brittiska öarna (Storbritannien)',
    'Ohfb-e:k' => 'Historia',
    'Ohfb-e:oe' => 'Lagstiftning',
    'Ohfb-ea' => 'England',
    'Ohfb-es' => 'Skottland',
    'Ohfb-et' => 'Irland',
    'Ohfb-f' => 'Mellaneuropa',
    'Ohfb-fa' => 'Tyskland',
    'Ohfb-fa:k' => 'Historia',
    'Ohfb-fag' => 'Västra Tyskland',
    'Ohfb-fah' => 'Östra Tyskland',
    'Ohfb-faz' => 'Särskilda orter',
    'Ohfb-fb' => 'Österrike och Liechtenstein',
    'Ohfb-fc' => 'Ungern',
    'Ohfb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohfb-h' => 'Schweiz',
    'Ohfb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohfb-j' => 'Frankrike och Monaco',
    'Ohfb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohfb-m' => 'Östeuropa',
    'Ohfb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohfb-mb' => 'Polen',
    'Ohfb-mc' => 'Estland, Lettland, Litauen',
    'Ohfb-n' => 'Balkanländerna',
    'Ohfb-o' => 'Asien',
    'Ohfb-oa' => 'Främre Asien',
    'Ohfb-oaf' => 'Palestina och Israel',
    'Ohfb-oafh' => 'Judar',
    'Ohfb-oafi' => 'Israel',
    'Ohfb-ob' => 'Främre Indien',
    'Ohfb-oc' => 'Bortre Indien',
    'Ohfb-od' => 'Ostindiska öarna',
    'Ohfb-oe' => 'Östasien',
    'Ohfb-oea' => 'Kina',
    'Ohfb-oec' => 'Japan',
    'Ohfb-p' => 'Afrika',
    'Ohfb-pa' => 'Nordafrika utom Egypten',
    'Ohfb-pb' => 'Egypten och Sudan',
    'Ohfb-pc' => 'Västafrika',
    'Ohfb-pd' => 'Centralafrika',
    'Ohfb-pe' => 'Södra Afrika',
    'Ohfb-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohfb-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohfb-pf' => 'Östafrika',
    'Ohfb-pg' => 'Nordöstafrika',
    'Ohfb-q' => 'Amerika',
    'Ohfb-qa' => 'Förenta staterna',
    'Ohfb-qa:k' => 'Historia',
    'Ohfb-qb' => 'Kanada',
    'Ohfb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohfb-qca' => 'Mexiko',
    'Ohfb-qcd' => 'El Salvador',
    'Ohfb-qch' => 'Västindien',
    'Ohfb-qd' => 'Sydamerika',
    'Ohfb-qdd' => 'Brasilien',
    'Ohfb-qdh' => 'Chile',
    'Ohfb-qdk' => 'Peru',
    'Ohfb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohfb-ra' => 'Australien',
    'Ohfb-rb' => 'Nya Zeeland',
    'Ohfb-s' => 'Polarländerna (Grönland)',
    'Ohfc' => 'Familjehjälp',
    'Ohfc-' => 'Särskilda länder och områden',
    'Ohfc-a' => 'Europa: allmänt',
    'Ohfc-ae' => 'Europeiska unionen (EU)',
    'Ohfc-b' => 'Norden: allmänt',
    'Ohfc-c' => 'Sverige',
    'Ohfc-c:k' => 'Historia',
    'Ohfc-c:oe' => 'Lagstiftning',
    'Ohfc-c:oi' => 'Statistik',
    'Ohfc-d' => 'Övriga Norden',
    'Ohfc-da' => 'Danmark',
    'Ohfc-db' => 'Norge',
    'Ohfc-dd' => 'Finland',
    'Ohfc-e' => 'Brittiska öarna (Storbritannien)',
    'Ohfc-f' => 'Mellaneuropa',
    'Ohfc-fa' => 'Tyskland',
    'Ohfc-fb' => 'Österrike och Liechtenstein',
    'Ohfc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohfc-h' => 'Schweiz',
    'Ohfc-j' => 'Frankrike och Monaco',
    'Ohfc-m' => 'Östeuropa',
    'Ohfc-n' => 'Balkanländerna',
    'Ohfc-o' => 'Asien',
    'Ohfc-p' => 'Afrika',
    'Ohfc-q' => 'Amerika',
    'Ohfc-qa' => 'Förenta staterna',
    'Ohfc-qb' => 'Kanada',
    'Ohfc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohfc-qd' => 'Sydamerika',
    'Ohfc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohfe' => 'Äldreomsorg',
    'Ohfe-' => 'Särskilda länder och områden',
    'Ohfe-a' => 'Europa: allmänt',
    'Ohfe-ae' => 'Europeiska unionen (EU)',
    'Ohfe-b' => 'Norden: allmänt',
    'Ohfe-c' => 'Sverige',
    'Ohfe-c:bf' => 'Organisationer och institutioner',
    'Ohfe-c:d' => 'Teori, filosofi och metodlära',
    'Ohfe-c:k' => 'Historia',
    'Ohfe-c:oe' => 'Lagstiftning',
    'Ohfe-c:oi' => 'Statistik',
    'Ohfe-ca' => 'Svealand',
    'Ohfe-caa' => 'Stockholm och Stockholms län',
    'Ohfe-cab' => 'Uppland och Uppsala län',
    'Ohfe-cad' => 'Närke och Örebro län',
    'Ohfe-cae' => 'Västmanland och Västmanlands län',
    'Ohfe-caf' => 'Dalarna och Dalarnas län',
    'Ohfe-cag' => 'Värmland och Värmlands län',
    'Ohfe-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohfe-cc' => 'Norrland',
    'Ohfe-cs' => 'Samer',
    'Ohfe-cz' => 'Särskilda orter',
    'Ohfe-d' => 'Övriga Norden',
    'Ohfe-da' => 'Danmark',
    'Ohfe-db' => 'Norge',
    'Ohfe-dd' => 'Finland',
    'Ohfe-ddz' => 'Särskilda orter',
    'Ohfe-e' => 'Brittiska öarna (Storbritannien)',
    'Ohfe-f' => 'Mellaneuropa',
    'Ohfe-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohfe-h' => 'Schweiz',
    'Ohfe-j' => 'Frankrike och Monaco',
    'Ohfe-m' => 'Östeuropa',
    'Ohfe-n' => 'Balkanländerna',
    'Ohfe-o' => 'Asien',
    'Ohfe-oa' => 'Främre Asien',
    'Ohfe-ob' => 'Främre Indien',
    'Ohfe-oc' => 'Bortre Indien',
    'Ohfe-oe' => 'Östasien',
    'Ohfe-p' => 'Afrika',
    'Ohfe-q' => 'Amerika',
    'Ohfe-qa' => 'Förenta staterna',
    'Ohfe-qb' => 'Kanada',
    'Ohfe-qd' => 'Sydamerika',
    'Ohfe-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohfh' => 'Handikappade',
    'Ohfh-' => 'Särskilda länder och områden',
    'Ohfh-a' => 'Europa: allmänt',
    'Ohfh-ae' => 'Europeiska unionen (EU)',
    'Ohfh-b' => 'Norden: allmänt',
    'Ohfh-c' => 'Sverige',
    'Ohfh-c:bf' => 'Organisationer och institutioner',
    'Ohfh-c:k' => 'Historia',
    'Ohfh-c:oe' => 'Lagstiftning',
    'Ohfh-c:oi' => 'Statistik',
    'Ohfh-ca' => 'Svealand',
    'Ohfh-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohfh-cc' => 'Norrland',
    'Ohfh-cz' => 'Särskilda orter',
    'Ohfh-d' => 'Övriga Norden',
    'Ohfh-da' => 'Danmark',
    'Ohfh-db' => 'Norge',
    'Ohfh-dc' => 'Island och Färöarna',
    'Ohfh-dd' => 'Finland',
    'Ohfh-e' => 'Brittiska öarna (Storbritannien)',
    'Ohfh-f' => 'Mellaneuropa',
    'Ohfh-j' => 'Frankrike och Monaco',
    'Ohfh-m' => 'Östeuropa',
    'Ohfh-o' => 'Asien',
    'Ohfh-p' => 'Afrika',
    'Ohfh-q' => 'Amerika',
    'Ohfh-qa' => 'Förenta staterna',
    'Ohfh-qb' => 'Kanada',
    'Ohfh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohfha' => 'Synskadade',
    'Ohfha-c' => 'Sverige',
    'Ohfha-c:bf' => 'Organisationer och institutioner',
    'Ohfha-o' => 'Asien',
    'Ohfha-p' => 'Afrika',
    'Ohfha-q' => 'Amerika',
    'Ohfhb' => 'Hörselskadade',
    'Ohfhb:k' => 'Allmänt: historia',
    'Ohfhb-b' => 'Norden: allmänt',
    'Ohfhb-c' => 'Sverige',
    'Ohfhb-c:bf' => 'Organisationer och institutioner',
    'Ohfhb-d' => 'Övriga Norden',
    'Ohfhb-q' => 'Amerika',
    'Ohfhc' => 'Psykiskt handikappade',
    'Ohfhc-a' => 'Europa: allmänt',
    'Ohfhc-b' => 'Norden: allmänt',
    'Ohfhc-c' => 'Sverige',
    'Ohfhc-c:bf' => 'Organisationer och institutioner',
    'Ohfhc-c:k' => 'Historia',
    'Ohfhc-c:oe' => 'Lagstiftning',
    'Ohfhc-d' => 'Övriga Norden',
    'Ohfhc-da' => 'Danmark',
    'Ohfhc-db' => 'Norge',
    'Ohfhc-dd' => 'Finland',
    'Ohfhc-e' => 'Brittiaska öarna (Storbritannien)',
    'Ohfhc-f' => 'Mellaneuropa',
    'Ohfhc-o' => 'Asien',
    'Ohfhc-q' => 'Amerika',
    'Ohfhf' => 'Rörelsehindrade',
    'Ohfhf-c' => 'Sverige',
    'Ohfhg' => 'Flerhandikappade',
    'Ohfhg-c' => 'Sverige',
    'Ohg' => 'Frivillig hjälpverksamhet',
    'Ohg:bf' => 'Allmänt: hjälporganisationer och -institutioner',
    'Ohg-' => 'Särskilda länder och områden',
    'Ohg-a' => 'Europa: allmänt',
    'Ohg-b' => 'Norden: allmänt',
    'Ohg-c' => 'Sverige',
    'Ohg-c:bf' => 'Organisationer och institutioner',
    'Ohg-c:k' => 'Historia',
    'Ohg-cs' => 'Samer',
    'Ohg-cz' => 'Särskilda orter',
    'Ohg-d' => 'Övriga Norden',
    'Ohg-da' => 'Danmark',
    'Ohg-db' => 'Norge',
    'Ohg-dd' => 'Finland',
    'Ohg-e' => 'Brittiska öarna (Storbritannien)',
    'Ohg-e:bf' => 'Organisationer och institutioner',
    'Ohg-e:k' => 'Historia',
    'Ohg-f' => 'Mellaneuropa',
    'Ohg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohg-j' => 'Frankrike och Monaco',
    'Ohg-m' => 'Östeuropa',
    'Ohg-n' => 'Balkanländerna',
    'Ohg-o' => 'Asien',
    'Ohg-oa' => 'Främre Asien',
    'Ohg-oaa' => 'Turkiet',
    'Ohg-oae' => 'Syrien och Libanon',
    'Ohg-oaf' => 'Palestina och Israel',
    'Ohg-oafh' => 'Judar',
    'Ohg-oafi' => 'Israel',
    'Ohg-ob' => 'Främre Indien',
    'Ohg-oba' => 'Indien',
    'Ohg-obb' => 'Pakistan och Bangladesh',
    'Ohg-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohg-oc' => 'Bortre Indien',
    'Ohg-od' => 'Ostindiska öarna',
    'Ohg-oe' => 'Östasien',
    'Ohg-p' => 'Afrika',
    'Ohg-q' => 'Amerika',
    'Ohg-qa' => 'Förenta staterna',
    'Ohg-qb' => 'Kanada',
    'Ohg-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohg-qd' => 'Sydamerika',
    'Ohg-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohi' => 'Alkohol-, narkotika- och nikotinfrågor',
    'Ohi-' => 'Allmänt: särskilda länder och områden',
    'Ohi-a' => 'Europa: allmänt',
    'Ohi-ae' => 'Europeiska unionen (EU)',
    'Ohi-b' => 'Norden: allmänt',
    'Ohi-c' => 'Sverige',
    'Ohi-c:bf' => 'Organisationer och institutioner',
    'Ohi-c:k' => 'Historia',
    'Ohi-c:oe' => 'Alkohol-, narkotika- och nikotinlagstiftning',
    'Ohi-c:oi' => 'Alkohol-, narkotika- och nikotinstatistik',
    'Ohi-ca' => 'Svealand',
    'Ohi-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohi-cc' => 'Norrland',
    'Ohi-cz' => 'Särskilda orter',
    'Ohi-d' => 'Övriga Norden',
    'Ohi-da' => 'Danmark',
    'Ohi-db' => 'Norge',
    'Ohi-dc' => 'Island och Färöarna',
    'Ohi-dd' => 'Finland',
    'Ohi-e' => 'Brittiska öarna (Storbritannien)',
    'Ohi-f' => 'Mellaneuropa',
    'Ohi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohi-h' => 'Schweiz',
    'Ohi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohi-j' => 'Frankrike och Monaco',
    'Ohi-m' => 'Östeuropa',
    'Ohi-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohi-mb' => 'Polen',
    'Ohi-mc' => 'Estland, Lettland, Litauen',
    'Ohi-o' => 'Asien',
    'Ohi-p' => 'Afrika',
    'Ohi-q' => 'Amerika',
    'Ohi-qa' => 'Förenta staterna',
    'Ohi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohi-qd' => 'Sydamerika',
    'Ohi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohi-s' => 'Polarländerna',
    'Ohia' => 'Alkoholfrågor',
    'Ohia-' => 'Särskilda länder och områden',
    'Ohia-a' => 'Europa: allmänt',
    'Ohia-ae' => 'Europeiska unionen (EU)',
    'Ohia-b' => 'Norden: allmänt',
    'Ohia-b:k' => 'Historia',
    'Ohia-c' => 'Sverige',
    'Ohia-c:bf' => 'Organisationer och institutioner',
    'Ohia-c:k' => 'Historia',
    'Ohia-c:k.' => 'Särskilda perioder',
    'Ohia-c:k.4' => 'Nya tiden 1520-',
    'Ohia-c:k.46' => '1800-talet',
    'Ohia-c:k.49' => '1865-1905',
    'Ohia-c:k.5' => '1905-',
    'Ohia-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohia-c:k.55' => '1945-',
    'Ohia-c:k.6' => '2000-',
    'Ohia-c:oe' => 'Alkoholagstiftning',
    'Ohia-c:oi' => 'Alkoholstatistik',
    'Ohia-ca' => 'Svealand',
    'Ohia-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohia-cc' => 'Norrland',
    'Ohia-cs' => 'Samer',
    'Ohia-cz' => 'Särskilda orter',
    'Ohia-d' => 'Övriga Norden',
    'Ohia-da' => 'Danmark',
    'Ohia-db' => 'Norge',
    'Ohia-dc' => 'Island och Färöarna',
    'Ohia-dd' => 'Finland',
    'Ohia-dd:k' => 'Historia',
    'Ohia-ddå' => 'Åland',
    'Ohia-e' => 'Brittiska öarna (Storbritannien)',
    'Ohia-f' => 'Mellaneuropa',
    'Ohia-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohia-j' => 'Frankrike och Monaco',
    'Ohia-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohia-m' => 'Östeuropa',
    'Ohia-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohia-mb' => 'Polen',
    'Ohia-o' => 'Asien',
    'Ohia-p' => 'Afrika',
    'Ohia-q' => 'Amerika',
    'Ohia-qa' => 'Förenta staterna',
    'Ohia-qa:bf' => 'Organisationer och institutioner',
    'Ohia-qa:k' => 'Historia',
    'Ohia-qb' => 'Kanada',
    'Ohia-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohia-s' => 'Polarländerna',
    'Ohib' => 'Narkotikafrågor',
    'Ohib-' => 'Särskilda länder och områden',
    'Ohib-a' => 'Europa: allmänt',
    'Ohib-ae' => 'Europeiska unionen (EU)',
    'Ohib-b' => 'Norden: allmänt',
    'Ohib-c' => 'Sverige',
    'Ohib-c:bf' => 'Organisationer och institutioner',
    'Ohib-c:k' => 'Historia',
    'Ohib-c:oe' => 'Narkotikalagstiftning',
    'Ohib-c:oi' => 'Narkotikastatistik',
    'Ohib-cz' => 'Särskilda orter',
    'Ohib-d' => 'Övriga Norden',
    'Ohib-da' => 'Danmark',
    'Ohib-db' => 'Norge',
    'Ohib-dd' => 'Finland',
    'Ohib-e' => 'Brittiska öarna (Storbritannien)',
    'Ohib-f' => 'Mellaneuropa',
    'Ohib-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohib-h' => 'Schweiz',
    'Ohib-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohib-j' => 'Frankrike och Monaco',
    'Ohib-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohib-m' => 'Östeuropa',
    'Ohib-n' => 'Balkanländerna',
    'Ohib-o' => 'Asien',
    'Ohib-p' => 'Afrika',
    'Ohib-q' => 'Amerika',
    'Ohib-qa' => 'Förenta staterna',
    'Ohib-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohib-qd' => 'Sydamerika',
    'Ohib-qda' => 'Colombia',
    'Ohib-qdd' => 'Brasilien',
    'Ohib-qdh' => 'Chile',
    'Ohib-qdi' => 'Bolivia',
    'Ohib-qdk' => 'Peru',
    'Ohic' => 'Nikotinfrågor',
    'Ohic-a' => 'Europa: allmänt',
    'Ohic-b' => 'Norden: allmänt',
    'Ohic-c' => 'Sverige',
    'Ohic-d' => 'Övriga Norden',
    'Ohic-e' => 'Brittiska öarna (Storbritannien)',
    'Ohic-q' => 'Amerika',
    'Ohj' => 'Genusfrågor',
    'Ohj:b' => 'Allmänt: könsrollsforskning',
    'Ohj:d' => 'Allmänt: könsrollsrollsteori och -filosofi',
    'Ohj:k' => 'Allmänt: könsrollshistoria',
    'Ohj:k.' => 'Särskilda perioder',
    'Ohj:k.2' => 'Forntiden',
    'Ohj:k.23' => 'Antikens historia: allmänt',
    'Ohj:k.24' => 'Den grekiska forntiden',
    'Ohj:k.26' => 'Den romerska forntiden',
    'Ohj:k.3' => 'Medeltiden (ca 500 - ca 1500)',
    'Ohj:k.4' => 'Nya tiden (ca 1500-)',
    'Ohj:k.46' => '1815-1914',
    'Ohj:k.5' => '1914-',
    'Ohj:k.6' => '2000-',
    'Ohj-' => 'Allmänt: särskilda länder och områden',
    'Ohj-a' => 'Europa: allmänt',
    'Ohj-a:k' => 'Könsrollsfrågornas historia',
    'Ohj-a:oe' => 'Könsrollslagstiftning',
    'Ohj-ae' => 'Europeiska unionen (EU)',
    'Ohj-ae:oe' => 'Könsrollslagstiftning',
    'Ohj-b' => 'Norden: allmänt',
    'Ohj-c' => 'Sverige',
    'Ohj-c:bf' => 'Organisationer och institutioner',
    'Ohj-c:k' => 'Könsrollshistoria',
    'Ohj-c:k.' => 'Särskilda perioder',
    'Ohj-c:k.4' => 'Nya tiden 1520-',
    'Ohj-c:k.42' => 'Stormaktstiden 1611-1718',
    'Ohj-c:k.43' => '1700-talet',
    'Ohj-c:k.46' => '1800-talet',
    'Ohj-c:k.49' => '1865-1905',
    'Ohj-c:k.5' => '1905-',
    'Ohj-c:k.6' => '2000-',
    'Ohj-c:oe' => 'Könsrollslagstiftning',
    'Ohj-c:oi' => 'Könsrollsstatistik',
    'Ohj-ca' => 'Svealand',
    'Ohj-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohj-cc' => 'Norrland',
    'Ohj-cs' => 'Samer',
    'Ohj-cz' => 'Särskilda orter',
    'Ohj-d' => 'Övriga Norden',
    'Ohj-da' => 'Danmark',
    'Ohj-db' => 'Norge',
    'Ohj-db:k' => 'Könsrollshistoria',
    'Ohj-dc' => 'Island och Färöarna',
    'Ohj-dd' => 'Finland',
    'Ohj-e' => 'Brittiska öarna (Storbritannien)',
    'Ohj-e:k' => 'Könsrollshistoria',
    'Ohj-e:k.' => 'Särskilda historiska perioder',
    'Ohj-e:k.2' => 'Före 1066',
    'Ohj-e:k.3' => 'Medeltiden 1066-1485',
    'Ohj-e:k.4' => 'Nya tiden 1485-',
    'Ohj-e:k.41' => '1485-1603',
    'Ohj-e:k.42' => '1603-1714',
    'Ohj-e:k.44' => '1714-1815',
    'Ohj-e:k.46' => '1800-1914',
    'Ohj-e:k.5' => '1914-',
    'Ohj-e:k.6' => '2000-',
    'Ohj-f' => 'Mellaneuropa',
    'Ohj-fa' => 'Tyskland',
    'Ohj-fa:k' => 'Könsrollshistoria',
    'Ohj-fag' => 'Västra Tyskland',
    'Ohj-fah' => 'Östra Tyskland',
    'Ohj-fb' => 'Österrike och Liechtenstein',
    'Ohj-fc' => 'Ungern',
    'Ohj-fd' => 'Tjeckien och Slovakien',
    'Ohj-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohj-ga' => 'Nederländerna',
    'Ohj-gb' => 'Belgien',
    'Ohj-h' => 'Schweiz',
    'Ohj-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohj-j' => 'Frankrike och Monaco',
    'Ohj-j:k' => 'Könsrollshistoria',
    'Ohj-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohj-l' => 'Portugal',
    'Ohj-m' => 'Östeuropa',
    'Ohj-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohj-mb' => 'Polen',
    'Ohj-mc' => 'Estland, Lettland, Litauen',
    'Ohj-n' => 'Balkanländerna',
    'Ohj-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohj-nc' => 'Bulgarien',
    'Ohj-nd' => 'Grekland',
    'Ohj-nf' => 'Albanien',
    'Ohj-o' => 'Asien',
    'Ohj-oa' => 'Främre Asien',
    'Ohj-oaa' => 'Turkiet',
    'Ohj-oab' => 'Cypern',
    'Ohj-oae' => 'Syrien och Libanon',
    'Ohj-oaf' => 'Palestina och Israel',
    'Ohj-oah' => 'Arabiska halvön',
    'Ohj-oai' => 'Irak',
    'Ohj-oak' => 'Iran (Persien)',
    'Ohj-oal' => 'Afghanistan',
    'Ohj-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ohj-ob' => 'Främre Indien',
    'Ohj-oba' => 'Indien',
    'Ohj-obb' => 'Pakistan och Bangladesh',
    'Ohj-obd' => 'Nepal',
    'Ohj-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohj-oc' => 'Bortre Indien',
    'Ohj-ocb' => 'Thailand',
    'Ohj-occ' => 'Malaysia, Singapore och Brunei',
    'Ohj-ocd' => 'Indokina',
    'Ohj-od' => 'Ostindiska öarna',
    'Ohj-oe' => 'Östasien',
    'Ohj-oea' => 'Kina',
    'Ohj-oeb' => 'Korea',
    'Ohj-oec' => 'Japan',
    'Ohj-oek' => 'Hongkong och Macau',
    'Ohj-p' => 'Afrika',
    'Ohj-pa' => 'Nordafrika utom Egypten',
    'Ohj-paa' => 'Marocko och Kanarieöarna',
    'Ohj-pab' => 'Algeriet',
    'Ohj-pac' => 'Tunisien',
    'Ohj-pad' => 'Libyen',
    'Ohj-pb' => 'Egypten och Sudan',
    'Ohj-pba' => 'Egypten',
    'Ohj-pbb' => 'Sudan',
    'Ohj-pc' => 'Västafrika',
    'Ohj-pcb' => 'Ekvatorialfrika',
    'Ohj-pcc' => 'Norra Västafrika',
    'Ohj-pcd' => 'Södra Västafrika',
    'Ohj-pcda' => 'Ghana',
    'Ohj-pcdb' => 'Togo',
    'Ohj-pcdd' => 'Nigeria',
    'Ohj-pd' => 'Centralafrika',
    'Ohj-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Ohj-pdb' => 'Angola',
    'Ohj-pe' => 'Södra Afrika',
    'Ohj-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohj-peaa' => 'Sydafrikanska republiken',
    'Ohj-peab' => 'Namibia',
    'Ohj-peac' => 'Lesotho',
    'Ohj-peb' => 'Botswana',
    'Ohj-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohj-peca' => 'Zimbabwe',
    'Ohj-pecb' => 'Zambia',
    'Ohj-ped' => 'Mocambique',
    'Ohj-pf' => 'Östafrika',
    'Ohj-pfa' => 'Uganda',
    'Ohj-pfb' => 'Kenya',
    'Ohj-pfc' => 'Tanzania',
    'Ohj-pg' => 'Nordöstafrika',
    'Ohj-q' => 'Amerika',
    'Ohj-qa' => 'Förenta staterna',
    'Ohj-qa:k' => 'Könsrollshistoria',
    'Ohj-qa:oe' => 'Könsrollslagstiftning',
    'Ohj-qat' => 'Indianer i Nordamerika',
    'Ohj-qb' => 'Kanada',
    'Ohj-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohj-qca' => 'Mexiko',
    'Ohj-qce' => 'Nicaragua',
    'Ohj-qch' => 'Västindien',
    'Ohj-qcha' => 'Stora Antillerna (Kuba)',
    'Ohj-qchaa' => 'Kuba',
    'Ohj-qchac' => 'Dominikanska republiken',
    'Ohj-qchb' => 'Små Antillerna',
    'Ohj-qct' => 'Indianer i Centralamerika',
    'Ohj-qd' => 'Sydamerika',
    'Ohj-qda' => 'Colombia',
    'Ohj-qdb' => 'Venezuela',
    'Ohj-qdd' => 'Brasilien',
    'Ohj-qde' => 'Paraguay',
    'Ohj-qdf' => 'Uruguay',
    'Ohj-qdg' => 'Argentina',
    'Ohj-qdh' => 'Chile',
    'Ohj-qdi' => 'Bolivia',
    'Ohj-qdk' => 'Peru',
    'Ohj-qdl' => 'Ecuador',
    'Ohj-qdt' => 'Indianer i Sydamerika',
    'Ohj-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohj-ra' => 'Australien',
    'Ohj-rb' => 'Nya Zeeland',
    'Ohj-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ohj-rd' => 'Nya Guinea',
    'Ohja' => 'Kvinnofrågor',
    'Ohja(x)' => 'Kvinnolexikon',
    'Ohja:b' => 'Kvinnoforskning',
    'Ohja:d' => 'Kvinnoforskningens teori och filosofi',
    'Ohja:k' => 'Kvinnohistoria',
    'Ohja:k.' => 'Särskilda perioder',
    'Ohja:k.2' => 'Forntiden',
    'Ohja:k.21' => 'Egypten',
    'Ohja:k.22' => 'Främre Asien',
    'Ohja:k.23' => 'Antikens historia: allmänt',
    'Ohja:k.24' => 'Den grekiska forntiden',
    'Ohja:k.26' => 'Den romerska forntiden',
    'Ohja:k.261' => 'Konungatiden och republiken till 31 f Kr',
    'Ohja:k.264' => 'Kejsartiden 31 f Kr - 476 e Kr',
    'Ohja:k.268' => 'Italien (utom Romerska riket)',
    'Ohja:k.269' => 'Romerska rikets provinser',
    'Ohja:k.29' => 'Germanerna under forntiden',
    'Ohja:k.3' => 'Medeltiden',
    'Ohja:k.31' => 'Bysantinska riket 395-1453',
    'Ohja:k.33' => 'Äldre medeltiden ca 476 - 1050',
    'Ohja:k.35' => 'Högmedeltiden ca 1050 - 1300',
    'Ohja:k.38' => 'Senmedeltiden ca 1300 - 1500',
    'Ohja:k.4' => 'Nya tiden',
    'Ohja:k.41' => '1500-1648',
    'Ohja:k.43' => '1648-1789',
    'Ohja:k.46' => '1815-1914',
    'Ohja:k.5' => '1900-',
    'Ohja:k.51' => 'Första världskriget 1914-1918',
    'Ohja:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohja:k.54' => 'Andra världskriget 1939-1945',
    'Ohja:k.55' => '1945-',
    'Ohja:k.58' => '1980-',
    'Ohja:k.6' => '2000-',
    'Ohja:oe' => 'Kvinnoloagstiftning',
    'Ohja-' => 'Särskilda länder och områden',
    'Ohja-a' => 'Europa: allmänt',
    'Ohja-a:k' => 'Kvinnohistoria',
    'Ohja-a:k.' => 'Särskilda perioder',
    'Ohja-a:k.2' => 'Forntiden',
    'Ohja-a:k.3' => 'Medeltiden',
    'Ohja-a:k.4' => 'Nya tiden',
    'Ohja-a:k.5' => '1914-',
    'Ohja-a:k.6' => '2000-',
    'Ohja-ae' => 'Europeiska unionen (EU)',
    'Ohja-ae:oe' => 'Kvinnolagstiftning',
    'Ohja-ak' => 'Kelter',
    'Ohja-b' => 'Norden: allmänt',
    'Ohja-b:k' => 'Kvinnohistoria',
    'Ohja-b:oe' => 'Kvinnolagstiftning',
    'Ohja-bc' => 'Nordkalotten',
    'Ohja-d' => 'Övriga Norden',
    'Ohja-da' => 'Danmark',
    'Ohja-da:bf' => 'Organisationer och institutioner',
    'Ohja-da:k' => 'Kvinnohistoria',
    'Ohja-db' => 'Norge',
    'Ohja-db:k' => 'Kvinnohistoria',
    'Ohja-db:oe' => 'Kvinnolagstiftning',
    'Ohja-dc' => 'Island och Färöarna',
    'Ohja-dcf' => 'Färöarna',
    'Ohja-dd' => 'Finland',
    'Ohja-dd:bf' => 'Organisationer och institutioner',
    'Ohja-dd:k' => 'Kvinnohistoria',
    'Ohja-ddå' => 'Åland',
    'Ohja-e' => 'Brittiska öarna (Storbritannien)',
    'Ohja-e:k' => 'Kvinnohistoria',
    'Ohja-e:k.' => 'Särskilda historiska perioder',
    'Ohja-e:k.2' => 'Före 1066',
    'Ohja-e:k.3' => 'Medeltiden 1066-1485',
    'Ohja-e:k.4' => 'Nya tiden 1485-',
    'Ohja-e:k.41' => '1485-1603',
    'Ohja-e:k.42' => '1603-1714',
    'Ohja-e:k.44' => '1714-1815',
    'Ohja-e:k.46' => '1800-1914',
    'Ohja-e:k.5' => '1914-',
    'Ohja-e:k.51' => 'Första världskriget 1914-1918',
    'Ohja-e:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohja-e:k.54' => 'Andra världskriget 1939-1945',
    'Ohja-e:k.55' => '1945-',
    'Ohja-e:k.58' => '1980-',
    'Ohja-e:k.59' => '1994-',
    'Ohja-e:k.6' => '2000-',
    'Ohja-es' => 'Skottland',
    'Ohja-et' => 'Irland',
    'Ohja-eta' => 'Irland (republiken)',
    'Ohja-etb' => 'Nordirland',
    'Ohja-f' => 'Mellaneuropa',
    'Ohja-fa' => 'Tyskland',
    'Ohja-fa:k' => 'Kvinnohistoria',
    'Ohja-fa:k.' => 'Särskilda perioder',
    'Ohja-fa:k.3' => '843 - ca 1500',
    'Ohja-fa:k.4' => 'Ca 1500-',
    'Ohja-fa:k.41' => '1500-1648',
    'Ohja-fa:k.43' => '1648-1806',
    'Ohja-fa:k.46' => '1806-1870',
    'Ohja-fa:k.47' => '1870-1918',
    'Ohja-fa:k.5' => '1900-talet',
    'Ohja-fa:k.51' => 'Första världskriget 1914-1918',
    'Ohja-fa:k.52' => '1918-1933',
    'Ohja-fa:k.53' => '1933-1945',
    'Ohja-fa:k.54' => 'Andra världskriget 1939-1945',
    'Ohja-fa:k.55' => '1945-',
    'Ohja-fa:k.59' => '1990-',
    'Ohja-fa:k.6' => '2000-',
    'Ohja-fag' => 'Västra Tyskland',
    'Ohja-fah' => 'Östra Tyskland',
    'Ohja-fai' => 'Berlin',
    'Ohja-fb' => 'Österrike och Liechtenstein',
    'Ohja-fb:k' => 'Kvinnohistoria',
    'Ohja-fc' => 'Ungern',
    'Ohja-fd' => 'Tjeckien och Slovakien',
    'Ohja-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohja-ga' => 'Nederländerna',
    'Ohja-gb' => 'Belgien',
    'Ohja-h' => 'Schweiz',
    'Ohja-h:k' => 'Kvinnohistoria',
    'Ohja-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohja-i:k' => 'Kvinnohistoria',
    'Ohja-j' => 'Frankrike och Monaco',
    'Ohja-j:k' => 'Kvinnohistoria',
    'Ohja-j:k.' => 'Särskilda historiska perioder',
    'Ohja-j:k.2' => 'Före 987',
    'Ohja-j:k.3' => 'Medeltiden 987-1498',
    'Ohja-j:k.4' => 'Nya tiden 1498-',
    'Ohja-j:k.41' => '1498-1610',
    'Ohja-j:k.42' => '1610-1715',
    'Ohja-j:k.44' => '1715-1789',
    'Ohja-j:k.45' => 'Franska revolutionen och Napoleon 1789-1815',
    'Ohja-j:k.46' => '1815-1870',
    'Ohja-j:k.47' => '1870-1914',
    'Ohja-j:k.5' => '1914-',
    'Ohja-j:k.51' => 'Första världskriget 1914-1918',
    'Ohja-j:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohja-j:k.54' => 'Andra världskriget 1939-1945',
    'Ohja-j:k.55' => '1945-',
    'Ohja-j:k.58' => '1981-',
    'Ohja-j:k.6' => '2000-',
    'Ohja-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohja-k:k' => 'Kvinnohistoria',
    'Ohja-k:k.' => 'Särskilda perioder (exkl Spanien som del av det arabiska väldet)',
    'Ohja-k:k.3' => 'Medeltiden 711-1479',
    'Ohja-k:k.4' => 'Nya tiden 1479-',
    'Ohja-k:k.41' => '1479-1648',
    'Ohja-k:k.43' => '1648-1789',
    'Ohja-k:k.45' => '1789-1815',
    'Ohja-k:K.46' => '1815-1914',
    'Ohja-k:k.5' => '1900-talet',
    'Ohja-k:k.6' => '2000-',
    'Ohja-l' => 'Portugal',
    'Ohja-m' => 'Östeuropa',
    'Ohja-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohja-ma:k' => 'Kvinnorhistoria',
    'Ohja-mb' => 'Polen',
    'Ohja-mb:k' => 'Kvinnohistoria',
    'Ohja-mc' => 'Estland, Lettland, Litauen',
    'Ohja-mca' => 'Estland',
    'Ohja-mcb' => 'Lettland',
    'Ohja-mcc' => 'Litauen',
    'Ohja-n' => 'Balkanländerna',
    'Ohja-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Ohja-nd' => 'Grekland',
    'Ohja-nf' => 'Albanien',
    'Ohja-o' => 'Asien',
    'Ohja-oa' => 'Främre Asien',
    'Ohja-oaa' => 'Turkiet',
    'Ohja-oaa:k' => 'Kvinnohistoria',
    'Ohja-oac' => 'Kaukasien',
    'Ohja-oae' => 'Syrien och Libanon',
    'Ohja-oaf' => 'Palestina och Israel',
    'Ohja-oafh' => 'Judar',
    'Ohja-oafh:k' => 'Kvinnohistoria',
    'Ohja-oafi' => 'Israel',
    'Ohja-oag' => 'Jordanien',
    'Ohja-oah' => 'Arabiska halvön',
    'Ohja-oaha' => 'Saudi-Arabien',
    'Ohja-oahb' => 'Nordjemen',
    'Ohja-oahc' => 'Sydjemen',
    'Ohja-oahd' => 'Oman',
    'Ohja-oahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Ohja-oahf' => 'Kuwait',
    'Ohja-oai' => 'Irak',
    'Ohja-oaj' => 'Kurder',
    'Ohja-oak' => 'Iran (Persien)',
    'Ohja-oak:k' => 'Kvinnohistoria',
    'Ohja-oal' => 'Afghanistan',
    'Ohja-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Ohja-ob' => 'Främre Indien',
    'Ohja-oba' => 'Indien',
    'Ohja-oba:k' => 'Kvinnohistoria',
    'Ohja-obb' => 'Pakistan och Bangladesh',
    'Ohja-obba' => 'Pakistan',
    'Ohja-obbb' => 'Bangladesh',
    'Ohja-obd' => 'Nepal',
    'Ohja-obe' => 'Sri Lanka (f d Ceylon)',
    'Ohja-oc' => 'Bortre Indien',
    'Ohja-oca' => 'Myanmar (f d Burma)',
    'Ohja-ocb' => 'Thailand',
    'Ohja-occ' => 'Malaysia, Singapore och Brunei',
    'Ohja-ocd' => 'Indokina',
    'Ohja-ocda' => 'Laos',
    'Ohja-ocdb' => 'Kambodja',
    'Ohja-ocdc' => 'Vietnam',
    'Ohja-od' => 'Ostindiska öarna',
    'Ohja-oda' => 'Indonesien',
    'Ohja-odc' => 'Filippinerna',
    'Ohja-oe' => 'Östasien',
    'Ohja-oea' => 'Kina',
    'Ohja-oea:k' => 'Kvinnohistoria',
    'Ohja-oeb' => 'Korea',
    'Ohja-oec' => 'Japan',
    'Ohja-oec:k' => 'Kvinnohistoria',
    'Ohja-oek' => 'Hongkong och Macau',
    'Ohja-of' => 'Centralasien',
    'Ohja-og' => 'Sibirien',
    'Ohja-p' => 'Afrika',
    'Ohja-pa' => 'Nordafrika utom Egypten',
    'Ohja-paa' => 'Marocko och Kanarieöarna',
    'Ohja-pab' => 'Algeriet',
    'Ohja-pac' => 'Tunisien',
    'Ohja-pad' => 'Libyen',
    'Ohja-pb' => 'Egypten och Sudan',
    'Ohja-pba' => 'Egypten',
    'Ohja-pba:k' => 'Kvinnohistoria',
    'Ohja-pbb' => 'Sudan',
    'Ohja-pc' => 'Västafrika',
    'Ohja-pcb' => 'Ekvatorialfrika',
    'Ohja-pcc' => 'Norra Västafrika',
    'Ohja-pcca' => 'Västra Sahara',
    'Ohja-pccc' => 'Senegal',
    'Ohja-pccd' => 'Gambia',
    'Ohja-pcce' => 'Mali',
    'Ohja-pccg' => 'Burkina Faso',
    'Ohja-pccm' => 'Sierra Leone',
    'Ohja-pccn' => 'Liberia',
    'Ohja-pcd' => 'Södra Västafrika',
    'Ohja-pcda' => 'Ghana',
    'Ohja-pcdb' => 'Togo',
    'Ohja-pcdc' => 'Benin',
    'Ohja-pcdd' => 'Nigeria',
    'Ohja-pd' => 'Centralafrika',
    'Ohja-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Ohja-pdb' => 'Angola',
    'Ohja-pe' => 'Södra Afrika',
    'Ohja-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ohja-peaa' => 'Sydafrikanska republiken',
    'Ohja-peab' => 'Namibia',
    'Ohja-peac' => 'Lesotho',
    'Ohja-pead' => 'Swaziland',
    'Ohja-peb' => 'Botswana',
    'Ohja-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ohja-peca' => 'Zimbabwe',
    'Ohja-pecb' => 'Zambia',
    'Ohja-pecc' => 'Malawi',
    'Ohja-ped' => 'Mocambique',
    'Ohja-pee' => 'Madagaskar (Malagasy)',
    'Ohja-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Ohja-pf' => 'Östafrika',
    'Ohja-pfa' => 'Uganda',
    'Ohja-pfb' => 'Kenya',
    'Ohja-pfc' => 'Tanzania',
    'Ohja-pg' => 'Nordöstafrika',
    'Ohja-pga' => 'Etiopien med Eritrea',
    'Ohja-pgb' => 'Somalia',
    'Ohja-q' => 'Amerika',
    'Ohja-qa' => 'Förenta staterna',
    'Ohja-qa:k' => 'Kvinnohistoria',
    'Ohja-qa:k.' => 'Särskilda historiska perioder',
    'Ohja-qa:k.4' => 'Nordamerika under nya tiden',
    'Ohja-qa:k.41' => 'Nordamerika före 1789',
    'Ohja-qa:k.46' => '1789-1865',
    'Ohja-qa:K.47' => '1865-1914',
    'Ohja-qa:k.5' => '1900-talet',
    'Ohja-qa:k.51' => 'Första världskriget 1914-1918',
    'Ohja-qa:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohja-qa:k.54' => 'Andra världskriget 1939-1945',
    'Ohja-qa:k.55' => '1945-',
    'Ohja-qa:k.57' => '1975-',
    'Ohja-qa:k.59' => '1990-',
    'Ohja-qa:k.6' => '2000-',
    'Ohja-qa:oe' => 'Kvinnolagstiftning',
    'Ohja-qat' => 'Indianer i Nordamerika',
    'Ohja-qb' => 'Kanada',
    'Ohja-qb:k' => 'Kvinnohistoria',
    'Ohja-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohja-qca' => 'Mexiko',
    'Ohja-qca:k' => 'Kvinnohistoria',
    'Ohja-qcb' => 'Guatemala',
    'Ohja-qcc' => 'Belize och Honduras',
    'Ohja-qcd' => 'El Salvador',
    'Ohja-qce' => 'Nicaragua',
    'Ohja-qcf' => 'Costa Rica',
    'Ohja-qcg' => 'Panama',
    'Ohja-qch' => 'Västindien',
    'Ohja-qcha' => 'Stora Antillerna (Kuba)',
    'Ohja-qchaa' => 'Kuba',
    'Ohja-qchac' => 'Dominikanska republiken',
    'Ohja-qchad' => 'Puerto Rico',
    'Ohja-qchb' => 'Små Antillerna',
    'Ohja-qct' => 'Indianer i Centralamerika',
    'Ohja-qd' => 'Sydamerika',
    'Ohja-qda' => 'Colombia',
    'Ohja-qdb' => 'Venezuela',
    'Ohja-qdc' => 'Guyanastaterna',
    'Ohja-qdd' => 'Brasilien',
    'Ohja-qdd:k' => 'Kvinnohistoria',
    'Ohja-qdg:k' => 'Kvinnohistoria',
    'Ohja-qde' => 'Paraguay',
    'Ohja-qdf' => 'Uruguay',
    'Ohja-qdg' => 'Argentina',
    'Ohja-qdh' => 'Chile',
    'Ohja-qdi' => 'Bolivia',
    'Ohja-qdk' => 'Peru',
    'Ohja-qdl' => 'Ecuador',
    'Ohja-qdt' => 'Indianer i Sydamerika',
    'Ohja-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohja-ra' => 'Australien',
    'Ohja-ra:k' => 'Kvinnohistoria',
    'Ohja-rb' => 'Nya Zeeland',
    'Ohja-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ohja-rd' => 'Nya Guinea',
    'Ohja-s' => 'Polarländerna',
    'Ohja-c' => 'Sverige',
    'Ohja-c:k' => 'Kvinnohistoria',
    'Ohja-c:k.' => 'Särskilda perioder',
    'Ohja-c:k.2' => 'Forntiden till ca 1060',
    'Ohja-c:k.3' => 'Medeltiden ca 1060-1520',
    'Ohja-c:k.4' => 'Nya tiden 1520-',
    'Ohja-c:k.42' => 'Stormaktstiden 1611-1718',
    'Ohja-c:k.43' => '1700-talet',
    'Ohja-c:k.44' => 'Frihetstiden 1718-1772',
    'Ohja-c:k.45' => 'Gustavianska tiden 1772-1809',
    'Ohja-c:k.46' => '1800-talet',
    'Ohja-c:k.47' => '1809-1844',
    'Ohja-c:k.48' => '1844-1865',
    'Ohja-c:k.49' => '1865-1905',
    'Ohja-c:k.5' => '1905-',
    'Ohja-c:k.51' => 'Första världskriget 1914-1918',
    'Ohja-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Ohja-c:k.55' => '1945-',
    'Ohja-c:k.58' => '1980-',
    'Ohja-c:k.59' => '1994-',
    'Ohja-c:k.6' => '2000-',
    'Ohja-c:oe' => 'Kvinnolagstiftning',
    'Ohja-c:oi' => 'Kvinnostatistik',
    'Ohja-ca' => 'Svealand',
    'Ohja-cb' => 'Götaland (inkl. Västra Götalands län)',
    'Ohja-cc' => 'Norrland',
    'Ohja-cs' => 'Samer',
    'Ohja-cz' => 'Särskilda orter',
    'Ohja-c:bf' => 'Institutioner och organisationer',
    'Ohjb' => 'Mansfrågor',
    'Ohjb:b' => 'Mansforskning',
    'Ohjb:k' => 'Manshistoria',
    'Ohjb-' => 'Särskilda länder och områden',
    'Ohjb-a' => 'Europa: allmänt',
    'Ohjb-b' => 'Norden: allmänt',
    'Ohjb-c' => 'Sverige',
    'Ohjb-c:k' => 'Manshistoria',
    'Ohjb-d' => 'Övriga Norden',
    'Ohjb-e' => 'Brittiska öarna (Storbritannien)',
    'Ohjb-e:k' => 'Manshistoria',
    'Ohjb-f' => 'Mellaneuropa',
    'Ohjb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohjb-j' => 'Frankrike och Monaco',
    'Ohjb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohjb-l' => 'Portugal',
    'Ohjb-m' => 'Östeuropa',
    'Ohjb-n' => 'Balkanländerna',
    'Ohjb-o' => 'Asien',
    'Ohjb-p' => 'Afrika',
    'Ohjb-q' => 'Amerika',
    'Ohjb-qa' => 'Förenta staterna',
    'Ohjb-qa:k' => 'Manshistoria',
    'Ohjb-qb' => 'Kanada',
    'Ohjb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohjb-qd' => 'Sydamerika',
    'Ohjb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohjh' => 'Homosexuella, bisexuella, transpersoner (HBT)',
    'Ohjh(x)' => 'Lexikon',
    'Ohjh:d' => 'Teori och filosofi',
    'Ohjh:k' => 'Historia',
    'Ohjh:k.' => 'Särskilda länder och områden',
    'Ohjh:k.2' => 'Forntiden',
    'Ohjh:k.23' => 'Antikens historia: allmänt',
    'Ohjh:k.24' => 'Den grekiska forntiden',
    'Ohjh:k.26' => 'Den romerska forntiden',
    'Ohjh:k.3' => 'Medeltiden',
    'Ohjh:k.4' => 'Nya tiden',
    'Ohjh:k.5' => '1900-',
    'Ohjh:k.6' => '2000-',
    'Ohjh-' => 'Allmänt: särskilda länder och områden',
    'Ohjh-a' => 'Europa: allmänt',
    'Ohjh-b' => 'Norden: allmänt',
    'Ohjh-c' => 'Sverige',
    'Ohjh-c:bf' => 'Organisationer och institutioner',
    'Ohjh-c:k' => 'Historia',
    'Ohjh-c:k.' => 'Särskilda perioder',
    'Ohjh-c:k.4' => 'Nya tiden 1520-',
    'Ohjh-c:k.5' => '1905-',
    'Ohjh-c:k.6' => '2000-',
    'Ohjh-c:oe' => 'Lagstiftning',
    'Ohjh-cz' => 'Särskilda orter',
    'Ohjh-d' => 'Övriga Norden',
    'Ohjh-e' => 'Brittiska öarna (Storbritannien)',
    'Ohjh-e:k' => 'Historia',
    'Ohjh-f' => 'Mellaneuropa',
    'Ohjh-fa' => 'Tyskland',
    'Ohjh-fb' => 'Österrike och Liechtenstein',
    'Ohjh-fc' => 'Ungern',
    'Ohjh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohjh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ohjh-j' => 'Frankrike och Monaco',
    'Ohjh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ohjh-l' => 'Portugal',
    'Ohjh-m' => 'Östeuropa',
    'Ohjh-n' => 'Balkanländerna',
    'Ohjh-o' => 'Asien',
    'Ohjh-p' => 'Afrika',
    'Ohjh-q' => 'Amerika',
    'Ohjh-qa' => 'Förenta staterna',
    'Ohjh-qa:k' => 'Historia',
    'Ohjh-qat' => 'Indianer i Nordamerika',
    'Ohjh-qb' => 'Kanada',
    'Ohjh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ohjh-qd' => 'Sydamerika',
    'Ohjh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohk' => 'Fritidsverksamhet',
    'Ohk:oa' => 'Fritidens sociologi',
    'Ohk-' => 'Särskilda länder och områden',
    'Ohk-a' => 'Europa: allmänt',
    'Ohk-b' => 'Norden: allmänt',
    'Ohk-c' => 'Sverige',
    'Ohk-c:bf' => 'Organisationer och institutioner',
    'Ohk-c:k' => 'Fritidens historia',
    'Ohk-c:oa' => 'Fritidens sociologi',
    'Ohk-c:oi' => 'Fritidstatistik',
    'Ohk-ca' => 'Svealand',
    'Ohk-cb' => 'Götaland (inkl Västra Götalands län)',
    'Ohk-cc' => 'Norrland',
    'Ohk-cz' => 'Särskilda orter',
    'Ohk-d' => 'Övriga Norden',
    'Ohk-da' => 'Danmark',
    'Ohk-db' => 'Norge',
    'Ohk-dd' => 'Finland',
    'Ohk-e' => 'Brittiska öarna (Storbritannien)',
    'Ohk-e:k' => 'Fritidens historia',
    'Ohk-f' => 'Mellaneuropa',
    'Ohk-fa' => 'Tyskland',
    'Ohk-fb' => 'Österrike och Liechtenstein',
    'Ohk-fc' => 'Ungern',
    'Ohk-fd' => 'Tjeckien och Slovakien',
    'Ohk-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ohk-j' => 'Frankrike och Monaco',
    'Ohk-m' => 'Östeuropa',
    'Ohk-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ohk-mb' => 'Polen',
    'Ohk-mc' => 'Estland, Lettland, Litauen',
    'Ohk-n' => 'Balkanländerna',
    'Ohk-o' => 'Asien',
    'Ohk-p' => 'Afrika',
    'Ohk-q' => 'Amerika',
    'Ohk-qa' => 'Förenta staterna',
    'Ohk-qb' => 'Kanada',
    'Ohk-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ohka' => 'Fritidsverksamhnet: barn och ungdom',
    'Ohka-a' => 'Europa: allmänt',
    'Ohka-b' => 'Norden: allmänt',
    'Ohka-c' => 'Sverige',
    'Ohka-c:k' => 'Historia',
    'Ohka-d' => 'Övriga Norden',
    'Ohka-da' => 'Danmark',
    'Ohka-db' => 'Norge',
    'Ohka-dc' => 'Island och Färöarna',
    'Ohka-dd' => 'Finland',
    'Ohka-f' => 'Mellaneuropa',
    'Ohm' => 'Allmänna samlingslokaler',
    'Ohm-c' => 'Sverige',
    'Ohm-c:bf' => 'Organisationer och institutioner',
    'Ohm-c:k' => 'Historia',
    'Ohm-cz' => 'Särskilda orter',
    'Ohm-d' => 'Övriga Norden',
    'Oi' => 'Statistik',
    'Oi(x)' => 'Statistiklexikon',
    'Oi:d' => 'Statistisk teori och undersökningsmetodik',
    'Oi:k' => 'Statistikens historia',
    'Oi:kc' => 'Sverige',
    'Oi-' => 'särskilda länder och områden',
    'Oi-a' => 'Europa: allmänt',
    'Oi-ae' => 'Europeiska unionen (EU)',
    'Oi-b' => 'Norden: allmänt',
    'Oi-bc' => 'Nordkalotten',
    'Oi-c' => 'Sverige',
    'Oi-c:bf' => 'Statistikinstitutioner och -organisationer',
    'Oi-c:k' => 'Statistikhistoria',
    'Oi-c:oi' => 'Statistiska tabeller',
    'Oi-ca' => 'Svealand',
    'Oi-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oi-cc' => 'Norrland',
    'Oi-cz' => 'Särskilda orter',
    'Oi-d' => 'Övriga Norden',
    'Oi-da' => 'Danmark',
    'Oi-da:k' => 'Statistikhistoria',
    'Oi-daz' => 'Särskilda orter',
    'Oi-db' => 'Norge',
    'Oi-db:bf' => 'Statistikinstitutioner och -organisationer',
    'Oi-dc' => 'Island och Färöarna',
    'Oi-dcf' => 'Färörna',
    'Oi-dd' => 'Finland',
    'Oi-ddz' => 'Särskilda orter',
    'Oi-ddå' => 'Åland',
    'Oi-e' => 'Brittiska öarna (Storbritannien)',
    'Oi-et' => 'Irland',
    'Oi-f' => 'Mellaneuropa',
    'Oi-fa' => 'Tyskland',
    'Oi-fb' => 'Österrike och Liechtenstein',
    'Oi-fc' => 'Ungern',
    'Oi-fd' => 'Tjeckien och Slovakien',
    'Oi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oi-ga' => 'Nederländerna',
    'Oi-gb' => 'Belgien',
    'Oi-h' => 'Schweiz',
    'Oi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oi-j' => 'Frankrike och Monaco',
    'Oi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oi-l' => 'Portugal',
    'Oi-m' => 'Östeuropa',
    'Oi-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oi-mad' => 'Ukraina',
    'Oi-mae' => 'Vitryssland',
    'Oi-maz' => 'Särskilda orter',
    'Oi-mb' => 'Polen',
    'Oi-mc' => 'Estland, Lettland, Litauen',
    'Oi-mca' => 'Estland',
    'Oi-mcb' => 'Lettland',
    'Oi-mcc' => 'Litauen',
    'Oi-n' => 'Balkanländerna',
    'Oi-na' => 'Rumänien',
    'Oi-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oi-nc' => 'Bulgarien',
    'Oi-nd' => 'Grekland',
    'Oi-nf' => 'Albanien',
    'Oi-o' => 'Asien',
    'Oi-oa' => 'Främre Asien',
    'Oi-oaa' => 'Turkiet',
    'Oi-oac' => 'Kaukasien',
    'Oi-oaf' => 'Palestina och Israel',
    'Oi-oafh' => 'Judar',
    'Oi-oafi' => 'Israel',
    'Oi-oah' => 'Arabiska halvön',
    'Oi-oak' => 'Iran (Persien)',
    'Oi-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oi-ob' => 'Främre Indien',
    'Oi-oba' => 'Indien',
    'Oi-obb' => 'Pakistan och Bangladesh',
    'Oi-obe' => 'Sri Lanka (f d Ceylon)',
    'Oi-oc' => 'Bortre Indien',
    'Oi-oca' => 'Myanmar (f d Burma)',
    'Oi-ocb' => 'Thailand',
    'Oi-occ' => 'Malaysia, Singapore och Brunei',
    'Oi-ocd' => 'Indokina',
    'Oi-od' => 'Ostindiska öarna',
    'Oi-oe' => 'Östasien',
    'Oi-oea' => 'Kina',
    'Oi-oeaf' => 'Taiwan',
    'Oi-oeak' => 'Tibet',
    'Oi-oeam' => 'Inre Mongoliet',
    'Oi-oeaz' => 'Särskilda orter',
    'Oi-oeb' => 'Korea',
    'Oi-oec' => 'Japan',
    'Oi-oek' => 'Hongkong och Macau',
    'Oi-of' => 'Centralasien',
    'Oi-p' => 'Afrika',
    'Oi-pa' => 'Nordafrika utom Egypten',
    'Oi-paa' => 'Marocko och Kanarieöarna',
    'Oi-pab' => 'Algeriet',
    'Oi-pac' => 'Tunisien',
    'Oi-pb' => 'Egypten och Sudan',
    'Oi-pba' => 'Egypten',
    'Oi-pbb' => 'Sudan',
    'Oi-pc' => 'Västafrika',
    'Oi-pcb' => 'Ekvatorialfrika',
    'Oi-pcba' => 'Tchad',
    'Oi-pcbb' => 'Centralafrikanska republiken',
    'Oi-pcbc' => 'Kongo (Brazzaville)',
    'Oi-pcbd' => 'Gabon',
    'Oi-pcbe' => 'Kamerun',
    'Oi-pcc' => 'Norra Västafrika',
    'Oi-pccb' => 'Mauretanien',
    'Oi-pccc' => 'Senegal',
    'Oi-pccd' => 'Gambia',
    'Oi-pcce' => 'Mali',
    'Oi-pccg' => 'Burkina Faso',
    'Oi-pcch' => 'Niger',
    'Oi-pcci' => 'Guniea-Bissau',
    'Oi-pccj' => 'Cap Verde',
    'Oi-pcck' => 'Guinea',
    'Oi-pccl' => 'Elfenbenskusten',
    'Oi-pccm' => 'Sierra Leone',
    'Oi-pccn' => 'Liberia',
    'Oi-pcd' => 'Södra Västafrika',
    'Oi-pcda' => 'Ghana',
    'Oi-pcdb' => 'Togo',
    'Oi-pcdc' => 'Benin',
    'Oi-pcdd' => 'Nigeria',
    'Oi-pd' => 'Centralafrika',
    'Oi-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Oi-pdaa' => 'Kongo (Kinshasa)',
    'Oi-pdab' => 'Rwanda',
    'Oi-pdac' => 'Burundi',
    'Oi-pdb' => 'Angola',
    'Oi-pe' => 'Södra Afrika',
    'Oi-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oi-peaa' => 'Sydafrikanska republiken',
    'Oi-peab' => 'Namibia',
    'Oi-peac' => 'Lesotho',
    'Oi-pead' => 'Swaziland',
    'Oi-peb' => 'Botswana',
    'Oi-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oi-peca' => 'Zimbabwe',
    'Oi-pecb' => 'Zambia',
    'Oi-pecc' => 'Malawi',
    'Oi-ped' => 'Mocambique',
    'Oi-pee' => 'Madagaskar (Malagasy)',
    'Oi-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Oi-pefa' => 'Komorerna',
    'Oi-pefb' => 'Mauritius',
    'Oi-pefc' => 'Réunion',
    'Oi-pf' => 'Östafrika',
    'Oi-pfa' => 'Uganda',
    'Oi-pfb' => 'Kenya',
    'Oi-pfc' => 'Tanzania',
    'Oi-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'Oi-pg' => 'Nordöstafrika',
    'Oi-pga' => 'Etiopien med Eritrea',
    'Oi-pgae' => 'Eritrea',
    'Oi-pgb' => 'Somalia',
    'Oi-pgc' => 'Djibouti',
    'Oi-q' => 'Amerika',
    'Oi-qa' => 'Förenta staterna',
    'Oi-qb' => 'Kanada',
    'Oi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oi-qca' => 'Mexiko',
    'Oi-qcb' => 'Guatemala',
    'Oi-qce' => 'Nicaragua',
    'Oi-qcf' => 'Costa Rica',
    'Oi-qch' => 'Västindien',
    'Oi-qd' => 'Sydamerika',
    'Oi-qda' => 'Colombia',
    'Oi-qdb' => 'Venezuela',
    'Oi-qdc' => 'Guyanastaterna',
    'Oi-qdd' => 'Brasilien',
    'Oi-qde' => 'Paraguay',
    'Oi-qdf' => 'Uruguay',
    'Oi-qdg' => 'Argentina',
    'Oi-qdh' => 'Chile',
    'Oi-qdi' => 'Bolivia',
    'Oi-qdk' => 'Peru',
    'Oi-qdl' => 'Ecuador',
    'Oi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oi-ra' => 'Australien',
    'Oi-rb' => 'Nya Zeeland',
    'Oi-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oi-rd' => 'Nya Guinea',
    'Oi-s' => 'Polarländerna',
    'Oj' => 'Demografi (befolkningsvetenskap)',
    'Oj:bf' => 'Demografiska institutioner',
    'Oj:d' => 'Demografisk teori, filosofi och metodlära',
    'Oj:dd' => 'Metodlära',
    'Oj:k' => 'Demografisk forskningshistoria',
    'Oj:ka' => 'Europa: allmänt',
    'Oj:kb' => 'Norden: allmänt',
    'Oj:kc' => 'Sverige',
    'Oj:kd' => 'Övriga Norden',
    'Oj:ke' => 'Brittiska öarna (Storbritannien)',
    'Oj:kf' => 'Mellaneuropa',
    'Oj:kj' => 'Frankrike och Monaco',
    'Oj:km' => 'Östeuropa',
    'Oj:ko' => 'Asien',
    'Oj:kp' => 'Afrika',
    'Oj:kq' => 'Amerika',
    'Oj:oi' => 'Statistiska demografiska tabeller',
    'Oj-' => 'Allmänt: särskilda länder och områden',
    'Oj-a' => 'Europa: allmänt',
    'Oj-ae' => 'Europeiska unionen (EU)',
    'Oj-b' => 'Norden: allmänt',
    'Oj-b:k' => 'Demografins historia',
    'Oj-c' => 'Sverige',
    'Oj-c:bf' => 'Demografiska institutioner',
    'Oj-c:k' => 'Demografins historia',
    'Oj-c:k.' => 'Särskilda perioder',
    'Oj-c:k.3' => 'Medeltiden ca 1060 - 1520',
    'Oj-c:k.4' => 'Nya tiden 1520-',
    'Oj-c:k.41' => 'Vasatiden 1520-1611',
    'Oj-c:k.42' => 'Stormaktstiden 1611-1718',
    'Oj-c:k.43' => '1700-talet',
    'Oj-c:k.45' => 'Gustavianska tiden 1772-1809',
    'Oj-c:k.46' => '1800-talet',
    'Oj-c:k.47' => '1809-1844',
    'Oj-c:k.48' => '1844-1865',
    'Oj-c:k.49' => '1865-1905',
    'Oj-c:k.5' => '1905-',
    'Oj-c:k.6' => '2000-',
    'Oj-c:oe' => 'Demografisk lagstiftning',
    'Oj-c:oi' => 'Statistiska demografiska tabeller',
    'Oj-ca' => 'Svealand',
    'Oj-caa' => 'Stockholm och Stockholms län',
    'Oj-caal' => 'Stockholms län',
    'Oj-cab' => 'Uppland och Uppsala län',
    'Oj-cac' => 'Södermanland och Södermanlands län',
    'Oj-cad' => 'Närke och Örebro län',
    'Oj-cae' => 'Västmanland och Västmanlands län',
    'Oj-caf' => 'Dalarna och Dalarnas län',
    'Oj-cag' => 'Värmland och Värmlands län',
    'Oj-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oj-cba' => 'Skåne och Skåne län',
    'Oj-cbb' => 'Halland och Hallands län',
    'Oj-cbd' => 'Småland (inkl Kronobergs, Jönköpings och Kalmar län)',
    'Oj-cbe' => 'Öland',
    'Oj-cbf' => 'Gotland och Gotlands län',
    'Oj-cbg' => 'Östergötland och Östergötlands län',
    'Oj-cbh' => 'Västergötland',
    'Oj-cbi' => 'Göteborg',
    'Oj-cbk' => 'Bohuslän',
    'Oj-cbl' => 'Dalsland',
    'Oj-cc' => 'Norrland',
    'Oj-ccb' => 'Hälsingland',
    'Oj-ccc' => 'Jämtland och Jämtlands län',
    'Oj-cce' => 'Medelpad',
    'Oj-ccf' => 'Ångermanland och Västernorrlands län',
    'Oj-ccg' => 'Västerbotten och Västerbottens län',
    'Oj-cch' => 'Norrbotten och Norrbottens län',
    'Oj-cci' => 'Lappland',
    'Oj-cs' => 'Samer',
    'Oj-cz' => 'Särskilda orter',
    'Oj-d' => 'Övriga Norden',
    'Oj-da' => 'Danmark',
    'Oj-db' => 'Norge',
    'Oj-db:oi' => 'Statistiska demografiska tabeller',
    'Oj-dc' => 'Island och Färöarna',
    'Oj-dd' => 'Finland',
    'Oj-dd:k' => 'Demografins historia',
    'Oj-dd:oi' => 'Statistiska demografiska tabeller',
    'Oj-ddz' => 'Särskilda orter',
    'Oj-e' => 'Brittiska öarna (Storbritannien)',
    'Oj-e:k' => 'Demografins historia',
    'Oj-et' => 'Irland',
    'Oj-f' => 'Mellaneuropa',
    'Oj-fa' => 'Tyskland',
    'Oj-fa:k' => 'Demografins historia',
    'Oj-fag' => 'Västra Tyskland',
    'Oj-fah' => 'Östra Tyskland',
    'Oj-faz' => 'Särskilda orter',
    'Oj-fb' => 'Österrike och Liechtenstein',
    'Oj-fc' => 'Ungern',
    'Oj-fd' => 'Tjeckien och Slovakien',
    'Oj-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oj-ga' => 'Nederländerna',
    'Oj-gb' => 'Belgien',
    'Oj-h' => 'Schweiz',
    'Oj-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oj-j' => 'Frankrike och Monaco',
    'Oj-j:k' => 'Demografins historia',
    'Oj-jz' => 'Särskilda orter',
    'Oj-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oj-l' => 'Portugal',
    'Oj-m' => 'Östeuropa',
    'Oj-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Oj-mad' => 'Ukraina',
    'Oj-mae' => 'Vitryssland',
    'Oj-mb' => 'Polen',
    'Oj-mc' => 'Estland, Lettland, Litauen',
    'Oj-mca' => 'Estland',
    'Oj-mcb' => 'Lettland',
    'Oj-mcc' => 'Litauen',
    'Oj-n' => 'Balkanländerna',
    'Oj-na' => 'Rumänien',
    'Oj-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Oj-nc' => 'Bulgarien',
    'Oj-nd' => 'Grekland',
    'Oj-nf' => 'Albanien',
    'Oj-o' => 'Asien',
    'Oj-oa' => 'Främre Asien',
    'Oj-oaa' => 'Turkiet',
    'Oj-oac' => 'Kaukasien',
    'Oj-oae' => 'Syrien och Libanon',
    'Oj-oaf' => 'Palestina och Israel',
    'Oj-oafh' => 'Judar',
    'Oj-oafi' => 'Israel',
    'Oj-oag' => 'Jordanien',
    'Oj-oah' => 'Arabiska halvön',
    'Oj-oaj' => 'Kurder',
    'Oj-oak' => 'Iran (Persien)',
    'Oj-oal' => 'Afghanistan',
    'Oj-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Oj-ob' => 'Främre Indien',
    'Oj-oba' => 'Indien',
    'Oj-obb' => 'Pakistan och Bangladesh',
    'Oj-obd' => 'Nepal',
    'Oj-obe' => 'Sri Lanka (f d Ceylon)',
    'Oj-oc' => 'Bortre Indien',
    'Oj-ocb' => 'Thailand',
    'Oj-occ' => 'Malaysia, Singapore och Brunei',
    'Oj-ocd' => 'Indokina',
    'Oj-od' => 'Ostindiska öarna',
    'Oj-oda' => 'Indonesien',
    'Oj-odc' => 'Filippinerna',
    'Oj-oe' => 'Östasien',
    'Oj-oea' => 'Kina',
    'Oj-oeb' => 'Korea',
    'Oj-oec' => 'Japan',
    'Oj-og' => 'Sibirien',
    'Oj-p' => 'Afrika',
    'Oj-pa' => 'Nordafrika utom Egypten',
    'Oj-paa' => 'Marocko och Kanarieöarna',
    'Oj-pab' => 'Algeriet',
    'Oj-pac' => 'Tunisien',
    'Oj-pb' => 'Egypten och Sudan',
    'Oj-pba' => 'Egypten',
    'Oj-pbb' => 'Sudan',
    'Oj-pc' => 'Västafrika',
    'Oj-pcb' => 'Ekvatorialfrika',
    'Oj-pcba' => 'Tchad',
    'Oj-pcbb' => 'Centralafrikanska republiken',
    'Oj-pcbd' => 'Gabon',
    'Oj-pcbe' => 'Kamerun',
    'Oj-pcc' => 'Norra Västafrika',
    'Oj-pccb' => 'Mauretanien',
    'Oj-pccc' => 'Senegal',
    'Oj-pccd' => 'Gambia',
    'Oj-pcce' => 'Mali',
    'Oj-pccg' => 'Burkina Faso',
    'Oj-pcch' => 'Niger',
    'Oj-pcci' => 'Guniea-Bissau',
    'Oj-pccj' => 'Cap Verde',
    'Oj-pcck' => 'Guinea',
    'Oj-pccl' => 'Elfenbenskusten',
    'Oj-pccm' => 'Sierra Leone',
    'Oj-pccn' => 'Liberia',
    'Oj-pcd' => 'Södra Västafrika',
    'Oj-pcda' => 'Ghana',
    'Oj-pcdb' => 'Togo',
    'Oj-pcdc' => 'Benin',
    'Oj-pcdd' => 'Nigeria',
    'Oj-pd' => 'Centralafrika',
    'Oj-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Oj-pdaa' => 'Kongo (Kinshasa)',
    'Oj-pdab' => 'Rwanda',
    'Oj-pdac' => 'Burundi',
    'Oj-pdb' => 'Angola',
    'Oj-pe' => 'Södra Afrika',
    'Oj-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Oj-peaa' => 'Sydafrikanska republiken',
    'Oj-peab' => 'Namibia',
    'Oj-peac' => 'Lesotho',
    'Oj-pead' => 'Swaziland',
    'Oj-peb' => 'Botswana',
    'Oj-pec' => 'Zimbabwe, Zambia, Malawi',
    'Oj-peca' => 'Zimbabwe',
    'Oj-pecb' => 'Zambia',
    'Oj-pecc' => 'Malawi',
    'Oj-ped' => 'Mocambique',
    'Oj-pee' => 'Madagaskar (Malagasy)',
    'Oj-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Oj-pefa' => 'Komorerna',
    'Oj-pefb' => 'Mauritius',
    'Oj-pefc' => 'Réunion',
    'Oj-pf' => 'Östafrika',
    'Oj-pfa' => 'Uganda',
    'Oj-pfb' => 'Kenya',
    'Oj-pfc' => 'Tanzania',
    'Oj-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'Oj-pg' => 'Nordöstafrika (Etiopien)',
    'Oj-q' => 'Amerika',
    'Oj-qa' => 'Förenta staterna',
    'Oj-qa:k' => 'Demografins historia',
    'Oj-qat' => 'Indianer i Nordamerika',
    'Oj-qaz' => 'Särskilda orter',
    'Oj-qb' => 'Kanada',
    'Oj-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oj-qca' => 'Mexiko',
    'Oj-qcb' => 'Guatemala',
    'Oj-qce' => 'Nicaragua',
    'Oj-qcf' => 'Costa Rica',
    'Oj-qcg' => 'Panama',
    'Oj-qch' => 'Västindien',
    'Oj-qcha' => 'Stora Antillerna (Kuba)',
    'Oj-qchb' => 'Små Antillerna',
    'Oj-qd' => 'Sydamerika',
    'Oj-qda' => 'Colombia',
    'Oj-qdb' => 'Venezuela',
    'Oj-qdc' => 'Guyanastaterna',
    'Oj-qdd' => 'Brasilien',
    'Oj-qde' => 'Paraguay',
    'Oj-qdf' => 'Uruguay',
    'Oj-qdg' => 'Argentina',
    'Oj-qdh' => 'Chile',
    'Oj-qdi' => 'Bolivia',
    'Oj-qdk' => 'Peru',
    'Oj-qdl' => 'Ecuador',
    'Oj-qdt' => 'Indianer i Sydamerika',
    'Oj-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oj-ra' => 'Australien',
    'Oj-rb' => 'Nya Zeeland',
    'Oj-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Oj-rd' => 'Nya Guinea',
    'Oj-s' => 'Polarländerna',
    'Oja' => 'Nativitet och mortalitet',
    'Oja-' => 'Särskilda länder och områden',
    'Oja-a' => 'Europa: allmänt',
    'Oja-ae' => 'Europeiska unionen (EU)',
    'Oja-b' => 'Norden: allmänt',
    'Oja-c' => 'Sverige',
    'Oja-c:k' => 'Historia',
    'Oja-c:k.' => 'Särskilda perioder',
    'Oja-c:k.4' => 'Nya tiden 1520-',
    'Oja-c:k.43' => '1700-talet',
    'Oja-c:k.46' => '1800-talet',
    'Oja-c:k.47' => '1809-1844',
    'Oja-c:k.49' => '1865-1905',
    'Oja-c:k.5' => '1905-',
    'Oja-c:k.6' => '2000-',
    'Oja-c:oi' => 'Statistik',
    'Oja-cz' => 'Särskilda orter',
    'Oja-ca' => 'Svealand',
    'Oja-caa' => 'Stockholm och Stockholms län',
    'Oja-cb' => 'Götaland (inkl Västra Götalands län)',
    'Oja-cc' => 'Norrland',
    'Oja-cca' => 'Gästrikland och Gävleborgs län',
    'Oja-ccc' => 'Jämtland och Jämtlands län',
    'Oja-ccg' => 'Västerbotten och Västerbottens län',
    'Oja-cch' => 'Norrbotten och Norrbottens län',
    'Oja-d' => 'Övriga Norden',
    'Oja-da' => 'Danmark',
    'Oja-db' => 'Norge',
    'Oja-dc' => 'Island och Färöarna',
    'Oja-dd' => 'Finland',
    'Oja-e' => 'Brittiska öarna (Storbritannien)',
    'Oja-f' => 'Mellaneuropa',
    'Oja-fa' => 'Tyskland',
    'Oja-fb' => 'Österrike och Liechtenstein',
    'Oja-fc' => 'Ungern',
    'Oja-fd' => 'Tjeckien och Slovakien',
    'Oja-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oja-j' => 'Frankrike och Monaco',
    'Oja-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Oja-l' => 'Portugal',
    'Oja-m' => 'Östeuropa',
    'Oja-n' => 'Balkanländerna',
    'Oja-o' => 'Asien',
    'Oja-oa' => 'Främre Asien',
    'Oja-ob' => 'Främre Indien',
    'Oja-oc' => 'Bortre Indien',
    'Oja-od' => 'Ostindiska öarna',
    'Oja-oe' => 'Östasien',
    'Oja-p' => 'Afrika',
    'Oja-pb' => 'Egypten och Sudan',
    'Oja-pc' => 'Västafrika',
    'Oja-pd' => 'Centralafrika',
    'Oja-pe' => 'Södra Afrika',
    'Oja-pf' => 'Östafrika',
    'Oja-pg' => 'Nordöstafrika (Etiopien)',
    'Oja-q' => 'Amerika',
    'Oja-qa' => 'Förenta staterna',
    'Oja-qb' => 'Kanada',
    'Oja-qc' => 'Mexiko, Centralamerika och Västindien',
    'Oja-qd' => 'Sydamerika',
    'Oja-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oja-s' => 'Polarländerna',
    'Ojc' => 'Flyttningar och befolkningsändringar',
    'Ojc:k' => 'Historia',
    'Ojc-' => 'Särskilda länder och områden',
    'Ojc-a' => 'Europa: allmänt',
    'Ojc-a:k' => 'Historia',
    'Ojc-ae' => 'Europeiska unionen (EU)',
    'Ojc-b' => 'Norden: allmänt',
    'Ojc-c' => 'Sverige',
    'Ojc-c:k' => 'Historia',
    'Ojac-c:oi' => 'Statistik',
    'Ojc-cs' => 'Samer',
    'Ojc-cz' => 'Särskilda orter',
    'Ojc-d' => 'Övriga Norden',
    'Ojc-da' => 'Danmark',
    'Ojc-db' => 'Norge',
    'Ojc-dd' => 'Finland',
    'Ojc-e' => 'Brittiska öarna (Storbritannien)',
    'Ojc-f' => 'Mellaneuropa',
    'Ojc-fa' => 'Tyskland',
    'Ojc-fb' => 'Österrike och Liechtenstein',
    'Ojc-fc' => 'Ungern',
    'Ojc-fd' => 'Tjeckien och Slovakien',
    'Ojc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ojc-h' => 'Schweiz',
    'Ojc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ojc-j' => 'Frankrike och Monaco',
    'Ojc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ojc-l' => 'Portugal',
    'Ojc-m' => 'Östeuropa',
    'Ojc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ojc-mb' => 'Polen',
    'Ojc-mc' => 'Estland, Lettland, Litauen',
    'Ojc-n' => 'Balkanländerna',
    'Ojc-o' => 'Asien',
    'Ojc-oa' => 'Främre Asien',
    'Ojc-ob' => 'Främre Indien',
    'Ojc-oba' => 'Indien',
    'Ojc-obb' => 'Pakistan och Bangladesh',
    'Ojc-oc' => 'Bortre Indien',
    'Ojc-od' => 'Ostindiska öarna',
    'Ojc-oe' => 'Östasien',
    'Ojc-oea' => 'Kina',
    'Ojc-oec' => 'Japan',
    'Ojc-oek' => 'Hongkong och Macau',
    'Ojc-og' => 'Sibirien',
    'Ojc-p' => 'Afrika',
    'Ojc-pa' => 'Nordafrika utom Egypten',
    'Ojc-pb' => 'Egypten och Sudan',
    'Ojc-pc' => 'Västafrika',
    'Ojc-pcb' => 'Ekvatorialfrika',
    'Ojc-pcc' => 'Norra Västafrika',
    'Ojc-pcd' => 'Södra Västafrika',
    'Ojc-pd' => 'Centralafrika',
    'Ojc-pe' => 'Södra Afrika',
    'Ojc-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Ojc-peaa' => 'Sydafrikanska republiken',
    'Ojc-peac' => 'Lesotho',
    'Ojc-pec' => 'Zimbabwe, Zambia, Malawi',
    'Ojc-pf' => 'Östafrika',
    'Ojc-pg' => 'Nordöstafrika',
    'Ojc-q' => 'Amerika',
    'Ojc-qa' => 'Förenta staterna',
    'Ojc-qat' => 'Indianer i Nordamerika',
    'Ojc-qaz' => 'Särskilda orter',
    'Ojc-qb' => 'Kanada',
    'Ojc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ojc-qca' => 'Mexiko',
    'Ojc-qch' => 'Västindien',
    'Ojc-qd' => 'Sydamerika',
    'Ojc-qda' => 'Colombia',
    'Ojc-qdb' => 'Venezuela',
    'Ojc-qdd' => 'Brasilien',
    'Ojc-qdg' => 'Argentina',
    'Ojc-qdh' => 'Chile',
    'Ojc-qdi' => 'Bolivia',
    'Ojc-qdk' => 'Peru',
    'Ojc-qdl' => 'Ecuador',
    'Ojc-qdt' => 'Indianer i Sydamerika',
    'Ojc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ojd' => 'Befolkningssammansättning och -fördelning',
    'Ojd:oi' => 'Statistik',
    'Ojd-' => 'Särskilda länder och områden',
    'Ojd-a' => 'Europa: allmänt',
    'Ojd-ae' => 'Europeiska unionen (EU)',
    'Ojd-b' => 'Norden: allmänt',
    'Ojd-c' => 'Sverige',
    'Ojd-c:k' => 'Historia',
    'Ojd-c:oe' => 'Demografisk lagstiftning',
    'Ojd-c:oi' => 'Statistik',
    'Ojd-cz' => 'Särskilda orter',
    'Ojd-d' => 'Övriga Norden',
    'Ojd-da' => 'Danmark',
    'Ojd-db' => 'Norge',
    'Ojd-dd' => 'Finland',
    'Ojd-e' => 'Brittiska öarna (Storbritannien)',
    'Ojd-f' => 'Mellaneuropa',
    'Ojd-m' => 'Östeuropa',
    'Ojd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ojd-mc' => 'Estland, Lettland, Litauen',
    'Ojd-o' => 'Asien',
    'Ojd-oa' => 'Främre Asien',
    'Ojd-ob' => 'Främre Indien',
    'Ojd-oc' => 'Bortre Indien',
    'Ojd-oe' => 'Östasien',
    'Ojd-p' => 'Afrika',
    'Ojd-q' => 'Amerika',
    'Ojd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ojf' => 'Folkbokföring',
    'Ojf-c' => 'Sverige',
    'Ojf-c:k' => 'Historia',
    'Ojf-c:oe' => 'Lagstiftning',
    'Ojf-cz' => 'Särskilda orter',
    'Ojf-d' => 'Övriga Norden',
    'Ojf-e' => 'Brittiska öarna (Storbritannien)',
    'Ojf-f' => 'Mellaneuropa',
    'Ojf-j' => 'Frankrike och Monaco',
    'Ojf-m' => 'Östeuropa',
    'Ojf-o' => 'Asien',
    'Ojf-p' => 'Afrika',
    'Ojf-q' => 'Amerika',
    'Ojp' => 'Befolkningspolitik',
    'Ojp-' => 'Särskilda länder och områden',
    'Ojp-a' => 'Europa: allmänt',
    'Ojp-c' => 'Sverige',
    'Ojp-c:k' => 'Demografins historia',
    'Ojp-d' => 'Övriga Norden',
    'Ojp-e' => 'Brittiska öarna (Storbritannien)',
    'Ojp-f' => 'Mellaneuropa',
    'Ojp-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ojp-j' => 'Frankrike och Monaco',
    'Ojp-m' => 'Östeuropa',
    'Ojp-n' => 'Balkanländerna',
    'Ojp-o' => 'Asien',
    'Ojp-oa' => 'Främre Asien',
    'Ojp-ob' => 'Främre Indien',
    'Ojp-oba' => 'Indien',
    'Ojp-obb' => 'Pakistan och Bangladesh',
    'Ojp-obd' => 'Nepal',
    'Ojp-oc' => 'Bortre Indien',
    'Ojp-od' => 'Ostindiska öarna',
    'Ojp-oe' => 'Östasien (Kina)',
    'Ojp-p' => 'Afrika',
    'Ojp-q' => 'Amerika',
    'Ojp-qa' => 'Förenta staterna',
    'Ojp-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ojp-qd' => 'Sydamerika',
    'Ojp-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ok' => 'Försäkring',
    'Ok(x)' => 'Allmänt: försäkringslexikon',
    'Ok-' => 'Allmänt: särskilda länder och områden',
    'Ok-a' => 'Europa: allmänt',
    'Ok-ae' => 'Europeiska unionen (EU)',
    'Ok-b' => 'Norden: allmänt',
    'Ok-b:oe' => 'Försäkringslagstiftning',
    'Ok-b:oi' => 'Försäkringsstatistik',
    'Ok-c' => 'Sverige',
    'Ok-c:bf' => 'Försäkringsinstitutioner',
    'Ok-c:k' => 'Försäkringshistoria',
    'Ok-c:oe' => 'Försäkringslagstiftning',
    'Ok-c:oi' => 'Försäkringsstatistik',
    'Ok-cz' => 'Särskilda orter',
    'Ok-d' => 'Övriga Norden',
    'Ok-da' => 'Danmark',
    'Ok-da:k' => 'Försäkringshistoria',
    'Ok-db' => 'Norge',
    'Ok-db:k' => 'Försäkringshistoria',
    'Ok-dd' => 'Finland',
    'Ok-dd:oi' => 'Försäkringsstatistik',
    'Ok-e' => 'Brittiska öarna (Storbritannien)',
    'Ok-e:k' => 'Försäkringshistoria',
    'Ok-f' => 'Mellaneuropa',
    'Ok-fa' => 'Tyskland',
    'Ok-fa:k' => 'Försäkringshistoria',
    'Ok-fa:oe' => 'Försäkringslagstiftning',
    'Ok-fb' => 'Österrike och Liechtenstein',
    'Ok-fd' => 'Tjeckien och Slovakien',
    'Ok-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ok-ga' => 'Nederländerna',
    'Ok-gb' => 'Belgien',
    'Ok-h' => 'Schweiz',
    'Ok-h:oe' => 'Försäkringslagstiftning',
    'Ok-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ok-j' => 'Frankrike och Monaco',
    'Ok-j:k' => 'Försäkringshistoria',
    'Ok-j:oe' => 'Försäkringslagstiftning',
    'Ok-m' => 'Östeuropa',
    'Ok-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ok-mb' => 'Polen',
    'Ok-mc' => 'Estland, Lettland, Litauen',
    'Ok-n' => 'Balkanländerna',
    'Ok-o' => 'Asien',
    'Ok-oa' => 'Främre Asien',
    'Ok-oe' => 'Östasien',
    'Ok-p' => 'Afrika',
    'Ok-q' => 'Amerika',
    'Ok-qa' => 'Förenta staterna',
    'Ok-qa:oe' => 'Försäkringslagstiftning',
    'Okd-qa:k' => 'Historia',
    'Ok-qb' => 'Kanada',
    'Ok-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ok-qd' => 'Sydamerika',
    'Ok-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oka' => 'Försäkringsteknik',
    'Okb' => 'Försäkringsrätt',
    'Okb-' => 'Särskilda länder och områden',
    'Okb-a' => 'Europa: allmänt',
    'Okb-ae' => 'Europeiska unionen (EU)',
    'Okb-b' => 'Norden: allmänt',
    'Okb-c' => 'Sverige',
    'Okb-c:oe' => 'Lagstiftning',
    'Okb-d' => 'Övriga Norden',
    'Okb-da' => 'Danmark',
    'Okb-da:oe' => 'Lagstiftining',
    'Okb-db' => 'Norge',
    'Okb-dd' => 'Finland',
    'Okb-e' => 'Brittiska öarna (Storbritannien)',
    'Okb-f' => 'Mellaneuropa',
    'Okb-fa' => 'Tyskland',
    'Okb-fa:oe' => 'Lagstiftning',
    'Okb-fag' => 'Västra Tyskland',
    'Okb-fb' => 'Österrike och Liechtenstein',
    'Okb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okb-h' => 'Schweiz',
    'Okb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Okb-j' => 'Frankrike och Monaco',
    'Okb-m' => 'Östeuropa',
    'Okb-o' => 'Asien',
    'Okb-p' => 'Afrika',
    'Okb-q' => 'Amerika',
    'Okb-qa' => 'Förenta staterna',
    'Okb-qa:oe' => 'Lagstiftning',
    'Okb-qb' => 'Kanada',
    'Okb-qd' => 'Sydamerika',
    'Okb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Okc' => 'Socialförsäkring',
    'Okc-' => 'Särskilda länder och områden',
    'Okc-a' => 'Europa: allmänt',
    'Okc-ae' => 'Europeiska unionen (EU)',
    'Okc-ae:oe' => 'Lagstiftning',
    'Okc-b' => 'Norden: allmänt',
    'Okc-b:oi' => 'Statistik',
    'Okc-c' => 'Sverige',
    'Okc-c:bf' => 'Organisationer och institutioner',
    'Okc-c:k' => 'Historia',
    'Okc-c:oe' => 'Lagstiftning',
    'Okc-c:oi' => 'Statistik',
    'Okc-d' => 'Övriga Norden',
    'Okc-da' => 'Danmark',
    'Okc-da:oe' => 'Lagstiftning',
    'Okc-db' => 'Norge',
    'Okc-db:oe' => 'Lagstiftning',
    'Okc-dd' => 'Finland',
    'Okc-e' => 'Brittiska öarna (Storbritannien)',
    'Okc-e:oe' => 'Lagstiftning',
    'Okc-f' => 'Mellaneuropa',
    'Okc-fa' => 'Tyskland',
    'Okc-fag' => 'Västra Tyskland',
    'Okc-fah' => 'Östra Tyskland',
    'Okc-fb' => 'Österrike och Liechtenstein',
    'Okc-fc' => 'Ungern',
    'Okc-fd' => 'Tjeckien och Slovakien',
    'Okc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okc-h' => 'Schweiz',
    'Okc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Okc-j' => 'Frankrike och Monaco',
    'Okc-j:oe' => 'Lagstiftning',
    'Okc-m' => 'Östeuropa',
    'Okc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Okc-mb' => 'Polen',
    'Okc-mc' => 'Estland, Lettland, Litauen',
    'Okc-o' => 'Asien',
    'Okc-oa' => 'Främre Asien',
    'Okc-ob' => 'Främre Indien',
    'Okc-oc' => 'Bortre Indien',
    'Okc-oe' => 'Östasien',
    'Okc-p' => 'Afrika',
    'Okc-q' => 'Amerika',
    'Okc-qa' => 'Förenta staterna',
    'Okc-qb' => 'Kanada',
    'Okc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Okc-qd' => 'Sydamerika',
    'Okc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Okca' => 'Pensioner',
    'Okca-' => 'Särskilda länder och områden',
    'Okca-a' => 'Europa: allmänt',
    'Okca-ae' => 'Europeiska unionen (EU)',
    'Okca-b' => 'Norden: allmänt',
    'Okca-c' => 'Sverige',
    'Okca-c:bf' => 'Organisationer och institutioner',
    'Okca-c:k' => 'Historia',
    'Okca-c:oe' => 'Lagstiftning',
    'Okca-c:oi' => 'Statistik',
    'Okca-d' => 'Övriga Norden',
    'Okca-da' => 'Danmark',
    'Okca-db' => 'Norge',
    'Okca-db:oe' => 'Lagstiftning',
    'Okca-dc' => 'Island och Färöarna',
    'Okca-dd' => 'Finland',
    'Okca-e' => 'Brittiska öarna (Storbritannien)',
    'Okca-f' => 'Mellaneuropa',
    'Okca-fa' => 'Tyskland',
    'Okca-fb' => 'Österrike och Liechtenstein',
    'Okca-fc' => 'Ungern',
    'Okca-fd' => 'Tjeckien och Slovakien',
    'Okca-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okca-h' => 'Schweiz',
    'Okca-j' => 'Frankrike och Monaco',
    'Okca-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Okca-m' => 'Östeuropa',
    'Okca-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Okca-mb' => 'Polen',
    'Okca-mc' => 'Estland, Lettland, Litauen',
    'Okca-n' => 'Balkanländerna',
    'Okca-o' => 'Asien',
    'Okca-p' => 'Afrika',
    'Okca-q' => 'Amerika',
    'Okca-qa' => 'Förenta staterna',
    'Okca-qb' => 'Kanada',
    'Okca-qd' => 'Sydamerika',
    'Okca-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Okcb' => 'Allmän sjukförsäkring',
    'Okcb-' => 'Särskilda länder och områden',
    'Okcb-a' => 'Europa: allmänt',
    'Okcb-ae' => 'Europeiska unionen (EU)',
    'Okcb-b' => 'Norden: allmänt',
    'Okcb-c' => 'Sverige',
    'Okcb-c:k' => 'Historia',
    'Okcb-c:oe' => 'Lagstiftning',
    'Okcb-c:oi' => 'Statistik',
    'Okcb-cz' => 'Särskilda orter',
    'Okcb-d' => 'Övriga Norden',
    'Okcb-da' => 'Danmark',
    'Okcb-db' => 'Norge',
    'Okcb-dd' => 'Finland',
    'Okcb-e' => 'Brittiska öarna (Storbritannien)',
    'Okcb-f' => 'Mellaneuropa (Tyskland)',
    'Okcb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okcb-h' => 'Schweiz',
    'Okcb-j' => 'Frankrike och Monaco',
    'Okcb-o' => 'Asien',
    'Okcb-q' => 'Amerika',
    'Okcb-qa' => 'Förenta staterna',
    'Okcb-qb' => 'Kanada',
    'Okcc' => 'Yrkesskadeförsäkring',
    'Okcc-b' => 'Norden: allmänt',
    'Okcc-c' => 'Sverige',
    'Okcc-c:oe' => 'Lagstiftning',
    'Okcc-c:oi' => 'Statistik',
    'Okcc-d' => 'Övriga Norden',
    'Okcc-da' => 'Danmark',
    'Okcc-db' => 'Norge',
    'Okcc-f' => 'Mellaneuropa',
    'Okcc-q' => 'Amerika',
    'Okcd' => 'Arbetslöshetsförsäkring',
    'Okcd-a' => 'Europa: allmänt',
    'Okcd-b' => 'Norden: allmänt',
    'Okcd-c' => 'Sverige',
    'Okcd-c:oe' => 'Lagstiftning',
    'Okcd-d' => 'Övriga Norden',
    'Okcd-da' => 'Danmark',
    'Okcd-dd' => 'Finland',
    'Okcd-e' => 'Brittiska öarna (Storbritannien)',
    'Okcd-f' => 'Mellaneuropa',
    'Okcd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okcd-q' => 'Amerika',
    'Okd' => 'Livförsäkring',
    'Okd-' => 'Särskilda länder och områden',
    'Okd-a' => 'Europa: allmänt',
    'Okd-b' => 'Norden: allmänt',
    'Okd-c' => 'Sverige',
    'Okd-c:k' => 'Historia',
    'Okd-c:oe' => 'Försäkringslagstiftning',
    'Okd-c:oi' => 'Försäkringsstatistik',
    'Okd-d' => 'Övriga Norden',
    'Okd-da' => 'Danmark',
    'Okd-da:k' => 'Historia',
    'Okd-db' => 'Norge',
    'Okd-db:k' => 'Historia',
    'Okd-dd' => 'Finland',
    'Okd-e' => 'Brittiska öarna (Storbritannien)',
    'Okd-f' => 'Mellaneuropa',
    'Okd-fa' => 'Tyskland',
    'Okd-fb' => 'Österrike och Liechtenstein',
    'Okd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Okd-ga' => 'Nederländerna',
    'Okd-gb' => 'Belgien',
    'Okd-h' => 'Schweiz',
    'Okd-j' => 'Frankrike och Monaco',
    'Okd-m' => 'Östeuropa',
    'Okd-o' => 'Asien',
    'Okd-q' => 'Amerika',
    'Okd-qa' => 'Förenta staterna',
    'Okd-qb' => 'Kanada',
    'Okd-qd' => 'Sydamerika',
    'Okd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Oke' => 'Skadeförsäkring',
    'Oke-' => 'Särskilda länder och områden',
    'Oke-a' => 'Europa: allmänt',
    'Oke-ae' => 'Europeiska unionen (EU)',
    'Oke-b' => 'Norden: allmänt',
    'Oke-c' => 'Sverige',
    'Oke-c:k' => 'Historia',
    'Oke-c:oe' => 'Lagstiftning',
    'Oke-c:oi' => 'Statistik',
    'Oke-d' => 'Övriga Norden',
    'Oke-da' => 'Danmark',
    'Oke-da:k' => 'Historia',
    'Oke-db' => 'Norge',
    'Oke-db:k' => 'Historia',
    'Oke-db:oe' => 'Lagstiftning',
    'Oke-dd' => 'Finland',
    'Oke-dd:k' => 'Historia',
    'Oke-e' => 'Brittiska öarna (Storbritannien)',
    'Oke-e:oe' => 'Lagstiftning',
    'Oke-f' => 'Mellaneuropa',
    'Oke-fa' => 'Tyskland',
    'Oke-fa:k' => 'Historia',
    'Oke-fa:oe' => 'Lagstiftning',
    'Oke-fb' => 'Österrike och Liechtenstein',
    'Oke-g' => 'Nederländerna, Belgien och Luxemburg',
    'Oke-h' => 'Schweiz',
    'Oke-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Oke-j' => 'Frankrike och Monaco',
    'Oke-m' => 'Östeuropa',
    'Oke-o' => 'Asien',
    'Oke-q' => 'Amerika',
    'Oke-qa' => 'Förenta staterna',
    'Oke-qb' => 'Kanada',
    'Okz' => 'Särskilda försäkringsföretag',
    'Om' => 'Kooperation',
    'Om-' => 'Allmänt: särskilda länder och områden',
    'Om-a' => 'Europa: allmänt',
    'Om-ae' => 'Europeiska unionen (EU)',
    'Om-b' => 'Norden: allmänt',
    'Om-c' => 'Sverige',
    'Om-c:bf' => 'Organisationer och institutioner',
    'Om-c:k' => 'Kooperationens historia',
    'Om-cz' => 'Särskilda orter',
    'Om-d' => 'Övriga Norden',
    'Om-da' => 'Danmark',
    'Om-db' => 'Norge',
    'Om-dc' => 'Island och Färöarna',
    'Om-dd' => 'Finland',
    'Om-e' => 'Brittiska öarna (Storbritannien)',
    'Om-et' => 'Irland',
    'Om-f' => 'Mellaneuropa',
    'Om-fa' => 'Tyskland',
    'Om-fb' => 'Österrike och Liechtenstein',
    'Om-fc' => 'Ungern',
    'Om-fd' => 'Tjeckien och Slovakien',
    'Om-g' => 'Nederländerna, Belgien och Luxemburg',
    'Om-h' => 'Schweiz',
    'Om-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Om-j' => 'Frankrike och Monaco',
    'Om-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Om-l' => 'Portugal',
    'Om-m' => 'Östeuropa',
    'Om-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Om-mb' => 'Polen',
    'Om-mc' => 'Estland, Lettland, Litauen',
    'Om-n' => 'Balkanländerna',
    'Om-o' => 'Asien',
    'Om-oa' => 'Främre Asien',
    'Om-ob' => 'Främre Indien',
    'Om-oe' => 'Östasien',
    'Om-p' => 'Afrika',
    'Om-pb' => 'Egypten och Sudan',
    'Om-pc' => 'Västafrika',
    'Om-pe' => 'Södra Afrika',
    'Om-pf' => 'Östafrika',
    'Om-pfb' => 'Kenya',
    'Om-pfc' => 'Tanzania',
    'Om-q' => 'Amerika',
    'Om-qa' => 'Förenta staterna',
    'Om-qb' => 'Kanada',
    'Om-qc' => 'Mexiko, Centralamerika och Västindien',
    'Om-qd' => 'Sydamerika',
    'Oma' => 'Konsumentkooperation',
    'Oma-a' => 'Europa: allmänt',
    'Oma-b' => 'Norden: allmänt',
    'Oma-c' => 'Sverige',
    'Oma-c:bf' => 'Organisationer och institutioner',
    'Oma-c:k' => 'Historia',
    'Oma-d' => 'Övriga Norden',
    'Oma-e' => 'Brittiska öarna (Storbritannien)',
    'Oma-f' => 'Mellaneuropa',
    'Oma-o' => 'Asien',
    'Oma-q' => 'Amerika',
    'Omb' => 'Producentkooperation',
    'Omb-a' => 'Europa: allmänt',
    'Omb-b' => 'Norden: allmänt',
    'Omb-c' => 'Sverige',
    'Omb-d' => 'Övriga Norden',
    'Omb-e' => 'Brittiska öarna (Storbritannien)',
    'Omb-f' => 'Mellaneuropa',
    'Omb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Omb-o' => 'Asien',
    'Omb-p' => 'Afrika',
    'Omb-q' => 'Amerika',
    'Op' => 'Framtidsstudier',
    'Op-' => 'Särskilda länder och områden',
    'Op-a' => 'Europa: allmänt',
    'Op-ae' => 'Europeiska unionen (EU)',
    'Op-b' => 'Norden: allmänt',
    'Op-c' => 'Sverige',
    'Op-c:bf' => 'Organisationer och institutioner',
    'Op-d' => 'Övriga Norden',
    'Op-da' => 'Danmark',
    'Op-db' => 'Norge',
    'Op-dd' => 'Finland',
    'Op-e' => 'Brittiska öarna (Storbritannien)',
    'Op-f' => 'Mellaneuropa',
    'Op-fa' => 'Tyskland',
    'Op-fb' => 'Österrike och Liechtenstein',
    'Op-h' => 'Schweiz',
    'Op-j' => 'Frankrike och Monaco',
    'Op-m' => 'Östeuropa',
    'Op-n' => 'Balkanländerna',
    'Op-o' => 'Asien',
    'Op-oa' => 'Främre Asien',
    'Op-oc' => 'Bortre Indien',
    'Op-oe' => 'Östasien',
    'Op-p' => 'Afrika',
    'Op-pc' => 'Västafrika',
    'Op-pe' => 'Södra Afrika',
    'Op-q' => 'Amerika',
    'Op-qa' => 'Förenta staterna',
    'Op-qb' => 'Kanada',
    'Op-qc' => 'Mexiko, Centralamerika och Västindien',
    'Op-qd' => 'Sydamerika',
    'Op-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'P' => 'Teknik, industri och kommunikationer',
    'P(x)' => 'Tekniklexikon',
    'P:b' => 'Teknisk forskning och tekniska institutioner',
    'P:bf' => 'Institutioner och organisationer',
    'P:d' => 'Teknisk teori och filosofi',
    'P:k' => 'Allmän teknikhistoria',
    'P:k.' => 'Särskilda perioder',
    'P:k.2' => 'Forntiden',
    'P:k.3' => 'Medeltiden',
    'P:k.4' => 'Nya tiden',
    'P:k.41' => '1500-1648',
    'P:k.43' => '1648-1789',
    'P:k.46' => '1815-1914',
    'P:k.5' => '1900-',
    'P:k.6' => '2000-',
    'P:ka' => 'Europa: allmänt',
    'P:kb' => 'Norden: allmänt',
    'P:kc' => 'Sverige',
    'P:kd' => 'Övriga Norden',
    'P:ke' => 'Brittiska öarna (Storbritannien)',
    'P:kf' => 'Mellaneuropa',
    'P:kg' => 'Nederländerna, Belgien och Luxemburg',
    'P:ki' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'P:kj' => 'Frankrike och Monaco',
    'P:kk' => 'Spanien (inkl Andorra och Gibraltar)',
    'P:km' => 'Östeuropa',
    'P:ko' => 'Asien',
    'P:kp' => 'Afrika',
    'P:kq' => 'Amerika',
    'P:oa' => 'Allmänt: sociologiska aspekter',
    'P.0' => 'Allmänt: särskilda aspekter, amatör- och hobbyverksamhet',
    'P.01' => 'Materiallära',
    'P.014' => 'Hållfasthetslära',
    'P.015' => 'Korrosion',
    'P.02' => 'Mätteknik och mätinstrument',
    'P.03' => 'Maskiner och redskap',
    'P.04' => 'Tjänsteföretag',
    'P.04-c' => 'Sverige',
    'P.05' => 'Industri',
    'P.05-' => 'Särskilda länder och områden',
    'P.05-a' => 'Europa: allmänt',
    'P.05-ae' => 'Europeiska unionen (EU)',
    'P.05-b' => 'Norden: allmänt',
    'P.05-c' => 'Sverige',
    'P.05-c:bf' => 'Institutioner',
    'P.05-cz' => 'Särskilda orter',
    'P.05-d' => 'Övriga Norden',
    'P.05-da' => 'Danmark',
    'P.05-db' => 'Norge',
    'P.05-dd' => 'Finland',
    'P.05-e' => 'Brittiska öarna (Storbritannien)',
    'P.05-f' => 'Mellaneuropa',
    'P.05-fa' => 'Tyskland',
    'P.05-fb' => 'Österrike och Liechtenstein',
    'P.05-fc' => 'Ungern',
    'P.05-fd' => 'Tjeckien och Slovakien',
    'P.05-g' => 'Nederländerna, Belgien och Luxemburg',
    'P.05-h' => 'Schweiz',
    'P.05-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'P.05-j' => 'Frankrike och Monaco',
    'P.05-m' => 'Östeuropa',
    'P.05-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'P.05-mb' => 'Polen',
    'P.05-mc' => 'Estland, Lettland, Litauen',
    'P.05-n' => 'Balkanländerna',
    'P.05-o' => 'Asien',
    'P.05-oa' => 'Främre Asien',
    'P.05-ob' => 'Främre Indien',
    'P.05-oc' => 'Bortre Indien',
    'P.05-od' => 'Ostindiska öarna',
    'P.05-oe' => 'Östasien',
    'P.05-oea' => 'Kina',
    'P.05-oeb' => 'Korea',
    'P.05-oec' => 'Japan',
    'P.05-p' => 'Afrika',
    'P.05-q' => 'Amerika',
    'P.05-qa' => 'Förenta staterna',
    'P.05-qb' => 'Kanada',
    'P.05-qc' => 'Mexiko, Centralamerika och Västindien',
    'P.05-qd' => 'Sydamerika',
    'P.05-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'P.06' => 'Hantverk och småindustri',
    'P.06-' => 'Särskilda länder och områden',
    'P.06-a' => 'Europa: allmänt',
    'P.06-c' => 'Sverige',
    'P.06-c:bf' => 'Institutioner',
    'P.06-cz' => 'Särskilda orter',
    'P.06-d' => 'Övriga Norden',
    'P.06-e' => 'Brittiska öarna (Storbritannien)',
    'P.06-f' => 'Mellaneuropa',
    'P.06-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'P.06-j' => 'Frankrike och Monaco',
    'P.06-m' => 'Östeuropa',
    'P.06-o' => 'Asien',
    'P.06-p' => 'Afrika',
    'P.06-q' => 'Amerika',
    'P.07' => 'Hemindustri',
    'P.08' => 'Energiförsörjning',
    'P.081' => 'Energi ur organiska bränslen',
    'P.0811' => 'Biomassa',
    'P.0812' => 'Olja och gas',
    'P.0813' => 'Kol',
    'P.082' => 'Vattenkraft',
    'P.083' => 'Vindkraft',
    'P.084' => 'Solenergi',
    'P.085' => 'Geotermisk energi',
    'P.086' => 'Kärnenergi och kärnteknik',
    'P.0864' => 'Fusionsenergi och fusionsreaktorer',
    'P.0868' => 'Avfallsteknik',
    'P.09' => 'Amatör- och hobbyverksamhet',
    'Pa' => 'Teknisk fysik',
    'Paa' => 'Teknisk akustik',
    'Paad' => 'Elektroakustiska apparater',
    'Paadb' => 'Bandspelare',
    'Paadc' => 'Grammofoner',
    'Paadh' => 'Högtalare',
    'Pab' => 'Teknisk optik',
    'Pabl' => 'Laserteknik',
    'Pac' => 'Teknisk värmelära',
    'Pb' => 'Maskinteknik',
    'Pb.0' => 'Särskilda aspekter',
    'Pb.01' => 'Materiallära',
    'Pb.02' => 'Mätteknik och mätinstrument',
    'Pb.03' => 'Maskiner och redskap',
    'Pb.05' => 'Industri',
    'Pba' => 'Maskinelement',
    'Pbaa' => 'Fästdetaljer',
    'Pbab' => 'Transmissioner (kraftöverföring)',
    'Pbac' => 'Lager (kullager), axlar, tappar',
    'Pbad' => 'Servomekanismer (automation)',
    'Pbb' => 'Värmemotorer',
    'Pbba' => 'Ångmaskiner',
    'Pbbb' => 'Förbränningsmotorer, gasturbiner, reaktionsmotorer',
    'Pbbö' => 'Övriga värmemotorer',
    'Pbc' => 'Vattenmotorer och pumpar',
    'Pbca' => 'Vattenmotorer',
    'Pbcb' => 'Pumpar',
    'Pbd' => 'Vindmotorer m m',
    'Pbe' => 'Transportanordningar',
    'Pbf' => 'Kylteknik, Tryckluftteknik, luftpumpar',
    'Pbfa' => 'Kylteknik',
    'Pbfb' => 'Tryckluftteknik, luftpumpar',
    'Pc' => 'Elektroteknik och elektrisk industri',
    'Pc:bf' => 'Allmänt: institutioner',
    'Pc:oe' => 'Allmänt: lagstiftning',
    'Pc.0' => 'Alllmänt: särskilda aspekter',
    'Pc.01' => 'Materiallära',
    'Pc.02' => 'Mätteknik och mätinstrument',
    'Pc.03' => 'Maskiner och redskap',
    'Pc.05' => 'Industri',
    'Pc.05-c' => 'Sverige',
    'Pca' => 'Elektrisk kraftproduktion',
    'Pcb' => 'Elektrisk kraftöverföring och distribution',
    'Pcc' => 'Elektriska maskiner',
    'Pcf' => 'Elektrisk ljusteknik',
    'Pcg' => 'Elektrisk värmeteknik',
    'Pch' => 'Teknisk elektrokemi',
    'Pci' => 'Elektronik',
    'Pci.0' => 'Särskilda aspekter',
    'Pci.01' => 'Materiallära',
    'Pci.02' => 'Mätteknik och mätinstrument',
    'Pci.03' => 'Maskiner och redskap',
    'Pci.05' => 'Industri',
    'Pci.05-c' => 'Sverige',
    'Pcia' => 'Kretsar',
    'Pcib' => 'Komponenter',
    'Pcic' => 'Optoelektronik',
    'Pcid' => 'Röntgenteknik',
    'Pcif' => 'Mikrovågelektronik',
    'Pcig' => 'Mikroelektronik',
    'Pcj' => 'Radio- och teleteknik',
    'Pcj.05' => 'Industri',
    'Pcja' => 'Telegrafi',
    'Pcjb' => 'Telefonteknik',
    'Pcjc' => 'Radio',
    'Pcjca' => 'Apparater och utrustning',
    'Pcjcaa' => 'Antenner',
    'Pcjcm' => 'Amatörradio',
    'Pcjcp' => 'Fjärrstyrning- och -kontroll',
    'Pcjcr' => 'Radar',
    'Pcjd' => 'Television',
    'Pcjda' => 'Apparater och utrustning',
    'Pcjdaa' => 'Antenner',
    'Pcjö' => 'Övrig teleteknik',
    'Pd' => 'Bergsbruk',
    'Pd:bf' => 'Institutioner',
    'Pd:oe' => 'Lagstiftning',
    'Pd.05' => 'Industri',
    'Pd.05-c' => 'Sverige',
    'Pda' => 'Prospektering och mineralutvinning',
    'Pdaa' => 'Prospektering',
    'Pdab' => 'Mineralutvinning',
    'Pdac' => 'Anrikning',
    'Pdb' => 'Metallurgi',
    'Pdba' => 'Järnets metallurgi',
    'Pdbb' => 'Övriga metallers metallurgi',
    'Pdbc' => 'Metallografi',
    'Pe' => 'Metallbearbetning och metallindustri',
    'Pe.0' => 'Allmänt: särskilda aspekter, amatör- och hobbyverksamhet',
    'Pe.01' => 'Materiallära',
    'Pe.02' => 'Mätteknik och mätinstrument',
    'Pe.03' => 'Maskiner och redskap',
    'Pe.05' => 'Industri',
    'Pe.05-c' => 'Sverige',
    'Pe.09' => 'Amatör- och hobbyverksamhet',
    'Pea' => 'Gjutning',
    'Pec' => 'Bearbetning och formning',
    'Peca' => 'Icke spånavskiljande (plastisk) bearbetning',
    'Pecb' => 'Spånavskiljande (spånskärande) bearbetning',
    'Ped' => 'Värme- och köldbehandling',
    'Pee' => 'Svetsning, skärning, lödning, limning',
    'Peea' => 'Svetsning',
    'Peeab' => 'Gassvetsning',
    'Peead' => 'Elsvetsning',
    'Peeb' => 'Skärning',
    'Peec' => 'Lödning',
    'Peed' => 'Limning',
    'Peg' => 'Ytbehandling',
    'Peh' => 'Metallprodukter',
    'Pej' => 'Metallmanufaktur och smideshantverk',
    'Pej.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pej.05' => 'Industri',
    'Pej.06' => 'Hantverk och småindustri',
    'Pej.09' => 'Amatör- och hobbyverksamhet',
    'Pel' => 'Finmekanik',
    'Pelk' => 'Urmakeri',
    'Pf' => 'Stenindustri',
    'Pf.05' => 'Industri',
    'Pg' => 'Glas, keramik, porslin',
    'Pg.0' => 'Allmänt: särskilda aspekter, amatör- och hobbyverksamhet',
    'Pg.01' => 'Materiallära',
    'Pg.05' => 'Industri',
    'Pg.09' => 'Amatör- och hobbyverksamhet',
    'Pga' => 'Glas',
    'Pga.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pga.01' => 'Materiallära',
    'Pga.05' => 'Industri',
    'Pga.06' => 'Hantverk och småindustri',
    'Pga.09' => 'Amatör- och hobbyverksamhet',
    'Pgb' => 'Keramik och porslin',
    'Pgb.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pgb.01' => 'Materiallära',
    'Pgb.05' => 'Industri',
    'Pgb.06' => 'Hantverk och småindustri',
    'Pgb.09' => 'Amatör- och hobbyverksamhet',
    'Ph' => 'Träteknik och träindustri',
    'Ph.0' => 'Allmänt: särskilda aspekter, amatör- och hobbyverksamhet',
    'Ph.01' => 'Materiallära',
    'Ph.03' => 'Maskiner och redskap',
    'Ph.05' => 'Industri',
    'Ph.05-c' => 'Sverige',
    'Ph.09' => 'Amatör- och hobbyverksamhet',
    'Pha' => 'Virkesframställning',
    'Phc' => 'Lagring av virke',
    'Phd' => 'Träbearbetning',
    'Phh' => 'Träprodukter',
    'Phh.0' => 'Tidsepok',
    'Phh.0-yoda' => 'Per-Henrik',
    'Phh-c' => 'Sverige',
    'Phh-cd' => 'Yoda',
    'Phh-ce' => 'Luke',
    'Phh-d' => 'Norge',
    'Phi' => 'Finsnickeri',
    'Phi.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Phi.01' => 'Materiallära',
    'Phi.03' => 'Maskiner och redskap',
    'Phi.05' => 'Industri',
    'Phi.06' => 'Hantverk och småindustri',
    'Phi.09' => 'Amatör- och hobbyverksamhet',
    'Pib.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pib.01' => 'Materiallära',
    'Pib.03' => 'Maskiner och redskap',
    'Pib.05' => 'Industri',
    'Pib.06' => 'Hantverk och småindustri',
    'Pib.09' => 'Amatör- och hobbyverksamhet',
    'Phj' => 'Kork och korkprodukter',
    'Pi' => 'Pappersindustri',
    'Pi.05' => 'Industri',
    'Pi.05-c' => 'Sverige',
    'Pia' => 'Cellulosa- och pappersmasseindustri',
    'Pia.05' => 'Industri',
    'Pia.05-c' => 'Sverige',
    'Pib' => 'Papper och papp',
    'Pic' => 'Pappersprodukter',
    'Pj' => 'Textil- och beklädnadsindustri',
    'Pj.0' => 'Allmänt: särskilda aspekter',
    'Pj.01' => 'Materiallära',
    'Pj.05' => 'Industri',
    'Pj.05-c' => 'Sverige',
    'Pj.06' => 'Hantverk och småindustri',
    'Pj.07' => 'Hemindustri',
    'Pja' => 'Textil- och konstfiberindustri',
    'Pja.0' => 'Särskilda aspekter',
    'Pja.01' => 'Materiallära',
    'Pja.03' => 'Maskiner och redskap',
    'Pja.05' => 'Industri',
    'Pja.05-c' => 'Sverige',
    'Pja.06' => 'Hantverk och småindustri',
    'Pja.07' => 'Hemindustri',
    'Pjaa' => 'Bastfibrer',
    'Pjab' => 'Fröhårsfibrer',
    'Pjac' => 'Hårfibrer',
    'Pjad' => 'Silke och konstfiber',
    'Pjb' => 'Textilkemi',
    'Pjb.09' => 'Amatör- och hobbyverksamhet',
    'Pjba' => 'Textilfärgning',
    'Pjbad' => 'Textiltryck och batik',
    'Pjc' => 'Beklädnadsvaror',
    'Pjc.05' => 'Industri',
    'Pjc.06' => 'Hantverk och småindustri',
    'Pjd' => 'Övriga textilprodukter',
    'Pk' => 'Läder- och pälsvaruindustri',
    'Pk.05' => 'Allmänt: industri',
    'Pk.09' => 'Allmänt: amatör- och hobbyverksamhet',
    'Pka' => 'Läderbearbetning',
    'Pkb' => 'Pälsberedning',
    'Pkc' => 'Skor och andra lädervaror',
    'Pkc.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pkc.05' => 'Industri',
    'Pkc.06' => 'Hantverk och småindustri',
    'Pkc.09' => 'Amatör- och hobbyverksamhet',
    'Pl' => 'Övriga produkter',
    'Pl.09' => 'Amatör- och hobbyverksamhet',
    'Plb' => 'Leksaker',
    'Plc' => 'Halm- och hårarbeten m m',
    'Pm' => 'Kemisk teknik och kemisk industri',
    'Pm:oe' => 'Allmänt: lagstiftning',
    'Pm.0' => 'Allmänt: särskilda aspekter',
    'Pm.01' => 'Materiallära',
    'Pm.03' => 'Maskiner och redskap',
    'Pm.05' => 'Industri',
    'Pm.05-c' => 'Sverige',
    'Pma' => 'Bränslen och sprängämnen',
    'Pma.05' => 'Industri',
    'Pmaa' => 'Bränslen',
    'Pmaa.05' => 'Industri',
    'Pmaa.05-c' => 'Sveriga',
    'Pmab' => 'Sprängämnen',
    'Pmb' => 'Livsmedel och njutningsmedel',
    'Pmb.05' => 'Industri',
    'Pmba' => 'Drycker och njutningsmedel',
    'Pmba.05' => 'Industri',
    'Pmbaa' => 'Drycker och bryggerinäring',
    'Pmbaa.05' => 'Industri',
    'Pmbaab' => 'Vin och öl',
    'Pmbaac' => 'Destillerade drycker',
    'Pmbab' => 'Tobaksvaror',
    'Pmbab.05' => 'Industri',
    'Pmbb' => 'Livsmedel',
    'Pmbb.05' => 'Industri',
    'Pmbb.05-c' => 'Industri',
    'Pmbba' => 'Livsmedelstillsatser m m',
    'Pmbbb' => 'Socker och sockerprodukter',
    'Pmbbc' => 'Spannmål och spannmålsprodukter',
    'Pmbbd' => 'Frukt och grönsaker',
    'Pmbbe' => 'Ägg och mejeriprodukter',
    'Pmbbf' => 'Fisk',
    'Pmbbg' => 'Kött',
    'Pmc' => 'Läkemedel och kosmetika',
    'Pmc.05' => 'Industri',
    'Pmca' => 'Läkemedel',
    'Pmcb' => 'Kosmetika',
    'Pmg' => 'Oljor, fetter och vaxer',
    'Pmh' => 'Färger och lacker',
    'Pmh.05' => 'Industri',
    'Pmh.09' => 'Amatör- och hobbyverksamhet',
    'Pmi' => 'Gummi och plaster',
    'Pmia' => 'Gummiarter och -produkter',
    'Pmib' => 'Plaster och plastindustri',
    'Pmib.01' => 'Materiallära',
    'Pmib.05' => 'Industri',
    'Pmö' => 'Övrig kemisk-teknisk industri',
    'Pmö.05' => 'Industri',
    'Pn' => 'Fotografi och filmteknik',
    'Pna' => 'Fotografi',
    'Pnaa' => 'Fotografisk utrustning och apparatur',
    'Pnaab' => 'Kameror',
    'Pnaabz' => 'Särskilda märken',
    'Pnaac' => 'Projektorer',
    'Pnac' => 'Mörkrumsteknik',
    'Pnaca' => 'Färgfilm',
    'Pnad' => 'Färgfotografi',
    'Pnae' => 'Fotografering under speciella förhållanden',
    'Pnaf' => 'Fotografering: speciella motiv',
    'Pnb' => 'Filmteknik, TV- och videofotografering',
    'Pnba' => 'Filmkameror',
    'Pnbb' => 'Klippning och redigering',
    'Pnbc' => 'Filmprojektion',
    'Pnbd' => 'Speciella filmtekniker',
    'Pnbdb' => 'Färgfilm',
    'Pnbdd' => 'Ljudfilm',
    'Pnbdg' => 'Animerad film',
    'Pnbf' => 'TV- och videofotografering',
    'Pnd' => 'Vetenskaplig och teknisk fotografi',
    'Pny' => 'Fotografi och filmteknik: restaurering och konservering',
    'Po' => 'Tryckeri och bokbinderi',
    'Po.05' => 'Allmänt: industri',
    'Poa' => 'Tryckeri',
    'Poa.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Poa.05' => 'Industri',
    'Poa.06' => 'Hantverk och småindustri',
    'Poa.09' => 'Amatör- och hobbyverksamhet',
    'Poab' => 'Sättning',
    'Poac' => 'Tryckförfaranden',
    'Pob' => 'Bokbinderi',
    'Pob.0' => 'Särskilda aspekter, amatör- och hobbyverksamhet',
    'Pob.05' => 'Industri',
    'Pob.06' => 'Hantverk och småindustri',
    'Pob.09' => 'Amatör- och hobbyverksamhet',
    'Pp' => 'Byggnadsteknik, byggnadsproduktion, teknisk hygien',
    'Pp:bf' => 'Allmänt: organisationer och institutioner',
    'Pp:oe' => 'Byggnadslagstiftning',
    'Pp.0' => 'Allmänt: särskilda aspekter',
    'Pp.01' => 'Materiallära',
    'Pp.02' => 'Mätteknik och mätinstrument',
    'Pp.03' => 'Maskiner och redskap',
    'Pp.05' => 'Industri',
    'Pp.05-c' => 'Sverige',
    'Ppa' => 'Byggnadsteknik',
    'Ppaa' => 'Geoteknik',
    'Ppab' => 'Byggnadsstatik',
    'Ppac' => 'Byggnadsmaterial och -varor',
    'Ppaca' => 'Sten, tegel, murbruk',
    'Ppacb' => 'Trä',
    'Ppacc' => 'Järn, stål och andra metaller',
    'Ppacd' => 'Cement och betong',
    'Ppace' => 'Plast',
    'Ppacö' => 'Övriga material',
    'Ppad' => 'Konstruktions- och arbetsteknik',
    'Ppada' => 'Grundkonstruktioner',
    'Ppadb' => 'Betongkonstruktioner',
    'Ppadc' => 'Stål- och metallkonstruktioner',
    'Ppadd' => 'Träkonstruktioner',
    'Ppadö' => 'Övriga konstruktioner',
    'Ppb' => 'Byggnadsproduktion: husbyggnad',
    'Ppba' => 'Projektering, produktion',
    'Ppbb' => 'Byggnadsdelar',
    'Ppbba' => 'Grunder',
    'Ppbbb' => 'Väggar och murar',
    'Ppbbc' => 'Valv och bågar',
    'Ppbbd' => 'Yttertak',
    'Ppbbe' => 'Bjälklag, golv, innertak',
    'Ppbbf' => 'Trappor, hissar',
    'Ppbbg' => 'Skorstenar, schakt, ventilationskanaler',
    'Ppbbh' => 'Dörrar, portar, fönster',
    'Ppbbi' => 'Altaner, balkonger, uterum',
    'Ppbc' => 'Värme, vatten, ventilation, kyla',
    'Ppbca' => 'Uppvärmning',
    'Ppbcb' => 'Ventilation och luftkonditionering',
    'Ppbcc' => 'Vatten och avlopp',
    'Ppbccb' => 'Badrum och bastu',
    'Ppbcd' => 'Isolering',
    'Ppbd' => 'Byggnader för särskilda ändamål',
    'Ppbda' => 'Bostadshus',
    'Ppbdaa' => 'Slott, herresäten',
    'Ppbdab' => 'Flerfamiljshus',
    'Ppbdac' => 'Enfamiljshus',
    'Ppbdaf' => 'Fritidshus',
    'Ppbdak' => 'Komplement till bostadshus',
    'Ppbdb' => 'Byggnader för industri, transport, lagring',
    'Ppbdc' => 'Byggnader för religiösa ändamål',
    'Ppbdd' => 'Förvaltningsbyggnader, kontor, butiker',
    'Ppbde' => 'Byggnader för sjukvård, social omsorg',
    'Ppbdf' => 'Byggnader för undervisning, vetenskap, kultur',
    'Ppbdg' => 'Byggnader för underhållning och rekreation',
    'Ppbdö' => 'Byggnader för övriga ändamål',
    'Ppc' => 'Bygnadsproduktion: väg- och vattenbyggnad',
    'Ppca' => 'Väg- och gatubyggnad',
    'Ppcaa' => 'Landsvägar',
    'Ppcab' => 'Gator',
    'Ppcb' => 'Järnvägsbyggnad',
    'Ppcc' => 'Tunnelbyggnad',
    'Ppcd' => 'Brobyggnad',
    'Ppce' => 'Flygplatsbyggnad',
    'Ppcf' => 'Vattenbyggnad',
    'Ppcfa' => 'Kanal- och slussbyggnad',
    'Ppcfb' => 'Hamnbyggnad',
    'Ppcfc' => 'Vattenbyggnad i floder och sjöar',
    'Ppcg' => 'Vattenkraftbyggnader',
    'Ppch' => 'Torrläggning och bevattning',
    'Ppd' => 'Teknisk hygien, vatten och avlopp, värmeförsörjning m m',
    'Ppda' => 'Vattenförsörjning och avlopp',
    'Ppdb' => 'Renhållning och avfallshantering',
    'Ppdd' => 'Buller',
    'Ppde' => 'Gatu- och vägbelysning',
    'Ppdf' => 'Värmeförsörjning',
    'Pr' => 'Transportmedel och kommunikationer',
    'Pra' => 'Landsvägsfordon och landsvägstrafik',
    'Pra:bf' => 'Allmänt: organisationer och institutioner',
    'Pra:oe' => 'Allmänt: lagstiftning',
    'Pra.09' => 'Modellarbeten',
    'Praa' => 'Icke motordrivna fordon',
    'Prab' => 'Motorfordon',
    'Praba' => 'Konstruktion och verkningssätt',
    'Prabaa' => 'Motorer',
    'Prabab' => 'Kraftöverföring',
    'Prabac' => 'Chassi',
    'Prabad' => 'Karosseri',
    'Prabae' => 'Elektroteknik',
    'Prabb' => 'Personbilar',
    'Prabc' => 'Bussar',
    'Prabd' => 'Lastbilar',
    'Prabe' => 'Traktorer',
    'Prabf' => 'Terrängmotorfordon',
    'Prabg' => 'Släpfordon och husvagnar',
    'Prabi' => 'Motorcyklar',
    'Prabj' => 'Mopeder',
    'Prabz' => 'Motorfordon: särskilda märken',
    'Prad' => 'Vägtrafik',
    'Prad:oe' => 'Lagstiftning',
    'Prad-' => 'Särskilda länder och områden',
    'Prad-a' => 'Europa: allmänt',
    'Prad-ae' => 'Europeiska unionen (EU)',
    'Prad-b' => 'Norden: allmänt',
    'Prad-c' => 'Sverige',
    'Prad-c:k' => 'Vägtrafikens historia',
    'Prad-c:oe' => 'Vägtrafiklagstiftning',
    'Prad-d' => 'Övriga Norden',
    'Prad-e' => 'Brittiska öarna (Storbritannien)',
    'Prad-f' => 'Mellaneuropa',
    'Prad-o' => 'Asien',
    'Prad-p' => 'Afrika',
    'Prad-q' => 'Amerika',
    'Pradb' => 'Trafiksäkerhet',
    'Pradb-' => 'Särskilda länder och områden',
    'Pradb-a' => 'Europa: allmänt',
    'Pradb-ae' => 'Europeiska unionen (EU)',
    'Pradb-b' => 'Norden: allmänt',
    'Pradb-c' => 'Sverige',
    'Pradb-c:bf' => 'Organisationer och institutioner',
    'Pradb-d' => 'Övriga Norden',
    'Pradb-q' => 'Amerika',
    'Pradc' => 'Trafik- och körkortsundervisning',
    'Pradc-c' => 'Sverige',
    'Pradd' => 'Vägtransportväsen (inkl taxi- och åkeriverksamhet)',
    'Pradd-' => 'Särskilda länder och områden',
    'Pradd-a' => 'Europa: allmänt',
    'Pradd-b' => 'Norden: allmänt',
    'Pradd-c' => 'Sverige',
    'Pradd-c:k' => 'Vägtrafikens historia',
    'Pradd-cz' => 'Särskilda orter',
    'Pradd-d' => 'Övriga Norden',
    'Pradd-q' => 'Amerika',
    'Prb' => 'Järnvägar och spårvägar',
    'Prb:bf' => 'Allmänt: organisationer och institutioner',
    'Prb:oe' => 'Allmänt: lagstiftning',
    'Prb.09' => 'Modelljärnvägar',
    'Prba' => 'Rälsfordon',
    'Prbd' => 'Järnvägs- och spårvägstrafik',
    'Prbd-' => 'Särskilda länder och områden',
    'Prbd-a' => 'Europa: allmänt',
    'Prbd-ae' => 'Europeiska unionen (EU)',
    'Prbd-b' => 'Norden: allmänt',
    'Prbd-c' => 'Sverige',
    'Prbd-c:k' => 'Järnvägs- och spårvägstrafikens historia',
    'Prtg-c:oe' => 'Lagstiftning',
    'Prbd-d' => 'Övriga Norden',
    'Prbd-e' => 'Brittiska öarna (Storbritannien)',
    'Prbd-f' => 'Mellaneuropa',
    'Prbd-j' => 'Frankrike och Monaco',
    'Prbd-m' => 'Östeuropa',
    'Prbd-o' => 'Asien',
    'Prbd-p' => 'Afrika',
    'Prbd-q' => 'Amerika',
    'Prc' => 'Fartyg och sjöfart',
    'Prc:bf' => 'Allmänt: organisationer och institutioner',
    'Prc:oe' => 'Allmänt: lagstiftning',
    'Prc.09' => 'Modellbåtar',
    'Prca' => 'Skeppsbyggeri',
    'Prcaa' => 'Skrovkonstruktioner',
    'Prcab' => 'Motorer',
    'Prcac' => 'Hjälpmaskiner',
    'Prcad' => 'Manöverorgan och instrument',
    'Prcb' => 'Fartyg: särskilda typer',
    'Prcba' => 'Segelfartyg',
    'Prcbb' => 'Passagerarfartyg',
    'Prcbc' => 'Lastfartyg',
    'Prcbcd' => 'Tankfartyg',
    'Prcbö' => 'Övriga särskilda fartygstyper',
    'Prcc' => 'Fritidsbåtar. Småbåtar',
    'Prcca' => 'Segelbåtar',
    'Prccb' => 'Motorbåtar',
    'Prccd' => 'Kanoter, roddbåtar',
    'Prcd' => 'Sjöfart',
    'Prcd-' => 'Särskilda länder och områden',
    'Prcd-a' => 'Europa: allmänt',
    'Prcd-ae' => 'Europeiska unionen (EU)',
    'Prcd-b' => 'Norden: allmänt',
    'Prcd-c' => 'Sverige',
    'Prcd-c:bf' => 'Organisationer och institutioner',
    'Prcd-c:k' => 'Sjöfarthistoria',
    'Prcd-c:oe' => 'Sjöfartslagstiftning',
    'Prcdc-cz' => 'Särskilda orter',
    'Prcd-d' => 'Övriga Norden',
    'Prcd-da' => 'Danmark',
    'Prcd-db' => 'Norge',
    'Prcd-dd' => 'Finland',
    'Prcd-e' => 'Brittiska öarna (Storbritannien)',
    'Prcd-f' => 'Mellaneuropa',
    'Prcd-j' => 'Frankrike och Monaco',
    'Prcd-m' => 'Östeuropa',
    'Prcd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Prcd-mb' => 'Polen',
    'Prcd-mc' => 'Estland, Lettland, Litauen',
    'Prcd-n' => 'Balkanländerna',
    'Prcd-o' => 'Asien',
    'Prcd-p' => 'Afrika',
    'Prcd-q' => 'Amerika',
    'Prcd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Prcd-s' => 'Polarländerna',
    'Prcda' => 'Navigation och manövrering. Sjömanskap',
    'Prcdak' => 'Knopar och splitsar',
    'Prcdc' => 'Lots- och fyrväsen',
    'Prcdc-c' => 'Sverige',
    'Prcdc-c:k' => 'Sjöfarthistoria',
    'Prcdd' => 'Bärgnings- och dykeriväsen (inkl sjöräddning)',
    'Prcdd-c' => 'Sverige',
    'Prcddh' => 'Haverier',
    'Prcddi' => 'Vrak',
    'Prco' => 'Off-shoreteknik',
    'Prd' => 'Luft- och rymdfarkostteknik',
    'Prd:bf' => 'Allmänt: organisationer och institutioner',
    'Prd:oe' => 'Allmänt: lagstiftning',
    'Prd.09' => 'Modellflyg',
    'Prda' => 'Ballonger och luftskepp',
    'Prdb' => 'Flygplan',
    'Prdba' => 'Flygplanskonstruktion',
    'Prdbaa' => 'Motorer',
    'Prdbab' => 'Manöverorgan och instrument',
    'Prdbb' => 'Särskilda kategorier och typer',
    'Prdbba' => 'Segelflygplan, glidflygplan och fallskärmar',
    'Prdbbc' => 'Helikoptrar',
    'Prdbbd' => 'Propellerplan',
    'Prdbbf' => 'Jetplan och raketplan',
    'Prdbbl' => 'Flygplan för särskilda ändamål',
    'Prdd' => 'Flygtrafik',
    'Prdd-' => 'Särskilda länder och områden',
    'Prdd-a' => 'Europa: allmänt',
    'Prdd-ae' => 'Europeiska unionen (EU)',
    'Prdd-b' => 'Norden: allmänt',
    'Prdd-c' => 'Sverige',
    'Prdd-c:bf' => 'Organisationer och institutioner',
    'Prdd-c:K' => 'Flygtrafikens historia',
    'Prdd-d' => 'Övriga Norden',
    'Prdd-o' => 'Asien',
    'Prdd-q' => 'Amerika',
    'Prdd-qa' => 'Förenta staterna',
    'Prdda' => 'Flyglära och navigation',
    'Prde' => 'Rymdteknik och rymdfart',
    'Prdea' => 'Jordsatelliter',
    'Prdeb' => 'Månfärder',
    'Prdec' => 'Interplanetära rymdfärder',
    'Prf' => 'Svävare, amfibiefarkoster m m',
    'Prt' => 'Transportväsen',
    'Prt-' => 'Särskilda länder och områden',
    'Prt-a' => 'Europa: allmänt',
    'Prt-ae' => 'Europeiska unionen (EU)',
    'Prt-b' => 'Norden: allmänt',
    'Prt-c' => 'Sverige',
    'Prt-d' => 'Övriga Norden',
    'Prt-e' => 'Brittiska öarna (Storbritannien)',
    'Prt-f' => 'Mellaneuropa',
    'Prt-g' => 'Nederländerna, Belgien och Luxemburg',
    'Prt-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Prt-j' => 'Frankrike och Monaco',
    'Prt-m' => 'Östeuropa',
    'Prt-o' => 'Asien',
    'Prt-p' => 'Afrika',
    'Prt-q' => 'Amerika',
    'Prt-qa' => 'Förenta staterna',
    'Prt-qb' => 'Kanada',
    'Prtg' => 'Godstransporter (inkl containertrafik)',
    'Prtg-c' => 'Sverige',
    'Prtp' => 'Persontransporter (inkl kollektivtrafik)',
    'Prtp-c' => 'Sverige',
    'Prtp-cz' => 'Särskilda orter',
    'Ps' => 'Brandteknik och brandväsen',
    'Ps-' => 'Särskilda länder och områden',
    'Ps-b' => 'Norden: allmänt',
    'Ps-c' => 'Sverige',
    'Ps-c:oe' => 'Lagstiftning',
    'Ps-d' => 'Övriga Norden',
    'Ps-q' => 'Amerika',
    'Pt' => 'Patentbeskrivningar',
    'Pu' => 'Datorer och databehandling',
    'Pu:k' => 'Allmänt: historia',
    'Pu:oe' => 'Allmänt: datalagstiftning',
    'Pu.0' => 'Allmänt: särskilda aspekter',
    'Pu.02' => 'Mätteknik och mätinstrument',
    'Pu.04' => 'Tjänsteföretag',
    'Pu.05' => 'Industri',
    'Pua' => 'Datorer och datorsystem',
    'Puaa' => 'Superdatorer',
    'Puab' => 'Stora datorer, minidatorer',
    'Puac' => 'Mikrodatorer',
    'Puaf' => 'Centralenheter',
    'Puag' => 'Minnen',
    'Puah' => 'Kringutrustning',
    'Puahe' => 'Terminaler',
    'Puahi' => 'Skrivare',
    'Puahö' => 'Övrig kringutrustning',
    'Puaz' => 'Särskilda datorer och datorfabrikat',
    'Pub' => 'Databehandling',
    'Puba' => 'Systemutveckling',
    'Pubb' => 'Programmering',
    'Pubbz' => 'Särskilda programspråk',
    'Pubd' => 'Program och system',
    'Pubdz' => 'Särskilda program och system',
    'Pubdb' => 'Operativsystem',
    'Pubdbz' => 'Särskilda operativsystem',
    'Pubdd' => 'Kompilatorer',
    'Pubdh' => 'Databashanteringssystem',
    'Pubdhz' => 'Särskilda databashanteringssystem',
    'Pubdi' => 'Informationsåtervinningssystem',
    'Pubdk' => 'Datorstödda konferenser',
    'Pubds' => 'Säkerhet och integritet',
    'Puc' => 'Datanät och datakommunikation',
    'Pucb' => 'Internet',
    'Pucba' => 'Protokoll',
    'Pucbb' => 'Programmering och redigering',
    'Pucbc' => 'Sökning',
    'Pud' => 'Artificiell intelligens',
    'Pue' => 'Bildbehandling',
    'Puea' => 'Analys av bilder',
    'Pueam' => 'Mönsterigenkänning',
    'Pueb' => 'Produktion av bilder (datorgrafik)',
    'Puf' => 'Multimedia',
    'Pug' => 'Ljud- och talbehandling',
    'Puga' => 'Analys av ljud',
    'Pugb' => 'Produktion av ljud',
    'Puh' => 'Datorstödd konstruktion och tillverkning (CAD/CAM)',
    'Puo' => 'Datorers påverkan på samhället',
    'Puoh' => 'Datorers påverkan på yrkeslivet',
    'Q' => 'Ekonomi och näringsväsen',
    'Q(x)' => 'Ekonomiska lexikon',
    'Qa' => 'Nationalekonomi och finansväsen',
    'Qa(x)' => 'Nationalekonomiska etc lexikon',
    'Qa:k' => 'Nationalekonomins historia',
    'Qa:kc' => 'Sverige',
    'Qa:kd' => 'Övriga Norden',
    'Qa:ke' => 'Brittiska öarna (Storbritannien)',
    'Qa:kf' => 'Mellaneuropa',
    'Qa:km' => 'Östeuropa',
    'Qa:kn' => 'Balkanländerna',
    'Qa:kq' => 'Amerika',
    'Qa:oe' => 'Lagstiftning',
    'Qaa' => 'Ekonomisk teori',
    'Qaaa' => 'Doktrinhistoria',
    'Qaab' => 'Ekonomiska teorier och system',
    'Qaab:k' => 'Historia',
    'Qaaba' => 'Teorier före 1850',
    'Qaabac' => 'Merkantilismen',
    'Qaabad' => 'Fysiokraterna',
    'Qaabae' => 'Klassiska skolan',
    'Qaabb' => 'Teorier 1850-',
    'Qaabba' => 'Socialistiska teorier',
    'Qaabbb' => 'Keynes',
    'Qaabc' => 'Teorier efter Keynes (1946-)',
    'Qaabm' => 'Ekonomiska system: marknadsekonomi',
    'Qaabm:k' => 'Marknadsekonomins historia',
    'Qaabn' => 'Ekonomiska system: blandekonomi',
    'Qaabo' => 'Ekonomiska system: planekonomi',
    'Qaac' => 'Ekonomisk teori: speciella frågor',
    'Qaaca' => 'värdeteori, pristeori',
    'Qaacab' => 'Tillgång och efterfrågan',
    'Qaacac' => 'Pristeori',
    'Qaacb' => 'Fördelningslära, allmän jämviktslära',
    'Qaacc' => 'Produktion',
    'Qaaccd' => 'Arbete och löner',
    'Qaacce' => 'Kapital',
    'Qaace' => 'Konsumtion',
    'Qaacea' => 'Sparande',
    'Qaaceb' => 'Investeringar',
    'Qaacf' => 'Välfärdsteori',
    'Qaacg' => 'Ekonomisk tillväxt och utveckling',
    'Qaach' => 'Handelsteori',
    'Qab' => 'Ekonometri',
    'Qab:dd' => 'Ekonometrins metiodlära',
    'Qac' => 'Konjunkturteori och konjunkturlära',
    'Qac-' => 'Särskilda länder och områden',
    'Qac-a' => 'Europa: allmänt',
    'Qac-ae' => 'Europeiska unionen (EU)',
    'Qac-b' => 'Norden: allmänt',
    'Qac-c' => 'Sverige',
    'Qac-d' => 'Övriga Norden',
    'Qac-da' => 'Danmark',
    'Qac-db' => 'Norge',
    'Qac-dd' => 'Finland',
    'Qac-e' => 'Brittiska öarna (Storbritannien)',
    'Qac-f' => 'Mellaneuropa',
    'Qac-m' => 'Östeuropa',
    'Qac-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qac-mb' => 'Polen',
    'Qac-n' => 'Balkanländerna',
    'Qac-o' => 'Asien',
    'Qac-oa' => 'Främre Asien',
    'Qac-oc' => 'Bortre Indien',
    'Qac-od' => 'Ostindiska öarna',
    'Qac-oe' => 'Östasien',
    'Qac-oea' => 'Kina',
    'Qac-oec' => 'Japan',
    'Qac-p' => 'Afrika',
    'Qac-q' => 'Amerika',
    'Qac-qa' => 'Förenta staterna',
    'Qac-qd' => 'Sydamerika',
    'Qac-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qad' => 'Ekonomiska förhållanden',
    'Qad(x)' => 'Lexikon',
    'Qad-' => 'Allmänt: särskilda länder och områden',
    'Qad-a' => 'Europa: allmänt',
    'Qad-a:k' => 'Historia',
    'Qad-ae' => 'Europeiska unionen (EU)',
    'Qad-b' => 'Norden: allmänt',
    'Qad-c' => 'Sverige',
    'Qad-c:k' => 'Historia',
    'Qad-cs' => 'Samer',
    'Qad-d' => 'Övriga Norden',
    'Qad-da' => 'Danmark',
    'Qad-db' => 'Norge',
    'Qad-dc' => 'Island och Färöarna',
    'Qad-dcf' => 'Färöarna',
    'Qad-dd' => 'Finland',
    'Qad-e' => 'Brittiska öarna (Storbritannien)',
    'Qad-e:k' => 'Historia',
    'Qad-ea' => 'England',
    'Qad-er' => 'Wales',
    'Qad-es' => 'Skottland',
    'Qad-et' => 'Irland',
    'Qad-eta' => 'Irland (republiken)',
    'Qad-etb' => 'Nordirland',
    'Qad-f' => 'Mellaneuropa',
    'Qad-fa' => 'Tyskland',
    'Qad-fa:k' => 'Historia',
    'Qad-fb' => 'Österrike och Liechtenstein',
    'Qad-fbi' => 'Liechtenstein',
    'Qad-fc' => 'Ungern',
    'Qad-fd' => 'Tjeckien och Slovakien',
    'Qad-fda' => 'Tjeckien',
    'Qad-fdb' => 'Slovakien',
    'Qad-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qad-ga' => 'Nederländerna',
    'Qad-gb' => 'Belgien',
    'Qad-gc' => 'Luxemburg',
    'Qad-h' => 'Schweiz',
    'Qad-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qad-iv' => 'Malta',
    'Qad-j' => 'Frankrike och Monaco',
    'Qad-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qad-l' => 'Portugal',
    'Qad-m' => 'Östeuropa',
    'Qad-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qad-ma:k' => 'Historia',
    'Qad-mad' => 'Ukraina',
    'Qad-mae' => 'Vitryssland',
    'Qad-maf' => 'Moldavien',
    'Qad-mb' => 'Polen',
    'Qad-mc' => 'Estland, Lettland, Litauen',
    'Qad-mca' => 'Estland',
    'Qad-mcb' => 'Lettland',
    'Qad-mcc' => 'Litauen',
    'Qad-n' => 'Balkanländerna',
    'Qad-na' => 'Rumänien',
    'Qad-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qad-nba' => 'Serbien (inkl unionen Serbien och Montenegro)',
    'Qad-nbb' => 'Kroatien',
    'Qad-nbc' => 'Slovenien',
    'Qad-nbd' => 'Bosnien-Hercegovina',
    'Qad-nbf' => 'Makedonien',
    'Qad-nc' => 'Bulgarien',
    'Qad-nd' => 'Grekland',
    'Qad-nf' => 'Albanien',
    'Qad-o' => 'Asien',
    'Qad-oa' => 'Främre Asien',
    'Qad-oaa' => 'Turkiet',
    'Qad-oab' => 'Cypern',
    'Qad-oac' => 'Kaukasien',
    'Qad-oae' => 'Syrien och Libanon',
    'Qad-oaf' => 'Palestina och Israel',
    'Qad-oafi' => 'Israel',
    'Qad-oag' => 'Jordanien',
    'Qad-oah' => 'Arabiska halvön',
    'Qad-oaha' => 'Saudi-Arabien',
    'Qad-oahb' => 'Nordjemen',
    'Qad-oahc' => 'Sydjemen',
    'Qad-oahd' => 'Oman',
    'Qad-oahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Qad-oahf' => 'Kuwait',
    'Qad-oai' => 'Irak',
    'Qad-oak' => 'Iran (Persien)',
    'Qad-oal' => 'Afghanistan',
    'Qad-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Qad-oama' => 'Kazakstan',
    'Qad-oamb' => 'Turkmenistan',
    'Qad-oamc' => 'Uzbekistan',
    'Qad-oamd' => 'Kirgisistan',
    'Qad-oame' => 'Tadzjikistan',
    'Qad-ob' => 'Främre Indien',
    'Qad-oba' => 'Indien',
    'Qad-obb' => 'Pakistan och Bangladesh',
    'Qad-obba' => 'Pakistan',
    'Qad-obbb' => 'Bangladesh',
    'Qad-obc' => 'Bhutan',
    'Qad-obd' => 'Nepal',
    'Qad-obe' => 'Sri Lanka (f d Ceylon)',
    'Qad-obf' => 'Maldiverna',
    'Qad-oc' => 'Bortre Indien',
    'Qad-oca' => 'Myanmar (f d Burma)',
    'Qad-ocb' => 'Thailand',
    'Qad-occ' => 'Malaysia, Singapore och Brunei',
    'Qad-occa' => 'Malaysia',
    'Qad-occb' => 'Singapore',
    'Qad-occd' => 'Brunei',
    'Qad-ocd' => 'Indokina',
    'Qad-ocda' => 'Laos',
    'Qad-ocdb' => 'Kambodja',
    'Qad-ocdc' => 'Vietnam',
    'Qad-od' => 'Ostindiska öarna',
    'Qad-oda' => 'Indonesien',
    'Qad-odaa' => 'Sumatra',
    'Qad-odab' => 'Java',
    'Qad-odac' => 'Kalimantan (Borneo)',
    'Qad-odaf' => 'Timor och Östtimor',
    'Qad-odc' => 'Filippinerna',
    'Qad-oe' => 'Östasien',
    'Qad-oea' => 'Kina',
    'Qad-oeaf' => 'Taiwan',
    'Qad-oeak' => 'Tibet',
    'Qad-oeb' => 'Korea',
    'Qad-oeba' => 'Nordkorea',
    'Qad-oebb' => 'Sydkorea',
    'Qad-oec' => 'Japan',
    'Qad-oek' => 'Hongkong och Macau',
    'Qad-oeka' => 'Hongkong',
    'Qad-oekc' => 'Macau',
    'Qad-of' => 'Centralasien',
    'Qad-ofc' => 'Mongoliet',
    'Qad-og' => 'Sibirien',
    'Qad-p' => 'Afrika',
    'Qad-pa' => 'Nordafrika utom Egypten',
    'Qad-paa' => 'Marocko och Kanarieöarna',
    'Qad-pab' => 'Algeriet',
    'Qad-pac' => 'Tunisien',
    'Qad-pad' => 'Libyen',
    'Qad-pb' => 'Egypten och Sudan',
    'Qad-pba' => 'Egypten',
    'Qad-pbb' => 'Sudan',
    'Qad-pc' => 'Västafrika',
    'Qad-pcb' => 'Ekvatorialfrika',
    'Qad-pcba' => 'Tchad',
    'Qad-pcbb' => 'Centralafrikanska republiken',
    'Qad-pcbc' => 'Kongo (Brazzaville)',
    'Qad-pcbd' => 'Gabon',
    'Qad-pcbe' => 'Kamerun',
    'Qad-pcc' => 'Norra Västafrika',
    'Qad-pccb' => 'Mauretanien',
    'Qad-pccc' => 'Senegal',
    'Qad-pccd' => 'Gambia',
    'Qad-pcce' => 'Mali',
    'Qad-pccg' => 'Burkina Faso',
    'Qad-pcch' => 'Niger',
    'Qad-pcci' => 'Guniea-Bissau',
    'Qad-pccj' => 'Cap Verde',
    'Qad-pcck' => 'Guinea',
    'Qad-pccl' => 'Elfenbenskusten',
    'Qad-pccm' => 'Sierra Leone',
    'Qad-pccn' => 'Liberia',
    'Qad-pcd' => 'Södra Västafrika',
    'Qad-pcda' => 'Ghana',
    'Qad-pcdb' => 'Togo',
    'Qad-pcdc' => 'Benin',
    'Qad-pcdd' => 'Nigeria',
    'Qad-pcde' => 'Ekvatorialguinea',
    'Qad-pcdf' => 'Sao Thomé och Principe',
    'Qad-pd' => 'Centralafrika',
    'Qad-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Qad-pdaa' => 'Kongo (Kinshasa)',
    'Qad-pdab' => 'Rwanda',
    'Qad-pdac' => 'Burundi',
    'Qad-pdb' => 'Angola',
    'Qad-pe' => 'Södra Afrika',
    'Qad-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Qad-peaa' => 'Sydafrikanska republiken',
    'Qad-peab' => 'Namibia',
    'Qad-peac' => 'Lesotho',
    'Qad-pead' => 'Swaziland',
    'Qad-peb' => 'Botswana',
    'Qad-pec' => 'Zimbabwe, Zambia, Malawi',
    'Qad-peca' => 'Zimbabwe',
    'Qad-pecb' => 'Zambia',
    'Qad-pecc' => 'Malawi',
    'Qad-ped' => 'Mocambique',
    'Qad-pee' => 'Madagaskar (Malagasy)',
    'Qad-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Qad-pefa' => 'Komorerna',
    'Qad-pefb' => 'Mauritius',
    'Qad-pefc' => 'Réunion',
    'Qad-pf' => 'Östafrika',
    'Qad-pfa' => 'Uganda',
    'Qad-pfb' => 'Kenya',
    'Qad-pfc' => 'Tanzania',
    'Qad-pfd' => 'Öar i nordvästra Indiska Oceanen (Seychellerna ...)',
    'Qad-pg' => 'Nordöstafrika',
    'Qad-pga' => 'Etiopien med Eritrea',
    'Qad-pgae' => 'Eritrea',
    'Qad-pgb' => 'Somalia',
    'Qad-pgc' => 'Djibouti',
    'Qad-q' => 'Amerika',
    'Qad-qa' => 'Förenta staterna',
    'Qad-qb' => 'Kanada',
    'Qad-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qad-qca' => 'Mexiko',
    'Qad-qcb' => 'Guatemala',
    'Qad-qcc' => 'Belize och Honduras',
    'Qad-qcd' => 'El Salvador',
    'Qad-qce' => 'Nicaragua',
    'Qad-qcf' => 'Costa Rica',
    'Qad-qcg' => 'Panama',
    'Qad-qch' => 'Västindien',
    'Qad-qcha' => 'Stora Antillerna',
    'Qad-qchaa' => 'Kuba',
    'Qad-qchab' => 'Haiti',
    'Qad-qchac' => 'Dominikanska republiken',
    'Qad-qchad' => 'Puerto Rico',
    'Qad-qchae' => 'Jamaica',
    'Qad-qchb' => 'Små Antillerna',
    'Qad-qchba' => 'Trinidad och Tobago',
    'Qad-qchbb' => 'Barbados',
    'Qad-qchbk' => 'St Lucia',
    'Qad-qchbm' => 'Grenada',
    'Qad-qchbö' => 'Övriga öar',
    'Qad-qchc' => 'Bahamas',
    'Qad-qchd' => 'Bermuda',
    'Qad-qd' => 'Sydamerika',
    'Qad-qda' => 'Colombia',
    'Qad-qdb' => 'Venezuela',
    'Qad-qdc' => 'Guyanastaterna',
    'Qad-qdd' => 'Brasilien',
    'Qad-qde' => 'Paraguay',
    'Qad-qdf' => 'Uruguay',
    'Qad-qdg' => 'Argentina',
    'Qad-qdh' => 'Chile',
    'Qad-qdi' => 'Bolivia',
    'Qad-qdk' => 'Peru',
    'Qad-qdl' => 'Ecuador',
    'Qad-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qad-ra' => 'Australien',
    'Qad-rb' => 'Nya Zeeland',
    'Qad-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qad-rca' => 'Melanesien',
    'Qad-rcb' => 'Polynesien',
    'Qad-rcc' => 'Mikronesien',
    'Qad-rd' => 'Nya Guinea',
    'Qad-s' => 'Polarländerna',
    'Qad-sa' => 'Arktis (Nordpolsområdet)',
    'Qad-saa' => 'Grönland',
    'Qad-sb' => 'Antarktis',
    'Qada' => 'Privat äganderätt',
    'Qada:k' => 'Den privata äganderättens historia',
    'Qada-' => 'Särskilda länder och områden',
    'Qada-a' => 'Europa: allmänt',
    'Qada-ae' => 'Europeiska unionen (EU)',
    'Qada-b' => 'Norden: allmänt',
    'Qada-c' => 'Sverige',
    'Qada-d' => 'Övriga Norden',
    'Qada-e' => 'Brittiska öarna (Storbritannien)',
    'Qada-f' => 'Mellaneuropa',
    'Qada-fa' => 'Tyskland',
    'Qada-fb' => 'Österrike och Liechtenstein',
    'Qada-fc' => 'Ungern',
    'Qada-fd' => 'Tjeckien och Slovakien',
    'Qada-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qada-j' => 'Frankrike och Monaco',
    'Qada-m' => 'Östeuropa',
    'Qada-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qada-mb' => 'Polen',
    'Qada-mc' => 'Estland, Lettland, Litauen',
    'Qada-n' => 'Balkanländerna',
    'Qada-o' => 'Asien',
    'Qada-oa' => 'Främre Asien',
    'Qada-ob' => 'Främre Indien',
    'Qada-oc' => 'Bortre Indien',
    'Qada-od' => 'Ostindiska öarna',
    'Qada-oe' => 'Östasien',
    'Qada-oea' => 'Kina',
    'Qada-oeb' => 'Korea',
    'Qada-oec' => 'Japan',
    'Qada-of' => 'Centralasien',
    'Qada-p' => 'Afrika',
    'Qada-q' => 'Amerika',
    'Qada-qa' => 'Förenta staterna',
    'Qada-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qada-qd' => 'Sydamerika',
    'Qada-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadb' => 'Monopol och konkurrens',
    'Qadb:oe' => 'Allmänt: lagstiftning',
    'Qadb-' => 'Särskilda länder och områden',
    'Qadb-a' => 'Europa: allmänt',
    'Qadb-ae' => 'Europeiska unionen (EU)',
    'Qadb-b' => 'Norden: allmänt',
    'Qadb-c' => 'Sverige',
    'Qadb-c:bf' => 'Organisationer och institutioner',
    'Qadb-c:oe' => 'Lagstiftning',
    'Qadb-d' => 'Övriga Norden',
    'Qadb-da' => 'Danmark',
    'Qadb-db' => 'Norge',
    'Qadb-dd' => 'Finland',
    'Qadb-e' => 'Brittiska öarna (Storbritannien)',
    'Qadb-f' => 'Mellaneuropa (Tyskland)',
    'Qadb-h' => 'Schweiz',
    'Qadb-j' => 'Frankrike och Monaco',
    'Qadb-m' => 'Östeuropa',
    'Qadb-o' => 'Asien',
    'Qadb-oe' => 'Östasien',
    'Qadb-p' => 'Afrika',
    'Qadb-q' => 'Amerika',
    'Qadb-qa' => 'Förenta staterna',
    'Qadb-qb' => 'Kanada',
    'Qadb-qd' => 'Sydamerika',
    'Qadba' => 'Monopol och oligopol',
    'Qadba-c' => 'Sverige',
    'Qadbb' => 'Karteller och truster',
    'Qadbb-c' => 'Sverige',
    'Qadc' => 'Statlig reglering av näringslivet',
    'Qadc-' => 'Särskilda länder och områden',
    'Qadc-a' => 'Europa: allmänt',
    'Qadc-ae' => 'Europeiska unionen (EU)',
    'Qadc-b' => 'Norden: allmänt',
    'Qadc-c' => 'Sverige',
    'Qadc-d' => 'Övriga Norden',
    'Qadc-da' => 'Danmark',
    'Qadc-db' => 'Norge',
    'Qadc-dd' => 'Finland',
    'Qadc-e' => 'Brittiska öarna (Storbritannien)',
    'Qadc-f' => 'Mellaneuropa',
    'Qadc-fa' => 'Tyskland',
    'Qadc-fb' => 'Österrike och Liechtenstein',
    'Qadc-fc' => 'Ungern',
    'Qadc-fd' => 'Tjeckien och Slovakien',
    'Qadc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qadc-h' => 'Schweiz',
    'Qadc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qadc-j' => 'Frankrike och Monaco',
    'Qadc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadc-m' => 'Östeuropa',
    'Qadc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadc-mb' => 'Polen',
    'Qadc-mc' => 'Estland, Lettland, Litauen',
    'Qadc-n' => 'Balkanländerna',
    'Qadc-na' => 'Rumänien',
    'Qadc-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qadc-nc' => 'Bulgarien',
    'Qadc-nd' => 'Grekland',
    'Qadc-nf' => 'Albanien',
    'Qadc-o' => 'Asien',
    'Qadc-oa' => 'Främre Asien',
    'Qadc-ob' => 'Främre Indien',
    'Qadc-oba' => 'Indien',
    'Qadc-obb' => 'Pakistan och Bangladesh',
    'Qadc-oc' => 'Bortre Indien',
    'Qadc-od' => 'Ostindiska öarna',
    'Qadc-oe' => 'Östasien',
    'Qadc-oea' => 'Kina',
    'Qadc-oeb' => 'Korea',
    'Qadc-oec' => 'Japan',
    'Qadc-p' => 'Afrika',
    'Qadc-pa' => 'Nordafrika utom Egypten',
    'Qadc-pb' => 'Egypten och Sudan',
    'Qadc-pc' => 'Västafrika',
    'Qadc-pe' => 'Södra Afrika',
    'Qadc-pf' => 'Östafrika',
    'Qadc-q' => 'Amerika',
    'Qadc-qa' => 'Förenta staterna',
    'Qadc-qb' => 'Kanada',
    'Qadc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadc-qd' => 'Sydamerika',
    'Qadc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadcb' => 'Regional- och lokaliseringspolitik',
    'Qadcb-' => 'Särskilda länder och områden',
    'Qadcb-a' => 'Europa: allmänt',
    'Qadcb-ae' => 'Europeiska unionen (EU)',
    'Qadcb-b' => 'Norden: allmänt',
    'Qadcb-c' => 'Sverige',
    'Qadcb-c:k' => 'Historia',
    'Qadcb-d' => 'Övriga Norden',
    'Qadcb-da' => 'Danmark',
    'Qadcb-db' => 'Norge',
    'Qadcb-dd' => 'Finland',
    'Qadcb-e' => 'Brittiska öarna (Storbritannien)',
    'Qadcb-es' => 'Skottland',
    'Qadcb-et' => 'Irland',
    'Qadcb-f' => 'Mellaneuropa',
    'Qadcb-fa' => 'Tyskland',
    'Qadcb-fb' => 'Österrike och Liechtenstein',
    'Qadcb-fc' => 'Ungern',
    'Qadcb-fd' => 'Tjeckien och Slovakien',
    'Qadcb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qadcb-ga' => 'Nederländerna',
    'Qadcb-gb' => 'Belgien',
    'Qadcb-gc' => 'Luxemburg',
    'Qadcb-h' => 'Schweiz',
    'Qadcb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qadcb-j' => 'Frankrike och Monaco',
    'Qadcb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadcb-l' => 'Portugal',
    'Qadcb-m' => 'Östeuropa',
    'Qadcb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadcb-mb' => 'Polen',
    'Qadcb-mc' => 'Estland, Lettland, Litauen',
    'Qadcb-n' => 'Balkanländerna',
    'Qadcb-o' => 'Asien',
    'Qadcb-oa' => 'Främre Asien',
    'Qadcb-ob' => 'Främre Indien',
    'Qadcb-oc' => 'Bortre Indien',
    'Qadcb-oe' => 'Östasien',
    'Qadcb-oea' => 'Kina',
    'Qadcb-oeb' => 'Korea',
    'Qadcb-oec' => 'Japan',
    'Qadcb-p' => 'Afrika',
    'Qadcb-q' => 'Amerika',
    'Qadcb-qa' => 'Förenta staterna',
    'Qadcb-qb' => 'Kanada',
    'Qadcb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadcb-qd' => 'Sydamerika',
    'Qadcb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadcc' => 'Industripolitik',
    'Qadcc-' => 'Särskilda länder och områden',
    'Qadcc-a' => 'Europa: allmänt',
    'Qadcc-ae' => 'Europeiska unionen (EU)',
    'Qadcc-b' => 'Norden: allmänt',
    'Qadcc-c' => 'Sverige',
    'Qadcc-d' => 'Övriga Norden',
    'Qadcc-da' => 'Danmark',
    'Qadcc-db' => 'Norge',
    'Qadcc-dd' => 'Finland',
    'Qadcc-e' => 'Brittiska öarna (Storbritannien)',
    'Qadcc-f' => 'Mellaneuropa',
    'Qadcc-fa' => 'Tyskland',
    'Qadcc-fb' => 'Österrike och Liechtenstein',
    'Qadcc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qadcc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qadcc-j' => 'Frankrike och Monaco',
    'Qadcc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadcc-m' => 'Östeuropa',
    'Qadcc-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadcc-mc' => 'Estland, Lettland, Litauen',
    'Qadcc-n' => 'Balkanländerna',
    'Qadcc-o' => 'Asien',
    'Qadcc-oa' => 'Främre Asien',
    'Qadcc-ob' => 'Främre Indien',
    'Qadcc-oba' => 'Indien',
    'Qadcc-obb' => 'Pakistan och Bangladesh',
    'Qadcc-oc' => 'Bortre Indien',
    'Qadcc-od' => 'Ostindiska öarna',
    'Qadcc-oe' => 'Östasien',
    'Qadcc-oea' => 'Kina',
    'Qadcc-oeb' => 'Korea',
    'Qadcc-oec' => 'Japan',
    'Qadcc-p' => 'Afrika',
    'Qadcc-pa' => 'Nordafrika utom Egypten',
    'Qadcc-pc' => 'Västafrika',
    'Qadcc-pe' => 'Södra Afrika',
    'Qadcc-pf' => 'Östafrika',
    'Qadcc-q' => 'Amerika',
    'Qadcc-qa' => 'Förenta staterna',
    'Qadcc-qb' => 'Kanada',
    'Qadcc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadcc-qd' => 'Sydamerika',
    'Qadcc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadcca' => 'Statligt företagande',
    'Qadcca-c' => 'Sverige',
    'Qadck-' => 'Särskilda länder och områden',
    'Qadck-c' => 'Sverige',
    'Qadck-c:k' => 'Historia',
    'Qadck-c:oe' => 'Lagstiftning',
    'Qadck-d' => 'Övriga Norden',
    'Qadck-e' => 'Brittiska öarna (Storbritannien)',
    'Qadck-f' => 'Mellaneuropa',
    'Qadck-fa' => 'Tyskland',
    'Qadck-fb' => 'Österrike och Liechtenstein',
    'Qadck-j' => 'Frankrike och Monaco',
    'Qadck-m' => 'Östeuropa (Ryssland inkl f d Sovjetunionen)',
    'Qadck-n' => 'Balkanländerna',
    'Qadck-o' => 'Asien',
    'Qadck-p' => 'Afrika',
    'Qadck-q' => 'Amerika',
    'Qadck' => 'Krigs- och krisekonomi',
    'Qadd' => 'Interstatligt ekonomiskt samarbete',
    'Qadd:bf' => 'Organisationer och institutioner',
    'Qadd:oe' => 'Lagstiftning',
    'Qadd-' => 'Särskilda länder och områden',
    'Qadd-a' => 'Europa: allmänt',
    'Qadd-a:bf' => 'Europeiska gemenskaperna (till 1993)',
    'Qadd-ae' => 'Europeiska gemenskaperna och Europeiska unionen (EU) (1993-)',
    'Qadd-ae:bf' => 'Organisationer och institutioner',
    'Qadd-b' => 'Norden: allmänt',
    'Qadd-c' => 'Sverige',
    'Qadd-d' => 'Övriga Norden',
    'Qadd-e' => 'Brittiska öarna (Storbritannien)',
    'Qadd-f' => 'Mellaneuropa',
    'Qadd-j' => 'Frankrike och Monaco',
    'Qadd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadd-m' => 'Östeuropa',
    'Qadd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadd-mb' => 'Polen',
    'Qadd-mc' => 'Estland, Lettland, Litauen',
    'Qadd-n' => 'Balkanländerna',
    'Qadd-o' => 'Asien',
    'Qadd-oa' => 'Främre Asien',
    'Qadd-ob' => 'Främre Indien',
    'Qadd-oc' => 'Bortre Indien',
    'Qadd-od' => 'Ostindiska öarna',
    'Qadd-oe' => 'Östasien',
    'Qadd-p' => 'Afrika',
    'Qadd-pa' => 'Nordafrika utom Egypten',
    'Qadd-pc' => 'Västafrika',
    'Qadd-pd' => 'Centralafrika',
    'Qadd-pe' => 'Södra Afrika',
    'Qadd-pf' => 'Östafrika',
    'Qadd-q' => 'Amerika',
    'Qadd-qa' => 'Förenta staterna',
    'Qadd-qb' => 'Kanada',
    'Qadd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadd-qca' => 'Mexiko',
    'Qadd-qch' => 'Västindien',
    'Qadd-qd' => 'Sydamerika',
    'Qadd-qda' => 'Colombia',
    'Qadd-qdb' => 'Venezuela',
    'Qadd-qdd' => 'Brasilien',
    'Qadd-qde' => 'Paraguay',
    'Qadd-qdf' => 'Uruguay',
    'Qadd-qdg' => 'Argentina',
    'Qadd-qdh' => 'Chile',
    'Qadd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qade' => 'Världsekonomi',
    'Qade:bf' => 'Organisationer och institutioner',
    'Qade:k' => 'Världsekonomins historia',
    'Qade-c' => 'Sverige',
    'Qade-o' => 'Asien',
    'Qade-p' => 'Afrika',
    'Qade-q' => 'Amerika',
    'Qadg' => 'Tjänster',
    'Qadg-c' => 'Sverige',
    'Qadh' => 'Industri',
    'Qadh-' => 'Särskilda länder och områden',
    'Qadh-a' => 'Europa: allmänt',
    'Qadh-ae' => 'Europeiska unionen (EU)',
    'Qadh-b' => 'Norden: allmänt',
    'Qadh-c' => 'Sverige',
    'Qadh-c:k' => 'Historia',
    'Qadh-d' => 'Övriga Norden',
    'Qadh-da' => 'Danmark',
    'Qadh-db' => 'Norge',
    'Qadh-dd' => 'Finland',
    'Qadh-e' => 'Brittiska öarna (Storbritannien)',
    'Qadh-f' => 'Mellaneuropa',
    'Qadh-fa' => 'Tyskland',
    'Qadh-fb' => 'Österrike och Liechtenstein',
    'Qadh-fc' => 'Ungern',
    'Qadh-fd' => 'Tjeckien och Slovakien',
    'Qadh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qadh-h' => 'Schweiz',
    'Qadh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qadh-j' => 'Frankrike och Monaco',
    'Qadh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadh-m' => 'Östeuropa',
    'Qadh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadh-mb' => 'Polen',
    'Qadh-mc' => 'Estland, Lettland, Litauen',
    'Qadh-n' => 'Balkanländerna',
    'Qadh-o' => 'Asien',
    'Qadh-oa' => 'Främre Asien',
    'Qadh-ob' => 'Främre Indien',
    'Qadh-oba' => 'Indien',
    'Qadh-obb' => 'Pakistan och Bangladesh',
    'Qadh-oc' => 'Bortre Indien',
    'Qadh-od' => 'Ostindiska öarna',
    'Qadh-oe' => 'Östasien',
    'Qadh-oea' => 'Kina',
    'Qadh-oeaf' => 'Taiwan',
    'Qadh-oeb' => 'Korea',
    'Qadh-oec' => 'Japan',
    'Qadh-oek' => 'Hongkong och Macau',
    'Qadh-of' => 'Centralasien',
    'Qadh-p' => 'Afrika',
    'Qadh-pa' => 'Nordafrika utom Egypten',
    'Qadh-pb' => 'Egypten och Sudan',
    'Qadh-pc' => 'Västafrika',
    'Qadh-pd' => 'Centralafrika',
    'Qadh-pe' => 'Södra Afrika',
    'Qadh-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Qadh-peb' => 'Botswana',
    'Qadh-pec' => 'Zimbabwe, Zambia, Malawi',
    'Qadh-pf' => 'Östafrika',
    'Qadh-pg' => 'Nordöstafrika',
    'Qadh-q' => 'Amerika',
    'Qadh-qa' => 'Förenta staterna',
    'Qadh-qb' => 'Kanada',
    'Qadh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadh-qd' => 'Sydamerika',
    'Qadh-qda' => 'Colombia',
    'Qadh-qdd' => 'Brasilien',
    'Qadh-qdf' => 'Uruguay',
    'Qadh-qdg' => 'Argentina',
    'Qadh-qdh' => 'Chile',
    'Qadh-qdi' => 'Bolivia',
    'Qadh-qdk' => 'Peru',
    'Qadh-qdl' => 'Ecuador',
    'Qadh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadi' => 'Handel',
    'Qadi:bf' => 'Orgnisationer och institutioner',
    'Qadi:k' => 'Handelns historia',
    'Qadi:oe' => 'Lagstiftning',
    'Qadi-' => 'Särskilda länder och områden',
    'Qadi-a' => 'Europa: allmänt',
    'Qadi-ae' => 'Europeiska unionen (EU)',
    'Qadi-b' => 'Norden: allmänt',
    'Qadi-c' => 'Sverige',
    'Qadi-d' => 'Övriga Norden',
    'Qadi-da' => 'Danmark',
    'Qadi-db' => 'Norge',
    'Qadi-dc' => 'Island och Färöarna',
    'Qadi-dd' => 'Finland',
    'Qadi-e' => 'Brittiska öarna (Storbritannien)',
    'Qadi-f' => 'Mellaneuropa',
    'Qadi-fa' => 'Tyskland',
    'Qadi-fb' => 'Österrike och Liechtenstein',
    'Qadi-fc' => 'Ungern',
    'Qadi-fd' => 'Tjeckien och Slovakien',
    'Qadi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qadi-h' => 'Schweiz',
    'Qadi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qadi-j' => 'Frankrike och Monaco',
    'Qadi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qadi-m' => 'Östeuropa',
    'Qadi-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qadi-mb' => 'Polen',
    'Qadi-mc' => 'Estland, Lettland, Litauen',
    'Qadi-n' => 'Balkanländerna',
    'Qadi-na' => 'Rumänien',
    'Qadi-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qadi-nc' => 'Bulgarien',
    'Qadi-o' => 'Asien',
    'Qadi-oa' => 'Främre Asien',
    'Qadi-oaa' => 'Turkiet',
    'Qadi-oaf' => 'Palestina och Israel',
    'Qadi-oai' => 'Irak',
    'Qadi-ob' => 'Främre Indien',
    'Qadi-oba' => 'Indien',
    'Qadi-obb' => 'Pakistan och Bangladesh',
    'Qadi-obe' => 'Sri Lanka (f d Ceylon)',
    'Qadi-oc' => 'Bortre Indien',
    'Qadi-ocb' => 'Thailand',
    'Qadi-occ' => 'Malaysia, Singapore och Brunei',
    'Qadi-ocd' => 'Indokina',
    'Qadi-od' => 'Ostindiska öarna',
    'Qadi-oda' => 'Indonesien',
    'Qadi-odc' => 'Filippinerna',
    'Qadi-oe' => 'Östasien',
    'Qadi-oea' => 'Kina',
    'Qadi-oeaf' => 'Taiwan',
    'Qadi-oeb' => 'Korea',
    'Qadi-oec' => 'Japan',
    'Qadi-oek' => 'Hongkong och Macau',
    'Qadi-p' => 'Afrika',
    'Qadi-pa' => 'Nordafrika utom Egypten',
    'Qadi-pb' => 'Egypten och Sudan',
    'Qadi-pc' => 'Västafrika',
    'Qadi-pcb' => 'Ekvatorialfrika',
    'Qadi-pcc' => 'Norra Västafrika',
    'Qadi-pcd' => 'Södra Västafrika',
    'Qadi-pd' => 'Centralafrika',
    'Qadi-pe' => 'Södra Afrika',
    'Qadi-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Qadi-pec' => 'Zimbabwe, Zambia, Malawi',
    'Qadi-ped' => 'Mocambique',
    'Qadi-pee' => 'Madagaskar (Malagasy)',
    'Qadi-pf' => 'Östafrika',
    'Qadi-q' => 'Amerika',
    'Qadi-qa' => 'Förenta staterna',
    'Qadi-qb' => 'Kanada',
    'Qadi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadi-qca' => 'Mexiko',
    'Qadi-qcb' => 'Guatemala',
    'Qadi-qcc' => 'Belize och Honduras',
    'Qadi-qcd' => 'El Salvador',
    'Qadi-qce' => 'Nicaragua',
    'Qadi-qcf' => 'Costa Rica',
    'Qadi-qcg' => 'Panama',
    'Qadi-qch' => 'Västindien',
    'Qadi-qd' => 'Sydamerika',
    'Qadi-qda' => 'Colombia',
    'Qadi-qdb' => 'Venezuela',
    'Qadi-qdc' => 'Guyanastaterna',
    'Qadi-qdd' => 'Brasilien',
    'Qadi-qde' => 'Paraguay',
    'Qadi-qdf' => 'Uruguay',
    'Qadi-qdg' => 'Argentina',
    'Qadi-qdh' => 'Chile',
    'Qadi-qdi' => 'Bolivia',
    'Qadi-qdk' => 'Peru',
    'Qadi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadi-ra' => 'Australien',
    'Qadi-rb' => 'Nya Zeeland',
    'Qadi-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qadi-rd' => 'Nya Guinea',
    'Qadj' => 'Inkomst- och förmögnehtsfördelning',
    'Qadj-' => 'Särskilda länder och områden',
    'Qadj-a' => 'Europa: allmänt',
    'Qadj-b' => 'Norden: allmänt',
    'Qadj-c' => 'Sverige',
    'Qadj-c:k' => 'Historia',
    'Qadj-d' => 'Övriga Norden',
    'Qadj-da' => 'Danmark',
    'Qadj-db' => 'Norge',
    'Qadj-dd' => 'Finland',
    'Qadj-e' => 'Brittiska öarna (Storbritannien)',
    'Qadj-f' => 'Mellaneuropa',
    'Qadj-m' => 'Östeuropa',
    'Qadj-o' => 'Asien',
    'Qadj-oa' => 'Främre Asien',
    'Qadj-ob' => 'Främre Indien',
    'Qadj-oc' => 'Bortre Indien',
    'Qadj-od' => 'Ostindiska öarna',
    'Qadj-oe' => 'Östasien',
    'Qadj-p' => 'Afrika',
    'Qadj-q' => 'Amerika',
    'Qadj-qa' => 'Förenta staterna',
    'Qadj-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadj-qd' => 'Sydamerika',
    'Qadj-qda' => 'Colombia',
    'Qadj-qdb' => 'Venezuela',
    'Qadj-qdd' => 'Brasilien',
    'Qadj-qdh' => 'Chile',
    'Qadj-qdi' => 'Bolivia',
    'Qadj-qdk' => 'Peru',
    'Qadj-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadj-ra' => 'Australien',
    'Qadj-rb' => 'Nya Zeeland',
    'Qadj-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qadj-rd' => 'Nya Guinea',
    'Qadj-s' => 'Polarländerna',
    'Qadk' => 'Tekniköverföring',
    'Qadk-' => 'Särskilda länder och områden',
    'Qadk-a' => 'Europa: allmänt',
    'Qadk-b' => 'Norden: allmänt',
    'Qadk-c' => 'Sverige',
    'Qadk-d' => 'Övriga Norden',
    'Qadk-e' => 'Brittiska öarna (Storbritannien)',
    'Qadk-f' => 'Mellaneuropa',
    'Qadk-j' => 'Frankrike och Monaco',
    'Qadk-m' => 'Östeuropa',
    'Qadk-o' => 'Asien',
    'Qadk-oa' => 'Främre Asien',
    'Qadk-ob' => 'Främre Indien',
    'Qadk-oc' => 'Bortre Indien',
    'Qadk-od' => 'Ostindiska öarna',
    'Qadk-oe' => 'Östasien',
    'Qadk-of' => 'Centralasien',
    'Qadk-p' => 'Afrika',
    'Qadk-q' => 'Amerika',
    'Qadk-qa' => 'Förenta staterna',
    'Qadk-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qadk-qd' => 'Sydamerika',
    'Qadk-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadn' => 'Naturresurser',
    'Qadn-' => 'Särskilda länder och områden',
    'Qadn-a' => 'Europa: allmänt',
    'Qadn-b' => 'Norden: allmänt',
    'Qadn-c' => 'Sverige',
    'Qadn-d' => 'Övriga Norden',
    'Qadn-e' => 'Brittiska öarna (Storbritannien)',
    'Qadn-f' => 'Mellaneuropa',
    'Qadn-m' => 'Östeuropa',
    'Qadn-o' => 'Asien',
    'Qadn-p' => 'Afrika',
    'Qadn-q' => 'Amerika',
    'Qadn-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qadn-s' => 'Polarländerna',
    'Qadu' => 'U-länderna',
    'Qadu:bf' => 'Organisationer och institutioner',
    'Qadu:k' => 'Historia',
    'Qadu-a' => 'Europa: allmänt',
    'Qadu-o' => 'Asien',
    'Qadu-p' => 'Afrika',
    'Qadu-q' => 'Amerika',
    'Qae' => 'Penning- och bankväsen',
    'Qae(x)' => 'Lexikon',
    'Qae:k' => 'Penning- och bankväsendets historia',
    'Qae:oe' => 'Allmänt: lagstiftning',
    'Qae-' => 'Allmänt: särskilda länder och områden',
    'Qae-a' => 'Europa: allmänt',
    'Qae-ae' => 'Europeiska unionen (EU)',
    'Qae-b' => 'Norden: allmänt',
    'Qae-c' => 'Sverige',
    'Qae-c:bf' => 'Organisationer och institutioner',
    'Qae-c:k' => 'Historia',
    'Qae-c:oe' => 'Lagstiftning',
    'Qae-cz' => 'Särskilda orter',
    'Qae-d' => 'Övriga Norden',
    'Qae-da' => 'Danmark',
    'Qae-db' => 'Norge',
    'Qae-dd' => 'Finland',
    'Qae-e' => 'Brittiska öarna (Storbritannien)',
    'Qae-f' => 'Mellaneuropa',
    'Qae-fa' => 'Tyskland',
    'Qae-fb' => 'Österrike och Liechtenstein',
    'Qae-fc' => 'Ungern',
    'Qae-fd' => 'Tjeckien och Slovakien',
    'Qae-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qae-h' => 'Schweiz',
    'Qae-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qae-j' => 'Frankrike och Monaco',
    'Qae-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qae-l' => 'Portugal',
    'Qae-m' => 'Östeuropa',
    'Qae-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qae-mb' => 'Polen',
    'Qae-mc' => 'Estland, Lettland, Litauen',
    'Qae-n' => 'Balkanländerna',
    'Qae-o' => 'Asien',
    'Qae-oa' => 'Främre Asien',
    'Qae-ob' => 'Främre Indien',
    'Qae-oc' => 'Bortre Indien',
    'Qae-od' => 'Ostindiska öarna',
    'Qae-oe' => 'Östasien',
    'Qae-oea' => 'Kina',
    'Qae-oeb' => 'Korea',
    'Qae-oec' => 'Japan',
    'Qae-oek' => 'Hongkong och Macau',
    'Qae-p' => 'Afrika',
    'Qae-pa' => 'Nordafrika utom Egypten',
    'Qae-pb' => 'Egypten och Sudan',
    'Qae-pc' => 'Västafrika',
    'Qae-pd' => 'Centralafrika',
    'Qae-pe' => 'Södra Afrika',
    'Qae-pf' => 'Östafrika',
    'Qae-q' => 'Amerika',
    'Qae-qa' => 'Förenta staterna',
    'Qae-qb' => 'Kanada',
    'Qae-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qae-qd' => 'Sydamerika',
    'Qae-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaea' => 'Penningväsen',
    'Qaea:k' => 'Penningsväsendets historia',
    'Qaea:oe' => 'Penninglagstiftning',
    'Qaea-' => 'Särskilda länder och områden',
    'Qaea-a' => 'Europa: allmänt',
    'Qaea-ae' => 'Europeiska unionen (EU)',
    'Qaea-b' => 'Norden: allmänt',
    'Qaea-c' => 'Sverige',
    'Qaea-c:k' => 'Historia',
    'Qaea-c:oe' => 'Lagstiftning',
    'Qaea-d' => 'Övriga Norden',
    'Qaea-da' => 'Danmark',
    'Qaea-db' => 'Norge',
    'Qaea-dd' => 'Finland',
    'Qaea-e' => 'Brittiska öarna (Storbritannien)',
    'Qaea-f' => 'Mellaneuropa',
    'Qaea-fa' => 'Tyskland',
    'Qaea-fb' => 'Österrike och Liechtenstein',
    'Qaea-fc' => 'Ungern',
    'Qaea-fd' => 'Tjeckien och Slovakien',
    'Qaea-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qaea-h' => 'Schweiz',
    'Qaea-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qaea-j' => 'Frankrike och Monaco',
    'Qaea-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qaea-m' => 'Östeuropa',
    'Qaea-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qaea-mb' => 'Polen',
    'Qaea-mc' => 'Estland, Lettland, Litauen',
    'Qaea-n' => 'Balkanländerna',
    'Qaea-o' => 'Asien',
    'Qaea-oa' => 'Främre Asien',
    'Qaea-ob' => 'Främre Indien',
    'Qaea-oc' => 'Bortre Indien',
    'Qaea-od' => 'Ostindiska öarna',
    'Qaea-oe' => 'Östasien',
    'Qaea-oea' => 'Kina',
    'Qaea-oec' => 'Japan',
    'Qaea-p' => 'Afrika',
    'Qaea-q' => 'Amerika',
    'Qaea-qa' => 'Förenta staterna',
    'Qaea-qb' => 'Kanada',
    'Qaea-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaea-qd' => 'Sydamerika',
    'Qaea-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeab' => 'Penningvärde',
    'Qaeab:k' => 'Penningvärdets historia',
    'Qaeab-' => 'Särskilda länder och områden',
    'Qaeab-a' => 'Europa: allmänt',
    'Qaeab-b' => 'Norden: allmänt',
    'Qaeab-c' => 'Sverige',
    'Qaeab-d' => 'Övriga Norden',
    'Qaeab-e' => 'Brittiska öarna (Storbritannien)',
    'Qaeab-f' => 'Mellaneuropa',
    'Qaeab-j' => 'Frankrike och Monaco',
    'Qaeab-m' => 'Östeuropa',
    'Qaeab-o' => 'Asien',
    'Qaeab-p' => 'Afrika',
    'Qaeab-q' => 'Amerika',
    'Qaeab-qa' => 'Förenta staterna',
    'Qaeab-qb' => 'Kanada',
    'Qaeab-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaeab-qd' => 'Sydamerika',
    'Qaeab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeac' => 'Myntfot',
    'Qaeac:k' => 'Myntfotens historia',
    'Qaeae' => 'Ränta och diskonto',
    'Qaeae-c' => 'Sverige',
    'Qaeaf' => 'Växelkurser',
    'Qaeaf-' => 'Särskilda länder och områden',
    'Qaeaf-a' => 'Europa: allmänt',
    'Qaeaf-ae' => 'Europeiska unionen (EU)',
    'Qaeaf-b' => 'Norden: allmänt',
    'Qaeaf-c' => 'Sverige',
    'Qaeaf-d' => 'Övriga Norden',
    'Qaeaf-f' => 'Mellaneuropa',
    'Qaeaf-o' => 'Asien',
    'Qaeaf-oa' => 'Främre Asien',
    'Qaeaf-p' => 'Afrika',
    'Qaeaf-q' => 'Amerika',
    'Qaeaf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeb' => 'Bank- och kreditväsen',
    'Qaeb:k' => 'Bank- och kreditväsendets historia',
    'Qaeb:oe' => 'Bank- och kreditlagstiftning',
    'Qaeb-' => 'Särskilda länder och områden',
    'Qaeb-a' => 'Europa: allmänt',
    'Qaeb-ae' => 'Europeiska unionen (EU)',
    'Qaeb-aez' => 'Särskilda banker',
    'Qaeb-b' => 'Norden: allmänt',
    'Qaeb-c' => 'Sverige',
    'Qaeb-c:bf' => 'Organisationer och institutioner',
    'Qaeb-c:k' => 'Bank- och kreditväsendets historia',
    'Qaeb-c:oe' => 'Bank- och kreditlagstiftning',
    'Qaeb-cz' => 'Särskilda banker',
    'Qaeb-d' => 'Övriga Norden',
    'Qaeb-da' => 'Danmark',
    'Qaeb-daz' => 'Särskilda banker',
    'Qaeb-db' => 'Norge',
    'Qaeb-dbz' => 'Särskilda banker',
    'Qaeb-dc' => 'Island och Färöarna',
    'Qaeb-dd' => 'Finland',
    'Qaeb-ddz' => 'Särskilda banker',
    'Qaeb-e' => 'Brittiska öarna (Storbritannien)',
    'Qaeb-ez' => 'Särskilda banker',
    'Qaeb-f' => 'Mellaneuropa',
    'Qaeb-fa' => 'Tyskland',
    'Qaeb-faz' => 'Särskilda banker',
    'Qaeb-fb' => 'Österrike och Liechtenstein',
    'Qaeb-fc' => 'Ungern',
    'Qaeb-fd' => 'Tjeckien och Slovakien',
    'Qaeb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qaeb-h' => 'Schweiz',
    'Qaeb-hz' => 'Särskilda banker',
    'Qaeb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qaeb-j' => 'Frankrike och Monaco',
    'Qaeb-jz' => 'Särskilda banker',
    'Qaeb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qaeb-l' => 'Portugal',
    'Qaeb-m' => 'Östeuropa',
    'Qaeb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qaeb-mb' => 'Polen',
    'Qaeb-mc' => 'Estland, Lettland, Litauen',
    'Qaeb-n' => 'Balkanländerna',
    'Qaeb-o' => 'Asien',
    'Qaeb-oa' => 'Främre Asien',
    'Qaeb-ob' => 'Främre Indien',
    'Qaeb-oc' => 'Bortre Indien',
    'Qaeb-od' => 'Ostindiska öarna',
    'Qaeb-oe' => 'Östasien',
    'Qaeb-oea' => 'Kina',
    'Qaeb-oeb' => 'Korea',
    'Qaeb-oec' => 'Japan',
    'Qaeb-oek' => 'Hongkong och Macau',
    'Qaeb-p' => 'Afrika',
    'Qaeb-pa' => 'Nordafrika utom Egypten',
    'Qaeb-pb' => 'Egypten och Sudan',
    'Qaeb-pc' => 'Västafrika',
    'Qaeb-pe' => 'Södra Afrika',
    'Qaeb-pf' => 'Östafrika',
    'Qaeb-q' => 'Amerika',
    'Qaeb-qa' => 'Förenta staterna',
    'Qaeb-qaz' => 'Särskilda banker',
    'Qaeb-qb' => 'Kanada',
    'Qaeb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaeb-qd' => 'Sydamerika',
    'Qaeb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeba' => 'Nationalbanker',
    'Qaeba-' => 'Särskilda länder och områden',
    'Qaeba-a' => 'Europa: allmänt',
    'Qaeba-ae' => 'Europeiska unionen (EU)',
    'Qaeba-c' => 'Sverige',
    'Qaeba-d' => 'Övriga Norden',
    'Qaeba-e' => 'Brittiska öarna (Storbritannien)',
    'Qaeba-f' => 'Mellaneuropa',
    'Qaeba-m' => 'Östeuropa',
    'Qaeba-o' => 'Asien',
    'Qaeba-q' => 'Amerika',
    'Qaebb' => 'Affärsbanker',
    'Qaebb-c' => 'Sverige',
    'Qaebb-c:k' => 'Historia',
    'Qaebb-d' => 'Övriga Norden',
    'Qaebc' => 'Sparbanker',
    'Qaebc-c' => 'Sverige',
    'Qaebc-c:k' => 'Historia',
    'Qaebc-d' => 'Övriga Norden',
    'Qaebc-f' => 'Mellaneuropa',
    'Qaebd' => 'Hypoteksinstitut',
    'Qaebd-c' => 'Sverige',
    'Qaebe' => 'Jordbruks- och föreningskassor',
    'Qaebe-c' => 'Sverige',
    'Qaebf' => 'Industribanker',
    'Qaebg' => 'Finans- och investeringsbolag',
    'Qaebg-c' => 'Sverige',
    'Qaebg-e' => 'Brittiska öarna (Storbritannien)',
    'Qaebg-o' => 'Asien',
    'Qaebg-q' => 'Amerika',
    'Qaebk' => 'Kreditväsen',
    'Qaebk-' => 'Särskilda länder och områden',
    'Qaebk-a' => 'Europa: allmänt',
    'Qaebk-b' => 'Norden: allmänt',
    'Qaebk-c' => 'Sverige',
    'Qaebk-c:k' => 'Kreditväsendets historia',
    'Qaebk-c:oe' => 'Kreditlagstiftning',
    'Qaebk-d' => 'Övriga Norden',
    'Qaebk-da' => 'Danmark',
    'Qaebk-db' => 'Norge',
    'Qaebk-dd' => 'Finland',
    'Qaebk-e' => 'Brittiska öarna (Storbritannien)',
    'Qaebk-f' => 'Mellaneuropa',
    'Qaebk-fa' => 'Tyskland',
    'Qaebk-fb' => 'Österrike och Liechtenstein',
    'Qaebk-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qaebk-h' => 'Schweiz',
    'Qaebk-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qaebk-j' => 'Frankrike och Monaco',
    'Qaebk-m' => 'Östeuropa',
    'Qaebk-n' => 'Balkanländerna',
    'Qaebk-o' => 'Asien',
    'Qaebk-p' => 'Afrika',
    'Qaebk-q' => 'Amerika',
    'Qaebkh' => 'Handelsväxlar och andra kreditinstrument',
    'Qaebkh-c' => 'Sverige',
    'Qaebk:k' => 'Krediväsendets historia',
    'Qaec' => 'Börsväsen',
    'Qaec-' => 'Särskilda länder och områden',
    'Qaec-a' => 'Europa: allmänt',
    'Qaec-b' => 'Norden: allmänt',
    'Qaec-c' => 'Sverige',
    'Qaec-c:k' => 'Börsväsendets historia',
    'Qaec-c:oe' => 'Börslagstiftning',
    'Qaec-cz' => 'Särskilda börser',
    'Qaec-d' => 'Övriga Norden',
    'Qaec-da' => 'Danmark',
    'Qaec-db' => 'Norge',
    'Qaec-dd' => 'Finland',
    'Qaec-e' => 'Brittiska öarna (Storbritannien)',
    'Qaec-f' => 'Mellaneuropa',
    'Qaec-fa' => 'Tyskland',
    'Qaec-fb' => 'Österrike och Liechtenstein',
    'Qaec-fc' => 'Ungern',
    'Qaec-fd' => 'Tjeckien och Slovakien',
    'Qaec-o' => 'Asien',
    'Qaec-p' => 'Afrika',
    'Qaec-q' => 'Amerika',
    'Qaec-qa' => 'Förenta staterna',
    'Qaec-qa:k' => 'Börsväsendets historia',
    'Qaec-q:oe' => 'Börslagstiftning',
    'Qaec-qaz' => 'Särskilda börser',
    'Qaec-qb' => 'Kanada',
    'Qaec-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeca' => 'Aktier och obligationer',
    'Qaeca-' => 'Särskilda länder och områden',
    'Qaeca-a' => 'Europa: allmänt',
    'Qaeca-b' => 'Norden: allmänt',
    'Qaeca-c' => 'Sverige',
    'Qaeca-c:k' => 'Historia',
    'Qaeca-c:oe' => 'Lagstiftning',
    'Qaeca-d' => 'Övriga Norden',
    'Qaeca-da' => 'Danmark',
    'Qaeca-db' => 'Norge',
    'Qaeca-dd' => 'Finland',
    'Qaeca-e' => 'Brittiska öarna (Storbritannien)',
    'Qaeca-f' => 'Mellaneuropa',
    'Qaeca-fa' => 'Tyskland',
    'Qaeca-h' => 'Schweiz',
    'Qaeca-j' => 'Frankrike och Monaco',
    'Qaeca-o' => 'Asien',
    'Qaeca-q' => 'Amerika',
    'Qaeca-qa' => 'Förenta staterna',
    'Qaed' => 'Internationella kapitalrörelser (inkl internationella banker)',
    'Qaed:bf' => 'Organisationer och institutioner',
    'Qaed:k' => 'De internationella kapitalrörelsernas historia',
    'Qaed:oe' => 'Lagstiftning',
    'Qaed-' => 'Särskilda länder och områden',
    'Qaed-a' => 'Europa: allmänt',
    'Qaed-ae' => 'Europeiska unionen (EU)',
    'Qaed-b' => 'Norden: allmänt',
    'Qaed-c' => 'Sverige',
    'Qaed-d' => 'Övriga Norden',
    'Qaed-e' => 'Brittiska öarna (Storbritannien)',
    'Qaed-f' => 'Mellaneuropa',
    'Qaed-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qaed-m' => 'Östeuropa',
    'Qaed-n' => 'Balkanländerna',
    'Qaed-o' => 'Asien',
    'Qaed-p' => 'Afrika',
    'Qaed-q' => 'Amerika',
    'Qaed-qa' => 'Förenta staterna',
    'Qaed-qd' => 'Sydamerika',
    'Qaed-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaeda' => 'Utlandsinvesteringar',
    'Qaeda-' => 'Särskilda länder och områden',
    'Qaeda-a' => 'Europa: allmänt',
    'Qaeda-ae' => 'Europeiska unionen (EU)',
    'Qaeda-b' => 'Norden: allmänt',
    'Qaeda-c' => 'Sverige',
    'Qaeda-d' => 'Övriga Norden',
    'Qaeda-da' => 'Danmark',
    'Qaeda-db' => 'Norge',
    'Qaeda-dd' => 'Finland',
    'Qaeda-e' => 'Brittiska öarna (Storbritannien)',
    'Qaeda-f' => 'Mellaneuropa',
    'Qaeda-fa' => 'Tyskland',
    'Qaeda-fb' => 'Österrike och Liechtenstein',
    'Qaeda-fc' => 'Ungern',
    'Qaeda-fd' => 'Tjeckien och Slovakien',
    'Qaeda-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qaeda-h' => 'Schweiz',
    'Qaeda-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qaeda-j' => 'Frankrike och Monaco',
    'Qaeda-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qaeda-l' => 'Portugal',
    'Qaeda-m' => 'Östeuropa',
    'Qaeda-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qaeda-mb' => 'Polen',
    'Qaeda-mc' => 'Estland, Lettland, Litauen',
    'Qaeda-o' => 'Asien',
    'Qaeda-oa' => 'Främre Asien',
    'Qaeda-ob' => 'Främre Indien',
    'Qaeda-oc' => 'Bortre Indien',
    'Qaeda-od' => 'Ostindiska öarna',
    'Qaeda-oe' => 'Östasien',
    'Qaeda-oea' => 'Kina',
    'Qaeda-oeb' => 'Korea',
    'Qaeda-oec' => 'Japan',
    'Qaeda-oek' => 'Hongkong och Macau',
    'Qaeda-of' => 'Centralasien',
    'Qaeda-p' => 'Afrika',
    'Qaeda-pa' => 'Nordafrika utom Egypten',
    'Qaeda-pb' => 'Egypten och Sudan',
    'Qaeda-pc' => 'Västafrika',
    'Qaeda-pe' => 'Södra Afrika',
    'Qaeda-pf' => 'Östafrika',
    'Qaeda-q' => 'Amerika',
    'Qaeda-qa' => 'Förenta staterna',
    'Qaeda-qb' => 'Kanada',
    'Qaeda-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaeda-qd' => 'Sydamerika',
    'Qaeda-qda' => 'Colombia',
    'Qaeda-qdb' => 'Venezuela',
    'Qaeda-qdd' => 'Brasilien',
    'Qaeda-qdg' => 'Argentina',
    'Qaeda-qdh' => 'Chile',
    'Qaeda-qdk' => 'Peru',
    'Qaeda-qdl' => 'Ecuador',
    'Qaeda-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaedb' => 'Multinationella företag',
    'Qaedb:k' => 'De multinationella företagens historia',
    'Qaedb-' => 'Särskilda länder och områden',
    'Qaedb-a' => 'Europa: allmänt',
    'Qaedb-b' => 'Norden: allmänt',
    'Qaedb-c' => 'Sverige',
    'Qaedb-d' => 'Övriga Norden',
    'Qaedb-e' => 'Brittiska öarna (Storbritannien)',
    'Qaedb-m' => 'Östeuropa',
    'Qaedb-o' => 'Asien',
    'Qaedb-oa' => 'Främre Asien',
    'Qaedb-ob' => 'Främre Indien',
    'Qaedb-oc' => 'Bortre Indien',
    'Qaedb-od' => 'Ostindiska öarna',
    'Qaedb-oe' => 'Östasien',
    'Qaedb-oea' => 'Kina',
    'Qaedb-oeb' => 'Korea',
    'Qaedb-oec' => 'Japan',
    'Qaedb-p' => 'Afrika',
    'Qaedb-q' => 'Amerika',
    'Qaedb-qa' => 'Förenta staterna',
    'Qaedb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaedb-qd' => 'Sydamerika',
    'Qaedb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qaf' => 'Finansväsen med finansrätt',
    'Qaf(x)' => 'Lexikon',
    'Qaf:k' => 'Finansväsendets och finansrättens historia',
    'Qaf:oe' => 'Allmänt: finansrättsliga aspekter',
    'Qaf-' => 'Allmänt: särskilda länder och områden',
    'Qaf-a' => 'Europa: allmänt',
    'Qaf-ae' => 'Europeiska unionen (EU)',
    'Qaf-b' => 'Norden: allmänt',
    'Qaf-c' => 'Sverige',
    'Qaf-c:k' => 'Historia',
    'Qaf-c:oe' => 'Finansrättsliga aspekter',
    'Qaf-d' => 'Övriga Norden',
    'Qaf-da' => 'Danmark',
    'Qaf-db' => 'Norge',
    'Qaf-dd' => 'Finland',
    'Qaf-e' => 'Brittiska öarna (Storbritannien)',
    'Qaf-f' => 'Mellaneuropa',
    'Qaf-fa' => 'Tyskland',
    'Qaf-fb' => 'Österrike och Liechtenstein',
    'Qaf-fc' => 'Ungern',
    'Qaf-fd' => 'Tjeckien och Slovakien',
    'Qaf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qaf-h' => 'Schweiz',
    'Qaf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qaf-j' => 'Frankrike och Monaco',
    'Qaf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qaf-m' => 'Östeuropa',
    'Qaf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qaf-mb' => 'Polen',
    'Qaf-mc' => 'Estland, Lettland, Litauen',
    'Qaf-n' => 'Balkanländerna',
    'Qaf-o' => 'Asien',
    'Qaf-oa' => 'Främre Asien',
    'Qaf-ob' => 'Främre Indien',
    'Qaf-oc' => 'Bortre Indien',
    'Qaf-od' => 'Ostindiska öarna',
    'Qaf-oe' => 'Östasien',
    'Qaf-oea' => 'Kina',
    'Qaf-oeb' => 'Korea',
    'Qaf-oec' => 'Japan',
    'Qaf-oek' => 'Hongkong och Macau',
    'Qaf-p' => 'Afrika',
    'Qaf-pa' => 'Nordafrika utom Egypten',
    'Qaf-pb' => 'Egypten och Sudan',
    'Qaf-pc' => 'Västafrika',
    'Qaf-pd' => 'Centralafrika',
    'Qaf-pe' => 'Södra Afrika',
    'Qaf-pf' => 'Östafrika',
    'Qaf-q' => 'Amerika',
    'Qaf-qa' => 'Förenta staterna',
    'Qaf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qaf-qd' => 'Sydamerika',
    'Qaf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafa' => 'Statshushållning',
    'Qafa:k' => 'Statshushållningens historia',
    'Qafa-' => 'Allmänt: särskilda länder och områden',
    'Qafa-a' => 'Europa: allmänt',
    'Qafa-ae' => 'Europeiska unionen (EU)',
    'Qafa-b' => 'Norden: allmänt',
    'Qafa-c' => 'Sverige',
    'Qafa-c:k' => 'Historia',
    'Qafa-c:oe' => 'Lagstiftning',
    'Qafa-d' => 'Övriga Norden',
    'Qafa-da' => 'Danmark',
    'Qafa-db' => 'Norge',
    'Qafa-dc' => 'Island och Färöarna',
    'Qafa-dd' => 'Finland',
    'Qafa-e' => 'Brittiska öarna (Storbritannien)',
    'Qafa-et' => 'Irland',
    'Qafa-f' => 'Mellaneuropa',
    'Qafa-fa' => 'Tyskland',
    'Qafa-fb' => 'Österrike och Liechtenstein',
    'Qafa-fc' => 'Ungern',
    'Qafa-fd' => 'Tjeckien och Slovakien',
    'Qafa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafa-h' => 'Schweiz',
    'Qafa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafa-j' => 'Frankrike och Monaco',
    'Qafa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafa-m' => 'Östeuropa',
    'Qafa-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qafa-mb' => 'Polen',
    'Qafa-mc' => 'Estland, Lettland, Litauen',
    'Qafa-n' => 'Balkanländerna',
    'Qafa-o' => 'Asien',
    'Qafa-oa' => 'Främre Asien',
    'Qafa-ob' => 'Främre Indien',
    'Qafa-oc' => 'Bortre Indien',
    'Qafa-od' => 'Ostindiska öarna',
    'Qafa-oe' => 'Östasien',
    'Qafa-oea' => 'Kina',
    'Qafa-oeb' => 'Korea',
    'Qafa-oec' => 'Japan',
    'Qafa-of' => 'Centralasien',
    'Qafa-p' => 'Afrika',
    'Qafa-pa' => 'Nordafrika utom Egypten',
    'Qafa-pb' => 'Egypten och Sudan',
    'Qafa-pc' => 'Västafrika',
    'Qafa-pd' => 'Centralafrika',
    'Qafa-pe' => 'Södra Afrika',
    'Qafa-pf' => 'Östafrika',
    'Qafa-pg' => 'Nordöstafrika',
    'Qafa-q' => 'Amerika',
    'Qafa-qa' => 'Förenta staterna',
    'Qafa-qa:k' => 'Historia',
    'Qafa-qb' => 'Kanada',
    'Qafa-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qafa-qca' => 'Mexiko',
    'Qafa-qch' => 'Västindien',
    'Qafa-qd' => 'Sydamerika',
    'Qafa-qda' => 'Colombia',
    'Qafa-qdb' => 'Venezuela',
    'Qafa-qdd' => 'Brasilien',
    'Qafa-qdg' => 'Argentina',
    'Qafa-qdh' => 'Chile',
    'Qafa-qdi' => 'Bolivia',
    'Qafa-qdk' => 'Peru',
    'Qafa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafb' => 'Finansförvaltning',
    'Qafb:oe' => 'Allmänt: lagstiftning',
    'Qafb-' => 'Särskilda länder och områden',
    'Qafb-a' => 'Europa: allmänt',
    'Qafb-ae' => 'Europeiska unionen (EU)',
    'Qafb-b' => 'Norden: allmänt',
    'Qafb-c' => 'Sverige',
    'Qafb-c:bf' => 'Organisationer och institutioner',
    'Qafb-c:k' => 'Historia',
    'Qafb-c:oe' => 'Lagstiftning',
    'Qafb-d' => 'Övriga Norden',
    'Qafb-da' => 'Danmark',
    'Qafb-db' => 'Norge',
    'Qafb-dc' => 'Island och Färöarna',
    'Qafb-dd' => 'Finland',
    'Qafb-e' => 'Brittiska öarna (Storbritannien)',
    'Qafb-f' => 'Mellaneuropa',
    'Qafb-fa' => 'Tyskland',
    'Qafb-fb' => 'Österrike och Liechtenstein',
    'Qafb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafb-h' => 'Schweiz',
    'Qafb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafb-j' => 'Frankrike och Monaco',
    'Qafb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafb-m' => 'Östeuropa',
    'Qafb-n' => 'Balkanländerna',
    'Qafb-o' => 'Asien',
    'Qafb-p' => 'Afrika',
    'Qafb-q' => 'Amerika',
    'Qafba' => 'Skatter',
    'Qafba:k' => 'Skatternas historia',
    'Qafba:oe' => 'Allmän skattelagstiftning',
    'Qafba-' => 'Särskilda länder och områden',
    'Qafba-a' => 'Europa: allmänt',
    'Qafba-a:oe' => 'Skattelagstiftning',
    'Qafba-ae' => 'Europeiska unionen (EU)',
    'Qafba-ae:oe' => 'Skattelagstiftning',
    'Qafba-b' => 'Norden: allmänt',
    'Qafba-b:oe' => 'Skattelagstiftning',
    'Qafba-c' => 'Sverige',
    'Qafba-c:bf' => 'Organisationer och institutioner',
    'Qafba-c:k' => 'Historia',
    'Qafba-c:oe' => 'Skatteagstiftning',
    'Qafba-d' => 'Övriga Norden',
    'Qafba-da' => 'Danmark',
    'Qafba-da:oe' => 'Skattelagstiftning',
    'Qafba-db' => 'Norge',
    'Qafba-db:oe' => 'Skattelagstiftning',
    'Qafba-dc' => 'Island och Färöarna',
    'Qafba-dd' => 'Finland',
    'Qafba-dd:oe' => 'Skattelagstiftning',
    'Qafba-e' => 'Brittiska öarna (Storbritannien)',
    'Qafba-e:oe' => 'Skattelagstiftning',
    'Qafba-et' => 'Irland',
    'Qafba-f' => 'Mellaneuropa',
    'Qafba-fa' => 'Tyskland',
    'Qafba-fa:oe' => 'Skattelagstiftning',
    'Qafba-fb' => 'Österrike och Liechtenstein',
    'Qafba-fbi' => 'Liechtenstein',
    'Qafba-fc' => 'Ungern',
    'Qafba-fd' => 'Tjeckien och Slovakien',
    'Qafba-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafba-ga' => 'Nederländerna',
    'Qafba-gb' => 'Belgien',
    'Qafba-gc' => 'Luxemburg',
    'Qafba-h' => 'Schweiz',
    'Qafba-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafba-j' => 'Frankrike och Monaco',
    'Qafba-j:oe' => 'Skattelagstiftning',
    'Qafba-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafba-l' => 'Portugal',
    'Qafba-m' => 'Östeuropa',
    'Qafba-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qafba-mb' => 'Polen',
    'Qafba-mc' => 'Estland, Lettland, Litauen',
    'Qafba-n' => 'Balkanländerna',
    'Qafba-o' => 'Asien',
    'Qafba-oa' => 'Främre Asien',
    'Qafba-oaa' => 'Turkiet',
    'Qafba-oab' => 'Cypern',
    'Qafba-oac' => 'Kaukasien',
    'Qafba-oaf' => 'Palestina och Israel',
    'Qafba-oah' => 'Arabiska halvön',
    'Qafba-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Qafba-ob' => 'Främre Indien',
    'Qafba-oc' => 'Bortre Indien',
    'Qafba-od' => 'Ostindiska öarna',
    'Qafba-oe' => 'Östasien',
    'Qafba-oea' => 'Kina',
    'Qafba-oeb' => 'Korea',
    'Qafba-oec' => 'Japan',
    'Qafba-p' => 'Afrika',
    'Qafba-pa' => 'Nordafrika utom Egypten',
    'Qafba-pc' => 'Västafrika',
    'Qafba-pe' => 'Södra Afrika',
    'Qafba-q' => 'Amerika',
    'Qafba-qa' => 'Förenta staterna',
    'Qafba-qa:oe' => 'Skattelagstiftning',
    'Qafba-qb' => 'Kanada',
    'Qafba-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qafba-qd' => 'Sydamerika',
    'Qafba-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafba-ra' => 'Australien',
    'Qafba-rb' => 'Nya Zeeland',
    'Qafbaa' => 'Direkta skatter',
    'Qafbaa-' => 'Särskilda länder och områden',
    'Qafbaa-a' => 'Europa: allmänt',
    'Qafbaa-ae' => 'Europeiska unionen (EU)',
    'Qafbaa-b' => 'Norden: allmänt',
    'Qafbaa-c' => 'Sverige',
    'Qafbaa-c:oe' => 'Lagstiftning',
    'Qafbaa-d' => 'Övriga Norden',
    'Qafbaa-da' => 'Danmark',
    'Qafbaa-da:oe' => 'Lagstiftning',
    'Qafbaa-db' => 'Norge',
    'Qafbaa-db:oe' => 'Lagstiftning',
    'Qafbaa-dd' => 'Finland',
    'Qafbaa-e' => 'Brittiska öarna (Storbritannien)',
    'Qafbaa-e:oe' => 'Lagstiftning',
    'Qafbaa-et' => 'Irland',
    'Qafbaa-f' => 'Mellaneuropa',
    'Qafbaa-fa' => 'Tyskland',
    'Qafbaa-fa:oe' => 'Lagstiftning',
    'Qafbaa-fb' => 'Österrike och Liechtenstein',
    'Qafbaa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafbaa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafbaa-j' => 'Frankrike och Monaco',
    'Qafbaa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafbaa-m' => 'Östeuropa',
    'Qafbaa-o' => 'Asien',
    'Qafbaa-p' => 'Afrika',
    'Qafbaa-q' => 'Amerika',
    'Qafbaa-qa' => 'Förenta staterna',
    'Qafbaa-qa:oe' => 'Lagstiftning',
    'Qafbaa-qb' => 'Kanada',
    'Qafbaa-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafbab' => 'Indirekta skatter',
    'Qafbab-' => 'Särskilda länder och områden',
    'Qafbab-a' => 'Europa: allmänt',
    'Qafbab-ae' => 'Europeiska unionen (EU)',
    'Qafbab-ae:oe' => 'Lagstiftning',
    'Qafbab-b' => 'Norden: allmänt',
    'Qafbab-c' => 'Sverige',
    'Qafbab-c:oe' => 'Lagstiftning',
    'Qafbab-d' => 'Övriga Norden',
    'Qafbab-da' => 'Danmark',
    'Qafbab-db' => 'Norge',
    'Qafbab-dd' => 'Finland',
    'Qafbab-e' => 'Brittiska öarna (Storbritannien)',
    'Qafbab-f' => 'Mellaneuropa',
    'Qafbab-fa' => 'Tyskland',
    'Qafbab-fb' => 'Österrike och Liechtenstein',
    'Qafbab-m' => 'Östeuropa',
    'Qafbab-n' => 'Balkanländerna',
    'Qafbab-o' => 'Asien',
    'Qafbab-q' => 'Amerika',
    'Qafbab-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafbac' => 'Arbetsgivaravgifter',
    'Qafbac-c' => 'Sverige',
    'Qafbac-c:oe' => 'Lagstiftning',
    'Qafbag' => 'Taxering och uppbörd (inkl deklaration)',
    'Qafbag:oe' => 'Allmänt: lagstiftning',
    'Qafbag-' => 'Särskilda länder och områden',
    'Qafbag-a' => 'Europa: allmänt',
    'Qafbag-b' => 'Norden: allmänt',
    'Qafbag-c' => 'Sverige',
    'Qafbag-c:k' => 'Historia',
    'Qafbag-c:oe' => 'Lagstiftning',
    'Qafbag-d' => 'Övriga Norden',
    'Qafbag-da' => 'Danmark',
    'Qafbag-db' => 'Norge',
    'Qafbag-dd' => 'Finland',
    'Qafbag-e' => 'Brittiska öarna (Storbritannien)',
    'Qafbag-f' => 'Mellaneuropa',
    'Qafbag-fa' => 'Tyskland',
    'Qafbag-fb' => 'Österrike och Liechtenstein',
    'Qafbag-fc' => 'Ungern',
    'Qafbag-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafbag-h' => 'Schweiz',
    'Qafbag-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafbag-j' => 'Frankrike och Monaco',
    'Qafbag-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafbag-m' => 'Östeuropa',
    'Qafbag-o' => 'Asien',
    'Qafbag-p' => 'Afrika',
    'Qafbag-q' => 'Amerika',
    'Qafbag-qa' => 'Förenta staterna',
    'Qafbag-qb' => 'Kanada',
    'Qafbag-qd' => 'Sydamerika',
    'Qafbag-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qafc' => 'Tullväsen',
    'Qafc:oe' => 'Allmän tullagstiftning',
    'Qafc-' => 'Särskilda länder och områden',
    'Qafc-a' => 'Europa: allmänt',
    'Qafc-ae' => 'Europeiska unionen (EU)',
    'Qafc-ae:oe' => 'Tullagstiftning',
    'Qafc-b' => 'Norden: allmänt',
    'Qafc-c' => 'Sverige',
    'Qafc-c:bf' => 'Organisationer och institutioner',
    'Qafc-c:k' => 'Tullväsendets historia',
    'Qafc-c:oe' => 'Tullagstiftning',
    'Qafc-d' => 'Övriga Norden',
    'Qafc-da' => 'Danmark',
    'Qafc-db' => 'Norge',
    'Qafc-dc' => 'Island och Färöarna',
    'Qafc-dd' => 'Finland',
    'Qafc-e' => 'Brittiska öarna (Storbritannien)',
    'Qafc-f' => 'Mellaneuropa',
    'Qafc-fa' => 'Tyskland',
    'Qafc-fb' => 'Österrike och Liechtenstein',
    'Qafc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qafc-h' => 'Schweiz',
    'Qafc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qafc-j' => 'Frankrike och Monaco',
    'Qafc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qafc-m' => 'Östeuropa',
    'Qafc-n' => 'Balkanländerna',
    'Qafc-o' => 'Asien',
    'Qafc-oa' => 'Främre Asien',
    'Qafc-oc' => 'Bortre Indien',
    'Qafc-od' => 'Ostindiska öarna',
    'Qafc-oe' => 'Östasien',
    'Qafc-p' => 'Afrika',
    'Qafc-q' => 'Amerika',
    'Qafc-qa' => 'Förenta staterna',
    'Qafc-qa:oe' => 'Tullagstiftning',
    'Qafc-qb' => 'Kanada',
    'Qafc-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qafc-qd' => 'Sydamerika',
    'Qafc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qb' => 'Företagsekonomi',
    'Qb(x)' => 'Företagsekonomiska lexikon',
    'Qb:bf' => 'Allmänt: Organisationer och institutioner',
    'Qb:d' => 'Företagsteori, metodlära',
    'Qb:dd' => 'Metodlära',
    'Qb:k' => 'Företagsekomomins historia',
    'Qb-' => 'Särskilda länder och områden',
    'Qb-a' => 'Europa: allmänt',
    'Qb-ae' => 'Europeiska unionen (EU)',
    'Qb-b' => 'Norden: allmänt',
    'Qb-c' => 'Sverige',
    'Qb-c:bf' => 'Organisationer och institutioner',
    'Qb-d' => 'Övriga Norden',
    'Qb-da' => 'Danmark',
    'Qb-db' => 'Norge',
    'Qb-dd' => 'Finland',
    'Qb-e' => 'Brittiska öarna (Storbritannien)',
    'Qb-f' => 'Mellaneuropa',
    'Qb-fa' => 'Tyskland',
    'Qb-fb' => 'Österrike och Liechtenstein',
    'Qb-fc' => 'Ungern',
    'Qb-fd' => 'Tjeckien och Slovakien',
    'Qb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qb-h' => 'Schweiz',
    'Qb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qb-j' => 'Frankrike och Monaco',
    'Qb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qb-l' => 'Portugal',
    'Qb-m' => 'Östeuropa',
    'Qb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qb-mb' => 'Polen',
    'Qb-mc' => 'Estland, Lettland, Litauen',
    'Qb-n' => 'Balkanländerna',
    'Qb-o' => 'Asien',
    'Qb-oa' => 'Främre Asien',
    'Qb-ob' => 'Främre Indien',
    'Qb-oc' => 'Bortre Indien',
    'Qb-od' => 'Ostindiska öarna',
    'Qb-oe' => 'Östasien',
    'Qb-oea' => 'Kina',
    'Qb-oeb' => 'Korea',
    'Qb-oec' => 'Japan',
    'Qb-oek' => 'Hongkong och Macau',
    'Qb-p' => 'Afrika',
    'Qb-pa' => 'Nordafrika utom Egypten',
    'Qb-pb' => 'Egypten och Sudan',
    'Qb-pc' => 'Västafrika',
    'Qb-pd' => 'Centralafrika',
    'Qb-pe' => 'Södra Afrika',
    'Qb-pf' => 'Östafrika',
    'Qb-q' => 'Amerika',
    'Qb-qa' => 'Förenta staterna',
    'Qb-qa:k' => 'Företagsekomomins historia',
    'Qb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qb-qd' => 'Sydamerika',
    'Qb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qba' => 'Företagsorganisation, företagsformer, företagsledning',
    'Qba:d' => 'Företagsorganisationens etc teori och filosofi',
    'Qba:k' => 'Företagsorganisationens etc historia',
    'Qbaa' => 'Organisation och administration',
    'Qbaab' => 'Organisationslära',
    'Qbaaf' => 'Administrativ rationalisering',
    'Qbaaj' => 'Projektadministration',
    'Qbab' => 'Ledning, arbetsledning',
    'Qbabb' => 'Beslutsfattande',
    'Qbabba' => 'Besluts- och planeringsmetoder',
    'Qbac' => 'Informations- och kommunikationsfrågor (inkl industrispionage)',
    'Qbac:oe' => 'Lagstiftning',
    'Qbaj' => 'Företagsetablering och -avveckling',
    'Qbaj:k' => 'Historia',
    'Qbak' => 'Konsultverksamhet',
    'Qban' => 'Företagsformer',
    'Qban:k' => 'Historia',
    'Qban:oe' => 'Lagstiftning',
    'Qbana' => 'Multinationella företag',
    'Qbanb' => 'Små- och medelstora företag',
    'Qbb' => 'Standardisering',
    'Qbc' => 'Redovisning',
    'Qbc(x)' => 'Lexikon',
    'Qbc:bf' => 'Redovisningens teori',
    'Qbc:k' => 'Redovisningens historia',
    'Qbc:oe' => 'Lagstiftning',
    'Qbca' => 'Handelsräkning',
    'Qbcb' => 'Bokföring',
    'Qbcb:oe' => 'Lagstiftning',
    'Qbcbk' => 'Kontoplaner',
    'Qbcc' => 'Kostnads- och intäktsfrågor',
    'Qbccb' => 'Budgetering',
    'Qbccc' => 'Investering och investeringskalkyl',
    'Qbccd' => 'Kostnader',
    'Qbcd' => 'Finansiering',
    'Qbce' => 'Balans, värdering, årsredovisning',
    'Qbcea' => 'Balans och värdering',
    'Qbceb' => 'Årsredovisning',
    'Qbceb:oe' => 'Lagstiftning',
    'Qbcec' => 'Koncernredovisning',
    'Qbced' => 'Intern redovisning',
    'Qbcee' => 'Extern redovisning',
    'Qbcef' => 'Inflationsredovisning',
    'Qbceg' => 'Social redovisning',
    'Qbcem' => 'Miljöredovisning',
    'Qbcf' => 'Revision',
    'Qbcf:oe' => 'Lagstiftning',
    'Qbcfa' => 'Intern revision och kontroll',
    'Qbcfb' => 'Extern revision',
    'Qbd' => 'Anläggningar och inventarier',
    'Qbda' => 'Lokalisering',
    'Qbdb' => 'Lokaler och inventarier',
    'Qbf' => 'Personaladministration',
    'Qbf:d' => 'Personaladministrationens teori',
    'Qbfa' => 'Personalsocial verksamhet',
    'Qbfb' => 'Rekrytering, anställning, personalutveckling',
    'Qbfbc' => 'Personalutveckling',
    'Qbfd' => 'Samarbetsfrågor',
    'Qbfe' => 'Löner och anställningsvillkor',
    'Qbg' => 'Kontorsteknik',
    'Qbg(x)' => 'Lexikon',
    'Qbga' => 'Kontorsinventarier och -maskiner',
    'Qbga:k' => 'Historia',
    'Qbgb' => 'Affärskorrespondens',
    'Qbgb(x)' => 'Lexikon',
    'Qbgbc' => 'Svenska',
    'Qbgbe' => 'Engelska',
    'Qbgbf' => 'Tyska',
    'Qbgbi' => 'Italienska',
    'Qbgbj' => 'Franska',
    'Qbgbk' => 'Spanska',
    'Qbgbm' => 'Slaviska och baltiska språk',
    'Qbgc' => 'Registreringsteknik',
    'Qbgd' => 'Blanketteknik',
    'Qbge' => 'Stenografi',
    'Qbgec' => 'Svenska',
    'Qbgf' => 'Ordbehandling, maskinskrivning och kopiering',
    'Qbi' => 'Driftsorganisation',
    'Qbia' => 'Driftsplanering och -kontroll, arbetsanalys',
    'Qbiaa' => 'Arbetsformer',
    'Qbiab' => 'Produktionskontroll',
    'Qbic' => 'Arbetsstudier',
    'Qbid' => 'Rationalisering',
    'Qbif' => 'Forsknings- och utvecklingsverksamhet',
    'Qbifd' => 'Produktutveckling',
    'Qbk' => 'Materialadministration',
    'Qbka' => 'Lagerorganisation',
    'Qbkb' => 'Förpackning',
    'Qbkc' => 'Transportorganisation',
    'Qbkd' => 'Inköpsorganisation',
    'Qbl' => 'Försäljningsorganisation. Marknadsföring',
    'Qbl(x)' => 'Lexikon',
    'Qbl:d' => 'Teori, filosofi',
    'Qbl:k' => 'Historia',
    'Qbl:oe' => 'Lagstiftning',
    'Qbla' => 'Försäljningsorganisation',
    'Qblb' => 'Marknadsföring',
    'Qblb(x)' => 'Lexikon',
    'Qblbc' => 'Industriell marknadsföring',
    'Qblbd' => 'Internationell marknadsföring',
    'Qblbe' => 'Marknadsföring av tjänster',
    'Qblbm' => 'Marknadsforskning och -analys',
    'Qblbmd' => 'Konsumentforskning',
    'Qbln' => 'Distributionskanaler',
    'Qblna' => 'Partihandel',
    'Qblnb' => 'Detaljhandel',
    'Qblnc' => 'Personlig försäljning',
    'Qblo' => 'Betalningsvillkor',
    'Qbm' => 'Reklam och PR (public relations)',
    'Qbm(x)' => 'Lexikon',
    'Qbm:d' => 'Teori, filosofi',
    'Qbm:k' => 'Historia',
    'Qbm:oe' => 'Lagstiftning',
    'Qbmc' => 'Reklam i tryckta medier',
    'Qbme' => 'Reklam i radio, TV, film',
    'Qbmg' => 'Direktreklam',
    'Qbmm' => 'Reklamens utformning',
    'Qbmo' => 'Reklamkontroll',
    'Qbmp' => 'PR (public relations)',
    'Qc' => 'Hem och hushåll',
    'Qc(x)' => 'Allmänt: lexikon',
    'Qc-' => 'Särskilda länder och områden',
    'Qc-a' => 'Europa: allmänt',
    'Qc-ae' => 'Europeiska unionen (EU)',
    'Qc-b' => 'Norden: allmänt',
    'Qc-c' => 'Sverige',
    'Qc-c:bf' => 'Organisationer och institutioner',
    'Qc-c:k' => 'Historia',
    'Qc-c:oe' => 'Konsumentlagstiftning',
    'Qc-d' => 'Övriga Norden',
    'Qc-da' => 'Danmark',
    'Qc-db' => 'Norge',
    'Qc-dd' => 'Finland',
    'Qc-e' => 'Brittiska öarna (Storbritannien)',
    'Qc-e:k' => 'Historia',
    'Qc-f' => 'Mellaneuropa',
    'Qc-fa' => 'Tyskland',
    'Qc-fb' => 'Österrike och Liechtenstein',
    'Qc-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qc-h' => 'Schweiz',
    'Qc-j' => 'Frankrike och Monaco',
    'Qc-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qc-m' => 'Östeuropa',
    'Qc-o' => 'Asien',
    'Qc-p' => 'Afrika',
    'Qc-q' => 'Amerika',
    'Qc-qa' => 'Förenta staterna',
    'Qc-qa:k' => 'Historia',
    'Qc-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qca' => 'Mat och dryck (inkl kulturhistoriska arbeten)',
    'Qca(x)' => 'Allmänt: lexikon',
    'Qca:k' => 'Allmänt: historia',
    'Qcaa' => 'Matlagning',
    'Qcaa(x)' => 'Matlagningslexikon',
    'Qcaa:k' => 'Matlagningshistoria',
    'Qcaaa' => 'Förrätter',
    'Qcaab' => 'Smörgåsar',
    'Qcaac' => 'Soppor',
    'Qcaad' => 'Grönsaker och sallader',
    'Qcaae' => 'Pasta-, ost- och risrätter',
    'Qcaaf' => 'Såser och salladdressingar',
    'Qcaak' => 'Kötträtter',
    'Qcaal' => 'Fiskrätter',
    'Qcaam' => 'Efterrätter',
    'Qcaat' => 'Särskilda tillagningsförfaranden',
    'Qcab' => 'Matlagning för speciella grupper och ändamål',
    'Qcaba' => 'Barnmat',
    'Qcabb' => 'Dietmat',
    'Qcabc' => 'Vegetarisk matlagning',
    'Qcabd' => 'Särskilda länder och områden',
    'Qcabd-a' => 'Europa: allmänt',
    'Qcabd-b' => 'Norden: allmänt',
    'Qcabd-c' => 'Sverige',
    'Qcabd-cs' => 'Samer',
    'Qcabd-d' => 'Övriga Norden',
    'Qcabd-da' => 'Danmark',
    'Qcabd-db' => 'Norge',
    'Qcabd-dc' => 'Island och Färöarna',
    'Qcabd-dd' => 'Finland',
    'Qcabd-e' => 'Brittiska öarna (Storbritannien)',
    'Qcabd-ea' => 'England',
    'Qcabd-es' => 'Skottland',
    'Qcabd-et' => 'Irland',
    'Qcabd-f' => 'Mellaneuropa',
    'Qcabd-fa' => 'Tyskland',
    'Qcabd-fb' => 'Österrike och Liechtenstein',
    'Qcabd-fc' => 'Ungern',
    'Qcabd-fd' => 'Tjeckien och Slovakien',
    'Qcabd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qcabd-h' => 'Schweiz',
    'Qcabd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qcabd-j' => 'Frankrike och Monaco',
    'Qcabd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qcabd-l' => 'Portugal',
    'Qcabd-m' => 'Östeuropa',
    'Qcabd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qcabd-mb' => 'Polen',
    'Qcabd-mc' => 'Estland, Lettland, Litauen',
    'Qcabd-n' => 'Balkanländerna',
    'Qcabd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qcabd-nd' => 'Grekland',
    'Qcabd-o' => 'Asien',
    'Qcabd-oa' => 'Främre Asien',
    'Qcabd-oaa' => 'Turkiet',
    'Qcabd-oab' => 'Cypern',
    'Qcabd-oac' => 'Kaukasien',
    'Qcabd-oae' => 'Syrien och Libanon',
    'Qcabd-oaf' => 'Palestina och Israel',
    'Qcabd-oafh' => 'Judar',
    'Qcabd-oafi' => 'Israel',
    'Qcabd-oah' => 'Arabiska halvön',
    'Qcabd-oak' => 'Iran (Persien)',
    'Qcabd-oal' => 'Afghanistan',
    'Qcabd-ob' => 'Främre Indien',
    'Qcabd-oba' => 'Indien',
    'Qcabd-obb' => 'Pakistan och Bangladesh',
    'Qcabd-oc' => 'Bortre Indien',
    'Qcabd-oca' => 'Myanmar (f d Burma)',
    'Qcabd-ocb' => 'Thailand',
    'Qcabd-occ' => 'Malaysia, Singapore och Brunei',
    'Qcabd-ocd' => 'Indokina',
    'Qcabd-od' => 'Ostindiska öarna',
    'Qcabd-oe' => 'Östasien',
    'Qcabd-oea' => 'Kina',
    'Qcabd-oeb' => 'Korea',
    'Qcabd-oec' => 'Japan',
    'Qcabd-p' => 'Afrika',
    'Qcabd-pa' => 'Nordafrika utom Egypten',
    'Qcabd-pb' => 'Egypten och Sudan',
    'Qcabd-pe' => 'Södra Afrika',
    'Qcabd-pf' => 'Östafrika',
    'Qcabd-pg' => 'Nordöstafrika',
    'Qcabd-q' => 'Amerika',
    'Qcabd-qb' => 'Kanada',
    'Qcabd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qcabd-qca' => 'Mexiko',
    'Qcabd-qch' => 'Västindien',
    'Qcabd-qd' => 'Sydamerika',
    'Qcabd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qcabd-s' => 'Polarländerna (Grönland)',
    'Qcad' => 'Hemkonservering och djupfrysning',
    'Qcada' => 'Hemkonservering',
    'Qcadb' => 'Djupfrysning',
    'Qcae' => 'Bakning',
    'Qcae:k' => 'Historia',
    'Qcaf' => 'Drycker',
    'Qcaf(x)' => 'Historia',
    'Qcaf:k' => 'Historia',
    'Qcai' => 'Dukning, servering',
    'Qcam' => 'Matberedningsmaskiner, husgeråd',
    'Qcb' => 'Hemmets vård',
    'Qcba' => 'Heminredning',
    'Qcbb' => 'Tvätt',
    'Qcbc' => 'Bostadsvård. Rengöring',
    'Qcbu' => 'Utrotning av skadedjur',
    'Qcc' => 'Kläder och sömnad',
    'Qcc:k' => 'Klädes- och sömnadshistoria',
    'Qcca' => 'Handarbete',
    'Qccaa' => 'Stickning',
    'Qccab' => 'Virkning',
    'Qccac' => 'Knyppling',
    'Qccad' => 'Broderi',
    'Qccada' => 'Landskapssöm och sömmar från olika länder',
    'Qccada-c' => 'Sverige',
    'Qccadb' => 'Märkning',
    'Qccadc' => 'Hopdragssöm',
    'Qccadd' => 'Korsstygn, tvistsöm',
    'Qccade' => 'Vitbroderi',
    'Qcca(x)' => 'Hndarbetslexikon',
    'Qccb' => 'Vävning',
    'Qccba' => 'Linnevävning',
    'Qccbb' => 'Mattvävning',
    'Qccbc' => 'Bandvävning',
    'Qccbd' => 'Bildvävning',
    'Qccc' => 'Sömnad',
    'Qccca' => 'Klädsömnad',
    'Qcccaa' => 'Barnkläder',
    'Qcccab' => 'Manskläder',
    'Qcccac' => 'Kvinnokläder',
    'Qcccd' => 'Lappning och lagning',
    'Qcd' => 'Personlig hygien',
    'Qcd:k' => 'Historia',
    'Qcg' => 'Umgängeskonst, etikettfrågor och andra personliga förhållanden',
    'Qcg:k' => 'Historia',
    'Qci' => 'Privatekonomi',
    'Qd' => 'Lantbruk',
    'Qd(x)' => 'Lantbrukslexikon',
    'Qd:bf' => 'Lantbruksorganisationer och -institutioner',
    'Qd:k' => 'Lantbrukets och lantbruksforskningens historia',
    'Qd:k.' => 'Särskilda perioder',
    'Qd:k.2' => 'Forntiden',
    'Qd:k.21' => 'Egypten',
    'Qd:k.22' => 'Främre Asien',
    'Qd:k.23' => 'Antikens historia: allmänt',
    'Qd:k.24' => 'Den grekiska forntiden',
    'Qd:k.26' => 'Den romerska forntiden',
    'Qd:k.261' => 'Konungatiden och republiken till 31 f Kr',
    'Qd:k.264' => 'Kejsartiden 31 f Kr - 476 e Kr',
    'Qd:k.269' => 'Romerska rikets provinser',
    'Qd:k.29' => 'Germanerna under forntiden',
    'Qd:k.3' => 'Medeltiden',
    'Qd:k.4' => 'Nya tiden',
    'Qd:k.46' => '1815-1914',
    'Qd:k.5' => '1900-',
    'Qd:k.6' => '2000-',
    'Qd:ka' => 'Europa: allmänt',
    'Qd:kae' => 'Europeiska unionen (EU)',
    'Qd:kb' => 'Norden: allmänt',
    'Qd:kc' => 'Sverige',
    'Qd:kcz' => 'Särskilda orter',
    'Qd:kd' => 'Övriga Norden',
    'Qd:ke' => 'Brittiska öarna (Storbritannien)',
    'Qd:kf' => 'Mellaneuropa',
    'Qd:kg' => 'Nederländerna, Belgien och Luxemburg',
    'Qd:kh' => 'Schweiz',
    'Qd:ki' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qd:kj' => 'Frankrike och Monaco',
    'Qd:km' => 'Östeuropa',
    'Qd:kn' => 'Balkanländerna',
    'Qd:ko' => 'Asien',
    'Qd:kp' => 'Afrika',
    'Qd:kq' => 'Amerika',
    'Qd:oe' => 'Lantbrukslagstiftning',
    'Qd-' => 'Särskilda länder och områden',
    'Qd-a' => 'Europa: allmänt',
    'Qd-a:k' => 'Lantbrukets historia',
    'Qd-a:k.' => 'Särskilda historiska perioder',
    'Qd-a:k.2' => 'Forntiden',
    'Qd-a:k.3' => 'Medeltiden',
    'Qd-a:k.4' => 'Nya tiden',
    'Qd-a:k.5' => '1914-',
    'Qd-a:k.6' => '2000-',
    'Qd-ae' => 'Europeiska unionen (EU)',
    'Qd-b' => 'Norden: allmänt',
    'Qd-c' => 'Sverige',
    'Qd-c:bf' => 'Organisationer och institutioner',
    'Qd-c:k' => 'Lantbrukets historia',
    'Qd-c:k.' => 'Särskilda historiska perioder',
    'Qd-c:k.2' => 'Forntiden till ca 1060',
    'Qd-c:k.3' => 'Medeltiden ca 1060-1520',
    'Qd-c:k.4' => 'Nya tiden 1520-',
    'Qd-c:k.41' => 'Vasatiden 1520-1611',
    'Qd-c:k.42' => 'Stormaktstiden 1611-1718',
    'Qd-c:k.43' => '1700-talet',
    'Qd-c:k.44' => 'Frihetstiden 1718-1772',
    'Qd-c:k.45' => 'Gustavianska tiden 1772-1809',
    'Qd-c:k.46' => '1800-talet',
    'Qd-c:k.47' => '1809-1844',
    'Qd-c:k.48' => '1844-1865',
    'Qd-c:k.49' => '1865-1905',
    'Qd-c:k.5' => '1905-',
    'Qd-c:k.51' => 'Första världskriget 1914-1918',
    'Qd-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Qd-c:k.54' => 'Andra världskriget 1939-1945',
    'Qd-c:k.55' => '1945-',
    'Qd-c:k.58' => '1980-',
    'Qd-c:k.59' => '1994-',
    'Qd-c:k.6' => '2000-',
    'Qd-c:oe' => 'Lantbrukslagstiftning',
    'Qd-cz' => 'Särskilda orter',
    'Qd-d' => 'Övriga Norden',
    'Qd-da' => 'Danmark',
    'Qd-da:bf' => 'Organisationer och institutioner',
    'Qd-da:k' => 'Lantbrukets historia',
    'Qd-da:k.' => 'Särskilda historiska perioder',
    'Qd-da:k.2' => 'Forntiden till ca 1050',
    'Qd-da:k.3' => 'Medeltiden ca 1050-1536',
    'Qd-da:k.4' => 'Nya tiden 1536-',
    'Qd-da:k.41' => '1536-1660',
    'Qd-da:k.43' => '1660-1814',
    'Qd-da:k.46' => '1800-1914',
    'Qd-da:k.5' => '1914-',
    'Qd-da:k.6' => '2000-',
    'Qd-da:oe' => 'Lantbrukslagstiftning',
    'Qd-db' => 'Norge',
    'Qd-db:bf' => 'Organisationer och institutioner',
    'Qd-db:k' => 'Lantbrukets historia',
    'Qd-db:k.' => 'Särskilda historiska perioder',
    'Qd-db:k.2' => 'Forntiden till ca 1030',
    'Qd-db:k.3' => 'Medeltiden ca 1030-1536',
    'Qd-db:k.5' => '1905-',
    'Qd-db:k.6' => '2000-',
    'Qd-dc' => 'Island och Färöarna',
    'Qd-dd' => 'Finland',
    'Qd-dd:bf' => 'Organisationer och institutioner',
    'Qd-dd:k' => 'Lantbrukets historia',
    'Qd-dd:k.' => 'Finland: särskilda perioder',
    'Qd-dd:k.4' => 'Nya tiden 1520-',
    'Qd-dd:k.5' => '1918-',
    'Qd-dd:k.6' => '2000-',
    'Qd-e' => 'Brittiska öarna (Storbritannien)',
    'Qd-e:bf' => 'Organisationer och institutioner',
    'Qd-e:k' => 'Lantbrukets historia',
    'Qd-e:k.' => 'Särskilda historiska perioder',
    'Qd-e:k.2' => 'Före 1066',
    'Qd-e:k.3' => 'Medeltiden 1066-1485',
    'Qd-e:k.4' => 'Nya tiden 1485-',
    'Qd-e:k.41' => '1485-1603',
    'Qd-e:k.42' => '1603-1714',
    'Qd-e:k.44' => '1714-1815',
    'Qd-e:k.46' => '1800-1914',
    'Qd-e:k.5' => '1914-',
    'Qd-e:k.6' => '2000-',
    'Qd-ea' => 'England',
    'Qd-er' => 'Wales',
    'Qd-es' => 'Skottland',
    'Qd-et' => 'Irland',
    'Qd-f' => 'Mellaneuropa',
    'Qd-fa' => 'Tyskland',
    'Qd-fa:bf' => 'Organisationer och institutioner',
    'Qd-fa:k' => 'Lantbrukets historia',
    'Qd-fa:k.' => 'Särskilda historiska perioder',
    'Qd-fa:k.2' => 'Före 843',
    'Qd-fa:k.3' => '843 - ca 1500',
    'Qd-fa:k.4' => 'Ca 1500-',
    'Qd-fa:k.41' => '1500-1648',
    'Qd-fa:k.43' => '1648-1806',
    'Qd-fa:k.46' => '1806-1870',
    'Qd-fa:k.47' => '1870-1918',
    'Qd-fa:k.5' => '1900-talet',
    'Qd-fa:k.51' => 'Första världskriget 1914-1918',
    'Qd-fa:k.52' => '1918-1933',
    'Qd-fa:k.53' => '1933-1945',
    'Qd-fa:k.55' => '1945-',
    'Qd-fa:k.6' => '2000-',
    'Qd-fb' => 'Österrike och Liechtenstein',
    'Qd-fb:k' => 'Lantbrukets historia',
    'Qd-fc' => 'Ungern',
    'Qd-fc:k' => 'Lantbrukets historia',
    'Qd-fd' => 'Tjeckien och Slovakien',
    'Qd-fd:k' => 'Lantbrukets historia',
    'Qd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qd-ga' => 'Nederländerna',
    'Qd-ga:k' => 'Lantbrukets historia',
    'Qd-gb' => 'Belgien',
    'Qd-gc' => 'Luxemburg',
    'Qd-h' => 'Schweiz',
    'Qd-h:k' => 'Lantbrukets historia',
    'Qd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qd-i:k' => 'Lantbrukets historia',
    'Qd-j' => 'Frankrike och Monaco',
    'Qd-j:bf' => 'Organisationer och institutioner',
    'Qd-j:k' => 'Lantbrukets historia',
    'Qd-j:k.' => 'Särskilda historiska perioder',
    'Qd-j:k.2' => 'Före 987',
    'Qd-j:k.3' => 'Medeltiden 987-1498',
    'Qd-j:k.4' => 'Nya tiden 1498-',
    'Qd-j:k.5' => '1914-',
    'Qd-j:k.6' => '2000-',
    'Qd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qd-k:k' => 'Lantbrukets historia',
    'Qd-l' => 'Portugal',
    'Qd-m' => 'Östeuropa',
    'Qd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qd-ma:k' => 'Lantbrukets historia',
    'Qd-ma:k.' => 'Särskilda historiska perioder',
    'Qd-ma:k.4' => 'Nya tiden 1533-',
    'Qd-ma:k.5' => 'Sovjetunionen 1917-1991 och Ryssland 1991-',
    'Qd-ma:k.6' => '2000-',
    'qd-ma:oe' => 'Lantbrukslagstiftning',
    'Qd-mad' => 'Ukraina',
    'Qd-mae' => 'Vitryssland',
    'Qd-maf' => 'Moldavien',
    'Qd-mb' => 'Polen',
    'Qd-mb:k' => 'Lantbrukets historia',
    'Qd-mc' => 'Estland, Lettland, Litauen',
    'Qd-mca' => 'Estland',
    'Qd-mca:k' => 'Lantbrukets historia',
    'Qd-mcb' => 'Lettland',
    'Qd-mcc' => 'Litauen',
    'Qd-n' => 'Balkanländerna',
    'Qd-na' => 'Rumänien',
    'Qd-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qd-nc' => 'Bulgarien',
    'Qd-nd' => 'Grekland',
    'Qd-nf' => 'Albanien',
    'Qd-o' => 'Asien',
    'Qd-oa' => 'Främre Asien',
    'Qd-oaa' => 'Turkiet',
    'Qd-oac' => 'Kaukasien',
    'Qd-oae' => 'Syrien och Libanon',
    'Qd-oaf' => 'Palestina och Israel',
    'Qd-oafh' => 'Judar',
    'Qd-oafi' => 'Israel',
    'Qd-oag' => 'Jordanien',
    'Qd-oah' => 'Arabiska halvön',
    'Qd-oai' => 'Irak',
    'Qd-oak' => 'Iran (Persien)',
    'Qd-oal' => 'Afghanistan',
    'Qd-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Qd-ob' => 'Främre Indien',
    'Qd-oba' => 'Indien',
    'Qd-oba:k' => 'Lantbrukets historia',
    'Qd-obb' => 'Pakistan och Bangladesh',
    'Qd-obba' => 'Pakistan',
    'Qd-obbb' => 'Bangladesh',
    'Qd-obd' => 'Nepal',
    'Qd-obe' => 'Sri Lanka (f d Ceylon)',
    'Qd-oc' => 'Bortre Indien',
    'Qd-oca' => 'Myanmar (f d Burma)',
    'Qd-ocb' => 'Thailand',
    'Qd-occ' => 'Malaysia, Singapore och Brunei',
    'Qd-ocd' => 'Indokina',
    'Qd-ocda' => 'Laos',
    'Qd-ocdb' => 'Kambodja',
    'Qd-ocdc' => 'Vietnam',
    'Qd-od' => 'Ostindiska öarna',
    'Qd-oda' => 'Indonesien',
    'Qd-odc' => 'Filippinerna',
    'Qd-oe' => 'Östasien',
    'Qd-oea' => 'Kina',
    'Qd-oea:k' => 'Lantbrukets historia',
    'Qd-oeaf' => 'Taiwan',
    'Qd-oeak' => 'Tibet',
    'Qd-oeam' => 'Inre Mongoliet',
    'Qd-oeb' => 'Korea',
    'Qd-oec' => 'Japan',
    'Qd-oec:k' => 'Lantbrukets historia',
    'Qd-of' => 'Centralasien',
    'Qd-og' => 'Sibirien',
    'Qd-p' => 'Afrika',
    'Qd-pa' => 'Nordafrika utom Egypten',
    'Qd-paa' => 'Marocko och Kanarieöarna',
    'Qd-pab' => 'Algeriet',
    'Qd-pac' => 'Tunisien',
    'Qd-pad' => 'Libyen',
    'Qd-pb' => 'Egypten och Sudan',
    'Qd-pba' => 'Egypten',
    'Qd-pba:k' => 'Lantbrukets historia',
    'Qd-pbb' => 'Sudan',
    'Qd-pc' => 'Västafrika',
    'Qd-pcb' => 'Ekvatorialfrika',
    'Qd-pcba' => 'Tchad',
    'Qd-pcbb' => 'Centralafrikanska republiken',
    'Qd-pcbc' => 'Kongo (Brazzaville)',
    'Qd-pcbd' => 'Gabon',
    'Qd-pcbe' => 'Kamerun',
    'Qd-pcc' => 'Norra Västafrika',
    'Qd-pccb' => 'Mauretanien',
    'Qd-pccc' => 'Senegal',
    'Qd-pccd' => 'Gambia',
    'Qd-pcce' => 'Mali',
    'Qd-pccg' => 'Burkina Faso',
    'Qd-pcch' => 'Niger',
    'Qd-pcci' => 'Guniea-Bissau',
    'Qd-pccj' => 'Cap Verde',
    'Qd-pcck' => 'Guinea',
    'Qd-pccl' => 'Elfenbenskusten',
    'Qd-pccm' => 'Sierra Leone',
    'Qd-pccn' => 'Liberia',
    'Qd-pcd' => 'Södra Västafrika',
    'Qd-pcda' => 'Ghana',
    'Qd-pcdb' => 'Togo',
    'Qd-pcdc' => 'Benin',
    'Qd-pcdd' => 'Nigeria',
    'Qd-pd' => 'Centralafrika',
    'Qd-pda' => 'Kongo (Kinshasa), Rwanda, Burundi',
    'Qd-pdb' => 'Angola',
    'Qd-pe' => 'Södra Afrika',
    'Qd-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Qd-peaa' => 'Sydafrikanska republiken',
    'Qd-peab' => 'Namibia',
    'Qd-peac' => 'Lesotho',
    'Qd-pead' => 'Swaziland',
    'Qd-peb' => 'Botswana',
    'Qd-pec' => 'Zimbabwe, Zambia, Malawi',
    'Qd-peca' => 'Zimbabwe',
    'Qd-pecb' => 'Zambia',
    'Qd-pecc' => 'Malawi',
    'Qd-ped' => 'Mocambique',
    'Qd-pee' => 'Madagaskar (Malagasy)',
    'Qd-pef' => 'Öar i sydvästra Indiska Oceanen och östra Atlanten (Komorerna ...)',
    'Qd-pf' => 'Östafrika',
    'Qd-pfa' => 'Uganda',
    'Qd-pfb' => 'Kenya',
    'Qd-pfc' => 'Tanzania',
    'Qd-pg' => 'Nordöstafrika',
    'Qd-pga' => 'Etiopien med Eritrea',
    'Qd-pgb' => 'Somalia',
    'Qd-pgc' => 'Djibouti',
    'Qd-q' => 'Amerika',
    'Qd-qa' => 'Förenta staterna',
    'Qd-qa:bf' => 'Organisationer och institutioner',
    'Qd-qa:k' => 'Lantbrukets historia',
    'Qd-qa:k.' => 'Särskilda historiska perioder',
    'Qd-qa:k.4' => 'Nordamerika under nya tiden',
    'Qd-qa:k.46' => '1789-1865',
    'Qd-qa:k.47' => '1865-1914',
    'Qd-qa:k.5' => '1900-talet',
    'Qd-qa:k.6' => '2000-',
    'Qd-qa:oe' => 'Lantbrukslagstiftning',
    'Qd-qat' => 'Indianer i Nordamerika',
    'Qd-qb' => 'Kanada',
    'Qd-qb:bf' => 'Organisationer och institutioner',
    'Qd-qb:k' => 'Lantbrukets historia',
    'Qd-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qd-qca' => 'Mexiko',
    'Qd-qca:k' => 'Lantbrukets historia',
    'Qd-qcb' => 'Guatemala',
    'Qd-qcc' => 'Belize och Honduras',
    'Qd-qcd' => 'El Salvador',
    'Qd-qce' => 'Nicaragua',
    'Qd-qcf' => 'Costa Rica',
    'Qd-qch' => 'Västindien',
    'Qd-qd' => 'Sydamerika',
    'Qd-qda' => 'Colombia',
    'Qd-qdb' => 'Venezuela',
    'Qd-qdc' => 'Guyanastaterna',
    'Qd-qdd' => 'Brasilien',
    'Qd-qde' => 'Paraguay',
    'Qd-qdf' => 'Uruguay',
    'Qd-qdg' => 'Argentina',
    'Qd-qdh' => 'Chile',
    'Qd-qdi' => 'Bolivia',
    'Qd-qdk' => 'Peru',
    'Qd-qdl' => 'Ecuador',
    'Qd-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qd-ra' => 'Australien',
    'Qd-rb' => 'Nya Zeeland',
    'Qd-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qd-rd' => 'Nya Guinea',
    'Qda' => 'Lantbruksekonomi',
    'Qda:k' => 'Lantbruksekonomins historia',
    'Qda:kc' => 'Sverige',
    'Qda:kd' => 'Övriga Norden',
    'Qda:kq' => 'Amerika',
    'Qdb' => 'Lantbrukets byggnader, redskap och maskiner',
    'Qdba' => 'Lantbruksbyggnader',
    'Qdba:k' => 'Historia',
    'Qdba:kc' => 'Sverige',
    'Qdba:kd' => 'Övriga Norden',
    'Qdba:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdba:kf' => 'Mellaneuropa',
    'Qdba:kq' => 'Amerika',
    'Qdbb' => 'Lantbruksredskap och -maskiner',
    'Qdbb:k' => 'Historia',
    'Qdbb:k.' => 'Särskilda perioder',
    'Qdbb:k.2' => 'Forntiden',
    'Qdbb:k.3' => 'Medeltiden',
    'Qdbb:k.4' => 'Nya tiden',
    'Qdbb:k.5' => '1900-',
    'Qdbb:k.6' => '2000-',
    'Qdbb:kc' => 'Sverige',
    'Qdbb:kd' => 'Övriga Norden',
    'Qdbb:kda' => 'Danmark',
    'Qdbb:kdb' => 'Norge',
    'Qdbb:kdd' => 'Finland',
    'Qdbb:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdbb:kf' => 'Mellaneuropa',
    'Qdbb:kfa' => 'Tyskland',
    'Qdbb:kfb' => 'Österrike och Liechtenstein',
    'Qdbb:kg' => 'Nederländerna, Belgien och Luxemburg',
    'Qdbb:kj' => 'Frankrike och Monaco',
    'Qdbb:kq' => 'Amerika',
    'Qdbb:kqa' => 'Förenta staterna',
    'Qdbb:kqb' => 'Kanada',
    'Qdc' => 'Jordbrukslära',
    'Qdc:k' => 'Jordbrukslärans historia',
    'Qdca' => 'Marklära',
    'Qdcb' => 'Jordens bearbetning',
    'Qdcb:k' => 'Historia',
    'Qdcb:kc' => 'Sverige',
    'Qdcb:kd' => 'Övriga Norden',
    'Qdcb:kf' => 'Mellaneuropa',
    'Qdcb:kq' => 'Amerika',
    'Qdcc' => 'Gödselmedel och gödsling',
    'Qdcc:k' => 'Historia',
    'Qdd' => 'Växtodlingslära',
    'Qdd:k' => 'Växtodlingslärans historia',
    'Qdda' => 'Skörd, lagring, fröodling, frökontroll, växtförädling',
    'Qdda:bf' => 'Organisationer och institutioner',
    'Qdda:k' => 'Historia',
    'Qddb' => 'Alternativa odlingsformer',
    'Qddb:k' => 'Historia',
    'Qddd' => 'Åkerbruksväxterna',
    'Qddd:k' => 'Historia',
    'Qddda' => 'Sädesslagen',
    'Qddda:k' => 'Historia',
    'Qdddb' => 'Trindsäd',
    'Qdddc' => 'Rotfrukter och potatis',
    'Qdddc:k' => 'Historia',
    'Qdddd' => 'Vallväxter och andra grönfoderväxter',
    'Qddde' => 'Olje- och spånadsväxter',
    'Qdddf' => 'Njutningsmedel och medicinalväxter',
    'Qdddf:k' => 'Historia',
    'Qde' => 'Växternas sjukdomar och skadedjur, växtskydd',
    'Qdea' => 'Växternas sjukdomar och skadedjur',
    'Qdeh' => 'Växtskydd',
    'Qdf' => 'Husdjurslära',
    'Qdf(x)' => 'Lexikon',
    'Qdf:bf' => 'Organisationer och institutioner',
    'Qdf:k' => 'Husdjurlärans historia',
    'Qdf:k.2' => 'Forntiden',
    'Qdf:kc' => 'Sverige',
    'Qdf:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdf:kf' => 'Mellaneuropa',
    'Qdf:kj' => 'Frankrike och Monaco',
    'Qdf:kq' => 'Amerika',
    'Qdfa' => 'Betes- och utfodringsfrågor',
    'Qdfa:k' => 'Historia',
    'Qdfb' => 'Veterinärmedicin',
    'Qdfb:bf' => 'Organisationer och institutioner',
    'Qdfb:k' => 'Historia',
    'Qdfb:kc' => 'Sverige',
    'Qdfb:kf' => 'Mellaneuropa',
    'Qdfb:kj' => 'Frankrike och Monaco',
    'Qdfb:kq' => 'Amerika',
    'Qdfb:oe' => 'Lagstiftning',
    'Qdfd' => 'Hästar',
    'Qdfd(x)' => 'Lexikon',
    'Qdfd:bf' => 'Organisationer och institutioner',
    'Qdfd:k' => 'Historia',
    'Qdfd:k.' => 'Särskilda perioder',
    'Qdfd:k.2' => 'Forntiden',
    'Qdfd:k.3' => 'Medeltiden',
    'Qdfd:k.4' => 'Nya tiden',
    'Qdfd:k.5' => '1900-',
    'Qdfd:k.6' => '2000-',
    'Qdfd:kc' => 'Sverige',
    'Qdfd:kd' => 'Övriga Norden',
    'Qdfd:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdfd:kf' => 'Mellaneuropa',
    'Qdfd:kfa' => 'Tyskland',
    'Qdfd:kh' => 'Schweiz',
    'Qdfd:kj' => 'Frankrike och Monaco',
    'Qdfd:kq' => 'Amerika',
    'Qdfe' => 'Nötkreatur',
    'Qdfe:bf' => 'Organisationer och institutioner',
    'Qdfe:k' => 'Historia',
    'Qdfe:kc' => 'Sverige',
    'Qdfe:kd' => 'Övriga Norden',
    'Qdfe:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdfe:kf' => 'Mellaneuropa',
    'Qdfe:kq' => 'Amerika',
    'Qdff' => 'Renar',
    'Qdff:k' => 'Historia',
    'Qdff:oe' => 'Lagstiftning',
    'Qdfg' => 'Får och getter',
    'Qdfg:k' => 'Historia',
    'Qdfg:kc' => 'Sverige',
    'Qdfg:kd' => 'Övriga Norden',
    'Qdfg:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdfg:kf' => 'Mellaneuropa',
    'Qdfg:kq' => 'Amerika',
    'Qdfg:kr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qdfh' => 'Svin',
    'Qdfh:k' => 'Historia',
    'Qdfi' => 'Fjäderfä',
    'Qdfi:k' => 'Historia',
    'Qdfj' => 'Hundar och katter',
    'Qdfja' => 'Hundar',
    'Qdfja(x)' => 'Lexikon',
    'Qdfja:bf' => 'Organisationer och institutioner',
    'Qdfja:k' => 'Historia',
    'Qdfjaz' => 'Särskilda hundraser',
    'Qdfjb' => 'Katter',
    'Qdfjb(x)' => 'Lexikon',
    'Qdfjb:k' => 'Historia',
    'Qdfjbz' => 'Särskilda kattraser',
    'Qdfk' => 'Bin',
    'Qdfk:bf' => 'Organisationer och institutioner',
    'Qdfk:k' => 'Historia',
    'Qdfk:kc' => 'Sverige',
    'Qdfk:kd' => 'Övriga Norden',
    'Qdfk:ke' => 'Brittiska öarna (Storbritannien)',
    'Qdfk:kf' => 'Mellaneuropa',
    'Qdfk:kj' => 'Frankrike och Monaco',
    'Qdfk:kq' => 'Amerika',
    'Qdfl' => 'Kaniner och pälsdjur',
    'Qdfm' => 'Akvarier, terrarier, burfåglar',
    'Qdfma' => 'Akvarier',
    'Qdfma(x)' => 'Lexikon',
    'Qdfmb' => 'Terrarier',
    'Qdfmc' => 'Burfåglar',
    'Qdfn' => 'Marsvin, hamstrar och övriga mindre husdjur',
    'Qdfö' => 'Övriga husdjur',
    'Qdfö:k' => 'Historia',
    'Qdg' => 'Mjölkproduktion',
    'Qdg:k' => 'Historia',
    'Qdh' => 'Äggproduktion',
    'Qdi' => 'Köttproduktion',
    'Qe(x)' => 'Trädgårdsexikon',
    'Qe' => 'Trädgårdsskötsel',
    'Qe:k' => 'Trädgårdsskötselns och trädgårdsforskningens historia',
    'Qe:k.' => 'Särskilda perioder',
    'Qe:k.2' => 'Forntiden',
    'Qe:k.3' => 'Medeltiden',
    'Qe:k.4' => 'Nya tiden',
    'Qe:k.5' => '1900-',
    'Qe:k.6' => '2000-',
    'Qe:kc' => 'Sverige',
    'Qe:ke' => 'Brittiska öarna (Storbritannien)',
    'Qe:kj' => 'Frankrike och Monaco',
    'Qe-' => 'Särskilda länder och områden',
    'Qe-a' => 'Europa: allmänt',
    'Qe-b' => 'Norden: allmänt',
    'Qe-c' => 'Sverige',
    'Qe-c:bf' => 'Organisationer och institutioner',
    'Qe-c:k' => 'Trädgårdsskötselns historia',
    'Qe-cz' => 'Särskilda orter',
    'Qe-d' => 'Övriga Norden',
    'Qe-da' => 'Danmark',
    'Qe-db' => 'Norge',
    'Qe-dd' => 'Finland',
    'Qe-e' => 'Brittiska öarna (Storbritannien)',
    'Qe-e:bf' => 'Organisationer och institutioner',
    'Qe-e:k' => 'Trädgårdsskötselns historia',
    'Qe-f' => 'Mellaneuropa',
    'Qe-fa' => 'Tyskland',
    'Qe-fd' => 'Tjeckien och Slovakien',
    'Qe-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qe-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qe-j' => 'Frankrike och Monaco',
    'Qe-n' => 'Balkanländerna',
    'Qe-o' => 'Asien',
    'Qe-q' => 'Amerika',
    'Qe-qa' => 'Förenta staterna',
    'Qe-qb' => 'Kanada',
    'Qe-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qe-qd' => 'Sydamerika',
    'Qec' => 'Trädgårdsarbete',
    'Qeca' => 'Trädgårdens marklära',
    'Qecb' => 'Jordens bearbetning',
    'Qecc' => 'Trädgårdsgödsling',
    'Qed' => 'Köksväxtodling',
    'Qed(x)' => 'Lexikon',
    'Qed:k' => 'Köksväxtodlingens historia',
    'Qedk' => 'Kryddväxter',
    'Qee' => 'Frukt- och bärodling',
    'Qee:k' => 'Frukt- och bärodlingens historia',
    'Qee:k.2' => 'Forntiden',
    'Qee:k.4' => 'Nya tiden',
    'Qee:kc' => 'Sverige',
    'Qee:kd' => 'Övriga Norden',
    'Qee:ke' => 'Brittiska öarna (Storbritannien)',
    'Qee:kf' => 'Mellaneuropa',
    'Qee:kj' => 'Frankrike och Monaco',
    'Qee:kq' => 'Amerika',
    'Qef' => 'Prydnadsväxtodling',
    'Qef(x)' => 'Lexikon',
    'Qef:k' => 'Prydnadsväxtodlingens historia',
    'Qef:k.2' => 'Forntiden',
    'Qef:k.4' => 'Nya tiden',
    'Qef:kc' => 'Sverige',
    'Qef:kd' => 'Övriga Norden',
    'Qef:ke' => 'Brittiska öarna (Storbritannien)',
    'Qef:kj' => 'Frankrike och Monaco',
    'Qef:kq' => 'Amerika',
    'Qefz' => 'Särskilda prydnadsväxter',
    'Qefk' => 'Inomhusväxter',
    'Qefk(x)' => 'Lexikon',
    'Qefkz' => 'Särskilda inomhusväxter',
    'Qf' => 'Skogsbruk',
    'Qf(x)' => 'Skogsbrukslexikon',
    'Qf:bf' => 'Skogsbruksorganisationer och -institutioner',
    'Qf:k' => 'Skogsbrukets och skogsforskningens historia',
    'Qf:k.' => 'Särskilda perioder',
    'Qf:k.2' => 'Forntiden',
    'Qf:k.3' => 'Medeltiden',
    'Qf:k.4' => 'Nya tiden',
    'Qf:k.5' => '1900-',
    'Qf:k.6' => '2000-',
    'Qf:kc' => 'Sverige',
    'Qf:kf' => 'Mellaneuropa',
    'Qf:kj' => 'Frankrike och Monaco',
    'Qf-' => 'Särskilda länder och områden',
    'Qf-a' => 'Europa: allmänt',
    'Qf-a:k' => 'Skogsbrukets historia',
    'Qf-ae' => 'Europeiska unionen (EU)',
    'Qf-b' => 'Norden: allmänt',
    'Qf-c' => 'Sverige',
    'Qf-c:bf' => 'Organisationer och institutioner',
    'Qf-c:k' => 'Skogsbrukets historia',
    'Qf-c:k.4' => 'Nya tiden 1520-',
    'Qf-c:k.41' => 'Vasatiden 1520-1611',
    'Qf-c:k.5' => '1905-',
    'Qf-c:oe' => 'Skogsvårdslagstiftning',
    'Qf-cz' => 'Särskilda orter',
    'Qf-d' => 'Övriga Norden',
    'Qf-da' => 'Danmark',
    'Qf-da:bf' => 'Organisationer och institutioner',
    'Qf-da:k' => 'Skogsbrukets historia',
    'Qf-db' => 'Norge',
    'Qf-db:bf' => 'Organisationer och institutioner',
    'Qf-db:k' => 'Skogsbrukets historia',
    'Qf-dc' => 'Island och Färöarna',
    'Qf-dd' => 'Finland',
    'Qf-dd:bf' => 'Organisationer och institutioner',
    'Qf-dd:k' => 'Skogsbrukets historia',
    'Qf-e' => 'Brittiska öarna (Storbritannien)',
    'Qf-e:k' => 'Skogsbrukets historia',
    'Qf-es' => 'Skottland',
    'Qf-et' => 'Irland',
    'Qf-f' => 'Mellaneuropa',
    'Qf-fa' => 'Tyskland',
    'Qf-fb' => 'Österrike och Liechtenstein',
    'Qf-fc' => 'Ungern',
    'Qf-fd' => 'Tjeckien och Slovakien',
    'Qf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qf-h' => 'Schweiz',
    'Qf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qf-j' => 'Frankrike och Monaco',
    'Qf-j:k' => 'Skogsbrukets historia',
    'Qf-j:k.' => 'Särskilda historiska perioder',
    'Qf-j:k.3' => 'Medeltiden 987-1498',
    'Qf-j:k.4' => 'Nya tiden 1498-',
    'Qf-j:k.5' => '1914-',
    'Qf-j:k.6' => '2000-',
    'Qf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qf-m' => 'Östeuropa',
    'Qf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qf-ma:k' => 'Skogsbrukets historia',
    'Qf-mb' => 'Polen',
    'Qf-mc' => 'Estland, Lettland, Litauen',
    'Qf-n' => 'Balkanländerna',
    'Qf-o' => 'Asien',
    'Qf-oa' => 'Främre Asien',
    'Qf-ob' => 'Främre Indien',
    'Qf-oba' => 'Indien',
    'Qf-obb' => 'Pakistan och Bangladesh',
    'Qf-obd' => 'Nepal',
    'Qf-obe' => 'Sri Lanka (f d Ceylon)',
    'Qf-oc' => 'Bortre Indien',
    'Qf-od' => 'Ostindiska öarna',
    'Qf-oe' => 'Östasien',
    'Qf-p' => 'Afrika',
    'Qf-pa' => 'Nordafrika utom Egypten',
    'Qf-pb' => 'Egypten och Sudan',
    'Qf-pc' => 'Västafrika',
    'Qf-pe' => 'Södra Afrika',
    'Qf-pf' => 'Östafrika',
    'Qf-pfa' => 'Uganda',
    'Qf-pfb' => 'Kenya',
    'Qf-pfc' => 'Tanzania',
    'Qf-pg' => 'Nordöstafrika',
    'Qf-q' => 'Amerika',
    'Qf-qa' => 'Förenta staterna',
    'Qf-qa:bf' => 'Organisationer och institutioner',
    'Qf-qa:k' => 'Skogsbrukets historia',
    'Qf-qa:k.' => 'Särskilda historiska perioder',
    'Qf-qa:k.4' => 'Nordamerika under nya tiden',
    'Qf-qa:k.5' => '1900-talet',
    'Qf-qa:k.6' => '2000-',
    'Qf-qb' => 'Kanada',
    'Qf-qb:k' => 'Skogsbrukets historia',
    'Qf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qf-qd' => 'Sydamerika',
    'Qf-qda' => 'Colombia',
    'Qf-qdc' => 'Guyanastaterna',
    'Qf-qdd' => 'Brasilien',
    'Qf-qdh' => 'Chile',
    'Qf-qdi' => 'Bolivia',
    'Qf-qdk' => 'Peru',
    'Qf-qdl' => 'Ecuador',
    'Qf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qfb' => 'Skogsekonomi',
    'Qfb:k' => 'Skogsekonomins historia',
    'Qfd' => 'Skogsbotanik',
    'Qfd:k' => 'Skogsbotanikens historia',
    'Qfe' => 'Skogsvård',
    'Qfe:k' => 'Skogsvårdens historia',
    'Qfe:kc' => 'Sverige',
    'Qfe:kd' => 'Övriga Norden',
    'Qfe:kf' => 'Mellaneuropa',
    'Qfh' => 'Avverkning och transport',
    'Qfh:k' => 'Historia',
    'Qfh:kc' => 'Sverige',
    'Qfh:kq' => 'Amerika',
    'Qfh:kqa' => 'Förenta staterna',
    'Qfh:kqb' => 'Kanada',
    'Qfj' => 'Skogsuppskattning och virkesmätning',
    'Qfj:k' => 'Historia',
    'Qfj:kc' => 'Sverige',
    'Qfj:kd' => 'Övriga Norden',
    'Qfj:kq' => 'Amerika',
    'Qfk' => 'Flottning och sortering',
    'Qfk:k' => 'Historia',
    'Qfk:kc' => 'Sverige',
    'Qfk:kd' => 'Övriga Norden',
    'Qfk:kf' => 'Mellaneuropa',
    'Qfk:kq' => 'Amerika',
    'Qg' => 'Jakt och fiske',
    'Qg-' => 'Allmänt: ärskilda länder och områden',
    'Qg-a' => 'Europa: allmänt',
    'Qg-b' => 'Norden: allmänt',
    'Qg-c' => 'Sverige',
    'Qg-cs' => 'Samer',
    'Qg-d' => 'Övriga Norden',
    'Qg-p' => 'Afrika',
    'Qga' => 'Jakt',
    'Qga(x)' => 'Jaktlexikon',
    'Qga:bf' => 'Jaktorganisationer och -institutioner',
    'Qga:k' => 'Jaktens historia',
    'Qga:kc' => 'Sverige',
    'Qga:oe' => 'Jaktlagstiftning',
    'Qga-' => 'Särskilda länder och områden',
    'Qga-a' => 'Europa: allmänt',
    'Qga-b' => 'Norden: allmänt',
    'Qga-c' => 'Sverige',
    'Qga-c:bf' => 'Organisationer och institutioner',
    'Qga-c:k' => 'Jaktens historia',
    'Qga-c:oe' => 'Jaktlagstiftning',
    'Qga-cs' => 'Samer',
    'Qga-cz' => 'Särskilda orter',
    'Qga-d' => 'Övriga Norden',
    'Qga-da' => 'Danmark',
    'Qga-db' => 'Norge',
    'Qga-dd' => 'Finland',
    'Qga-e' => 'Brittiska öarna (Storbritannien)',
    'Qga-f' => 'Mellaneuropa',
    'Qga-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qga-h' => 'Schweiz',
    'Qga-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qga-j' => 'Frankrike och Monaco',
    'Qga-m' => 'Östeuropa',
    'Qga-o' => 'Asien',
    'Qga-p' => 'Afrika',
    'Qga-q' => 'Amerika',
    'Qgac' => 'Jaktmetoder och -redskap',
    'Qgac:k' => 'Historia',
    'Qgad' => 'Viltvård',
    'Qgah' => 'Jaktskildringar',
    'Qgb' => 'Fiske',
    'Qgb(x)' => 'Fiskelexikon',
    'Qgb:bf' => 'Fiskeorganisationer och -institutioner',
    'Qgb:k' => 'Fiskets historia',
    'Qgb:k.' => 'Särskilda perioder',
    'Qgb:k.2' => 'Forntiden',
    'Qgb:k.3' => 'Medeltiden',
    'Qgb:k.4' => 'Nya tiden',
    'Qgb:k.5' => '1900-',
    'Qgb:k.6' => '2000-',
    'Qgb:kb' => 'Norden: allmänt',
    'Qgb:kc' => 'Sverige',
    'Qgb:kd' => 'Övriga Norden',
    'Qgb:ke' => 'Brittiska öarna (Storbritannien)',
    'Qgb:oe' => 'Fiskelagstiftning',
    'Qgb-' => 'Särskilda länder och områden',
    'Qgb-a' => 'Europa: allmänt',
    'Qgb-ae' => 'Europeiska unionen (EU)',
    'Qgb-b' => 'Norden: allmänt',
    'Qgb-b:K' => 'Historia',
    'Qgb-c' => 'Sverige',
    'Qgb-c:bf' => 'Organisationer och institutioner',
    'Qgb-c:k' => 'Historia',
    'Qgb-c:oe' => 'Lagstiftning',
    'Qgb-cs' => 'Samer',
    'Qgb-cz' => 'Särskilda orter',
    'Qgb-d' => 'Övriga Norden',
    'Qgb-da' => 'Danmark',
    'Qgb-da:k' => 'Historia',
    'Qgb-db' => 'Norge',
    'Qgb-db:k' => 'Historia',
    'Qgb-dc' => 'Island och Färöarna',
    'Qgb-dc:k' => 'Historia',
    'Qgb-dd' => 'Finland',
    'Qgb-dd:k' => 'Historia',
    'Qgb-e' => 'Brittiska öarna (Storbritannien)',
    'Qgb-e:k' => 'Historia',
    'Qgb-f' => 'Mellaneuropa',
    'Qgb-fa' => 'Tyskland',
    'Qgb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qgb-h' => 'Schweiz',
    'Qgb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qgb-j' => 'Frankrike och Monaco',
    'Qgb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qgb-l' => 'Portugal',
    'Qgb-m' => 'Östeuropa',
    'Qgb-n' => 'Balkanländerna',
    'Qgb-o' => 'Asien',
    'Qgb-oa' => 'Främre Asien',
    'Qgb-ob' => 'Främre Indien',
    'Qgb-oc' => 'Bortre Indien',
    'Qgb-od' => 'Ostindiska öarna',
    'Qgb-oe' => 'Östasien',
    'Qgb-p' => 'Afrika',
    'Qgb-pa' => 'Nordafrika utom Egypten',
    'Qgb-pc' => 'Västafrika',
    'Qgb-pd' => 'Centralafrika',
    'Qgb-pe' => 'Södra Afrika',
    'Qgb-pf' => 'Östafrika',
    'Qgb-pg' => 'Nordöstafrika',
    'Qgb-q' => 'Amerika',
    'Qgb-qa' => 'Förenta staterna',
    'Qgb-qa:k' => 'Historia',
    'Qgb-qb' => 'Kanada',
    'Qgb-qd' => 'Sydamerika',
    'Qgb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qgb-s' => 'Polarländerna',
    'Qgba' => 'Sportfiske',
    'Qgbaa' => 'Metoder och redskap',
    'Qgbb' => 'Fiskodling',
    'Qgbb:k' => 'Historia',
    'Qgbc' => 'Fiskemetoder och -redskap',
    'Qgbd' => 'Fiskevård',
    'Qgbh' => 'Fiskeskildringar',
    'Qgbo' => 'Fångst av havsdäggdjur',
    'Qgbo:k' => 'Historia',
    'Qgbp' => 'Fångst och odling av skaldjur, kräftdjur m m',
    'Qgbp:k' => 'Historia',
    'Qi' => 'Handel',
    'Qi(x)' => 'Allmänt: lexikon och uppslagsverk',
    'Qi:k' => 'Handelns historia',
    'Qi:k.' => 'Särskilda perioder',
    'Qi:k.2' => 'Forntiden',
    'Qi:k.23' => 'Antikens historia: allmänt',
    'Qi:k.24' => 'Den grekiska forntiden',
    'Qi:k.26' => 'Den romerska forntiden',
    'Qi:k.3' => 'Medeltiden',
    'Qi:k.4' => 'Nya tiden',
    'Qi:k.5' => '1900-',
    'Qi:k.6' => '2000-',
    'Qi:kc' => 'Sverige',
    'Qi:kd' => 'Övriga Norden',
    'Qi:kf' => 'Mellaneuropa',
    'Qi:oe' => 'Handelslagstiftning',
    'Qi-' => 'Särskilda länder och områden',
    'Qi-a' => 'Europa: allmänt',
    'Qi-a:k' => 'Handelns historia',
    'Qi-ae' => 'Europeiska unionen (EU)',
    'Qi-b' => 'Norden: allmänt',
    'Qi-bc' => 'Nordkalotten',
    'Qi-c' => 'Sverige',
    'Qi-c:bf' => 'Organisationer och institutioner',
    'Qi-c:k' => 'Handelns historia',
    'Qi-c:k.' => 'Särskilda historiska perioder',
    'Qi-c:k.4' => 'Nya tiden 1520-',
    'Qi-c:k.42' => 'Stormaktstiden 1611-1718',
    'Qi-c:k.43' => '1700-talet',
    'Qi-c:k.45' => 'Gustavianska tiden 1772-1809',
    'Qi-c:k.46' => '1800-talet',
    'Qi-c:k.49' => '1865-1905',
    'Qi-c:k.5' => '1905-',
    'Qi-c:k.51' => 'Första världskriget 1914-1918',
    'Qi-c:k.52' => 'Mellankrigstiden 1918-1939',
    'Qi-c:k.54' => 'Andra världskriget 1939-1945',
    'Qi-c:k.55' => '1945-',
    'Qi-c:k.6' => '2000-',
    'Qi-c:oe' => 'Handelslagstiftning',
    'Qi-cz' => 'Särskilda orter',
    'Qi-d' => 'Övriga Norden',
    'Qi-da' => 'Danmark',
    'Qi-da:k' => 'Handelns historia',
    'Qi-db' => 'Norge',
    'Qi-db:k' => 'Handelns historia',
    'Qi-dc' => 'Island och Färöarna',
    'Qi-dd' => 'Finland',
    'Qi-dd:k' => 'Handelns historia',
    'Qi-e' => 'Brittiska öarna (Storbritannien)',
    'Qi-e:k' => 'Handelns historia',
    'Qi-e:k.3' => 'Medeltiden 1066-1485',
    'Qi-e:k.4' => 'Nya tiden 1485-',
    'Qi-e:k.5' => '1914-',
    'Qi-et' => 'Irland',
    'Qi-f' => 'Mellaneuropa',
    'Qi-fa' => 'Tyskland',
    'Qi-fa:k' => 'Handelns historia',
    'Qi-fb' => 'Österrike och Liechtenstein',
    'Qi-fc' => 'Ungern',
    'Qi-fd' => 'Tjeckien och Slovakien',
    'Qi-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qi-ga' => 'Nederländerna',
    'Qi-ga:k' => 'Handelns historia',
    'Qi-gb' => 'Belgien',
    'Qi-gc' => 'Luxemburg',
    'Qi-h' => 'Schweiz',
    'Qi-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qi-iv' => 'Malta',
    'Qi-j' => 'Frankrike och Monaco',
    'Qi-j:k' => 'Handelns historia',
    'Qi-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qi-k:k' => 'Handelns historia',
    'Qi-l' => 'Portugal',
    'Qi-m' => 'Östeuropa',
    'Qi-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qi-ma:k' => 'Handelns historia',
    'Qi-mb' => 'Polen',
    'Qi-mc' => 'Estland, Lettland, Litauen',
    'Qi-mca' => 'Estland',
    'Qi-mcb' => 'Lettland',
    'Qi-mcc' => 'Litauen',
    'Qi-n' => 'Balkanländerna',
    'Qi-na' => 'Rumänien',
    'Qi-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Qi-nc' => 'Bulgarien',
    'Qi-nd' => 'Grekland',
    'Qi-nf' => 'Albanien',
    'Qi-o' => 'Asien',
    'Qi-oa' => 'Främre Asien',
    'Qi-oaa' => 'Turkiet',
    'Qi-oab' => 'Cypern',
    'Qi-oac' => 'Kaukasien',
    'Qi-oae' => 'Syrien och Libanon',
    'Qi-oaf' => 'Palestina och Israel',
    'Qi-oafi' => 'Israel',
    'Qi-oag' => 'Jordanien',
    'Qi-oah' => 'Arabiska halvön',
    'Qi-oaha' => 'Saudi-Arabien',
    'Qi-oahb' => 'Nordjemen',
    'Qi-oahd' => 'Oman',
    'Qi-oahe' => 'Förenade Arabemiraten, Qatar, Bahrain',
    'Qi-oahf' => 'Kuwait',
    'Qi-oai' => 'Irak',
    'Qi-oak' => 'Iran (Persien)',
    'Qi-oam' => 'Kazakstan, Turkmenistan, Uzbekistan, Kirgisistan, Tadzjikistan (f d Sovjetiska centralasien)',
    'Qi-ob' => 'Främre Indien',
    'Qi-oba' => 'Indien',
    'Qi-obb' => 'Pakistan och Bangladesh',
    'Qi-obd' => 'Nepal',
    'Qi-obe' => 'Sri Lanka (f d Ceylon)',
    'Qi-oc' => 'Bortre Indien',
    'Qi-ocb' => 'Thailand',
    'Qi-occ' => 'Malaysia, Singapore och Brunei',
    'Qi-occa' => 'Malaysia',
    'Qi-occb' => 'Singapore',
    'Qi-occd' => 'Brunei',
    'Qi-ocd' => 'Indokina',
    'Qi-od' => 'Ostindiska öarna',
    'Qi-oda' => 'Indonesien',
    'Qi-odc' => 'Filippinerna',
    'Qi-oe' => 'Östasien',
    'Qi-oea' => 'Kina',
    'Qi-oeaf' => 'Taiwan',
    'Qi-oeb' => 'Korea',
    'Qi-oec' => 'Japan',
    'Qi-oek' => 'Hongkong och Macau',
    'Qi-og' => 'Sibirien',
    'Qi-p' => 'Afrika',
    'Qi-pa' => 'Nordafrika utom Egypten',
    'Qi-pb' => 'Egypten och Sudan',
    'Qi-pc' => 'Västafrika',
    'Qi-pcb' => 'Ekvatorialfrika',
    'Qi-pcc' => 'Norra Västafrika',
    'Qi-pcd' => 'Södra Västafrika',
    'Qi-pcda' => 'Ghana',
    'Qi-pcdb' => 'Togo',
    'Qi-pcdc' => 'Benin',
    'Qi-pcdd' => 'Nigeria',
    'Qi-pd' => 'Centralafrika',
    'Qi-pe' => 'Södra Afrika',
    'Qi-pea' => 'Sydafrikanska republiken, Namibia, Lesotho, Swaziland',
    'Qi-peaa' => 'Sydafrikanska republiken',
    'Qi-peab' => 'Namibia',
    'Qi-peac' => 'Lesotho',
    'Qi-peb' => 'Botswana',
    'Qi-pec' => 'Zimbabwe, Zambia, Malawi',
    'Qi-ped' => 'Mocambique',
    'Qi-pf' => 'Östafrika',
    'Qi-pg' => 'Nordöstafrika',
    'Qi-q' => 'Amerika',
    'Qi-qa' => 'Förenta staterna',
    'Qi-qa:k' => 'Handelns historia',
    'Qi-qb' => 'Kanada',
    'Qi-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qi-qca' => 'Mexiko',
    'Qi-qcb' => 'Guatemala',
    'Qi-qcf' => 'Costa Rica',
    'Qi-qcg' => 'Panama',
    'Qi-qch' => 'Västindien',
    'Qi-qcha' => 'Stora Antillerna',
    'Qi-qchb' => 'Små Antillerna',
    'Qi-qchc' => 'Bahamas',
    'Qi-qchd' => 'Bermuda',
    'Qi-qd' => 'Sydamerika',
    'Qi-qda' => 'Colombia',
    'Qi-qdb' => 'Venezuela',
    'Qi-qdd' => 'Brasilien',
    'Qi-qde' => 'Paraguay',
    'Qi-qdf' => 'Uruguay',
    'Qi-qdg' => 'Argentina',
    'Qi-qdh' => 'Chile',
    'Qi-qdi' => 'Bolivia',
    'Qi-qdk' => 'Peru',
    'Qi-qdl' => 'Ecuador',
    'Qi-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qi-ra' => 'Australien',
    'Qi-rb' => 'Nya Zeeland',
    'Qi-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qi-rd' => 'Nya Guinea',
    'Qia' => 'Handelsteknik',
    'Qik' => 'Varukännedom',
    'Qil' => 'Handelskalendrar och -lexikon',
    'Qil-' => 'Särskilda länder och områden',
    'Qil-a' => 'Europa: allmänt',
    'Qil-ae' => 'Europeiska unionen (EU)',
    'Qil-b' => 'Norden: allmänt',
    'Qil-c' => 'Sverige',
    'Qil-cz' => 'Särskilda orter',
    'Qil-d' => 'Övriga Norden',
    'Qil-da' => 'Danmark',
    'Qil-db' => 'Norge',
    'Qil-dc' => 'Island och Färöarna',
    'Qil-dd' => 'Finland',
    'Qil-e' => 'Brittiska öarna (Storbritannien)',
    'Qil-f' => 'Mellaneuropa',
    'Qil-fa' => 'Tyskland',
    'Qil-fb' => 'Österrike och Liechtenstein',
    'Qil-fd' => 'Tjeckien och Slovakien',
    'Qil-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qil-h' => 'Schweiz',
    'Qil-j' => 'Frankrike och Monaco',
    'Qil-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qil-l' => 'Portugal',
    'Qil-m' => 'Östeuropa',
    'Qil-o' => 'Asien',
    'Qil-p' => 'Afrika',
    'Qil-q' => 'Amerika',
    'Qil-qa' => 'Förenta staterna',
    'Qil-qb' => 'Kanada',
    'Qil-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qil-qd' => 'Sydamerika',
    'Qil-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qil-s' => 'Polarländerna',
    'Qim' => 'Handel med speciella varor',
    'Qimi' => 'Konst, musik, teater, film, fotokonst',
    'Qimp' => 'Teknik, industri och kommunikationer',
    'Qimpa' => 'Teknisk fysik',
    'Qimpb' => 'Maskinteknik',
    'Qimpc' => 'Elektroteknik och elektrisk industri',
    'Qimpd' => 'Bergsbruk',
    'Qimpe' => 'Metallbearbetning och metallindustri',
    'Qimpg' => 'Glas, keramik, porslin',
    'Qimph' => 'Träteknik och träindustri',
    'Qimpi' => 'Pappersindustri',
    'Qimpj' => 'Textil- och beklädnadsindustri',
    'Qimpk' => 'Läder- och pälsvaruindustri',
    'Qimpm' => 'Kemisk teknik och kemisk industri',
    'Qimpma' => 'Bränslen och sprängämnen',
    'Qimpmb' => 'Livsmedel och njutningsmedel',
    'Qimpmba' => 'Drycker och njutningsmedel',
    'Qimpmbaa' => 'Drycker och bryggerinäring',
    'Qimpmbab' => 'Tobaksvaror',
    'Qimpmbb' => 'Livsmedel',
    'Qimpmc' => 'Läkemedel och kosmetika',
    'Qimpmg' => 'Oljor, fetter och vaxer',
    'Qimpmh' => 'Färger och lacker',
    'Qimpmi' => 'Gummi och plaster',
    'Qimpmö' => 'Övrig kemisk-teknisk industri',
    'Qimpp' => 'Byggnadsteknik, byggnadsproduktion, teknisk hygien',
    'Qimpr' => 'Transportmedel och kommunikationer',
    'Qimpu' => 'Datorer och databehandling',
    'Qimq' => 'Ekonomi och näringsväsen',
    'Qimqc' => 'Hem och hushåll',
    'Qimqd' => 'Lantbruk',
    'Qimqdb' => 'Lantbrukets byggnader, redskap och maskiner',
    'Qimqdd' => 'Växtodlingslära',
    'Qimqddd' => 'Åkerbruksväxterna',
    'Qimqddda' => 'Sädesslagen',
    'Qimqdddc' => 'Rotfrukter och potatis',
    'Qimqddde' => 'Olje- och spånadsväxter',
    'Qimqdddf' => 'Njutningsmedel och medicinalväxter',
    'Qimqdf' => 'Husdjurslära',
    'Qimqdg' => 'Mjölkproduktion',
    'Qimqdh' => 'Äggproduktion',
    'Qimqdi' => 'Köttproduktion',
    'Qimqe' => 'Trädgårdsskötsel',
    'Qimqf' => 'Skogsbruk',
    'Qimqg' => 'Jakt och fiske',
    'Qimqj' => 'Post- och televäsen',
    'Qimqm' => 'Hotell och turistväsen',
    'Qimr' => 'Idrott, lek och spel',
    'Qims' => 'Militärväsen',
    'Qimu' => 'Naturvetenskap',
    'Qimv' => 'Medicin',
    'Qis' => 'Marknader och varumässor',
    'Qis:k' => 'Historia',
    'Qis-' => 'Särskilda länder och områden',
    'Qis-a' => 'Europa: allmänt',
    'Qis-b' => 'Norden: allmänt',
    'Qis-c' => 'Sverige',
    'Qis-cs' => 'Samer',
    'Qis-cz' => 'Särskilda orter',
    'Qis-d' => 'Övriga Norden',
    'Qis-e' => 'Brittiska öarna (Storbritannien)',
    'Qis-f' => 'Mellaneuropa',
    'Qis-fa' => 'Tyskland',
    'Qis-fb' => 'Österrike och Liechtenstein',
    'Qis-fd' => 'Tjeckien och Slovakien',
    'Qis-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qis-h' => 'Schweiz',
    'Qis-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qis-j' => 'Frankrike och Monaco',
    'Qis-m' => 'Östeuropa',
    'Qis-o' => 'Asien',
    'Qis-p' => 'Afrika',
    'Qis-q' => 'Amerika',
    'Qis-qa' => 'Förenta staterna',
    'Qis-qb' => 'Kanada',
    'Qis-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qis-qd' => 'Sydamerika',
    'Qis-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qiv' => 'Handelskammare, handelsrepresentation',
    'Qiv-' => 'Särskilda länder och områden',
    'Qiv-c' => 'Sverige',
    'Qiv-c:bf' => 'Organisationer och institutioner',
    'Qiv-d' => 'Övriga Norden',
    'Qiv-e' => 'Brittiska öarna (Storbritannien)',
    'Qiv-f' => 'Mellaneuropa',
    'Qiv-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qiv-j' => 'Frankrike och Monaco',
    'Qiv-m' => 'Östeuropa',
    'Qiv-o' => 'Asien',
    'Qiv-q' => 'Amerika',
    'Qj' => 'Post- och televäsen',
    'Qjf' => 'Postväsen',
    'Qjf.bf' => 'Organisationer och institutioner',
    'Qjf:k' => 'Postväsendets historia',
    'Qjf:kc' => 'Sverige',
    'Qjf-' => 'Särskilda länder och områden',
    'Qjf-a' => 'Europa: allmänt',
    'Qjf-b' => 'Norden: allmänt',
    'Qjf-c' => 'Sverige',
    'Qjf-c:bf' => 'Organisationer och institutioner',
    'Qjf-c:k' => 'Postväsendets historia',
    'Qjf-c:oe' => 'Postlagstiftning',
    'Qjf-cz' => 'Särskilda orter',
    'Qjf-d' => 'Övriga Norden',
    'Qjf-da' => 'Danmark',
    'Qjf-da:k' => 'Postväsendets historia',
    'Qjf-db' => 'Norge',
    'Qjf-db:k' => 'Postväsendets historia',
    'Qjf-dc' => 'Island och Färöarna',
    'Qjf-dd' => 'Finland',
    'Qjf-e' => 'Brittiska öarna (Storbritannien)',
    'Qjf-e:k' => 'Postväsendets historia',
    'Qjf-f' => 'Mellaneuropa',
    'Qjf-fa' => 'Tyskland',
    'Qjf-fa:k' => 'Postväsendets historia',
    'Qjf-fb' => 'Österrike och Liechtenstein',
    'Qjf-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qjf-h' => 'Schweiz',
    'Qjf-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qjf-j' => 'Frankrike och Monaco',
    'Qjf-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qjf-m' => 'Östeuropa',
    'Qjf-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qjf-mb' => 'Polen',
    'Qjf-mc' => 'Estland, Lettland, Litauen',
    'Qjf-n' => 'Balkanländerna',
    'Qjf-o' => 'Asien',
    'Qjf-oa' => 'Främre Asien',
    'Qjf-ob' => 'Främre Indien',
    'Qjf-oc' => 'Bortre Indien',
    'Qjf-od' => 'Ostindiska öarna',
    'Qjf-oe' => 'Östasien',
    'Qjf-oea' => 'Kina',
    'Qjf-oec' => 'Japan',
    'Qjf-oek' => 'Hongkong och Macau',
    'Qjf-p' => 'Afrika',
    'Qjf-pb' => 'Egypten och Sudan',
    'Qjf-pc' => 'Västafrika',
    'Qjf-pe' => 'Södra Afrika',
    'Qjf-pf' => 'Östafrika',
    'Qjf-pg' => 'Nordöstafrika',
    'Qjf-q' => 'Amerika',
    'Qjf-qa' => 'Förenta staterna',
    'Qjf-qa:k' => 'Postväsendets historia',
    'Qjf-qb' => 'Kanada',
    'Qjf-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qjf-qd' => 'Sydamerika',
    'Qjf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qjf-ra' => 'Australien',
    'Qjf-rb' => 'Nya Zeeland',
    'Qjf-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qjf-s' => 'Polarländerna',
    'Qjfb' => 'Frimärken',
    'Qjfb(x)' => 'Lexikon',
    'Qjfb:k' => 'Historia',
    'Qjfb-' => 'Särskilda länder och områden',
    'Qjfb-a' => 'Europa: allmänt',
    'Qjfb-b' => 'Norden: allmänt',
    'Qjfb-c' => 'Sverige',
    'Qjfb-c:bf' => 'Organisationer och institutioner',
    'Qjfb-c:k' => 'Historia',
    'Qjfb-d' => 'Övriga Norden',
    'Qjfb-da' => 'Danmark',
    'Qjfb-db' => 'Norge',
    'Qjfb-dc' => 'Island och Färöarna',
    'Qjfb-dd' => 'Finland',
    'Qjfb-e' => 'Brittiska öarna (Storbritannien)',
    'Qjfb-e:k' => 'Historia',
    'Qjfb-f' => 'Mellaneuropa',
    'Qjfb-fa' => 'Tyskland',
    'Qjfb-fa:k' => 'Historia',
    'Qjfb-fb' => 'Österrike och Liechtenstein',
    'Qjfb-fd' => 'Tjeckien och Slovakien',
    'Qjfb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qjfb-h' => 'Schweiz',
    'Qjfb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qjfb-j' => 'Frankrike och Monaco',
    'Qjfb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qjfb-m' => 'Östeuropa',
    'Qjfb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qjfb-mb' => 'Polen',
    'Qjfb-mc' => 'Estland, Lettland, Litauen',
    'Qjfb-n' => 'Balkanländerna',
    'Qjfb-o' => 'Asien',
    'Qjfb-oa' => 'Främre Asien',
    'Qjfb-ob' => 'Främre Indien',
    'Qjfb-oc' => 'Bortre Indien',
    'Qjfb-oe' => 'Östasien',
    'Qjfb-p' => 'Afrika',
    'Qjfb-q' => 'Amerika',
    'Qjfb-qa' => 'Förenta staterna',
    'Qjfb-qb' => 'Kanada',
    'Qjfb-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qjfb-qd' => 'Sydamerika',
    'Qjfb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qjfb-ra' => 'Australien',
    'Qjfb-rb' => 'Nya Zeeland',
    'Qjfb-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Qjfb-s' => 'Polarländerna',
    'Qjg' => 'Televäsen',
    'Qjg:bf' => 'organisationer och institutioner',
    'Qjg:k' => 'Televäsendets historia',
    'Qjg:oe' => 'Telelagstiftning',
    'Qjg-' => 'Särskilda länder och områden',
    'Qjg-a' => 'Europa: allmänt',
    'Qjg-ae' => 'Europeiska unionen (EU)',
    'Qjg-b' => 'Norden: allmänt',
    'Qjg-c' => 'Sverige',
    'Qjg-c:bf' => 'Organisationer och institutioner',
    'Qjg-c:k' => 'Televäsendets historia',
    'Qjg-c:oe' => 'Telelagstiftning',
    'Qjg-cz' => 'Särskilda orter',
    'Qjg-d' => 'Övriga Norden',
    'Qjg-da' => 'Danmark',
    'Qjg-db' => 'Norge',
    'Qjg-dc' => 'Island och Färöarna',
    'Qjg-dd' => 'Finland',
    'Qjg-e' => 'Brittiska öarna (Storbritannien)',
    'Qjg-f' => 'Mellaneuropa',
    'Qjg-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qjg-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qjg-j' => 'Frankrike och Monaco',
    'Qjg-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qjg-m' => 'Östeuropa',
    'Qjg-o' => 'Asien',
    'Qjg-p' => 'Afrika',
    'Qjg-q' => 'Amerika',
    'Qjg-qa' => 'Förenta staterna',
    'Qjg-qb' => 'Kanada',
    'Qjg-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qjg-qd' => 'Sydamerika',
    'Qjg-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qm' => 'Hotell, restauranger och turism',
    'Qm(x)' => 'Hotell, restauranger och turism: lexikon',
    'Qm:k' => 'Hotell, restauranger och turism: historia',
    'Qm-' => 'Särskilda länder och områden',
    'Qm-a' => 'Europa: allmänt',
    'Qm-ae' => 'Europeiska unionen (EU)',
    'Qm-b' => 'Norden: allmänt',
    'Qm-c' => 'Sverige',
    'Qm-c:bf' => 'Turistföreningar',
    'Qm-c:k' => 'Hotell- och turistväsendets historia',
    'Qm-cs' => 'Samer',
    'Qm-cz' => 'Särskilda restauranger, hotell m m',
    'Qm-d' => 'Övriga Norden',
    'Qm-da' => 'Danmark',
    'Qm-db' => 'Norge',
    'Qm-dd' => 'Finland',
    'Qm-e' => 'Brittiska öarna (Storbritannien)',
    'Qm-e:k' => 'Hotell- och turistväsendets historia',
    'Qm-f' => 'Mellaneuropa',
    'Qm-fa' => 'Tyskland',
    'Qm-fb' => 'Österrike och Liechtenstein',
    'Qm-g' => 'Nederländerna, Belgien och Luxemburg',
    'Qm-h' => 'Schweiz',
    'Qm-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Qm-j' => 'Frankrike och Monaco',
    'Qm-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Qm-l' => 'Portugal',
    'Qm-m' => 'Östeuropa',
    'Qm-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Qm-mb' => 'Polen',
    'Qm-mc' => 'Estland, Lettland, Litauen',
    'Qm-n' => 'Balkanländerna',
    'Qm-o' => 'Asien',
    'Qm-oa' => 'Främre Asien',
    'Qm-ob' => 'Främre Indien',
    'Qm-oc' => 'Bortre Indien',
    'Qm-od' => 'Ostindiska öarna',
    'Qm-oe' => 'Östasien',
    'Qm-p' => 'Afrika',
    'Qm-pa' => 'Nordafrika utom Egypten',
    'Qm-pb' => 'Egypten och Sudan',
    'Qm-pc' => 'Västafrika',
    'Qm-pe' => 'Södra Afrika',
    'Qm-pf' => 'Östafrika',
    'Qm-q' => 'Amerika',
    'Qm-qa' => 'Förenta staterna',
    'Qm-qa:k' => 'Televäsendets historia',
    'Qm-qb' => 'Kanada',
    'Qm-qc' => 'Mexiko, Centralamerika och Västindien',
    'Qm-qd' => 'Sydamerika',
    'Qm-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Qm-s' => 'Polarländerna',
    'Qz' => 'Särskilda företag',
    'R' => 'Idrott, lek och spel',
    'Ra' => 'Gymnastik',
    'Rag' => 'Motion',
    'Rah' => 'Bodybuilding',
    'Rai' => 'Yoga',
    'Raj' => 'Akrobatik',
    'Rb' => 'Idrott och sport',
    'Rb:bf' => 'Idrottsorganisationer och -institutioner',
    'Rb:do' => 'Idrottspsykologi',
    'Rb:k' => 'Idrottsforskningens historia',
    'Rb:kc' => 'Sverige',
    'Rb:oa' => 'Idrottssociologi',
    'Rb-' => 'Särskilda länder och områden',
    'Rb-a' => 'Europa: allmänt',
    'Rb-b' => 'Norden: allmänt',
    'Rb-c' => 'Sverige',
    'Rb-cs' => 'Samer',
    'Rb-cz' => 'Särskilda orter',
    'Rb-d' => 'Övriga Norden',
    'Rb-e' => 'Brittiska öarna (Storbritannien)',
    'Rb-f' => 'Mellaneuropa',
    'Rb-j' => 'Frankrike och Monaco',
    'Rb-m' => 'Östeuropa',
    'Rb-o' => 'Asien',
    'Rb-p' => 'Afrika',
    'Rb-q' => 'Amerika',
    'Rb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Rba' => 'Allmän idrott. Friidrott',
    'Rbaa' => 'Gång och löpning',
    'Rbaaa' => 'Gång',
    'Rbaac' => 'Löpning',
    'Rbab' => 'Hopp',
    'Rbac' => 'Kast',
    'Rbad' => 'Mångkamp',
    'Rbb' => 'Boll- och kägelsport',
    'Rbba' => 'Fotboll och rugby',
    'Rbbaa' => 'Fotboll',
    'Rbbab' => 'Rugby',
    'Rbbb' => 'Handboll, basketboll, volleyboll',
    'Rbbba' => 'Handboll',
    'Rbbbc' => 'Basketboll',
    'Rbbbe' => 'Volleyboll',
    'Rbbc' => 'Baseboll, cricket, golf',
    'Rbbcg' => 'Golf',
    'Rbbd' => 'Racketsport',
    'Rbbda' => 'Tennis',
    'Rbbdb' => 'Squash',
    'Rbbdd' => 'Badminton',
    'Rbbde' => 'Bordtennis',
    'Rbbe' => 'Bowling m fl precisionsspel',
    'Rbc' => 'Simning, simhopp, dykning m m',
    'Rbca' => 'Simning',
    'Rbcc' => 'Simhopp',
    'Rbce' => 'Dykning',
    'Rbcg' => 'Vattenpolo',
    'Rbd' => 'Sjösport. Båtsport',
    'Rbda' => 'Kanotsport',
    'Rbdb' => 'Rodd',
    'Rbdc' => 'Segling',
    'Rbdci' => 'Brädsegling (windsurfing)',
    'Rbdd' => 'Motorbåtsport',
    'Rbde' => 'Surfing, vattenskidåkning',
    'Rbe' => 'Djursport',
    'Rbea' => 'Hästsport',
    'Rbeaa' => 'Galoppsport',
    'Rbeab' => 'Travsport m m',
    'Rbeac' => 'Ridsport (inkl hästpolo)',
    'Rbej' => 'Hundsport',
    'Rbem' => 'Duvsport',
    'Rbf' => 'Cykel-, motor- och flygsport',
    'Rbfa' => 'Cykelsport',
    'Rbfb' => 'Motorcykelsport',
    'Rbfc' => 'Bilsport',
    'Rbfd' => 'Flygsport',
    'Rbg' => 'Vintersport',
    'Rbga' => 'Skidsport',
    'Rbgaa' => 'Längdåkning',
    'Rbgac' => 'Utförsåkning',
    'Rbgae' => 'Backhoppning',
    'Rbgb' => 'Skridskoåkning',
    'Rbgba' => 'Konståkning',
    'Rbgc' => 'Ishockey och bandy',
    'Rbgcb' => 'Ishockey',
    'Rbgcd' => 'Bandy',
    'Rbgd' => 'Övrig issport',
    'Rbgj' => 'Kälk- och bobsleighåkning',
    'Rbh' => 'Rullskridskor, rullbräda, rullskidor',
    'Rbi' => 'Budo (kampsporter)',
    'Rbia' => 'Kendo',
    'Rbib' => 'Judo',
    'Rbic' => 'Karate',
    'Rbid' => 'Aikido',
    'Rbj' => 'Brottning',
    'Rbk' => 'Boxning',
    'Rbl' => 'Tyngdlyftning',
    'Rbm' => 'Orienteringssport (inkl skidorientering)',
    'Rbn' => 'Alpinism',
    'Rbo' => 'Friluftsliv',
    'Rbp' => 'Fäktning',
    'Rbq' => 'Skytte',
    'Rbqb' => 'Skytte med eldhandvapen',
    'Rbqd' => 'Bågskytte',
    'Rbr' => 'Handikappidrott',
    'Rbv' => 'Olympiska spelen',
    'Rbz' => 'Särskilda idrottsutövare',
    'Rc' => 'Danslekar och dans',
    'Rca' => 'Sång- och danslekar',
    'Rcb' => 'Dans',
    'Rcba' => 'Folkdans',
    'Rcbb' => 'Modern dans',
    'Rd' => 'Spel och tidsfördriv',
    'Rda' => 'Schack',
    'Rdb' => 'Kortspel',
    'Rdba' => 'Bridge',
    'Rdbj' => 'Patienser',
    'Rdc' => 'Sällskapsspel',
    'Rdca' => 'Biljard',
    'Rdcb' => 'Dataspel',
    'Rdd' => 'Lekar',
    'Rdda' => 'Frågesport',
    'Rddb' => 'Gåtor, charader, rebusar',
    'Rddc' => 'Korsord',
    'Rddd' => 'Trollkonster, kortkonster',
    'Rddf' => 'Utomhuslekar',
    'Rdj' => 'Leksaker',
    'Rds' => 'Samlarverksamhet',
    'Re' => 'Lotteri, vadhållning, tips',
    'Re-' => 'Särskilda länder och områden',
    'Re-a' => 'Europa: allmänt',
    'Re-b' => 'Norden: allmänt',
    'Re-d' => 'Övriga Norden',
    'Re-q' => 'Amerika',
    'Rh' => 'Scoutrörelsen',
    'Rh-' => 'Särskilda länder och områden',
    'Rh-c' => 'Sverige',
    'Rh-cz' => 'Särskilda orter',
    'Rh-d' => 'Övriga Norden',
    'S' => 'Militärväsen',
    'S(x)' => 'Militära lexikon',
    'S:bf' => 'Militära institutioner',
    'S:do' => 'Allmänt: militär psykologi',
    'S:k' => 'Allmän krigshistoria och krigskonstens historia',
    'S:k.' => 'Särskilda perioder',
    'S:k.2' => 'Forntiden',
    'S:k.22' => 'Främre Asien',
    'S:k.23' => 'Antikens historia: allmänt',
    'S:k.24' => 'Den grekiska forntiden',
    'S:k.26' => 'Den romerska forntiden',
    'S:k.3' => 'Medeltiden',
    'S:k.4' => 'Nya tiden',
    'S:k.5' => '1900-',
    'S:k.6' => '2000-',
    'S:kc' => 'Sverige',
    'S:oa' => 'Allmänt: militär sociologi',
    'S.0' => 'Allmänt: särskilda militära aspekter',
    'S.01' => 'Strategi och taktik',
    'S.02' => 'Organisation och ledning',
    'S.03' => 'Personal',
    'S.04' => 'Utbildning',
    'S.05' => 'Ekonomisk förvaltning',
    'S.06' => 'Anläggningar',
    'S.07' => 'Materiel och utrustning (inkl uniformer)',
    'S.075' => 'Uniformer',
    'S-' => 'Allmänt: särskilda länder och områden',
    'S-a' => 'Europa: allmänt',
    'S-ae' => 'Europeiska unionen (EU)',
    'S-b' => 'Norden: allmänt',
    'S-c' => 'Sverige',
    'S-cz' => 'Särskilda förband, enheter och orter',
    'S-d' => 'Övriga Norden',
    'S-da' => 'Danmark',
    'S-db' => 'Norge',
    'S-dc' => 'Island och Färöarna',
    'S-dd' => 'Finland',
    'S-e' => 'Brittiska öarna (Storbritannien)',
    'S-f' => 'Mellaneuropa',
    'S-fa' => 'Tyskland',
    'S-fb' => 'Österrike och Liechtenstein',
    'S-fc' => 'Ungern',
    'S-fd' => 'Tjeckien och Slovakien',
    'S-g' => 'Nederländerna, Belgien och Luxemburg',
    'S-h' => 'Schweiz',
    'S-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'S-j' => 'Frankrike och Monaco',
    'S-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'S-l' => 'Portugal',
    'S-m' => 'Östeuropa',
    'S-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'S-mb' => 'Polen',
    'S-mc' => 'Estland, Lettland, Litauen',
    'S-n' => 'Balkanländerna',
    'S-na' => 'Rumänien',
    'S-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'S-nc' => 'Bulgarien',
    'S-nd' => 'Grekland',
    'S-nf' => 'Albanien',
    'S-o' => 'Asien',
    'S-oa' => 'Främre Asien',
    'S-ob' => 'Främre Indien',
    'S-oc' => 'Bortre Indien',
    'S-od' => 'Ostindiska öarna',
    'S-oe' => 'Östasien',
    'S-oea' => 'Kina',
    'S-oeb' => 'Korea',
    'S-oec' => 'Japan',
    'S-oek' => 'Hongkong och Macau',
    'S-p' => 'Afrika',
    'S-pa' => 'Nordafrika utom Egypten',
    'S-pb' => 'Egypten och Sudan',
    'S-pc' => 'Västafrika',
    'S-pd' => 'Centralafrika',
    'S-pe' => 'Södra Afrika',
    'S-pf' => 'Östafrika',
    'S-pg' => 'Nordöstafrika',
    'S-q' => 'Amerika',
    'S-qa' => 'Förenta staterna',
    'S-qb' => 'Kanada',
    'S-qc' => 'Mexiko, Centralamerika och Västindien',
    'S-qd' => 'Sydamerika',
    'S-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'S-s' => 'Polarländerna',
    'Sa' => 'Lantkrigsväsen',
    'Sa:k' => 'Lantkrigsväsendets historia',
    'Sa.0' => 'Lantkrigsväsen: särskilda aspekter',
    'Sa.01' => 'Strategi och taktik',
    'Sa.02' => 'Organisation och ledning',
    'Sa.03' => 'Personal',
    'Sa.04' => 'Utbildning',
    'Sa.07' => 'Materiel och utrustning (inkl uniformer)',
    'Sa-' => 'Särskilda länder och områden',
    'Sa-a' => 'Europa: allmänt',
    'Sa-c' => 'Sverige',
    'Sa-d' => 'Övriga Norden',
    'Sa-da' => 'Danmark',
    'Sa-db' => 'Norge',
    'Sa-dd' => 'Finland',
    'Sa-e' => 'Brittiska öarna (Storbritannien)',
    'Sa-f' => 'Mellaneuropa',
    'Sa-fa' => 'Tyskland',
    'Sa-fb' => 'Österrike och Liechtenstein',
    'Sa-g' => 'Nederländerna, Belgien och Luxemburg',
    'Sa-h' => 'Schweiz',
    'Sa-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Sa-j' => 'Frankrike och Monaco',
    'Sa-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Sa-m' => 'Östeuropa',
    'Sa-n' => 'Balkanländerna',
    'Sa-o' => 'Asien',
    'Sa-q' => 'Amerika',
    'Saa' => 'Infanteri',
    'Saak' => 'Flygburet infanteri (inkl fallskärmstrupper)',
    'Sab' => 'Kavalleri',
    'Sabg' => 'Intendentur',
    'Sac' => 'Pansartrupper',
    'Sad' => 'Artilleri',
    'Sadl' => 'Luftvärnsartilleri',
    'Sadm' => 'Kustartilleri',
    'Sae' => 'Fortifikation och ingenjörsväsen',
    'Saf' => 'Signalväsen',
    'Sag' => 'Underhållsväsen',
    'Saga' => 'Träng',
    'Sagc' => 'Tygväsen',
    'Sb' => 'Sjökrigsväsen',
    'Sb:k' => 'Sjökrigsväsendets historia',
    'Sb.0' => 'Sjökrigsväsen: särskilda aspekter',
    'Sb.01' => 'Strategi och taktik',
    'Sb.02' => 'Organisation och ledning',
    'Sb.04' => 'Utbildning',
    'Sb.07' => 'Materiel och utrustning (inkl uniformer)',
    'Sb-' => 'Särskilda länder och områden',
    'Sb-a' => 'Europa: allmänt',
    'Sb-b' => 'Norden: allmänt',
    'Sb-c' => 'Sverige',
    'Sb-d' => 'Övriga Norden',
    'Sb-e' => 'Brittiska öarna (Storbritannien)',
    'Sb-f' => 'Mellaneuropa',
    'Sb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Sb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Sb-j' => 'Frankrike och Monaco',
    'Sb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Sb-m' => 'Östeuropa',
    'Sb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Sb-mb' => 'Polen',
    'Sb-n' => 'Balkanländerna',
    'Sb-o' => 'Asien',
    'Sb-p' => 'Afrika',
    'Sb-q' => 'Amerika',
    'Sb-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Sbk' => 'Ubåtsvapnet',
    'Sbl' => 'Minvapnet',
    'Sbm' => 'Amfibieoperationer',
    'Sc' => 'Luftkrigsväsen',
    'Sc:k' => 'Luftkrigsväsendets historia',
    'Sc.0' => 'Luftkrigsväsen: särskilda aspekter',
    'Sc.01' => 'Strategi och taktik',
    'Sc.07' => 'Materiel och utrustning (inkl uniformer)',
    'Sc-' => 'Särskilda länder och områden',
    'Sc-c' => 'Sverige',
    'Sc-d' => 'Övriga Norden',
    'Sc-e' => 'Brittiska öarna (Storbritannien)',
    'Sc-f' => 'Mellaneuropa',
    'Sc-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Sc-j' => 'Frankrike och Monaco',
    'Sc-m' => 'Östeuropa',
    'Sc-o' => 'Asien',
    'Sc-q' => 'Amerika',
    'Se' => 'Total krigföring',
    'Se-' => 'Särskilda länder och områden',
    'Se-a' => 'Europa: allmänt',
    'Se-c' => 'Sverige',
    'Se-d' => 'Övriga Norden',
    'Se-e' => 'Brittiska öarna (Storbritannien)',
    'Se-f' => 'Mellaneuropa',
    'Se-j' => 'Frankrike och Monaco',
    'Se-m' => 'Östeuropa',
    'Se-o' => 'Asien',
    'Se-p' => 'Afrika',
    'Se-q' => 'Amerika',
    'Seg' => 'Gerillakrigföring',
    'Sei' => 'Underrättelseverksamhet',
    'Sf' => 'Kärnvapenkrigföring',
    'Sf:k' => 'Kärnvapenkrigföringens historia',
    'Sf.0' => 'Kärnvapenkrigföring: särskilda aspekter',
    'Sf.01' => 'Strategi och taktik',
    'Sf.07' => 'Materiel och utrustning (inkl uniformer)',
    'Sf-' => 'Särskilda länder och områden',
    'Sf-a' => 'Europa: allmänt',
    'Sf-b' => 'Norden: allmänt',
    'Sf-c' => 'Sverige',
    'Sf-d' => 'Övriga Norden',
    'Sf-e' => 'Brittiska öarna (Storbritannien)',
    'Sf-f' => 'Mellaneuropa',
    'Sf-fb' => 'Österrike och Liechtenstein',
    'Sf-j' => 'Frankrike och Monaco',
    'Sf-m' => 'Östeuropa',
    'Sf-o' => 'Asien',
    'Sf-p' => 'Afrika',
    'Sf-q' => 'Amerika',
    'Sf-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Sf-s' => 'Polarländerna',
    'Sg' => 'Kemisk och biologisk krigföring',
    'Sh' => 'Psykologiskt försvar',
    'Si' => 'Civilförsvar',
    'Si-' => 'Särskilda länder och områden',
    'Si-a' => 'Europa: allmänt',
    'Si-b' => 'Norden: allmänt',
    'Si-c' => 'Sverige',
    'Si-d' => 'Övriga Norden',
    'Si-e' => 'Brittiska öarna (Storbritannien)',
    'Si-f' => 'Mellaneuropa',
    'Si-m' => 'Östeuropa',
    'Si-n' => 'Balkanländerna',
    'Si-o' => 'Asien',
    'Si-q' => 'Amerika',
    'Sj' => 'Ekonomiskt försvar',
    'Sk' => 'Frivilligt försvarsarbete',
    'Sk-' => 'Allmänt: särskilda länder och områden',
    'Sk-c' => 'Sverige',
    'Sk-d' => 'Övriga Norden',
    'Sv' => 'Vapen',
    'Sv:k' => 'Allmän vapenhistoria',
    'Sv:k.' => 'Särskilda perioder',
    'Sv:k.2' => 'Forntiden',
    'Sv:k.3' => 'Medeltiden',
    'Sv:k.4' => 'Nya tiden',
    'Sv-' => 'Allmänt: särskilda länder och områden',
    'Sv-a' => 'Europa: allmänt',
    'Sv-c' => 'Sverige',
    'Sv-d' => 'Övriga Norden',
    'Sv-e' => 'Brittiska öarna (Storbritannien)',
    'Sv-f' => 'Mellaneuropa',
    'Sv-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Sv-j' => 'Frankrike och Monaco',
    'Sv-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Sv-m' => 'Östeuropa',
    'Sv-n' => 'Balkanländerna',
    'Sv-o' => 'Asien',
    'Sv-p' => 'Afrika',
    'Sv-q' => 'Amerika',
    'Sva' => 'Armborst och bågar',
    'Svb' => 'Blankvapen',
    'Svd' => 'Skyddsvapen',
    'Sve' => 'Skjutvapen',
    'Svh' => 'Ammunition, projektiler, sprängvapen',
    'T' => 'Matematik',
    'Ta' => 'Matematik: allmänt',
    'Ta(t)' => 'Matematiska tabeller',
    'Ta(x)' => 'Matematiska lexikon',
    'Ta:bf' => 'Matematiska institutioner',
    'Ta:d' => 'Matematikens filosofi',
    'Ta:k' => 'Matematikens historia',
    'Ta:k.' => 'Särskilda perioder',
    'Ta:k.2' => 'Forntiden',
    'Ta:k.3' => 'Medeltiden',
    'Ta:k.4' => 'Nya tiden',
    'Ta:k.5' => '1900-',
    'Ta:k.6' => '2000-',
    'Ta:kc' => 'Sverige',
    'Tac' => 'Mängdlära',
    'Tad' => 'Ordnade algebraiska strukturer och lattices',
    'Tag' => 'Grafteori',
    'Tak' => 'Numerisk analys',
    'Takk' => 'Approximationer',
    'Tal' => 'Tillämpad matematik',
    'Tala' => 'Matematisk programmering',
    'Talaa' => 'Linjär programmering',
    'Talk' => 'Kryptering',
    'Tam' => 'Matematiska lekar',
    'Tas' => 'Matematisk simulering',
    'Tb' => 'Aritmetik',
    'Tb:k' => 'Aritmetikens historia',
    'Tc' => 'Algebra',
    'Tc:k' => 'Algebrans historia',
    'Tce' => 'Kombinatorik',
    'Tch' => 'Abstrakt algebra',
    'Tchb' => 'Ekvationsteori',
    'Tche' => 'Linjär och multilinjär algebra',
    'Tchet' => 'Topologisk och besläktad algebra',
    'Tchf' => 'Gruppteori',
    'Tchg' => 'Kroppar, ringar',
    'Tck' => 'Talteori',
    'Td' => 'Analys',
    'Td:k' => 'Analysens historia',
    'Tda' => 'Reella funktioner',
    'Tdb' => 'Serier',
    'Tdbf' => 'Fourieranalys och abstrakt harmonisk analys',
    'Tdc' => 'Integral- och differentialkalkyl',
    'Tdca' => 'Integralkalkyl och -ekvationer',
    'Tdcaa' => 'Integrationsteori och måtteori',
    'Tdcab' => 'Integralekvationer',
    'Tdcb' => 'Differentialkalkyl och -ekvationer',
    'Tdcbb' => 'Differentialekvationer',
    'Tdcbba' => 'Ordinära differentialekvationer',
    'Tdcbbb' => 'Partiella differentialekvationer',
    'Tdd' => 'Variationskalkyl och optimering',
    'Tde' => 'Potentialteori',
    'Tdf' => 'Finita differenser och funktionalekvationer',
    'Tdg' => 'Funktionalanalys',
    'Tdgb' => 'Operatorkalkyl',
    'Tdh' => 'Funktioner av komplexa variabler',
    'Tdö' => 'Speciella funktioner',
    'Te' => 'Geometri',
    'Te:k' => 'Geometrins historia',
    'Tea' => 'Euklidisk geometri',
    'Teaa' => 'Planimetri',
    'Teab' => 'Stereometri',
    'Teh' => 'Icke-euklidisk geometri',
    'Tej' => 'Trigonometri',
    'Tek' => 'Deskriptiv geometri',
    'Tel' => 'Analytisk geometri',
    'Tele' => 'Algebraisk geometri',
    'Telf' => 'Differential- och integralgeometri',
    'Tep' => 'Topologi',
    'Tepb' => 'Algebraisk topologi',
    'Tepc' => 'Analytisk topologi',
    'Tepd' => 'Global analys och analys på mångfalder',
    'Tf' => 'Mått, mål och vikt',
    'Tf:k' => 'Historia',
    'Tf:kc' => 'Sverige',
    'Th' => 'Sannolikhetskalkyl och matematisk statistik',
    'Th:k' => 'Sannolikhetskalkylens och den matematiska statistikens historia',
    'Tha' => 'Sannolikhetskalkyl',
    'Thab' => 'Stokastiska processer',
    'Thabb' => 'Markovprocesser',
    'Thac' => 'Spelteori och beslutsteori',
    'Thi' => 'Matematisk statistik',
    'Thib' => 'Stickprovsteori',
    'Thic' => 'Deskriptiv statistik och multivariat analys',
    'Thid' => 'Statistisk inferens',
    'Thie' => 'Tidsserieanalys',
    'Thj' => 'Försäkringsmatematik',
    'U' => 'Naturvetenskap',
    'U(x)' => 'Naturvetenskapliga lexikon',
    'U:b' => 'Naturvetenskaplig forskning och n naturvetenskapliga institutioner',
    'U:bf' => 'Institutioner och organisationer',
    'U:d' => 'Naturvetenskaplig teori, filosofi och metodlära',
    'U:dd' => 'Metodlära',
    'U:k' => 'Naturvetenskapens historia',
    'U:k.' => 'Särskilda perioder',
    'U:k.2' => 'Forntiden',
    'U:k.3' => 'Medeltiden',
    'U:k.4' => 'Nya tiden',
    'U:k.41' => '1500-1648',
    'U:k.43' => '1648-1789',
    'U:k.46' => '1815-1914',
    'U:k.5' => '1900-',
    'U:k.6' => '2000-',
    'U:ka' => 'Europa: allmänt',
    'U:kb' => 'Norden: allmänt',
    'U:kc' => 'Sverige',
    'U:kd' => 'Övriga Norden',
    'U:ke' => 'Brittiska öarna (Storbritannien)',
    'U:kf' => 'Mellaneuropa',
    'U:kg' => 'Nederländerna, Belgien och Luxemburg',
    'U:kh' => 'Schweiz',
    'U:ki' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'U:kj' => 'Frankrike och Monaco',
    'U:kk' => 'Spanien (inkl Andorra och Gibraltar)',
    'U:kl' => 'Portugal',
    'U:km' => 'Östeuropa',
    'U:ko' => 'Asien',
    'U:koa' => 'Främre Asien',
    'U:kob' => 'Främre Indien',
    'U:koe' => 'Östasien',
    'U:kq' => 'Amerika',
    'U:kr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'U:oa' => 'Naturvetenskapens sociologi',
    'U.02' => 'Allmän instrumentlära',
    'Ua' => 'Astronomi',
    'Ua(y)' => 'Astronomiska kartor, stjärnkataloger och bilderböcker',
    'Ua:bf' => 'Astronomiska institutioner',
    'Ua:k' => 'Astronomins historia',
    'Ua:k.' => 'Särskilda perioder',
    'Ua:k.2' => 'Forntiden',
    'Ua:k.21' => 'Egypten',
    'Ua:k.22' => 'Främre Asien',
    'Ua:k.23' => 'Antikens historia: allmänt',
    'Ua:k.24' => 'Den grekiska forntiden',
    'Ua:k.26' => 'Den romerska forntiden',
    'Ua:k.3' => 'Medeltiden',
    'Ua:k.4' => 'Nya tiden',
    'Ua:k.5' => '1900-',
    'Ua:k.6' => '2000-',
    'Ua:kc' => 'Sverige',
    'Ua:ke' => 'Brittiska öarna (Storbritannien)',
    'Ua:kf' => 'Mellaneuropa',
    'Ua:kg' => 'Nederländerna, Belgien och Luxemburg',
    'Ua:ki' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ua:kj' => 'Frankrike och Monaco',
    'Ua:kk' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ua:km' => 'Östeuropa',
    'Ua:ko' => 'Asien',
    'Ua:koa' => 'Främre Asien',
    'Ua:kob' => 'Främre Indien',
    'Ua:koe' => 'Östasien',
    'Ua:kq' => 'Amerika',
    'Ua.02' => 'Instrumentlära',
    'Uaa' => 'Universum',
    'Uaab' => 'Galaxer',
    'Uaaba' => 'Vintergatan',
    'Uaabb' => 'Magellanska molnen',
    'Uaac' => 'Stjärnhopar och associationer',
    'Uaaf' => 'Det interstellära mediet',
    'Uab' => 'Solsystemet',
    'Uaba' => 'Solen',
    'Uabb' => 'Planeter (utom Jorden)',
    'Uabba' => 'Merkurius',
    'Uabbb' => 'Venus',
    'Uabbc' => 'Mars',
    'Uabbd' => 'Småplaneter',
    'Uabbe' => 'Jupiter',
    'Uabbf' => 'Saturnus',
    'Uabbg' => 'Uranus, Neptunus och Pluto',
    'Uabd' => 'Jorden',
    'Uabe' => 'Månen',
    'Uabf' => 'Kometer',
    'Uabg' => 'Meteorer, zodiakljus och solvind',
    'Uac' => 'Stjärnor',
    'Uacc' => 'Dubbel- och multipelstjärnor',
    'Uacd' => 'Variabla stjärnor',
    'Uacda' => 'Eruptiva variabler',
    'Uae' => 'Praktisk astronomi',
    'Uaeo' => 'Optisk astronomi',
    'Uaer' => 'Radio- och radarastronomi',
    'Uaeö' => 'Övriga observationsmetoder',
    'Uaf' => 'Tidmätning',
    'Uafa' => 'Almanackor',
    'Uag' => 'Celest mekanik',
    'Uah' => 'Sfärisk astronomi och positionsastronomi',
    'Uai' => 'Astrofysik',
    'Uaia' => 'Relativistisk astrofysik',
    'Ub' => 'Geofysik',
    'Ub.02' => 'Instrumentlära: allmänt',
    'Uba' => 'Meteorologi',
    'Uba:bf' => 'Meterologiska institutioner',
    'Uba:k' => 'Metereologins historia',
    'Uba.02' => 'Instrumentlära',
    'Ubaa' => 'Atmosfärens sammansättning, struktur, mekanik',
    'Ubab' => 'Lufttemperatur och strålning',
    'Ubac' => 'Lufttryck',
    'Ubad' => 'Luftströmmar och vindsystem',
    'Ubae' => 'Stormar',
    'Ubag' => 'Luftfuktighet',
    'Ubah' => 'Speciella fenomen i atmosfären',
    'Ubai' => 'Praktisk meteorologi',
    'Ubaj' => 'Klimatologi',
    'Ubb' => 'Oceanografi och hydrologi',
    'Ubb:bf' => 'Oceanografiska och hydrologiska institutioner',
    'Ubba' => 'Oceanografi',
    'Ubba:bf' => 'Oceanografiska institutioner',
    'Ubba:k' => 'Oceanografins och hydrologins historia',
    'Ubba.02' => 'Instrumentlära',
    'Ubbaa' => 'Havsvattnets egenskaper',
    'Ubbab' => 'Maringeologi',
    'Ubbad' => 'Havsströmmar, vågor, tidvatten',
    'Ubbb' => 'Hydrologi',
    'Ubbb:k' => 'Hydrologins historia',
    'Ubbbc' => 'Sjöar',
    'Ubbbd' => 'Floder, älvar, åar',
    'Ubbbg' => 'Grundvatten',
    'Ubc' => 'Geodesi',
    'Ubc:k' => 'Geodesins historia',
    'Ubc.02' => 'Instrumentlära',
    'Ubcf' => 'Fotogrammetri',
    'Ubcg' => 'Gravitationsmätning',
    'Ubci' => 'Lantmäteri och fältmätning',
    'Ubd' => 'Jordmagnetism',
    'Ubd.02' => 'Instumentlära',
    'Ubdd' => 'Magnetosfär, jonosfär',
    'Ube' => 'Vulkaner och jordbävningar',
    'Ubea' => 'Vulkaner',
    'Ubeb' => 'Jordbävningar',
    'Uc' => 'Fysik och kemi',
    'Uc.bf' => 'Institutioner',
    'Uc:k' => 'Fysikens och kemins historia',
    'Uc:kc' => 'Sverige',
    'Ucb' => 'Mekanik',
    'Ucb:k' => 'Mekanikens historia',
    'Ucb.02' => 'Instrumentlära och mätteknik',
    'Ucba' => 'Fasta kroppars mekanik',
    'Ucbaa' => 'Stelkroppsmekanik',
    'Ucbab' => 'Deformerbara kroppars mekanik',
    'Ucbb' => 'Fluidmekanik',
    'Ucbba' => 'Vätskors mekanik',
    'Ucbbb' => 'Gasdynamik och aerodynamik',
    'Ucc' => 'Fysik',
    'Ucc.bf' => 'Särskilda fysikinstitutioner',
    'Ucc:k' => 'Fysikens historia',
    'Ucc:kc' => 'Sverige',
    'Ucc.02' => 'Instrumentlära och mätteknik',
    'Ucca' => 'Akustik',
    'Uccb' => 'Optik',
    'Uccc' => 'Värmelära',
    'Uccd' => 'Elektricitet och magnetism',
    'Uccdb' => 'Elektronik',
    'Uccdm' => 'Magnetism',
    'Ucce' => 'Teoretisk och matematisk fysik',
    'Uccea' => 'Relativitetsteori',
    'Ucceb' => 'Kvantfysik och fältteori',
    'Uccec' => 'Statistisk mekanik',
    'Ucced' => 'Fysikens matematiska metoder',
    'Uccg' => 'Fasta tillståndets fysik',
    'Uccgc' => 'Ytor, gränsytor, tunna skikt',
    'Ucch' => 'Vätskors fysik',
    'Ucci' => 'Gasfysik',
    'Uccj' => 'Plasmafysik',
    'Ucd' => 'Molekyl-, atom-, kärn- och partikelfysik',
    'Ucd.bf' => 'Särskilda institutioner',
    'Ucd.02' => 'Instrumentlära och mätteknik',
    'Ucdb' => 'Strålningsfysik: allmänt',
    'Ucdc' => 'Atom- och molekylfysik',
    'Ucdg' => 'Kärn- och partikelfysik',
    'Ucdga' => 'Partikelfysik',
    'Ucdgaa' => 'Leptoner',
    'Ucdgab' => 'Hadroner',
    'Ucdgc' => 'Atomkärnor och kärnstruktur',
    'Ucdge' => 'Kärnreaktioner',
    'Ucdgf' => 'Radioaktivitet',
    'Uce' => 'Kemi',
    'Uce.bf' => 'Kemiinstitutioner',
    'Uce:k' => 'Kemins historia',
    'Uce:kc' => 'Sverige',
    'Uce.02' => 'Instrumentlära och mätteknik',
    'Ucea' => 'Oorganisk kemi',
    'Uceaz' => 'Särskilda grundämnen',
    'Uceb' => 'Organisk kemi',
    'Uceba' => 'Synteser och reaktioner',
    'Ucebb' => 'Organiska föreningar: allmänt',
    'Ucebc' => 'Alifatiska och cykliska föreningar',
    'Ucebh' => 'Naturämnen',
    'Ucebha' => 'Steroider',
    'Ucebhc' => 'Proteiner',
    'Ucebhe' => 'Kolhydrater',
    'Ucebj' => 'Polymerer',
    'Ucee' => 'Teoretisk och fysikalisk kemi',
    'Uceea' => 'Aggregationstillståndens kemi',
    'Uceeb' => 'Molekyl- och atomstruktur',
    'Uceee' => 'Kvantkemi',
    'Uceef' => 'Fysikalisk kemi',
    'Uceefa' => 'Elektrokemi och lösningar',
    'Uceefc' => 'Fotokemi',
    'Uceefe' => 'Termokemi',
    'Uceeff' => 'Kärnkemi',
    'Uceefg' => 'Kemiska reaktioner och kemisk syntes',
    'Ucef' => 'Analytisk kemi',
    'Ucefa' => 'Optiska metoder',
    'Ucefb' => 'Termiska metoder',
    'Ucefc' => 'Elektromagnetiska metoder',
    'Ucefd' => 'Radiokemiska metoder',
    'Ucefe' => 'Kromatografi',
    'Ucefs' => 'Gasanalys',
    'Ud' => 'Geologi och paleontologi',
    'Ud:bf' => 'Geologiska och paleontologiska institutioner',
    'Ud:k' => 'Geologins och paleontologins historia',
    'Ud:kc' => 'Sverige',
    'Ud.02' => 'Instrumentlära',
    'Ud-' => 'Särskilda länder och områden',
    'Ud-a' => 'Europa: allmänt',
    'Ud-b' => 'Norden: allmänt',
    'Ud-c' => 'Sverige',
    'Ud-cz' => 'Särskilda orter',
    'Ud-d' => 'Övriga Norden',
    'Ud-da' => 'Danmark',
    'Ud-db' => 'Norge',
    'Ud-dc' => 'Island och Färöarna',
    'Ud-dd' => 'Finland',
    'Ud-e' => 'Brittiska öarna (Storbritannien)',
    'Ud-f' => 'Mellaneuropa',
    'Ud-fa' => 'Tyskland',
    'Ud-fb' => 'Österrike och Liechtenstein',
    'Ud-fc' => 'Ungern',
    'Ud-fd' => 'Tjeckien och Slovakien',
    'Ud-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ud-h' => 'Schweiz',
    'Ud-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ud-j' => 'Frankrike och Monaco',
    'Ud-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ud-l' => 'Portugal',
    'Ud-m' => 'Östeuropa',
    'Ud-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ud-mb' => 'Polen',
    'Ud-mc' => 'Estland, Lettland, Litauen',
    'Ud-n' => 'Balkanländerna',
    'Ud-o' => 'Asien',
    'Ud-oa' => 'Främre Asien',
    'Ud-ob' => 'Främre Indien',
    'Ud-oc' => 'Bortre Indien',
    'Ud-od' => 'Ostindiska öarna',
    'Ud-oe' => 'Östasien',
    'Ud-of' => 'Centralasien',
    'Ud-og' => 'Sibirien',
    'Ud-p' => 'Afrika',
    'Ud-pa' => 'Nordafrika utom Egypten',
    'Ud-pb' => 'Egypten och Sudan',
    'Ud-pc' => 'Västafrika',
    'Ud-pd' => 'Centralafrika',
    'Ud-pe' => 'Södra Afrika',
    'Ud-pf' => 'Östafrika',
    'Ud-pg' => 'Nordöstafrika',
    'Ud-q' => 'Amerika',
    'Ud-qa' => 'Förenta staterna',
    'Ud-qb' => 'Kanada',
    'Ud-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ud-qd' => 'Sydamerika',
    'Ud-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ud-ra' => 'Australien',
    'Ud-rb' => 'Nya Zeeland',
    'Ud-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ud-rd' => 'Nya Guinea',
    'Ud-s' => 'Polarländerna',
    'Ud-sa' => 'Arktis (Nordpolsområdet)',
    'Ud-sb' => 'Antarktis',
    'Uda' => 'Allmän och historisk geologi',
    'Udaa' => 'Endogena processer',
    'Udac' => 'Exogena processer',
    'Udacg' => 'Glaciologi',
    'Udad' => 'Geomorfologi',
    'Udada' => 'Kontinenter',
    'Udadb' => 'Öar, korallrev',
    'Udadc' => 'Berg, kullar',
    'Udadd' => 'Grottor, dalar',
    'Udade' => 'Slätter, öknar, stepper',
    'Udag' => 'Historisk geologi',
    'Udaga' => 'Prekambriska eran',
    'Udagb' => 'Paleozoiska eran',
    'Udagba' => 'Kambrium',
    'Udagbb' => 'Ordovicium',
    'Udagbc' => 'Silur',
    'Udagbd' => 'Devon',
    'Udagbe' => 'Karbon',
    'Udagbf' => 'Perm',
    'Udagf' => 'Mesozoiska eran',
    'Udagfa' => 'Trias',
    'Udagfb' => 'Jura',
    'Udagfc' => 'Krita',
    'Udagh' => 'Kenozoiska eran',
    'Udagha' => 'Tertiärtiden',
    'Udaghb' => 'Kvartärtiden',
    'Udb' => 'Paleontologi',
    'Udb.0' => 'Särskilda paleontologiska aspekter och delområden',
    'Udb.01' => 'Systematik',
    'Udb.02' => 'Preparering och restaurering',
    'Udb.03' => 'Anatomi',
    'Udb.05' => 'Paleoekologi',
    'Udb.08' => 'Fossila plankton',
    'Udba' => 'Paleobotanik (växter)',
    'Udbae' => 'Fröväxter (Fanerogamer)',
    'Udbah' => 'Kryptogamer',
    'Udbb' => 'Paleozoologi (djur)',
    'Udbbe' => 'Ryggradsdjur (Vertebrata)',
    'Udbbj' => 'Ryggradslösa djur (Evertebrata)',
    'Udt' => 'Geokemi',
    'Udu' => 'Mineralogi',
    'Udua' => 'Allmän kristallografi och mineralogi',
    'Udub' => 'Särskilda mineral',
    'Uduc' => 'Meteoriter',
    'Udv' => 'Petrologi',
    'Udva' => 'Eruptiva bergarter',
    'Udvd' => 'Metamorfa bergarter',
    'Udve' => 'Sedimentära bergarter',
    'Udx' => 'Ekonomisk geologi',
    'Udxb' => 'Förekomster av mineraliska brännmaterial',
    'Udxc' => 'Järnmalmsförekomster',
    'Udxd' => 'Förekomster av metaller och halvmetaller',
    'Udxdz' => 'Särskilda metaller och halvmetaller',
    'Udxe' => 'Förekomster av värdefull sten',
    'Udxez' => 'Särskilda stenarter',
    'Udxf' => 'Vattenförekomster',
    'Udxg' => 'Förekomster av värdefulla jordarter',
    'Udxgz' => 'Särskilda jordarter',
    'Udxh' => 'Förekomster av ädelstenar',
    'Udxhz' => 'Särskilda ädelstenar',
    'Udxö' => 'Förekomster av övriga värdefulla mineral',
    'Ue' => 'Biologi',
    'Ue:bf' => 'Biologisinstitutioner',
    'Ue:k' => 'Biologins historia',
    'Ue:kc' => 'Sverige',
    'Ue.0' => 'Särskilda biologiska aspekter och delområden',
    'Ue.02' => 'Biologisk teknik',
    'Ue.03' => 'Anatomi',
    'Ue.033' => 'Histologi',
    'Ue.034' => 'Embryologi',
    'Ue.039' => 'Cytologi (cellbiologi)',
    'Ue.0391' => 'Cellkärnan',
    'Ue.03912' => 'Kromosomer',
    'Ue.03916' => 'Nukleinsyror',
    'Ue.0393' => 'Cytoplasma',
    'Ue.0395' => 'Cellmembran och cellvägg',
    'Ue.0397' => 'Cellfysiologi',
    'Ue.04' => 'Fysiologi',
    'Ue.041' => 'Cirkulation',
    'Ue.042' => 'Respiration',
    'Ue.043' => 'Näringsfysiologi och ämnesomsättning',
    'Ue.044' => 'Sekretion och exkretion',
    'Ue.046' => 'Reproduktion',
    'Ue.047' => 'Rörelse, sinnen, kontrollprocesser',
    'Ue.048' => 'Biofysik och biokemi',
    'Ue.0481' => 'Biofysik',
    'Ue.0482' => 'Biokemi',
    'Ue.04821' => 'Vätskor, pigment, oorganiskt material',
    'Ue.04822' => 'Organiska föreningar',
    'Ue.04823' => 'Proteiner',
    'Ue.04824' => 'Enzymer',
    'Ue.04825' => 'Vitaminer',
    'Ue.04826' => 'Hormoner',
    'Ue.04827' => 'Lipider',
    'Ue.04828' => 'Kolhydrater',
    'Ue.049' => 'Molekylärbiologi',
    'Ue.05' => 'Ekologi',
    'Ue.051' => 'Autekologi',
    'Ue.052' => 'Synekologi',
    'Ue.055' => 'Ekosystem i vatten',
    'Ue.056' => 'Ekosystem på land',
    'Ue.07' => 'Biogeografi',
    'Ue.07-' => 'Särskilda länder och områden',
    'Ue.07-a' => 'Europa: allmänt',
    'Ue.07-b' => 'Norden: allmänt',
    'Ue.07-c' => 'Sverige',
    'Ue.07-cz' => 'Särskilda orter',
    'Ue.07-d' => 'Övriga Norden',
    'Ue.07-e' => 'Brittiska öarna (Storbritannien)',
    'Ue.07-f' => 'Mellaneuropa',
    'Ue.07-m' => 'Östeuropa',
    'Ue.07-o' => 'Asien',
    'Ue.07-p' => 'Afrika',
    'Ue.07-q' => 'Amerika',
    'Ue.07-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ue.07-s' => 'Polarländerna',
    'Ue.08' => 'Vattnens växt- och djurvärld',
    'Ue.082' => 'Havens växt- och djurvärld',
    'Ue.084' => 'Sötvattnens växt- och djurvärld',
    'Uea' => 'Utvecklingslära och genetik',
    'Ueaa' => 'Utvecklingslära',
    'Ueab' => 'Genetik',
    'Ueaba' => 'Genteknik',
    'Ueb' => 'Fysisk antropologi',
    'Ueba' => 'Den förhistoriska människan',
    'Uec' => 'Mikrobiologi',
    'Ueca' => 'Bakteriologi',
    'Uecb' => 'Virologi',
    'Ued' => 'Bioteknik',
    'Uf' => 'Botanik',
    'Uf:bf' => 'Botanikinstitutioner',
    'Uf:k' => 'Botanikens historia',
    'Uf:k.' => 'Särskilda perioder',
    'Uf:k.2' => 'Forntiden',
    'Uf:k.3' => 'Medeltiden',
    'Uf:k.4' => 'Nya tiden',
    'Uf:kc' => 'Sverige',
    'Uf.0' => 'Särskilda botaniska aspekter och delområden',
    'Uf.01' => 'Systematik',
    'Uf.02' => 'Växtkonservering, -preparering',
    'Uf.03' => 'Växtanatomi och -morfologi',
    'Uf.033' => 'Histologi',
    'Uf.034' => 'Embryologi',
    'Uf.035' => 'Palynologi',
    'Uf.039' => 'Cytologi',
    'Uf.04' => 'Växtfysiologi',
    'Uf.041' => 'Cirkulation',
    'Uf.042' => 'Respiration',
    'Uf.043' => 'Näringsfysiologi och ämnesomsättning',
    'Uf.044' => 'Sekretion och exkretion',
    'Uf.045' => 'Genetik',
    'Uf.046' => 'Reproduktion',
    'Uf.047' => 'Rörelse och kontrollprocesser',
    'Uf.048' => 'Biofysik och biokemi',
    'Uf.05' => 'Växtekologi',
    'Uf.051' => 'Autekologi',
    'Uf.052' => 'Synekologi',
    'Uf.055' => 'Ekosystem i vatten',
    'Uf.056' => 'Ekosystem på land',
    'Uf.06' => 'Växtpatologi',
    'Uf.07' => 'Växtgeografi',
    'Uf.07-' => 'Allmänt: särskilda länder och områden',
    'Uf.07-a' => 'Europa: allmänt',
    'Uf.07-b' => 'Norden: allmänt',
    'Uf.07-c' => 'Sverige',
    'Uf.07-cz' => 'Särskilda orter',
    'Uf.07-d' => 'Övriga Norden',
    'Uf.07-da' => 'Danmark',
    'Uf.07-db' => 'Norge',
    'Uf.07-dc' => 'Island och Färöarna',
    'Uf.07-dd' => 'Finland',
    'Uf.07-e' => 'Brittiska öarna (Storbritannien)',
    'Uf.07-f' => 'Mellaneuropa',
    'Uf.07-fa' => 'Tyskland',
    'Uf.07-fb' => 'Österrike och Liechtenstein',
    'Uf.07-fc' => 'Ungern',
    'Uf.07-fd' => 'Tjeckien och Slovakien',
    'Uf.07-g' => 'Nederländerna, Belgien och Luxemburg',
    'Uf.07-h' => 'Schweiz',
    'Uf.07-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Uf.07-j' => 'Frankrike och Monaco',
    'Uf.07-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Uf.07-l' => 'Portugal',
    'Uf.07-m' => 'Östeuropa',
    'Uf.07-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Uf.07-mb' => 'Polen',
    'Uf.07-mc' => 'Estland, Lettland, Litauen',
    'Uf.07-n' => 'Balkanländerna',
    'Uf.07-na' => 'Rumänien',
    'Uf.07-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Uf.07-nc' => 'Bulgarien',
    'Uf.07-nd' => 'Grekland',
    'Uf.07-nf' => 'Albanien',
    'Uf.07-o' => 'Asien',
    'Uf.07-oa' => 'Främre Asien',
    'Uf.07-ob' => 'Främre Indien',
    'Uf.07-oc' => 'Bortre Indien',
    'Uf.07-od' => 'Ostindiska öarna',
    'Uf.07-oe' => 'Östasien',
    'Uf.07-oea' => 'Kina',
    'Uf.07-oec' => 'Japan',
    'Uf.07-of' => 'Centralasien',
    'Uf.07-og' => 'Sibirien',
    'Uf.07-p' => 'Afrika',
    'Uf.07-pa' => 'Nordafrika utom Egypten',
    'Uf.07-pb' => 'Egypten och Sudan',
    'Uf.07-pc' => 'Västafrika',
    'Uf.07-pd' => 'Centralafrika',
    'Uf.07-pe' => 'Södra Afrika',
    'Uf.07-pf' => 'Östafrika',
    'Uf.07-pg' => 'Nordöstafrika',
    'Uf.07-q' => 'Amerika',
    'Uf.07-qa' => 'Förenta staterna',
    'Uf.07-qb' => 'Kanada',
    'Uf.07-qc' => 'Mexiko, Centralamerika och Västindien',
    'Uf.07-qd' => 'Sydamerika',
    'Uf.07-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Uf.07-ra' => 'Australien',
    'Uf.07-rb' => 'Nya Zeeland',
    'Uf.07-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Uf.07-rd' => 'Nya Guinea',
    'Uf.07-s' => 'Polarländerna',
    'Uf.07-sa' => 'Arktis (Nordpolsområdet)',
    'Uf.07-sb' => 'Antarktis',
    'Uf.08' => 'Vattnens växtvärld',
    'Uf.082' => 'Havens växtvärls',
    'Uf.084' => 'Sötvattnens växtvärld',
    'Ufa' => 'Särskilda grupper av växter',
    'Ufaa' => 'Vedartade växter',
    'Ufab' => 'Nyttoväxter',
    'Ufac' => 'Giftiga växter',
    'Ufe' => 'Fröväxter (Fanerogamer): allmänt',
    'Uff' => 'Fanerogamer: gömfröiga (Magnoliophytina)',
    'Uffa' => 'Tvåhjärtbladiga (Magnoliopsida)',
    'Uffaa' => 'Kaktusväxter (Cactaceae)',
    'Uffab' => 'Korsblommiga (Brassicaceae)',
    'Uffac' => 'Rosväxter (Rosaceae)',
    'Uffad' => 'Ärtväxter (Fabaceae)',
    'Uffae' => 'Flockblommiga (Apiaceae)',
    'Uffaf' => 'Korgblommiga (Asteraceae)',
    'Uffag' => 'Potatisväxter (Solanaceae)',
    'Uffah' => 'Kransblommiga (Lamiaceae)',
    'Uffaö' => 'Övriga tvåhjärtbladiga',
    'Uffaöz' => 'Särskilda tvåhjärtbladiga familjer',
    'Uffb' => 'Enhjärtbladiga (Liliopsida)',
    'Uffba' => 'Palmer (Palmae)',
    'Uffbb' => 'Tågväxter (Juncaceae) och halvgräs (Cyperaceae)',
    'Uffbc' => 'Gräs (Poaceae)',
    'Uffbd' => 'Liljeväxter (Liliaceae)',
    'Uffbe' => 'Orkidéer (Orchidaceae)',
    'Uffbö' => 'Övriga enhjärtbladiga',
    'Uffböz' => 'Särskilda enhjärtbladiga familjer',
    'Ufg' => 'Fanerogamer: nakenfröiga (Pinophytina)',
    'Ufga' => 'Barrväxter (Pinopsida)',
    'Ufh' => 'Kryptogamer',
    'Ufha' => 'Ormbunksväxter (Pteridophyta)',
    'Ufhb' => 'Mossor (Bryophyta)',
    'Ufhba' => 'Bladmossor (Bryopsida)',
    'Ufhbb' => 'Levermossor (Hepaticopsida)',
    'Ufhc' => 'Alger (Algae)',
    'Ufhca' => 'Grönalger (Chlorophycota)',
    'Ufhcb' => 'Euglenor (Euglenophyceae) och Dinoflagellater (Dinophyceae)',
    'Ufhcc' => 'Brunalger (Phaeophyceae)',
    'Ufhcd' => 'Rödalger (Rhodophyceae)',
    'Ufhce' => 'Guldalger (Chrysophyceae), gulgrönalger (Xantophyceae) och kiselalger (Bacillariophyceae)',
    'Ufhcf' => 'Blågrönalger (Cyanophycota)',
    'Ufhd' => 'Lavar (Lichenes)',
    'Ufhe' => 'Svampar (Fungi)',
    'Ufhea' => 'Giftiga svampar',
    'Ufhed' => 'Basidiesvampar (Basidiomycota)',
    'Ufhee' => 'Sporsäckssvampar (Ascomycota)',
    'Ufhef' => 'Ofullständiga svampar (Fungi imperfecti)',
    'Ufheg' => 'Algsvampar (Phycomycetes)',
    'Ufheh' => 'Slemsvampar (Mycetozoa)',
    'Ug' => 'Zoologi',
    'Ug:bf' => 'Zoologiinstitutioner',
    'Ug:k' => 'Zoologins historia',
    'Ug:kc' => 'Sverige',
    'Ug.0' => 'Särskilda zoologiska aspekter och delområden',
    'Ug.01' => 'Systematik',
    'Ug.02' => 'Djurkonservering, -preparering',
    'Ug.03' => 'Djuranatomi och -morfologi',
    'Ug.033' => 'Histologi',
    'Ug.034' => 'Embryologi',
    'Ug.039' => 'Cytologi',
    'Ug.04' => 'Djurfysiologi',
    'Ug.041' => 'Cirkulation',
    'Ug.042' => 'Respiration',
    'Ug.043' => 'Näringsfysiologi och ämnesomsättning',
    'Ug.044' => 'Sekretion och exkretion',
    'Ug.045' => 'Genetik',
    'Ug.046' => 'Reproduktion',
    'Ug.047' => 'Rörelse, sinnen, kontrollprocesser',
    'Ug.048' => 'Biofysik och biokemi',
    'Ug.05' => 'Djurekologi och -psykologi',
    'Ug.051' => 'Autekologi',
    'Ug.052' => 'Synekologi',
    'Ug.055' => 'Ekosystem i vatten',
    'Ug.056' => 'Ekosystem på land',
    'Ug.06' => 'Djurpatologi',
    'Ug.07' => 'Djurgeografi',
    'Ug.07-' => 'Allmänt: särskilda länder och områden',
    'Ug.07-a' => 'Europa: allmänt',
    'Ug.07-b' => 'Norden: allmänt',
    'Ug.07-c' => 'Sverige',
    'Ug.07-cz' => 'Särskilda orter',
    'Ug.07-d' => 'Övriga Norden',
    'Ug.07-da' => 'Danmark',
    'Ug.07-db' => 'Norge',
    'Ug.07-dc' => 'Island och Färöarna',
    'Ug.07-dd' => 'Finland',
    'Ug.07-e' => 'Brittiska öarna (Storbritannien)',
    'Ug.07-f' => 'Mellaneuropa',
    'Ug.07-fa' => 'Tyskland',
    'Ug.07-fb' => 'Österrike och Liechtenstein',
    'Ug.07-fc' => 'Ungern',
    'Ug.07-fd' => 'Tjeckien och Slovakien',
    'Ug.07-g' => 'Nederländerna, Belgien och Luxemburg',
    'Ug.07-h' => 'Schweiz',
    'Ug.07-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Ug.07-j' => 'Frankrike och Monaco',
    'Ug.07-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Ug.07-m' => 'Östeuropa',
    'Ug.07-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ug.07-mb' => 'Polen',
    'Ug.07-mc' => 'Estland, Lettland, Litauen',
    'Ug.07-n' => 'Balkanländerna',
    'Ug.07-o' => 'Asien',
    'Ug.07-oa' => 'Främre Asien',
    'Ug.07-ob' => 'Främre Indien',
    'Ug.07-oc' => 'Bortre Indien',
    'Ug.07-od' => 'Ostindiska öarna',
    'Ug.07-oe' => 'Östasien',
    'Ug.07-p' => 'Afrika',
    'Ug.07-pa' => 'Nordafrika utom Egypten',
    'Ug.07-pb' => 'Egypten och Sudan',
    'Ug.07-pc' => 'Västafrika',
    'Ug.07-pd' => 'Centralafrika',
    'Ug.07-pe' => 'Södra Afrika',
    'Ug.07-pf' => 'Östafrika',
    'Ug.07-pg' => 'Nordöstafrika',
    'Ug.07-q' => 'Amerika',
    'Ug.07-qa' => 'Förenta staterna',
    'Ug.07-qb' => 'Kanada',
    'Ug.07-qc' => 'Mexiko, Centralamerika och Västindien',
    'Ug.07-qd' => 'Sydamerika',
    'Ug.07-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Ug.07-ra' => 'Australien',
    'Ug.07-rb' => 'Nya Zeeland',
    'Ug.07-rc' => 'Melanesien, Polynesien och Mikronesien',
    'Ug.07-s' => 'Polarländerna',
    'Ug.07-sa' => 'Arktis (Nordpolsområdet)',
    'Ug.07-sb' => 'Antarktis',
    'Ug.08' => 'Vattnens djurvärld',
    'Uge' => 'Ryggradsdjur (Vertebrata)',
    'Ugf' => 'Däggdjur (Mammalia)',
    'Ugfa' => 'Primater (Primates)',
    'Ugfb' => 'Rovdjur (Carnivora)',
    'Ugfbb' => 'Säldjur (Pinnipedia)',
    'Ugfc' => 'Partåiga och uddatåiga hovdjur (Artiodactyla och Perissodactyla)',
    'Ugfd' => 'Elefantdjur (Proboscidea) och hyraxar (Hyracoidea)',
    'Ugfe' => 'Valar (Cetacea)',
    'Ugff' => 'Fladdermöss (Chiroptera), pälsfladdrare (Dermoptera) och insektätare (Insectivora)',
    'Ugfg' => 'Gnagare (Rodentia) och hardjur (Lagomorpha)',
    'Ugfh' => 'Myrkottar (Pholidota) och tandfattiga (Edentata)',
    'Ugfi' => 'Pungdjur (Marsupialia)',
    'Ugfj' => 'Kloakdjur (Monotremata)',
    'Ugfk' => 'Sirendjur (Sirenia)',
    'Ugg' => 'Fåglar (Aves)',
    'Ugga' => 'Tättingar (Passeriformes)',
    'Uggb' => 'Hackspettar (Piciformes)',
    'Uggc' => 'Musfåglar (Coliiformes), trogoner (Trogoniformes) och blåkråkefåglar (Coraciiformes)',
    'Uggd' => 'Seglare (Apodiformes)',
    'Ugge' => 'Skärrfåglar (Caprimulgiformes) och ugglor (Strigiformes)',
    'Uggf' => 'Gökfåglar (Cuculiformes)',
    'Uggg' => 'Papegojfåglar (Psittaciformes)',
    'Uggh' => 'Duvfåglar (Columbiformes)',
    'Uggi' => 'Vadarfåglar (Charadriiformes)',
    'Uggj' => 'Tran- och rallfåglar (Gruiformes)',
    'Uggk' => 'Hönsfåglar (Galliformes)',
    'Uggl' => 'Rovfåglar (Falconiformes)',
    'Uggm' => 'Andfåglar (Anseriformes)',
    'Uggn' => 'Storkfåglar (Ciconiiformes)',
    'Uggo' => 'Pelikanfåglar (Pelecaniformes) och stormfåglar (Procellariiformes)',
    'Uggp' => 'Doppingar (Podicipediformes) och lommar (Gaviiformes)',
    'Uggr' => 'Stubbstjärthöns (Tinamiformes) och ratiter (Ratitae)',
    'Uggs' => 'Pingviner (Sphenisciformes)',
    'Uggt' => 'Flamingoer (Phoenicopteriformes)',
    'Ugh' => 'Kräldjur (Reptilia) och groddjur (Amphibia)',
    'Ugha' => 'Kräldjur (Reptilia): allmänt',
    'Ughb' => 'Krokodiler (Crocodylia)',
    'Ughc' => 'Sköldpaddor (Chelonia)',
    'Ughd' => 'Ormar (Serpentes)',
    'Ughe' => 'Ödlor (Lacertilia) och bryggödlor (Rhynchocephalia)',
    'Ughf' => 'Groddjur (Amphibia): allmänt',
    'Ughg' => 'Stjärtgroddjur (Urodela) och maskgroddjur (Gymnophiona)',
    'Ughh' => 'Stjärtlösa groddjur (Anura)',
    'Ugi' => 'Fiskar (Pisces) och rundmunnar (Cyclostomi)',
    'Ugia' => 'Benfiskar (Teleostei)',
    'Ugib' => 'Benganoider (Holostei), broskganoider (Chondrostei) och lungfiskar (Dipnoi)',
    'Ugic' => 'Hajfiskar (Elasmobranchii)',
    'Ugid' => 'Fengäddor (Polypteridae) och kvastfeningar (Crossopterygii)',
    'Ugie' => 'Rundmunnar (Cyclostomi)',
    'Ugj' => 'Ryggradslösa djur (Evertebrata)',
    'Ugja' => 'Deuterostomia (utom Vertebrata)',
    'Ugjaa' => 'Cephalochordata',
    'Ugjab' => 'Pilmaskar (Chaetognatha) och skäggmaskar(Pogonophora)',
    'Ugjac' => 'Tagghudingar (Echinodermata)',
    'Ugjad' => 'Hemichordata',
    'Ugjb' => 'Insekter (Insecta)',
    'Ugjba' => 'Steklar (Hymenoptera)',
    'Ugjbb' => 'Fjärilar (Lepidoptera), nattsländor (Trichoptera) och näbbsländor (Mecoptera)',
    'Ugjbc' => 'Tvåvingar (Diptera) och loppor (Siphonaptera)',
    'Ugjbd' => 'Skalbaggar (Coleoptera) och vridvingar (Strepsiptera)',
    'Ugjbe' => 'Nätvingar (Neuroptera)',
    'Ugjbf' => 'Halvvingar (Hemiptera)',
    'Ugjbg' => 'Tripsar (Thysanoptera)',
    'Ugjbh' => 'Löss (Phthiraptera) och stövsländor (Psocoptera)',
    'Ugjbi' => 'Hopprätvingar (Orthoptera)',
    'Ugjbj' => 'Bäcksländor (Plecoptera) och spinnfotingar (Embioptera)',
    'Ugjbk' => 'Kackerlackor och bönsyrsor (Dictyoptera)',
    'Ugjbl' => 'Trollsländor (Odonata) och dagsländor (Ephemeroptera)',
    'Ugjbm' => 'Primärt vinglösa (Apterygota)',
    'Ugjc' => 'Tusenfotingar (Myriapoda), Pararthropoda och spindeldjur (Chelicerata)',
    'Ugjca' => 'Tusenfotingar (Myriapoda)',
    'Ugjcb' => 'Pararthropoda',
    'Ugjcc' => 'Spindeldjur (Chelicerata)',
    'Ugjd' => 'Kräftdjur (Crustacea)',
    'Ugjda' => 'Sköldkräftor (Eucarida)',
    'Ugjdb' => 'Övriga högre kräftdjur (Malacostraca)',
    'Ugjdc' => 'Rankfotingar (Cirripedia) och karplöss (Branchiura)',
    'Ugjdd' => 'Hoppkräftor (Copepoda) och Mystacocarida',
    'Ugjde' => 'Musselkräftor (Ostracoda)',
    'Ugjdf' => 'Bladfotingar (Phyllopoda), Anostraca och Cephalocarida',
    'Ugje' => 'Blötdjur (Mollusca)',
    'Ugjea' => 'Bläckfiskar (Cephalopoda)',
    'Ugjeb' => 'Snäckor (Gastropoda) och elefanttandsnäckor (Scaphopoda)',
    'Ugjec' => 'Urmollusker (Monoplacophora), ledsnäckor (Polyplacophora)och maskmollusker (Solenogastres)',
    'Ugjed' => 'Musslor (Bivalvia)',
    'Ugjf' => 'Armfotingar (Brachiopoda), mossdjur (Bryozoa) och Phoronida',
    'Ugjg' => 'Maskar (Vermes)',
    'Ugjgb' => 'Havsborstmaskar (Polychaeta)',
    'Ugjgc' => 'Glattmaskar (Oligochaeta)',
    'Ugjgd' => 'Iglar (Hirudinea)',
    'Ugjge' => 'Övriga ringmaskar (Annelida)',
    'Ugjgf' => 'Trådmaskar (Nematoda) och tagelmaskar (Nematomorpha)',
    'Ugjgg' => 'Hjuldjur (Rotatoria)',
    'Ugjgh' => 'Övriga Aschelminthes samt Entoprocta',
    'Ugjgi' => 'Plattmaskar (Platyhelminthes) och slemmaskar (Nemertini)',
    'Ugji' => 'Nässeldjur (Cnidaria), kammaneter (Ctenophora) och mesozoer (Mesozoa)',
    'Ugjj' => 'Svampdjur (Porifera)',
    'Ugjk' => 'Protozoer (Protozoa)',
    'Ugjka' => 'Infusionsdjur (Ciliata)',
    'Ugjkb' => 'Gisseldjur (Flagellata)',
    'Ugjkc' => 'Rotfotingar (Rhizopoda)',
    'Ugjkd' => 'Spordjur (Sporozoa)',
    'Uh' => 'Miljöfrågor och naturskydd',
    'Uh:bf' => 'Miljö- och naturskyddsinstitutioner',
    'Uh:oe' => 'Miljörätt',
    'Uh-' => 'Allmänt: särskilda länder och områden',
    'Uh-a' => 'Europa: allmänt',
    'Uh-ae' => 'Europeiska unionen (EU)',
    'Uh-b' => 'Norden: allmänt',
    'Uh-c' => 'Sverige',
    'Uh-c:oe' => 'Miljörätt',
    'Uh-cz' => 'Särskilda orter',
    'Uh-d' => 'Övriga Norden',
    'Uh-da' => 'Danmark',
    'Uh-db' => 'Norge',
    'Uh-dc' => 'Island och Färöarna',
    'Uh-dd' => 'Finland',
    'Uh-e' => 'Brittiska öarna (Storbritannien)',
    'Uh-f' => 'Mellaneuropa',
    'Uh-fa' => 'Tyskland',
    'Uh-fb' => 'Österrike och Liechtenstein',
    'Uh-fc' => 'Ungern',
    'Uh-fd' => 'Tjeckien och Slovakien',
    'Uh-g' => 'Nederländerna, Belgien och Luxemburg',
    'Uh-h' => 'Schweiz',
    'Uh-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Uh-j' => 'Frankrike och Monaco',
    'Uh-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Uh-l' => 'Portugal',
    'Uh-m' => 'Östeuropa',
    'Uh-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Uh-mb' => 'Polen',
    'Uh-mc' => 'Estland, Lettland, Litauen',
    'Uh-n' => 'Balkanländerna',
    'Uh-o' => 'Asien',
    'Uh-oa' => 'Främre Asien',
    'Uh-ob' => 'Främre Indien',
    'Uh-oc' => 'Bortre Indien',
    'Uh-od' => 'Ostindiska öarna',
    'Uh-oe' => 'Östasien',
    'Uh-oea' => 'Kina',
    'Uh-oec' => 'Japan',
    'Uh-of' => 'Centralasien',
    'Uh-og' => 'Sibirien',
    'Uh-p' => 'Afrika',
    'Uh-q' => 'Amerika',
    'Uh-qa' => 'Förenta staterna',
    'Uh-qb' => 'Kanada',
    'Uh-qc' => 'Mexiko, Centralamerika och Västindien',
    'Uh-qd' => 'Sydamerika',
    'Uh-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Uh-s' => 'Polarländerna',
    'Uh-sa' => 'Arktis (Nordpolsområdet)',
    'Uh-sb' => 'Antarktis',
    'Uha' => 'Miljöekonomi',
    'Uhb' => 'Humanekologi',
    'Uhc' => 'Föroreningsfrågor',
    'Uhc-' => 'Särskilda länder och områden',
    'Uhc-a' => 'Europa: allmänt',
    'Uhc-ae' => 'Europeiska unionen (EU)',
    'Uhc-b' => 'Norden: allmänt',
    'Uhc-c' => 'Sverige',
    'Uhc-cz' => 'Särskilda orter',
    'Uhc-d' => 'Övriga Norden',
    'Uhc-f' => 'Mellaneuropa',
    'Uhc-m' => 'Östeuropa',
    'Uhc-o' => 'Asien',
    'Uhc-p' => 'Afrika',
    'Uhc-q' => 'Amerika',
    'Uhc-s' => 'Polarländerna',
    'Uhca' => 'Luftföroreningar',
    'Uhcb' => 'Vattenföroreningar',
    'Uhcc' => 'Markföroreningar',
    'Uhcd' => 'Förorenande ämnen',
    'Uhch' => 'Föroreningskällor',
    'Uhe' => 'Naturskydd',
    'Uhe-' => 'Särskilda länder och områden',
    'Uhe-a' => 'Europa: allmänt',
    'Uhe-ae' => 'Europeiska unionen (EU)',
    'Uhe-b' => 'Norden: allmänt',
    'Uhe-c' => 'Sverige',
    'Uhe-cz' => 'Särskilda orter',
    'Uhe-d' => 'Övriga Norden',
    'Uhe-e' => 'Brittiska öarna (Storbritannien)',
    'Uhe-f' => 'Mellaneuropa',
    'Uhe-m' => 'Östeuropa',
    'Uhe-o' => 'Asien',
    'Uhe-p' => 'Afrika',
    'Uhe-q' => 'Amerika',
    'Uhe-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Uhe-s' => 'Polarländerna',
    'Uhf' => 'Naturskydd - växter',
    'Uhg' => 'Naturskydd - djur',
    'V' => 'Medicin',
    'V(x)' => 'Medicinska lexikon',
    'V:b' => 'Medicinsk forskning och medicinska institutioner',
    'V:bf' => 'Organisationer och institutioner',
    'V:d' => 'Medicinens filosofi och metodlära',
    'V:dd' => 'Metodlära',
    'V:k' => 'Medicinhistoria',
    'V:k.' => 'Särskilda perioder',
    'V:k.2' => 'Forntiden',
    'V:k.21' => 'Egypten',
    'V:k.22' => 'Främre Asien',
    'V:k.23' => 'Antikens historia: allmänt',
    'V:k.24' => 'Den grekiska forntiden',
    'V:K.241' => 'Före ca 500 f Kr',
    'V:k.243' => 'Den klassiska tiden ca 500 - 336 f Kr',
    'V:k.245' => 'Den hellenistiska tiden ca 336 - 31 f Kr',
    'V:k.246' => 'Romartiden 31 f Kr - 476 e Kr',
    'V:k.26' => 'Den romerska forntiden',
    'V:k.264' => 'Kejsartiden 31 f Kr - 476 e Kr',
    'V:k.269' => 'Romerska rikets provinser',
    'V:k.3' => 'Medeltiden',
    'V:k.31' => 'Bysantinska riket 395-1453',
    'V:k.32' => 'Arabiska väldet 622-1517',
    'V:k.33' => 'Äldre medeltiden ca 476 - 1050',
    'V:k.35' => 'Högmedeltiden ca 1050 - 1300',
    'V:k.38' => 'Senmedeltiden ca 1300 - 1500',
    'V:k.4' => 'Nya tiden',
    'V:k.41' => '1500-1648',
    'V:k.43' => '1648-1789',
    'V:k.46' => '1815-1914',
    'V:k.5' => '1900-',
    'V:k.6' => '2000-',
    'V:ka' => 'Europa: allmänt',
    'V:kb' => 'Norden: allmänt',
    'V:kc' => 'Sverige',
    'V:kd' => 'Övriga Norden',
    'V:kda' => 'Danmark',
    'V:kdb' => 'Norge',
    'V:kdc' => 'Island och Färöarna',
    'V:kdd' => 'Finland',
    'V:ke' => 'Brittiska öarna (Storbritannien)',
    'V:kf' => 'Mellaneuropa',
    'V:kfa' => 'Tyskland',
    'V:kfb' => 'Österrike och Liechtenstein',
    'V:kfc' => 'Ungern',
    'V:kfd' => 'Tjeckien och Slovakien',
    'V:kg' => 'Nederländerna, Belgien och Luxemburg',
    'V:kh' => 'Schweiz',
    'V:ki' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'V:kj' => 'Frankrike och Monaco',
    'V:kk' => 'Spanien (inkl Andorra och Gibraltar)',
    'V:km' => 'Östeuropa',
    'V:kn' => 'Balkanländerna',
    'V:ko' => 'Asien',
    'V:koa' => 'Främre Asien',
    'V:kob' => 'Främre Indien',
    'V:kod' => 'Ostindiska öarna',
    'V:koe' => 'Östasien',
    'V:kof' => 'Centralasien',
    'V:kp' => 'Afrika',
    'V:kq' => 'Amerika',
    'V:kqa' => 'Förenta staterna',
    'V:kqb' => 'Kanada',
    'V:kqc' => 'Mexiko, Centralamerika och Västindien',
    'V:kqd' => 'Sydamerika',
    'V:kr' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'V:oa' => 'Allmänt: medicinsk sociologi',
    'V:oe' => 'Allmänt: medicinlagstiftning',
    'V:oi' => 'Allmänt: medicinstatistik',
    'Va' => 'Medicinsk genetik, mikrobiologi, immunologi m fl icke-kliniska discipliner',
    'Vaa' => 'Medicinsk genetik',
    'Vaa:k' => 'Historia',
    'Vaa:kc' => 'Sverige',
    'Vab' => 'Medicinsk mikrobiologi',
    'Vaba' => 'Medicinsk bakteriologi',
    'Vabb' => 'Medicinsk virologi',
    'Vac' => 'Medicinsk parasitologi',
    'Vad' => 'Immunologi',
    'Vae' => 'Toxikologi',
    'Vaf' => 'Experimentell patologi',
    'Vb' => 'Anatomi',
    'Vb:k' => 'Anatomins historia',
    'Vbb' => 'Histologi, embryologi, teratologi',
    'Vbba' => 'Histologi (vävnadslära)',
    'Vbbb' => 'Embryologi (fosterutvecklingslära)',
    'Vbbc' => 'Teratologi (missbildningslära)',
    'Vc' => 'Medicinsk fysiologi, biofysik och kemi',
    'Vca' => 'Medicinsk fysiologi',
    'Vcb' => 'Medicinsk biofysik och kemi',
    'Vcba' => 'Medicinsk biofysik',
    'Vcbb' => 'Medicinsk kemi',
    'Vcbba' => 'Klinisk kemi',
    'Vcc' => 'Näringslära (nutrition)',
    'Vd' => 'Farmakologi',
    'Vd:k' => 'Farmakologins historia',
    'Vd:kc' => 'Sverige',
    'Vd:oe' => 'Läkemedelslagstiftning',
    'Vdd' => 'Farmaci och farmakognosi (apoteksvetenskap och drogkännedom)',
    'Vde' => 'Farmakodynamik och farmakokinetik (läkemedelseffektlära och läkemedelsomsättningslära)',
    'Vdf' => 'Medicinalväxter',
    'Vdf:k' => 'Medicinalväxternas historia',
    'Vdp' => 'Apoteksväsen',
    'Vdp-c' => 'Sverige',
    'Ve' => 'Allmän medicin',
    'Vea' => 'Diagnostiska metoder (sjukdomsbestämmande metoder)',
    'Veac' => 'Klinisk patologi',
    'Veag' => 'Klinisk cytologi',
    'Veah' => 'Diagnostisk radiologi',
    'Veal' => 'Ultraljudsdiagnostik',
    'Veb' => 'Särskilda sjukdomar',
    'Veba' => 'Infektionssjukdomar',
    'Veba:k' => 'Historia',
    'Veba:kc' => 'Sverige',
    'Vebaa' => 'Sexuellt överförda sjukdomar',
    'Vebb' => 'Bristsjukdomar',
    'Vebe' => 'Ämnesomsättningssjukdomar',
    'Vebg' => 'Förgiftningssjukdomar',
    'Vebl' => 'Psykosomatiska sjukdomar',
    'Vebr' => 'Immunologiska sjukdomar',
    'Ved' => 'Blodet och de blodbildande organen (hematologi)',
    'Ved:k' => 'Hematologins historia',
    'Vef' => 'Nervsystemet (neurologi)',
    'Vef:k' => 'Neurologins historia',
    'Veh' => 'Cirkulationsorganen (kardiologi och angiologi)',
    'Veh:k' => 'Kardiologins och angiologins historia',
    'Vei' => 'Andningsorganen (pneumologi)',
    'Vei:k' => 'Pneumologins historia',
    'Vej' => 'Matspjälkningsorganen (medicinsk gastroenterologi)',
    'Vej:k' => 'Gastroenterologins historia',
    'Vek' => 'Njurarna och urinvägarna (nefrologi och urologi)',
    'Vek:k' => 'Nefrologins och urologins historia',
    'Vem' => 'Huden (dermatologi)',
    'Vem:k' => 'Dermatologins historia',
    'Ven' => 'Muskler och skelett (myologi och osteologi)',
    'Ven:k' => 'Myologins och osteologins historia',
    'Veo' => 'Endokrina organ (endokrinologi)',
    'Veo:k' => 'Endokrinologins historia',
    'Veod' => 'Diabetes',
    'Vep' => 'Onkologi (läran om tumörer)',
    'Vep:b' => 'Tumörforskning, institutioner',
    'Vep:k' => 'Onkologins historia',
    'Vepa' => 'Radioterapi',
    'Vepb' => 'Kemoterapi',
    'Vf' => 'Kirurgi och anestesi',
    'Vf:k' => 'Kirurgins och anestesins historia',
    'Vfd' => 'Anestesi',
    'Vfe' => 'Plastikkirurgi och rekonstruktiv kirurgi',
    'Vff' => 'Transplantation',
    'Vfg' => 'Traumatologi',
    'Vfh' => 'Barnkirurgi',
    'Vfn' => 'Kirurgi: särskilda organ, organsystem och kroppsdelar',
    'Vfnf' => 'Neurokirurgi',
    'Vfnh' => 'Hjärt- och kärlkirurgi',
    'Vfni' => 'Thoraxkirurgi',
    'Vfnj' => 'Kirurgisk gastroenterologi',
    'Vfnk' => 'Urologi',
    'Vfno' => 'Kirurgisk endokrinologi',
    'Vfo' => 'Ortopedi',
    'Vg' => 'Gynekologi och andrologi',
    'Vg:k' => 'Gynekologins och andrologins historia',
    'Vg:oe' => 'Gynekologi- och andrologilagstiftning',
    'Vga' => 'Gynekologi och obstetrik',
    'Vgaa' => 'Gynekologi',
    'Vgaab' => 'Bröstet',
    'Vgab' => 'Obstetrik (förlossningslära)',
    'Vgaba' => 'Graviditet',
    'Vgb' => 'Andrologi',
    'Vh' => 'Pediatrik',
    'Vh:k' => 'Pediatrikens historia',
    'Vha' => 'Neonatalmedicin',
    'Vhb' => 'Barnets fysiska utveckling',
    'Vhc' => 'Amning',
    'Vi' => 'Oftalmologi (ögat)',
    'Vi:k' => 'Oftalmologins historia',
    'Vib' => 'Anatomi',
    'Vic' => 'Fysiologi',
    'Vie' => 'Sjukdomar',
    'Vif' => 'Kirurgi',
    'Vj' => 'Otorinolaryngologi',
    'Vjb' => 'Otologi (örat)',
    'Vjbb' => 'Anatomi',
    'Vjbc' => 'Fysiologi',
    'Vjbe' => 'Sjukdomar',
    'Vjbf' => 'Kirurgi',
    'Vji' => 'Rinologi (näsan)',
    'Vjj' => 'Laryngologi',
    'Vk' => 'Odontologi',
    'Vk:k' => 'Odontologins historia',
    'Vka' => 'Förebyggande tandvård',
    'Vkb' => 'Odontologisk röntgendiagnostik',
    'Vkc' => 'Tandsjukdomar',
    'Vkca' => 'Karies',
    'Vkcb' => 'Tandlossning (parodontos)',
    'Vkd' => 'Tandreglering (ortodonti)',
    'Vke' => 'Proteslära (protetik)',
    'Vkf' => 'Oral kirurgi och anestesi',
    'Vkh' => 'Barntandvård',
    'Vko' => 'Rättsodontologi',
    'Vkp' => 'Tandvårdsorganisation',
    'Vkp-c' => 'Sverige',
    'Vl' => 'Psykiatri',
    'Vl:b' => 'Psykiatrisk forskning, psykiatriska institutioner',
    'Vl:k' => 'Psykiatrins historia',
    'Vl:kc' => 'Sverige',
    'Vl:oe' => 'Psykiatrilagstifnting',
    'Vla' => 'Psykiska sjukdomar',
    'Vla:k' => 'Historia',
    'Vlaa' => 'Psykoser',
    'Vlab' => 'Neuroser',
    'Vlad' => 'Psykisk utvecklingsstörning',
    'Vlb' => 'Psykiatriska behandlingsmetoder',
    'Vlb:k' => 'Historia',
    'Vlba' => 'Medicinska behandlingsmetoder',
    'Vlbb' => 'Hypnos',
    'Vlbd' => 'Psykoterapi',
    'Vlbda' => 'Gruppterapi och miljöterapi',
    'Vlbdb' => 'Aktivitetsterapi',
    'Vlbdg' => 'Analytisk terapi',
    'Vlbdö' => 'Övriga psykoterapeutiska metoder',
    'Vle' => 'Barn- och ungdomspsykiatri',
    'Vlf' => 'Geriatrisk psykiatri',
    'Vln' => 'Drogberoende och drogmissbruk',
    'Vlna' => 'Alkoholism',
    'Vlnb' => 'Narkomani',
    'Vlo' => 'Rättspsykiatri',
    'Vm' => 'Terapimetoder',
    'Vma' => 'Fysioterapi. Sjukgymnastik',
    'Vma:k' => 'Fysioterapins och sjukgymnastikens historia',
    'Vmb' => 'Dietik',
    'Vmb:k' => 'Dietikhistoria',
    'Vmbb' => 'Bantning och fasta',
    'Vmd' => 'Radioterapi',
    'Vme' => 'Serumterapi',
    'Vmf' => 'Läkemedelsadministration',
    'Vmj' => 'Arbetsterapi',
    'Vml' => 'Alternativa terapiformer',
    'Vml:k' => 'Historia',
    'Vn' => 'Samhällsmedicin, hygien, sexologi',
    'Vna' => 'Samhällsmedicin och socialmedicin',
    'Vna:k' => 'Samhälls- och socialmedicinens historia',
    'Vnaa' => 'Folkhälsa',
    'Vnab' => 'Rehabilitering',
    'Vnaba' => 'Habilitering',
    'Vnac' => 'Epidemiologi',
    'Vnac:k' => 'Epidemiologins historia',
    'Vnac-c' => 'Sverige',
    'Vnam' => 'Misshandel och vanvård',
    'Vnama' => 'Barnmisshandel',
    'Vnamb' => 'Kvinnomisshandel',
    'Vnb' => 'Hygien',
    'Vnb:k' => 'Hygienhistoria',
    'Vnb:oe' => 'Hygienlagstiftning',
    'Vnbb' => 'Miljömedicin',
    'Vnbc' => 'Sjukhushygien',
    'Vnbf' => 'Yrkesmedicin',
    'Vnbfa' => 'Ergonomi',
    'Vnbfb' => 'Företagshälsovård',
    'Vnd' => 'Sexologi',
    'Vnd:k' => 'Sexologins historia',
    'Vnda' => 'Kvinnan och sexuallivet',
    'Vndb' => 'Mannen och sexuallivet',
    'Vndh' => 'Homosexualitet, bisexualitet, transsexualitet',
    'Vndi' => 'Handikappade och sexuallivet',
    'Vndm' => 'Födelsekontroll',
    'Vndma' => 'Abort',
    'Vndp' => 'Prostitution, otukt, incest, våldtäkt',
    'Vndp:k' => 'Prostitutionens etc historia',
    'Vo' => 'Rättsmedicin',
    'Vp' => 'Hälso- och sjukvård',
    'Vp-' => 'Särskilda länder och områden',
    'Vp-a' => 'Europa: allmänt',
    'Vp-ae' => 'Europeiska unionen (EU)',
    'Vp-b' => 'Norden: allmänt',
    'Vp-c' => 'Sverige',
    'Vp-c:b' => 'Hälso- och sjukvårdsforskning, sjukvårdsinstitutioner',
    'Vp-c:k' => 'Hälso- och sjukvårdens historia',
    'Vp-c:oe' => 'Hälso- och sjukvårdslagstiftning',
    'Vp-cs' => 'Samer',
    'Vp-cz' => 'Särskilda sjukvårdsanstalter',
    'Vp-d' => 'Övriga Norden',
    'Vp-da' => 'Danmark',
    'Vp-db' => 'Norge',
    'Vp-dd' => 'Finland',
    'Vp-e' => 'Brittiska öarna (Storbritannien)',
    'Vp-f' => 'Mellaneuropa',
    'Vp-fa' => 'Tyskland',
    'Vp-fb' => 'Österrike och Liechtenstein',
    'Vp-fc' => 'Ungern',
    'Vp-fd' => 'Tjeckien och Slovakien',
    'Vp-h' => 'Schweiz',
    'Vp-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Vp-j' => 'Frankrike och Monaco',
    'Vp-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Vp-m' => 'Östeuropa',
    'Vp-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Vp-mb' => 'Polen',
    'Vp-mc' => 'Estland, Lettland, Litauen',
    'Vp-n' => 'Balkanländerna',
    'Vp-o' => 'Asien',
    'Vp-oa' => 'Främre Asien',
    'Vp-ob' => 'Främre Indien',
    'Vp-oc' => 'Bortre Indien',
    'Vp-od' => 'Ostindiska öarna',
    'Vp-oe' => 'Östasien',
    'Vp-oea' => 'Kina',
    'Vp-oeb' => 'Korea',
    'Vp-oec' => 'Japan',
    'Vp-p' => 'Afrika',
    'Vp-pa' => 'Nordafrika utom Egypten',
    'Vp-pb' => 'Egypten och Sudan',
    'Vp-pc' => 'Västafrika',
    'Vp-pd' => 'Centralafrika',
    'Vp-pe' => 'Södra Afrika',
    'Vp-pf' => 'Östafrika',
    'Vp-pg' => 'Nordöstafrika',
    'Vp-q' => 'Amerika',
    'Vp-qa' => 'Förenta staterna',
    'Vp-qb' => 'Kanada',
    'Vp-qc' => 'Mexiko, Centralamerika och Västindien',
    'Vp-qd' => 'Sydamerika',
    'Vp-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Vp-ra' => 'Australien',
    'Vp-s' => 'Polarländerna',
    'Vpa' => 'Sjukvårdsekonomi',
    'Vpb' => 'Sjukvårdsadministration och -organisation',
    'Vpd' => 'Sjukvårdspersonal',
    'Vpe' => 'Sjukvårdslokaler och -utrustning',
    'Vpea' => 'Sjukvårdslokaler',
    'Vpeb' => 'Sjukvårdsutrustning och medicinsk teknik',
    'Vpf' => 'Sjukvårdsarbete',
    'Vpg' => 'Omvårdnad',
    'Vpg:b' => 'Omvårdnadsforskning',
    'Vph' => 'Primärvård',
    'Vpha' => 'Mödra- och barnhälsovård',
    'Vphb' => 'Hemsjukvård',
    'Vphc' => 'Egenvård',
    'Vpj' => 'Akutvård',
    'Vpk' => 'Intensivvård',
    'Vpl' => 'Långvård',
    'Vpm' => 'Palliativ vård',
    'Vs' => 'Geriatrik',
    'Vt' => 'Flyg- och navalmedicin, rymdmedicin',
    'Vu' => 'Idrottsmedicin',
    'Vx' => 'Militärmedicin',
    'Vx-c' => 'Sverige',
    'X' => 'Musikalier (noter)',
    'X(s)' => 'Musikalier: Samlingar och studiepartitur',
    'X(st)' => 'Studiepartitur',
    'Xa' => 'Musikteori',
    'Xb' => 'Musikhistoria',
    'Xb(s)' => 'Samlingar och studiepartitur',
    'Xb(st)' => 'Studiepartitur',
    'Xb.' => 'Särskilda perioder',
    'Xb.3' => 'Medeltiden och renässansen ca 600 - 1600',
    'Xb.38' => 'Renässansen ca 1450 - 1600',
    'Xb.4' => 'Nya tiden ca 1600 -',
    'Xb.43' => 'Barocken ca 1600 - 1750',
    'Xb.45' => 'Klassicismen och förromantiken ca 1750 - 1820',
    'Xb.47' => 'Högromantiken och senromantiken ca 1820 - 1900',
    'Xb.5' => '1900-talet',
    'Xb.6' => '2000-',
    'Xb-' => 'Särskilda länder och områden',
    'Xb-c' => 'Sverige',
    'Xb-d' => 'Övriga Norden',
    'Xb-da' => 'Danmark',
    'Xb-db' => 'Norge',
    'Xb-dd' => 'Finland',
    'Xb-e' => 'Brittiska öarna (Storbritannien)',
    'Xb-f' => 'Mellaneuropa',
    'Xb-fa' => 'Tyskland',
    'Xb-fb' => 'Österrike och Liechtenstein',
    'Xb-fc' => 'Ungern',
    'Xb-fd' => 'Tjeckien och Slovakien',
    'Xb-g' => 'Nederländerna, Belgien och Luxemburg',
    'Xb-h' => 'Schweiz',
    'Xb-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Xb-j' => 'Frankrike och Monaco',
    'Xb-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Xb-l' => 'Portugal',
    'Xb-m' => 'Östeuropa',
    'Xb-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Xb-mb' => 'Polen',
    'Xb-mc' => 'Estland, Lettland, Litauen',
    'Xb-n' => 'Balkanländerna',
    'Xb-o' => 'Asien',
    'Xb-q' => 'Amerika',
    'Xc' => 'Soloverk: valfri besättning',
    'Xc(ö)' => 'Övningar',
    'Xd' => 'Instrumentalmusik: tangentinstrument',
    'Xd(s)' => 'Samlingar och studiepartitur',
    'Xd(ö)' => 'Övningar',
    'Xda' => 'Piano',
    'Xda(s)' => 'Samlingar och studiepartitur',
    'Xda(st)' => 'Studiepartitur',
    'Xda(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xda(ö)' => 'Övningar',
    'Xda.0' => 'Antal instrument',
    'Xda.01' => '1 instrument',
    'Xda.011' => '1 hand',
    'Xda.014' => '4 händer',
    'Xda.016' => '6 händer',
    'Xda.02' => '2 instrument',
    'Xdaz' => 'Särskilda pianoinstrument',
    'Xdb' => 'Orgel',
    'Xdb(s)' => 'Samlingar och studiepartitur',
    'Xdb(ö)' => 'Övningar',
    'Xdbz' => 'Särskilda pianoinstrument',
    'Xdc' => 'Cembaloinstrument',
    'Xdc(s)' => 'Samlingar och studiepartitur',
    'Xdc(st)' => 'Studiepartitur',
    'Xdc(ö)' => 'Övningar',
    'Xdd' => 'Klavikord',
    'Xdi' => 'Elektriska tangentinstrument (keyboard)',
    'Xe' => 'Instrumentalmusik: stråkinstrument',
    'Xe(s)' => 'Samlingar och studiepartitur',
    'Xe(ö)' => 'Övningar',
    'Xea' => 'Violin',
    'Xea(ö)' => 'Övningar',
    'Xeaa' => 'Violin(er) utan ack',
    'Xeai' => 'Violin + tangentinstrument eller bc',
    'Xeb' => 'Viola',
    'Xeb(ö)' => 'Övningar',
    'Xec' => 'Violoncell',
    'Xec(ö)' => 'Övningar',
    'Xed' => 'Kontrabas',
    'Xed(ö)' => 'Övningar',
    'Xee' => 'Viola da gamba',
    'Xeg' => 'Nyckelharpa',
    'Xez' => 'Övriga särskilda stråkinstrument',
    'Xf' => 'Instrumentalmusik: blåsinstrument',
    'Xf(ö)' => 'Övningar',
    'Xfa' => 'Flöjt',
    'Xfa(s)' => 'Samlingar och studiepartitur',
    'Xfa(ö)' => 'Övningar',
    'Xfaa' => 'Flöjt(er) utan ack',
    'Xfai' => 'Flöjt + tangentinstrument eller bc',
    'Xfaz' => 'Särskilda flöjter',
    'Xfb' => 'Blockflöjt',
    'Xfb(ö)' => 'Övningar',
    'Xfc' => 'Oboe',
    'Xfc(ö)' => 'Övningar',
    'Xfci' => 'Engelskt horn (altoboe)',
    'Xfd' => 'Klarinett',
    'Xfd(ö)' => 'Övningar',
    'Xfdl' => 'Bassetthorn',
    'Xfe' => 'Saxofon',
    'Xfe(ö)' => 'Övningar',
    'Xff' => 'Fagott',
    'Xff(ö)' => 'Övningar',
    'Xfg' => 'Trumpet',
    'Xfg(ö)' => 'Övningar',
    'Xfgl' => 'Kornett',
    'Xfh' => 'Horn (valthorn)',
    'Xfh(ö)' => 'Övningar',
    'Xfi' => 'Trombon (basun)',
    'Xfi(ö)' => 'Övningar',
    'Xfj' => 'Tuba',
    'Xfk' => 'Dragspel',
    'Xfk(s)' => 'Samlingar och studiepartitur',
    'Xfk(ö)' => 'Övningar',
    'Xfl' => 'Säckpipa',
    'Xfm' => 'Munspel',
    'Xfz' => 'Övriga särskilda blåsinstrument',
    'Xg' => 'Instrumentalmusik: knäppinstrument',
    'Xg(ö)' => 'Övningar',
    'Xga' => 'Harpa',
    'Xgb' => 'Gitarr',
    'Xgb(s)' => 'Samlingar och studiepartitur',
    'Xgb(ö)' => 'Övningar',
    'Xgbi' => 'Elgitarr',
    'Xgbib' => 'Elbas',
    'Xgbz' => 'Övriga särskilda gitarrer',
    'Xgc' => 'Mandolin',
    'Xgd' => 'Luta och bouzouki',
    'Xgdz' => 'Övriga särskilda lutinstrument',
    'Xge' => 'Citterinstrument',
    'Xh' => 'Instrumentalmusik: slagverk och strykidiofoner',
    'Xh(ö)' => 'Övningar',
    'Xha' => 'Trumma och puka',
    'Xha(ö)' => 'Övningar',
    'Xhe' => 'Vibrafon',
    'Xhf' => 'Xylofon',
    'Xhg' => 'Marimba',
    'Xhk' => 'Slagverksgrupp',
    'Xi' => 'Instrumentalmusik: elektriska musikinstrument',
    'Xj' => 'Instrumentalmusik: Mekaniska musikinstrument',
    'Xk' => 'Instrumentalensembler',
    'Xk(ö)' => 'Övningar',
    'Xkd' => 'Ensembler med tangentinstrument',
    'Xkdd' => 'Tangentinstrument + annat tangentinstrument + ev andra instrument',
    'Xkde' => 'Tangentinstrument  flera sttåkinstrument',
    'Xkdea' => 'Pianotrio',
    'Xkdeb' => 'Pianokvartett',
    'Xkdec' => 'Pianokvintett',
    'Xkdf' => 'Tangentinstrument + flera blåsinstrument',
    'Xkdg' => 'Tangentinstrument + knäppinstrument + ev flera instrument',
    'Xke' => 'Ensembler med stråkinstrument',
    'Xkee' => 'Enbart stråkinstrument',
    'Xkeea' => 'Stråktrio',
    'Xkeeb' => 'Stråkkvartett',
    'Xkef' => 'Stråkinstrument + blåsinstrument',
    'Xkf' => 'Ensembler med blåsinstrument',
    'Xkff' => 'Träblåsensembler',
    'Xkffa' => 'Blåskvartett',
    'Xkffb' => 'Blåskvintett',
    'Xkfg' => 'Bleckblåsensembler (brassensembler)',
    'Xkfga' => 'Brasskvintett',
    'Xkfgb' => 'Bassextett',
    'Xkg' => 'Ensembler med knäppinstrument',
    'Xkge' => 'Knäppinstrument + stråkinstrument',
    'Xkgf' => 'Knäppinstrument + blåsinstrument',
    'Xkh' => 'Ensembler med slagverk + 1 eller flera andra instrument',
    'Xki' => 'Ensembler med elektroakustiska inslag',
    'Xkk' => 'Ensembler för historiska instrument',
    'Xko' => 'Ensembler med vokala inslag',
    'Xkv' => 'Ensembler med valfria instrument',
    'Xl' => 'Instrumentalmusik: orkestrar',
    'Xlb' => 'Orkestrar med konserterande soloinstrument',
    'Xlba' => 'Concerti grossi, orkesterkonserter',
    'Xlbb' => 'Musik för flera instrument av helt olika art + orkester',
    'Xlbd' => 'Musik för tangentinstrument + orkester',
    'Xlbda' => 'Piano',
    'Xlbdb' => 'Orgel',
    'Xlbdc' => 'Cembalo',
    'Xlbe' => 'Musik för stråkinstrument + orkester',
    'Xlbea' => 'Violin',
    'Xlbeb' => 'Viola',
    'Xlbec' => 'Violoncell',
    'Xlbed' => 'Kontrabas',
    'Xlbee' => 'Viola da gamba',
    'Xlbf' => 'Musik för blåsinstrument + orkester',
    'Xlbfa' => 'Flöjt',
    'Xlbfb' => 'Blockflöjt',
    'Xlbfc' => 'Oboe',
    'Xlbfd' => 'Klarinett',
    'Xlbfe' => 'Saxofon',
    'Xlbff' => 'Fagott',
    'Xlbfg' => 'Trumpet',
    'Xlbfh' => 'Horn (valthorn)',
    'Xlbfi' => 'Trombon (basun)',
    'Xlbfj' => 'Tuba',
    'Xlbfk' => 'Dragspel',
    'Xlbg' => 'Musik för knäppinstrument + orkester',
    'Xlbh' => 'Musik för slagverk och strykidiofoner + orkester',
    'Xlbi' => 'Musik för elektriska instrument + orkester',
    'Xlc' => 'Kammarorkestrar',
    'Xlca' => 'Utan blåsare',
    'Xlcb' => 'Med blåsare',
    'Xlcc' => 'Salongsorkestrar',
    'Xld' => 'Stråkorkestrar',
    'Xld(s)' => 'Samlingar och studiepartitur',
    'Xld(st)' => 'Studiepartitur',
    'Xld(ö)' => 'Övningar',
    'Xle' => 'Symfoniorkestrar',
    'Xle(s)' => 'Samlingar och studiepartitur',
    'Xle(st)' => 'Studiepartitur',
    'Xlf' => 'Blåsorkestrar',
    'Xlfa' => 'Militärorkestrar',
    'Xlfb' => 'Brassband',
    'Xlz' => 'Specialorkestrar',
    'Xm' => 'Instrumentalmusik: särskilda former',
    'Xma' => 'Symfoniska verk',
    'Xma(s)' => 'Samlingar och studiepartitur',
    'Xma(st)' => 'Studiepartitur',
    'Xmb' => 'Instrumentalkonserter',
    'Xmba' => 'Concerti grossi, orkesterkonserter',
    'Xmbb' => 'Konserter för flera instrument av helt olika art',
    'Xmbd' => 'Konserter för tangentinstrument',
    'Xmbda' => 'Piano',
    'Xmbdb' => 'Orgel',
    'Xmbdc' => 'Cembalo',
    'Xmbe' => 'Konserter för sråkinstrument',
    'Xmbea' => 'Violin',
    'Xmbeb' => 'Viola',
    'Xmbec' => 'Violoncell',
    'Xmbf' => 'Konserter för blåsinstrument',
    'Xmbfa' => 'Flöjt',
    'Xmbfb' => 'Blockflöjt',
    'Xmbfc' => 'Oboe',
    'Xmbfd' => 'Klarinett',
    'Xmbfe' => 'Saxofon',
    'Xmbff' => 'Fagott',
    'Xmbfg' => 'Trumpet',
    'Xmbfh' => 'Horn (valthorn)',
    'Xmbfi' => 'Trombon (basun)',
    'Xmbg' => 'Konserter för knäppinstrument',
    'Xmbh' => 'Konserter för slagverk och strykidiofoner',
    'Xmc' => 'Divertimenti, serenader, sviter m m',
    'Xmca' => 'Divertimenti',
    'Xmcb' => 'Kassationer',
    'Xmcc' => 'Serenader',
    'Xmcd' => 'Sviter och parodier',
    'Xmd' => 'Variationsverk',
    'Xmda' => 'Passacaglior, chaconner, folior, divisions, ostinati etc',
    'Xmdb' => 'Koralbearbetningar',
    'Xmdc' => 'Tema med variationer',
    'Xme' => 'Uvertyrer m m',
    'Xme(s)' => 'Samlingar och studiepartitur',
    'Xme(st)' => 'Studiepartitur',
    'Xmea' => 'Preludier',
    'Xmea(s)' => 'Samlingar och studiepartitur',
    'Xmea(st)' => 'Studiepartitur',
    'Xmf' => 'Symfoniska dikter och karaktärsstycken',
    'Xmf(s)' => 'Samlingar och studiepartitur',
    'Xmf(st)' => 'Studiepartitur',
    'Xmf(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xmfa' => 'Symfoniska dikter',
    'Xmfb' => 'Serenader från tiden efter ca 1800',
    'Xmg' => 'Rapsodier, fantasier, etyder m m',
    'Xmga' => 'Rapsodier',
    'Xmgb' => 'Fantasier',
    'Xmgc' => 'Etyder, capricer',
    'Xmgd' => 'Parafraser',
    'Xmge' => 'Sviter från tiden efter ca 1800',
    'Xmge(s)' => 'Samlingar och studiepartitur',
    'Xmge(st)' => 'Studiepartitur',
    'Xmh' => 'Danser och dansstycken',
    'Xmh(s)' => 'Samlingar och studiepartitur',
    'Xmh(st)' => 'Studiepartitur',
    'Xmha' => 'Symfoniska danser',
    'Xmhz' => 'Särskilda dansformer',
    'Xmi' => 'Marscher',
    'Xmia' => 'Militärmarscher',
    'Xmiz' => 'Övriga särskilda typer av marscher',
    'Xmj' => 'Kanons, toccator, fugor, ricercari, tienti m m',
    'Xmj(s)' => 'Samlingar och studiepartitur',
    'Xmj(st)' => 'Studiepartitur',
    'Xmk' => 'Fria orkesterformer',
    'Xml' => 'Sonater',
    'Xml(s)' => 'Samligar och studiepartitur',
    'Xml(st)' => 'Studiepartitur',
    'Xms' => 'Sakral instrumentalmusik',
    'Xn' => 'Elektroakustisk musik och ljudkonst',
    'Xo' => 'Solosång',
    'Xo(ö)' => 'Övningar',
    'Xoa' => '1 röst',
    'Xoaa' => '1 röst utan ackompanjemang',
    'Xoab' => '1 röst + tangentinstrument eller bc',
    'Xoaba' => 'Piano',
    'Xoaba(s)' => 'Samlingar och studiepartitur',
    'Xoaba(st)' => 'Studiepartitur',
    'Xoaba(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xoabb' => 'Orgel',
    'Xoabc' => 'Cembalo',
    'Xoac' => '1 röst +  knäppinstrument',
    'Xoaca' => 'Harpa',
    'Xoacb' => 'Gitarr',
    'Xoacd' => 'Luta',
    'Xoad' => '1 röst + annat instrument',
    'Xoae' => '1 röst  instrumentalensemble eller orkester',
    'Xoaek' => 'Instrumentalensemble',
    'Xoael' => 'Orkester',
    'Xob' => '2 röster',
    'Xoba' => '2 röster utan ackompanjemang',
    'Xobb' => '2 röster + tangentinstrument',
    'Xobba' => 'Piano',
    'Xobc' => '2 röster + knäppinstrument',
    'Xobe' => '2 röster + instrumentalensemble eller orkester',
    'Xobek' => 'Instrumentalensemble',
    'Xobel' => 'Orkester',
    'Xoc' => '3 röster',
    'Xoca' => '2 röster utan ackompanjemang',
    'Xocb' => '2 röster + tangentinstrument',
    'Xoce' => '2 röster + instrumentalensemble eller orkester',
    'Xocek' => 'Instrumentalensemble',
    'Xocel' => 'Orkester',
    'Xod' => '4 röster',
    'Xoda' => '2 röster utan ackompanjemang',
    'Xodb' => '2 röster + tangentinstrument',
    'Xodc' => '2 röster + knäppinstrument',
    'Xode' => '2 röster + instrumentalensemble eller orkester',
    'Xoe' => '5 eller flera röster',
    'Xoea' => '2 röster utan ackompanjemang',
    'Xoeb' => '2 röster + tangentinstrument',
    'Xoee' => '2 röster + instrumentalensemble eller orkester',
    'Xp' => 'Körsång',
    'Xpa' => 'Unison sång med eller utan ackompanjemang',
    'Xpb' => 'Flerstämmig körsång med instrumental- och/eller orkesterackompanjemang',
    'Xpba' => 'Damkör eller barnkör',
    'Xpbaa' => 'Damkör',
    'Xpbab' => 'Barnkör',
    'Xpbc' => 'Blandad kör',
    'Xpbc(s)' => 'Samlingar och studiepartitur',
    'Xpbc(st)' => 'Studiepartitur',
    'Xpbc(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xpbd' => 'Manskör',
    'Xpc' => 'Flerstämmig körsång a cappella',
    'Xpca' => 'Damkör eller barnkör',
    'Xpcaa' => 'Damkör',
    'Xpcab' => 'Barnkör',
    'Xpcc' => 'Blandad kör',
    'Xpcc(s)' => 'Samlingar och studiepartitur',
    'Xpcc(st)' => 'Studiepartitur',
    'Xpcd' => 'Manskör',
    'Xpå' => 'Talkör',
    'Xq' => 'Vokalmusik: särskilda former',
    'Xqa' => 'Oratorier',
    'Xqaa' => 'Oratorier med profan text',
    'Xqab' => 'Oratorier med religiös text',
    'Xqab(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xqb' => 'Kantater',
    'Xqba' => 'Kantater med profan text',
    'Xqba(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xqbb' => 'Kantater med religiös text',
    'Xqbb(s)' => 'Samlingar och studiepartitur',
    'Xqbb(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xqc' => 'Äldre vokalmusikformer',
    'Xqca' => 'Vokalmusik från medeltiden',
    'Xqca-f' => 'Minne- och mästersånger från Tyskland',
    'Xqca-i' => 'Caccie, ballate samta andra sånger från Italien',
    'Xqca-j' => 'Trubadur- och trouvèresånger och andra sånger från Frankrike',
    'Xqcb' => 'Madrigaler',
    'Xqcba' => '1300-talsmadrigaler',
    'Xqcbb' => 'Madrigaler från renässansen',
    'Xqcbc' => 'Madrigalkomedier',
    'Xqcc' => 'Motetter',
    'Xqcd' => 'Andra sånger från renässansen',
    'Xqcd(s)' => 'Samlingar och studiepartitur',
    'Xqd' => 'Passioner',
    'Xqe' => 'Andra vokalverk med liturgisk eller biblisk text',
    'Xqea' => 'Mässor',
    'Xqea(s)' => 'Samlingar och studiepartitur',
    'Xqea(st)' => 'Studiepartitur',
    'Xqea(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xqear' => 'Rekviem',
    'Xqeb' => 'Litanior',
    'Xqec' => 'Cantica',
    'Xqed' => 'Hymner, sekvenser, antifoner etc',
    'Xqedz' => 'Särskilda traditionella texter',
    'Xqee' => 'Övriga bibeltexter',
    'Xqeea' => 'Psaltarpsalmer',
    'Xqeeb' => 'Lamentationer',
    'Xqf' => 'Solistiska former efter ca 1600',
    'Xqfa' => 'Solosång från barocken ca 1600-1750',
    'Xqfb' => 'Konsertarior',
    'Xqfc' => 'Religiösa solosånger och arior',
    'Xqfd' => 'Lieder, romanser, ballader och sångcykler',
    'Xqfd(s)' => 'Samlingar och studiepartitur',
    'Xqfd-' => 'Särskilda länder och områden',
    'Xqfd-c' => 'Sverige',
    'Xqfd-d' => 'Övriga Norden',
    'Xqfd-da' => 'Danmark',
    'Xqfd-db' => 'Norge',
    'Xqfd-dc' => 'Island och Färöarna',
    'Xqfd-dd' => 'Finland',
    'Xqfd-e' => 'Brittiska öarna (Storbritannien)',
    'Xqfd-f' => 'Mellaneuropa',
    'Xqfd-fa' => 'Tyskland',
    'Xqfd-fb' => 'Österrike och Liechtenstein',
    'Xqfd-fc' => 'Ungern',
    'Xqfd-fd' => 'Tjeckien och Slovakien',
    'Xqfd-g' => 'Nederländerna, Belgien och Luxemburg',
    'Xqfd-h' => 'Schweiz',
    'Xqfd-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Xqfd-j' => 'Frankrike och Monaco',
    'Xqfd-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Xqfd-l' => 'Portugal',
    'Xqfd-m' => 'Östeuropa',
    'Xqfd-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Xqfd-mb' => 'Polen',
    'Xqfd-mc' => 'Estland, Lettland, Litauen',
    'Xqfd-n' => 'Balkanländerna',
    'Xqfd-o' => 'Asien',
    'Xqfd-q' => 'Amerika',
    'Xqfd-qa' => 'Förenta staterna',
    'Xqfd-qd' => 'Sydamerika',
    'Xqfe' => 'Friare solistisk musik för soloröst',
    'Xqg' => 'Nationella sånger',
    'Xqga' => 'Nationalsånger',
    'Xqgb' => 'Övriga nationella sånger',
    'Xqh' => 'Visor',
    'Xqh(s)' => 'Samlingar',
    'Xqh-c' => 'Visor på svenska',
    'Xqhz' => 'Särskilda typer av populära sånger och visor',
    'Xqj' => 'Barnvisor och -ramsor',
    'Xqj(s)' => 'Samlingar',
    'Xqja' => 'Barnvisor',
    'Xqja(s)' => 'Samlingar',
    'Xqjb' => 'Barnramsor',
    'Xqjc' => 'Vaggvisor',
    'Xqk' => 'Kanons',
    'Xql' => 'Körmusik efter ca 1600',
    'Xqla' => 'Körmusik från barocken ca 1600-1750',
    'Xqlaa' => 'Med profan text',
    'Xqlab' => 'Med religiös text',
    'Xqlb' => 'Körmusik ca 1750-1950',
    'Xqlba' => 'Med profan text',
    'Xqlbb' => 'Med religiös text',
    'Xqlc' => 'Modern körmusik efter ca 1950',
    'Xqlca' => 'Med profan text',
    'Xqlcb' => 'Med religiös text',
    'Xr' => 'Dramatisk och scenisk musik',
    'Xra' => 'Operor',
    'Xra(s)' => 'Samlingar och studiepartitur',
    'Xra(st)' => 'Studiepartitur',
    'Xra(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xrb' => 'Operetter',
    'Xrb(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xrba' => 'Musikaler',
    'Xrba(s)' => 'Samlingar och studiepartitur',
    'Xrba(st)' => 'Studiepartitur',
    'Xrba(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xrc' => 'Baletter',
    'Xrc(s)' => 'Samlingar och studiepartitur',
    'Xrc(st)' => 'Studiepartitur',
    'Xrc(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xrd' => 'Revyer',
    'Xrda' => 'Spex',
    'Xre' => 'Film- och skådespelmusik',
    'Xrea' => 'Filmmusik',
    'Xrea(s)' => 'Samlingar och studiepartitur',
    'Xrea(up)' => 'Utdrag för piano eller annat tangentinstrument',
    'Xreb' => 'Skådespelsmusik',
    'Xrh' => 'Musik till melodramer och uppläsningar',
    'Xrha' => 'Uppläsningar etc med specialkomponerad musik',
    'Xrhc' => 'Uppläsningar etc till improviserad musik',
    'Xrhj' => 'Sagor, sagospel etc med specialkomponerad musik',
    'Xrs' => 'Legend- och mysteriespel',
    'Xrt' => 'Multimediaverk',
    'Xs' => 'Religiös musik',
    'Xsa' => 'Kristna samfund',
    'Xsaa' => 'Romersk-katolska kyrkan',
    'Xsaaa' => 'Mässa',
    'Xsaab' => 'Tidegärd',
    'Xsaac' => 'Hymner, sekvenser, troper, rimofficier m m',
    'Xsab' => 'Grekisk-ortodoxa kyrkan',
    'Xsac' => 'Bysantinsk kyrkomusik',
    'Xsad' => 'Protestantisk kyrkomusik',
    'Xsad-c' => 'Svenska kyrkan',
    'Xsae' => 'Anglikansk kyrkomusik',
    'Xsb' => 'Icke-kristna religioner',
    'Xse' => 'Koraler och psalmer',
    'Xsea' => 'Romers-katolska kyrkan',
    'Xsed' => 'Protestantiska kyrkor',
    'Xsed-c' => 'Svenska kyrkan',
    'Xsee' => 'Anglikanska kyrkor',
    'Xsf' => 'Andliga sånger och visor',
    'Xsf(s)' => 'Samlingar',
    'Xsfa' => 'Andliga schlager',
    'Xsfb' => 'Andliga barnvisor',
    'Xsfs' => 'Särskilda frikyrkosamfunds sångböcker',
    'Xsg' => 'Gospels och negro spirituals',
    'Xsga' => 'Traditionella negro spirituals och gospels',
    'Xsgb' => 'Modern gospelsång',
    'Xu' => 'Västerländsk folkmusik',
    'Xu-' => 'Särskilda länder och områden',
    'Xu-a' => 'Europa: allmänt',
    'Xu-b' => 'Norden: allmänt',
    'Xu-c' => 'Sverige',
    'Xu-cs' => 'Samer',
    'Xu-d' => 'Övriga Norden',
    'Xu-da' => 'Danmark',
    'Xu-db' => 'Norge',
    'Xu-dc' => 'Island och Färöarna',
    'Xu-dd' => 'Finland',
    'Xu-e' => 'Brittiska öarna (Storbritannien)',
    'Xu-f' => 'Mellaneuropa',
    'Xu-fa' => 'Tyskland',
    'Xu-fb' => 'Österrike och Liechtenstein',
    'Xu-fc' => 'Ungern',
    'Xu-fd' => 'Tjeckien och Slovakien',
    'Xu-g' => 'Nederländerna, Belgien och Luxemburg',
    'Xu-h' => 'Schweiz',
    'Xu-i' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Xu-j' => 'Frankrike och Monaco',
    'Xu-k' => 'Spanien (inkl Andorra och Gibraltar)',
    'Xu-l' => 'Portugal',
    'Xu-m' => 'Östeuropa',
    'Xu-ma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Xu-mb' => 'Polen',
    'Xu-mc' => 'Estland, Lettland, Litauen',
    'Xu-n' => 'Balkanländerna',
    'Xu-na' => 'Rumänien',
    'Xu-nb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Xu-nc' => 'Bulgarien',
    'Xu-nd' => 'Grekland',
    'Xu-nf' => 'Albanien',
    'Xu-o' => 'Asien',
    'Xu-q' => 'Amerika',
    'Xu-qa' => 'Förenta staterna',
    'Xu-qb' => 'Kanada',
    'Xu-qc' => 'Mexiko, Centralamerika och Västindien',
    'Xu-qd' => 'Sydamerika',
    'Xv' => 'Icke-västerländska kulturers musik',
    'Xv-' => 'Särskilda länder och områden',
    'Xv-m' => 'Östeuropa',
    'Xv-o' => 'Asien',
    'Xv-oa' => 'Främre Asien',
    'Xv-ob' => 'Främre Indien',
    'Xv-oc' => 'Bortre Indien',
    'Xv-od' => 'Ostindiska öarna',
    'Xv-oe' => 'Östasien',
    'Xv-p' => 'Afrika',
    'Xv-pc' => 'Västafrika',
    'Xv-pe' => 'Södra Afrika',
    'Xv-pf' => 'Östafrika',
    'Xv-q' => 'Amerika',
    'Xv-qc' => 'Mexiko, Centralamerika och Västindien',
    'Xv-qd' => 'Sydamerika',
    'Xv-r' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)',
    'Xx' => 'Jazz, rock och populärmusik',
    'Xxa' => 'Besättning',
    'Xxad' => 'Instrumentalmusik: tangentinstrument',
    'Xxada' => 'Piano',
    'Xxadi' => 'Elektriska tangentinstrument (keyboard)',
    'Xxae' => 'Instrumentalmusik: stråkinstrument',
    'Xxaf' => 'Instrumentalmusik: blåsinstrument',
    'Xxafa' => 'Flöjt',
    'Xxafd' => 'Klarinett',
    'Xxafe' => 'Saxofon',
    'Xxafg' => 'Trumpet',
    'Xxafk' => 'Dragspel',
    'Xxafm' => 'Munspel',
    'Xxag' => 'Instrumentalmusik: knäppinstrument',
    'Xxagb' => 'Gitarr',
    'Xxagbi' => 'Elgitarr',
    'Xxagbib' => 'Elbas',
    'Xxah' => 'Instrumentalmusik: slagverk och strykidiofoner',
    'Xxak' => 'Instrumentalensembler',
    'Xxakd' => 'Ensembler med tangentinstrument',
    'Xxake' => 'Ensembler med stråkinstrument',
    'Xxakf' => 'Ensembler med blåsinstrument',
    'Xxal' => 'Instrumentalmusik: orkestrar',
    'Xxale' => 'Symfoniorkestrar',
    'Xxalf' => 'Blåsorkestrar',
    'Xxao' => 'Solosång',
    'Xxaoa' => '1 röst',
    'Xxaoab' => '1 röst + tangentinstrument eller bc',
    'Xxaoaba' => 'Piano',
    'Xxaoac' => '1 röst +  knäppinstrument',
    'Xxaoacb' => 'Gitarr',
    'Xxaoae' => '1 röst  instrumentalensemble eller orkester',
    'Xxaob' => '2 röster',
    'Xxap' => 'Körsång',
    'Xxapb' => 'Flerstämmig körsång med instrumental- och/eller orkesterackompanjemang',
    'Xxapc' => 'Flerstämmig körsång a cappella',
    'Xxb' => 'Ragtime',
    'Xxc' => 'Jazz',
    'Xxca' => 'Tidig jazz',
    'Xxcb' => 'Swing och sweet',
    'Xxcc' => 'Modern jazz',
    'Xxcz' => 'Särskilda artister och ensembler',
    'Xxd' => 'New age',
    'Xxf' => 'Blues',
    'Xxfa' => 'Country blues',
    'Xxfb' => 'Classic blues',
    'Xxfc' => 'City blues',
    'Xxfd' => 'Rythm &amp; blues',
    'Xxfe' => 'Soul, funk, hip-hop oh rap',
    'Xxfz' => 'Särskilda artister och ensembler',
    'Xxg' => 'Nordamerikansk folkmusik utom blues',
    'Xxn' => 'Rock',
    'Xxna' => 'Tidig rock',
    'Xxnd' => '60-talets pop och rock',
    'Xxne' => '70-talets rock och framåt',
    'Xxng' => 'Folkrock',
    'Xxnh' => 'Countryrock',
    'Xxni' => 'Singers/songwriters (&#034;visrocksångare&#034;)',
    'Xxnv' => 'Icke-västerländsk populärmusik av rocktryp',
    'Xxnz' => 'Särskilda artister och ensembler',
    'Xxp' => 'Populärmusik',
    'Xxpb' => 'Schlager och evergreens',
    'Xxpb-c' => 'Sverige',
    'Xxpc' => 'Barbershop',
    'Xxpd' => 'Lätta arrangemang av seriös musik',
    'Xxpz' => 'Särskilda artister och ensembler',
    'Xxq' => 'Dansmusik',
    'Xxqa' => 'Gammaldans',
    'Xxqb' => 'Modern dans från 1900-talet',
    'Xxqz' => 'Särskilda artister och ensembler',
    'Xy' => 'texter till vokal och dramatisk musik',
    'Xyb' => 'Sånger och visor',
    'Xyb(s)' => 'Samlingar',
    'Xyc' => 'Texter till körverk',
    'Xyd' => 'Libretton',
    'Xyda' => 'Operalibretton',
    'Xydb' => 'Operettlibretton',
    'Xä' => 'Parodier, signaler, ljudeffekter m m',
    'Xö' => 'Övrigt',
    'Xöa' => 'Årstidscykeln',
    'Xöaj' => 'Julmusik',
    'Xöb' => 'Livscykeln',
    'Xöbb' => 'Bröllopsmusik',
    'Xöbs' => 'Sorge- och begravningsmusik',
    'Y' => 'Musikinspelningar',
    'Y(s)' => 'Samlingar',
    'Ya' => 'Musikteori',
    'Yb' => 'Musikhistoria',
    'Yb.' => 'Allmänt: särskilda perioder',
    'Yb.3' => 'Medeltiden och renässansen ca 600 - 1600',
    'Yb.4' => 'Nya tiden ca 1600 -',
    'Yb.5' => '1900-talet',
    'Yb.6' => '2000-',
    'Yb-c' => 'Sverige',
    'Yc' => 'Soloverk: valfri besättning',
    'Yd' => 'Instrumentalmusik: tangentinstrument',
    'Yda' => 'Piano',
    'Ydb' => 'Orgel',
    'Ydc' => 'Cembaloinstrument',
    'Ye' => 'Instrumentalmusik: stråkinstrument',
    'Yea' => 'Violin',
    'Yeb' => 'Viola',
    'Yec' => 'Violoncell',
    'Yee' => 'Viola da gamba',
    'Yeg' => 'Nyckelharpa',
    'Yf' => 'Instrumentalmusik: blåsinstrument',
    'Yfa' => 'Flöjt',
    'Yfb' => 'Blockflöjt',
    'Yfc' => 'Oboe',
    'Yfd' => 'Klarinett',
    'Yfe' => 'Saxofon',
    'Yff' => 'Fagott',
    'Yfg' => 'Trumbet',
    'Yfh' => 'Horn (valthorn)',
    'Yfi' => 'Trombon (basun)',
    'Yfj' => 'Tuba',
    'Yfk' => 'Dragspel',
    'Yfl' => 'Säckpipa',
    'Yfm' => 'Munspel',
    'Yg' => 'Instrumentalmusik: knäppinstrument',
    'Yga' => 'Harpa',
    'Ygb' => 'Gitarr',
    'Ygc' => 'Mandolin',
    'Ygd' => 'Luta',
    'Yge' => 'Citterinstrument',
    'Yh' => 'Instrumentalmusik: slagverk och strykidiofoner',
    'Yi' => 'Instrumentalmusik: elektriska musikinstrument',
    'Yj' => 'Instrumentalmusik: Mekaniska musikinstrument',
    'Yk' => 'Instrumentalensembler',
    'Ykd' => 'Ensembler med tangentinstrument',
    'Yke' => 'Ensembler med stråkinstrument',
    'Ykf' => 'Ensbemler med blåsinstrument',
    'Ykg' => 'Ensembler med knäppinstrument',
    'Ykh' => 'Ensembler med slagverk + 1 eller flera andra instrument',
    'Yki' => 'Ensembler med elektroakustiska inslag',
    'Ykk' => 'Ensembler för historiska instrument',
    'Yko' => 'Ensembler med vokala inslag',
    'Ykv' => 'Ensembler för valfria instrument',
    'Yl' => 'Instrumentalmusik: orkestrar',
    'Ylb' => 'Orkestrar med konserterande soloinstrument',
    'Ylba' => 'Concerti grossi, orkesterkonserter',
    'Ylbb' => 'Musik för flera instrument av helt olika karaktär',
    'Ylbd' => 'Musik för tangentinstrument + orkester',
    'Ylbe' => 'Musik för stråkinstrument + orkester',
    'Ylbf' => 'Musik för blåsinstrument  + orkester',
    'Ylbg' => 'Musik för knäppinstrument + orkester',
    'Ylbh' => 'Musik för slagverk och strykidiofoner + orkester',
    'Ylc' => 'Kammarorkestrar',
    'Yld' => 'Stråkorkestrar',
    'Yle' => 'Symfoniorkestrar',
    'Ylf' => 'Blåsorkestrar',
    'Ylv' => 'Orkestrar med valfria instrument',
    'Ym' => 'Instrumentalmusik: särskilda former',
    'Yma' => 'Symfoniska verk',
    'Ymb' => 'Instrumentalkonserter',
    'Ymba' => 'Concerti grossi, orkesterkonserter',
    'Ymbb' => 'Konserter för flera instrument av helt olika karaktär',
    'Ymbd' => 'Konserter för tangentinstrument',
    'Ymbe' => 'Konserter för stråkinstrument',
    'Ymbf' => 'Konserter för blåsinstrument',
    'Ymbg' => 'Konserter för knäppinstrument',
    'Ymbh' => 'Konserter för slagverk och strykidiofoner',
    'Ymc' => 'Divertimenti, serenader, sviter m m',
    'Ymd' => 'Variationsverk',
    'Yme' => 'Uvertyrer m m',
    'Ymf' => 'Symfoniska dikter och karaktärsstycken',
    'Ymfa' => 'Symfoniska dikter',
    'Ymfb' => 'Serenader från tiden efter ca 1800',
    'Ymg' => 'Rapsodier, fantasier, etyder m m',
    'Ymga' => 'Rapsodier',
    'Ymgb' => 'Fantasier',
    'Ymgc' => 'Etyder, capricer',
    'Ymge' => 'Sviter från tiden efter 1800',
    'Ymh' => 'Danser och dansstycken',
    'Ymi' => 'Marscher',
    'Ymj' => 'Kanons, toccator, fugor, ricercari, tienti m m',
    'Ymk' => 'Fria orkesterformer',
    'Yml' => 'Sonater',
    'Yms' => 'Sakral instrumentalmusik',
    'Yn' => 'Elektroakustisk musik och ljudkonst',
    'Yna' => 'Elektroakustiska kompositioner',
    'Ynb' => 'Elektroakustiska bearbetningar',
    'Ync' => 'Elektroakustisk musik med instrumentala eller vokala inslag',
    'Ynd' => 'Text - ljudkompositioner',
    'Yne' => 'Ljudkonst',
    'Yo' => 'Solosång',
    'Yoa' => '1 röst',
    'Yob' => '2 röster',
    'Yoc' => '3 röster',
    'Yod' => '4 röster',
    'Yoe' => '5 eller flera röster',
    'Yp' => 'Körsång',
    'Ypa' => 'Unison sång med eller utan ackompanjemang',
    'Ypb' => 'Flerstämmig körsång med instrumental- och/eller orkesterackompanjemang',
    'Ypba' => 'Damkör eller barnkör',
    'Ypbc' => 'Blandad kör',
    'Ypbd' => 'Manskör',
    'Ypc' => 'Flerstämmig körsång a cappella',
    'Ypå' => 'Talkör',
    'Yq' => 'Vokalmusik: särskilda former',
    'Yqa' => 'Oratorier',
    'Yqb' => 'Kantater',
    'Yqc' => 'Äldre vokalmusikformer (- ca 1600)',
    'Yqd' => 'Passioner',
    'Yqe' => 'Andra vokalverk med liturgisk eller biblisk text',
    'Yqea' => 'Mässor',
    'Yqeb' => 'Litanior',
    'Yqec' => 'Cantica',
    'Yqed' => 'Hymner, sekvenser, antifoner etc',
    'Yqee' => 'Övriga bibeltexter',
    'Yqf' => 'Solistiska former efter ca 1600',
    'Yqfa' => 'Solosång från barocken ca 1600-1750',
    'Yqfb' => 'Konsertarior',
    'Yqfc' => 'Religiösa solosånger och arior',
    'Yqfd' => 'Lieder, romanser, ballader och sångcykler',
    'Yqfe' => 'Friare solistisk musik för soloröst',
    'Yqg' => 'Nationella sånger',
    'Yqh' => 'Visor',
    'Yqhz' => 'Särskilda typer av populära sånger och visor',
    'Yqj' => 'Barnvisor',
    'Yql' => 'Körmusik efter ca 1600',
    'Yr' => 'Dramatisk och scenisk musik',
    'Yra' => 'Operor',
    'Yrb' => 'Operetter och musikaler',
    'Yrba' => 'Musikaler',
    'Yrc' => 'Baletter',
    'Yrd' => 'Revyer',
    'Yre' => 'Film- och skådespelmusik',
    'Yrea' => 'Filmmusik',
    'Yreb' => 'Skådespelsmusik',
    'Yrh' => 'Musik till melodramer och uppläsningar',
    'Yrs' => 'Legend- och mysteriespel',
    'Ys' => 'Religiös musik',
    'Ysa' => 'Kristna samfund',
    'Ysb' => 'Icke-kristna religioner',
    'Yse' => 'Koraler och psalmer',
    'Ysf' => 'Andliga sånger och visor',
    'Ysg' => 'Gospels och negro spirituals',
    'Yu' => 'Västerländsk folkmusik',
    'Yu-c' => 'Sverige',
    'Yu-cs' => 'Samer',
    'Yu-d' => 'Övriga Norden',
    'Yv' => 'Icke-västerländska kulturers musik',
    'Yv-o' => 'Asien',
    'Yv-p' => 'Afrika',
    'Yv-q' => 'Amerika',
    'Yx' => 'Jazz, rock och populärmusik',
    'Yxa' => 'Besättning',
    'Yxb' => 'Ragtime',
    'Yxc' => 'Jazz',
    'Yxca' => 'Tidig jazz',
    'Yxcb' => 'Swing och sweet',
    'Yxcc' => 'Modern jazz',
    'Yxd' => 'New age',
    'Yxf' => 'Blues',
    'Yxfa' => 'Country blues',
    'Yxfb' => 'Classic blues',
    'Yxfc' => 'City blues',
    'Yxfd' => 'Rythm &amp; blues',
    'Yxfe' => 'Soul, funk, hip-hop och rap',
    'Yxg' => 'Nordamerikansk folkmusik utom blues',
    'Yxn' => 'Rock',
    'Yxna' => 'Tidig rock',
    'Yxnd' => '60-talets pop och rock',
    'Yxne' => '70-talets pop och rock',
    'Yxng' => 'Folkrock',
    'Yxni' => 'Singers/songwriters (&#034;visrocksångare&#034;)',
    'Yxnv' => 'Icke-västerländsk populärmusik av rocktyp',
    'Yxp' => 'Populärmusik',
    'Yxq' => 'Dansmusik',
    'Yä' => 'Parodier, signaler, ljudeffekter m m',
    'Yö' => 'Övrigt',
    'Yöaj' => 'Julmusik',
    'Yöb' => 'Livscykeln',
    'Ä' => 'Tidningar',
    'Äc' => 'Sverige',
    'Äd' => 'Övriga Norden',
    'Äda' => 'Danmark',
    'Ädb' => 'Norge',
    'Ädc' => 'Island och Färöarna',
    'Ädd' => 'Finland',
    'Äe' => 'Brittiska öarna (Storbritannien)',
    'Äf' => 'Mellaneuropa',
    'Äfa' => 'Tyskland',
    'Äfb' => 'Österrike och Liechtenstein',
    'Äfc' => 'Ungern',
    'Äfd' => 'Tjeckien och Slovakien',
    'Äg' => 'Nederländerna, Belgien och Luxemburg',
    'Äga' => 'Nederländerna',
    'Ägb' => 'Belgien',
    'Äh' => 'Schweiz',
    'Äi' => 'Italien (inkl Vatikanstaten, San Marino och Malta)',
    'Äj' => 'Frankrike och Monaco',
    'Äk' => 'Spanien (inkl Andorra och Gibraltar)',
    'Äl' => 'Portugal',
    'Äm' => 'Östeuropa',
    'Äma' => 'Ryssland (inkl f d Sovjetunionen)',
    'Ämb' => 'Polen',
    'Ämc' => 'Estland, Lettland, Litauen',
    'Ämca' => 'Estland',
    'Ämcb' => 'Lettland',
    'Ämcc' => 'Litauen',
    'Än' => 'Balkanländerna',
    'Änb' => 'F d Jugoslavien (Serbien, Kroatien, Slovenien etc)',
    'Änc' => 'Bulgarien',
    'Änd' => 'Grekland',
    'Äo' => 'Asien',
    'Äoa' => 'Främre Asien',
    'Äob' => 'Främre Indien',
    'Äoe' => 'Östasien',
    'Äoea' => 'Kina',
    'Äp' => 'Afrika',
    'Äq' => 'Amerika',
    'Äqa' => 'Förenta staterna',
    'Äqb' => 'Kanada',
    'Äqc' => 'Mexiko, Centralamerika och Västindien',
    'Äqd' => 'Sydamerika',
    'Är' => 'Oceanien (Australien, Nya Zeeland, Melanesien, Polynesien, Mikronesien)'
  }
end
